# Temple

[![npm](https://img.shields.io/npm/v/templejs.svg)](http://ghub.io/templejs) [![Dependency Status](https://david-dm.org/beneaththeink/temple.svg)](https://david-dm.org/beneaththeink/temple) [![Build Status](https://travis-ci.org/BeneathTheInk/Temple.svg?branch=master)](https://travis-ci.org/BeneathTheInk/Temple) [![Join the chat at https://gitter.im/BeneathTheInk/Temple](https://badges.gitter.im/BeneathTheInk/Temple.svg)](https://gitter.im/BeneathTheInk/Temple)

Yet another JavaScript view framework.

* __Reactive__ - Efficiently updates the DOM as data changes using [Trackr](http://ghub.io/trackr) and [Incremental DOM](http://ghub.io/incremental-dom).
* __Template Driven__ - Use an HTML-like template syntax to quickly generate UI scaffolding.
* __Modular & Extensible__ - All templates are encapsulated, reusable components.
* __Stateless__ - Without embedded view state, templates stay simple, robust, and flexible.

To get started with Temple quickly:

```sh
npm install templejs -g
templejs playground
```

Some helpful links:

- [Online Playground](#)
- [Template Syntax Reference](https://github.com/BeneathTheInk/Temple/wiki/Language-Reference)
- [API Documentation](https://github.com/BeneathTheInk/Temple/wiki/API-Documentation)
- [Examples](examples)

All contributions are welcome! Please submit an [issue](https://github.com/BeneathTheInk/Temple/issues/new) or [pull-request](https://github.com/BeneathTheInk/Temple/pulls). If you need help, join me on [Gitter](https://gitter.im/BeneathTheInk/Temple).
