(function (global, factory) {
            typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
            typeof define === 'function' && define.amd ? define(['exports'], factory) :
            (factory((global.Temple = global.Temple || {})));
}(this, function (exports) { 'use strict';

            var babelHelpers = {};
            babelHelpers.typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
              return typeof obj;
            } : function (obj) {
              return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj;
            };

            babelHelpers.classCallCheck = function (instance, Constructor) {
              if (!(instance instanceof Constructor)) {
                throw new TypeError("Cannot call a class as a function");
              }
            };

            babelHelpers.createClass = function () {
              function defineProperties(target, props) {
                for (var i = 0; i < props.length; i++) {
                  var descriptor = props[i];
                  descriptor.enumerable = descriptor.enumerable || false;
                  descriptor.configurable = true;
                  if ("value" in descriptor) descriptor.writable = true;
                  Object.defineProperty(target, descriptor.key, descriptor);
                }
              }

              return function (Constructor, protoProps, staticProps) {
                if (protoProps) defineProperties(Constructor.prototype, protoProps);
                if (staticProps) defineProperties(Constructor, staticProps);
                return Constructor;
              };
            }();

            babelHelpers.defineProperty = function (obj, key, value) {
              if (key in obj) {
                Object.defineProperty(obj, key, {
                  value: value,
                  enumerable: true,
                  configurable: true,
                  writable: true
                });
              } else {
                obj[key] = value;
              }

              return obj;
            };

            babelHelpers.inherits = function (subClass, superClass) {
              if (typeof superClass !== "function" && superClass !== null) {
                throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
              }

              subClass.prototype = Object.create(superClass && superClass.prototype, {
                constructor: {
                  value: subClass,
                  enumerable: false,
                  writable: true,
                  configurable: true
                }
              });
              if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
            };

            babelHelpers.possibleConstructorReturn = function (self, call) {
              if (!self) {
                throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
              }

              return call && (typeof call === "object" || typeof call === "function") ? call : self;
            };

            babelHelpers;


            var __commonjs_global = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : this;
            function __commonjs(fn, module) { return module = { exports: {} }, fn(module, module.exports, __commonjs_global), module.exports; }

            var isObjectLike = __commonjs(function (module) {
            /**
             * Checks if `value` is object-like. A value is object-like if it's not `null`
             * and has a `typeof` result of "object".
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
             * @example
             *
             * _.isObjectLike({});
             * // => true
             *
             * _.isObjectLike([1, 2, 3]);
             * // => true
             *
             * _.isObjectLike(_.noop);
             * // => false
             *
             * _.isObjectLike(null);
             * // => false
             */
            function isObjectLike(value) {
              return !!value && typeof value == 'object';
            }

            module.exports = isObjectLike;
            });

            var require$$0$3 = (isObjectLike && typeof isObjectLike === 'object' && 'default' in isObjectLike ? isObjectLike['default'] : isObjectLike);

            var isSymbol = __commonjs(function (module) {
            var isObjectLike = require$$0$3;

            /** `Object#toString` result references. */
            var symbolTag = '[object Symbol]';

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /**
             * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
             * of values.
             */
            var objectToString = objectProto.toString;

            /**
             * Checks if `value` is classified as a `Symbol` primitive or object.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is correctly classified,
             *  else `false`.
             * @example
             *
             * _.isSymbol(Symbol.iterator);
             * // => true
             *
             * _.isSymbol('abc');
             * // => false
             */
            function isSymbol(value) {
              return typeof value == 'symbol' ||
                (isObjectLike(value) && objectToString.call(value) == symbolTag);
            }

            module.exports = isSymbol;
            });

            var require$$0$2 = (isSymbol && typeof isSymbol === 'object' && 'default' in isSymbol ? isSymbol['default'] : isSymbol);

            var isObject = __commonjs(function (module) {
            /**
             * Checks if `value` is the [language type](https://es5.github.io/#x8) of `Object`.
             * (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an object, else `false`.
             * @example
             *
             * _.isObject({});
             * // => true
             *
             * _.isObject([1, 2, 3]);
             * // => true
             *
             * _.isObject(_.noop);
             * // => true
             *
             * _.isObject(null);
             * // => false
             */
            function isObject(value) {
              var type = typeof value;
              return !!value && (type == 'object' || type == 'function');
            }

            module.exports = isObject;
            });

            var _isObject = (isObject && typeof isObject === 'object' && 'default' in isObject ? isObject['default'] : isObject);

            var isFunction = __commonjs(function (module) {
            var isObject = _isObject;

            /** `Object#toString` result references. */
            var funcTag = '[object Function]',
                genTag = '[object GeneratorFunction]';

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /**
             * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
             * of values.
             */
            var objectToString = objectProto.toString;

            /**
             * Checks if `value` is classified as a `Function` object.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is correctly classified,
             *  else `false`.
             * @example
             *
             * _.isFunction(_);
             * // => true
             *
             * _.isFunction(/abc/);
             * // => false
             */
            function isFunction(value) {
              // The use of `Object#toString` avoids issues with the `typeof` operator
              // in Safari 8 which returns 'object' for typed array and weak map constructors,
              // and PhantomJS 1.9 which returns 'function' for `NodeList` instances.
              var tag = isObject(value) ? objectToString.call(value) : '';
              return tag == funcTag || tag == genTag;
            }

            module.exports = isFunction;
            });

            var _isFunction = (isFunction && typeof isFunction === 'object' && 'default' in isFunction ? isFunction['default'] : isFunction);

            var toNumber = __commonjs(function (module) {
            var isFunction = _isFunction,
                isObject = _isObject,
                isSymbol = require$$0$2;

            /** Used as references for various `Number` constants. */
            var NAN = 0 / 0;

            /** Used to match leading and trailing whitespace. */
            var reTrim = /^\s+|\s+$/g;

            /** Used to detect bad signed hexadecimal string values. */
            var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

            /** Used to detect binary string values. */
            var reIsBinary = /^0b[01]+$/i;

            /** Used to detect octal string values. */
            var reIsOctal = /^0o[0-7]+$/i;

            /** Built-in method references without a dependency on `root`. */
            var freeParseInt = parseInt;

            /**
             * Converts `value` to a number.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to process.
             * @returns {number} Returns the number.
             * @example
             *
             * _.toNumber(3);
             * // => 3
             *
             * _.toNumber(Number.MIN_VALUE);
             * // => 5e-324
             *
             * _.toNumber(Infinity);
             * // => Infinity
             *
             * _.toNumber('3');
             * // => 3
             */
            function toNumber(value) {
              if (typeof value == 'number') {
                return value;
              }
              if (isSymbol(value)) {
                return NAN;
              }
              if (isObject(value)) {
                var other = isFunction(value.valueOf) ? value.valueOf() : value;
                value = isObject(other) ? (other + '') : other;
              }
              if (typeof value != 'string') {
                return value === 0 ?  value : +value;
              }
              value = value.replace(reTrim, '');
              var isBinary = reIsBinary.test(value);
              return (isBinary || reIsOctal.test(value))
                ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
                : (reIsBadHex.test(value) ? NAN : +value);
            }

            module.exports = toNumber;
            });

            var require$$0$1 = (toNumber && typeof toNumber === 'object' && 'default' in toNumber ? toNumber['default'] : toNumber);

            var toInteger = __commonjs(function (module) {
            var toNumber = require$$0$1;

            /** Used as references for various `Number` constants. */
            var INFINITY = 1 / 0,
                MAX_INTEGER = 1.7976931348623157e+308;

            /**
             * Converts `value` to an integer.
             *
             * **Note:** This function is loosely based on
             * [`ToInteger`](http://www.ecma-international.org/ecma-262/6.0/#sec-tointeger).
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to convert.
             * @returns {number} Returns the converted integer.
             * @example
             *
             * _.toInteger(3);
             * // => 3
             *
             * _.toInteger(Number.MIN_VALUE);
             * // => 0
             *
             * _.toInteger(Infinity);
             * // => 1.7976931348623157e+308
             *
             * _.toInteger('3');
             * // => 3
             */
            function toInteger(value) {
              if (!value) {
                return value === 0 ? value : 0;
              }
              value = toNumber(value);
              if (value === INFINITY || value === -INFINITY) {
                var sign = (value < 0 ? -1 : 1);
                return sign * MAX_INTEGER;
              }
              var remainder = value % 1;
              return value === value ? (remainder ? value - remainder : value) : 0;
            }

            module.exports = toInteger;
            });

            var require$$1 = (toInteger && typeof toInteger === 'object' && 'default' in toInteger ? toInteger['default'] : toInteger);

            var _apply = __commonjs(function (module) {
            /**
             * A faster alternative to `Function#apply`, this function invokes `func`
             * with the `this` binding of `thisArg` and the arguments of `args`.
             *
             * @private
             * @param {Function} func The function to invoke.
             * @param {*} thisArg The `this` binding of `func`.
             * @param {...*} args The arguments to invoke `func` with.
             * @returns {*} Returns the result of `func`.
             */
            function apply(func, thisArg, args) {
              var length = args.length;
              switch (length) {
                case 0: return func.call(thisArg);
                case 1: return func.call(thisArg, args[0]);
                case 2: return func.call(thisArg, args[0], args[1]);
                case 3: return func.call(thisArg, args[0], args[1], args[2]);
              }
              return func.apply(thisArg, args);
            }

            module.exports = apply;
            });

            var require$$4 = (_apply && typeof _apply === 'object' && 'default' in _apply ? _apply['default'] : _apply);

            var rest = __commonjs(function (module) {
            var apply = require$$4,
                toInteger = require$$1;

            /** Used as the `TypeError` message for "Functions" methods. */
            var FUNC_ERROR_TEXT = 'Expected a function';

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeMax = Math.max;

            /**
             * Creates a function that invokes `func` with the `this` binding of the
             * created function and arguments from `start` and beyond provided as
             * an array.
             *
             * **Note:** This method is based on the
             * [rest parameter](https://mdn.io/rest_parameters).
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Function
             * @param {Function} func The function to apply a rest parameter to.
             * @param {number} [start=func.length-1] The start position of the rest parameter.
             * @returns {Function} Returns the new function.
             * @example
             *
             * var say = _.rest(function(what, names) {
             *   return what + ' ' + _.initial(names).join(', ') +
             *     (_.size(names) > 1 ? ', & ' : '') + _.last(names);
             * });
             *
             * say('hello', 'fred', 'barney', 'pebbles');
             * // => 'hello fred, barney, & pebbles'
             */
            function rest(func, start) {
              if (typeof func != 'function') {
                throw new TypeError(FUNC_ERROR_TEXT);
              }
              start = nativeMax(start === undefined ? (func.length - 1) : toInteger(start), 0);
              return function() {
                var args = arguments,
                    index = -1,
                    length = nativeMax(args.length - start, 0),
                    array = Array(length);

                while (++index < length) {
                  array[index] = args[start + index];
                }
                switch (start) {
                  case 0: return func.call(this, array);
                  case 1: return func.call(this, args[0], array);
                  case 2: return func.call(this, args[0], args[1], array);
                }
                var otherArgs = Array(start + 1);
                index = -1;
                while (++index < start) {
                  otherArgs[index] = args[index];
                }
                otherArgs[start] = array;
                return apply(func, this, otherArgs);
              };
            }

            module.exports = rest;
            });

            var require$$0 = (rest && typeof rest === 'object' && 'default' in rest ? rest['default'] : rest);

            var isLength = __commonjs(function (module) {
            /** Used as references for various `Number` constants. */
            var MAX_SAFE_INTEGER = 9007199254740991;

            /**
             * Checks if `value` is a valid array-like length.
             *
             * **Note:** This function is loosely based on
             * [`ToLength`](http://ecma-international.org/ecma-262/6.0/#sec-tolength).
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a valid length,
             *  else `false`.
             * @example
             *
             * _.isLength(3);
             * // => true
             *
             * _.isLength(Number.MIN_VALUE);
             * // => false
             *
             * _.isLength(Infinity);
             * // => false
             *
             * _.isLength('3');
             * // => false
             */
            function isLength(value) {
              return typeof value == 'number' &&
                value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
            }

            module.exports = isLength;
            });

            var require$$1$1 = (isLength && typeof isLength === 'object' && 'default' in isLength ? isLength['default'] : isLength);

            var _baseProperty = __commonjs(function (module) {
            /**
             * The base implementation of `_.property` without support for deep paths.
             *
             * @private
             * @param {string} key The key of the property to get.
             * @returns {Function} Returns the new function.
             */
            function baseProperty(key) {
              return function(object) {
                return object == null ? undefined : object[key];
              };
            }

            module.exports = baseProperty;
            });

            var require$$2$1 = (_baseProperty && typeof _baseProperty === 'object' && 'default' in _baseProperty ? _baseProperty['default'] : _baseProperty);

            var _getLength = __commonjs(function (module) {
            var baseProperty = require$$2$1;

            /**
             * Gets the "length" property value of `object`.
             *
             * **Note:** This function is used to avoid a
             * [JIT bug](https://bugs.webkit.org/show_bug.cgi?id=142792) that affects
             * Safari on at least iOS 8.1-8.3 ARM64.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {*} Returns the "length" value.
             */
            var getLength = baseProperty('length');

            module.exports = getLength;
            });

            var require$$2 = (_getLength && typeof _getLength === 'object' && 'default' in _getLength ? _getLength['default'] : _getLength);

            var isArrayLike = __commonjs(function (module) {
            var getLength = require$$2,
                isFunction = _isFunction,
                isLength = require$$1$1;

            /**
             * Checks if `value` is array-like. A value is considered array-like if it's
             * not a function and has a `value.length` that's an integer greater than or
             * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
             * @example
             *
             * _.isArrayLike([1, 2, 3]);
             * // => true
             *
             * _.isArrayLike(document.body.children);
             * // => true
             *
             * _.isArrayLike('abc');
             * // => true
             *
             * _.isArrayLike(_.noop);
             * // => false
             */
            function isArrayLike(value) {
              return value != null && isLength(getLength(value)) && !isFunction(value);
            }

            module.exports = isArrayLike;
            });

            var require$$0$5 = (isArrayLike && typeof isArrayLike === 'object' && 'default' in isArrayLike ? isArrayLike['default'] : isArrayLike);

            var isArrayLikeObject = __commonjs(function (module) {
            var isArrayLike = require$$0$5,
                isObjectLike = require$$0$3;

            /**
             * This method is like `_.isArrayLike` except that it also checks if `value`
             * is an object.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an array-like object,
             *  else `false`.
             * @example
             *
             * _.isArrayLikeObject([1, 2, 3]);
             * // => true
             *
             * _.isArrayLikeObject(document.body.children);
             * // => true
             *
             * _.isArrayLikeObject('abc');
             * // => false
             *
             * _.isArrayLikeObject(_.noop);
             * // => false
             */
            function isArrayLikeObject(value) {
              return isObjectLike(value) && isArrayLike(value);
            }

            module.exports = isArrayLikeObject;
            });

            var require$$0$4 = (isArrayLikeObject && typeof isArrayLikeObject === 'object' && 'default' in isArrayLikeObject ? isArrayLikeObject['default'] : isArrayLikeObject);

            var _isKeyable = __commonjs(function (module) {
            /**
             * Checks if `value` is suitable for use as unique object key.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
             */
            function isKeyable(value) {
              var type = typeof value;
              return type == 'number' || type == 'boolean' ||
                (type == 'string' && value != '__proto__') || value == null;
            }

            module.exports = isKeyable;
            });

            var require$$0$6 = (_isKeyable && typeof _isKeyable === 'object' && 'default' in _isKeyable ? _isKeyable['default'] : _isKeyable);

            var _cacheHas = __commonjs(function (module) {
            var isKeyable = require$$0$6;

            /** Used to stand-in for `undefined` hash values. */
            var HASH_UNDEFINED = '__lodash_hash_undefined__';

            /**
             * Checks if `value` is in `cache`.
             *
             * @private
             * @param {Object} cache The set cache to search.
             * @param {*} value The value to search for.
             * @returns {number} Returns `true` if `value` is found, else `false`.
             */
            function cacheHas(cache, value) {
              var map = cache.__data__;
              if (isKeyable(value)) {
                var data = map.__data__,
                    hash = typeof value == 'string' ? data.string : data.hash;

                return hash[value] === HASH_UNDEFINED;
              }
              return map.has(value);
            }

            module.exports = cacheHas;
            });

            var require$$2$3 = (_cacheHas && typeof _cacheHas === 'object' && 'default' in _cacheHas ? _cacheHas['default'] : _cacheHas);

            var _baseUnary = __commonjs(function (module) {
            /**
             * The base implementation of `_.unary` without support for storing wrapper metadata.
             *
             * @private
             * @param {Function} func The function to cap arguments for.
             * @returns {Function} Returns the new function.
             */
            function baseUnary(func) {
              return function(value) {
                return func(value);
              };
            }

            module.exports = baseUnary;
            });

            var require$$1$2 = (_baseUnary && typeof _baseUnary === 'object' && 'default' in _baseUnary ? _baseUnary['default'] : _baseUnary);

            var _arrayMap = __commonjs(function (module) {
            /**
             * A specialized version of `_.map` for arrays without support for iteratee
             * shorthands.
             *
             * @private
             * @param {Array} array The array to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array} Returns the new mapped array.
             */
            function arrayMap(array, iteratee) {
              var index = -1,
                  length = array.length,
                  result = Array(length);

              while (++index < length) {
                result[index] = iteratee(array[index], index, array);
              }
              return result;
            }

            module.exports = arrayMap;
            });

            var require$$3 = (_arrayMap && typeof _arrayMap === 'object' && 'default' in _arrayMap ? _arrayMap['default'] : _arrayMap);

            var _arrayIncludesWith = __commonjs(function (module) {
            /**
             * This function is like `arrayIncludes` except that it accepts a comparator.
             *
             * @private
             * @param {Array} array The array to search.
             * @param {*} target The value to search for.
             * @param {Function} comparator The comparator invoked per element.
             * @returns {boolean} Returns `true` if `target` is found, else `false`.
             */
            function arrayIncludesWith(array, value, comparator) {
              var index = -1,
                  length = array.length;

              while (++index < length) {
                if (comparator(value, array[index])) {
                  return true;
                }
              }
              return false;
            }

            module.exports = arrayIncludesWith;
            });

            var require$$3$1 = (_arrayIncludesWith && typeof _arrayIncludesWith === 'object' && 'default' in _arrayIncludesWith ? _arrayIncludesWith['default'] : _arrayIncludesWith);

            var _indexOfNaN = __commonjs(function (module) {
            /**
             * Gets the index at which the first occurrence of `NaN` is found in `array`.
             *
             * @private
             * @param {Array} array The array to search.
             * @param {number} fromIndex The index to search from.
             * @param {boolean} [fromRight] Specify iterating from right to left.
             * @returns {number} Returns the index of the matched `NaN`, else `-1`.
             */
            function indexOfNaN(array, fromIndex, fromRight) {
              var length = array.length,
                  index = fromIndex + (fromRight ? 0 : -1);

              while ((fromRight ? index-- : ++index < length)) {
                var other = array[index];
                if (other !== other) {
                  return index;
                }
              }
              return -1;
            }

            module.exports = indexOfNaN;
            });

            var require$$0$7 = (_indexOfNaN && typeof _indexOfNaN === 'object' && 'default' in _indexOfNaN ? _indexOfNaN['default'] : _indexOfNaN);

            var _baseIndexOf = __commonjs(function (module) {
            var indexOfNaN = require$$0$7;

            /**
             * The base implementation of `_.indexOf` without `fromIndex` bounds checks.
             *
             * @private
             * @param {Array} array The array to search.
             * @param {*} value The value to search for.
             * @param {number} fromIndex The index to search from.
             * @returns {number} Returns the index of the matched value, else `-1`.
             */
            function baseIndexOf(array, value, fromIndex) {
              if (value !== value) {
                return indexOfNaN(array, fromIndex);
              }
              var index = fromIndex - 1,
                  length = array.length;

              while (++index < length) {
                if (array[index] === value) {
                  return index;
                }
              }
              return -1;
            }

            module.exports = baseIndexOf;
            });

            var require$$4$2 = (_baseIndexOf && typeof _baseIndexOf === 'object' && 'default' in _baseIndexOf ? _baseIndexOf['default'] : _baseIndexOf);

            var _arrayIncludes = __commonjs(function (module) {
            var baseIndexOf = require$$4$2;

            /**
             * A specialized version of `_.includes` for arrays without support for
             * specifying an index to search from.
             *
             * @private
             * @param {Array} array The array to search.
             * @param {*} target The value to search for.
             * @returns {boolean} Returns `true` if `target` is found, else `false`.
             */
            function arrayIncludes(array, value) {
              return !!array.length && baseIndexOf(array, value, 0) > -1;
            }

            module.exports = arrayIncludes;
            });

            var require$$4$1 = (_arrayIncludes && typeof _arrayIncludes === 'object' && 'default' in _arrayIncludes ? _arrayIncludes['default'] : _arrayIncludes);

            var _cachePush = __commonjs(function (module) {
            var isKeyable = require$$0$6;

            /** Used to stand-in for `undefined` hash values. */
            var HASH_UNDEFINED = '__lodash_hash_undefined__';

            /**
             * Adds `value` to the set cache.
             *
             * @private
             * @name push
             * @memberOf SetCache
             * @param {*} value The value to cache.
             */
            function cachePush(value) {
              var map = this.__data__;
              if (isKeyable(value)) {
                var data = map.__data__,
                    hash = typeof value == 'string' ? data.string : data.hash;

                hash[value] = HASH_UNDEFINED;
              }
              else {
                map.set(value, HASH_UNDEFINED);
              }
            }

            module.exports = cachePush;
            });

            var require$$0$8 = (_cachePush && typeof _cachePush === 'object' && 'default' in _cachePush ? _cachePush['default'] : _cachePush);

            var _isHostObject = __commonjs(function (module) {
            /**
             * Checks if `value` is a host object in IE < 9.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a host object, else `false`.
             */
            function isHostObject(value) {
              // Many host objects are `Object` objects that can coerce to strings
              // despite having improperly defined `toString` methods.
              var result = false;
              if (value != null && typeof value.toString != 'function') {
                try {
                  result = !!(value + '');
                } catch (e) {}
              }
              return result;
            }

            module.exports = isHostObject;
            });

            var require$$1$6 = (_isHostObject && typeof _isHostObject === 'object' && 'default' in _isHostObject ? _isHostObject['default'] : _isHostObject);

            var isNative = __commonjs(function (module) {
            var isFunction = _isFunction,
                isHostObject = require$$1$6,
                isObjectLike = require$$0$3;

            /** Used to match `RegExp` [syntax characters](http://ecma-international.org/ecma-262/6.0/#sec-patterns). */
            var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

            /** Used to detect host constructors (Safari). */
            var reIsHostCtor = /^\[object .+?Constructor\]$/;

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /** Used to resolve the decompiled source of functions. */
            var funcToString = Function.prototype.toString;

            /** Used to check objects for own properties. */
            var hasOwnProperty = objectProto.hasOwnProperty;

            /** Used to detect if a method is native. */
            var reIsNative = RegExp('^' +
              funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
              .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
            );

            /**
             * Checks if `value` is a native function.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a native function,
             *  else `false`.
             * @example
             *
             * _.isNative(Array.prototype.push);
             * // => true
             *
             * _.isNative(_);
             * // => false
             */
            function isNative(value) {
              if (value == null) {
                return false;
              }
              if (isFunction(value)) {
                return reIsNative.test(funcToString.call(value));
              }
              return isObjectLike(value) &&
                (isHostObject(value) ? reIsNative : reIsHostCtor).test(value);
            }

            module.exports = isNative;
            });

            var require$$0$11 = (isNative && typeof isNative === 'object' && 'default' in isNative ? isNative['default'] : isNative);

            var _getNative = __commonjs(function (module) {
            var isNative = require$$0$11;

            /**
             * Gets the native function at `key` of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {string} key The key of the method to get.
             * @returns {*} Returns the function if it's native, else `undefined`.
             */
            function getNative(object, key) {
              var value = object[key];
              return isNative(value) ? value : undefined;
            }

            module.exports = getNative;
            });

            var require$$1$5 = (_getNative && typeof _getNative === 'object' && 'default' in _getNative ? _getNative['default'] : _getNative);

            var _nativeCreate = __commonjs(function (module) {
            var getNative = require$$1$5;

            /* Built-in method references that are verified to be native. */
            var nativeCreate = getNative(Object, 'create');

            module.exports = nativeCreate;
            });

            var require$$0$10 = (_nativeCreate && typeof _nativeCreate === 'object' && 'default' in _nativeCreate ? _nativeCreate['default'] : _nativeCreate);

            var _hashSet = __commonjs(function (module) {
            var nativeCreate = require$$0$10;

            /** Used to stand-in for `undefined` hash values. */
            var HASH_UNDEFINED = '__lodash_hash_undefined__';

            /**
             * Sets the hash `key` to `value`.
             *
             * @private
             * @param {Object} hash The hash to modify.
             * @param {string} key The key of the value to set.
             * @param {*} value The value to set.
             */
            function hashSet(hash, key, value) {
              hash[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
            }

            module.exports = hashSet;
            });

            var require$$1$4 = (_hashSet && typeof _hashSet === 'object' && 'default' in _hashSet ? _hashSet['default'] : _hashSet);

            var eq = __commonjs(function (module) {
            /**
             * Performs a
             * [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
             * comparison between two values to determine if they are equivalent.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to compare.
             * @param {*} other The other value to compare.
             * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
             * @example
             *
             * var object = { 'user': 'fred' };
             * var other = { 'user': 'fred' };
             *
             * _.eq(object, object);
             * // => true
             *
             * _.eq(object, other);
             * // => false
             *
             * _.eq('a', 'a');
             * // => true
             *
             * _.eq('a', Object('a'));
             * // => false
             *
             * _.eq(NaN, NaN);
             * // => true
             */
            function eq(value, other) {
              return value === other || (value !== value && other !== other);
            }

            module.exports = eq;
            });

            var require$$0$14 = (eq && typeof eq === 'object' && 'default' in eq ? eq['default'] : eq);

            var _assocIndexOf = __commonjs(function (module) {
            var eq = require$$0$14;

            /**
             * Gets the index at which the `key` is found in `array` of key-value pairs.
             *
             * @private
             * @param {Array} array The array to search.
             * @param {*} key The key to search for.
             * @returns {number} Returns the index of the matched value, else `-1`.
             */
            function assocIndexOf(array, key) {
              var length = array.length;
              while (length--) {
                if (eq(array[length][0], key)) {
                  return length;
                }
              }
              return -1;
            }

            module.exports = assocIndexOf;
            });

            var require$$0$13 = (_assocIndexOf && typeof _assocIndexOf === 'object' && 'default' in _assocIndexOf ? _assocIndexOf['default'] : _assocIndexOf);

            var _assocSet = __commonjs(function (module) {
            var assocIndexOf = require$$0$13;

            /**
             * Sets the associative array `key` to `value`.
             *
             * @private
             * @param {Array} array The array to modify.
             * @param {string} key The key of the value to set.
             * @param {*} value The value to set.
             */
            function assocSet(array, key, value) {
              var index = assocIndexOf(array, key);
              if (index < 0) {
                array.push([key, value]);
              } else {
                array[index][1] = value;
              }
            }

            module.exports = assocSet;
            });

            var require$$0$12 = (_assocSet && typeof _assocSet === 'object' && 'default' in _assocSet ? _assocSet['default'] : _assocSet);

            var _checkGlobal = __commonjs(function (module) {
            /**
             * Checks if `value` is a global object.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {null|Object} Returns `value` if it's a global object, else `null`.
             */
            function checkGlobal(value) {
              return (value && value.Object === Object) ? value : null;
            }

            module.exports = checkGlobal;
            });

            var require$$0$16 = (_checkGlobal && typeof _checkGlobal === 'object' && 'default' in _checkGlobal ? _checkGlobal['default'] : _checkGlobal);

            var _root = __commonjs(function (module, exports, global) {
            var checkGlobal = require$$0$16;

            /** Used to determine if values are of the language type `Object`. */
            var objectTypes = {
              'function': true,
              'object': true
            };

            /** Detect free variable `exports`. */
            var freeExports = (objectTypes[typeof exports] && exports && !exports.nodeType)
              ? exports
              : undefined;

            /** Detect free variable `module`. */
            var freeModule = (objectTypes[typeof module] && module && !module.nodeType)
              ? module
              : undefined;

            /** Detect free variable `global` from Node.js. */
            var freeGlobal = checkGlobal(freeExports && freeModule && typeof global == 'object' && global);

            /** Detect free variable `self`. */
            var freeSelf = checkGlobal(objectTypes[typeof self] && self);

            /** Detect free variable `window`. */
            var freeWindow = checkGlobal(objectTypes[typeof window] && window);

            /** Detect `this` as the global object. */
            var thisGlobal = checkGlobal(objectTypes[typeof __commonjs_global] && __commonjs_global);

            /**
             * Used as a reference to the global object.
             *
             * The `this` value is used if it's the global object to avoid Greasemonkey's
             * restricted `window` object, otherwise the `window` object is used.
             */
            var root = freeGlobal ||
              ((freeWindow !== (thisGlobal && thisGlobal.window)) && freeWindow) ||
                freeSelf || thisGlobal || Function('return this')();

            module.exports = root;
            });

            var require$$0$15 = (_root && typeof _root === 'object' && 'default' in _root ? _root['default'] : _root);

            var _Map = __commonjs(function (module) {
            var getNative = require$$1$5,
                root = require$$0$15;

            /* Built-in method references that are verified to be native. */
            var Map = getNative(root, 'Map');

            module.exports = Map;
            });

            var require$$3$2 = (_Map && typeof _Map === 'object' && 'default' in _Map ? _Map['default'] : _Map);

            var _mapSet = __commonjs(function (module) {
            var Map = require$$3$2,
                assocSet = require$$0$12,
                hashSet = require$$1$4,
                isKeyable = require$$0$6;

            /**
             * Sets the map `key` to `value`.
             *
             * @private
             * @name set
             * @memberOf MapCache
             * @param {string} key The key of the value to set.
             * @param {*} value The value to set.
             * @returns {Object} Returns the map cache instance.
             */
            function mapSet(key, value) {
              var data = this.__data__;
              if (isKeyable(key)) {
                hashSet(typeof key == 'string' ? data.string : data.hash, key, value);
              } else if (Map) {
                data.map.set(key, value);
              } else {
                assocSet(data.map, key, value);
              }
              return this;
            }

            module.exports = mapSet;
            });

            var require$$0$9 = (_mapSet && typeof _mapSet === 'object' && 'default' in _mapSet ? _mapSet['default'] : _mapSet);

            var _hashHas = __commonjs(function (module) {
            var nativeCreate = require$$0$10;

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty = objectProto.hasOwnProperty;

            /**
             * Checks if a hash value for `key` exists.
             *
             * @private
             * @param {Object} hash The hash to query.
             * @param {string} key The key of the entry to check.
             * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
             */
            function hashHas(hash, key) {
              return nativeCreate ? hash[key] !== undefined : hasOwnProperty.call(hash, key);
            }

            module.exports = hashHas;
            });

            var require$$0$17 = (_hashHas && typeof _hashHas === 'object' && 'default' in _hashHas ? _hashHas['default'] : _hashHas);

            var _assocHas = __commonjs(function (module) {
            var assocIndexOf = require$$0$13;

            /**
             * Checks if an associative array value for `key` exists.
             *
             * @private
             * @param {Array} array The array to query.
             * @param {string} key The key of the entry to check.
             * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
             */
            function assocHas(array, key) {
              return assocIndexOf(array, key) > -1;
            }

            module.exports = assocHas;
            });

            var require$$0$18 = (_assocHas && typeof _assocHas === 'object' && 'default' in _assocHas ? _assocHas['default'] : _assocHas);

            var _mapHas = __commonjs(function (module) {
            var Map = require$$3$2,
                assocHas = require$$0$18,
                hashHas = require$$0$17,
                isKeyable = require$$0$6;

            /**
             * Checks if a map value for `key` exists.
             *
             * @private
             * @name has
             * @memberOf MapCache
             * @param {string} key The key of the entry to check.
             * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
             */
            function mapHas(key) {
              var data = this.__data__;
              if (isKeyable(key)) {
                return hashHas(typeof key == 'string' ? data.string : data.hash, key);
              }
              return Map ? data.map.has(key) : assocHas(data.map, key);
            }

            module.exports = mapHas;
            });

            var require$$1$7 = (_mapHas && typeof _mapHas === 'object' && 'default' in _mapHas ? _mapHas['default'] : _mapHas);

            var _hashGet = __commonjs(function (module) {
            var nativeCreate = require$$0$10;

            /** Used to stand-in for `undefined` hash values. */
            var HASH_UNDEFINED = '__lodash_hash_undefined__';

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty = objectProto.hasOwnProperty;

            /**
             * Gets the hash value for `key`.
             *
             * @private
             * @param {Object} hash The hash to query.
             * @param {string} key The key of the value to get.
             * @returns {*} Returns the entry value.
             */
            function hashGet(hash, key) {
              if (nativeCreate) {
                var result = hash[key];
                return result === HASH_UNDEFINED ? undefined : result;
              }
              return hasOwnProperty.call(hash, key) ? hash[key] : undefined;
            }

            module.exports = hashGet;
            });

            var require$$1$8 = (_hashGet && typeof _hashGet === 'object' && 'default' in _hashGet ? _hashGet['default'] : _hashGet);

            var _assocGet = __commonjs(function (module) {
            var assocIndexOf = require$$0$13;

            /**
             * Gets the associative array value for `key`.
             *
             * @private
             * @param {Array} array The array to query.
             * @param {string} key The key of the value to get.
             * @returns {*} Returns the entry value.
             */
            function assocGet(array, key) {
              var index = assocIndexOf(array, key);
              return index < 0 ? undefined : array[index][1];
            }

            module.exports = assocGet;
            });

            var require$$0$19 = (_assocGet && typeof _assocGet === 'object' && 'default' in _assocGet ? _assocGet['default'] : _assocGet);

            var _mapGet = __commonjs(function (module) {
            var Map = require$$3$2,
                assocGet = require$$0$19,
                hashGet = require$$1$8,
                isKeyable = require$$0$6;

            /**
             * Gets the map value for `key`.
             *
             * @private
             * @name get
             * @memberOf MapCache
             * @param {string} key The key of the value to get.
             * @returns {*} Returns the entry value.
             */
            function mapGet(key) {
              var data = this.__data__;
              if (isKeyable(key)) {
                return hashGet(typeof key == 'string' ? data.string : data.hash, key);
              }
              return Map ? data.map.get(key) : assocGet(data.map, key);
            }

            module.exports = mapGet;
            });

            var require$$2$4 = (_mapGet && typeof _mapGet === 'object' && 'default' in _mapGet ? _mapGet['default'] : _mapGet);

            var _hashDelete = __commonjs(function (module) {
            var hashHas = require$$0$17;

            /**
             * Removes `key` and its value from the hash.
             *
             * @private
             * @param {Object} hash The hash to modify.
             * @param {string} key The key of the value to remove.
             * @returns {boolean} Returns `true` if the entry was removed, else `false`.
             */
            function hashDelete(hash, key) {
              return hashHas(hash, key) && delete hash[key];
            }

            module.exports = hashDelete;
            });

            var require$$1$9 = (_hashDelete && typeof _hashDelete === 'object' && 'default' in _hashDelete ? _hashDelete['default'] : _hashDelete);

            var _assocDelete = __commonjs(function (module) {
            var assocIndexOf = require$$0$13;

            /** Used for built-in method references. */
            var arrayProto = Array.prototype;

            /** Built-in value references. */
            var splice = arrayProto.splice;

            /**
             * Removes `key` and its value from the associative array.
             *
             * @private
             * @param {Array} array The array to modify.
             * @param {string} key The key of the value to remove.
             * @returns {boolean} Returns `true` if the entry was removed, else `false`.
             */
            function assocDelete(array, key) {
              var index = assocIndexOf(array, key);
              if (index < 0) {
                return false;
              }
              var lastIndex = array.length - 1;
              if (index == lastIndex) {
                array.pop();
              } else {
                splice.call(array, index, 1);
              }
              return true;
            }

            module.exports = assocDelete;
            });

            var require$$0$20 = (_assocDelete && typeof _assocDelete === 'object' && 'default' in _assocDelete ? _assocDelete['default'] : _assocDelete);

            var _mapDelete = __commonjs(function (module) {
            var Map = require$$3$2,
                assocDelete = require$$0$20,
                hashDelete = require$$1$9,
                isKeyable = require$$0$6;

            /**
             * Removes `key` and its value from the map.
             *
             * @private
             * @name delete
             * @memberOf MapCache
             * @param {string} key The key of the value to remove.
             * @returns {boolean} Returns `true` if the entry was removed, else `false`.
             */
            function mapDelete(key) {
              var data = this.__data__;
              if (isKeyable(key)) {
                return hashDelete(typeof key == 'string' ? data.string : data.hash, key);
              }
              return Map ? data.map['delete'](key) : assocDelete(data.map, key);
            }

            module.exports = mapDelete;
            });

            var require$$3$3 = (_mapDelete && typeof _mapDelete === 'object' && 'default' in _mapDelete ? _mapDelete['default'] : _mapDelete);

            var _Hash = __commonjs(function (module) {
            var nativeCreate = require$$0$10;

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /**
             * Creates an hash object.
             *
             * @private
             * @constructor
             * @returns {Object} Returns the new hash object.
             */
            function Hash() {}

            // Avoid inheriting from `Object.prototype` when possible.
            Hash.prototype = nativeCreate ? nativeCreate(null) : objectProto;

            module.exports = Hash;
            });

            var require$$1$10 = (_Hash && typeof _Hash === 'object' && 'default' in _Hash ? _Hash['default'] : _Hash);

            var _mapClear = __commonjs(function (module) {
            var Hash = require$$1$10,
                Map = require$$3$2;

            /**
             * Removes all key-value entries from the map.
             *
             * @private
             * @name clear
             * @memberOf MapCache
             */
            function mapClear() {
              this.__data__ = {
                'hash': new Hash,
                'map': Map ? new Map : [],
                'string': new Hash
              };
            }

            module.exports = mapClear;
            });

            var require$$4$3 = (_mapClear && typeof _mapClear === 'object' && 'default' in _mapClear ? _mapClear['default'] : _mapClear);

            var _MapCache = __commonjs(function (module) {
            var mapClear = require$$4$3,
                mapDelete = require$$3$3,
                mapGet = require$$2$4,
                mapHas = require$$1$7,
                mapSet = require$$0$9;

            /**
             * Creates a map cache object to store key-value pairs.
             *
             * @private
             * @constructor
             * @param {Array} [values] The values to cache.
             */
            function MapCache(values) {
              var index = -1,
                  length = values ? values.length : 0;

              this.clear();
              while (++index < length) {
                var entry = values[index];
                this.set(entry[0], entry[1]);
              }
            }

            // Add methods to `MapCache`.
            MapCache.prototype.clear = mapClear;
            MapCache.prototype['delete'] = mapDelete;
            MapCache.prototype.get = mapGet;
            MapCache.prototype.has = mapHas;
            MapCache.prototype.set = mapSet;

            module.exports = MapCache;
            });

            var require$$1$3 = (_MapCache && typeof _MapCache === 'object' && 'default' in _MapCache ? _MapCache['default'] : _MapCache);

            var _SetCache = __commonjs(function (module) {
            var MapCache = require$$1$3,
                cachePush = require$$0$8;

            /**
             *
             * Creates a set cache object to store unique values.
             *
             * @private
             * @constructor
             * @param {Array} [values] The values to cache.
             */
            function SetCache(values) {
              var index = -1,
                  length = values ? values.length : 0;

              this.__data__ = new MapCache;
              while (++index < length) {
                this.push(values[index]);
              }
            }

            // Add methods to `SetCache`.
            SetCache.prototype.push = cachePush;

            module.exports = SetCache;
            });

            var require$$5 = (_SetCache && typeof _SetCache === 'object' && 'default' in _SetCache ? _SetCache['default'] : _SetCache);

            var _baseDifference = __commonjs(function (module) {
            var SetCache = require$$5,
                arrayIncludes = require$$4$1,
                arrayIncludesWith = require$$3$1,
                arrayMap = require$$3,
                baseUnary = require$$1$2,
                cacheHas = require$$2$3;

            /** Used as the size to enable large array optimizations. */
            var LARGE_ARRAY_SIZE = 200;

            /**
             * The base implementation of methods like `_.difference` without support
             * for excluding multiple arrays or iteratee shorthands.
             *
             * @private
             * @param {Array} array The array to inspect.
             * @param {Array} values The values to exclude.
             * @param {Function} [iteratee] The iteratee invoked per element.
             * @param {Function} [comparator] The comparator invoked per element.
             * @returns {Array} Returns the new array of filtered values.
             */
            function baseDifference(array, values, iteratee, comparator) {
              var index = -1,
                  includes = arrayIncludes,
                  isCommon = true,
                  length = array.length,
                  result = [],
                  valuesLength = values.length;

              if (!length) {
                return result;
              }
              if (iteratee) {
                values = arrayMap(values, baseUnary(iteratee));
              }
              if (comparator) {
                includes = arrayIncludesWith;
                isCommon = false;
              }
              else if (values.length >= LARGE_ARRAY_SIZE) {
                includes = cacheHas;
                isCommon = false;
                values = new SetCache(values);
              }
              outer:
              while (++index < length) {
                var value = array[index],
                    computed = iteratee ? iteratee(value) : value;

                if (isCommon && computed === computed) {
                  var valuesIndex = valuesLength;
                  while (valuesIndex--) {
                    if (values[valuesIndex] === computed) {
                      continue outer;
                    }
                  }
                  result.push(value);
                }
                else if (!includes(values, computed, comparator)) {
                  result.push(value);
                }
              }
              return result;
            }

            module.exports = baseDifference;
            });

            var require$$2$2 = (_baseDifference && typeof _baseDifference === 'object' && 'default' in _baseDifference ? _baseDifference['default'] : _baseDifference);

            var without = __commonjs(function (module) {
            var baseDifference = require$$2$2,
                isArrayLikeObject = require$$0$4,
                rest = require$$0;

            /**
             * Creates an array excluding all given values using
             * [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
             * for equality comparisons.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Array
             * @param {Array} array The array to filter.
             * @param {...*} [values] The values to exclude.
             * @returns {Array} Returns the new array of filtered values.
             * @example
             *
             * _.without([1, 2, 1, 3], 1, 2);
             * // => [3]
             */
            var without = rest(function(array, values) {
              return isArrayLikeObject(array)
                ? baseDifference(array, values)
                : [];
            });

            module.exports = without;
            });

            var _without = (without && typeof without === 'object' && 'default' in without ? without['default'] : without);

            var isArray = __commonjs(function (module) {
            /**
             * Checks if `value` is classified as an `Array` object.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @type {Function}
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is correctly classified,
             *  else `false`.
             * @example
             *
             * _.isArray([1, 2, 3]);
             * // => true
             *
             * _.isArray(document.body.children);
             * // => false
             *
             * _.isArray('abc');
             * // => false
             *
             * _.isArray(_.noop);
             * // => false
             */
            var isArray = Array.isArray;

            module.exports = isArray;
            });

            var require$$0$21 = (isArray && typeof isArray === 'object' && 'default' in isArray ? isArray['default'] : isArray);

            var _isKey = __commonjs(function (module) {
            var isArray = require$$0$21,
                isSymbol = require$$0$2;

            /** Used to match property names within property paths. */
            var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
                reIsPlainProp = /^\w*$/;

            /**
             * Checks if `value` is a property name and not a property path.
             *
             * @private
             * @param {*} value The value to check.
             * @param {Object} [object] The object to query keys on.
             * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
             */
            function isKey(value, object) {
              var type = typeof value;
              if (type == 'number' || type == 'symbol') {
                return true;
              }
              return !isArray(value) &&
                (isSymbol(value) || reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
                  (object != null && value in Object(object)));
            }

            module.exports = isKey;
            });

            var require$$2$5 = (_isKey && typeof _isKey === 'object' && 'default' in _isKey ? _isKey['default'] : _isKey);

            var _Symbol = __commonjs(function (module) {
            var root = require$$0$15;

            /** Built-in value references. */
            var Symbol = root.Symbol;

            module.exports = Symbol;
            });

            var require$$9 = (_Symbol && typeof _Symbol === 'object' && 'default' in _Symbol ? _Symbol['default'] : _Symbol);

            var toString = __commonjs(function (module) {
            var Symbol = require$$9,
                isSymbol = require$$0$2;

            /** Used as references for various `Number` constants. */
            var INFINITY = 1 / 0;

            /** Used to convert symbols to primitives and strings. */
            var symbolProto = Symbol ? Symbol.prototype : undefined,
                symbolToString = symbolProto ? symbolProto.toString : undefined;

            /**
             * Converts `value` to a string if it's not one. An empty string is returned
             * for `null` and `undefined` values. The sign of `-0` is preserved.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to process.
             * @returns {string} Returns the string.
             * @example
             *
             * _.toString(null);
             * // => ''
             *
             * _.toString(-0);
             * // => '-0'
             *
             * _.toString([1, 2, 3]);
             * // => '1,2,3'
             */
            function toString(value) {
              // Exit early for strings to avoid a performance hit in some environments.
              if (typeof value == 'string') {
                return value;
              }
              if (value == null) {
                return '';
              }
              if (isSymbol(value)) {
                return symbolToString ? symbolToString.call(value) : '';
              }
              var result = (value + '');
              return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
            }

            module.exports = toString;
            });

            var require$$0$24 = (toString && typeof toString === 'object' && 'default' in toString ? toString['default'] : toString);

            var memoize = __commonjs(function (module) {
            var MapCache = require$$1$3;

            /** Used as the `TypeError` message for "Functions" methods. */
            var FUNC_ERROR_TEXT = 'Expected a function';

            /**
             * Creates a function that memoizes the result of `func`. If `resolver` is
             * provided it determines the cache key for storing the result based on the
             * arguments provided to the memoized function. By default, the first argument
             * provided to the memoized function is used as the map cache key. The `func`
             * is invoked with the `this` binding of the memoized function.
             *
             * **Note:** The cache is exposed as the `cache` property on the memoized
             * function. Its creation may be customized by replacing the `_.memoize.Cache`
             * constructor with one whose instances implement the
             * [`Map`](http://ecma-international.org/ecma-262/6.0/#sec-properties-of-the-map-prototype-object)
             * method interface of `delete`, `get`, `has`, and `set`.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Function
             * @param {Function} func The function to have its output memoized.
             * @param {Function} [resolver] The function to resolve the cache key.
             * @returns {Function} Returns the new memoizing function.
             * @example
             *
             * var object = { 'a': 1, 'b': 2 };
             * var other = { 'c': 3, 'd': 4 };
             *
             * var values = _.memoize(_.values);
             * values(object);
             * // => [1, 2]
             *
             * values(other);
             * // => [3, 4]
             *
             * object.a = 2;
             * values(object);
             * // => [1, 2]
             *
             * // Modify the result cache.
             * values.cache.set(object, ['a', 'b']);
             * values(object);
             * // => ['a', 'b']
             *
             * // Replace `_.memoize.Cache`.
             * _.memoize.Cache = WeakMap;
             */
            function memoize(func, resolver) {
              if (typeof func != 'function' || (resolver && typeof resolver != 'function')) {
                throw new TypeError(FUNC_ERROR_TEXT);
              }
              var memoized = function() {
                var args = arguments,
                    key = resolver ? resolver.apply(this, args) : args[0],
                    cache = memoized.cache;

                if (cache.has(key)) {
                  return cache.get(key);
                }
                var result = func.apply(this, args);
                memoized.cache = cache.set(key, result);
                return result;
              };
              memoized.cache = new (memoize.Cache || MapCache);
              return memoized;
            }

            // Assign cache to `_.memoize`.
            memoize.Cache = MapCache;

            module.exports = memoize;
            });

            var require$$1$14 = (memoize && typeof memoize === 'object' && 'default' in memoize ? memoize['default'] : memoize);

            var _stringToPath = __commonjs(function (module) {
            var memoize = require$$1$14,
                toString = require$$0$24;

            /** Used to match property names within property paths. */
            var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]/g;

            /** Used to match backslashes in property paths. */
            var reEscapeChar = /\\(\\)?/g;

            /**
             * Converts `string` to a property path array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the property path array.
             */
            var stringToPath = memoize(function(string) {
              var result = [];
              toString(string).replace(rePropName, function(match, number, quote, string) {
                result.push(quote ? string.replace(reEscapeChar, '$1') : (number || match));
              });
              return result;
            });

            module.exports = stringToPath;
            });

            var require$$0$23 = (_stringToPath && typeof _stringToPath === 'object' && 'default' in _stringToPath ? _stringToPath['default'] : _stringToPath);

            var _baseCastPath = __commonjs(function (module) {
            var isArray = require$$0$21,
                stringToPath = require$$0$23;

            /**
             * Casts `value` to a path array if it's not one.
             *
             * @private
             * @param {*} value The value to inspect.
             * @returns {Array} Returns the cast property path array.
             */
            function baseCastPath(value) {
              return isArray(value) ? value : stringToPath(value);
            }

            module.exports = baseCastPath;
            });

            var require$$3$4 = (_baseCastPath && typeof _baseCastPath === 'object' && 'default' in _baseCastPath ? _baseCastPath['default'] : _baseCastPath);

            var _baseGet = __commonjs(function (module) {
            var baseCastPath = require$$3$4,
                isKey = require$$2$5;

            /**
             * The base implementation of `_.get` without support for default values.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array|string} path The path of the property to get.
             * @returns {*} Returns the resolved value.
             */
            function baseGet(object, path) {
              path = isKey(path, object) ? [path] : baseCastPath(path);

              var index = 0,
                  length = path.length;

              while (object != null && index < length) {
                object = object[path[index++]];
              }
              return (index && index == length) ? object : undefined;
            }

            module.exports = baseGet;
            });

            var require$$1$13 = (_baseGet && typeof _baseGet === 'object' && 'default' in _baseGet ? _baseGet['default'] : _baseGet);

            var _basePropertyDeep = __commonjs(function (module) {
            var baseGet = require$$1$13;

            /**
             * A specialized version of `baseProperty` which supports deep paths.
             *
             * @private
             * @param {Array|string} path The path of the property to get.
             * @returns {Function} Returns the new function.
             */
            function basePropertyDeep(path) {
              return function(object) {
                return baseGet(object, path);
              };
            }

            module.exports = basePropertyDeep;
            });

            var require$$1$12 = (_basePropertyDeep && typeof _basePropertyDeep === 'object' && 'default' in _basePropertyDeep ? _basePropertyDeep['default'] : _basePropertyDeep);

            var property = __commonjs(function (module) {
            var baseProperty = require$$2$1,
                basePropertyDeep = require$$1$12,
                isKey = require$$2$5;

            /**
             * Creates a function that returns the value at `path` of a given object.
             *
             * @static
             * @memberOf _
             * @since 2.4.0
             * @category Util
             * @param {Array|string} path The path of the property to get.
             * @returns {Function} Returns the new function.
             * @example
             *
             * var objects = [
             *   { 'a': { 'b': { 'c': 2 } } },
             *   { 'a': { 'b': { 'c': 1 } } }
             * ];
             *
             * _.map(objects, _.property('a.b.c'));
             * // => [2, 1]
             *
             * _.map(_.sortBy(objects, _.property(['a', 'b', 'c'])), 'a.b.c');
             * // => [1, 2]
             */
            function property(path) {
              return isKey(path) ? baseProperty(path) : basePropertyDeep(path);
            }

            module.exports = property;
            });

            var require$$0$22 = (property && typeof property === 'object' && 'default' in property ? property['default'] : property);

            var identity = __commonjs(function (module) {
            /**
             * This method returns the first argument given to it.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Util
             * @param {*} value Any value.
             * @returns {*} Returns `value`.
             * @example
             *
             * var object = { 'user': 'fred' };
             *
             * _.identity(object) === object;
             * // => true
             */
            function identity(value) {
              return value;
            }

            module.exports = identity;
            });

            var require$$2$6 = (identity && typeof identity === 'object' && 'default' in identity ? identity['default'] : identity);

            var isString = __commonjs(function (module) {
            var isArray = require$$0$21,
                isObjectLike = require$$0$3;

            /** `Object#toString` result references. */
            var stringTag = '[object String]';

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /**
             * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
             * of values.
             */
            var objectToString = objectProto.toString;

            /**
             * Checks if `value` is classified as a `String` primitive or object.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is correctly classified,
             *  else `false`.
             * @example
             *
             * _.isString('abc');
             * // => true
             *
             * _.isString(1);
             * // => false
             */
            function isString(value) {
              return typeof value == 'string' ||
                (!isArray(value) && isObjectLike(value) && objectToString.call(value) == stringTag);
            }

            module.exports = isString;
            });

            var _isString = (isString && typeof isString === 'object' && 'default' in isString ? isString['default'] : isString);

            var _isIndex = __commonjs(function (module) {
            /** Used as references for various `Number` constants. */
            var MAX_SAFE_INTEGER = 9007199254740991;

            /** Used to detect unsigned integer values. */
            var reIsUint = /^(?:0|[1-9]\d*)$/;

            /**
             * Checks if `value` is a valid array-like index.
             *
             * @private
             * @param {*} value The value to check.
             * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
             * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
             */
            function isIndex(value, length) {
              value = (typeof value == 'number' || reIsUint.test(value)) ? +value : -1;
              length = length == null ? MAX_SAFE_INTEGER : length;
              return value > -1 && value % 1 == 0 && value < length;
            }

            module.exports = isIndex;
            });

            var require$$1$15 = (_isIndex && typeof _isIndex === 'object' && 'default' in _isIndex ? _isIndex['default'] : _isIndex);

            var isArguments = __commonjs(function (module) {
            var isArrayLikeObject = require$$0$4;

            /** `Object#toString` result references. */
            var argsTag = '[object Arguments]';

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty = objectProto.hasOwnProperty;

            /**
             * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
             * of values.
             */
            var objectToString = objectProto.toString;

            /** Built-in value references. */
            var propertyIsEnumerable = objectProto.propertyIsEnumerable;

            /**
             * Checks if `value` is likely an `arguments` object.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is correctly classified,
             *  else `false`.
             * @example
             *
             * _.isArguments(function() { return arguments; }());
             * // => true
             *
             * _.isArguments([1, 2, 3]);
             * // => false
             */
            function isArguments(value) {
              // Safari 8.1 incorrectly makes `arguments.callee` enumerable in strict mode.
              return isArrayLikeObject(value) && hasOwnProperty.call(value, 'callee') &&
                (!propertyIsEnumerable.call(value, 'callee') || objectToString.call(value) == argsTag);
            }

            module.exports = isArguments;
            });

            var require$$2$7 = (isArguments && typeof isArguments === 'object' && 'default' in isArguments ? isArguments['default'] : isArguments);

            var _hasPath = __commonjs(function (module) {
            var baseCastPath = require$$3$4,
                isArguments = require$$2$7,
                isArray = require$$0$21,
                isIndex = require$$1$15,
                isKey = require$$2$5,
                isLength = require$$1$1,
                isString = _isString;

            /**
             * Checks if `path` exists on `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array|string} path The path to check.
             * @param {Function} hasFunc The function to check properties.
             * @returns {boolean} Returns `true` if `path` exists, else `false`.
             */
            function hasPath(object, path, hasFunc) {
              if (object == null) {
                return false;
              }
              var result = hasFunc(object, path);
              if (!result && !isKey(path)) {
                path = baseCastPath(path);

                var index = -1,
                    length = path.length;

                while (object != null && ++index < length) {
                  var key = path[index];
                  if (!(result = hasFunc(object, key))) {
                    break;
                  }
                  object = object[key];
                }
              }
              var length = object ? object.length : undefined;
              return result || (
                !!length && isLength(length) && isIndex(path, length) &&
                (isArray(object) || isString(object) || isArguments(object))
              );
            }

            module.exports = hasPath;
            });

            var require$$0$26 = (_hasPath && typeof _hasPath === 'object' && 'default' in _hasPath ? _hasPath['default'] : _hasPath);

            var _baseHasIn = __commonjs(function (module) {
            /**
             * The base implementation of `_.hasIn` without support for deep paths.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array|string} key The key to check.
             * @returns {boolean} Returns `true` if `key` exists, else `false`.
             */
            function baseHasIn(object, key) {
              return key in Object(object);
            }

            module.exports = baseHasIn;
            });

            var require$$1$16 = (_baseHasIn && typeof _baseHasIn === 'object' && 'default' in _baseHasIn ? _baseHasIn['default'] : _baseHasIn);

            var hasIn = __commonjs(function (module) {
            var baseHasIn = require$$1$16,
                hasPath = require$$0$26;

            /**
             * Checks if `path` is a direct or inherited property of `object`.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Object
             * @param {Object} object The object to query.
             * @param {Array|string} path The path to check.
             * @returns {boolean} Returns `true` if `path` exists, else `false`.
             * @example
             *
             * var object = _.create({ 'a': _.create({ 'b': _.create({ 'c': 3 }) }) });
             *
             * _.hasIn(object, 'a');
             * // => true
             *
             * _.hasIn(object, 'a.b.c');
             * // => true
             *
             * _.hasIn(object, ['a', 'b', 'c']);
             * // => true
             *
             * _.hasIn(object, 'b');
             * // => false
             */
            function hasIn(object, path) {
              return hasPath(object, path, baseHasIn);
            }

            module.exports = hasIn;
            });

            var require$$0$25 = (hasIn && typeof hasIn === 'object' && 'default' in hasIn ? hasIn['default'] : hasIn);

            var get = __commonjs(function (module) {
            var baseGet = require$$1$13;

            /**
             * Gets the value at `path` of `object`. If the resolved value is
             * `undefined` the `defaultValue` is used in its place.
             *
             * @static
             * @memberOf _
             * @since 3.7.0
             * @category Object
             * @param {Object} object The object to query.
             * @param {Array|string} path The path of the property to get.
             * @param {*} [defaultValue] The value returned for `undefined` resolved values.
             * @returns {*} Returns the resolved value.
             * @example
             *
             * var object = { 'a': [{ 'b': { 'c': 3 } }] };
             *
             * _.get(object, 'a[0].b.c');
             * // => 3
             *
             * _.get(object, ['a', '0', 'b', 'c']);
             * // => 3
             *
             * _.get(object, 'a.b.c', 'default');
             * // => 'default'
             */
            function get(object, path, defaultValue) {
              var result = object == null ? undefined : baseGet(object, path);
              return result === undefined ? defaultValue : result;
            }

            module.exports = get;
            });

            var require$$1$17 = (get && typeof get === 'object' && 'default' in get ? get['default'] : get);

            var isTypedArray = __commonjs(function (module) {
            var isLength = require$$1$1,
                isObjectLike = require$$0$3;

            /** `Object#toString` result references. */
            var argsTag = '[object Arguments]',
                arrayTag = '[object Array]',
                boolTag = '[object Boolean]',
                dateTag = '[object Date]',
                errorTag = '[object Error]',
                funcTag = '[object Function]',
                mapTag = '[object Map]',
                numberTag = '[object Number]',
                objectTag = '[object Object]',
                regexpTag = '[object RegExp]',
                setTag = '[object Set]',
                stringTag = '[object String]',
                weakMapTag = '[object WeakMap]';

            var arrayBufferTag = '[object ArrayBuffer]',
                dataViewTag = '[object DataView]',
                float32Tag = '[object Float32Array]',
                float64Tag = '[object Float64Array]',
                int8Tag = '[object Int8Array]',
                int16Tag = '[object Int16Array]',
                int32Tag = '[object Int32Array]',
                uint8Tag = '[object Uint8Array]',
                uint8ClampedTag = '[object Uint8ClampedArray]',
                uint16Tag = '[object Uint16Array]',
                uint32Tag = '[object Uint32Array]';

            /** Used to identify `toStringTag` values of typed arrays. */
            var typedArrayTags = {};
            typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
            typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
            typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
            typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
            typedArrayTags[uint32Tag] = true;
            typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
            typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
            typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
            typedArrayTags[errorTag] = typedArrayTags[funcTag] =
            typedArrayTags[mapTag] = typedArrayTags[numberTag] =
            typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
            typedArrayTags[setTag] = typedArrayTags[stringTag] =
            typedArrayTags[weakMapTag] = false;

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /**
             * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
             * of values.
             */
            var objectToString = objectProto.toString;

            /**
             * Checks if `value` is classified as a typed array.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is correctly classified,
             *  else `false`.
             * @example
             *
             * _.isTypedArray(new Uint8Array);
             * // => true
             *
             * _.isTypedArray([]);
             * // => false
             */
            function isTypedArray(value) {
              return isObjectLike(value) &&
                isLength(value.length) && !!typedArrayTags[objectToString.call(value)];
            }

            module.exports = isTypedArray;
            });

            var require$$0$28 = (isTypedArray && typeof isTypedArray === 'object' && 'default' in isTypedArray ? isTypedArray['default'] : isTypedArray);

            var _WeakMap = __commonjs(function (module) {
            var getNative = require$$1$5,
                root = require$$0$15;

            /* Built-in method references that are verified to be native. */
            var WeakMap = getNative(root, 'WeakMap');

            module.exports = WeakMap;
            });

            var require$$0$29 = (_WeakMap && typeof _WeakMap === 'object' && 'default' in _WeakMap ? _WeakMap['default'] : _WeakMap);

            var _Set = __commonjs(function (module) {
            var getNative = require$$1$5,
                root = require$$0$15;

            /* Built-in method references that are verified to be native. */
            var Set = getNative(root, 'Set');

            module.exports = Set;
            });

            var require$$1$18 = (_Set && typeof _Set === 'object' && 'default' in _Set ? _Set['default'] : _Set);

            var _Promise = __commonjs(function (module) {
            var getNative = require$$1$5,
                root = require$$0$15;

            /* Built-in method references that are verified to be native. */
            var Promise = getNative(root, 'Promise');

            module.exports = Promise;
            });

            var require$$2$9 = (_Promise && typeof _Promise === 'object' && 'default' in _Promise ? _Promise['default'] : _Promise);

            var _DataView = __commonjs(function (module) {
            var getNative = require$$1$5,
                root = require$$0$15;

            /* Built-in method references that are verified to be native. */
            var DataView = getNative(root, 'DataView');

            module.exports = DataView;
            });

            var require$$4$4 = (_DataView && typeof _DataView === 'object' && 'default' in _DataView ? _DataView['default'] : _DataView);

            var _getTag = __commonjs(function (module) {
            var DataView = require$$4$4,
                Map = require$$3$2,
                Promise = require$$2$9,
                Set = require$$1$18,
                WeakMap = require$$0$29;

            /** `Object#toString` result references. */
            var mapTag = '[object Map]',
                objectTag = '[object Object]',
                promiseTag = '[object Promise]',
                setTag = '[object Set]',
                weakMapTag = '[object WeakMap]';

            var dataViewTag = '[object DataView]';

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /** Used to resolve the decompiled source of functions. */
            var funcToString = Function.prototype.toString;

            /**
             * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
             * of values.
             */
            var objectToString = objectProto.toString;

            /** Used to detect maps, sets, and weakmaps. */
            var dataViewCtorString = DataView ? (DataView + '') : '',
                mapCtorString = Map ? funcToString.call(Map) : '',
                promiseCtorString = Promise ? funcToString.call(Promise) : '',
                setCtorString = Set ? funcToString.call(Set) : '',
                weakMapCtorString = WeakMap ? funcToString.call(WeakMap) : '';

            /**
             * Gets the `toStringTag` of `value`.
             *
             * @private
             * @param {*} value The value to query.
             * @returns {string} Returns the `toStringTag`.
             */
            function getTag(value) {
              return objectToString.call(value);
            }

            // Fallback for data views, maps, sets, and weak maps in IE 11,
            // for data views in Edge, and promises in Node.js.
            if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
                (Map && getTag(new Map) != mapTag) ||
                (Promise && getTag(Promise.resolve()) != promiseTag) ||
                (Set && getTag(new Set) != setTag) ||
                (WeakMap && getTag(new WeakMap) != weakMapTag)) {
              getTag = function(value) {
                var result = objectToString.call(value),
                    Ctor = result == objectTag ? value.constructor : null,
                    ctorString = typeof Ctor == 'function' ? funcToString.call(Ctor) : '';

                if (ctorString) {
                  switch (ctorString) {
                    case dataViewCtorString: return dataViewTag;
                    case mapCtorString: return mapTag;
                    case promiseCtorString: return promiseTag;
                    case setCtorString: return setTag;
                    case weakMapCtorString: return weakMapTag;
                  }
                }
                return result;
              };
            }

            module.exports = getTag;
            });

            var require$$7 = (_getTag && typeof _getTag === 'object' && 'default' in _getTag ? _getTag['default'] : _getTag);

            var _isPrototype = __commonjs(function (module) {
            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /**
             * Checks if `value` is likely a prototype object.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
             */
            function isPrototype(value) {
              var Ctor = value && value.constructor,
                  proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;

              return value === proto;
            }

            module.exports = isPrototype;
            });

            var require$$1$19 = (_isPrototype && typeof _isPrototype === 'object' && 'default' in _isPrototype ? _isPrototype['default'] : _isPrototype);

            var _baseTimes = __commonjs(function (module) {
            /**
             * The base implementation of `_.times` without support for iteratee shorthands
             * or max array length checks.
             *
             * @private
             * @param {number} n The number of times to invoke `iteratee`.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array} Returns the array of results.
             */
            function baseTimes(n, iteratee) {
              var index = -1,
                  result = Array(n);

              while (++index < n) {
                result[index] = iteratee(index);
              }
              return result;
            }

            module.exports = baseTimes;
            });

            var require$$4$6 = (_baseTimes && typeof _baseTimes === 'object' && 'default' in _baseTimes ? _baseTimes['default'] : _baseTimes);

            var _indexKeys = __commonjs(function (module) {
            var baseTimes = require$$4$6,
                isArguments = require$$2$7,
                isArray = require$$0$21,
                isLength = require$$1$1,
                isString = _isString;

            /**
             * Creates an array of index keys for `object` values of arrays,
             * `arguments` objects, and strings, otherwise `null` is returned.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array|null} Returns index keys, else `null`.
             */
            function indexKeys(object) {
              var length = object ? object.length : undefined;
              if (isLength(length) &&
                  (isArray(object) || isString(object) || isArguments(object))) {
                return baseTimes(length, String);
              }
              return null;
            }

            module.exports = indexKeys;
            });

            var require$$3$6 = (_indexKeys && typeof _indexKeys === 'object' && 'default' in _indexKeys ? _indexKeys['default'] : _indexKeys);

            var _baseKeys = __commonjs(function (module) {
            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeKeys = Object.keys;

            /**
             * The base implementation of `_.keys` which doesn't skip the constructor
             * property of prototypes or treat sparse arrays as dense.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             */
            function baseKeys(object) {
              return nativeKeys(Object(object));
            }

            module.exports = baseKeys;
            });

            var require$$4$7 = (_baseKeys && typeof _baseKeys === 'object' && 'default' in _baseKeys ? _baseKeys['default'] : _baseKeys);

            var _getPrototype = __commonjs(function (module) {
            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeGetPrototype = Object.getPrototypeOf;

            /**
             * Gets the `[[Prototype]]` of `value`.
             *
             * @private
             * @param {*} value The value to query.
             * @returns {null|Object} Returns the `[[Prototype]]`.
             */
            function getPrototype(value) {
              return nativeGetPrototype(Object(value));
            }

            module.exports = getPrototype;
            });

            var require$$0$31 = (_getPrototype && typeof _getPrototype === 'object' && 'default' in _getPrototype ? _getPrototype['default'] : _getPrototype);

            var _baseHas = __commonjs(function (module) {
            var getPrototype = require$$0$31;

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty = objectProto.hasOwnProperty;

            /**
             * The base implementation of `_.has` without support for deep paths.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array|string} key The key to check.
             * @returns {boolean} Returns `true` if `key` exists, else `false`.
             */
            function baseHas(object, key) {
              // Avoid a bug in IE 10-11 where objects with a [[Prototype]] of `null`,
              // that are composed entirely of index properties, return `false` for
              // `hasOwnProperty` checks of them.
              return hasOwnProperty.call(object, key) ||
                (typeof object == 'object' && key in object && getPrototype(object) === null);
            }

            module.exports = baseHas;
            });

            var require$$1$20 = (_baseHas && typeof _baseHas === 'object' && 'default' in _baseHas ? _baseHas['default'] : _baseHas);

            var keys = __commonjs(function (module) {
            var baseHas = require$$1$20,
                baseKeys = require$$4$7,
                indexKeys = require$$3$6,
                isArrayLike = require$$0$5,
                isIndex = require$$1$15,
                isPrototype = require$$1$19;

            /**
             * Creates an array of the own enumerable property names of `object`.
             *
             * **Note:** Non-object values are coerced to objects. See the
             * [ES spec](http://ecma-international.org/ecma-262/6.0/#sec-object.keys)
             * for more details.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Object
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             * @example
             *
             * function Foo() {
             *   this.a = 1;
             *   this.b = 2;
             * }
             *
             * Foo.prototype.c = 3;
             *
             * _.keys(new Foo);
             * // => ['a', 'b'] (iteration order is not guaranteed)
             *
             * _.keys('hi');
             * // => ['0', '1']
             */
            function keys(object) {
              var isProto = isPrototype(object);
              if (!(isProto || isArrayLike(object))) {
                return baseKeys(object);
              }
              var indexes = indexKeys(object),
                  skipIndexes = !!indexes,
                  result = indexes || [],
                  length = result.length;

              for (var key in object) {
                if (baseHas(object, key) &&
                    !(skipIndexes && (key == 'length' || isIndex(key, length))) &&
                    !(isProto && key == 'constructor')) {
                  result.push(key);
                }
              }
              return result;
            }

            module.exports = keys;
            });

            var require$$0$30 = (keys && typeof keys === 'object' && 'default' in keys ? keys['default'] : keys);

            var _equalObjects = __commonjs(function (module) {
            var baseHas = require$$1$20,
                keys = require$$0$30;

            /** Used to compose bitmasks for comparison styles. */
            var PARTIAL_COMPARE_FLAG = 2;

            /**
             * A specialized version of `baseIsEqualDeep` for objects with support for
             * partial deep comparisons.
             *
             * @private
             * @param {Object} object The object to compare.
             * @param {Object} other The other object to compare.
             * @param {Function} equalFunc The function to determine equivalents of values.
             * @param {Function} customizer The function to customize comparisons.
             * @param {number} bitmask The bitmask of comparison flags. See `baseIsEqual`
             *  for more details.
             * @param {Object} stack Tracks traversed `object` and `other` objects.
             * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
             */
            function equalObjects(object, other, equalFunc, customizer, bitmask, stack) {
              var isPartial = bitmask & PARTIAL_COMPARE_FLAG,
                  objProps = keys(object),
                  objLength = objProps.length,
                  othProps = keys(other),
                  othLength = othProps.length;

              if (objLength != othLength && !isPartial) {
                return false;
              }
              var index = objLength;
              while (index--) {
                var key = objProps[index];
                if (!(isPartial ? key in other : baseHas(other, key))) {
                  return false;
                }
              }
              // Assume cyclic values are equal.
              var stacked = stack.get(object);
              if (stacked) {
                return stacked == other;
              }
              var result = true;
              stack.set(object, other);

              var skipCtor = isPartial;
              while (++index < objLength) {
                key = objProps[index];
                var objValue = object[key],
                    othValue = other[key];

                if (customizer) {
                  var compared = isPartial
                    ? customizer(othValue, objValue, key, other, object, stack)
                    : customizer(objValue, othValue, key, object, other, stack);
                }
                // Recursively compare objects (susceptible to call stack limits).
                if (!(compared === undefined
                      ? (objValue === othValue || equalFunc(objValue, othValue, customizer, bitmask, stack))
                      : compared
                    )) {
                  result = false;
                  break;
                }
                skipCtor || (skipCtor = key == 'constructor');
              }
              if (result && !skipCtor) {
                var objCtor = object.constructor,
                    othCtor = other.constructor;

                // Non `Object` object instances with different constructors are not equal.
                if (objCtor != othCtor &&
                    ('constructor' in object && 'constructor' in other) &&
                    !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
                      typeof othCtor == 'function' && othCtor instanceof othCtor)) {
                  result = false;
                }
              }
              stack['delete'](object);
              return result;
            }

            module.exports = equalObjects;
            });

            var require$$4$5 = (_equalObjects && typeof _equalObjects === 'object' && 'default' in _equalObjects ? _equalObjects['default'] : _equalObjects);

            var _setToArray = __commonjs(function (module) {
            /**
             * Converts `set` to an array.
             *
             * @private
             * @param {Object} set The set to convert.
             * @returns {Array} Returns the converted array.
             */
            function setToArray(set) {
              var index = -1,
                  result = Array(set.size);

              set.forEach(function(value) {
                result[++index] = value;
              });
              return result;
            }

            module.exports = setToArray;
            });

            var require$$0$32 = (_setToArray && typeof _setToArray === 'object' && 'default' in _setToArray ? _setToArray['default'] : _setToArray);

            var _mapToArray = __commonjs(function (module) {
            /**
             * Converts `map` to an array.
             *
             * @private
             * @param {Object} map The map to convert.
             * @returns {Array} Returns the converted array.
             */
            function mapToArray(map) {
              var index = -1,
                  result = Array(map.size);

              map.forEach(function(value, key) {
                result[++index] = [key, value];
              });
              return result;
            }

            module.exports = mapToArray;
            });

            var require$$3$7 = (_mapToArray && typeof _mapToArray === 'object' && 'default' in _mapToArray ? _mapToArray['default'] : _mapToArray);

            var _arraySome = __commonjs(function (module) {
            /**
             * A specialized version of `_.some` for arrays without support for iteratee
             * shorthands.
             *
             * @private
             * @param {Array} array The array to iterate over.
             * @param {Function} predicate The function invoked per iteration.
             * @returns {boolean} Returns `true` if any element passes the predicate check,
             *  else `false`.
             */
            function arraySome(array, predicate) {
              var index = -1,
                  length = array.length;

              while (++index < length) {
                if (predicate(array[index], index, array)) {
                  return true;
                }
              }
              return false;
            }

            module.exports = arraySome;
            });

            var require$$0$33 = (_arraySome && typeof _arraySome === 'object' && 'default' in _arraySome ? _arraySome['default'] : _arraySome);

            var _equalArrays = __commonjs(function (module) {
            var arraySome = require$$0$33;

            /** Used to compose bitmasks for comparison styles. */
            var UNORDERED_COMPARE_FLAG = 1,
                PARTIAL_COMPARE_FLAG = 2;

            /**
             * A specialized version of `baseIsEqualDeep` for arrays with support for
             * partial deep comparisons.
             *
             * @private
             * @param {Array} array The array to compare.
             * @param {Array} other The other array to compare.
             * @param {Function} equalFunc The function to determine equivalents of values.
             * @param {Function} customizer The function to customize comparisons.
             * @param {number} bitmask The bitmask of comparison flags. See `baseIsEqual`
             *  for more details.
             * @param {Object} stack Tracks traversed `array` and `other` objects.
             * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
             */
            function equalArrays(array, other, equalFunc, customizer, bitmask, stack) {
              var index = -1,
                  isPartial = bitmask & PARTIAL_COMPARE_FLAG,
                  isUnordered = bitmask & UNORDERED_COMPARE_FLAG,
                  arrLength = array.length,
                  othLength = other.length;

              if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
                return false;
              }
              // Assume cyclic values are equal.
              var stacked = stack.get(array);
              if (stacked) {
                return stacked == other;
              }
              var result = true;
              stack.set(array, other);

              // Ignore non-index properties.
              while (++index < arrLength) {
                var arrValue = array[index],
                    othValue = other[index];

                if (customizer) {
                  var compared = isPartial
                    ? customizer(othValue, arrValue, index, other, array, stack)
                    : customizer(arrValue, othValue, index, array, other, stack);
                }
                if (compared !== undefined) {
                  if (compared) {
                    continue;
                  }
                  result = false;
                  break;
                }
                // Recursively compare arrays (susceptible to call stack limits).
                if (isUnordered) {
                  if (!arraySome(other, function(othValue) {
                        return arrValue === othValue ||
                          equalFunc(arrValue, othValue, customizer, bitmask, stack);
                      })) {
                    result = false;
                    break;
                  }
                } else if (!(
                      arrValue === othValue ||
                        equalFunc(arrValue, othValue, customizer, bitmask, stack)
                    )) {
                  result = false;
                  break;
                }
              }
              stack['delete'](array);
              return result;
            }

            module.exports = equalArrays;
            });

            var require$$2$10 = (_equalArrays && typeof _equalArrays === 'object' && 'default' in _equalArrays ? _equalArrays['default'] : _equalArrays);

            var _Uint8Array = __commonjs(function (module) {
            var root = require$$0$15;

            /** Built-in value references. */
            var Uint8Array = root.Uint8Array;

            module.exports = Uint8Array;
            });

            var require$$3$8 = (_Uint8Array && typeof _Uint8Array === 'object' && 'default' in _Uint8Array ? _Uint8Array['default'] : _Uint8Array);

            var _equalByTag = __commonjs(function (module) {
            var Symbol = require$$9,
                Uint8Array = require$$3$8,
                equalArrays = require$$2$10,
                mapToArray = require$$3$7,
                setToArray = require$$0$32;

            /** Used to compose bitmasks for comparison styles. */
            var UNORDERED_COMPARE_FLAG = 1,
                PARTIAL_COMPARE_FLAG = 2;

            /** `Object#toString` result references. */
            var boolTag = '[object Boolean]',
                dateTag = '[object Date]',
                errorTag = '[object Error]',
                mapTag = '[object Map]',
                numberTag = '[object Number]',
                regexpTag = '[object RegExp]',
                setTag = '[object Set]',
                stringTag = '[object String]',
                symbolTag = '[object Symbol]';

            var arrayBufferTag = '[object ArrayBuffer]',
                dataViewTag = '[object DataView]';

            /** Used to convert symbols to primitives and strings. */
            var symbolProto = Symbol ? Symbol.prototype : undefined,
                symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

            /**
             * A specialized version of `baseIsEqualDeep` for comparing objects of
             * the same `toStringTag`.
             *
             * **Note:** This function only supports comparing values with tags of
             * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
             *
             * @private
             * @param {Object} object The object to compare.
             * @param {Object} other The other object to compare.
             * @param {string} tag The `toStringTag` of the objects to compare.
             * @param {Function} equalFunc The function to determine equivalents of values.
             * @param {Function} customizer The function to customize comparisons.
             * @param {number} bitmask The bitmask of comparison flags. See `baseIsEqual`
             *  for more details.
             * @param {Object} stack Tracks traversed `object` and `other` objects.
             * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
             */
            function equalByTag(object, other, tag, equalFunc, customizer, bitmask, stack) {
              switch (tag) {
                case dataViewTag:
                  if ((object.byteLength != other.byteLength) ||
                      (object.byteOffset != other.byteOffset)) {
                    return false;
                  }
                  object = object.buffer;
                  other = other.buffer;

                case arrayBufferTag:
                  if ((object.byteLength != other.byteLength) ||
                      !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
                    return false;
                  }
                  return true;

                case boolTag:
                case dateTag:
                  // Coerce dates and booleans to numbers, dates to milliseconds and
                  // booleans to `1` or `0` treating invalid dates coerced to `NaN` as
                  // not equal.
                  return +object == +other;

                case errorTag:
                  return object.name == other.name && object.message == other.message;

                case numberTag:
                  // Treat `NaN` vs. `NaN` as equal.
                  return (object != +object) ? other != +other : object == +other;

                case regexpTag:
                case stringTag:
                  // Coerce regexes to strings and treat strings, primitives and objects,
                  // as equal. See https://es5.github.io/#x15.10.6.4 for more details.
                  return object == (other + '');

                case mapTag:
                  var convert = mapToArray;

                case setTag:
                  var isPartial = bitmask & PARTIAL_COMPARE_FLAG;
                  convert || (convert = setToArray);

                  if (object.size != other.size && !isPartial) {
                    return false;
                  }
                  // Assume cyclic values are equal.
                  var stacked = stack.get(object);
                  if (stacked) {
                    return stacked == other;
                  }
                  bitmask |= UNORDERED_COMPARE_FLAG;
                  stack.set(object, other);

                  // Recursively compare objects (susceptible to call stack limits).
                  return equalArrays(convert(object), convert(other), equalFunc, customizer, bitmask, stack);

                case symbolTag:
                  if (symbolValueOf) {
                    return symbolValueOf.call(object) == symbolValueOf.call(other);
                  }
              }
              return false;
            }

            module.exports = equalByTag;
            });

            var require$$5$1 = (_equalByTag && typeof _equalByTag === 'object' && 'default' in _equalByTag ? _equalByTag['default'] : _equalByTag);

            var _stackSet = __commonjs(function (module) {
            var MapCache = require$$1$3,
                assocSet = require$$0$12;

            /** Used as the size to enable large array optimizations. */
            var LARGE_ARRAY_SIZE = 200;

            /**
             * Sets the stack `key` to `value`.
             *
             * @private
             * @name set
             * @memberOf Stack
             * @param {string} key The key of the value to set.
             * @param {*} value The value to set.
             * @returns {Object} Returns the stack cache instance.
             */
            function stackSet(key, value) {
              var data = this.__data__,
                  array = data.array;

              if (array) {
                if (array.length < (LARGE_ARRAY_SIZE - 1)) {
                  assocSet(array, key, value);
                } else {
                  data.array = null;
                  data.map = new MapCache(array);
                }
              }
              var map = data.map;
              if (map) {
                map.set(key, value);
              }
              return this;
            }

            module.exports = stackSet;
            });

            var require$$0$34 = (_stackSet && typeof _stackSet === 'object' && 'default' in _stackSet ? _stackSet['default'] : _stackSet);

            var _stackHas = __commonjs(function (module) {
            var assocHas = require$$0$18;

            /**
             * Checks if a stack value for `key` exists.
             *
             * @private
             * @name has
             * @memberOf Stack
             * @param {string} key The key of the entry to check.
             * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
             */
            function stackHas(key) {
              var data = this.__data__,
                  array = data.array;

              return array ? assocHas(array, key) : data.map.has(key);
            }

            module.exports = stackHas;
            });

            var require$$1$22 = (_stackHas && typeof _stackHas === 'object' && 'default' in _stackHas ? _stackHas['default'] : _stackHas);

            var _stackGet = __commonjs(function (module) {
            var assocGet = require$$0$19;

            /**
             * Gets the stack value for `key`.
             *
             * @private
             * @name get
             * @memberOf Stack
             * @param {string} key The key of the value to get.
             * @returns {*} Returns the entry value.
             */
            function stackGet(key) {
              var data = this.__data__,
                  array = data.array;

              return array ? assocGet(array, key) : data.map.get(key);
            }

            module.exports = stackGet;
            });

            var require$$2$11 = (_stackGet && typeof _stackGet === 'object' && 'default' in _stackGet ? _stackGet['default'] : _stackGet);

            var _stackDelete = __commonjs(function (module) {
            var assocDelete = require$$0$20;

            /**
             * Removes `key` and its value from the stack.
             *
             * @private
             * @name delete
             * @memberOf Stack
             * @param {string} key The key of the value to remove.
             * @returns {boolean} Returns `true` if the entry was removed, else `false`.
             */
            function stackDelete(key) {
              var data = this.__data__,
                  array = data.array;

              return array ? assocDelete(array, key) : data.map['delete'](key);
            }

            module.exports = stackDelete;
            });

            var require$$3$9 = (_stackDelete && typeof _stackDelete === 'object' && 'default' in _stackDelete ? _stackDelete['default'] : _stackDelete);

            var _stackClear = __commonjs(function (module) {
            /**
             * Removes all key-value entries from the stack.
             *
             * @private
             * @name clear
             * @memberOf Stack
             */
            function stackClear() {
              this.__data__ = { 'array': [], 'map': null };
            }

            module.exports = stackClear;
            });

            var require$$4$8 = (_stackClear && typeof _stackClear === 'object' && 'default' in _stackClear ? _stackClear['default'] : _stackClear);

            var _Stack = __commonjs(function (module) {
            var stackClear = require$$4$8,
                stackDelete = require$$3$9,
                stackGet = require$$2$11,
                stackHas = require$$1$22,
                stackSet = require$$0$34;

            /**
             * Creates a stack cache object to store key-value pairs.
             *
             * @private
             * @constructor
             * @param {Array} [values] The values to cache.
             */
            function Stack(values) {
              var index = -1,
                  length = values ? values.length : 0;

              this.clear();
              while (++index < length) {
                var entry = values[index];
                this.set(entry[0], entry[1]);
              }
            }

            // Add methods to `Stack`.
            Stack.prototype.clear = stackClear;
            Stack.prototype['delete'] = stackDelete;
            Stack.prototype.get = stackGet;
            Stack.prototype.has = stackHas;
            Stack.prototype.set = stackSet;

            module.exports = Stack;
            });

            var require$$1$21 = (_Stack && typeof _Stack === 'object' && 'default' in _Stack ? _Stack['default'] : _Stack);

            var _baseIsEqualDeep = __commonjs(function (module) {
            var Stack = require$$1$21,
                equalArrays = require$$2$10,
                equalByTag = require$$5$1,
                equalObjects = require$$4$5,
                getTag = require$$7,
                isArray = require$$0$21,
                isHostObject = require$$1$6,
                isTypedArray = require$$0$28;

            /** Used to compose bitmasks for comparison styles. */
            var PARTIAL_COMPARE_FLAG = 2;

            /** `Object#toString` result references. */
            var argsTag = '[object Arguments]',
                arrayTag = '[object Array]',
                objectTag = '[object Object]';

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty = objectProto.hasOwnProperty;

            /**
             * A specialized version of `baseIsEqual` for arrays and objects which performs
             * deep comparisons and tracks traversed objects enabling objects with circular
             * references to be compared.
             *
             * @private
             * @param {Object} object The object to compare.
             * @param {Object} other The other object to compare.
             * @param {Function} equalFunc The function to determine equivalents of values.
             * @param {Function} [customizer] The function to customize comparisons.
             * @param {number} [bitmask] The bitmask of comparison flags. See `baseIsEqual`
             *  for more details.
             * @param {Object} [stack] Tracks traversed `object` and `other` objects.
             * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
             */
            function baseIsEqualDeep(object, other, equalFunc, customizer, bitmask, stack) {
              var objIsArr = isArray(object),
                  othIsArr = isArray(other),
                  objTag = arrayTag,
                  othTag = arrayTag;

              if (!objIsArr) {
                objTag = getTag(object);
                objTag = objTag == argsTag ? objectTag : objTag;
              }
              if (!othIsArr) {
                othTag = getTag(other);
                othTag = othTag == argsTag ? objectTag : othTag;
              }
              var objIsObj = objTag == objectTag && !isHostObject(object),
                  othIsObj = othTag == objectTag && !isHostObject(other),
                  isSameTag = objTag == othTag;

              if (isSameTag && !objIsObj) {
                stack || (stack = new Stack);
                return (objIsArr || isTypedArray(object))
                  ? equalArrays(object, other, equalFunc, customizer, bitmask, stack)
                  : equalByTag(object, other, objTag, equalFunc, customizer, bitmask, stack);
              }
              if (!(bitmask & PARTIAL_COMPARE_FLAG)) {
                var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
                    othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

                if (objIsWrapped || othIsWrapped) {
                  var objUnwrapped = objIsWrapped ? object.value() : object,
                      othUnwrapped = othIsWrapped ? other.value() : other;

                  stack || (stack = new Stack);
                  return equalFunc(objUnwrapped, othUnwrapped, customizer, bitmask, stack);
                }
              }
              if (!isSameTag) {
                return false;
              }
              stack || (stack = new Stack);
              return equalObjects(object, other, equalFunc, customizer, bitmask, stack);
            }

            module.exports = baseIsEqualDeep;
            });

            var require$$2$8 = (_baseIsEqualDeep && typeof _baseIsEqualDeep === 'object' && 'default' in _baseIsEqualDeep ? _baseIsEqualDeep['default'] : _baseIsEqualDeep);

            var _baseIsEqual = __commonjs(function (module) {
            var baseIsEqualDeep = require$$2$8,
                isObject = _isObject,
                isObjectLike = require$$0$3;

            /**
             * The base implementation of `_.isEqual` which supports partial comparisons
             * and tracks traversed objects.
             *
             * @private
             * @param {*} value The value to compare.
             * @param {*} other The other value to compare.
             * @param {Function} [customizer] The function to customize comparisons.
             * @param {boolean} [bitmask] The bitmask of comparison flags.
             *  The bitmask may be composed of the following flags:
             *     1 - Unordered comparison
             *     2 - Partial comparison
             * @param {Object} [stack] Tracks traversed `value` and `other` objects.
             * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
             */
            function baseIsEqual(value, other, customizer, bitmask, stack) {
              if (value === other) {
                return true;
              }
              if (value == null || other == null || (!isObject(value) && !isObjectLike(other))) {
                return value !== value && other !== other;
              }
              return baseIsEqualDeep(value, other, baseIsEqual, customizer, bitmask, stack);
            }

            module.exports = baseIsEqual;
            });

            var require$$0$27 = (_baseIsEqual && typeof _baseIsEqual === 'object' && 'default' in _baseIsEqual ? _baseIsEqual['default'] : _baseIsEqual);

            var _baseMatchesProperty = __commonjs(function (module) {
            var baseIsEqual = require$$0$27,
                get = require$$1$17,
                hasIn = require$$0$25;

            /** Used to compose bitmasks for comparison styles. */
            var UNORDERED_COMPARE_FLAG = 1,
                PARTIAL_COMPARE_FLAG = 2;

            /**
             * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
             *
             * @private
             * @param {string} path The path of the property to get.
             * @param {*} srcValue The value to match.
             * @returns {Function} Returns the new function.
             */
            function baseMatchesProperty(path, srcValue) {
              return function(object) {
                var objValue = get(object, path);
                return (objValue === undefined && objValue === srcValue)
                  ? hasIn(object, path)
                  : baseIsEqual(srcValue, objValue, undefined, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG);
              };
            }

            module.exports = baseMatchesProperty;
            });

            var require$$3$5 = (_baseMatchesProperty && typeof _baseMatchesProperty === 'object' && 'default' in _baseMatchesProperty ? _baseMatchesProperty['default'] : _baseMatchesProperty);

            var _baseToPairs = __commonjs(function (module) {
            var arrayMap = require$$3;

            /**
             * The base implementation of `_.toPairs` and `_.toPairsIn` which creates an array
             * of key-value pairs for `object` corresponding to the property names of `props`.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array} props The property names to get values for.
             * @returns {Object} Returns the new array of key-value pairs.
             */
            function baseToPairs(object, props) {
              return arrayMap(props, function(key) {
                return [key, object[key]];
              });
            }

            module.exports = baseToPairs;
            });

            var require$$1$23 = (_baseToPairs && typeof _baseToPairs === 'object' && 'default' in _baseToPairs ? _baseToPairs['default'] : _baseToPairs);

            var toPairs = __commonjs(function (module) {
            var baseToPairs = require$$1$23,
                keys = require$$0$30;

            /**
             * Creates an array of own enumerable string keyed-value pairs for `object`
             * which can be consumed by `_.fromPairs`.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @alias entries
             * @category Object
             * @param {Object} object The object to query.
             * @returns {Array} Returns the new array of key-value pairs.
             * @example
             *
             * function Foo() {
             *   this.a = 1;
             *   this.b = 2;
             * }
             *
             * Foo.prototype.c = 3;
             *
             * _.toPairs(new Foo);
             * // => [['a', 1], ['b', 2]] (iteration order is not guaranteed)
             */
            function toPairs(object) {
              return baseToPairs(object, keys(object));
            }

            module.exports = toPairs;
            });

            var require$$0$36 = (toPairs && typeof toPairs === 'object' && 'default' in toPairs ? toPairs['default'] : toPairs);

            var _isStrictComparable = __commonjs(function (module) {
            var isObject = _isObject;

            /**
             * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` if suitable for strict
             *  equality comparisons, else `false`.
             */
            function isStrictComparable(value) {
              return value === value && !isObject(value);
            }

            module.exports = isStrictComparable;
            });

            var require$$1$24 = (_isStrictComparable && typeof _isStrictComparable === 'object' && 'default' in _isStrictComparable ? _isStrictComparable['default'] : _isStrictComparable);

            var _getMatchData = __commonjs(function (module) {
            var isStrictComparable = require$$1$24,
                toPairs = require$$0$36;

            /**
             * Gets the property names, values, and compare flags of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the match data of `object`.
             */
            function getMatchData(object) {
              var result = toPairs(object),
                  length = result.length;

              while (length--) {
                result[length][2] = isStrictComparable(result[length][1]);
              }
              return result;
            }

            module.exports = getMatchData;
            });

            var require$$0$35 = (_getMatchData && typeof _getMatchData === 'object' && 'default' in _getMatchData ? _getMatchData['default'] : _getMatchData);

            var _baseIsMatch = __commonjs(function (module) {
            var Stack = require$$1$21,
                baseIsEqual = require$$0$27;

            /** Used to compose bitmasks for comparison styles. */
            var UNORDERED_COMPARE_FLAG = 1,
                PARTIAL_COMPARE_FLAG = 2;

            /**
             * The base implementation of `_.isMatch` without support for iteratee shorthands.
             *
             * @private
             * @param {Object} object The object to inspect.
             * @param {Object} source The object of property values to match.
             * @param {Array} matchData The property names, values, and compare flags to match.
             * @param {Function} [customizer] The function to customize comparisons.
             * @returns {boolean} Returns `true` if `object` is a match, else `false`.
             */
            function baseIsMatch(object, source, matchData, customizer) {
              var index = matchData.length,
                  length = index,
                  noCustomizer = !customizer;

              if (object == null) {
                return !length;
              }
              object = Object(object);
              while (index--) {
                var data = matchData[index];
                if ((noCustomizer && data[2])
                      ? data[1] !== object[data[0]]
                      : !(data[0] in object)
                    ) {
                  return false;
                }
              }
              while (++index < length) {
                data = matchData[index];
                var key = data[0],
                    objValue = object[key],
                    srcValue = data[1];

                if (noCustomizer && data[2]) {
                  if (objValue === undefined && !(key in object)) {
                    return false;
                  }
                } else {
                  var stack = new Stack;
                  if (customizer) {
                    var result = customizer(objValue, srcValue, key, object, source, stack);
                  }
                  if (!(result === undefined
                        ? baseIsEqual(srcValue, objValue, customizer, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG, stack)
                        : result
                      )) {
                    return false;
                  }
                }
              }
              return true;
            }

            module.exports = baseIsMatch;
            });

            var require$$1$25 = (_baseIsMatch && typeof _baseIsMatch === 'object' && 'default' in _baseIsMatch ? _baseIsMatch['default'] : _baseIsMatch);

            var _baseMatches = __commonjs(function (module) {
            var baseIsMatch = require$$1$25,
                getMatchData = require$$0$35;

            /**
             * The base implementation of `_.matches` which doesn't clone `source`.
             *
             * @private
             * @param {Object} source The object of property values to match.
             * @returns {Function} Returns the new function.
             */
            function baseMatches(source) {
              var matchData = getMatchData(source);
              if (matchData.length == 1 && matchData[0][2]) {
                var key = matchData[0][0],
                    value = matchData[0][1];

                return function(object) {
                  if (object == null) {
                    return false;
                  }
                  return object[key] === value &&
                    (value !== undefined || (key in Object(object)));
                };
              }
              return function(object) {
                return object === source || baseIsMatch(object, source, matchData);
              };
            }

            module.exports = baseMatches;
            });

            var require$$4$9 = (_baseMatches && typeof _baseMatches === 'object' && 'default' in _baseMatches ? _baseMatches['default'] : _baseMatches);

            var _baseIteratee = __commonjs(function (module) {
            var baseMatches = require$$4$9,
                baseMatchesProperty = require$$3$5,
                identity = require$$2$6,
                isArray = require$$0$21,
                property = require$$0$22;

            /**
             * The base implementation of `_.iteratee`.
             *
             * @private
             * @param {*} [value=_.identity] The value to convert to an iteratee.
             * @returns {Function} Returns the iteratee.
             */
            function baseIteratee(value) {
              // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
              // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
              if (typeof value == 'function') {
                return value;
              }
              if (value == null) {
                return identity;
              }
              if (typeof value == 'object') {
                return isArray(value)
                  ? baseMatchesProperty(value[0], value[1])
                  : baseMatches(value);
              }
              return property(value);
            }

            module.exports = baseIteratee;
            });

            var require$$1$11 = (_baseIteratee && typeof _baseIteratee === 'object' && 'default' in _baseIteratee ? _baseIteratee['default'] : _baseIteratee);

            var _createBaseEach = __commonjs(function (module) {
            var isArrayLike = require$$0$5;

            /**
             * Creates a `baseEach` or `baseEachRight` function.
             *
             * @private
             * @param {Function} eachFunc The function to iterate over a collection.
             * @param {boolean} [fromRight] Specify iterating from right to left.
             * @returns {Function} Returns the new base function.
             */
            function createBaseEach(eachFunc, fromRight) {
              return function(collection, iteratee) {
                if (collection == null) {
                  return collection;
                }
                if (!isArrayLike(collection)) {
                  return eachFunc(collection, iteratee);
                }
                var length = collection.length,
                    index = fromRight ? length : -1,
                    iterable = Object(collection);

                while ((fromRight ? index-- : ++index < length)) {
                  if (iteratee(iterable[index], index, iterable) === false) {
                    break;
                  }
                }
                return collection;
              };
            }

            module.exports = createBaseEach;
            });

            var require$$0$37 = (_createBaseEach && typeof _createBaseEach === 'object' && 'default' in _createBaseEach ? _createBaseEach['default'] : _createBaseEach);

            var _createBaseFor = __commonjs(function (module) {
            /**
             * Creates a base function for methods like `_.forIn` and `_.forOwn`.
             *
             * @private
             * @param {boolean} [fromRight] Specify iterating from right to left.
             * @returns {Function} Returns the new base function.
             */
            function createBaseFor(fromRight) {
              return function(object, iteratee, keysFunc) {
                var index = -1,
                    iterable = Object(object),
                    props = keysFunc(object),
                    length = props.length;

                while (length--) {
                  var key = props[fromRight ? length : ++index];
                  if (iteratee(iterable[key], key, iterable) === false) {
                    break;
                  }
                }
                return object;
              };
            }

            module.exports = createBaseFor;
            });

            var require$$0$38 = (_createBaseFor && typeof _createBaseFor === 'object' && 'default' in _createBaseFor ? _createBaseFor['default'] : _createBaseFor);

            var _baseFor = __commonjs(function (module) {
            var createBaseFor = require$$0$38;

            /**
             * The base implementation of `baseForOwn` which iterates over `object`
             * properties returned by `keysFunc` invoking `iteratee` for each property.
             * Iteratee functions may exit iteration early by explicitly returning `false`.
             *
             * @private
             * @param {Object} object The object to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @param {Function} keysFunc The function to get the keys of `object`.
             * @returns {Object} Returns `object`.
             */
            var baseFor = createBaseFor();

            module.exports = baseFor;
            });

            var require$$1$27 = (_baseFor && typeof _baseFor === 'object' && 'default' in _baseFor ? _baseFor['default'] : _baseFor);

            var _baseForOwn = __commonjs(function (module) {
            var baseFor = require$$1$27,
                keys = require$$0$30;

            /**
             * The base implementation of `_.forOwn` without support for iteratee shorthands.
             *
             * @private
             * @param {Object} object The object to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Object} Returns `object`.
             */
            function baseForOwn(object, iteratee) {
              return object && baseFor(object, iteratee, keys);
            }

            module.exports = baseForOwn;
            });

            var require$$1$26 = (_baseForOwn && typeof _baseForOwn === 'object' && 'default' in _baseForOwn ? _baseForOwn['default'] : _baseForOwn);

            var _baseEach = __commonjs(function (module) {
            var baseForOwn = require$$1$26,
                createBaseEach = require$$0$37;

            /**
             * The base implementation of `_.forEach` without support for iteratee shorthands.
             *
             * @private
             * @param {Array|Object} collection The collection to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array|Object} Returns `collection`.
             */
            var baseEach = createBaseEach(baseForOwn);

            module.exports = baseEach;
            });

            var require$$4$10 = (_baseEach && typeof _baseEach === 'object' && 'default' in _baseEach ? _baseEach['default'] : _baseEach);

            var _arrayEach = __commonjs(function (module) {
            /**
             * A specialized version of `_.forEach` for arrays without support for
             * iteratee shorthands.
             *
             * @private
             * @param {Array} array The array to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array} Returns `array`.
             */
            function arrayEach(array, iteratee) {
              var index = -1,
                  length = array.length;

              while (++index < length) {
                if (iteratee(array[index], index, array) === false) {
                  break;
                }
              }
              return array;
            }

            module.exports = arrayEach;
            });

            var require$$3$10 = (_arrayEach && typeof _arrayEach === 'object' && 'default' in _arrayEach ? _arrayEach['default'] : _arrayEach);

            var forEach = __commonjs(function (module) {
            var arrayEach = require$$3$10,
                baseEach = require$$4$10,
                baseIteratee = require$$1$11,
                isArray = require$$0$21;

            /**
             * Iterates over elements of `collection` invoking `iteratee` for each element.
             * The iteratee is invoked with three arguments: (value, index|key, collection).
             * Iteratee functions may exit iteration early by explicitly returning `false`.
             *
             * **Note:** As with other "Collections" methods, objects with a "length"
             * property are iterated like arrays. To avoid this behavior use `_.forIn`
             * or `_.forOwn` for object iteration.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @alias each
             * @category Collection
             * @param {Array|Object} collection The collection to iterate over.
             * @param {Function} [iteratee=_.identity] The function invoked per iteration.
             * @returns {Array|Object} Returns `collection`.
             * @example
             *
             * _([1, 2]).forEach(function(value) {
             *   console.log(value);
             * });
             * // => Logs `1` then `2`.
             *
             * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
             *   console.log(key);
             * });
             * // => Logs 'a' then 'b' (iteration order is not guaranteed).
             */
            function forEach(collection, iteratee) {
              return (typeof iteratee == 'function' && isArray(collection))
                ? arrayEach(collection, iteratee)
                : baseEach(collection, baseIteratee(iteratee));
            }

            module.exports = forEach;
            });

            var _forEach = (forEach && typeof forEach === 'object' && 'default' in forEach ? forEach['default'] : forEach);

            // shim for using process in browser
            // based off https://github.com/defunctzombie/node-process/blob/master/browser.js
            var queue = [];
            var draining = false;
            var currentQueue;
            var queueIndex = -1;

            function cleanUpNextTick() {
                draining = false;
                if (currentQueue.length) {
                    queue = currentQueue.concat(queue);
                } else {
                    queueIndex = -1;
                }
                if (queue.length) {
                    drainQueue();
                }
            }

            function drainQueue() {
                if (draining) {
                    return;
                }
                var timeout = setTimeout(cleanUpNextTick);
                draining = true;

                var len = queue.length;
                while(len) {
                    currentQueue = queue;
                    queue = [];
                    while (++queueIndex < len) {
                        if (currentQueue) {
                            currentQueue[queueIndex].run();
                        }
                    }
                    queueIndex = -1;
                    len = queue.length;
                }
                currentQueue = null;
                draining = false;
                clearTimeout(timeout);
            }

            function $inject_process_nextTick(fun) {
                var args = new Array(arguments.length - 1);
                if (arguments.length > 1) {
                    for (var i = 1; i < arguments.length; i++) {
                        args[i - 1] = arguments[i];
                    }
                }
                queue.push(new Item(fun, args));
                if (queue.length === 1 && !draining) {
                    setTimeout(drainQueue, 0);
                }
            }

            // v8 likes predictible objects
            function Item(fun, array) {
                this.fun = fun;
                this.array = array;
            }
            Item.prototype.run = function () {
                this.fun.apply(null, this.array);
            };
            var title = 'browser';
            var browser = true;
            var env = {};
            var argv = [];
            var version$1 = ''; // empty string to avoid regexp issues
            var versions = {};

            function noop() {}

            var on = noop;
            var addListener = noop;
            var once = noop;
            var off = noop;
            var removeListener = noop;
            var removeAllListeners = noop;
            var emit = noop;

            function binding(name) {
                throw new Error('process.binding is not supported');
            }

            function cwd () { return '/' }
            function chdir (dir) {
                throw new Error('process.chdir is not supported');
            };
            function umask() { return 0; }

            var process = {
              nextTick: $inject_process_nextTick,
              title: title,
              browser: browser,
              env: env,
              argv: argv,
              version: version$1,
              versions: versions,
              on: on,
              addListener: addListener,
              once: once,
              off: off,
              removeListener: removeListener,
              removeAllListeners: removeAllListeners,
              emit: emit,
              binding: binding,
              cwd: cwd,
              chdir: chdir,
              umask: umask
            };

            /**
             * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
             *
             * Licensed under the Apache License, Version 2.0 (the "License");
             * you may not use this file except in compliance with the License.
             * You may obtain a copy of the License at
             *
             *      http://www.apache.org/licenses/LICENSE-2.0
             *
             * Unless required by applicable law or agreed to in writing, software
             * distributed under the License is distributed on an "AS-IS" BASIS,
             * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
             * See the License for the specific language governing permissions and
             * limitations under the License.
             */


            /**
             * A cached reference to the hasOwnProperty function.
             */
            var hasOwnProperty = Object.prototype.hasOwnProperty;


            /**
             * A cached reference to the create function.
             */
            var create = Object.create;


            /**
             * Used to prevent property collisions between our "map" and its prototype.
             * @param {!Object<string, *>} map The map to check.
             * @param {string} property The property to check.
             * @return {boolean} Whether map has property.
             */
            var has = function(map, property) {
              return hasOwnProperty.call(map, property);
            };


            /**
             * Creates an map object without a prototype.
             * @return {!Object}
             */
            var createMap = function() {
              return create(null);
            };

            /**
             * Keeps track of information needed to perform diffs for a given DOM node.
             * @param {!string} nodeName
             * @param {?string=} key
             * @constructor
             */
            function NodeData(nodeName, key) {
              /**
               * The attributes and their values.
               * @const {!Object<string, *>}
               */
              this.attrs = createMap();

              /**
               * An array of attribute name/value pairs, used for quickly diffing the
               * incomming attributes to see if the DOM node's attributes need to be
               * updated.
               * @const {Array<*>}
               */
              this.attrsArr = [];

              /**
               * The incoming attributes for this Node, before they are updated.
               * @const {!Object<string, *>}
               */
              this.newAttrs = createMap();

              /**
               * The key used to identify this node, used to preserve DOM nodes when they
               * move within their parent.
               * @const
               */
              this.key = key;

              /**
               * Keeps track of children within this node by their key.
               * {?Object<string, !Element>}
               */
              this.keyMap = null;

              /**
               * Whether or not the keyMap is currently valid.
               * {boolean}
               */
              this.keyMapValid = true;

              /**
               * The node name for this node.
               * @const {string}
               */
              this.nodeName = nodeName;

              /**
               * @type {?string}
               */
              this.text = null;
            }


            /**
             * Initializes a NodeData object for a Node.
             *
             * @param {Node} node The node to initialize data for.
             * @param {string} nodeName The node name of node.
             * @param {?string=} key The key that identifies the node.
             * @return {!NodeData} The newly initialized data object
             */
            var initData = function(node, nodeName, key) {
              var data = new NodeData(nodeName, key);
              node['__incrementalDOMData'] = data;
              return data;
            };


            /**
             * Retrieves the NodeData object for a Node, creating it if necessary.
             *
             * @param {Node} node The node to retrieve the data for.
             * @return {!NodeData} The NodeData for this Node.
             */
            var getData = function(node) {
              var data = node['__incrementalDOMData'];

              if (!data) {
                var nodeName = node.nodeName.toLowerCase();
                var key = null;

                if (node instanceof Element) {
                  key = node.getAttribute('key');
                }

                data = initData(node, nodeName, key);
              }

              return data;
            };

            /**
             * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
             *
             * Licensed under the Apache License, Version 2.0 (the "License");
             * you may not use this file except in compliance with the License.
             * You may obtain a copy of the License at
             *
             *      http://www.apache.org/licenses/LICENSE-2.0
             *
             * Unless required by applicable law or agreed to in writing, software
             * distributed under the License is distributed on an "AS-IS" BASIS,
             * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
             * See the License for the specific language governing permissions and
             * limitations under the License.
             */

            var symbols = {
              default: '__default',

              placeholder: '__placeholder'
            };

            /**
             * Applies an attribute or property to a given Element. If the value is null
             * or undefined, it is removed from the Element. Otherwise, the value is set
             * as an attribute.
             * @param {!Element} el
             * @param {string} name The attribute's name.
             * @param {?(boolean|number|string)=} value The attribute's value.
             */
            var applyAttr = function(el, name, value) {
              if (value == null) {
                el.removeAttribute(name);
              } else {
                el.setAttribute(name, value);
              }
            };

            /**
             * Applies a property to a given Element.
             * @param {!Element} el
             * @param {string} name The property's name.
             * @param {*} value The property's value.
             */
            var applyProp = function(el, name, value) {
              el[name] = value;
            };


            /**
             * Applies a style to an Element. No vendor prefix expansion is done for
             * property names/values.
             * @param {!Element} el
             * @param {string} name The attribute's name.
             * @param {*} style The style to set. Either a string of css or an object
             *     containing property-value pairs.
             */
            var applyStyle = function(el, name, style) {
              if (typeof style === 'string') {
                el.style.cssText = style;
              } else {
                el.style.cssText = '';
                var elStyle = el.style;
                var obj = /** @type {!Object<string,string>} */(style);

                for (var prop in obj) {
                  if (has(obj, prop)) {
                    elStyle[prop] = obj[prop];
                  }
                }
              }
            };


            /**
             * Updates a single attribute on an Element.
             * @param {!Element} el
             * @param {string} name The attribute's name.
             * @param {*} value The attribute's value. If the value is an object or
             *     function it is set on the Element, otherwise, it is set as an HTML
             *     attribute.
             */
            var applyAttributeTyped = function(el, name, value) {
              var type = typeof value;

              if (type === 'object' || type === 'function') {
                applyProp(el, name, value);
              } else {
                applyAttr(el, name, /** @type {?(boolean|number|string)} */(value));
              }
            };


            /**
             * Calls the appropriate attribute mutator for this attribute.
             * @param {!Element} el
             * @param {string} name The attribute's name.
             * @param {*} value The attribute's value.
             */
            var updateAttribute = function(el, name, value) {
              var data = getData(el);
              var attrs = data.attrs;

              if (attrs[name] === value) {
                return;
              }

              var mutator = attributes[name] || attributes[symbols.default];
              mutator(el, name, value);

              attrs[name] = value;
            };


            /**
             * A publicly mutable object to provide custom mutators for attributes.
             * @const {!Object<string, function(!Element, string, *)>}
             */
            var attributes = createMap();

            // Special generic mutator that's called for any attribute that does not
            // have a specific mutator.
            attributes[symbols.default] = applyAttributeTyped;

            attributes[symbols.placeholder] = function() {};

            attributes['style'] = applyStyle;

            /**
             * Gets the namespace to create an element (of a given tag) in.
             * @param {string} tag The tag to get the namespace for.
             * @param {?Node} parent
             * @return {?string} The namespace to create the tag in.
             */
            var getNamespaceForTag = function(tag, parent) {
              if (tag === 'svg') {
                return 'http://www.w3.org/2000/svg';
              }

              if (getData(parent).nodeName === 'foreignObject') {
                return null;
              }

              return parent.namespaceURI;
            };


            /**
             * Creates an Element.
             * @param {Document} doc The document with which to create the Element.
             * @param {?Node} parent
             * @param {string} tag The tag for the Element.
             * @param {?string=} key A key to identify the Element.
             * @param {?Array<*>=} statics An array of attribute name/value pairs of the
             *     static attributes for the Element.
             * @return {!Element}
             */
            var createElement = function(doc, parent, tag, key, statics) {
              var namespace = getNamespaceForTag(tag, parent);
              var el;

              if (namespace) {
                el = doc.createElementNS(namespace, tag);
              } else {
                el = doc.createElement(tag);
              }

              initData(el, tag, key);

              if (statics) {
                for (var i = 0; i < statics.length; i += 2) {
                  updateAttribute(el, /** @type {!string}*/(statics[i]), statics[i + 1]);
                }
              }

              return el;
            };


            /**
             * Creates a Text Node.
             * @param {Document} doc The document with which to create the Element.
             * @return {!Text}
             */
            var createText = function(doc) {
              var node = doc.createTextNode('');
              initData(node, '#text', null);
              return node;
            };


            /**
             * Creates a mapping that can be used to look up children using a key.
             * @param {?Node} el
             * @return {!Object<string, !Element>} A mapping of keys to the children of the
             *     Element.
             */
            var createKeyMap = function(el) {
              var map = createMap();
              var children = el.children;
              var count = children.length;

              for (var i = 0; i < count; i += 1) {
                var child = children[i];
                var key = getData(child).key;

                if (key) {
                  map[key] = child;
                }
              }

              return map;
            };


            /**
             * Retrieves the mapping of key to child node for a given Element, creating it
             * if necessary.
             * @param {?Node} el
             * @return {!Object<string, !Node>} A mapping of keys to child Elements
             */
            var getKeyMap = function(el) {
              var data = getData(el);

              if (!data.keyMap) {
                data.keyMap = createKeyMap(el);
              }

              return data.keyMap;
            };


            /**
             * Retrieves a child from the parent with the given key.
             * @param {?Node} parent
             * @param {?string=} key
             * @return {?Node} The child corresponding to the key.
             */
            var getChild = function(parent, key) {
              return key ? getKeyMap(parent)[key] : null;
            };


            /**
             * Registers an element as being a child. The parent will keep track of the
             * child using the key. The child can be retrieved using the same key using
             * getKeyMap. The provided key should be unique within the parent Element.
             * @param {?Node} parent The parent of child.
             * @param {string} key A key to identify the child with.
             * @param {!Node} child The child to register.
             */
            var registerChild = function(parent, key, child) {
              getKeyMap(parent)[key] = child;
            };

            /**
             * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
             *
             * Licensed under the Apache License, Version 2.0 (the "License");
             * you may not use this file except in compliance with the License.
             * You may obtain a copy of the License at
             *
             *      http://www.apache.org/licenses/LICENSE-2.0
             *
             * Unless required by applicable law or agreed to in writing, software
             * distributed under the License is distributed on an "AS-IS" BASIS,
             * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
             * See the License for the specific language governing permissions and
             * limitations under the License.
             */

            /** */
            var notifications = {
              /**
               * Called after patch has compleated with any Nodes that have been created
               * and added to the DOM.
               * @type {?function(Array<!Node>)}
               */
              nodesCreated: null,

              /**
               * Called after patch has compleated with any Nodes that have been removed
               * from the DOM.
               * Note it's an applications responsibility to handle any childNodes.
               * @type {?function(Array<!Node>)}
               */
              nodesDeleted: null
            };

            /**
             * Keeps track of the state of a patch.
             * @constructor
             */
            function Context() {
              /**
               * @type {(Array<!Node>|undefined)}
               */
              this.created = notifications.nodesCreated && [];

              /**
               * @type {(Array<!Node>|undefined)}
               */
              this.deleted = notifications.nodesDeleted && [];
            }


            /**
             * @param {!Node} node
             */
            Context.prototype.markCreated = function(node) {
              if (this.created) {
                this.created.push(node);
              }
            };


            /**
             * @param {!Node} node
             */
            Context.prototype.markDeleted = function(node) {
              if (this.deleted) {
                this.deleted.push(node);
              }
            };


            /**
             * Notifies about nodes that were created during the patch opearation.
             */
            Context.prototype.notifyChanges = function() {
              if (this.created && this.created.length > 0) {
                notifications.nodesCreated(this.created);
              }

              if (this.deleted && this.deleted.length > 0) {
                notifications.nodesDeleted(this.deleted);
              }
            };

            /**
             * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
             *
             * Licensed under the Apache License, Version 2.0 (the "License");
             * you may not use this file except in compliance with the License.
             * You may obtain a copy of the License at
             *
             *      http://www.apache.org/licenses/LICENSE-2.0
             *
             * Unless required by applicable law or agreed to in writing, software
             * distributed under the License is distributed on an "AS-IS" BASIS,
             * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
             * See the License for the specific language governing permissions and
             * limitations under the License.
             */


            /**
              * Keeps track whether or not we are in an attributes declaration (after
              * elementOpenStart, but before elementOpenEnd).
              * @type {boolean}
              */
            var inAttributes = false;


            /**
              * Keeps track whether or not we are in an element that should not have its
              * children cleared.
              * @type {boolean}
              */
            var inSkip = false;


            /**
             * Makes sure that there is a current patch context.
             * @param {*} context
             */
            var assertInPatch = function(context) {
              if (!context) {
                throw new Error('Cannot call currentElement() unless in patch');
              }
            };


            /**
            * Makes sure that keyed Element matches the tag name provided.
            * @param {!string} nodeName The nodeName of the node that is being matched.
            * @param {string=} tag The tag name of the Element.
            * @param {?string=} key The key of the Element.
            */
            var assertKeyedTagMatches = function(nodeName, tag, key) {
              if (nodeName !== tag) {
                throw new Error('Was expecting node with key "' + key + '" to be a ' +
                    tag + ', not a ' + nodeName + '.');
              }
            };


            /**
             * Makes sure that a patch closes every node that it opened.
             * @param {?Node} openElement
             * @param {!Node|!DocumentFragment} root
             */
            var assertNoUnclosedTags = function(openElement, root) {
              if (openElement === root) {
                return;
              }

              var currentElement = openElement;
              var openTags = [];
              while (currentElement && currentElement !== root) {
                openTags.push(currentElement.nodeName.toLowerCase());
                currentElement = currentElement.parentNode;
              }

              throw new Error('One or more tags were not closed:\n' +
                  openTags.join('\n'));
            };


            /**
             * Makes sure that the caller is not where attributes are expected.
             * @param {string} functionName
             */
            var assertNotInAttributes = function(functionName) {
              if (inAttributes) {
                throw new Error(functionName + '() may not be called between ' +
                    'elementOpenStart() and elementOpenEnd().');
              }
            };


            /**
             * Makes sure that the caller is not inside an element that has declared skip.
             * @param {string} functionName
             */
            var assertNotInSkip = function(functionName) {
              if (inSkip) {
                throw new Error(functionName + '() may not be called inside an element ' +
                    'that has called skip().');
              }
            };


            /**
             * Makes sure that the caller is where attributes are expected.
             * @param {string} functionName
             */
            var assertInAttributes = function(functionName) {
              if (!inAttributes) {
                throw new Error(functionName + '() must be called after ' +
                    'elementOpenStart().');
              }
            };


            /**
             * Makes sure the patch closes virtual attributes call
             */
            var assertVirtualAttributesClosed = function() {
              if (inAttributes) {
                throw new Error('elementOpenEnd() must be called after calling ' +
                    'elementOpenStart().');
              }
            };


            /**
              * Makes sure that placeholders have a key specified. Otherwise, conditional
              * placeholders and conditional elements next to placeholders will cause
              * placeholder elements to be re-used as non-placeholders and vice versa.
              * @param {string} key
              */
            var assertPlaceholderKeySpecified = function(key) {
              if (!key) {
                throw new Error('Placeholder elements must have a key specified.');
              }
            };


            /**
              * Makes sure that tags are correctly nested.
              * @param {string} nodeName
              * @param {string} tag
              */
            var assertCloseMatchesOpenTag = function(nodeName, tag) {
              if (nodeName !== tag) {
                throw new Error('Received a call to close ' + tag + ' but ' +
                    nodeName + ' was open.');
              }
            };


            /**
             * Makes sure that no children elements have been declared yet in the current
             * element.
             * @param {string} functionName
             * @param {?Node} previousNode
             */
            var assertNoChildrenDeclaredYet = function(functionName, previousNode) {
              if (previousNode !== null) {
                throw new Error(functionName + '() must come before any child ' +
                    'declarations inside the current element.');
              }
            };


            /**
             * Updates the state of being in an attribute declaration.
             * @param {boolean} value
             * @return {boolean} the previous value.
             */
            var setInAttributes = function(value) {
              var previous = inAttributes;
              inAttributes = value;
              return previous;
            };


            /**
             * Updates the state of being in a skip element.
             * @param {boolean} value
             * @return {boolean} the previous value.
             */
            var setInSkip = function(value) {
              var previous = inSkip;
              inSkip = value;
              return previous;
            };

            /** @type {?Context} */
            var context = null;

            /** @type {?Node} */
            var currentNode;

            /** @type {?Node} */
            var currentParent;

            /** @type {?Node} */
            var previousNode;

            /** @type {?Element|?DocumentFragment} */
            var root;

            /** @type {?Document} */
            var doc;


            /**
             * Patches the document starting at el with the provided function. This function
             * may be called during an existing patch operation.
             * @param {!Element|!DocumentFragment} node The Element or Document
             *     to patch.
             * @param {!function(T)} fn A function containing elementOpen/elementClose/etc.
             *     calls that describe the DOM.
             * @param {T=} data An argument passed to fn to represent DOM state.
             * @template T
             */
            var patch = function(node, fn, data) {
              var prevContext = context;
              var prevRoot = root;
              var prevDoc = doc;
              var prevCurrentNode = currentNode;
              var prevCurrentParent = currentParent;
              var prevPreviousNode = previousNode;
              var previousInAttributes = false;
              var previousInSkip = false;

              context = new Context();
              root = node;
              doc = node.ownerDocument;
              currentNode = node;
              currentParent = null;
              previousNode = null;

              if (process.env.NODE_ENV !== 'production') {
                previousInAttributes = setInAttributes(false);
                previousInSkip = setInSkip(false);
              }

              enterNode();
              fn(data);
              exitNode();

              if (process.env.NODE_ENV !== 'production') {
                assertVirtualAttributesClosed();
                assertNoUnclosedTags(previousNode, node);
                setInAttributes(previousInAttributes);
                setInSkip(previousInSkip);
              }

              context.notifyChanges();

              context = prevContext;
              root = prevRoot;
              doc = prevDoc;
              currentNode = prevCurrentNode;
              currentParent = prevCurrentParent;
              previousNode = prevPreviousNode;
            };


            /**
             * Checks whether or not the current node matches the specified nodeName and
             * key.
             *
             * @param {?string} nodeName The nodeName for this node.
             * @param {?string=} key An optional key that identifies a node.
             * @return {boolean} True if the node matches, false otherwise.
             */
            var matches = function(nodeName, key) {
              var data = getData(currentNode);

              // Key check is done using double equals as we want to treat a null key the
              // same as undefined. This should be okay as the only values allowed are
              // strings, null and undefined so the == semantics are not too weird.
              return nodeName === data.nodeName && key == data.key;
            };


            /**
             * Aligns the virtual Element definition with the actual DOM, moving the
             * corresponding DOM node to the correct location or creating it if necessary.
             * @param {string} nodeName For an Element, this should be a valid tag string.
             *     For a Text, this should be #text.
             * @param {?string=} key The key used to identify this element.
             * @param {?Array<*>=} statics For an Element, this should be an array of
             *     name-value pairs.
             */
            var alignWithDOM = function(nodeName, key, statics) {
              if (currentNode && matches(nodeName, key)) {
                return;
              }

              var node;

              // Check to see if the node has moved within the parent.
              if (key) {
                node = getChild(currentParent, key);
                if (node && process.env.NODE_ENV !== 'production') {
                  assertKeyedTagMatches(getData(node).nodeName, nodeName, key);
                }
              }

              // Create the node if it doesn't exist.
              if (!node) {
                if (nodeName === '#text') {
                  node = createText(doc);
                } else {
                  node = createElement(doc, currentParent, nodeName, key, statics);
                }

                if (key) {
                  registerChild(currentParent, key, node);
                }

                context.markCreated(node);
              }

              // If the node has a key, remove it from the DOM to prevent a large number
              // of re-orders in the case that it moved far or was completely removed.
              // Since we hold on to a reference through the keyMap, we can always add it
              // back.
              if (currentNode && getData(currentNode).key) {
                currentParent.replaceChild(node, currentNode);
                getData(currentParent).keyMapValid = false;
              } else {
                currentParent.insertBefore(node, currentNode);
              }

              currentNode = node;
            };


            /**
             * Clears out any unvisited Nodes, as the corresponding virtual element
             * functions were never called for them.
             */
            var clearUnvisitedDOM = function() {
              var node = currentParent;
              var data = getData(node);
              var keyMap = data.keyMap;
              var keyMapValid = data.keyMapValid;
              var child = node.lastChild;
              var key;

              if (child === previousNode && keyMapValid) {
                return;
              }

              if (data.attrs[symbols.placeholder] && node !== root) {
                return;
              }

              while (child !== previousNode) {
                node.removeChild(child);
                context.markDeleted(/** @type {!Node}*/(child));

                key = getData(child).key;
                if (key) {
                  delete keyMap[key];
                }
                child = node.lastChild;
              }

              // Clean the keyMap, removing any unusued keys.
              if (!keyMapValid) {
                for (key in keyMap) {
                  child = keyMap[key];
                  if (child.parentNode !== node) {
                    context.markDeleted(child);
                    delete keyMap[key];
                  }
                }

                data.keyMapValid = true;
              }
            };


            /**
             * Changes to the first child of the current node.
             */
            var enterNode = function() {
              currentParent = currentNode;
              currentNode = currentNode.firstChild;
              previousNode = null;
            };


            /**
             * Changes to the next sibling of the current node.
             */
            var nextNode = function() {
              previousNode = currentNode;
              currentNode = currentNode.nextSibling;
            };


            /**
             * Changes to the parent of the current node, removing any unvisited children.
             */
            var exitNode = function() {
              clearUnvisitedDOM();

              previousNode = currentParent;
              currentNode = currentParent.nextSibling;
              currentParent = currentParent.parentNode;
            };


            /**
             * Makes sure that the current node is an Element with a matching tagName and
             * key.
             *
             * @param {string} tag The element's tag.
             * @param {?string=} key The key used to identify this element. This can be an
             *     empty string, but performance may be better if a unique value is used
             *     when iterating over an array of items.
             * @param {?Array<*>=} statics An array of attribute name/value pairs of the
             *     static attributes for the Element. These will only be set once when the
             *     Element is created.
             * @return {!Element} The corresponding Element.
             */
            var coreElementOpen = function(tag, key, statics) {
              alignWithDOM(tag, key, statics);
              enterNode();
              return /** @type {!Element} */(currentParent);
            };


            /**
             * Closes the currently open Element, removing any unvisited children if
             * necessary.
             *
             * @return {!Element} The corresponding Element.
             */
            var coreElementClose = function() {
              if (process.env.NODE_ENV !== 'production') {
                setInSkip(false);
              }

              exitNode();
              return /** @type {!Element} */(previousNode);
            };


            /**
             * Makes sure the current node is a Text node and creates a Text node if it is
             * not.
             *
             * @return {!Text} The corresponding Text Node.
             */
            var coreText = function() {
              alignWithDOM('#text', null, null);
              nextNode();
              return /** @type {!Text} */(previousNode);
            };


            /**
             * Gets the current Element being patched.
             * @return {!Element}
             */
            var currentElement = function() {
              if (process.env.NODE_ENV !== 'production') {
                assertInPatch(context);
                assertNotInAttributes('currentElement');
              }
              return /** @type {!Element} */(currentParent);
            };


            /**
             * Skips the children in a subtree, allowing an Element to be closed without
             * clearing out the children.
             */
            var skip = function() {
              if (process.env.NODE_ENV !== 'production') {
                assertNoChildrenDeclaredYet('skip', previousNode);
                setInSkip(true);
              }
              previousNode = currentParent.lastChild;
            };

            /**
             * The offset in the virtual element declaration where the attributes are
             * specified.
             * @const
             */
            var ATTRIBUTES_OFFSET = 3;


            /**
             * Builds an array of arguments for use with elementOpenStart, attr and
             * elementOpenEnd.
             * @const {Array<*>}
             */
            var argsBuilder = [];


            /**
             * @param {string} tag The element's tag.
             * @param {?string=} key The key used to identify this element. This can be an
             *     empty string, but performance may be better if a unique value is used
             *     when iterating over an array of items.
             * @param {?Array<*>=} statics An array of attribute name/value pairs of the
             *     static attributes for the Element. These will only be set once when the
             *     Element is created.
             * @param {...*} var_args Attribute name/value pairs of the dynamic attributes
             *     for the Element.
             * @return {!Element} The corresponding Element.
             */
            var elementOpen = function(tag, key, statics, var_args) {
              if (process.env.NODE_ENV !== 'production') {
                assertNotInAttributes('elementOpen');
                assertNotInSkip('elementOpen');
              }

              var node = coreElementOpen(tag, key, statics);
              var data = getData(node);

              /*
               * Checks to see if one or more attributes have changed for a given Element.
               * When no attributes have changed, this is much faster than checking each
               * individual argument. When attributes have changed, the overhead of this is
               * minimal.
               */
              var attrsArr = data.attrsArr;
              var newAttrs = data.newAttrs;
              var attrsChanged = false;
              var i = ATTRIBUTES_OFFSET;
              var j = 0;

              for (; i < arguments.length; i += 1, j += 1) {
                if (attrsArr[j] !== arguments[i]) {
                  attrsChanged = true;
                  break;
                }
              }

              for (; i < arguments.length; i += 1, j += 1) {
                attrsArr[j] = arguments[i];
              }

              if (j < attrsArr.length) {
                attrsChanged = true;
                attrsArr.length = j;
              }

              /*
               * Actually perform the attribute update.
               */
              if (attrsChanged) {
                for (i = ATTRIBUTES_OFFSET; i < arguments.length; i += 2) {
                  newAttrs[arguments[i]] = arguments[i + 1];
                }

                for (var attr in newAttrs) {
                  updateAttribute(node, attr, newAttrs[attr]);
                  newAttrs[attr] = undefined;
                }
              }

              return node;
            };


            /**
             * Declares a virtual Element at the current location in the document. This
             * corresponds to an opening tag and a elementClose tag is required. This is
             * like elementOpen, but the attributes are defined using the attr function
             * rather than being passed as arguments. Must be folllowed by 0 or more calls
             * to attr, then a call to elementOpenEnd.
             * @param {string} tag The element's tag.
             * @param {?string=} key The key used to identify this element. This can be an
             *     empty string, but performance may be better if a unique value is used
             *     when iterating over an array of items.
             * @param {?Array<*>=} statics An array of attribute name/value pairs of the
             *     static attributes for the Element. These will only be set once when the
             *     Element is created.
             */
            var elementOpenStart = function(tag, key, statics) {
              if (process.env.NODE_ENV !== 'production') {
                assertNotInAttributes('elementOpenStart');
                setInAttributes(true);
              }

              argsBuilder[0] = tag;
              argsBuilder[1] = key;
              argsBuilder[2] = statics;
            };


            /***
             * Defines a virtual attribute at this point of the DOM. This is only valid
             * when called between elementOpenStart and elementOpenEnd.
             *
             * @param {string} name
             * @param {*} value
             */
            var attr = function(name, value) {
              if (process.env.NODE_ENV !== 'production') {
                assertInAttributes('attr');
              }

              argsBuilder.push(name, value);
            };


            /**
             * Closes an open tag started with elementOpenStart.
             * @return {!Element} The corresponding Element.
             */
            var elementOpenEnd = function() {
              if (process.env.NODE_ENV !== 'production') {
                assertInAttributes('elementOpenEnd');
                setInAttributes(false);
              }

              var node = elementOpen.apply(null, argsBuilder);
              argsBuilder.length = 0;
              return node;
            };


            /**
             * Closes an open virtual Element.
             *
             * @param {string} tag The element's tag.
             * @return {!Element} The corresponding Element.
             */
            var elementClose = function(tag) {
              if (process.env.NODE_ENV !== 'production') {
                assertNotInAttributes('elementClose');
              }

              var node = coreElementClose();

              if (process.env.NODE_ENV !== 'production') {
                assertCloseMatchesOpenTag(getData(node).nodeName, tag);
              }

              return node;
            };


            /**
             * Declares a virtual Element at the current location in the document that has
             * no children.
             * @param {string} tag The element's tag.
             * @param {?string=} key The key used to identify this element. This can be an
             *     empty string, but performance may be better if a unique value is used
             *     when iterating over an array of items.
             * @param {?Array<*>=} statics An array of attribute name/value pairs of the
             *     static attributes for the Element. These will only be set once when the
             *     Element is created.
             * @param {...*} var_args Attribute name/value pairs of the dynamic attributes
             *     for the Element.
             * @return {!Element} The corresponding Element.
             */
            var elementVoid = function(tag, key, statics, var_args) {
              var node = elementOpen.apply(null, arguments);
              elementClose.apply(null, arguments);
              return node;
            };


            /**
             * Declares a virtual Element at the current location in the document that is a
             * placeholder element. Children of this Element can be manually managed and
             * will not be cleared by the library.
             *
             * A key must be specified to make sure that this node is correctly preserved
             * across all conditionals.
             *
             * @param {string} tag The element's tag.
             * @param {string} key The key used to identify this element.
             * @param {?Array<*>=} statics An array of attribute name/value pairs of the
             *     static attributes for the Element. These will only be set once when the
             *     Element is created.
             * @param {...*} var_args Attribute name/value pairs of the dynamic attributes
             *     for the Element.
             * @return {!Element} The corresponding Element.
             */
            var elementPlaceholder = function(tag, key, statics, var_args) {
              if (process.env.NODE_ENV !== 'production') {
                assertPlaceholderKeySpecified(key);
              }

              elementOpen.apply(null, arguments);
              skip();
              return elementClose.apply(null, arguments);
            };


            /**
             * Declares a virtual Text at this point in the document.
             *
             * @param {string|number|boolean} value The value of the Text.
             * @param {...(function((string|number|boolean)):string)} var_args
             *     Functions to format the value which are called only when the value has
             *     changed.
             * @return {!Text} The corresponding text node.
             */
            var text = function(value, var_args) {
              if (process.env.NODE_ENV !== 'production') {
                assertNotInAttributes('text');
                assertNotInSkip('text');
              }

              var node = coreText();
              var data = getData(node);

              if (data.text !== value) {
                data.text = /** @type {string} */(value);

                var formatted = value;
                for (var i = 1; i < arguments.length; i += 1) {
                  formatted = arguments[i](formatted);
                }

                node.data = formatted;
              }

              return node;
            };

            var _baseValues = __commonjs(function (module) {
            var arrayMap = require$$3;

            /**
             * The base implementation of `_.values` and `_.valuesIn` which creates an
             * array of `object` property values corresponding to the property names
             * of `props`.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array} props The property names to get values for.
             * @returns {Object} Returns the array of property values.
             */
            function baseValues(object, props) {
              return arrayMap(props, function(key) {
                return object[key];
              });
            }

            module.exports = baseValues;
            });

            var require$$1$28 = (_baseValues && typeof _baseValues === 'object' && 'default' in _baseValues ? _baseValues['default'] : _baseValues);

            var values = __commonjs(function (module) {
            var baseValues = require$$1$28,
                keys = require$$0$30;

            /**
             * Creates an array of the own enumerable string keyed property values of `object`.
             *
             * **Note:** Non-object values are coerced to objects.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Object
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property values.
             * @example
             *
             * function Foo() {
             *   this.a = 1;
             *   this.b = 2;
             * }
             *
             * Foo.prototype.c = 3;
             *
             * _.values(new Foo);
             * // => [1, 2] (iteration order is not guaranteed)
             *
             * _.values('hi');
             * // => ['h', 'i']
             */
            function values(object) {
              return object ? baseValues(object, keys(object)) : [];
            }

            module.exports = values;
            });

            var require$$0$39 = (values && typeof values === 'object' && 'default' in values ? values['default'] : values);

            var _stringToArray = __commonjs(function (module) {
            /** Used to compose unicode character classes. */
            var rsAstralRange = '\\ud800-\\udfff',
                rsComboMarksRange = '\\u0300-\\u036f\\ufe20-\\ufe23',
                rsComboSymbolsRange = '\\u20d0-\\u20f0',
                rsVarRange = '\\ufe0e\\ufe0f';

            /** Used to compose unicode capture groups. */
            var rsAstral = '[' + rsAstralRange + ']',
                rsCombo = '[' + rsComboMarksRange + rsComboSymbolsRange + ']',
                rsFitz = '\\ud83c[\\udffb-\\udfff]',
                rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')',
                rsNonAstral = '[^' + rsAstralRange + ']',
                rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}',
                rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]',
                rsZWJ = '\\u200d';

            /** Used to compose unicode regexes. */
            var reOptMod = rsModifier + '?',
                rsOptVar = '[' + rsVarRange + ']?',
                rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*',
                rsSeq = rsOptVar + reOptMod + rsOptJoin,
                rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';

            /** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
            var reComplexSymbol = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');

            /**
             * Converts `string` to an array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the converted array.
             */
            function stringToArray(string) {
              return string.match(reComplexSymbol);
            }

            module.exports = stringToArray;
            });

            var require$$1$29 = (_stringToArray && typeof _stringToArray === 'object' && 'default' in _stringToArray ? _stringToArray['default'] : _stringToArray);

            var _iteratorToArray = __commonjs(function (module) {
            /**
             * Converts `iterator` to an array.
             *
             * @private
             * @param {Object} iterator The iterator to convert.
             * @returns {Array} Returns the converted array.
             */
            function iteratorToArray(iterator) {
              var data,
                  result = [];

              while (!(data = iterator.next()).done) {
                result.push(data.value);
              }
              return result;
            }

            module.exports = iteratorToArray;
            });

            var require$$4$11 = (_iteratorToArray && typeof _iteratorToArray === 'object' && 'default' in _iteratorToArray ? _iteratorToArray['default'] : _iteratorToArray);

            var _copyArray = __commonjs(function (module) {
            /**
             * Copies the values of `source` to `array`.
             *
             * @private
             * @param {Array} source The array to copy values from.
             * @param {Array} [array=[]] The array to copy values to.
             * @returns {Array} Returns `array`.
             */
            function copyArray(source, array) {
              var index = -1,
                  length = source.length;

              array || (array = Array(length));
              while (++index < length) {
                array[index] = source[index];
              }
              return array;
            }

            module.exports = copyArray;
            });

            var require$$8 = (_copyArray && typeof _copyArray === 'object' && 'default' in _copyArray ? _copyArray['default'] : _copyArray);

            var toArray = __commonjs(function (module) {
            var Symbol = require$$9,
                copyArray = require$$8,
                getTag = require$$7,
                isArrayLike = require$$0$5,
                isString = _isString,
                iteratorToArray = require$$4$11,
                mapToArray = require$$3$7,
                setToArray = require$$0$32,
                stringToArray = require$$1$29,
                values = require$$0$39;

            /** `Object#toString` result references. */
            var mapTag = '[object Map]',
                setTag = '[object Set]';

            /** Built-in value references. */
            var iteratorSymbol = typeof (iteratorSymbol = Symbol && Symbol.iterator) == 'symbol' ? iteratorSymbol : undefined;

            /**
             * Converts `value` to an array.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Lang
             * @param {*} value The value to convert.
             * @returns {Array} Returns the converted array.
             * @example
             *
             * _.toArray({ 'a': 1, 'b': 2 });
             * // => [1, 2]
             *
             * _.toArray('abc');
             * // => ['a', 'b', 'c']
             *
             * _.toArray(1);
             * // => []
             *
             * _.toArray(null);
             * // => []
             */
            function toArray(value) {
              if (!value) {
                return [];
              }
              if (isArrayLike(value)) {
                return isString(value) ? stringToArray(value) : copyArray(value);
              }
              if (iteratorSymbol && value[iteratorSymbol]) {
                return iteratorToArray(value[iteratorSymbol]());
              }
              var tag = getTag(value),
                  func = tag == mapTag ? mapToArray : (tag == setTag ? setToArray : values);

              return func(value);
            }

            module.exports = toArray;
            });

            var _toArray = (toArray && typeof toArray === 'object' && 'default' in toArray ? toArray['default'] : toArray);

            var index = __commonjs(function (module) {
            'use strict';

            /**
             * Determine if a DOM element matches a CSS selector
             *
             * @param {Element} elem
             * @param {String} selector
             * @return {Boolean}
             * @api public
             */

            function matches(elem, selector) {
              // Vendor-specific implementations of `Element.prototype.matches()`.
              var proto = window.Element.prototype;
              var nativeMatches = proto.matches ||
                  proto.mozMatchesSelector ||
                  proto.msMatchesSelector ||
                  proto.oMatchesSelector ||
                  proto.webkitMatchesSelector;

              if (!elem || elem.nodeType !== 1) {
                return false;
              }

              var parentElem = elem.parentNode;

              // use native 'matches'
              if (nativeMatches) {
                return nativeMatches.call(elem, selector);
              }

              // native support for `matches` is missing and a fallback is required
              var nodes = parentElem.querySelectorAll(selector);
              var len = nodes.length;

              for (var i = 0; i < len; i++) {
                if (nodes[i] === elem) {
                  return true;
                }
              }

              return false;
            }

            /**
             * Expose `matches`
             */

            module.exports = matches;
            });

            var matchesSelector = (index && typeof index === 'object' && 'default' in index ? index['default'] : index);

            function forEach$1(val, fn, scope) {
            	if (val && typeof val.forEach === "function") val.forEach(fn, scope);else _forEach(val, fn, scope);
            }

            function map(val, fn, scope) {
            	var res = [];
            	forEach$1(val, function (v, i, l) {
            		res.push(fn.call(scope, v, i, l));
            	});
            	return res;
            }

            // like jQuery's empty(), removes all children
            function emptyNode(node) {
            	while (node.lastChild) {
            		node.removeChild(node.lastChild);
            	}return node;
            }

            var entity = /&(?:#x[a-f0-9]+|#[0-9]+|[a-z0-9]+);?/ig;

            function containsEntities(str) {
            	return entity.test(str);
            }

            // converts html entities to unicode
            var decodeEntities = function () {
            	if (typeof document === "undefined") return;

            	// this prevents any overhead from creating the object each time
            	var element = document.createElement('div');

            	return function decodeHTMLEntities(str) {
            		str = str.replace(entity, function (m) {
            			element.innerHTML = m;
            			return element.textContent;
            		});

            		emptyNode(element);

            		return str;
            	};
            }();

            // convert html into DOM nodes
            function toString$1(value) {
            	if (typeof value !== "string") {
            		value = value != null ? value.toString() : "";
            	}

            	return value;
            }

            function joinValues() {
            	return _toArray(arguments).map(toString$1).join("");
            }

            function matches$1(node, selector) {
            	if (require$$0$21(selector)) return selector.some(function (s) {
            		return matches$1(node, s);
            	});

            	if (selector instanceof window.Node) {
            		return node === selector;
            	}

            	if (typeof selector === "function") {
            		return !!selector(node);
            	}

            	if (node.nodeType === window.Node.ELEMENT_NODE) {
            		return matchesSelector(node, selector);
            	}

            	return false;
            }

            // export function getPropertyFromClass(obj, prop) {
            // 	var val;
            // 	let proto = Object.getPrototypeOf(obj);
            //
            // 	if (typeof prop === "string" && prop) {
            // 		let p = prop;
            // 		prop = c => c[p];
            // 	}
            //
            // 	if (typeof prop !== "function") {
            // 		throw new Error("Expecting function or string for property.");
            // 	}
            //
            // 	while (proto) {
            // 		val = merge.defaults(val, prop(proto.constructor));
            // 		proto = Object.getPrototypeOf(proto);
            // 	}
            //
            // 	return val;
            // }

var utils = Object.freeze({
            	forEach: forEach$1,
            	map: map,
            	emptyNode: emptyNode,
            	containsEntities: containsEntities,
            	decodeEntities: decodeEntities,
            	toString: toString$1,
            	joinValues: joinValues,
            	matches: matches$1
            });

            var performanceNow = __commonjs(function (module, exports, global) {
            // Generated by CoffeeScript 1.7.1
            (function() {
              var getNanoSeconds, hrtime, loadTime;

              if ((typeof performance !== "undefined" && performance !== null) && performance.now) {
                module.exports = function() {
                  return performance.now();
                };
              } else if ((typeof process !== "undefined" && process !== null) && process.hrtime) {
                module.exports = function() {
                  return (getNanoSeconds() - loadTime) / 1e6;
                };
                hrtime = process.hrtime;
                getNanoSeconds = function() {
                  var hr;
                  hr = hrtime();
                  return hr[0] * 1e9 + hr[1];
                };
                loadTime = getNanoSeconds();
              } else if (Date.now) {
                module.exports = function() {
                  return Date.now() - loadTime;
                };
                loadTime = Date.now();
              } else {
                module.exports = function() {
                  return new Date().getTime() - loadTime;
                };
                loadTime = new Date().getTime();
              }

            }).call(__commonjs_global);
            });

            var require$$0$41 = (performanceNow && typeof performanceNow === 'object' && 'default' in performanceNow ? performanceNow['default'] : performanceNow);

            var index$1 = __commonjs(function (module, exports, global) {
            var now = require$$0$41
              , global = typeof window === 'undefined' ? {} : window
              , vendors = ['moz', 'webkit']
              , suffix = 'AnimationFrame'
              , raf = global['request' + suffix]
              , caf = global['cancel' + suffix] || global['cancelRequest' + suffix]

            for(var i = 0; i < vendors.length && !raf; i++) {
              raf = global[vendors[i] + 'Request' + suffix]
              caf = global[vendors[i] + 'Cancel' + suffix]
                  || global[vendors[i] + 'CancelRequest' + suffix]
            }

            // Some versions of FF have rAF but not cAF
            if(!raf || !caf) {
              var last = 0
                , id = 0
                , queue = []
                , frameDuration = 1000 / 60

              raf = function(callback) {
                if(queue.length === 0) {
                  var _now = now()
                    , next = Math.max(0, frameDuration - (_now - last))
                  last = next + _now
                  setTimeout(function() {
                    var cp = queue.slice(0)
                    // Clear queue here to prevent
                    // callbacks from appending listeners
                    // to the current frame's queue
                    queue.length = 0
                    for(var i = 0; i < cp.length; i++) {
                      if(!cp[i].cancelled) {
                        try{
                          cp[i].callback(last)
                        } catch(e) {
                          setTimeout(function() { throw e }, 0)
                        }
                      }
                    }
                  }, Math.round(next))
                }
                queue.push({
                  handle: ++id,
                  callback: callback,
                  cancelled: false
                })
                return id
              }

              caf = function(handle) {
                for(var i = 0; i < queue.length; i++) {
                  if(queue[i].handle === handle) {
                    queue[i].cancelled = true
                  }
                }
              }
            }

            module.exports = function(fn) {
              // Wrap in a new function to prevent
              // `cancel` potentially being assigned
              // to the native rAF function
              return raf.call(global, fn)
            }
            module.exports.cancel = function() {
              caf.apply(global, arguments)
            }
            });

            var require$$0$40 = (index$1 && typeof index$1 === 'object' && 'default' in index$1 ? index$1['default'] : index$1);

            var trackr = __commonjs(function (module, exports, global) {
            /////////////////////////////////////////////////////
            // Package docs at http://docs.meteor.com/#tracker //
            // Last merge: https://github.com/meteor/meteor/blob/696876b1848e4d6a920143422c2c50c4501c85a3/packages/tracker/tracker.js //
            /////////////////////////////////////////////////////

            //
            module.exports = (function() {

            // check for global and use that one instead of loading a new one
            if (typeof global.Trackr !== "undefined") {
            	return global.Trackr;
            }

            /**
             * @namespace Trackr
             * @summary The namespace for Trackr-related methods.
             */
            var Trackr = global.Trackr = {};

            // http://docs.meteor.com/#tracker_active

            /**
             * @summary True if there is a current computation, meaning that dependencies on reactive data sources will be tracked and potentially cause the current computation to be rerun.
             * @locus Client
             * @type {Boolean}
             */
            Trackr.active = false;

            // http://docs.meteor.com/#tracker_currentcomputation

            /**
             * @summary The current computation, or `null` if there isn't one.	The current computation is the [`Trackr.Computation`](#tracker_computation) object created by the innermost active call to `Trackr.autorun`, and it's the computation that gains dependencies when reactive data sources are accessed.
             * @locus Client
             * @type {Trackr.Computation}
             */
            Trackr.currentComputation = null;

            // References to all computations created within the Trackr by id.
            // Keeping these references on an underscore property gives more control to
            // tooling and packages extending Trackr without increasing the API surface.
            // These can used to monkey-patch computations, their functions, use
            // computation ids for tracking, etc.
            Trackr._computations = {};

            var setCurrentComputation = function (c) {
            	Trackr.currentComputation = c;
            	Trackr.active = !! c;
            };

            var _debugFunc = function () {
            	return (typeof console !== "undefined") && console.error ?
            			 function () { console.error.apply(console, arguments); } :
            			 function () {};
            };

            var _throwOrLog = function (from, e) {
            	if (throwFirstError) {
            		throw e;
            	} else {
            		var printArgs = ["Exception from Trackr " + from + " function:"];
            		if (e.stack && e.message && e.name) {
            			var idx = e.stack.indexOf(e.message);
            			if (idx < 0 || idx > e.name.length + 2) { // check for "Error: "
            				// message is not part of the stack
            				var message = e.name + ": " + e.message;
            				printArgs.push(message);
            			}
            		}
            		printArgs.push(e.stack);

            		for (var i = 0; i < printArgs.length; i++) {
            			_debugFunc()(printArgs[i]);
            		}
            	}
            };

            // Takes a function `f`, and wraps it in a `Meteor._noYieldsAllowed`
            // block if we are running on the server. On the client, returns the
            // original function (since `Meteor._noYieldsAllowed` is a
            // no-op). This has the benefit of not adding an unnecessary stack
            // frame on the client.
            var withNoYieldsAllowed = function (f) {
            	return f;
            };

            var nextId = 1;
            // computations whose callbacks we should call at flush time
            var pendingComputations = [];
            // `true` if a Trackr.flush is scheduled, or if we are in Trackr.flush now
            var willFlush = false;
            // `true` if we are in Trackr.flush now
            var inFlush = false;
            // `true` if we are computing a computation now, either first time
            // or recompute.	This matches Trackr.active unless we are inside
            // Trackr.nonreactive, which nullfies currentComputation even though
            // an enclosing computation may still be running.
            var inCompute = false;
            // `true` if the `_throwFirstError` option was passed in to the call
            // to Trackr.flush that we are in. When set, throw rather than log the
            // first error encountered while flushing. Before throwing the error,
            // finish flushing (from a finally block), logging any subsequent
            // errors.
            var throwFirstError = false;

            var afterFlushCallbacks = [];

            var requestAnimationFrame = require$$0$40;

            var requireFlush = function () {
            	if (! willFlush) {
            		requestAnimationFrame(Trackr._runFlush);
            		willFlush = true;
            	}
            };

            // Trackr.Computation constructor is visible but private
            // (throws an error if you try to call it)
            var constructingComputation = false;

            //
            // http://docs.meteor.com/#tracker_computation

            /**
             * @summary A Computation object represents code that is repeatedly rerun
             * in response to
             * reactive data changes. Computations don't have return values; they just
             * perform actions, such as rerendering a template on the screen. Computations
             * are created using Trackr.autorun. Use stop to prevent further rerunning of a
             * computation.
             * @instancename computation
             */
            Trackr.Computation = function (f, parent, options) {
            	if (! constructingComputation)
            		throw new Error(
            			"Trackr.Computation constructor is private; use Trackr.autorun");
            	constructingComputation = false;

            	var self = this;
            	options = options || {};

            	// http://docs.meteor.com/#computation_stopped

            	/**
            	 * @summary True if this computation has been stopped.
            	 * @locus Client
            	 * @memberOf Trackr.Computation
            	 * @instance
            	 * @name	stopped
            	 */
            	self.stopped = false;

            	// http://docs.meteor.com/#computation_invalidated

            	/**
            	 * @summary True if this computation has been invalidated (and not yet rerun), or if it has been stopped.
            	 * @locus Client
            	 * @memberOf Trackr.Computation
            	 * @instance
            	 * @name	invalidated
            	 * @type {Boolean}
            	 */
            	self.invalidated = false;

            	// http://docs.meteor.com/#computation_firstrun

            	/**
            	 * @summary True during the initial run of the computation at the time `Trackr.autorun` is called, and false on subsequent reruns and at other times.
            	 * @locus Client
            	 * @memberOf Trackr.Computation
            	 * @instance
            	 * @name	firstRun
            	 * @type {Boolean}
            	 */
            	self.firstRun = true;

            	self._id = nextId++;
            	self._onInvalidateCallbacks = [];
            	self._onStopCallbacks = [];
            	// the plan is at some point to use the parent relation
            	// to constrain the order that computations are processed
            	self._parent = parent;
            	self._func = f;
            	self._onError = options.onError;
            	self._recomputing = false;
            	self._context = options.context || null;

            	// Register the computation within the global Trackr.
            	Trackr._computations[self._id] = self;

            	var errored = true;
            	try {
            		self._compute();
            		errored = false;
            	} finally {
            		self.firstRun = false;
            		if (errored)
            			self.stop();
            	}
            };

            // http://docs.meteor.com/#computation_oninvalidate

            /**
             * @summary Registers `callback` to run when this computation is next invalidated, or runs it immediately if the computation is already invalidated.	The callback is run exactly once and not upon future invalidations unless `onInvalidate` is called again after the computation becomes valid again.
             * @locus Client
             * @param {Function} callback Function to be called on invalidation. Receives one argument, the computation that was invalidated.
             */
            Trackr.Computation.prototype.onInvalidate = function (f, ctx) {
            	var self = this;

            	if (typeof f !== 'function')
            		throw new Error("onInvalidate requires a function");

            	if (self.invalidated) {
            		Trackr.nonreactive(function () {
            			withNoYieldsAllowed(f).call(ctx || self._context, self);
            		});
            	} else {
            		self._onInvalidateCallbacks.push({ fn: f, ctx: ctx });
            	}
            };

            /**
             * @summary Registers `callback` to run when this computation is stopped, or runs it immediately if the computation is already stopped.	The callback is run after any `onInvalidate` callbacks.
             * @locus Client
             * @param {Function} callback Function to be called on stop. Receives one argument, the computation that was stopped.
             */
            Trackr.Computation.prototype.onStop = function (f, ctx) {
            	var self = this;

            	if (typeof f !== 'function')
            		throw new Error("onStop requires a function");

            	if (self.stopped) {
            		Trackr.nonreactive(function () {
            			withNoYieldsAllowed(f).call(ctx || self._context, self);
            		});
            	} else {
            		self._onStopCallbacks.push({ fn: f, ctx: ctx });
            	}
            };

            // http://docs.meteor.com/#computation_invalidate

            /**
             * @summary Invalidates this computation so that it will be rerun.
             * @locus Client
             */
            Trackr.Computation.prototype.invalidate = function () {
            	var self = this;
            	if (! self.invalidated) {
            		// if we're currently in _recompute(), don't enqueue
            		// ourselves, since we'll rerun immediately anyway.
            		if (! self._recomputing && ! self.stopped) {
            			requireFlush();
            			pendingComputations.push(this);
            		}

            		self.invalidated = true;

            		// callbacks can't add callbacks, because
            		// self.invalidated === true.
            		for(var i = 0, f; f = self._onInvalidateCallbacks[i]; i++) {
            			Trackr.nonreactive(function () {
            				withNoYieldsAllowed(f.fn).call(f.ctx || self._context, self);
            			});
            		}
            		self._onInvalidateCallbacks = [];
            	}
            };

            // http://docs.meteor.com/#computation_stop

            /**
             * @summary Prevents this computation from rerunning.
             * @locus Client
             */
            Trackr.Computation.prototype.stop = function () {
            	var self = this;

            	if (! self.stopped) {
            		self.stopped = true;
            		self.invalidate();
            		// Unregister from global Trackr.
            		delete Trackr._computations[self._id];
            		for(var i = 0, f; f = self._onStopCallbacks[i]; i++) {
            			Trackr.nonreactive(function () {
            				withNoYieldsAllowed(f.fn).call(f.ctx || self._context, self);
            			});
            		}
            		self._onStopCallbacks = [];
            	}
            };

            Trackr.Computation.prototype._compute = function () {
            	var self = this;
            	self.invalidated = false;

            	var previous = Trackr.currentComputation;
            	setCurrentComputation(self);
            	var previousInCompute = inCompute;
            	inCompute = true;
            	try {
            		withNoYieldsAllowed(self._func).call(self._context, self);
            	} finally {
            		setCurrentComputation(previous);
            		inCompute = previousInCompute;
            	}
            };

            Trackr.Computation.prototype._needsRecompute = function () {
            	var self = this;
            	return self.invalidated && ! self.stopped;
            };

            Trackr.Computation.prototype._recompute = function () {
            	var self = this;

            	self._recomputing = true;
            	try {
            		if (self._needsRecompute()) {
            			try {
            				self._compute();
            			} catch (e) {
            				if (self._onError) {
            					self._onError(e);
            				} else {
            					_throwOrLog("recompute", e);
            				}
            			}
            		}
            	} finally {
            		self._recomputing = false;
            	}
            };

            //
            // http://docs.meteor.com/#tracker_dependency

            /**
             * @summary A Dependency represents an atomic unit of reactive data that a
             * computation might depend on. Reactive data sources such as Session or
             * Minimongo internally create different Dependency objects for different
             * pieces of data, each of which may be depended on by multiple computations.
             * When the data changes, the computations are invalidated.
             * @class
             * @instanceName dependency
             */
            Trackr.Dependency = function () {
            	this._dependentsById = {};
            };

            // http://docs.meteor.com/#dependency_depend
            //
            // Adds `computation` to this set if it is not already
            // present.	Returns true if `computation` is a new member of the set.
            // If no argument, defaults to currentComputation, or does nothing
            // if there is no currentComputation.

            /**
             * @summary Declares that the current computation (or `fromComputation` if given) depends on `dependency`.	The computation will be invalidated the next time `dependency` changes.

            If there is no current computation and `depend()` is called with no arguments, it does nothing and returns false.

            Returns true if the computation is a new dependent of `dependency` rather than an existing one.
             * @locus Client
             * @param {Trackr.Computation} [fromComputation] An optional computation declared to depend on `dependency` instead of the current computation.
             * @returns {Boolean}
             */
            Trackr.Dependency.prototype.depend = function (computation) {
            	if (! computation) {
            		if (! Trackr.active)
            			return false;

            		computation = Trackr.currentComputation;
            	}
            	var self = this;
            	var id = computation._id;
            	if (! (id in self._dependentsById)) {
            		self._dependentsById[id] = computation;
            		computation.onInvalidate(function () {
            			delete self._dependentsById[id];
            		});
            		return true;
            	}
            	return false;
            };

            // http://docs.meteor.com/#dependency_changed

            /**
             * @summary Invalidate all dependent computations immediately and remove them as dependents.
             * @locus Client
             */
            Trackr.Dependency.prototype.changed = function () {
            	var self = this;
            	for (var id in self._dependentsById)
            		self._dependentsById[id].invalidate();
            };

            // http://docs.meteor.com/#dependency_hasdependents

            /**
             * @summary True if this Dependency has one or more dependent Computations, which would be invalidated if this Dependency were to change.
             * @locus Client
             * @returns {Boolean}
             */
            Trackr.Dependency.prototype.hasDependents = function () {
            	var self = this;
            	for(var id in self._dependentsById)
            		return true;
            	return false;
            };

            // http://docs.meteor.com/#tracker_flush

            /**
             * @summary Process all reactive updates immediately and ensure that all invalidated computations are rerun.
             * @locus Client
             */
            Trackr.flush = function (options) {
            	Trackr._runFlush({ finishSynchronously: true,
            											throwFirstError: options && options._throwFirstError });
            };

            // Run all pending computations and afterFlush callbacks.	If we were not called
            // directly via Trackr.flush, this may return before they're all done to allow
            // the event loop to run a little before continuing.
            Trackr._runFlush = function (options) {
            	// XXX What part of the comment below is still true? (We no longer
            	// have Spark)
            	//
            	// Nested flush could plausibly happen if, say, a flush causes
            	// DOM mutation, which causes a "blur" event, which runs an
            	// app event handler that calls Trackr.flush.	At the moment
            	// Spark blocks event handlers during DOM mutation anyway,
            	// because the LiveRange tree isn't valid.	And we don't have
            	// any useful notion of a nested flush.
            	//
            	// https://app.asana.com/0/159908330244/385138233856
            	if (inFlush)
            		throw new Error("Can't call Trackr.flush while flushing");

            	if (inCompute)
            		throw new Error("Can't flush inside Trackr.autorun");

            	options = options || {};

            	inFlush = true;
            	willFlush = true;
            	throwFirstError = !! options.throwFirstError;

            	var recomputedCount = 0;
            	var finishedTry = false;
            	try {
            		while (pendingComputations.length ||
            					 afterFlushCallbacks.length) {

            			// recompute all pending computations
            			while (pendingComputations.length) {
            				var comp = pendingComputations.shift();
            				comp._recompute();
            				if (comp._needsRecompute()) {
            					pendingComputations.unshift(comp);
            				}

            				if (! options.finishSynchronously && ++recomputedCount > 1000) {
            					finishedTry = true;
            					return;
            				}
            			}

            			if (afterFlushCallbacks.length) {
            				// call one afterFlush callback, which may
            				// invalidate more computations
            				var cb = afterFlushCallbacks.shift();
            				try {
            					cb.fn.call(cb.ctx);
            				} catch (e) {
            					_throwOrLog("afterFlush", e);
            				}
            			}
            		}
            		finishedTry = true;
            	} finally {
            		if (! finishedTry) {
            			// we're erroring due to throwFirstError being true.
            			inFlush = false; // needed before calling `Trackr.flush()` again
            			// finish flushing
            			Trackr._runFlush({
            				finishSynchronously: options.finishSynchronously,
            				throwFirstError: false
            			});
            		}
            		willFlush = false;
            		inFlush = false;
            		if (pendingComputations.length || afterFlushCallbacks.length) {
            			// We're yielding because we ran a bunch of computations and we aren't
            			// required to finish synchronously, so we'd like to give the event loop a
            			// chance. We should flush again soon.
            			if (options.finishSynchronously) {
            				throw new Error("still have more to do?");	// shouldn't happen
            			}
            			setTimeout(requireFlush, 10);
            		}
            	}
            };

            // http://docs.meteor.com/#tracker_autorun
            //
            // Run f(). Record its dependencies. Rerun it whenever the
            // dependencies change.
            //
            // Returns a new Computation, which is also passed to f.
            //
            // Links the computation to the current computation
            // so that it is stopped if the current computation is invalidated.

            /**
             * @callback Trackr.ComputationFunction
             * @param {Trackr.Computation}
             */
            /**
             * @summary Run a function now and rerun it later whenever its dependencies
             * change. Returns a Computation object that can be used to stop or observe the
             * rerunning.
             * @locus Client
             * @param {Trackr.ComputationFunction} runFunc The function to run. It receives
             * one argument: the Computation object that will be returned.
             * @param {Object} [options]
             * @param {Function} options.onError Optional. The function to run when an error
             * happens in the Computation. The only argument it recieves is the Error
             * thrown. Defaults to the error being logged to the console.
             * @returns {Trackr.Computation}
             */
            Trackr.autorun = function (f, options, ctx) {
            	if (typeof f !== 'function')
            		throw new Error('Trackr.autorun requires a function argument');

            	options = options || {};
            	if (ctx) options.context = ctx;

            	constructingComputation = true;
            	var c = new Trackr.Computation(
            		f, Trackr.currentComputation, options);

            	if (Trackr.active)
            		Trackr.onInvalidate(function () {
            			c.stop();
            		});

            	return c;
            };

            // http://docs.meteor.com/#tracker_nonreactive
            //
            // Run `f` with no current computation, returning the return value
            // of `f`.	Used to turn off reactivity for the duration of `f`,
            // so that reactive data sources accessed by `f` will not result in any
            // computations being invalidated.

            /**
             * @summary Run a function without tracking dependencies.
             * @locus Client
             * @param {Function} func A function to call immediately.
             */
            Trackr.nonReactive =
            Trackr.nonreactive = function (f, ctx) {
            	var previous = Trackr.currentComputation;
            	setCurrentComputation(null);
            	try {
            		return f.call(ctx);
            	} finally {
            		setCurrentComputation(previous);
            	}
            };

            // like nonreactive but makes a function instead
            Trackr.nonReactable =
            Trackr.nonreactable = function (f, ctx) {
            	return function() {
            		var args = arguments;
            		var self = this;
            		return Trackr.nonreactive(function() {
            			return f.apply(ctx || self, args);
            		});
            	};
            };

            // http://docs.meteor.com/#tracker_oninvalidate

            /**
             * @summary Registers a new [`onInvalidate`](#computation_oninvalidate) callback on the current computation (which must exist), to be called immediately when the current computation is invalidated or stopped.
             * @locus Client
             * @param {Function} callback A callback function that will be invoked as `func(c)`, where `c` is the computation on which the callback is registered.
             */
            Trackr.onInvalidate = function (f, ctx) {
            	if (! Trackr.active)
            		throw new Error("Trackr.onInvalidate requires a currentComputation");

            	Trackr.currentComputation.onInvalidate(f, ctx);
            };

            // http://docs.meteor.com/#tracker_afterflush

            /**
             * @summary Schedules a function to be called during the next flush, or later in the current flush if one is in progress, after all invalidated computations have been rerun.	The function will be run once and not on subsequent flushes unless `afterFlush` is called again.
             * @locus Client
             * @param {Function} callback A function to call at flush time.
             */
            Trackr.afterFlush = function (f, ctx) {
            	afterFlushCallbacks.push({ fn: f, ctx: ctx });
            	requireFlush();
            };

            // export it
            return Trackr;

            })();
            });

            var Trackr = (trackr && typeof trackr === 'object' && 'default' in trackr ? trackr['default'] : trackr);

            function autotext(fn, that) {
            	var node = coreText();

            	function renderText(c) {
            		c.node = node;
            		var data = getData(node);
            		var value = fn.call(that, node);

            		if (data.text !== value) {
            			data.text = value;
            			node.data = toString$1(value);
            		}
            	}

            	return Trackr.autorun(renderText);
            }

            function autoelement(node, fn) {
            	return Trackr.autorun(function (c) {
            		c.element = node;

            		// catch errors that idom likes to throw
            		var cur = void 0;
            		try {
            			cur = currentElement();
            		} catch (e) {
            			e;
            		}

            		// call straight or patch
            		if (cur === node) fn(node, c);else patch(node, function () {
            			return fn(node, c);
            		});
            	});
            }

            var execDeletedCallbacks = function execDeletedCallbacks(node) {
            	var data = getData(node);
            	var cbs = data.deletedCallbacks;
            	if (!cbs) return;
            	cbs.splice(0, cbs.length).forEach(function (fn) {
            		fn.call(null, node);
            	});
            };

            notifications.nodesDeleted = function (nodes) {
            	_forEach(nodes, function (node) {
            		if (node.childNodes) notifications.nodesDeleted(node.childNodes);
            		execDeletedCallbacks(node);
            	});
            };

            function onDestroy(node, fn) {
            	if (typeof fn !== "function") {
            		throw new Error("Expecting function.");
            	}

            	var data = getData(node);
            	if (!data.deletedCallbacks) data.deletedCallbacks = [];
            	data.deletedCallbacks.push(fn);
            }

            function removeDestroyListener(node, fn) {
            	var data = getData(node);
            	if (data.deletedCallbacks) {
            		data.deletedCallbacks = _without(data.deletedCallbacks, fn);
            	}
            }

            // function renderHTML(node) {
            // 	if (node.type == "text") {
            // 		return idom.text(node.content);
            // 	}
            //
            // 	if (node.type == "tag") {
            // 		var argsArray = [node.name, null, null];
            //
            // 		// convert attrs into a flat array
            // 		for (var attr in node.attrs) {
            // 			argsArray.push(attr);
            // 			argsArray.push(node.attrs[attr]);
            // 		}
            //
            // 		if (node.voidElement) {
            // 			return idom.elementVoid.apply(idom, argsArray);
            // 		} else {
            // 			idom.elementOpen.apply(idom, argsArray);
            //
            // 			for (var i = 0; i < node.children.length; i++) {
            // 				renderHTML(node.children[i]);
            // 			}
            //
            // 			return idom.elementClose(node.name);
            // 		}
            // 	}
            // }

            // export function html(src) {
            // 	var tree = parseHTML("<div>" + src + "</div>");
            // 	if (_.isArray(tree)) tree = tree[0];
            // 	return tree.children.map(renderHTML);
            // }

            function updateProperty(el, name, value) {
            	var data = getData(el);
            	var attrs = data.attrs;

            	if (attrs[name] === value) {
            		return;
            	}

            	el[name] = value;
            	attrs[name] = value;
            }

var idom = Object.freeze({
            	updateAttribute: updateAttribute,
            	getData: getData,
            	autotext: autotext,
            	autoelement: autoelement,
            	onDestroy: onDestroy,
            	removeDestroyListener: removeDestroyListener,
            	updateProperty: updateProperty,
            	patch: patch,
            	currentElement: currentElement,
            	skip: skip,
            	elementVoid: elementVoid,
            	elementOpenStart: elementOpenStart,
            	elementOpenEnd: elementOpenEnd,
            	elementOpen: elementOpen,
            	elementClose: elementClose,
            	elementPlaceholder: elementPlaceholder,
            	text: text,
            	attr: attr,
            	symbols: symbols,
            	attributes: attributes,
            	applyAttr: applyAttr,
            	applyProp: applyProp,
            	notifications: notifications
            });

            var has$1 = __commonjs(function (module) {
            var baseHas = require$$1$20,
                hasPath = require$$0$26;

            /**
             * Checks if `path` is a direct property of `object`.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Object
             * @param {Object} object The object to query.
             * @param {Array|string} path The path to check.
             * @returns {boolean} Returns `true` if `path` exists, else `false`.
             * @example
             *
             * var object = { 'a': { 'b': { 'c': 3 } } };
             * var other = _.create({ 'a': _.create({ 'b': _.create({ 'c': 3 }) }) });
             *
             * _.has(object, 'a');
             * // => true
             *
             * _.has(object, 'a.b.c');
             * // => true
             *
             * _.has(object, ['a', 'b', 'c']);
             * // => true
             *
             * _.has(other, 'a');
             * // => false
             */
            function has(object, path) {
              return hasPath(object, path, baseHas);
            }

            module.exports = has;
            });

            var _has = (has$1 && typeof has$1 === 'object' && 'default' in has$1 ? has$1['default'] : has$1);

            // Copyright Joyent, Inc. and other Node contributors.
            //
            // Permission is hereby granted, free of charge, to any person obtaining a
            // copy of this software and associated documentation files (the
            // "Software"), to deal in the Software without restriction, including
            // without limitation the rights to use, copy, modify, merge, publish,
            // distribute, sublicense, and/or sell copies of the Software, and to permit
            // persons to whom the Software is furnished to do so, subject to the
            // following conditions:
            //
            // The above copyright notice and this permission notice shall be included
            // in all copies or substantial portions of the Software.
            //
            // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
            // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
            // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
            // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
            // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
            // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
            // USE OR OTHER DEALINGS IN THE SOFTWARE.

            function EventEmitter() {
              this._events = this._events || {};
              this._maxListeners = this._maxListeners || undefined;
            }
            // Backwards-compat with node 0.10.x
            EventEmitter.EventEmitter = EventEmitter;

            EventEmitter.prototype._events = undefined;
            EventEmitter.prototype._maxListeners = undefined;

            // By default EventEmitters will print a warning if more than 10 listeners are
            // added to it. This is a useful default which helps finding memory leaks.
            EventEmitter.defaultMaxListeners = 10;

            // Obviously not all Emitters should be limited to 10. This function allows
            // that to be increased. Set to zero for unlimited.
            EventEmitter.prototype.setMaxListeners = function(n) {
              if (!isNumber(n) || n < 0 || isNaN(n))
                throw TypeError('n must be a positive number');
              this._maxListeners = n;
              return this;
            };

            EventEmitter.prototype.emit = function(type) {
              var er, handler, len, args, i, listeners;

              if (!this._events)
                this._events = {};

              // If there is no 'error' event listener then throw.
              if (type === 'error') {
                if (!this._events.error ||
                    (isObject$1(this._events.error) && !this._events.error.length)) {
                  er = arguments[1];
                  if (er instanceof Error) {
                    throw er; // Unhandled 'error' event
                  }
                  throw TypeError('Uncaught, unspecified "error" event.');
                }
              }

              handler = this._events[type];

              if (isUndefined(handler))
                return false;

              if (isFunction$1(handler)) {
                switch (arguments.length) {
                  // fast cases
                  case 1:
                    handler.call(this);
                    break;
                  case 2:
                    handler.call(this, arguments[1]);
                    break;
                  case 3:
                    handler.call(this, arguments[1], arguments[2]);
                    break;
                  // slower
                  default:
                    args = Array.prototype.slice.call(arguments, 1);
                    handler.apply(this, args);
                }
              } else if (isObject$1(handler)) {
                args = Array.prototype.slice.call(arguments, 1);
                listeners = handler.slice();
                len = listeners.length;
                for (i = 0; i < len; i++)
                  listeners[i].apply(this, args);
              }

              return true;
            };

            EventEmitter.prototype.addListener = function(type, listener) {
              var m;

              if (!isFunction$1(listener))
                throw TypeError('listener must be a function');

              if (!this._events)
                this._events = {};

              // To avoid recursion in the case that type === "newListener"! Before
              // adding it to the listeners, first emit "newListener".
              if (this._events.newListener)
                this.emit('newListener', type,
                          isFunction$1(listener.listener) ?
                          listener.listener : listener);

              if (!this._events[type])
                // Optimize the case of one listener. Don't need the extra array object.
                this._events[type] = listener;
              else if (isObject$1(this._events[type]))
                // If we've already got an array, just append.
                this._events[type].push(listener);
              else
                // Adding the second element, need to change to array.
                this._events[type] = [this._events[type], listener];

              // Check for listener leak
              if (isObject$1(this._events[type]) && !this._events[type].warned) {
                if (!isUndefined(this._maxListeners)) {
                  m = this._maxListeners;
                } else {
                  m = EventEmitter.defaultMaxListeners;
                }

                if (m && m > 0 && this._events[type].length > m) {
                  this._events[type].warned = true;
                  console.error('(node) warning: possible EventEmitter memory ' +
                                'leak detected. %d listeners added. ' +
                                'Use emitter.setMaxListeners() to increase limit.',
                                this._events[type].length);
                  if (typeof console.trace === 'function') {
                    // not supported in IE 10
                    console.trace();
                  }
                }
              }

              return this;
            };

            EventEmitter.prototype.on = EventEmitter.prototype.addListener;

            EventEmitter.prototype.once = function(type, listener) {
              if (!isFunction$1(listener))
                throw TypeError('listener must be a function');

              var fired = false;

              function g() {
                this.removeListener(type, g);

                if (!fired) {
                  fired = true;
                  listener.apply(this, arguments);
                }
              }

              g.listener = listener;
              this.on(type, g);

              return this;
            };

            // emits a 'removeListener' event iff the listener was removed
            EventEmitter.prototype.removeListener = function(type, listener) {
              var list, position, length, i;

              if (!isFunction$1(listener))
                throw TypeError('listener must be a function');

              if (!this._events || !this._events[type])
                return this;

              list = this._events[type];
              length = list.length;
              position = -1;

              if (list === listener ||
                  (isFunction$1(list.listener) && list.listener === listener)) {
                delete this._events[type];
                if (this._events.removeListener)
                  this.emit('removeListener', type, listener);

              } else if (isObject$1(list)) {
                for (i = length; i-- > 0;) {
                  if (list[i] === listener ||
                      (list[i].listener && list[i].listener === listener)) {
                    position = i;
                    break;
                  }
                }

                if (position < 0)
                  return this;

                if (list.length === 1) {
                  list.length = 0;
                  delete this._events[type];
                } else {
                  list.splice(position, 1);
                }

                if (this._events.removeListener)
                  this.emit('removeListener', type, listener);
              }

              return this;
            };

            EventEmitter.prototype.removeAllListeners = function(type) {
              var key, listeners;

              if (!this._events)
                return this;

              // not listening for removeListener, no need to emit
              if (!this._events.removeListener) {
                if (arguments.length === 0)
                  this._events = {};
                else if (this._events[type])
                  delete this._events[type];
                return this;
              }

              // emit removeListener for all listeners on all events
              if (arguments.length === 0) {
                for (key in this._events) {
                  if (key === 'removeListener') continue;
                  this.removeAllListeners(key);
                }
                this.removeAllListeners('removeListener');
                this._events = {};
                return this;
              }

              listeners = this._events[type];

              if (isFunction$1(listeners)) {
                this.removeListener(type, listeners);
              } else if (listeners) {
                // LIFO order
                while (listeners.length)
                  this.removeListener(type, listeners[listeners.length - 1]);
              }
              delete this._events[type];

              return this;
            };

            EventEmitter.prototype.listeners = function(type) {
              var ret;
              if (!this._events || !this._events[type])
                ret = [];
              else if (isFunction$1(this._events[type]))
                ret = [this._events[type]];
              else
                ret = this._events[type].slice();
              return ret;
            };

            EventEmitter.prototype.listenerCount = function(type) {
              if (this._events) {
                var evlistener = this._events[type];

                if (isFunction$1(evlistener))
                  return 1;
                else if (evlistener)
                  return evlistener.length;
              }
              return 0;
            };

            EventEmitter.listenerCount = function(emitter, type) {
              return emitter.listenerCount(type);
            };

            function isFunction$1(arg) {
              return typeof arg === 'function';
            }

            function isNumber(arg) {
              return typeof arg === 'number';
            }

            function isObject$1(arg) {
              return typeof arg === 'object' && arg !== null;
            }

            function isUndefined(arg) {
              return arg === void 0;
            }

            var index$2 = __commonjs(function (module, exports) {
            'use strict';

            function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

            var Trackr$$ = _interopDefault(Trackr);

            var babelHelpers = {};
            babelHelpers.typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
              return typeof obj;
            } : function (obj) {
              return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj;
            };

            babelHelpers.classCallCheck = function (instance, Constructor) {
              if (!(instance instanceof Constructor)) {
                throw new TypeError("Cannot call a class as a function");
              }
            };

            babelHelpers.createClass = function () {
              function defineProperties(target, props) {
                for (var i = 0; i < props.length; i++) {
                  var descriptor = props[i];
                  descriptor.enumerable = descriptor.enumerable || false;
                  descriptor.configurable = true;
                  if ("value" in descriptor) descriptor.writable = true;
                  Object.defineProperty(target, descriptor.key, descriptor);
                }
              }

              return function (Constructor, protoProps, staticProps) {
                if (protoProps) defineProperties(Constructor.prototype, protoProps);
                if (staticProps) defineProperties(Constructor, staticProps);
                return Constructor;
              };
            }();

            babelHelpers;

            function trackProperty(obj, prop, value, options) {
            	if ((typeof obj === "undefined" ? "undefined" : babelHelpers.typeof(obj)) !== "object" || obj == null) {
            		throw new Error("Expecting object to define the reactive property on.");
            	}

            	if (typeof prop !== "string") throw new Error("Expecting string for property name.");

            	var dep = new Trackr$$.Dependency();

            	Object.defineProperty(obj, prop, {
            		configurable: options != null && Boolean(options.configurable),
            		enumerable: options == null || options.enumerable !== false,
            		set: function set(val) {
            			if (val !== value) {
            				value = val;
            				dep.changed();
            			}

            			return value;
            		},
            		get: function get() {
            			dep.depend();
            			return value;
            		}
            	});

            	return obj;
            }

            function hasOwn(o, k) {
            	return Object.prototype.hasOwnProperty.call(o, k);
            }

            var Map = function () {
            	function Map(obj) {
            		babelHelpers.classCallCheck(this, Map);

            		this._keysDep = new Trackr$$.Dependency();
            		this._valuesDep = new Trackr$$.Dependency();
            		this._deps = {};
            		this._values = {};

            		if ((typeof obj === "undefined" ? "undefined" : babelHelpers.typeof(obj)) === "object" && obj != null) {
            			for (var key in obj) {
            				this.set(key, obj[key]);
            			}
            		}
            	}

            	babelHelpers.createClass(Map, [{
            		key: "set",
            		value: function set(key, value) {
            			if ((typeof key === "undefined" ? "undefined" : babelHelpers.typeof(key)) === "object") {
            				for (var k in key) {
            					if (hasOwn(key, k)) this.set(k, key[k]);
            				}
            				return this;
            			}

            			var has = hasOwn(this._values, key);

            			if (!has || this._values[key] !== value) {
            				this._values[key] = value;
            				this._getDep(key).changed();
            				if (!has) this._keysDep.changed();
            				this._valuesDep.changed();
            			}

            			return this;
            		}
            	}, {
            		key: "clear",
            		value: function clear() {
            			var keys = Object.keys(this._values);

            			if (keys.length) {
            				var _iteratorNormalCompletion = true;
            				var _didIteratorError = false;
            				var _iteratorError = undefined;

            				try {
            					for (var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            						var k = _step.value;

            						delete this._values[k];
            						this._getDep(k).changed();
            					}
            				} catch (err) {
            					_didIteratorError = true;
            					_iteratorError = err;
            				} finally {
            					try {
            						if (!_iteratorNormalCompletion && _iterator.return) {
            							_iterator.return();
            						}
            					} finally {
            						if (_didIteratorError) {
            							throw _iteratorError;
            						}
            					}
            				}

            				this._keysDep.changed();
            				this._valuesDep.changed();
            			}

            			return this;
            		}
            	}, {
            		key: "delete",
            		value: function _delete(key) {
            			if (hasOwn(this._values, key)) {
            				delete this._values[key];
            				this._getDep(key).changed();
            				this._keysDep.changed();
            				this._valuesDep.changed();
            			}

            			return this;
            		}
            	}, {
            		key: "forEach",
            		value: function forEach(fn, ctx) {
            			var _iteratorNormalCompletion2 = true;
            			var _didIteratorError2 = false;
            			var _iteratorError2 = undefined;

            			try {
            				for (var _iterator2 = this.keys()[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            					var k = _step2.value;

            					fn.call(ctx, this.get(k), k, this);
            				}
            			} catch (err) {
            				_didIteratorError2 = true;
            				_iteratorError2 = err;
            			} finally {
            				try {
            					if (!_iteratorNormalCompletion2 && _iterator2.return) {
            						_iterator2.return();
            					}
            				} finally {
            					if (_didIteratorError2) {
            						throw _iteratorError2;
            					}
            				}
            			}

            			return this;
            		}
            	}, {
            		key: "_getDep",
            		value: function _getDep(k) {
            			if (this._deps[k] == null) this._deps[k] = new Trackr$$.Dependency();
            			return this._deps[k];
            		}
            	}, {
            		key: "get",
            		value: function get(key) {
            			this._getDep(key).depend();
            			return this._values[key];
            		}
            	}, {
            		key: "has",
            		value: function has(key) {
            			this._getDep(key).depend();
            			return hasOwn(this._values, key);
            		}
            	}, {
            		key: "keys",
            		value: function keys() {
            			this._keysDep.depend();
            			return Object.keys(this._values);
            		}

            		// TODO enable when ES6 settles
            		// * entries() {
            		// 	for (let k of this.keys()) {
            		// 		yield [ k, this.get(k) ];
            		// 	}
            		// }
            		//
            		// * values() {
            		// 	for (let k of this.keys()) {
            		// 		yield this.get(k);
            		// 	}
            		// }

            	}, {
            		key: "toJSON",
            		value: function toJSON() {
            			var out = {};
            			var _iteratorNormalCompletion3 = true;
            			var _didIteratorError3 = false;
            			var _iteratorError3 = undefined;

            			try {
            				for (var _iterator3 = this.keys()[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            					var k = _step3.value;
            					out[k] = this.get(k);
            				}
            			} catch (err) {
            				_didIteratorError3 = true;
            				_iteratorError3 = err;
            			} finally {
            				try {
            					if (!_iteratorNormalCompletion3 && _iterator3.return) {
            						_iterator3.return();
            					}
            				} finally {
            					if (_didIteratorError3) {
            						throw _iteratorError3;
            					}
            				}
            			}

            			return out;
            		}
            	}, {
            		key: "__trackr",
            		get: function get() {
            			return true;
            		}
            	}, {
            		key: "__trackr_type",
            		get: function get() {
            			return "map";
            		}
            	}, {
            		key: "size",
            		get: function get() {
            			return this.keys().length;
            		}
            	}]);
            	return Map;
            }();

            // Map.prototype[Symbol.iterator] = Map.prototype.values;

            Map.isMap = function (o) {
            	return o && o.__trackr && o.__trackr_type === "map";
            };

            var slice = Array.prototype.slice.call.bind(Array.prototype.slice);
            var arrayLike = function arrayLike(o) {
            	return typeof o.length === "number" && o.length >= 0;
            };

            function summariseSpliceOperation(array, args) {
            	var index, addedItems, removedItems;

            	if (!args) return null;

            	// figure out where the changes started...
            	index = +(args[0] < 0 ? array.length + args[0] : args[0]);

            	// ...and how many items were added to or removed from the array
            	addedItems = Math.max(0, args.length - 2);
            	removedItems = args[1] !== undefined ? args[1] : array.length - index;

            	// It's possible to do e.g. [ 1, 2, 3 ].splice( 2, 2 ) - i.e. the second argument
            	// means removing more items from the end of the array than there are. In these
            	// cases we need to curb JavaScript's enthusiasm or we'll get out of sync
            	removedItems = Math.min(removedItems, array.length - index);

            	return {
            		index: index,
            		added: addedItems,
            		removed: removedItems
            	};
            }

            var List = function () {
            	function List() {
            		babelHelpers.classCallCheck(this, List);

            		this._itemDep = new Trackr$$.Dependency();
            		this._lengthDep = new Trackr$$.Dependency();
            		this._deps = {};
            		this._items = [];
            		var _iteratorNormalCompletion = true;
            		var _didIteratorError = false;
            		var _iteratorError = undefined;

            		try {
            			for (var _iterator = slice(arguments)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            				var a = _step.value;
            				pushDynamic(this, a);
            			}
            		} catch (err) {
            			_didIteratorError = true;
            			_iteratorError = err;
            		} finally {
            			try {
            				if (!_iteratorNormalCompletion && _iterator.return) {
            					_iterator.return();
            				}
            			} finally {
            				if (_didIteratorError) {
            					throw _iteratorError;
            				}
            			}
            		}
            	}

            	babelHelpers.createClass(List, [{
            		key: "get",
            		value: function get(index) {
            			this._getDep(index).depend();
            			return this._items[index];
            		}
            	}, {
            		key: "_getDep",
            		value: function _getDep(k) {
            			if (this._deps[k] == null) this._deps[k] = new Trackr$$.Dependency();
            			return this._deps[k];
            		}
            	}, {
            		key: "splice",
            		value: function splice() {
            			var args = slice(arguments);
            			var op = summariseSpliceOperation(this._items, args);
            			var r = this._items.splice.apply(this._items, args);

            			this._itemDep.changed();
            			if (op.added !== op.removed) this._lengthDep.changed();
            			for (var i = 0; i < Math.max(op.added, op.removed); i++) {
            				this._getDep(op.index + i).changed();
            			}

            			return r;
            		}
            	}, {
            		key: "push",
            		value: function push() {
            			var args = [this._items.length, 0].concat(slice(arguments));
            			this.splice.apply(this, args);
            			return this._items.length;
            		}
            	}, {
            		key: "pop",
            		value: function pop() {
            			return this.splice(this._items.length - 1, 1)[0];
            		}
            	}, {
            		key: "unshift",
            		value: function unshift() {
            			var args = [0, 0].concat(slice(arguments));
            			this.splice.apply(this, args);
            			return this._items.length;
            		}
            	}, {
            		key: "shift",
            		value: function shift() {
            			return this.splice(0, 1)[0];
            		}
            	}, {
            		key: "reverse",
            		value: function reverse() {
            			this._items.reverse();

            			this._itemDep.changed();
            			for (var i = 0; i < this._items.length; i++) {
            				this._getDep(i).changed();
            			}

            			return this;
            		}
            	}, {
            		key: "sort",
            		value: function sort(f) {
            			this._items.sort(f);

            			this._itemDep.changed();
            			for (var i = 0; i < this._items.length; i++) {
            				this._getDep(i).changed();
            			}

            			return this;
            		}
            	}, {
            		key: "set",
            		value: function set(index, value) {
            			this.splice(index, 1, value);
            			return this;
            		}
            	}, {
            		key: "concat",
            		value: function concat() {
            			var l = new List(this);
            			var _iteratorNormalCompletion2 = true;
            			var _didIteratorError2 = false;
            			var _iteratorError2 = undefined;

            			try {
            				for (var _iterator2 = slice(arguments)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            					var a = _step2.value;
            					pushDynamic(l, a);
            				}
            			} catch (err) {
            				_didIteratorError2 = true;
            				_iteratorError2 = err;
            			} finally {
            				try {
            					if (!_iteratorNormalCompletion2 && _iterator2.return) {
            						_iterator2.return();
            					}
            				} finally {
            					if (_didIteratorError2) {
            						throw _iteratorError2;
            					}
            				}
            			}

            			return l;
            		}
            	}, {
            		key: "join",
            		value: function join(char) {
            			var str = "";
            			var len = this.length;

            			for (var v, i = 0; i < len; i++) {
            				v = this.get(i);
            				if (v == null) v = "";
            				if (typeof v !== "string") v = v.toString();
            				str += v + (i !== len - 1 ? char : "");
            			}

            			return str;
            		}
            	}, {
            		key: "slice",
            		value: function slice(start, end) {
            			var i = undefined,
            			    cloned = [],
            			    upTo = undefined,
            			    size = undefined,
            			    len = this._items.length;

            			// Handle negative value for "start"
            			if (typeof start === "number" && !isNaN(start)) {
            				if (start < 0) {
            					this._lengthDep.depend();
            					start = Math.max(0, len + start);
            				}
            			} else {
            				start = 0;
            			}

            			// Handle negative value for "end"
            			if (typeof end === "number" && !isNaN(end)) {
            				upTo = Math.min(end, len);
            				if (end < 0) {
            					this._lengthDep.depend();
            					upTo = len + end;
            				}
            			} else {
            				this._lengthDep.depend();
            				upTo = len;
            			}

            			// Actual expected size of the slice
            			size = upTo - start;

            			if (size > 0) {
            				cloned = new Array(size);
            				for (i = 0; i < size; i++) {
            					cloned[i] = this.get(start + i);
            				}
            			}

            			return cloned;
            		}
            	}, {
            		key: "indexOf",
            		value: function indexOf(member, start) {
            			var len = this._items.length;

            			if (typeof start === "number" && !isNaN(start)) {
            				start = Math.min(Math.max(start, 0), len);
            			} else {
            				start = 0;
            			}

            			for (var i = start; i < len; i++) {
            				if (this.get(i) === member) return i;
            			}

            			// only depend on length change if member wasn't found
            			this._lengthDep.depend();
            			return -1;
            		}
            	}, {
            		key: "forEach",
            		value: function forEach(fn, ctx) {
            			this._itemDep.depend();

            			for (var i = 0; i < this._items.length; i++) {
            				fn.call(ctx, this._items[i], i, this);
            			}

            			return this;
            		}
            	}, {
            		key: "reduce",
            		value: function reduce(fn, value) {
            			this.forEach(function (current, index, list) {
            				value = fn.call(null, value, current, index, list);
            			});

            			return value;
            		}
            	}, {
            		key: "map",
            		value: function map(fn, ctx) {
            			return this.reduce(function (els) {
            				els.push(fn.apply(ctx, slice(arguments, 1)));
            				return els;
            			}, []);
            		}
            	}, {
            		key: "filter",
            		value: function filter(fn, ctx) {
            			return this.reduce(function (els, item) {
            				if (fn.apply(ctx, slice(arguments, 1))) els.push(item);
            				return els;
            			}, []);
            		}
            	}, {
            		key: "some",
            		value: function some(fn, ctx) {
            			var len = this._items.length;

            			for (var i = 0; i < len; i++) {
            				if (fn.call(ctx, this.get(i), i, this)) return true;
            			}

            			// only depend on length if none of the elements pass
            			this._lengthDep.depend();
            			return false;
            		}
            	}, {
            		key: "every",
            		value: function every(fn, ctx) {
            			var len = this._items.length;

            			for (var i = 0; i < len; i++) {
            				if (!fn.call(ctx, this.get(i), i, this)) return false;
            			}

            			// only depend on length if all of the elements pass
            			this._lengthDep.depend();
            			return true;
            		}

            		// TODO enable when ES6 settles
            		// * values() {
            		// 	let len = this._items.length;
            		//
            		// 	for (let i = 0; i < len; i++) {
            		// 		yield this.get(i);
            		// 	}
            		//
            		// 	// depend on length if it gets to the end
            		// 	this._lengthDep.depend();
            		// }

            	}, {
            		key: "toJSON",
            		value: function toJSON() {
            			return this.slice(0);
            		}
            	}, {
            		key: "toArray",
            		value: function toArray() {
            			return this.slice(0);
            		}
            	}, {
            		key: "__trackr",
            		get: function get() {
            			return true;
            		}
            	}, {
            		key: "__trackr_type",
            		get: function get() {
            			return "list";
            		}
            	}, {
            		key: "length",
            		get: function get() {
            			this._lengthDep.depend();
            			return this._items.length;
            		}
            	}]);
            	return List;
            }();

            // List.prototype[Symbol.iterator] = List.prototype.values;

            List.isList = function (o) {
            	return o && o.__trackr && o.__trackr_type === "list";
            };

            function pushDynamic(l, v) {
            	if (arrayLike(v)) l.push.apply(l, slice(v));else if (List.isList(v)) v.forEach(function (i) {
            		return l.push(i);
            	});else l.push(v);
            }

            var Variable = function () {
            	function Variable(value) {
            		babelHelpers.classCallCheck(this, Variable);

            		this._value = void 0;
            		this._dep = new Trackr$$.Dependency();
            		this.set(value);
            	}

            	babelHelpers.createClass(Variable, [{
            		key: "set",
            		value: function set(value) {
            			if (value !== this._value) {
            				this._value = value;
            				this._dep.changed();
            			}
            		}
            	}, {
            		key: "get",
            		value: function get() {
            			this._dep.depend();
            			return this._value;
            		}
            	}, {
            		key: "toString",
            		value: function toString() {
            			return "" + this.get();
            		}
            	}, {
            		key: "toJSON",
            		value: function toJSON() {
            			return this.get();
            		}
            	}, {
            		key: "__trackr",
            		get: function get() {
            			return true;
            		}
            	}, {
            		key: "__trackr_type",
            		get: function get() {
            			return "variable";
            		}
            	}]);
            	return Variable;
            }();

            Variable.isVariable = function (o) {
            	return o && o.__trackr && o.__trackr_type === "variable";
            };

            exports.List = List;
            exports.Map = Map;
            exports.Variable = Variable;
            exports.trackProperty = trackProperty;
            });

            var trackProperty = index$2.trackProperty;
            var Variable = index$2.Variable;
            var Map = index$2.Map;
            var List = index$2.List;

            var index$4 = __commonjs(function (module) {
            var hasOwn = Object.prototype.hasOwnProperty;

            var defaults = {
            	configurable: false,
            	enumerable: true
            };

            // defines protected, immutable properties
            function assignProps(obj, key, val, opts) {
            	var k;

            	// accept object syntax
            	if (typeof key === "object") {
            		for (k in key) {
            			if (hasOwn.call(key, k)) assignProps(obj, k, key[k], val);
            		}
            		return;
            	}

            	var desc = {};
            	opts = opts || {};

            	// build base descriptor
            	for (k in defaults) {
            		desc[k] = typeof opts[k] === "boolean" ? opts[k] : defaults[k];
            	}

            	// set descriptor props based on value
            	if (!opts.forceStatic && typeof val === "function") {
            		desc.get = val;
            	} else {
            		desc.value = val;
            		desc.writable = false;
            	}

            	// define the property
            	Object.defineProperty(obj, key, desc);
            }

            module.exports = assignProps;
            });

            var assignProps = (index$4 && typeof index$4 === 'object' && 'default' in index$4 ? index$4['default'] : index$4);

            var _isIterateeCall = __commonjs(function (module) {
            var eq = require$$0$14,
                isArrayLike = require$$0$5,
                isIndex = require$$1$15,
                isObject = _isObject;

            /**
             * Checks if the given arguments are from an iteratee call.
             *
             * @private
             * @param {*} value The potential iteratee value argument.
             * @param {*} index The potential iteratee index or key argument.
             * @param {*} object The potential iteratee object argument.
             * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
             *  else `false`.
             */
            function isIterateeCall(value, index, object) {
              if (!isObject(object)) {
                return false;
              }
              var type = typeof index;
              if (type == 'number'
                    ? (isArrayLike(object) && isIndex(index, object.length))
                    : (type == 'string' && index in object)
                  ) {
                return eq(object[index], value);
              }
              return false;
            }

            module.exports = isIterateeCall;
            });

            var require$$1$30 = (_isIterateeCall && typeof _isIterateeCall === 'object' && 'default' in _isIterateeCall ? _isIterateeCall['default'] : _isIterateeCall);

            var _createAssigner = __commonjs(function (module) {
            var isIterateeCall = require$$1$30,
                rest = require$$0;

            /**
             * Creates a function like `_.assign`.
             *
             * @private
             * @param {Function} assigner The function to assign values.
             * @returns {Function} Returns the new assigner function.
             */
            function createAssigner(assigner) {
              return rest(function(object, sources) {
                var index = -1,
                    length = sources.length,
                    customizer = length > 1 ? sources[length - 1] : undefined,
                    guard = length > 2 ? sources[2] : undefined;

                customizer = typeof customizer == 'function'
                  ? (length--, customizer)
                  : undefined;

                if (guard && isIterateeCall(sources[0], sources[1], guard)) {
                  customizer = length < 3 ? undefined : customizer;
                  length = 1;
                }
                object = Object(object);
                while (++index < length) {
                  var source = sources[index];
                  if (source) {
                    assigner(object, source, index, customizer);
                  }
                }
                return object;
              });
            }

            module.exports = createAssigner;
            });

            var require$$3$11 = (_createAssigner && typeof _createAssigner === 'object' && 'default' in _createAssigner ? _createAssigner['default'] : _createAssigner);

            var _assignValue = __commonjs(function (module) {
            var eq = require$$0$14;

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty = objectProto.hasOwnProperty;

            /**
             * Assigns `value` to `key` of `object` if the existing value is not equivalent
             * using [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
             * for equality comparisons.
             *
             * @private
             * @param {Object} object The object to modify.
             * @param {string} key The key of the property to assign.
             * @param {*} value The value to assign.
             */
            function assignValue(object, key, value) {
              var objValue = object[key];
              if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
                  (value === undefined && !(key in object))) {
                object[key] = value;
              }
            }

            module.exports = assignValue;
            });

            var require$$0$43 = (_assignValue && typeof _assignValue === 'object' && 'default' in _assignValue ? _assignValue['default'] : _assignValue);

            var _copyObjectWith = __commonjs(function (module) {
            var assignValue = require$$0$43;

            /**
             * This function is like `copyObject` except that it accepts a function to
             * customize copied values.
             *
             * @private
             * @param {Object} source The object to copy properties from.
             * @param {Array} props The property identifiers to copy.
             * @param {Object} [object={}] The object to copy properties to.
             * @param {Function} [customizer] The function to customize copied values.
             * @returns {Object} Returns `object`.
             */
            function copyObjectWith(source, props, object, customizer) {
              object || (object = {});

              var index = -1,
                  length = props.length;

              while (++index < length) {
                var key = props[index];

                var newValue = customizer
                  ? customizer(object[key], source[key], key, object, source)
                  : source[key];

                assignValue(object, key, newValue);
              }
              return object;
            }

            module.exports = copyObjectWith;
            });

            var require$$0$42 = (_copyObjectWith && typeof _copyObjectWith === 'object' && 'default' in _copyObjectWith ? _copyObjectWith['default'] : _copyObjectWith);

            var _copyObject = __commonjs(function (module) {
            var copyObjectWith = require$$0$42;

            /**
             * Copies properties of `source` to `object`.
             *
             * @private
             * @param {Object} source The object to copy properties from.
             * @param {Array} props The property identifiers to copy.
             * @param {Object} [object={}] The object to copy properties to.
             * @returns {Object} Returns `object`.
             */
            function copyObject(source, props, object) {
              return copyObjectWith(source, props, object);
            }

            module.exports = copyObject;
            });

            var require$$4$12 = (_copyObject && typeof _copyObject === 'object' && 'default' in _copyObject ? _copyObject['default'] : _copyObject);

            var assign = __commonjs(function (module) {
            var assignValue = require$$0$43,
                copyObject = require$$4$12,
                createAssigner = require$$3$11,
                isArrayLike = require$$0$5,
                isPrototype = require$$1$19,
                keys = require$$0$30;

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty = objectProto.hasOwnProperty;

            /** Built-in value references. */
            var propertyIsEnumerable = objectProto.propertyIsEnumerable;

            /** Detect if properties shadowing those on `Object.prototype` are non-enumerable. */
            var nonEnumShadows = !propertyIsEnumerable.call({ 'valueOf': 1 }, 'valueOf');

            /**
             * Assigns own enumerable string keyed properties of source objects to the
             * destination object. Source objects are applied from left to right.
             * Subsequent sources overwrite property assignments of previous sources.
             *
             * **Note:** This method mutates `object` and is loosely based on
             * [`Object.assign`](https://mdn.io/Object/assign).
             *
             * @static
             * @memberOf _
             * @since 0.10.0
             * @category Object
             * @param {Object} object The destination object.
             * @param {...Object} [sources] The source objects.
             * @returns {Object} Returns `object`.
             * @example
             *
             * function Foo() {
             *   this.c = 3;
             * }
             *
             * function Bar() {
             *   this.e = 5;
             * }
             *
             * Foo.prototype.d = 4;
             * Bar.prototype.f = 6;
             *
             * _.assign({ 'a': 1 }, new Foo, new Bar);
             * // => { 'a': 1, 'c': 3, 'e': 5 }
             */
            var assign = createAssigner(function(object, source) {
              if (nonEnumShadows || isPrototype(source) || isArrayLike(source)) {
                copyObject(source, keys(source), object);
                return;
              }
              for (var key in source) {
                if (hasOwnProperty.call(source, key)) {
                  assignValue(object, key, source[key]);
                }
              }
            });

            module.exports = assign;
            });

            var _assign = (assign && typeof assign === 'object' && 'default' in assign ? assign['default'] : assign);

            var includes = __commonjs(function (module) {
            var baseIndexOf = require$$4$2,
                isArrayLike = require$$0$5,
                isString = _isString,
                toInteger = require$$1,
                values = require$$0$39;

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeMax = Math.max;

            /**
             * Checks if `value` is in `collection`. If `collection` is a string it's
             * checked for a substring of `value`, otherwise
             * [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
             * is used for equality comparisons. If `fromIndex` is negative, it's used as
             * the offset from the end of `collection`.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Collection
             * @param {Array|Object|string} collection The collection to search.
             * @param {*} value The value to search for.
             * @param {number} [fromIndex=0] The index to search from.
             * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.
             * @returns {boolean} Returns `true` if `value` is found, else `false`.
             * @example
             *
             * _.includes([1, 2, 3], 1);
             * // => true
             *
             * _.includes([1, 2, 3], 1, 2);
             * // => false
             *
             * _.includes({ 'user': 'fred', 'age': 40 }, 'fred');
             * // => true
             *
             * _.includes('pebbles', 'eb');
             * // => true
             */
            function includes(collection, value, fromIndex, guard) {
              collection = isArrayLike(collection) ? collection : values(collection);
              fromIndex = (fromIndex && !guard) ? toInteger(fromIndex) : 0;

              var length = collection.length;
              if (fromIndex < 0) {
                fromIndex = nativeMax(length + fromIndex, 0);
              }
              return isString(collection)
                ? (fromIndex <= length && collection.indexOf(value, fromIndex) > -1)
                : (!!length && baseIndexOf(collection, value, fromIndex) > -1);
            }

            module.exports = includes;
            });

            var _includes = (includes && typeof includes === 'object' && 'default' in includes ? includes['default'] : includes);

            var global$1 = typeof global !== "undefined" ? global :
                        typeof self !== "undefined" ? self :
                        typeof window !== "undefined" ? window : {}

            var index$5 = __commonjs(function (module, exports, global) {
            var now = require$$0$41
              , root = typeof window === 'undefined' ? global : window
              , vendors = ['moz', 'webkit']
              , suffix = 'AnimationFrame'
              , raf = root['request' + suffix]
              , caf = root['cancel' + suffix] || root['cancelRequest' + suffix]

            for(var i = 0; !raf && i < vendors.length; i++) {
              raf = root[vendors[i] + 'Request' + suffix]
              caf = root[vendors[i] + 'Cancel' + suffix]
                  || root[vendors[i] + 'CancelRequest' + suffix]
            }

            // Some versions of FF have rAF but not cAF
            if(!raf || !caf) {
              var last = 0
                , id = 0
                , queue = []
                , frameDuration = 1000 / 60

              raf = function(callback) {
                if(queue.length === 0) {
                  var _now = now()
                    , next = Math.max(0, frameDuration - (_now - last))
                  last = next + _now
                  setTimeout(function() {
                    var cp = queue.slice(0)
                    // Clear queue here to prevent
                    // callbacks from appending listeners
                    // to the current frame's queue
                    queue.length = 0
                    for(var i = 0; i < cp.length; i++) {
                      if(!cp[i].cancelled) {
                        try{
                          cp[i].callback(last)
                        } catch(e) {
                          setTimeout(function() { throw e }, 0)
                        }
                      }
                    }
                  }, Math.round(next))
                }
                queue.push({
                  handle: ++id,
                  callback: callback,
                  cancelled: false
                })
                return id
              }

              caf = function(handle) {
                for(var i = 0; i < queue.length; i++) {
                  if(queue[i].handle === handle) {
                    queue[i].cancelled = true
                  }
                }
              }
            }

            module.exports = function(fn) {
              // Wrap in a new function to prevent
              // `cancel` potentially being assigned
              // to the native rAF function
              return raf.call(root, fn)
            }
            module.exports.cancel = function() {
              caf.apply(root, arguments)
            }
            module.exports.polyfill = function() {
              root.requestAnimationFrame = raf
              root.cancelAnimationFrame = caf
            }
            });

            var raf = (index$5 && typeof index$5 === 'object' && 'default' in index$5 ? index$5['default'] : index$5);

            var decorators = {};

            function plugin() {
            	this._decorators = {};
            	this.decorate = add;
            	this.stopDecorating = remove;
            	this.findDecorator = find;
            }

            // creates a decorator
            function add(name, fn, options) {
            	var _this = this;

            	if ((typeof name === "undefined" ? "undefined" : babelHelpers.typeof(name)) === "object") {
            		options = fn;
            		_forEach(name, function (fn, n) {
            			if (require$$0$21(fn)) add.call(_this, n, fn[0], fn[1]);else add.call(_this, n, fn, options);
            		});
            		return this;
            	}

            	if (typeof name !== "string" || name === "") throw new Error("Expecting non-empty string for decorator name.");
            	if (typeof fn !== "function") throw new Error("Expecting function for decorator.");

            	var decs = this._decorators ? this._decorators : decorators;
            	decs[name] = {
            		template: this,
            		callback: fn,
            		options: options || {}
            	};

            	return this;
            }

            // removes a decorator
            function remove(name) {
            	if (this._decorators) {
            		if (name == null) this._decorators = {};else delete this._decorators[name];
            	} else if (name) {
            		delete decorators[name];
            	}

            	return this;
            }

            function find(name) {
            	var decs = this._decorators;
            	if (decs != null && decs[name]) {
            		return decs[name];
            	}
            }

            // finds the best decorator
            function lookup$1(scope, name) {
            	// look on the closest template
            	var owner = scope.getTemplateScope();
            	if (owner) {
            		var dec = owner.template.findDecorator(name);
            		if (dec) return _assign({ owner: owner }, dec);
            	}

            	// look globally
            	if (decorators[name]) {
            		return _assign({ owner: global$1 }, decorators[name]);
            	}
            }

            function setAttribute(node, name, values) {
            	var v = !values || !values.length || values[0] == null ? "" : values[0];
            	updateAttribute(node, name, v);
            }

            function render$1(_scope, name, value) {
            	var node = currentElement();
            	if (!node) throw new Error("Not currently patching.");

            	// each decorator is given its own scope
            	var scope = new Scope(null, _scope);

            	var isStaticValue = typeof value !== "function";
            	var getValue = function getValue() {
            		var val = isStaticValue ? value : value(scope);
            		if (!require$$0$21(val)) val = [val];
            		return val;
            	};

            	// look up decorator by name
            	var d = lookup$1(scope, name);

            	// quick escape if static value and no decorator
            	if (isStaticValue && !d) {
            		setAttribute(node, name, getValue());
            		return;
            	}

            	var anim = void 0,
            	    comp = void 0;
            	var cancel = false;
            	var decscope = _assign({
            		target: node,
            		scope: scope
            	}, d);

            	var run = function run(c) {
            		decscope.comp = c;
            		var val = getValue();

            		if (!d) {
            			setAttribute(node, name, val);
            			return;
            		}

            		// execute the callback
            		d.callback.apply(d.template, [decscope].concat(val));
            	};

            	// defer computation if desired
            	if (d && d.options && d.options.defer) {
            		// clean up when current computation reruns
            		var pcomp = Trackr.currentComputation;
            		if (!pcomp) throw new Error("Can only render decorator in a computation.");
            		pcomp.onInvalidate(function () {
            			cancel = true;
            			if (anim) raf.cancel(anim);
            			if (comp) comp.stop();
            		});

            		// run decorator on the next frame
            		anim = raf(function () {
            			if (cancel) return;
            			anim = null;
            			comp = Trackr.autorun(run);
            		});
            	} else {
            		Trackr.autorun(run);
            	}
            }

var decorators$1 = Object.freeze({
            	plugin: plugin,
            	default: plugin,
            	add: add,
            	remove: remove,
            	find: find,
            	lookup: lookup$1,
            	render: render$1
            });

            var decorators$2 = {};
            var actions = {};

            // Action Class
            var Action = function () {
            	function Action(name, scope) {
            		babelHelpers.classCallCheck(this, Action);

            		this.name = name;
            		this.scope = scope;
            		this.bubbles = true;
            	}

            	babelHelpers.createClass(Action, [{
            		key: "stopPropagation",
            		value: function stopPropagation() {
            			this.bubbles = false;
            			return this;
            		}
            	}], [{
            		key: "create",
            		value: function create(name, scope) {
            			var action = void 0;

            			if (typeof name === "string") {
            				action = new Action(name, scope);
            			} else if (_isObject(name) && !(name instanceof Action)) {
            				action = _assign(new Action(), action);
            			} else {
            				action = name;
            			}

            			if (!(action instanceof Action)) {
            				throw new Error("Expecting action name, object or instance of Action.");
            			}

            			return action;
            		}
            	}]);
            	return Action;
            }();

            // the plugin
            function plugin$1() {
            	this.use("decorators");
            	this._actions = {};
            	this.actions = this.addAction = add$1;
            	this.removeAction = remove$1;
            	this.decorate(decorators$2);
            }

            // standard dom events
            defineEvent(['load', 'scroll', 'click', 'dblclick', 'mousedown', 'mouseup', 'mouseenter', 'mouseleave', 'keydown', 'keypress', 'keyup', 'blur', 'focus', 'change', 'input', 'submit', 'reset', 'drag', 'dragdrop', 'dragend', 'dragenter', 'dragexit', 'dragleave', 'dragover', 'dragstart', 'drop']);

            function defineEvent(event) {
            	if (require$$0$21(event)) return event.forEach(defineEvent);

            	decorators$2["on-" + event] = function (decor, key) {
            		var node = void 0,
            		    args = void 0;
            		var listener = function listener(e) {
            			// create a new action object
            			var action = new Action(key, decor.scope);
            			action.original = e;
            			action.target = action.node = node;
            			action.owner = decor.owner;
            			action.template = decor.template;

            			// fire the action
            			return fire(action, null, args);
            		};

            		node = decor.target;
            		args = Array.prototype.slice.call(arguments, 2);

            		node.addEventListener(event, listener);
            		decor.comp.onInvalidate(function () {
            			node.removeEventListener(event, listener);
            		});
            	};
            }

            // Msutache Instance Methods
            function add$1(name, fn) {
            	var _this = this;

            	if ((typeof name === "undefined" ? "undefined" : babelHelpers.typeof(name)) === "object" && fn == null) {
            		_forEach(name, function (fn, n) {
            			return add$1.call(_this, n, fn);
            		});
            		return this;
            	}

            	if (typeof name !== "string" || name === "") throw new Error("Expecting non-empty string for action name.");
            	if (typeof fn !== "function") throw new Error("Expecting function for action.");

            	var obj = this._actions;
            	if (!obj) obj = actions;
            	if (obj[name] == null) obj[name] = [];
            	if (! ~obj[name].indexOf(fn)) obj[name].push(fn);

            	return this;
            }

            function remove$1(name, fn) {
            	if (typeof name === "function" && fn == null) {
            		fn = name;
            		name = null;
            	}

            	var obj = this._actions;
            	if (!obj) obj = actions;

            	if (name == null && fn == null) {
            		// clear actions, but never on the global
            		if (this._actions != null) this._actions = {};
            	} else if (fn == null) {
            		delete obj[name];
            	} else if (name == null) {
            		_forEach(obj, function (d, n) {
            			obj[n] = d.filter(function (f) {
            				return f !== fn;
            			});
            		});
            	} else if (obj[name] != null) {
            		obj[name] = _without(obj[name], fn);
            	}

            	return this;
            }

            function fire(a, b, args) {
            	var action = Action.create(a, b);
            	if (!action.scope) {
            		throw new Error("Action is missing a scope.");
            	}

            	var scope = action.scope;
            	var name = action.name;
            	args = [].concat(action, args);

            	// runs function, unless propagation is stopped
            	function run(fn) {
            		if (fn.apply(scope, args) === false) {
            			action.bubbles = false;
            		}

            		return !action.bubbles;
            	}

            	// bubble the action up through all the scopes
            	while (action.bubbles && scope) {
            		if (scope.template) {
            			var acts = scope.template._actions;
            			if (acts != null && Array.isArray(acts[name])) {
            				acts[name].some(run);
            			}
            		}

            		scope = scope.parent;
            	}

            	// bubble action to the global actions
            	if (action.bubbles && Array.isArray(actions[name])) {
            		actions[name].some(run);
            	}

            	return Boolean(action.bubbles);
            }

var actions$1 = Object.freeze({
            	Action: Action,
            	plugin: plugin$1,
            	default: plugin$1,
            	defineEvent: defineEvent,
            	add: add$1,
            	remove: remove$1,
            	fire: fire
            });

            var _baseDelay = __commonjs(function (module) {
            /** Used as the `TypeError` message for "Functions" methods. */
            var FUNC_ERROR_TEXT = 'Expected a function';

            /**
             * The base implementation of `_.delay` and `_.defer` which accepts an array
             * of `func` arguments.
             *
             * @private
             * @param {Function} func The function to delay.
             * @param {number} wait The number of milliseconds to delay invocation.
             * @param {Object} args The arguments to provide to `func`.
             * @returns {number} Returns the timer id.
             */
            function baseDelay(func, wait, args) {
              if (typeof func != 'function') {
                throw new TypeError(FUNC_ERROR_TEXT);
              }
              return setTimeout(function() { func.apply(undefined, args); }, wait);
            }

            module.exports = baseDelay;
            });

            var require$$1$31 = (_baseDelay && typeof _baseDelay === 'object' && 'default' in _baseDelay ? _baseDelay['default'] : _baseDelay);

            var defer = __commonjs(function (module) {
            var baseDelay = require$$1$31,
                rest = require$$0;

            /**
             * Defers invoking the `func` until the current call stack has cleared. Any
             * additional arguments are provided to `func` when it's invoked.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Function
             * @param {Function} func The function to defer.
             * @param {...*} [args] The arguments to invoke `func` with.
             * @returns {number} Returns the timer id.
             * @example
             *
             * _.defer(function(text) {
             *   console.log(text);
             * }, 'deferred');
             * // => Logs 'deferred' after one or more milliseconds.
             */
            var defer = rest(function(func, args) {
              return baseDelay(func, 1, args);
            });

            module.exports = defer;
            });

            var _defer = (defer && typeof defer === 'object' && 'default' in defer ? defer['default'] : defer);

            var _arrayReduce = __commonjs(function (module) {
            /**
             * A specialized version of `_.reduce` for arrays without support for
             * iteratee shorthands.
             *
             * @private
             * @param {Array} array The array to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @param {*} [accumulator] The initial value.
             * @param {boolean} [initAccum] Specify using the first element of `array` as
             *  the initial value.
             * @returns {*} Returns the accumulated value.
             */
            function arrayReduce(array, iteratee, accumulator, initAccum) {
              var index = -1,
                  length = array.length;

              if (initAccum && length) {
                accumulator = array[++index];
              }
              while (++index < length) {
                accumulator = iteratee(accumulator, array[index], index, array);
              }
              return accumulator;
            }

            module.exports = arrayReduce;
            });

            var require$$0$44 = (_arrayReduce && typeof _arrayReduce === 'object' && 'default' in _arrayReduce ? _arrayReduce['default'] : _arrayReduce);

            var _basePick = __commonjs(function (module) {
            var arrayReduce = require$$0$44;

            /**
             * The base implementation of `_.pick` without support for individual
             * property identifiers.
             *
             * @private
             * @param {Object} object The source object.
             * @param {string[]} props The property identifiers to pick.
             * @returns {Object} Returns the new object.
             */
            function basePick(object, props) {
              object = Object(object);
              return arrayReduce(props, function(result, key) {
                if (key in object) {
                  result[key] = object[key];
                }
                return result;
              }, {});
            }

            module.exports = basePick;
            });

            var require$$1$32 = (_basePick && typeof _basePick === 'object' && 'default' in _basePick ? _basePick['default'] : _basePick);

            var _arrayPush = __commonjs(function (module) {
            /**
             * Appends the elements of `values` to `array`.
             *
             * @private
             * @param {Array} array The array to modify.
             * @param {Array} values The values to append.
             * @returns {Array} Returns `array`.
             */
            function arrayPush(array, values) {
              var index = -1,
                  length = values.length,
                  offset = array.length;

              while (++index < length) {
                array[offset + index] = values[index];
              }
              return array;
            }

            module.exports = arrayPush;
            });

            var require$$3$12 = (_arrayPush && typeof _arrayPush === 'object' && 'default' in _arrayPush ? _arrayPush['default'] : _arrayPush);

            var _baseFlatten = __commonjs(function (module) {
            var arrayPush = require$$3$12,
                isArguments = require$$2$7,
                isArray = require$$0$21,
                isArrayLikeObject = require$$0$4;

            /**
             * The base implementation of `_.flatten` with support for restricting flattening.
             *
             * @private
             * @param {Array} array The array to flatten.
             * @param {number} depth The maximum recursion depth.
             * @param {boolean} [isStrict] Restrict flattening to arrays-like objects.
             * @param {Array} [result=[]] The initial result value.
             * @returns {Array} Returns the new flattened array.
             */
            function baseFlatten(array, depth, isStrict, result) {
              result || (result = []);

              var index = -1,
                  length = array.length;

              while (++index < length) {
                var value = array[index];
                if (depth > 0 && isArrayLikeObject(value) &&
                    (isStrict || isArray(value) || isArguments(value))) {
                  if (depth > 1) {
                    // Recursively flatten arrays (susceptible to call stack limits).
                    baseFlatten(value, depth - 1, isStrict, result);
                  } else {
                    arrayPush(result, value);
                  }
                } else if (!isStrict) {
                  result[result.length] = value;
                }
              }
              return result;
            }

            module.exports = baseFlatten;
            });

            var require$$2$12 = (_baseFlatten && typeof _baseFlatten === 'object' && 'default' in _baseFlatten ? _baseFlatten['default'] : _baseFlatten);

            var pick = __commonjs(function (module) {
            var baseFlatten = require$$2$12,
                basePick = require$$1$32,
                rest = require$$0;

            /**
             * Creates an object composed of the picked `object` properties.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Object
             * @param {Object} object The source object.
             * @param {...(string|string[])} [props] The property identifiers to pick,
             *  specified individually or in arrays.
             * @returns {Object} Returns the new object.
             * @example
             *
             * var object = { 'a': 1, 'b': '2', 'c': 3 };
             *
             * _.pick(object, ['a', 'c']);
             * // => { 'a': 1, 'c': 3 }
             */
            var pick = rest(function(object, props) {
              return object == null ? {} : basePick(object, baseFlatten(props, 1));
            });

            module.exports = pick;
            });

            var _pick = (pick && typeof pick === 'object' && 'default' in pick ? pick['default'] : pick);

            var isDate = __commonjs(function (module) {
            var isObjectLike = require$$0$3;

            /** `Object#toString` result references. */
            var dateTag = '[object Date]';

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /**
             * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
             * of values.
             */
            var objectToString = objectProto.toString;

            /**
             * Checks if `value` is classified as a `Date` object.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is correctly classified,
             *  else `false`.
             * @example
             *
             * _.isDate(new Date);
             * // => true
             *
             * _.isDate('Mon April 23 2012');
             * // => false
             */
            function isDate(value) {
              return isObjectLike(value) && objectToString.call(value) == dateTag;
            }

            module.exports = isDate;
            });

            var _isDate = (isDate && typeof isDate === 'object' && 'default' in isDate ? isDate['default'] : isDate);

            var value_types = ["radio", "option"];
            var selection_types = ["text", "search", "tel", "url", "password"];

            var formBindings = {};

            function plugin$2(options) {
            	this.use("decorators");

            	options = options || {};

            	// add methods
            	this._formBindings = {};
            	this.twoway = this.addFormBinding = add$2;
            	this.getFormBinding = get$2;
            	this.removeFormBinding = remove$2;

            	// add main binding decorator
            	this.decorate("bind-to", bindTo.bind(this, options, false));
            	this.decorate("lazybind-to", bindTo.bind(this, options, true));

            	// add value decorator for radios and options
            	this.decorate("value", valueOf, { parse: "string" });
            }

            function add$2(id, getter, onChange) {
            	var _this = this;

            	if (_isObject(id)) {
            		_forEach(id, function (v, k) {
            			return add$2.call(_this, k, v);
            		});
            		return this;
            	}

            	if (typeof id !== "string") throw new Error("Expecting a string for the form binding ID.");

            	var bindings = this._formBindings || formBindings;
            	if (bindings[id] != null) throw new Error("A form binding with id '" + id + "' already exists.");

            	if (_isObject(getter) && onChange == null) {
            		onChange = getter.change;
            		getter = getter.get;
            	}

            	if (typeof getter !== "function") throw new Error("Expecting a function or object for the form binding getter.");
            	if (typeof onChange !== "function") onChange = null;

            	bindings[id] = {
            		get: getter,
            		change: onChange
            	};

            	return this;
            }

            function get$2(id) {
            	if (typeof id !== "string") return;

            	if (this._formBindings && this._formBindings[id]) {
            		return this._formBindings[id];
            	}

            	return formBindings[id];
            }

            function remove$2(id) {
            	if (this._formBindings) {
            		if (id == null) this._formBindings = {};else delete this._formBindings[id];
            	} else if (id) {
            		delete formBindings[id];
            	}

            	return this;
            }

            var type_map = {
            	"text": ["text", "color", "email", "password", "search", "tel", "url", "hidden"],
            	"number": ["number", "range"],
            	"date": ["date", "datetime", "datetime-local", "month", "time", "week"],
            	"file": ["file"],
            	"checkbox": ["checkbox"],
            	"radio": ["radio"]
            };

            function getType(el) {
            	switch (el.tagName.toLowerCase()) {
            		case "input":
            			for (var type in type_map) {
            				if (_includes(type_map[type], el.type)) return type;
            			}
            			break;

            		case "select":
            			return "select";

            		case "option":
            			return "option";

            		case "textarea":
            			return "text";
            	}
            }

            function getNodeValue(node, type) {
            	if (type == null) type = getType(node);
            	var val;

            	switch (type) {
            		case "number":
            			val = node.valueAsNumber;
            			break;
            		case "text":
            			val = node.value;
            			break;

            		case "checkbox":
            			val = node.checked;
            			break;

            		case "date":
            			val = node.valueAsDate;
            			break;

            		case "select":
            			var opt = node.querySelector("option:checked");
            			if (opt != null) val = opt.$bound_value;
            			break;

            		case "file":
            			val = !node.multiple ? node.files[0] : _toArray(node.files);
            			break;

            		case "radio":
            			val = node.$bound_value;
            			break;
            	}

            	return val;
            }

            function setLiveValue(live, el, fn) {
            	var active = document.activeElement === el;
            	if (!live && active) return;
            	var sel = selection_types.indexOf(el.type) > -1;
            	var pos = sel ? [el.selectionStart, el.selectionEnd] : null;
            	fn();
            	if (sel && active) el.setSelectionRange.apply(el, pos);
            }

            function setNodeValue(el, val, type, live) {
            	if (type == null) type = getType(el);

            	switch (type) {
            		case "number":
            			setLiveValue(live, el, function () {
            				updateProperty(el, typeof val === "number" ? "valueAsNumber" : "value", val);
            			});
            			break;

            		case "text":
            			setLiveValue(live, el, function () {
            				updateProperty(el, "value", toString$1(val));
            			});
            			break;

            		case "checkbox":
            			updateProperty(el, "checked", Boolean(val));
            			break;

            		case "date":
            			setLiveValue(live, el, function () {
            				updateProperty(el, _isDate(val) ? "valueAsDate" : "value", val);
            			});
            			break;

            		case "select":
            			_toArray(el.querySelectorAll("option")).forEach(function (opt) {
            				updateProperty(opt, "selected", opt.$bound_value === val);
            			});
            			break;

            		case "radio":
            			updateProperty(el, "checked", el.$bound_value === val);
            			break;
            	}
            }

            function bindTo(options, lazy, d, id) {
            	var fbind = this.getFormBinding(id);
            	if (fbind == null) return;

            	var el = d.target;
            	var args = _toArray(arguments).slice(4);
            	var type = getType(el);
            	var onChange = void 0;
            	var twscope = _pick(d, "scope", "template", "target");

            	// detect changes to the input's value
            	if (typeof fbind.change === "function") {
            		onChange = function onChange(e) {
            			fbind.change.apply(_assign(twscope, {
            				original: e
            			}), [getNodeValue(el, type)].concat(args));
            		};

            		el.addEventListener("change", onChange);
            		el.addEventListener("paste", onChange);
            		if (!(options.lazy || lazy)) el.addEventListener("keyup", onChange);

            		d.comp.onInvalidate(function () {
            			el.removeEventListener("change", onChange);
            			el.removeEventListener("paste", onChange);
            			el.removeEventListener("keyup", onChange);
            		});
            	}

            	var nodeValueComp = void 0,
            	    stopped = false;

            	d.comp.onInvalidate(function () {
            		stopped = true;
            		if (nodeValueComp) nodeValueComp.stop();
            	});

            	// reactively set the value on the input
            	// deferred so value decorators run
            	_defer(function () {
            		if (stopped) return;
            		nodeValueComp = Trackr.autorun(function () {
            			setNodeValue(el, fbind.get.apply(twscope, args), type, options.live);
            		});
            	});
            }

            function valueOf(d, val) {
            	var el = d.target,
            	    type = getType(el);

            	if (!_includes(value_types, type)) {
            		updateAttribute(el, "value", val);
            		return;
            	}

            	el.$bound_value = val;
            	updateProperty(el, "value", val);
            }

            function plugin$3() {
            	this.use("decorators");
            	this.decorate("ref", decorator);
            }

            var warned = [];

            function warnOnce(msg) {
            	if (_includes(warned, msg)) return;
            	console.warn(msg);
            	warned.push(msg);
            }

            function decorator(d, key) {
            	var scope = d.owner;
            	if (!scope.refs) scope.refs = {};

            	// warn about overwrites overwrite
            	if (_has(scope.refs, key)) {
            		warnOnce("Multiple elements with reference '" + key + "'.");
            		return;
            	}

            	// set the reference
            	scope.refs[key] = d.target;

            	// remove the reference when the element disappears
            	d.comp.onInvalidate(function () {
            		delete scope.refs[key];
            	});
            }

            // export function find(key) {
            // 	var tpls = [ this ],
            // 		tpl;
            //
            // 	while (tpls.length) {
            // 		tpl = tpls.shift();
            // 		if (tpl.refs && tpl.refs[key]) return tpl.refs[key];
            // 		// tpls = tpls.concat(tpl.getComponents());
            // 	}
            //
            // 	return null;
            // }

            // declare, but don't set the plugin variable
            // exports and imports are hoisted, so this cannot do anything to the value
            var plugins;

            function load(tpl, plugin, args) {
            	var name = void 0;
            	if (plugins == null) plugins = {};

            	if (_isString(plugin)) {
            		name = plugin;
            		if (plugins[name] == null) throw new Error("No plugin exists with id '" + name + "'.");

            		plugin = plugins[name];
            	}

            	if (!_isFunction(plugin)) throw new Error("Expecting string or function for plugin");

            	// check if plugin is already loaded on this template
            	if (tpl._loaded_plugins == null) tpl._loaded_plugins = [];
            	if (tpl._loaded_plugins.some(function (p) {
            		return p.plugin === plugin;
            	})) return tpl;

            	if (args == null) args = [];
            	if (!require$$0$21(args)) args = [args];
            	tpl._loaded_plugins.push({
            		name: name,
            		plugin: plugin,
            		args: args
            	});

            	plugin.apply(tpl, args);
            	return tpl;
            }

            function register(name, fn) {
            	if (plugins == null) plugins = {};

            	if (typeof name !== "string") {
            		throw new Error("Expecting string name for plugin.");
            	}

            	if (typeof fn !== "function") {
            		throw new Error("Expecting function for plugin.");
            	}

            	if (fn === plugins[name]) return;
            	if (plugins[name] != null) {
            		throw new Error("Refusing to overwrite existing plugin \"name\".");
            	}

            	plugins[name] = fn;
            }

            function get$1(name) {
            	return plugins && plugins[name];
            }

            register("decorators", plugin);
            register("actions", plugin$1);
            register("twoway", plugin$2);
            register("refs", plugin$3);

var plugins$1 = Object.freeze({
            	load: load,
            	register: register,
            	get: get$1
            });

            var backboneExtendStandalone = __commonjs(function (module, exports) {
            (function (definition) {
              if (typeof exports === "object") {
                module.exports = definition();
              }
              else if (typeof define === 'function' && define.amd) {
                define(definition);
              }
              else {
                window.BackboneExtend = definition();
              }
            })(function () {
              "use strict";
              
              // mini-underscore
              var _ = {
                has: function (obj, key) {
                  return Object.prototype.hasOwnProperty.call(obj, key);
                },
              
                extend: function(obj) {
                  for (var i=1; i<arguments.length; ++i) {
                    var source = arguments[i];
                    if (source) {
                      for (var prop in source) {
                        obj[prop] = source[prop];
                      }
                    }
                  }
                  return obj;
                }
              };

              /// Following code is pasted from Backbone.js ///

              // Helper function to correctly set up the prototype chain, for subclasses.
              // Similar to `goog.inherits`, but uses a hash of prototype properties and
              // class properties to be extended.
              var extend = function(protoProps, staticProps) {
                var parent = this;
                var child;

                // The constructor function for the new subclass is either defined by you
                // (the "constructor" property in your `extend` definition), or defaulted
                // by us to simply call the parent's constructor.
                if (protoProps && _.has(protoProps, 'constructor')) {
                  child = protoProps.constructor;
                } else {
                  child = function(){ return parent.apply(this, arguments); };
                }

                // Add static properties to the constructor function, if supplied.
                _.extend(child, parent, staticProps);

                // Set the prototype chain to inherit from `parent`, without calling
                // `parent`'s constructor function.
                var Surrogate = function(){ this.constructor = child; };
                Surrogate.prototype = parent.prototype;
                child.prototype = new Surrogate();

                // Add prototype properties (instance properties) to the subclass,
                // if supplied.
                if (protoProps) _.extend(child.prototype, protoProps);

                // Set a convenience property in case the parent's prototype is needed
                // later.
                child.__super__ = parent.prototype;

                return child;
              };

              // Expose the extend function
              return extend;
            });
            });

            var subclass = (backboneExtendStandalone && typeof backboneExtendStandalone === 'object' && 'default' in backboneExtendStandalone ? backboneExtendStandalone['default'] : backboneExtendStandalone);

            var templates = {};
            var types = {};

            function Template(name, render) {
            	if (typeof name !== "string" || name === "") {
            		throw new Error("Expecting a non-empty string for template name.");
            	}

            	if (typeof render !== "function") {
            		throw new Error("Expecting a function for render.");
            	}

            	EventEmitter.call(this);
            	this.setMaxListeners(0);

            	// internal state
            	this.s = {
            		// template name
            		name: name,
            		// render method
            		render: render,
            		// dependency for easy invalidate
            		renderdep: new Trackr.Dependency(),
            		// holds the helpers
            		helpers: new Map()
            	};

            	// default plugins
            	this.use("decorators");
            	this.initialize();
            }

            Template.extend = subclass;
            Template.prototype = Object.create(EventEmitter.prototype);
            Template.prototype.constructor = Template;
            Template.prototype.type = "template";
            Template.prototype.initialize = function () {};

            // plugin proxy for scopes
            Template.prototype.use = function use(p) {
            	return load(this, p, _toArray(arguments).slice(1));
            };

            Template.prototype.createScope = function (data, parent) {
            	if (data instanceof Scope) {
            		;
            		var _ref = [data, null];
            		parent = _ref[0];
            		data = _ref[1];
            	}var scope = new Scope(data, parent, this);
            	this.emit("scope", scope);
            	return scope;
            };

            Template.prototype.invalidate = function () {
            	this.s.renderdep.changed();
            	return this;
            };

            Template.prototype.render = function (data, key) {
            	this.s.renderdep.depend();
            	var scope = this.createScope(data);
            	this.s.render(scope, key);
            	this.emit("render", scope);
            	return scope;
            };

            var injectable_nodes = [1, // Node.ELEMENT_NODE,
            9, // Node.DOCUMENT_NODE,
            11 // Node.DOCUMENT_FRAGMENT_NODE
            ];

            Template.prototype.paint = function (node, data) {
            	var _this = this;

            	if (typeof node === "string") node = document.querySelector(node);
            	if (!node || !_includes(injectable_nodes, node.nodeType)) {
            		throw new Error("Expecting a valid DOM element to paint.");
            	}

            	var scope = data instanceof Scope ? data : new Scope(data);
            	var c = Trackr.autorun(function () {
            		patch(node, function () {
            			return _this.render(scope);
            		});
            	});

            	c.scope = scope;
            	c.template = this;

            	c.onStop(function () {
            		patch(node, function () {});
            	});

            	return c;
            };

            var globalHelpers = new Map();

            var helpers = Template.prototype.helpers = function (key, value) {
            	var _this2 = this;

            	if ((typeof key === "undefined" ? "undefined" : babelHelpers.typeof(key)) === "object") {
            		Object.keys(key).forEach(function (k) {
            			return helpers.call(_this2, k, key[k]);
            		});
            		return this;
            	}

            	var h = globalHelpers;
            	if (this instanceof Template) h = this.s.helpers;

            	if (typeof value === "undefined") h.delete(key);else h.set(key, value);

            	return this;
            };

            var getHelper = Template.prototype.getHelper = function (key) {
            	if (this instanceof Template) {
            		return this.s.helpers.get(key);
            	}

            	return globalHelpers.get(key);
            };

            function render(name, scope, key) {
            	var tpl = getByName(name);
            	if (tpl) return tpl.render(scope, key);
            }

            function getByName(name) {
            	return templates[name];
            }

            function paint(tpl, node, data) {
            	if (typeof tpl === "string") {
            		tpl = getByName(tpl);
            		if (!tpl) throw new Error("No template exists with name '" + tpl + "'");
            	}
            	if (!(tpl instanceof Template)) {
            		throw new Error("Expecting template name or instance of Template.");
            	}
            	return tpl.paint(node, data);
            }

            function registerType(type, props) {
            	if (typeof type !== "string" || !type) {
            		throw new Error("Expecting non-empty string for type.");
            	}
            	if (_has(types, type)) {
            		throw new Error("Template type '" + type + "' already exists.");
            	}

            	if (typeof props === "function") {
            		props = { initialize: props };
            	}

            	props = _assign({}, props, { type: type });

            	var T = Template;
            	if (props.extends && _has(types, props.extends)) {
            		T = types[props.extends];
            		delete props.extends;
            	}

            	function wrap(k, f) {
            		return function () {
            			var osuper = this.super;
            			this.super = T.prototype[k];
            			var ret = f.apply(this, arguments);
            			this.super = osuper;
            			return ret;
            		};
            	}

            	for (var k in props) {
            		var fn = props[k];
            		if (typeof fn !== "function") continue;
            		if (/this\.super|this\["super"\]|this\['super'\]/.test(fn.toString())) {
            			props[k] = wrap(k, fn);
            		}
            	}

            	return types[type] = T.extend(props);
            }

            function create$1(name, type, render) {
            	if (typeof name !== "string" || !name) {
            		throw new Error("Expecting non-empty string for name.");
            	}
            	if (getByName(name)) {
            		throw new Error("Template '" + name + "' already exists.");
            	}

            	if (typeof type === "function") {
            		;
            		var _ref2 = [type, null];
            		render = _ref2[0];
            		type = _ref2[1];
            	}if (type && !_has(types, type)) {
            		throw new Error("Template type " + type + " does not exist.");
            	}

            	var T = type ? types[type] : Template;
            	return templates[name] = new T(name, render);
            }

            function Scope(data, parent, template) {
            	if (!(this instanceof Scope)) {
            		return new Scope(parent);
            	}

            	EventEmitter.call(this);
            	this.setMaxListeners(0);

            	if (data instanceof Scope) {
            		var _ref = [parent, data, null];
            		template = _ref[0];
            		parent = _ref[1];
            		data = _ref[2];
            	}

            	if (parent && !(parent instanceof Scope)) {
            		throw new Error("Expecting an instance of Scope for parent.");
            	}

            	// internal view state
            	this.s = {
            		// parent view for scope
            		parent: parent || null,
            		// associated template object
            		template: template || null,
            		// holds lexical data
            		scope: {},
            		// holds "this" data
            		data: new Variable()
            	};

            	// set initial data
            	if (data != null) this.set(data);
            	if (!this.parent) this.dataVar.set(data);
            }

            Scope.prototype = Object.create(EventEmitter.prototype);
            Scope.prototype.constructor = Scope;

            assignProps(Scope.prototype, {
            	scope: function scope() {
            		return this.s.scope;
            	},
            	dataVar: function dataVar() {
            		return this.s.data;
            	},
            	data: function data() {
            		return this.s.data.get();
            	},
            	template: function template() {
            		return this.s.template;
            	},
            	parent: function parent() {
            		return this.s.parent;
            	}
            });

            Scope.prototype.set = function (key, value) {
            	var _this = this;

            	if ((typeof key === "undefined" ? "undefined" : babelHelpers.typeof(key)) === "object") {
            		_forEach(key, function (v, k) {
            			return _this.set(k, v);
            		});
            		return this;
            	}

            	if (key === "this") {
            		this.s.data.set(value);
            	} else {
            		if (typeof value === "undefined") delete this.s.scope[key];else this.s.scope[key] = value;
            	}

            	return this;
            };

            Scope.prototype.get = function (key) {
            	return _has(this.s.scope, key) ? this.s.scope[key] : void 0;
            };

            Scope.prototype.parentData = function (dist) {
            	if (typeof dist !== "number" || isNaN(dist)) dist = 1;

            	if (dist >= 0) {
            		var _v = this;
            		while (dist && _v) {
            			dist--;
            			_v = _v.parent;
            		}
            		return !dist && _v ? _v.data : void 0;
            	}

            	var views = [];
            	var v = this;

            	while (v) {
            		views.push(v);
            		v = v.parent;
            	}

            	var view = views[Math.abs(dist) - 1];
            	return view ? view.data : void 0;
            };

            Scope.prototype.getTemplateScope = function () {
            	var view = this;

            	while (view) {
            		if (view.template != null) {
            			return view;
            		}

            		view = view.parent;
            	}
            };

            Scope.prototype.getTemplate = function () {
            	var scope = this.getTemplateScope();
            	return scope ? scope.template : void 0;
            };

            var lookup = function lookup(tpl, scope, key) {
            	var view = void 0;

            	// 0-0. check for this
            	if (!key || key === "this") {
            		view = scope;
            		while (view) {
            			var _val = view.data;
            			if (_val !== void 0) return _val;
            			view = view.parent;
            		}
            	}

            	// 0-1. special method $this
            	if (key === "$this") {
            		return function (d) {
            			return scope.parentData(d);
            		};
            	}

            	// 1. check closest template helpers
            	if (tpl) {
            		var _val2 = tpl.getHelper(key);
            		if (_val2 !== void 0) return _val2;
            	}

            	// 2. check lexical scope
            	view = scope;
            	while (view) {
            		var _val3 = view.get(key);
            		if (_val3 !== void 0) return _val3;
            		view = view.parent;
            	}

            	// 3. check global helpers
            	var val = getHelper(key);
            	if (val !== void 0) return val;
            };

            Scope.prototype.lookup = function (key) {
            	return lookup(this.getTemplate(), this, key);
            };

            var util = __commonjs(function (module, exports) {
            /* -*- Mode: js; js-indent-level: 2; -*- */
            /*
             * Copyright 2011 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE or:
             * http://opensource.org/licenses/BSD-3-Clause
             */
            {
              /**
               * This is a helper function for getting values from parameter/options
               * objects.
               *
               * @param args The object we are extracting values from
               * @param name The name of the property we are getting.
               * @param defaultValue An optional value to return if the property is missing
               * from the object. If this is not specified and the property is missing, an
               * error will be thrown.
               */
              function getArg(aArgs, aName, aDefaultValue) {
                if (aName in aArgs) {
                  return aArgs[aName];
                } else if (arguments.length === 3) {
                  return aDefaultValue;
                } else {
                  throw new Error('"' + aName + '" is a required argument.');
                }
              }
              exports.getArg = getArg;

              var urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.]*)(?::(\d+))?(\S*)$/;
              var dataUrlRegexp = /^data:.+\,.+$/;

              function urlParse(aUrl) {
                var match = aUrl.match(urlRegexp);
                if (!match) {
                  return null;
                }
                return {
                  scheme: match[1],
                  auth: match[2],
                  host: match[3],
                  port: match[4],
                  path: match[5]
                };
              }
              exports.urlParse = urlParse;

              function urlGenerate(aParsedUrl) {
                var url = '';
                if (aParsedUrl.scheme) {
                  url += aParsedUrl.scheme + ':';
                }
                url += '//';
                if (aParsedUrl.auth) {
                  url += aParsedUrl.auth + '@';
                }
                if (aParsedUrl.host) {
                  url += aParsedUrl.host;
                }
                if (aParsedUrl.port) {
                  url += ":" + aParsedUrl.port
                }
                if (aParsedUrl.path) {
                  url += aParsedUrl.path;
                }
                return url;
              }
              exports.urlGenerate = urlGenerate;

              /**
               * Normalizes a path, or the path portion of a URL:
               *
               * - Replaces consequtive slashes with one slash.
               * - Removes unnecessary '.' parts.
               * - Removes unnecessary '<dir>/..' parts.
               *
               * Based on code in the Node.js 'path' core module.
               *
               * @param aPath The path or url to normalize.
               */
              function normalize(aPath) {
                var path = aPath;
                var url = urlParse(aPath);
                if (url) {
                  if (!url.path) {
                    return aPath;
                  }
                  path = url.path;
                }
                var isAbsolute = exports.isAbsolute(path);

                var parts = path.split(/\/+/);
                for (var part, up = 0, i = parts.length - 1; i >= 0; i--) {
                  part = parts[i];
                  if (part === '.') {
                    parts.splice(i, 1);
                  } else if (part === '..') {
                    up++;
                  } else if (up > 0) {
                    if (part === '') {
                      // The first part is blank if the path is absolute. Trying to go
                      // above the root is a no-op. Therefore we can remove all '..' parts
                      // directly after the root.
                      parts.splice(i + 1, up);
                      up = 0;
                    } else {
                      parts.splice(i, 2);
                      up--;
                    }
                  }
                }
                path = parts.join('/');

                if (path === '') {
                  path = isAbsolute ? '/' : '.';
                }

                if (url) {
                  url.path = path;
                  return urlGenerate(url);
                }
                return path;
              }
              exports.normalize = normalize;

              /**
               * Joins two paths/URLs.
               *
               * @param aRoot The root path or URL.
               * @param aPath The path or URL to be joined with the root.
               *
               * - If aPath is a URL or a data URI, aPath is returned, unless aPath is a
               *   scheme-relative URL: Then the scheme of aRoot, if any, is prepended
               *   first.
               * - Otherwise aPath is a path. If aRoot is a URL, then its path portion
               *   is updated with the result and aRoot is returned. Otherwise the result
               *   is returned.
               *   - If aPath is absolute, the result is aPath.
               *   - Otherwise the two paths are joined with a slash.
               * - Joining for example 'http://' and 'www.example.com' is also supported.
               */
              function join(aRoot, aPath) {
                if (aRoot === "") {
                  aRoot = ".";
                }
                if (aPath === "") {
                  aPath = ".";
                }
                var aPathUrl = urlParse(aPath);
                var aRootUrl = urlParse(aRoot);
                if (aRootUrl) {
                  aRoot = aRootUrl.path || '/';
                }

                // `join(foo, '//www.example.org')`
                if (aPathUrl && !aPathUrl.scheme) {
                  if (aRootUrl) {
                    aPathUrl.scheme = aRootUrl.scheme;
                  }
                  return urlGenerate(aPathUrl);
                }

                if (aPathUrl || aPath.match(dataUrlRegexp)) {
                  return aPath;
                }

                // `join('http://', 'www.example.com')`
                if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
                  aRootUrl.host = aPath;
                  return urlGenerate(aRootUrl);
                }

                var joined = aPath.charAt(0) === '/'
                  ? aPath
                  : normalize(aRoot.replace(/\/+$/, '') + '/' + aPath);

                if (aRootUrl) {
                  aRootUrl.path = joined;
                  return urlGenerate(aRootUrl);
                }
                return joined;
              }
              exports.join = join;

              exports.isAbsolute = function (aPath) {
                return aPath.charAt(0) === '/' || !!aPath.match(urlRegexp);
              };

              /**
               * Make a path relative to a URL or another path.
               *
               * @param aRoot The root path or URL.
               * @param aPath The path or URL to be made relative to aRoot.
               */
              function relative(aRoot, aPath) {
                if (aRoot === "") {
                  aRoot = ".";
                }

                aRoot = aRoot.replace(/\/$/, '');

                // It is possible for the path to be above the root. In this case, simply
                // checking whether the root is a prefix of the path won't work. Instead, we
                // need to remove components from the root one by one, until either we find
                // a prefix that fits, or we run out of components to remove.
                var level = 0;
                while (aPath.indexOf(aRoot + '/') !== 0) {
                  var index = aRoot.lastIndexOf("/");
                  if (index < 0) {
                    return aPath;
                  }

                  // If the only part of the root that is left is the scheme (i.e. http://,
                  // file:///, etc.), one or more slashes (/), or simply nothing at all, we
                  // have exhausted all components, so the path is not relative to the root.
                  aRoot = aRoot.slice(0, index);
                  if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
                    return aPath;
                  }

                  ++level;
                }

                // Make sure we add a "../" for each component we removed from the root.
                return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
              }
              exports.relative = relative;

              /**
               * Because behavior goes wacky when you set `__proto__` on objects, we
               * have to prefix all the strings in our set with an arbitrary character.
               *
               * See https://github.com/mozilla/source-map/pull/31 and
               * https://github.com/mozilla/source-map/issues/30
               *
               * @param String aStr
               */
              function toSetString(aStr) {
                return '$' + aStr;
              }
              exports.toSetString = toSetString;

              function fromSetString(aStr) {
                return aStr.substr(1);
              }
              exports.fromSetString = fromSetString;

              /**
               * Comparator between two mappings where the original positions are compared.
               *
               * Optionally pass in `true` as `onlyCompareGenerated` to consider two
               * mappings with the same original source/line/column, but different generated
               * line and column the same. Useful when searching for a mapping with a
               * stubbed out mapping.
               */
              function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
                var cmp = mappingA.source - mappingB.source;
                if (cmp !== 0) {
                  return cmp;
                }

                cmp = mappingA.originalLine - mappingB.originalLine;
                if (cmp !== 0) {
                  return cmp;
                }

                cmp = mappingA.originalColumn - mappingB.originalColumn;
                if (cmp !== 0 || onlyCompareOriginal) {
                  return cmp;
                }

                cmp = mappingA.generatedColumn - mappingB.generatedColumn;
                if (cmp !== 0) {
                  return cmp;
                }

                cmp = mappingA.generatedLine - mappingB.generatedLine;
                if (cmp !== 0) {
                  return cmp;
                }

                return mappingA.name - mappingB.name;
              }
              exports.compareByOriginalPositions = compareByOriginalPositions;

              /**
               * Comparator between two mappings with deflated source and name indices where
               * the generated positions are compared.
               *
               * Optionally pass in `true` as `onlyCompareGenerated` to consider two
               * mappings with the same generated line and column, but different
               * source/name/original line and column the same. Useful when searching for a
               * mapping with a stubbed out mapping.
               */
              function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
                var cmp = mappingA.generatedLine - mappingB.generatedLine;
                if (cmp !== 0) {
                  return cmp;
                }

                cmp = mappingA.generatedColumn - mappingB.generatedColumn;
                if (cmp !== 0 || onlyCompareGenerated) {
                  return cmp;
                }

                cmp = mappingA.source - mappingB.source;
                if (cmp !== 0) {
                  return cmp;
                }

                cmp = mappingA.originalLine - mappingB.originalLine;
                if (cmp !== 0) {
                  return cmp;
                }

                cmp = mappingA.originalColumn - mappingB.originalColumn;
                if (cmp !== 0) {
                  return cmp;
                }

                return mappingA.name - mappingB.name;
              }
              exports.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;

              function strcmp(aStr1, aStr2) {
                if (aStr1 === aStr2) {
                  return 0;
                }

                if (aStr1 > aStr2) {
                  return 1;
                }

                return -1;
              }

              /**
               * Comparator between two mappings with inflated source and name strings where
               * the generated positions are compared.
               */
              function compareByGeneratedPositionsInflated(mappingA, mappingB) {
                var cmp = mappingA.generatedLine - mappingB.generatedLine;
                if (cmp !== 0) {
                  return cmp;
                }

                cmp = mappingA.generatedColumn - mappingB.generatedColumn;
                if (cmp !== 0) {
                  return cmp;
                }

                cmp = strcmp(mappingA.source, mappingB.source);
                if (cmp !== 0) {
                  return cmp;
                }

                cmp = mappingA.originalLine - mappingB.originalLine;
                if (cmp !== 0) {
                  return cmp;
                }

                cmp = mappingA.originalColumn - mappingB.originalColumn;
                if (cmp !== 0) {
                  return cmp;
                }

                return strcmp(mappingA.name, mappingB.name);
              }
              exports.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;
            }
            });

            var require$$4$13 = (util && typeof util === 'object' && 'default' in util ? util['default'] : util);

            var mappingList = __commonjs(function (module, exports) {
            /* -*- Mode: js; js-indent-level: 2; -*- */
            /*
             * Copyright 2014 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE or:
             * http://opensource.org/licenses/BSD-3-Clause
             */
            {
              var util = require$$4$13;

              /**
               * Determine whether mappingB is after mappingA with respect to generated
               * position.
               */
              function generatedPositionAfter(mappingA, mappingB) {
                // Optimized for most common case
                var lineA = mappingA.generatedLine;
                var lineB = mappingB.generatedLine;
                var columnA = mappingA.generatedColumn;
                var columnB = mappingB.generatedColumn;
                return lineB > lineA || lineB == lineA && columnB >= columnA ||
                       util.compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0;
              }

              /**
               * A data structure to provide a sorted view of accumulated mappings in a
               * performance conscious manner. It trades a neglibable overhead in general
               * case for a large speedup in case of mappings being added in order.
               */
              function MappingList() {
                this._array = [];
                this._sorted = true;
                // Serves as infimum
                this._last = {generatedLine: -1, generatedColumn: 0};
              }

              /**
               * Iterate through internal items. This method takes the same arguments that
               * `Array.prototype.forEach` takes.
               *
               * NOTE: The order of the mappings is NOT guaranteed.
               */
              MappingList.prototype.unsortedForEach =
                function MappingList_forEach(aCallback, aThisArg) {
                  this._array.forEach(aCallback, aThisArg);
                };

              /**
               * Add the given source mapping.
               *
               * @param Object aMapping
               */
              MappingList.prototype.add = function MappingList_add(aMapping) {
                if (generatedPositionAfter(this._last, aMapping)) {
                  this._last = aMapping;
                  this._array.push(aMapping);
                } else {
                  this._sorted = false;
                  this._array.push(aMapping);
                }
              };

              /**
               * Returns the flat, sorted array of mappings. The mappings are sorted by
               * generated position.
               *
               * WARNING: This method returns internal data without copying, for
               * performance. The return value must NOT be mutated, and should be treated as
               * an immutable borrow. If you want to take ownership, you must make your own
               * copy.
               */
              MappingList.prototype.toArray = function MappingList_toArray() {
                if (!this._sorted) {
                  this._array.sort(util.compareByGeneratedPositionsInflated);
                  this._sorted = true;
                }
                return this._array;
              };

              exports.MappingList = MappingList;
            }
            });

            var require$$0$46 = (mappingList && typeof mappingList === 'object' && 'default' in mappingList ? mappingList['default'] : mappingList);

            var arraySet = __commonjs(function (module, exports) {
            /* -*- Mode: js; js-indent-level: 2; -*- */
            /*
             * Copyright 2011 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE or:
             * http://opensource.org/licenses/BSD-3-Clause
             */
            {
              var util = require$$4$13;

              /**
               * A data structure which is a combination of an array and a set. Adding a new
               * member is O(1), testing for membership is O(1), and finding the index of an
               * element is O(1). Removing elements from the set is not supported. Only
               * strings are supported for membership.
               */
              function ArraySet() {
                this._array = [];
                this._set = {};
              }

              /**
               * Static method for creating ArraySet instances from an existing array.
               */
              ArraySet.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
                var set = new ArraySet();
                for (var i = 0, len = aArray.length; i < len; i++) {
                  set.add(aArray[i], aAllowDuplicates);
                }
                return set;
              };

              /**
               * Return how many unique items are in this ArraySet. If duplicates have been
               * added, than those do not count towards the size.
               *
               * @returns Number
               */
              ArraySet.prototype.size = function ArraySet_size() {
                return Object.getOwnPropertyNames(this._set).length;
              };

              /**
               * Add the given string to this set.
               *
               * @param String aStr
               */
              ArraySet.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
                var sStr = util.toSetString(aStr);
                var isDuplicate = this._set.hasOwnProperty(sStr);
                var idx = this._array.length;
                if (!isDuplicate || aAllowDuplicates) {
                  this._array.push(aStr);
                }
                if (!isDuplicate) {
                  this._set[sStr] = idx;
                }
              };

              /**
               * Is the given string a member of this set?
               *
               * @param String aStr
               */
              ArraySet.prototype.has = function ArraySet_has(aStr) {
                var sStr = util.toSetString(aStr);
                return this._set.hasOwnProperty(sStr);
              };

              /**
               * What is the index of the given string in the array?
               *
               * @param String aStr
               */
              ArraySet.prototype.indexOf = function ArraySet_indexOf(aStr) {
                var sStr = util.toSetString(aStr);
                if (this._set.hasOwnProperty(sStr)) {
                  return this._set[sStr];
                }
                throw new Error('"' + aStr + '" is not in the set.');
              };

              /**
               * What is the element at the given index?
               *
               * @param Number aIdx
               */
              ArraySet.prototype.at = function ArraySet_at(aIdx) {
                if (aIdx >= 0 && aIdx < this._array.length) {
                  return this._array[aIdx];
                }
                throw new Error('No element indexed by ' + aIdx);
              };

              /**
               * Returns the array representation of this set (which has the proper indices
               * indicated by indexOf). Note that this is a copy of the internal array used
               * for storing the members so that no one can mess with internal state.
               */
              ArraySet.prototype.toArray = function ArraySet_toArray() {
                return this._array.slice();
              };

              exports.ArraySet = ArraySet;
            }
            });

            var require$$2$13 = (arraySet && typeof arraySet === 'object' && 'default' in arraySet ? arraySet['default'] : arraySet);

            var base64 = __commonjs(function (module, exports) {
            /* -*- Mode: js; js-indent-level: 2; -*- */
            /*
             * Copyright 2011 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE or:
             * http://opensource.org/licenses/BSD-3-Clause
             */
            {
              var intToCharMap = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.split('');

              /**
               * Encode an integer in the range of 0 to 63 to a single base 64 digit.
               */
              exports.encode = function (number) {
                if (0 <= number && number < intToCharMap.length) {
                  return intToCharMap[number];
                }
                throw new TypeError("Must be between 0 and 63: " + number);
              };

              /**
               * Decode a single base 64 character code digit to an integer. Returns -1 on
               * failure.
               */
              exports.decode = function (charCode) {
                var bigA = 65;     // 'A'
                var bigZ = 90;     // 'Z'

                var littleA = 97;  // 'a'
                var littleZ = 122; // 'z'

                var zero = 48;     // '0'
                var nine = 57;     // '9'

                var plus = 43;     // '+'
                var slash = 47;    // '/'

                var littleOffset = 26;
                var numberOffset = 52;

                // 0 - 25: ABCDEFGHIJKLMNOPQRSTUVWXYZ
                if (bigA <= charCode && charCode <= bigZ) {
                  return (charCode - bigA);
                }

                // 26 - 51: abcdefghijklmnopqrstuvwxyz
                if (littleA <= charCode && charCode <= littleZ) {
                  return (charCode - littleA + littleOffset);
                }

                // 52 - 61: 0123456789
                if (zero <= charCode && charCode <= nine) {
                  return (charCode - zero + numberOffset);
                }

                // 62: +
                if (charCode == plus) {
                  return 62;
                }

                // 63: /
                if (charCode == slash) {
                  return 63;
                }

                // Invalid base64 digit.
                return -1;
              };
            }
            });

            var require$$0$47 = (base64 && typeof base64 === 'object' && 'default' in base64 ? base64['default'] : base64);

            var base64Vlq = __commonjs(function (module, exports) {
            /* -*- Mode: js; js-indent-level: 2; -*- */
            /*
             * Copyright 2011 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE or:
             * http://opensource.org/licenses/BSD-3-Clause
             *
             * Based on the Base 64 VLQ implementation in Closure Compiler:
             * https://code.google.com/p/closure-compiler/source/browse/trunk/src/com/google/debugging/sourcemap/Base64VLQ.java
             *
             * Copyright 2011 The Closure Compiler Authors. All rights reserved.
             * Redistribution and use in source and binary forms, with or without
             * modification, are permitted provided that the following conditions are
             * met:
             *
             *  * Redistributions of source code must retain the above copyright
             *    notice, this list of conditions and the following disclaimer.
             *  * Redistributions in binary form must reproduce the above
             *    copyright notice, this list of conditions and the following
             *    disclaimer in the documentation and/or other materials provided
             *    with the distribution.
             *  * Neither the name of Google Inc. nor the names of its
             *    contributors may be used to endorse or promote products derived
             *    from this software without specific prior written permission.
             *
             * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
             * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
             * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
             * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
             * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
             * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
             * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
             * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
             * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
             * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
             */
            {
              var base64 = require$$0$47;

              // A single base 64 digit can contain 6 bits of data. For the base 64 variable
              // length quantities we use in the source map spec, the first bit is the sign,
              // the next four bits are the actual value, and the 6th bit is the
              // continuation bit. The continuation bit tells us whether there are more
              // digits in this value following this digit.
              //
              //   Continuation
              //   |    Sign
              //   |    |
              //   V    V
              //   101011

              var VLQ_BASE_SHIFT = 5;

              // binary: 100000
              var VLQ_BASE = 1 << VLQ_BASE_SHIFT;

              // binary: 011111
              var VLQ_BASE_MASK = VLQ_BASE - 1;

              // binary: 100000
              var VLQ_CONTINUATION_BIT = VLQ_BASE;

              /**
               * Converts from a two-complement value to a value where the sign bit is
               * placed in the least significant bit.  For example, as decimals:
               *   1 becomes 2 (10 binary), -1 becomes 3 (11 binary)
               *   2 becomes 4 (100 binary), -2 becomes 5 (101 binary)
               */
              function toVLQSigned(aValue) {
                return aValue < 0
                  ? ((-aValue) << 1) + 1
                  : (aValue << 1) + 0;
              }

              /**
               * Converts to a two-complement value from a value where the sign bit is
               * placed in the least significant bit.  For example, as decimals:
               *   2 (10 binary) becomes 1, 3 (11 binary) becomes -1
               *   4 (100 binary) becomes 2, 5 (101 binary) becomes -2
               */
              function fromVLQSigned(aValue) {
                var isNegative = (aValue & 1) === 1;
                var shifted = aValue >> 1;
                return isNegative
                  ? -shifted
                  : shifted;
              }

              /**
               * Returns the base 64 VLQ encoded value.
               */
              exports.encode = function base64VLQ_encode(aValue) {
                var encoded = "";
                var digit;

                var vlq = toVLQSigned(aValue);

                do {
                  digit = vlq & VLQ_BASE_MASK;
                  vlq >>>= VLQ_BASE_SHIFT;
                  if (vlq > 0) {
                    // There are still more digits in this value, so we must make sure the
                    // continuation bit is marked.
                    digit |= VLQ_CONTINUATION_BIT;
                  }
                  encoded += base64.encode(digit);
                } while (vlq > 0);

                return encoded;
              };

              /**
               * Decodes the next base 64 VLQ value from the given string and returns the
               * value and the rest of the string via the out parameter.
               */
              exports.decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
                var strLen = aStr.length;
                var result = 0;
                var shift = 0;
                var continuation, digit;

                do {
                  if (aIndex >= strLen) {
                    throw new Error("Expected more digits in base 64 VLQ value.");
                  }

                  digit = base64.decode(aStr.charCodeAt(aIndex++));
                  if (digit === -1) {
                    throw new Error("Invalid base64 digit: " + aStr.charAt(aIndex - 1));
                  }

                  continuation = !!(digit & VLQ_CONTINUATION_BIT);
                  digit &= VLQ_BASE_MASK;
                  result = result + (digit << shift);
                  shift += VLQ_BASE_SHIFT;
                } while (continuation);

                aOutParam.value = fromVLQSigned(result);
                aOutParam.rest = aIndex;
              };
            }
            });

            var require$$1$34 = (base64Vlq && typeof base64Vlq === 'object' && 'default' in base64Vlq ? base64Vlq['default'] : base64Vlq);

            var sourceMapGenerator = __commonjs(function (module, exports) {
            /* -*- Mode: js; js-indent-level: 2; -*- */
            /*
             * Copyright 2011 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE or:
             * http://opensource.org/licenses/BSD-3-Clause
             */
            {
              var base64VLQ = require$$1$34;
              var util = require$$4$13;
              var ArraySet = require$$2$13.ArraySet;
              var MappingList = require$$0$46.MappingList;

              /**
               * An instance of the SourceMapGenerator represents a source map which is
               * being built incrementally. You may pass an object with the following
               * properties:
               *
               *   - file: The filename of the generated source.
               *   - sourceRoot: A root for all relative URLs in this source map.
               */
              function SourceMapGenerator(aArgs) {
                if (!aArgs) {
                  aArgs = {};
                }
                this._file = util.getArg(aArgs, 'file', null);
                this._sourceRoot = util.getArg(aArgs, 'sourceRoot', null);
                this._skipValidation = util.getArg(aArgs, 'skipValidation', false);
                this._sources = new ArraySet();
                this._names = new ArraySet();
                this._mappings = new MappingList();
                this._sourcesContents = null;
              }

              SourceMapGenerator.prototype._version = 3;

              /**
               * Creates a new SourceMapGenerator based on a SourceMapConsumer
               *
               * @param aSourceMapConsumer The SourceMap.
               */
              SourceMapGenerator.fromSourceMap =
                function SourceMapGenerator_fromSourceMap(aSourceMapConsumer) {
                  var sourceRoot = aSourceMapConsumer.sourceRoot;
                  var generator = new SourceMapGenerator({
                    file: aSourceMapConsumer.file,
                    sourceRoot: sourceRoot
                  });
                  aSourceMapConsumer.eachMapping(function (mapping) {
                    var newMapping = {
                      generated: {
                        line: mapping.generatedLine,
                        column: mapping.generatedColumn
                      }
                    };

                    if (mapping.source != null) {
                      newMapping.source = mapping.source;
                      if (sourceRoot != null) {
                        newMapping.source = util.relative(sourceRoot, newMapping.source);
                      }

                      newMapping.original = {
                        line: mapping.originalLine,
                        column: mapping.originalColumn
                      };

                      if (mapping.name != null) {
                        newMapping.name = mapping.name;
                      }
                    }

                    generator.addMapping(newMapping);
                  });
                  aSourceMapConsumer.sources.forEach(function (sourceFile) {
                    var content = aSourceMapConsumer.sourceContentFor(sourceFile);
                    if (content != null) {
                      generator.setSourceContent(sourceFile, content);
                    }
                  });
                  return generator;
                };

              /**
               * Add a single mapping from original source line and column to the generated
               * source's line and column for this source map being created. The mapping
               * object should have the following properties:
               *
               *   - generated: An object with the generated line and column positions.
               *   - original: An object with the original line and column positions.
               *   - source: The original source file (relative to the sourceRoot).
               *   - name: An optional original token name for this mapping.
               */
              SourceMapGenerator.prototype.addMapping =
                function SourceMapGenerator_addMapping(aArgs) {
                  var generated = util.getArg(aArgs, 'generated');
                  var original = util.getArg(aArgs, 'original', null);
                  var source = util.getArg(aArgs, 'source', null);
                  var name = util.getArg(aArgs, 'name', null);

                  if (!this._skipValidation) {
                    this._validateMapping(generated, original, source, name);
                  }

                  if (source != null && !this._sources.has(source)) {
                    this._sources.add(source);
                  }

                  if (name != null && !this._names.has(name)) {
                    this._names.add(name);
                  }

                  this._mappings.add({
                    generatedLine: generated.line,
                    generatedColumn: generated.column,
                    originalLine: original != null && original.line,
                    originalColumn: original != null && original.column,
                    source: source,
                    name: name
                  });
                };

              /**
               * Set the source content for a source file.
               */
              SourceMapGenerator.prototype.setSourceContent =
                function SourceMapGenerator_setSourceContent(aSourceFile, aSourceContent) {
                  var source = aSourceFile;
                  if (this._sourceRoot != null) {
                    source = util.relative(this._sourceRoot, source);
                  }

                  if (aSourceContent != null) {
                    // Add the source content to the _sourcesContents map.
                    // Create a new _sourcesContents map if the property is null.
                    if (!this._sourcesContents) {
                      this._sourcesContents = {};
                    }
                    this._sourcesContents[util.toSetString(source)] = aSourceContent;
                  } else if (this._sourcesContents) {
                    // Remove the source file from the _sourcesContents map.
                    // If the _sourcesContents map is empty, set the property to null.
                    delete this._sourcesContents[util.toSetString(source)];
                    if (Object.keys(this._sourcesContents).length === 0) {
                      this._sourcesContents = null;
                    }
                  }
                };

              /**
               * Applies the mappings of a sub-source-map for a specific source file to the
               * source map being generated. Each mapping to the supplied source file is
               * rewritten using the supplied source map. Note: The resolution for the
               * resulting mappings is the minimium of this map and the supplied map.
               *
               * @param aSourceMapConsumer The source map to be applied.
               * @param aSourceFile Optional. The filename of the source file.
               *        If omitted, SourceMapConsumer's file property will be used.
               * @param aSourceMapPath Optional. The dirname of the path to the source map
               *        to be applied. If relative, it is relative to the SourceMapConsumer.
               *        This parameter is needed when the two source maps aren't in the same
               *        directory, and the source map to be applied contains relative source
               *        paths. If so, those relative source paths need to be rewritten
               *        relative to the SourceMapGenerator.
               */
              SourceMapGenerator.prototype.applySourceMap =
                function SourceMapGenerator_applySourceMap(aSourceMapConsumer, aSourceFile, aSourceMapPath) {
                  var sourceFile = aSourceFile;
                  // If aSourceFile is omitted, we will use the file property of the SourceMap
                  if (aSourceFile == null) {
                    if (aSourceMapConsumer.file == null) {
                      throw new Error(
                        'SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, ' +
                        'or the source map\'s "file" property. Both were omitted.'
                      );
                    }
                    sourceFile = aSourceMapConsumer.file;
                  }
                  var sourceRoot = this._sourceRoot;
                  // Make "sourceFile" relative if an absolute Url is passed.
                  if (sourceRoot != null) {
                    sourceFile = util.relative(sourceRoot, sourceFile);
                  }
                  // Applying the SourceMap can add and remove items from the sources and
                  // the names array.
                  var newSources = new ArraySet();
                  var newNames = new ArraySet();

                  // Find mappings for the "sourceFile"
                  this._mappings.unsortedForEach(function (mapping) {
                    if (mapping.source === sourceFile && mapping.originalLine != null) {
                      // Check if it can be mapped by the source map, then update the mapping.
                      var original = aSourceMapConsumer.originalPositionFor({
                        line: mapping.originalLine,
                        column: mapping.originalColumn
                      });
                      if (original.source != null) {
                        // Copy mapping
                        mapping.source = original.source;
                        if (aSourceMapPath != null) {
                          mapping.source = util.join(aSourceMapPath, mapping.source)
                        }
                        if (sourceRoot != null) {
                          mapping.source = util.relative(sourceRoot, mapping.source);
                        }
                        mapping.originalLine = original.line;
                        mapping.originalColumn = original.column;
                        if (original.name != null) {
                          mapping.name = original.name;
                        }
                      }
                    }

                    var source = mapping.source;
                    if (source != null && !newSources.has(source)) {
                      newSources.add(source);
                    }

                    var name = mapping.name;
                    if (name != null && !newNames.has(name)) {
                      newNames.add(name);
                    }

                  }, this);
                  this._sources = newSources;
                  this._names = newNames;

                  // Copy sourcesContents of applied map.
                  aSourceMapConsumer.sources.forEach(function (sourceFile) {
                    var content = aSourceMapConsumer.sourceContentFor(sourceFile);
                    if (content != null) {
                      if (aSourceMapPath != null) {
                        sourceFile = util.join(aSourceMapPath, sourceFile);
                      }
                      if (sourceRoot != null) {
                        sourceFile = util.relative(sourceRoot, sourceFile);
                      }
                      this.setSourceContent(sourceFile, content);
                    }
                  }, this);
                };

              /**
               * A mapping can have one of the three levels of data:
               *
               *   1. Just the generated position.
               *   2. The Generated position, original position, and original source.
               *   3. Generated and original position, original source, as well as a name
               *      token.
               *
               * To maintain consistency, we validate that any new mapping being added falls
               * in to one of these categories.
               */
              SourceMapGenerator.prototype._validateMapping =
                function SourceMapGenerator_validateMapping(aGenerated, aOriginal, aSource,
                                                            aName) {
                  if (aGenerated && 'line' in aGenerated && 'column' in aGenerated
                      && aGenerated.line > 0 && aGenerated.column >= 0
                      && !aOriginal && !aSource && !aName) {
                    // Case 1.
                    return;
                  }
                  else if (aGenerated && 'line' in aGenerated && 'column' in aGenerated
                           && aOriginal && 'line' in aOriginal && 'column' in aOriginal
                           && aGenerated.line > 0 && aGenerated.column >= 0
                           && aOriginal.line > 0 && aOriginal.column >= 0
                           && aSource) {
                    // Cases 2 and 3.
                    return;
                  }
                  else {
                    throw new Error('Invalid mapping: ' + JSON.stringify({
                      generated: aGenerated,
                      source: aSource,
                      original: aOriginal,
                      name: aName
                    }));
                  }
                };

              /**
               * Serialize the accumulated mappings in to the stream of base 64 VLQs
               * specified by the source map format.
               */
              SourceMapGenerator.prototype._serializeMappings =
                function SourceMapGenerator_serializeMappings() {
                  var previousGeneratedColumn = 0;
                  var previousGeneratedLine = 1;
                  var previousOriginalColumn = 0;
                  var previousOriginalLine = 0;
                  var previousName = 0;
                  var previousSource = 0;
                  var result = '';
                  var mapping;
                  var nameIdx;
                  var sourceIdx;

                  var mappings = this._mappings.toArray();
                  for (var i = 0, len = mappings.length; i < len; i++) {
                    mapping = mappings[i];

                    if (mapping.generatedLine !== previousGeneratedLine) {
                      previousGeneratedColumn = 0;
                      while (mapping.generatedLine !== previousGeneratedLine) {
                        result += ';';
                        previousGeneratedLine++;
                      }
                    }
                    else {
                      if (i > 0) {
                        if (!util.compareByGeneratedPositionsInflated(mapping, mappings[i - 1])) {
                          continue;
                        }
                        result += ',';
                      }
                    }

                    result += base64VLQ.encode(mapping.generatedColumn
                                               - previousGeneratedColumn);
                    previousGeneratedColumn = mapping.generatedColumn;

                    if (mapping.source != null) {
                      sourceIdx = this._sources.indexOf(mapping.source);
                      result += base64VLQ.encode(sourceIdx - previousSource);
                      previousSource = sourceIdx;

                      // lines are stored 0-based in SourceMap spec version 3
                      result += base64VLQ.encode(mapping.originalLine - 1
                                                 - previousOriginalLine);
                      previousOriginalLine = mapping.originalLine - 1;

                      result += base64VLQ.encode(mapping.originalColumn
                                                 - previousOriginalColumn);
                      previousOriginalColumn = mapping.originalColumn;

                      if (mapping.name != null) {
                        nameIdx = this._names.indexOf(mapping.name);
                        result += base64VLQ.encode(nameIdx - previousName);
                        previousName = nameIdx;
                      }
                    }
                  }

                  return result;
                };

              SourceMapGenerator.prototype._generateSourcesContent =
                function SourceMapGenerator_generateSourcesContent(aSources, aSourceRoot) {
                  return aSources.map(function (source) {
                    if (!this._sourcesContents) {
                      return null;
                    }
                    if (aSourceRoot != null) {
                      source = util.relative(aSourceRoot, source);
                    }
                    var key = util.toSetString(source);
                    return Object.prototype.hasOwnProperty.call(this._sourcesContents,
                                                                key)
                      ? this._sourcesContents[key]
                      : null;
                  }, this);
                };

              /**
               * Externalize the source map.
               */
              SourceMapGenerator.prototype.toJSON =
                function SourceMapGenerator_toJSON() {
                  var map = {
                    version: this._version,
                    sources: this._sources.toArray(),
                    names: this._names.toArray(),
                    mappings: this._serializeMappings()
                  };
                  if (this._file != null) {
                    map.file = this._file;
                  }
                  if (this._sourceRoot != null) {
                    map.sourceRoot = this._sourceRoot;
                  }
                  if (this._sourcesContents) {
                    map.sourcesContent = this._generateSourcesContent(map.sources, map.sourceRoot);
                  }

                  return map;
                };

              /**
               * Render the source map being generated to a string.
               */
              SourceMapGenerator.prototype.toString =
                function SourceMapGenerator_toString() {
                  return JSON.stringify(this.toJSON());
                };

              exports.SourceMapGenerator = SourceMapGenerator;
            }
            });

            var require$$1$33 = (sourceMapGenerator && typeof sourceMapGenerator === 'object' && 'default' in sourceMapGenerator ? sourceMapGenerator['default'] : sourceMapGenerator);

            var sourceNode = __commonjs(function (module, exports) {
            /* -*- Mode: js; js-indent-level: 2; -*- */
            /*
             * Copyright 2011 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE or:
             * http://opensource.org/licenses/BSD-3-Clause
             */
            {
              var SourceMapGenerator = require$$1$33.SourceMapGenerator;
              var util = require$$4$13;

              // Matches a Windows-style `\r\n` newline or a `\n` newline used by all other
              // operating systems these days (capturing the result).
              var REGEX_NEWLINE = /(\r?\n)/;

              // Newline character code for charCodeAt() comparisons
              var NEWLINE_CODE = 10;

              // Private symbol for identifying `SourceNode`s when multiple versions of
              // the source-map library are loaded. This MUST NOT CHANGE across
              // versions!
              var isSourceNode = "$$$isSourceNode$$$";

              /**
               * SourceNodes provide a way to abstract over interpolating/concatenating
               * snippets of generated JavaScript source code while maintaining the line and
               * column information associated with the original source code.
               *
               * @param aLine The original line number.
               * @param aColumn The original column number.
               * @param aSource The original source's filename.
               * @param aChunks Optional. An array of strings which are snippets of
               *        generated JS, or other SourceNodes.
               * @param aName The original identifier.
               */
              function SourceNode(aLine, aColumn, aSource, aChunks, aName) {
                this.children = [];
                this.sourceContents = {};
                this.line = aLine == null ? null : aLine;
                this.column = aColumn == null ? null : aColumn;
                this.source = aSource == null ? null : aSource;
                this.name = aName == null ? null : aName;
                this[isSourceNode] = true;
                if (aChunks != null) this.add(aChunks);
              }

              /**
               * Creates a SourceNode from generated code and a SourceMapConsumer.
               *
               * @param aGeneratedCode The generated code
               * @param aSourceMapConsumer The SourceMap for the generated code
               * @param aRelativePath Optional. The path that relative sources in the
               *        SourceMapConsumer should be relative to.
               */
              SourceNode.fromStringWithSourceMap =
                function SourceNode_fromStringWithSourceMap(aGeneratedCode, aSourceMapConsumer, aRelativePath) {
                  // The SourceNode we want to fill with the generated code
                  // and the SourceMap
                  var node = new SourceNode();

                  // All even indices of this array are one line of the generated code,
                  // while all odd indices are the newlines between two adjacent lines
                  // (since `REGEX_NEWLINE` captures its match).
                  // Processed fragments are removed from this array, by calling `shiftNextLine`.
                  var remainingLines = aGeneratedCode.split(REGEX_NEWLINE);
                  var shiftNextLine = function() {
                    var lineContents = remainingLines.shift();
                    // The last line of a file might not have a newline.
                    var newLine = remainingLines.shift() || "";
                    return lineContents + newLine;
                  };

                  // We need to remember the position of "remainingLines"
                  var lastGeneratedLine = 1, lastGeneratedColumn = 0;

                  // The generate SourceNodes we need a code range.
                  // To extract it current and last mapping is used.
                  // Here we store the last mapping.
                  var lastMapping = null;

                  aSourceMapConsumer.eachMapping(function (mapping) {
                    if (lastMapping !== null) {
                      // We add the code from "lastMapping" to "mapping":
                      // First check if there is a new line in between.
                      if (lastGeneratedLine < mapping.generatedLine) {
                        // Associate first line with "lastMapping"
                        addMappingWithCode(lastMapping, shiftNextLine());
                        lastGeneratedLine++;
                        lastGeneratedColumn = 0;
                        // The remaining code is added without mapping
                      } else {
                        // There is no new line in between.
                        // Associate the code between "lastGeneratedColumn" and
                        // "mapping.generatedColumn" with "lastMapping"
                        var nextLine = remainingLines[0];
                        var code = nextLine.substr(0, mapping.generatedColumn -
                                                      lastGeneratedColumn);
                        remainingLines[0] = nextLine.substr(mapping.generatedColumn -
                                                            lastGeneratedColumn);
                        lastGeneratedColumn = mapping.generatedColumn;
                        addMappingWithCode(lastMapping, code);
                        // No more remaining code, continue
                        lastMapping = mapping;
                        return;
                      }
                    }
                    // We add the generated code until the first mapping
                    // to the SourceNode without any mapping.
                    // Each line is added as separate string.
                    while (lastGeneratedLine < mapping.generatedLine) {
                      node.add(shiftNextLine());
                      lastGeneratedLine++;
                    }
                    if (lastGeneratedColumn < mapping.generatedColumn) {
                      var nextLine = remainingLines[0];
                      node.add(nextLine.substr(0, mapping.generatedColumn));
                      remainingLines[0] = nextLine.substr(mapping.generatedColumn);
                      lastGeneratedColumn = mapping.generatedColumn;
                    }
                    lastMapping = mapping;
                  }, this);
                  // We have processed all mappings.
                  if (remainingLines.length > 0) {
                    if (lastMapping) {
                      // Associate the remaining code in the current line with "lastMapping"
                      addMappingWithCode(lastMapping, shiftNextLine());
                    }
                    // and add the remaining lines without any mapping
                    node.add(remainingLines.join(""));
                  }

                  // Copy sourcesContent into SourceNode
                  aSourceMapConsumer.sources.forEach(function (sourceFile) {
                    var content = aSourceMapConsumer.sourceContentFor(sourceFile);
                    if (content != null) {
                      if (aRelativePath != null) {
                        sourceFile = util.join(aRelativePath, sourceFile);
                      }
                      node.setSourceContent(sourceFile, content);
                    }
                  });

                  return node;

                  function addMappingWithCode(mapping, code) {
                    if (mapping === null || mapping.source === undefined) {
                      node.add(code);
                    } else {
                      var source = aRelativePath
                        ? util.join(aRelativePath, mapping.source)
                        : mapping.source;
                      node.add(new SourceNode(mapping.originalLine,
                                              mapping.originalColumn,
                                              source,
                                              code,
                                              mapping.name));
                    }
                  }
                };

              /**
               * Add a chunk of generated JS to this source node.
               *
               * @param aChunk A string snippet of generated JS code, another instance of
               *        SourceNode, or an array where each member is one of those things.
               */
              SourceNode.prototype.add = function SourceNode_add(aChunk) {
                if (Array.isArray(aChunk)) {
                  aChunk.forEach(function (chunk) {
                    this.add(chunk);
                  }, this);
                }
                else if (aChunk[isSourceNode] || typeof aChunk === "string") {
                  if (aChunk) {
                    this.children.push(aChunk);
                  }
                }
                else {
                  throw new TypeError(
                    "Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk
                  );
                }
                return this;
              };

              /**
               * Add a chunk of generated JS to the beginning of this source node.
               *
               * @param aChunk A string snippet of generated JS code, another instance of
               *        SourceNode, or an array where each member is one of those things.
               */
              SourceNode.prototype.prepend = function SourceNode_prepend(aChunk) {
                if (Array.isArray(aChunk)) {
                  for (var i = aChunk.length-1; i >= 0; i--) {
                    this.prepend(aChunk[i]);
                  }
                }
                else if (aChunk[isSourceNode] || typeof aChunk === "string") {
                  this.children.unshift(aChunk);
                }
                else {
                  throw new TypeError(
                    "Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk
                  );
                }
                return this;
              };

              /**
               * Walk over the tree of JS snippets in this node and its children. The
               * walking function is called once for each snippet of JS and is passed that
               * snippet and the its original associated source's line/column location.
               *
               * @param aFn The traversal function.
               */
              SourceNode.prototype.walk = function SourceNode_walk(aFn) {
                var chunk;
                for (var i = 0, len = this.children.length; i < len; i++) {
                  chunk = this.children[i];
                  if (chunk[isSourceNode]) {
                    chunk.walk(aFn);
                  }
                  else {
                    if (chunk !== '') {
                      aFn(chunk, { source: this.source,
                                   line: this.line,
                                   column: this.column,
                                   name: this.name });
                    }
                  }
                }
              };

              /**
               * Like `String.prototype.join` except for SourceNodes. Inserts `aStr` between
               * each of `this.children`.
               *
               * @param aSep The separator.
               */
              SourceNode.prototype.join = function SourceNode_join(aSep) {
                var newChildren;
                var i;
                var len = this.children.length;
                if (len > 0) {
                  newChildren = [];
                  for (i = 0; i < len-1; i++) {
                    newChildren.push(this.children[i]);
                    newChildren.push(aSep);
                  }
                  newChildren.push(this.children[i]);
                  this.children = newChildren;
                }
                return this;
              };

              /**
               * Call String.prototype.replace on the very right-most source snippet. Useful
               * for trimming whitespace from the end of a source node, etc.
               *
               * @param aPattern The pattern to replace.
               * @param aReplacement The thing to replace the pattern with.
               */
              SourceNode.prototype.replaceRight = function SourceNode_replaceRight(aPattern, aReplacement) {
                var lastChild = this.children[this.children.length - 1];
                if (lastChild[isSourceNode]) {
                  lastChild.replaceRight(aPattern, aReplacement);
                }
                else if (typeof lastChild === 'string') {
                  this.children[this.children.length - 1] = lastChild.replace(aPattern, aReplacement);
                }
                else {
                  this.children.push(''.replace(aPattern, aReplacement));
                }
                return this;
              };

              /**
               * Set the source content for a source file. This will be added to the SourceMapGenerator
               * in the sourcesContent field.
               *
               * @param aSourceFile The filename of the source file
               * @param aSourceContent The content of the source file
               */
              SourceNode.prototype.setSourceContent =
                function SourceNode_setSourceContent(aSourceFile, aSourceContent) {
                  this.sourceContents[util.toSetString(aSourceFile)] = aSourceContent;
                };

              /**
               * Walk over the tree of SourceNodes. The walking function is called for each
               * source file content and is passed the filename and source content.
               *
               * @param aFn The traversal function.
               */
              SourceNode.prototype.walkSourceContents =
                function SourceNode_walkSourceContents(aFn) {
                  for (var i = 0, len = this.children.length; i < len; i++) {
                    if (this.children[i][isSourceNode]) {
                      this.children[i].walkSourceContents(aFn);
                    }
                  }

                  var sources = Object.keys(this.sourceContents);
                  for (var i = 0, len = sources.length; i < len; i++) {
                    aFn(util.fromSetString(sources[i]), this.sourceContents[sources[i]]);
                  }
                };

              /**
               * Return the string representation of this source node. Walks over the tree
               * and concatenates all the various snippets together to one string.
               */
              SourceNode.prototype.toString = function SourceNode_toString() {
                var str = "";
                this.walk(function (chunk) {
                  str += chunk;
                });
                return str;
              };

              /**
               * Returns the string representation of this source node along with a source
               * map.
               */
              SourceNode.prototype.toStringWithSourceMap = function SourceNode_toStringWithSourceMap(aArgs) {
                var generated = {
                  code: "",
                  line: 1,
                  column: 0
                };
                var map = new SourceMapGenerator(aArgs);
                var sourceMappingActive = false;
                var lastOriginalSource = null;
                var lastOriginalLine = null;
                var lastOriginalColumn = null;
                var lastOriginalName = null;
                this.walk(function (chunk, original) {
                  generated.code += chunk;
                  if (original.source !== null
                      && original.line !== null
                      && original.column !== null) {
                    if(lastOriginalSource !== original.source
                       || lastOriginalLine !== original.line
                       || lastOriginalColumn !== original.column
                       || lastOriginalName !== original.name) {
                      map.addMapping({
                        source: original.source,
                        original: {
                          line: original.line,
                          column: original.column
                        },
                        generated: {
                          line: generated.line,
                          column: generated.column
                        },
                        name: original.name
                      });
                    }
                    lastOriginalSource = original.source;
                    lastOriginalLine = original.line;
                    lastOriginalColumn = original.column;
                    lastOriginalName = original.name;
                    sourceMappingActive = true;
                  } else if (sourceMappingActive) {
                    map.addMapping({
                      generated: {
                        line: generated.line,
                        column: generated.column
                      }
                    });
                    lastOriginalSource = null;
                    sourceMappingActive = false;
                  }
                  for (var idx = 0, length = chunk.length; idx < length; idx++) {
                    if (chunk.charCodeAt(idx) === NEWLINE_CODE) {
                      generated.line++;
                      generated.column = 0;
                      // Mappings end at eol
                      if (idx + 1 === length) {
                        lastOriginalSource = null;
                        sourceMappingActive = false;
                      } else if (sourceMappingActive) {
                        map.addMapping({
                          source: original.source,
                          original: {
                            line: original.line,
                            column: original.column
                          },
                          generated: {
                            line: generated.line,
                            column: generated.column
                          },
                          name: original.name
                        });
                      }
                    } else {
                      generated.column++;
                    }
                  }
                });
                this.walkSourceContents(function (sourceFile, sourceContent) {
                  map.setSourceContent(sourceFile, sourceContent);
                });

                return { code: generated.code, map: map };
              };

              exports.SourceNode = SourceNode;
            }
            });

            var require$$0$45 = (sourceNode && typeof sourceNode === 'object' && 'default' in sourceNode ? sourceNode['default'] : sourceNode);

            var quickSort = __commonjs(function (module, exports) {
            /* -*- Mode: js; js-indent-level: 2; -*- */
            /*
             * Copyright 2011 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE or:
             * http://opensource.org/licenses/BSD-3-Clause
             */
            {
              // It turns out that some (most?) JavaScript engines don't self-host
              // `Array.prototype.sort`. This makes sense because C++ will likely remain
              // faster than JS when doing raw CPU-intensive sorting. However, when using a
              // custom comparator function, calling back and forth between the VM's C++ and
              // JIT'd JS is rather slow *and* loses JIT type information, resulting in
              // worse generated code for the comparator function than would be optimal. In
              // fact, when sorting with a comparator, these costs outweigh the benefits of
              // sorting in C++. By using our own JS-implemented Quick Sort (below), we get
              // a ~3500ms mean speed-up in `bench/bench.html`.

              /**
               * Swap the elements indexed by `x` and `y` in the array `ary`.
               *
               * @param {Array} ary
               *        The array.
               * @param {Number} x
               *        The index of the first item.
               * @param {Number} y
               *        The index of the second item.
               */
              function swap(ary, x, y) {
                var temp = ary[x];
                ary[x] = ary[y];
                ary[y] = temp;
              }

              /**
               * Returns a random integer within the range `low .. high` inclusive.
               *
               * @param {Number} low
               *        The lower bound on the range.
               * @param {Number} high
               *        The upper bound on the range.
               */
              function randomIntInRange(low, high) {
                return Math.round(low + (Math.random() * (high - low)));
              }

              /**
               * The Quick Sort algorithm.
               *
               * @param {Array} ary
               *        An array to sort.
               * @param {function} comparator
               *        Function to use to compare two items.
               * @param {Number} p
               *        Start index of the array
               * @param {Number} r
               *        End index of the array
               */
              function doQuickSort(ary, comparator, p, r) {
                // If our lower bound is less than our upper bound, we (1) partition the
                // array into two pieces and (2) recurse on each half. If it is not, this is
                // the empty array and our base case.

                if (p < r) {
                  // (1) Partitioning.
                  //
                  // The partitioning chooses a pivot between `p` and `r` and moves all
                  // elements that are less than or equal to the pivot to the before it, and
                  // all the elements that are greater than it after it. The effect is that
                  // once partition is done, the pivot is in the exact place it will be when
                  // the array is put in sorted order, and it will not need to be moved
                  // again. This runs in O(n) time.

                  // Always choose a random pivot so that an input array which is reverse
                  // sorted does not cause O(n^2) running time.
                  var pivotIndex = randomIntInRange(p, r);
                  var i = p - 1;

                  swap(ary, pivotIndex, r);
                  var pivot = ary[r];

                  // Immediately after `j` is incremented in this loop, the following hold
                  // true:
                  //
                  //   * Every element in `ary[p .. i]` is less than or equal to the pivot.
                  //
                  //   * Every element in `ary[i+1 .. j-1]` is greater than the pivot.
                  for (var j = p; j < r; j++) {
                    if (comparator(ary[j], pivot) <= 0) {
                      i += 1;
                      swap(ary, i, j);
                    }
                  }

                  swap(ary, i + 1, j);
                  var q = i + 1;

                  // (2) Recurse on each half.

                  doQuickSort(ary, comparator, p, q - 1);
                  doQuickSort(ary, comparator, q + 1, r);
                }
              }

              /**
               * Sort the given array in-place with the given comparator function.
               *
               * @param {Array} ary
               *        An array to sort.
               * @param {function} comparator
               *        Function to use to compare two items.
               */
              exports.quickSort = function (ary, comparator) {
                doQuickSort(ary, comparator, 0, ary.length - 1);
              };
            }
            });

            var require$$0$48 = (quickSort && typeof quickSort === 'object' && 'default' in quickSort ? quickSort['default'] : quickSort);
            var quickSort = quickSort.quickSort;

            var binarySearch = __commonjs(function (module, exports) {
            /* -*- Mode: js; js-indent-level: 2; -*- */
            /*
             * Copyright 2011 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE or:
             * http://opensource.org/licenses/BSD-3-Clause
             */
            {
              exports.GREATEST_LOWER_BOUND = 1;
              exports.LEAST_UPPER_BOUND = 2;

              /**
               * Recursive implementation of binary search.
               *
               * @param aLow Indices here and lower do not contain the needle.
               * @param aHigh Indices here and higher do not contain the needle.
               * @param aNeedle The element being searched for.
               * @param aHaystack The non-empty array being searched.
               * @param aCompare Function which takes two elements and returns -1, 0, or 1.
               * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
               *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
               *     closest element that is smaller than or greater than the one we are
               *     searching for, respectively, if the exact element cannot be found.
               */
              function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
                // This function terminates when one of the following is true:
                //
                //   1. We find the exact element we are looking for.
                //
                //   2. We did not find the exact element, but we can return the index of
                //      the next-closest element.
                //
                //   3. We did not find the exact element, and there is no next-closest
                //      element than the one we are searching for, so we return -1.
                var mid = Math.floor((aHigh - aLow) / 2) + aLow;
                var cmp = aCompare(aNeedle, aHaystack[mid], true);
                if (cmp === 0) {
                  // Found the element we are looking for.
                  return mid;
                }
                else if (cmp > 0) {
                  // Our needle is greater than aHaystack[mid].
                  if (aHigh - mid > 1) {
                    // The element is in the upper half.
                    return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
                  }

                  // The exact needle element was not found in this haystack. Determine if
                  // we are in termination case (3) or (2) and return the appropriate thing.
                  if (aBias == exports.LEAST_UPPER_BOUND) {
                    return aHigh < aHaystack.length ? aHigh : -1;
                  } else {
                    return mid;
                  }
                }
                else {
                  // Our needle is less than aHaystack[mid].
                  if (mid - aLow > 1) {
                    // The element is in the lower half.
                    return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
                  }

                  // we are in termination case (3) or (2) and return the appropriate thing.
                  if (aBias == exports.LEAST_UPPER_BOUND) {
                    return mid;
                  } else {
                    return aLow < 0 ? -1 : aLow;
                  }
                }
              }

              /**
               * This is an implementation of binary search which will always try and return
               * the index of the closest element if there is no exact hit. This is because
               * mappings between original and generated line/col pairs are single points,
               * and there is an implicit region between each of them, so a miss just means
               * that you aren't on the very start of a region.
               *
               * @param aNeedle The element you are looking for.
               * @param aHaystack The array that is being searched.
               * @param aCompare A function which takes the needle and an element in the
               *     array and returns -1, 0, or 1 depending on whether the needle is less
               *     than, equal to, or greater than the element, respectively.
               * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
               *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
               *     closest element that is smaller than or greater than the one we are
               *     searching for, respectively, if the exact element cannot be found.
               *     Defaults to 'binarySearch.GREATEST_LOWER_BOUND'.
               */
              exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
                if (aHaystack.length === 0) {
                  return -1;
                }

                var index = recursiveSearch(-1, aHaystack.length, aNeedle, aHaystack,
                                            aCompare, aBias || exports.GREATEST_LOWER_BOUND);
                if (index < 0) {
                  return -1;
                }

                // We have found either the exact element, or the next-closest element than
                // the one we are searching for. However, there may be more than one such
                // element. Make sure we always return the smallest of these.
                while (index - 1 >= 0) {
                  if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
                    break;
                  }
                  --index;
                }

                return index;
              };
            }
            });

            var require$$3$13 = (binarySearch && typeof binarySearch === 'object' && 'default' in binarySearch ? binarySearch['default'] : binarySearch);

            var sourceMapConsumer = __commonjs(function (module, exports) {
            /* -*- Mode: js; js-indent-level: 2; -*- */
            /*
             * Copyright 2011 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE or:
             * http://opensource.org/licenses/BSD-3-Clause
             */
            {
              var util = require$$4$13;
              var binarySearch = require$$3$13;
              var ArraySet = require$$2$13.ArraySet;
              var base64VLQ = require$$1$34;
              var quickSort = require$$0$48.quickSort;

              function SourceMapConsumer(aSourceMap) {
                var sourceMap = aSourceMap;
                if (typeof aSourceMap === 'string') {
                  sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
                }

                return sourceMap.sections != null
                  ? new IndexedSourceMapConsumer(sourceMap)
                  : new BasicSourceMapConsumer(sourceMap);
              }

              SourceMapConsumer.fromSourceMap = function(aSourceMap) {
                return BasicSourceMapConsumer.fromSourceMap(aSourceMap);
              }

              /**
               * The version of the source mapping spec that we are consuming.
               */
              SourceMapConsumer.prototype._version = 3;

              // `__generatedMappings` and `__originalMappings` are arrays that hold the
              // parsed mapping coordinates from the source map's "mappings" attribute. They
              // are lazily instantiated, accessed via the `_generatedMappings` and
              // `_originalMappings` getters respectively, and we only parse the mappings
              // and create these arrays once queried for a source location. We jump through
              // these hoops because there can be many thousands of mappings, and parsing
              // them is expensive, so we only want to do it if we must.
              //
              // Each object in the arrays is of the form:
              //
              //     {
              //       generatedLine: The line number in the generated code,
              //       generatedColumn: The column number in the generated code,
              //       source: The path to the original source file that generated this
              //               chunk of code,
              //       originalLine: The line number in the original source that
              //                     corresponds to this chunk of generated code,
              //       originalColumn: The column number in the original source that
              //                       corresponds to this chunk of generated code,
              //       name: The name of the original symbol which generated this chunk of
              //             code.
              //     }
              //
              // All properties except for `generatedLine` and `generatedColumn` can be
              // `null`.
              //
              // `_generatedMappings` is ordered by the generated positions.
              //
              // `_originalMappings` is ordered by the original positions.

              SourceMapConsumer.prototype.__generatedMappings = null;
              Object.defineProperty(SourceMapConsumer.prototype, '_generatedMappings', {
                get: function () {
                  if (!this.__generatedMappings) {
                    this._parseMappings(this._mappings, this.sourceRoot);
                  }

                  return this.__generatedMappings;
                }
              });

              SourceMapConsumer.prototype.__originalMappings = null;
              Object.defineProperty(SourceMapConsumer.prototype, '_originalMappings', {
                get: function () {
                  if (!this.__originalMappings) {
                    this._parseMappings(this._mappings, this.sourceRoot);
                  }

                  return this.__originalMappings;
                }
              });

              SourceMapConsumer.prototype._charIsMappingSeparator =
                function SourceMapConsumer_charIsMappingSeparator(aStr, index) {
                  var c = aStr.charAt(index);
                  return c === ";" || c === ",";
                };

              /**
               * Parse the mappings in a string in to a data structure which we can easily
               * query (the ordered arrays in the `this.__generatedMappings` and
               * `this.__originalMappings` properties).
               */
              SourceMapConsumer.prototype._parseMappings =
                function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
                  throw new Error("Subclasses must implement _parseMappings");
                };

              SourceMapConsumer.GENERATED_ORDER = 1;
              SourceMapConsumer.ORIGINAL_ORDER = 2;

              SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
              SourceMapConsumer.LEAST_UPPER_BOUND = 2;

              /**
               * Iterate over each mapping between an original source/line/column and a
               * generated line/column in this source map.
               *
               * @param Function aCallback
               *        The function that is called with each mapping.
               * @param Object aContext
               *        Optional. If specified, this object will be the value of `this` every
               *        time that `aCallback` is called.
               * @param aOrder
               *        Either `SourceMapConsumer.GENERATED_ORDER` or
               *        `SourceMapConsumer.ORIGINAL_ORDER`. Specifies whether you want to
               *        iterate over the mappings sorted by the generated file's line/column
               *        order or the original's source/line/column order, respectively. Defaults to
               *        `SourceMapConsumer.GENERATED_ORDER`.
               */
              SourceMapConsumer.prototype.eachMapping =
                function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
                  var context = aContext || null;
                  var order = aOrder || SourceMapConsumer.GENERATED_ORDER;

                  var mappings;
                  switch (order) {
                  case SourceMapConsumer.GENERATED_ORDER:
                    mappings = this._generatedMappings;
                    break;
                  case SourceMapConsumer.ORIGINAL_ORDER:
                    mappings = this._originalMappings;
                    break;
                  default:
                    throw new Error("Unknown order of iteration.");
                  }

                  var sourceRoot = this.sourceRoot;
                  mappings.map(function (mapping) {
                    var source = mapping.source === null ? null : this._sources.at(mapping.source);
                    if (source != null && sourceRoot != null) {
                      source = util.join(sourceRoot, source);
                    }
                    return {
                      source: source,
                      generatedLine: mapping.generatedLine,
                      generatedColumn: mapping.generatedColumn,
                      originalLine: mapping.originalLine,
                      originalColumn: mapping.originalColumn,
                      name: mapping.name === null ? null : this._names.at(mapping.name)
                    };
                  }, this).forEach(aCallback, context);
                };

              /**
               * Returns all generated line and column information for the original source,
               * line, and column provided. If no column is provided, returns all mappings
               * corresponding to a either the line we are searching for or the next
               * closest line that has any mappings. Otherwise, returns all mappings
               * corresponding to the given line and either the column we are searching for
               * or the next closest column that has any offsets.
               *
               * The only argument is an object with the following properties:
               *
               *   - source: The filename of the original source.
               *   - line: The line number in the original source.
               *   - column: Optional. the column number in the original source.
               *
               * and an array of objects is returned, each with the following properties:
               *
               *   - line: The line number in the generated source, or null.
               *   - column: The column number in the generated source, or null.
               */
              SourceMapConsumer.prototype.allGeneratedPositionsFor =
                function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
                  var line = util.getArg(aArgs, 'line');

                  // When there is no exact match, BasicSourceMapConsumer.prototype._findMapping
                  // returns the index of the closest mapping less than the needle. By
                  // setting needle.originalColumn to 0, we thus find the last mapping for
                  // the given line, provided such a mapping exists.
                  var needle = {
                    source: util.getArg(aArgs, 'source'),
                    originalLine: line,
                    originalColumn: util.getArg(aArgs, 'column', 0)
                  };

                  if (this.sourceRoot != null) {
                    needle.source = util.relative(this.sourceRoot, needle.source);
                  }
                  if (!this._sources.has(needle.source)) {
                    return [];
                  }
                  needle.source = this._sources.indexOf(needle.source);

                  var mappings = [];

                  var index = this._findMapping(needle,
                                                this._originalMappings,
                                                "originalLine",
                                                "originalColumn",
                                                util.compareByOriginalPositions,
                                                binarySearch.LEAST_UPPER_BOUND);
                  if (index >= 0) {
                    var mapping = this._originalMappings[index];

                    if (aArgs.column === undefined) {
                      var originalLine = mapping.originalLine;

                      // Iterate until either we run out of mappings, or we run into
                      // a mapping for a different line than the one we found. Since
                      // mappings are sorted, this is guaranteed to find all mappings for
                      // the line we found.
                      while (mapping && mapping.originalLine === originalLine) {
                        mappings.push({
                          line: util.getArg(mapping, 'generatedLine', null),
                          column: util.getArg(mapping, 'generatedColumn', null),
                          lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
                        });

                        mapping = this._originalMappings[++index];
                      }
                    } else {
                      var originalColumn = mapping.originalColumn;

                      // Iterate until either we run out of mappings, or we run into
                      // a mapping for a different line than the one we were searching for.
                      // Since mappings are sorted, this is guaranteed to find all mappings for
                      // the line we are searching for.
                      while (mapping &&
                             mapping.originalLine === line &&
                             mapping.originalColumn == originalColumn) {
                        mappings.push({
                          line: util.getArg(mapping, 'generatedLine', null),
                          column: util.getArg(mapping, 'generatedColumn', null),
                          lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
                        });

                        mapping = this._originalMappings[++index];
                      }
                    }
                  }

                  return mappings;
                };

              exports.SourceMapConsumer = SourceMapConsumer;

              /**
               * A BasicSourceMapConsumer instance represents a parsed source map which we can
               * query for information about the original file positions by giving it a file
               * position in the generated source.
               *
               * The only parameter is the raw source map (either as a JSON string, or
               * already parsed to an object). According to the spec, source maps have the
               * following attributes:
               *
               *   - version: Which version of the source map spec this map is following.
               *   - sources: An array of URLs to the original source files.
               *   - names: An array of identifiers which can be referrenced by individual mappings.
               *   - sourceRoot: Optional. The URL root from which all sources are relative.
               *   - sourcesContent: Optional. An array of contents of the original source files.
               *   - mappings: A string of base64 VLQs which contain the actual mappings.
               *   - file: Optional. The generated file this source map is associated with.
               *
               * Here is an example source map, taken from the source map spec[0]:
               *
               *     {
               *       version : 3,
               *       file: "out.js",
               *       sourceRoot : "",
               *       sources: ["foo.js", "bar.js"],
               *       names: ["src", "maps", "are", "fun"],
               *       mappings: "AA,AB;;ABCDE;"
               *     }
               *
               * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit?pli=1#
               */
              function BasicSourceMapConsumer(aSourceMap) {
                var sourceMap = aSourceMap;
                if (typeof aSourceMap === 'string') {
                  sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
                }

                var version = util.getArg(sourceMap, 'version');
                var sources = util.getArg(sourceMap, 'sources');
                // Sass 3.3 leaves out the 'names' array, so we deviate from the spec (which
                // requires the array) to play nice here.
                var names = util.getArg(sourceMap, 'names', []);
                var sourceRoot = util.getArg(sourceMap, 'sourceRoot', null);
                var sourcesContent = util.getArg(sourceMap, 'sourcesContent', null);
                var mappings = util.getArg(sourceMap, 'mappings');
                var file = util.getArg(sourceMap, 'file', null);

                // Once again, Sass deviates from the spec and supplies the version as a
                // string rather than a number, so we use loose equality checking here.
                if (version != this._version) {
                  throw new Error('Unsupported version: ' + version);
                }

                sources = sources
                  // Some source maps produce relative source paths like "./foo.js" instead of
                  // "foo.js".  Normalize these first so that future comparisons will succeed.
                  // See bugzil.la/1090768.
                  .map(util.normalize)
                  // Always ensure that absolute sources are internally stored relative to
                  // the source root, if the source root is absolute. Not doing this would
                  // be particularly problematic when the source root is a prefix of the
                  // source (valid, but why??). See github issue #199 and bugzil.la/1188982.
                  .map(function (source) {
                    return sourceRoot && util.isAbsolute(sourceRoot) && util.isAbsolute(source)
                      ? util.relative(sourceRoot, source)
                      : source;
                  });

                // Pass `true` below to allow duplicate names and sources. While source maps
                // are intended to be compressed and deduplicated, the TypeScript compiler
                // sometimes generates source maps with duplicates in them. See Github issue
                // #72 and bugzil.la/889492.
                this._names = ArraySet.fromArray(names, true);
                this._sources = ArraySet.fromArray(sources, true);

                this.sourceRoot = sourceRoot;
                this.sourcesContent = sourcesContent;
                this._mappings = mappings;
                this.file = file;
              }

              BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
              BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;

              /**
               * Create a BasicSourceMapConsumer from a SourceMapGenerator.
               *
               * @param SourceMapGenerator aSourceMap
               *        The source map that will be consumed.
               * @returns BasicSourceMapConsumer
               */
              BasicSourceMapConsumer.fromSourceMap =
                function SourceMapConsumer_fromSourceMap(aSourceMap) {
                  var smc = Object.create(BasicSourceMapConsumer.prototype);

                  var names = smc._names = ArraySet.fromArray(aSourceMap._names.toArray(), true);
                  var sources = smc._sources = ArraySet.fromArray(aSourceMap._sources.toArray(), true);
                  smc.sourceRoot = aSourceMap._sourceRoot;
                  smc.sourcesContent = aSourceMap._generateSourcesContent(smc._sources.toArray(),
                                                                          smc.sourceRoot);
                  smc.file = aSourceMap._file;

                  // Because we are modifying the entries (by converting string sources and
                  // names to indices into the sources and names ArraySets), we have to make
                  // a copy of the entry or else bad things happen. Shared mutable state
                  // strikes again! See github issue #191.

                  var generatedMappings = aSourceMap._mappings.toArray().slice();
                  var destGeneratedMappings = smc.__generatedMappings = [];
                  var destOriginalMappings = smc.__originalMappings = [];

                  for (var i = 0, length = generatedMappings.length; i < length; i++) {
                    var srcMapping = generatedMappings[i];
                    var destMapping = new Mapping;
                    destMapping.generatedLine = srcMapping.generatedLine;
                    destMapping.generatedColumn = srcMapping.generatedColumn;

                    if (srcMapping.source) {
                      destMapping.source = sources.indexOf(srcMapping.source);
                      destMapping.originalLine = srcMapping.originalLine;
                      destMapping.originalColumn = srcMapping.originalColumn;

                      if (srcMapping.name) {
                        destMapping.name = names.indexOf(srcMapping.name);
                      }

                      destOriginalMappings.push(destMapping);
                    }

                    destGeneratedMappings.push(destMapping);
                  }

                  quickSort(smc.__originalMappings, util.compareByOriginalPositions);

                  return smc;
                };

              /**
               * The version of the source mapping spec that we are consuming.
               */
              BasicSourceMapConsumer.prototype._version = 3;

              /**
               * The list of original sources.
               */
              Object.defineProperty(BasicSourceMapConsumer.prototype, 'sources', {
                get: function () {
                  return this._sources.toArray().map(function (s) {
                    return this.sourceRoot != null ? util.join(this.sourceRoot, s) : s;
                  }, this);
                }
              });

              /**
               * Provide the JIT with a nice shape / hidden class.
               */
              function Mapping() {
                this.generatedLine = 0;
                this.generatedColumn = 0;
                this.source = null;
                this.originalLine = null;
                this.originalColumn = null;
                this.name = null;
              }

              /**
               * Parse the mappings in a string in to a data structure which we can easily
               * query (the ordered arrays in the `this.__generatedMappings` and
               * `this.__originalMappings` properties).
               */
              BasicSourceMapConsumer.prototype._parseMappings =
                function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
                  var generatedLine = 1;
                  var previousGeneratedColumn = 0;
                  var previousOriginalLine = 0;
                  var previousOriginalColumn = 0;
                  var previousSource = 0;
                  var previousName = 0;
                  var length = aStr.length;
                  var index = 0;
                  var cachedSegments = {};
                  var temp = {};
                  var originalMappings = [];
                  var generatedMappings = [];
                  var mapping, str, segment, end, value;

                  while (index < length) {
                    if (aStr.charAt(index) === ';') {
                      generatedLine++;
                      index++;
                      previousGeneratedColumn = 0;
                    }
                    else if (aStr.charAt(index) === ',') {
                      index++;
                    }
                    else {
                      mapping = new Mapping();
                      mapping.generatedLine = generatedLine;

                      // Because each offset is encoded relative to the previous one,
                      // many segments often have the same encoding. We can exploit this
                      // fact by caching the parsed variable length fields of each segment,
                      // allowing us to avoid a second parse if we encounter the same
                      // segment again.
                      for (end = index; end < length; end++) {
                        if (this._charIsMappingSeparator(aStr, end)) {
                          break;
                        }
                      }
                      str = aStr.slice(index, end);

                      segment = cachedSegments[str];
                      if (segment) {
                        index += str.length;
                      } else {
                        segment = [];
                        while (index < end) {
                          base64VLQ.decode(aStr, index, temp);
                          value = temp.value;
                          index = temp.rest;
                          segment.push(value);
                        }

                        if (segment.length === 2) {
                          throw new Error('Found a source, but no line and column');
                        }

                        if (segment.length === 3) {
                          throw new Error('Found a source and line, but no column');
                        }

                        cachedSegments[str] = segment;
                      }

                      // Generated column.
                      mapping.generatedColumn = previousGeneratedColumn + segment[0];
                      previousGeneratedColumn = mapping.generatedColumn;

                      if (segment.length > 1) {
                        // Original source.
                        mapping.source = previousSource + segment[1];
                        previousSource += segment[1];

                        // Original line.
                        mapping.originalLine = previousOriginalLine + segment[2];
                        previousOriginalLine = mapping.originalLine;
                        // Lines are stored 0-based
                        mapping.originalLine += 1;

                        // Original column.
                        mapping.originalColumn = previousOriginalColumn + segment[3];
                        previousOriginalColumn = mapping.originalColumn;

                        if (segment.length > 4) {
                          // Original name.
                          mapping.name = previousName + segment[4];
                          previousName += segment[4];
                        }
                      }

                      generatedMappings.push(mapping);
                      if (typeof mapping.originalLine === 'number') {
                        originalMappings.push(mapping);
                      }
                    }
                  }

                  quickSort(generatedMappings, util.compareByGeneratedPositionsDeflated);
                  this.__generatedMappings = generatedMappings;

                  quickSort(originalMappings, util.compareByOriginalPositions);
                  this.__originalMappings = originalMappings;
                };

              /**
               * Find the mapping that best matches the hypothetical "needle" mapping that
               * we are searching for in the given "haystack" of mappings.
               */
              BasicSourceMapConsumer.prototype._findMapping =
                function SourceMapConsumer_findMapping(aNeedle, aMappings, aLineName,
                                                       aColumnName, aComparator, aBias) {
                  // To return the position we are searching for, we must first find the
                  // mapping for the given position and then return the opposite position it
                  // points to. Because the mappings are sorted, we can use binary search to
                  // find the best mapping.

                  if (aNeedle[aLineName] <= 0) {
                    throw new TypeError('Line must be greater than or equal to 1, got '
                                        + aNeedle[aLineName]);
                  }
                  if (aNeedle[aColumnName] < 0) {
                    throw new TypeError('Column must be greater than or equal to 0, got '
                                        + aNeedle[aColumnName]);
                  }

                  return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
                };

              /**
               * Compute the last column for each generated mapping. The last column is
               * inclusive.
               */
              BasicSourceMapConsumer.prototype.computeColumnSpans =
                function SourceMapConsumer_computeColumnSpans() {
                  for (var index = 0; index < this._generatedMappings.length; ++index) {
                    var mapping = this._generatedMappings[index];

                    // Mappings do not contain a field for the last generated columnt. We
                    // can come up with an optimistic estimate, however, by assuming that
                    // mappings are contiguous (i.e. given two consecutive mappings, the
                    // first mapping ends where the second one starts).
                    if (index + 1 < this._generatedMappings.length) {
                      var nextMapping = this._generatedMappings[index + 1];

                      if (mapping.generatedLine === nextMapping.generatedLine) {
                        mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
                        continue;
                      }
                    }

                    // The last mapping for each line spans the entire line.
                    mapping.lastGeneratedColumn = Infinity;
                  }
                };

              /**
               * Returns the original source, line, and column information for the generated
               * source's line and column positions provided. The only argument is an object
               * with the following properties:
               *
               *   - line: The line number in the generated source.
               *   - column: The column number in the generated source.
               *   - bias: Either 'SourceMapConsumer.GREATEST_LOWER_BOUND' or
               *     'SourceMapConsumer.LEAST_UPPER_BOUND'. Specifies whether to return the
               *     closest element that is smaller than or greater than the one we are
               *     searching for, respectively, if the exact element cannot be found.
               *     Defaults to 'SourceMapConsumer.GREATEST_LOWER_BOUND'.
               *
               * and an object is returned with the following properties:
               *
               *   - source: The original source file, or null.
               *   - line: The line number in the original source, or null.
               *   - column: The column number in the original source, or null.
               *   - name: The original identifier, or null.
               */
              BasicSourceMapConsumer.prototype.originalPositionFor =
                function SourceMapConsumer_originalPositionFor(aArgs) {
                  var needle = {
                    generatedLine: util.getArg(aArgs, 'line'),
                    generatedColumn: util.getArg(aArgs, 'column')
                  };

                  var index = this._findMapping(
                    needle,
                    this._generatedMappings,
                    "generatedLine",
                    "generatedColumn",
                    util.compareByGeneratedPositionsDeflated,
                    util.getArg(aArgs, 'bias', SourceMapConsumer.GREATEST_LOWER_BOUND)
                  );

                  if (index >= 0) {
                    var mapping = this._generatedMappings[index];

                    if (mapping.generatedLine === needle.generatedLine) {
                      var source = util.getArg(mapping, 'source', null);
                      if (source !== null) {
                        source = this._sources.at(source);
                        if (this.sourceRoot != null) {
                          source = util.join(this.sourceRoot, source);
                        }
                      }
                      var name = util.getArg(mapping, 'name', null);
                      if (name !== null) {
                        name = this._names.at(name);
                      }
                      return {
                        source: source,
                        line: util.getArg(mapping, 'originalLine', null),
                        column: util.getArg(mapping, 'originalColumn', null),
                        name: name
                      };
                    }
                  }

                  return {
                    source: null,
                    line: null,
                    column: null,
                    name: null
                  };
                };

              /**
               * Return true if we have the source content for every source in the source
               * map, false otherwise.
               */
              BasicSourceMapConsumer.prototype.hasContentsOfAllSources =
                function BasicSourceMapConsumer_hasContentsOfAllSources() {
                  if (!this.sourcesContent) {
                    return false;
                  }
                  return this.sourcesContent.length >= this._sources.size() &&
                    !this.sourcesContent.some(function (sc) { return sc == null; });
                };

              /**
               * Returns the original source content. The only argument is the url of the
               * original source file. Returns null if no original source content is
               * available.
               */
              BasicSourceMapConsumer.prototype.sourceContentFor =
                function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
                  if (!this.sourcesContent) {
                    return null;
                  }

                  if (this.sourceRoot != null) {
                    aSource = util.relative(this.sourceRoot, aSource);
                  }

                  if (this._sources.has(aSource)) {
                    return this.sourcesContent[this._sources.indexOf(aSource)];
                  }

                  var url;
                  if (this.sourceRoot != null
                      && (url = util.urlParse(this.sourceRoot))) {
                    // XXX: file:// URIs and absolute paths lead to unexpected behavior for
                    // many users. We can help them out when they expect file:// URIs to
                    // behave like it would if they were running a local HTTP server. See
                    // https://bugzilla.mozilla.org/show_bug.cgi?id=885597.
                    var fileUriAbsPath = aSource.replace(/^file:\/\//, "");
                    if (url.scheme == "file"
                        && this._sources.has(fileUriAbsPath)) {
                      return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)]
                    }

                    if ((!url.path || url.path == "/")
                        && this._sources.has("/" + aSource)) {
                      return this.sourcesContent[this._sources.indexOf("/" + aSource)];
                    }
                  }

                  // This function is used recursively from
                  // IndexedSourceMapConsumer.prototype.sourceContentFor. In that case, we
                  // don't want to throw if we can't find the source - we just want to
                  // return null, so we provide a flag to exit gracefully.
                  if (nullOnMissing) {
                    return null;
                  }
                  else {
                    throw new Error('"' + aSource + '" is not in the SourceMap.');
                  }
                };

              /**
               * Returns the generated line and column information for the original source,
               * line, and column positions provided. The only argument is an object with
               * the following properties:
               *
               *   - source: The filename of the original source.
               *   - line: The line number in the original source.
               *   - column: The column number in the original source.
               *   - bias: Either 'SourceMapConsumer.GREATEST_LOWER_BOUND' or
               *     'SourceMapConsumer.LEAST_UPPER_BOUND'. Specifies whether to return the
               *     closest element that is smaller than or greater than the one we are
               *     searching for, respectively, if the exact element cannot be found.
               *     Defaults to 'SourceMapConsumer.GREATEST_LOWER_BOUND'.
               *
               * and an object is returned with the following properties:
               *
               *   - line: The line number in the generated source, or null.
               *   - column: The column number in the generated source, or null.
               */
              BasicSourceMapConsumer.prototype.generatedPositionFor =
                function SourceMapConsumer_generatedPositionFor(aArgs) {
                  var source = util.getArg(aArgs, 'source');
                  if (this.sourceRoot != null) {
                    source = util.relative(this.sourceRoot, source);
                  }
                  if (!this._sources.has(source)) {
                    return {
                      line: null,
                      column: null,
                      lastColumn: null
                    };
                  }
                  source = this._sources.indexOf(source);

                  var needle = {
                    source: source,
                    originalLine: util.getArg(aArgs, 'line'),
                    originalColumn: util.getArg(aArgs, 'column')
                  };

                  var index = this._findMapping(
                    needle,
                    this._originalMappings,
                    "originalLine",
                    "originalColumn",
                    util.compareByOriginalPositions,
                    util.getArg(aArgs, 'bias', SourceMapConsumer.GREATEST_LOWER_BOUND)
                  );

                  if (index >= 0) {
                    var mapping = this._originalMappings[index];

                    if (mapping.source === needle.source) {
                      return {
                        line: util.getArg(mapping, 'generatedLine', null),
                        column: util.getArg(mapping, 'generatedColumn', null),
                        lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
                      };
                    }
                  }

                  return {
                    line: null,
                    column: null,
                    lastColumn: null
                  };
                };

              exports.BasicSourceMapConsumer = BasicSourceMapConsumer;

              /**
               * An IndexedSourceMapConsumer instance represents a parsed source map which
               * we can query for information. It differs from BasicSourceMapConsumer in
               * that it takes "indexed" source maps (i.e. ones with a "sections" field) as
               * input.
               *
               * The only parameter is a raw source map (either as a JSON string, or already
               * parsed to an object). According to the spec for indexed source maps, they
               * have the following attributes:
               *
               *   - version: Which version of the source map spec this map is following.
               *   - file: Optional. The generated file this source map is associated with.
               *   - sections: A list of section definitions.
               *
               * Each value under the "sections" field has two fields:
               *   - offset: The offset into the original specified at which this section
               *       begins to apply, defined as an object with a "line" and "column"
               *       field.
               *   - map: A source map definition. This source map could also be indexed,
               *       but doesn't have to be.
               *
               * Instead of the "map" field, it's also possible to have a "url" field
               * specifying a URL to retrieve a source map from, but that's currently
               * unsupported.
               *
               * Here's an example source map, taken from the source map spec[0], but
               * modified to omit a section which uses the "url" field.
               *
               *  {
               *    version : 3,
               *    file: "app.js",
               *    sections: [{
               *      offset: {line:100, column:10},
               *      map: {
               *        version : 3,
               *        file: "section.js",
               *        sources: ["foo.js", "bar.js"],
               *        names: ["src", "maps", "are", "fun"],
               *        mappings: "AAAA,E;;ABCDE;"
               *      }
               *    }],
               *  }
               *
               * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit#heading=h.535es3xeprgt
               */
              function IndexedSourceMapConsumer(aSourceMap) {
                var sourceMap = aSourceMap;
                if (typeof aSourceMap === 'string') {
                  sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
                }

                var version = util.getArg(sourceMap, 'version');
                var sections = util.getArg(sourceMap, 'sections');

                if (version != this._version) {
                  throw new Error('Unsupported version: ' + version);
                }

                this._sources = new ArraySet();
                this._names = new ArraySet();

                var lastOffset = {
                  line: -1,
                  column: 0
                };
                this._sections = sections.map(function (s) {
                  if (s.url) {
                    // The url field will require support for asynchronicity.
                    // See https://github.com/mozilla/source-map/issues/16
                    throw new Error('Support for url field in sections not implemented.');
                  }
                  var offset = util.getArg(s, 'offset');
                  var offsetLine = util.getArg(offset, 'line');
                  var offsetColumn = util.getArg(offset, 'column');

                  if (offsetLine < lastOffset.line ||
                      (offsetLine === lastOffset.line && offsetColumn < lastOffset.column)) {
                    throw new Error('Section offsets must be ordered and non-overlapping.');
                  }
                  lastOffset = offset;

                  return {
                    generatedOffset: {
                      // The offset fields are 0-based, but we use 1-based indices when
                      // encoding/decoding from VLQ.
                      generatedLine: offsetLine + 1,
                      generatedColumn: offsetColumn + 1
                    },
                    consumer: new SourceMapConsumer(util.getArg(s, 'map'))
                  }
                });
              }

              IndexedSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
              IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer;

              /**
               * The version of the source mapping spec that we are consuming.
               */
              IndexedSourceMapConsumer.prototype._version = 3;

              /**
               * The list of original sources.
               */
              Object.defineProperty(IndexedSourceMapConsumer.prototype, 'sources', {
                get: function () {
                  var sources = [];
                  for (var i = 0; i < this._sections.length; i++) {
                    for (var j = 0; j < this._sections[i].consumer.sources.length; j++) {
                      sources.push(this._sections[i].consumer.sources[j]);
                    }
                  }
                  return sources;
                }
              });

              /**
               * Returns the original source, line, and column information for the generated
               * source's line and column positions provided. The only argument is an object
               * with the following properties:
               *
               *   - line: The line number in the generated source.
               *   - column: The column number in the generated source.
               *
               * and an object is returned with the following properties:
               *
               *   - source: The original source file, or null.
               *   - line: The line number in the original source, or null.
               *   - column: The column number in the original source, or null.
               *   - name: The original identifier, or null.
               */
              IndexedSourceMapConsumer.prototype.originalPositionFor =
                function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
                  var needle = {
                    generatedLine: util.getArg(aArgs, 'line'),
                    generatedColumn: util.getArg(aArgs, 'column')
                  };

                  // Find the section containing the generated position we're trying to map
                  // to an original position.
                  var sectionIndex = binarySearch.search(needle, this._sections,
                    function(needle, section) {
                      var cmp = needle.generatedLine - section.generatedOffset.generatedLine;
                      if (cmp) {
                        return cmp;
                      }

                      return (needle.generatedColumn -
                              section.generatedOffset.generatedColumn);
                    });
                  var section = this._sections[sectionIndex];

                  if (!section) {
                    return {
                      source: null,
                      line: null,
                      column: null,
                      name: null
                    };
                  }

                  return section.consumer.originalPositionFor({
                    line: needle.generatedLine -
                      (section.generatedOffset.generatedLine - 1),
                    column: needle.generatedColumn -
                      (section.generatedOffset.generatedLine === needle.generatedLine
                       ? section.generatedOffset.generatedColumn - 1
                       : 0),
                    bias: aArgs.bias
                  });
                };

              /**
               * Return true if we have the source content for every source in the source
               * map, false otherwise.
               */
              IndexedSourceMapConsumer.prototype.hasContentsOfAllSources =
                function IndexedSourceMapConsumer_hasContentsOfAllSources() {
                  return this._sections.every(function (s) {
                    return s.consumer.hasContentsOfAllSources();
                  });
                };

              /**
               * Returns the original source content. The only argument is the url of the
               * original source file. Returns null if no original source content is
               * available.
               */
              IndexedSourceMapConsumer.prototype.sourceContentFor =
                function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
                  for (var i = 0; i < this._sections.length; i++) {
                    var section = this._sections[i];

                    var content = section.consumer.sourceContentFor(aSource, true);
                    if (content) {
                      return content;
                    }
                  }
                  if (nullOnMissing) {
                    return null;
                  }
                  else {
                    throw new Error('"' + aSource + '" is not in the SourceMap.');
                  }
                };

              /**
               * Returns the generated line and column information for the original source,
               * line, and column positions provided. The only argument is an object with
               * the following properties:
               *
               *   - source: The filename of the original source.
               *   - line: The line number in the original source.
               *   - column: The column number in the original source.
               *
               * and an object is returned with the following properties:
               *
               *   - line: The line number in the generated source, or null.
               *   - column: The column number in the generated source, or null.
               */
              IndexedSourceMapConsumer.prototype.generatedPositionFor =
                function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
                  for (var i = 0; i < this._sections.length; i++) {
                    var section = this._sections[i];

                    // Only consider this section if the requested source is in the list of
                    // sources of the consumer.
                    if (section.consumer.sources.indexOf(util.getArg(aArgs, 'source')) === -1) {
                      continue;
                    }
                    var generatedPosition = section.consumer.generatedPositionFor(aArgs);
                    if (generatedPosition) {
                      var ret = {
                        line: generatedPosition.line +
                          (section.generatedOffset.generatedLine - 1),
                        column: generatedPosition.column +
                          (section.generatedOffset.generatedLine === generatedPosition.line
                           ? section.generatedOffset.generatedColumn - 1
                           : 0)
                      };
                      return ret;
                    }
                  }

                  return {
                    line: null,
                    column: null
                  };
                };

              /**
               * Parse the mappings in a string in to a data structure which we can easily
               * query (the ordered arrays in the `this.__generatedMappings` and
               * `this.__originalMappings` properties).
               */
              IndexedSourceMapConsumer.prototype._parseMappings =
                function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
                  this.__generatedMappings = [];
                  this.__originalMappings = [];
                  for (var i = 0; i < this._sections.length; i++) {
                    var section = this._sections[i];
                    var sectionMappings = section.consumer._generatedMappings;
                    for (var j = 0; j < sectionMappings.length; j++) {
                      var mapping = sectionMappings[j];

                      var source = section.consumer._sources.at(mapping.source);
                      if (section.consumer.sourceRoot !== null) {
                        source = util.join(section.consumer.sourceRoot, source);
                      }
                      this._sources.add(source);
                      source = this._sources.indexOf(source);

                      var name = section.consumer._names.at(mapping.name);
                      this._names.add(name);
                      name = this._names.indexOf(name);

                      // The mappings coming from the consumer for the section have
                      // generated positions relative to the start of the section, so we
                      // need to offset them to be relative to the start of the concatenated
                      // generated file.
                      var adjustedMapping = {
                        source: source,
                        generatedLine: mapping.generatedLine +
                          (section.generatedOffset.generatedLine - 1),
                        generatedColumn: mapping.generatedColumn +
                          (section.generatedOffset.generatedLine === mapping.generatedLine
                          ? section.generatedOffset.generatedColumn - 1
                          : 0),
                        originalLine: mapping.originalLine,
                        originalColumn: mapping.originalColumn,
                        name: name
                      };

                      this.__generatedMappings.push(adjustedMapping);
                      if (typeof adjustedMapping.originalLine === 'number') {
                        this.__originalMappings.push(adjustedMapping);
                      }
                    }
                  }

                  quickSort(this.__generatedMappings, util.compareByGeneratedPositionsDeflated);
                  quickSort(this.__originalMappings, util.compareByOriginalPositions);
                };

              exports.IndexedSourceMapConsumer = IndexedSourceMapConsumer;
            }
            });

            var require$$1$35 = (sourceMapConsumer && typeof sourceMapConsumer === 'object' && 'default' in sourceMapConsumer ? sourceMapConsumer['default'] : sourceMapConsumer);

            var sourceMap = __commonjs(function (module, exports) {
            /*
             * Copyright 2009-2011 Mozilla Foundation and contributors
             * Licensed under the New BSD license. See LICENSE.txt or:
             * http://opensource.org/licenses/BSD-3-Clause
             */
            exports.SourceMapGenerator = require$$1$33.SourceMapGenerator;
            exports.SourceMapConsumer = require$$1$35.SourceMapConsumer;
            exports.SourceNode = require$$0$45.SourceNode;
            });

            var SourceNode = sourceMap.SourceNode;

            var ASTNode = function () {
            	function ASTNode(line, col, props) {
            		babelHelpers.classCallCheck(this, ASTNode);

            		if ((typeof line === "undefined" ? "undefined" : babelHelpers.typeof(line)) === "object" && col == null && props == null) {
            			var _ref = [line, null];
            			props = _ref[0];
            			line = _ref[1];
            		}

            		this._line = typeof line === "number" ? line : 0;
            		this._column = typeof col === "number" ? col : 0;
            		_assign(this, props);
            	}

            	babelHelpers.createClass(ASTNode, [{
            		key: "_sn",
            		value: function _sn(file, chunk) {
            			return new SourceNode(this._line, this._column, file, chunk);
            		}
            	}, {
            		key: "start",
            		value: function start(data) {
            			this._writer = {
            				chunks: [],
            				data: data
            			};

            			return this;
            		}
            	}, {
            		key: "_normalize_indent",
            		value: function _normalize_indent() {
            			var d = this._writer.data;
            			if (typeof d.indent === "string") d.tabchar = d.indent;
            			if (d.indent !== false && typeof d.indent !== "number") d.indent = 0;
            		}
            	}, {
            		key: "indent",
            		value: function indent() {
            			this._normalize_indent();
            			var d = this._writer.data;
            			if (typeof d.indent === "number") d.indent++;
            			return this;
            		}
            	}, {
            		key: "outdent",
            		value: function outdent() {
            			this._normalize_indent();
            			var d = this._writer.data;
            			if (typeof d.indent === "number" && d.indent > 0) d.indent--;
            			return this;
            		}
            	}, {
            		key: "tabs",
            		value: function tabs() {
            			this._normalize_indent();

            			var res = "";
            			var d = this._writer.data;
            			var tabchar = d.tabchar;
            			if (tabchar == null) tabchar = "  ";

            			if (typeof d.indent === "number") {
            				for (var i = 0; i < d.indent; i++) {
            					res += tabchar;
            				}
            			}

            			return res;
            		}
            	}, {
            		key: "write",
            		value: function write(chunk) {
            			this.push([].concat(this.tabs(), chunk, "\n"));
            			return this;
            		}
            	}, {
            		key: "push",
            		value: function push(chunk) {
            			this._writer.chunks.push(chunk);
            			return this;
            		}
            	}, {
            		key: "end",
            		value: function end(chunk) {
            			if (chunk) this.write(chunk);
            			var w = this._writer;
            			delete this._writer;
            			return this._sn(w.data.filename, w.chunks);
            		}
            	}, {
            		key: "compile",
            		value: function compile() {
            			throw new Error("Not implemented.");
            			// return this._sn(data.filename);
            		}
            	}, {
            		key: "toJSON",
            		value: function toJSON() {
            			var _this = this;

            			var out = {};
            			Object.keys(this).forEach(function (k) {
            				if (k[0] === "_") return;
            				out[k] = _this[k];
            			});
            			_assign(out, _pick(this, "_line", "_column"));
            		}
            	}]);
            	return ASTNode;
            }();

            var uniqueId = __commonjs(function (module) {
            var toString = require$$0$24;

            /** Used to generate unique IDs. */
            var idCounter = 0;

            /**
             * Generates a unique ID. If `prefix` is given the ID is appended to it.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Util
             * @param {string} [prefix=''] The value to prefix the ID with.
             * @returns {string} Returns the unique ID.
             * @example
             *
             * _.uniqueId('contact_');
             * // => 'contact_104'
             *
             * _.uniqueId();
             * // => '105'
             */
            function uniqueId(prefix) {
              var id = ++idCounter;
              return toString(prefix) + id;
            }

            module.exports = uniqueId;
            });

            var _uniqueId = (uniqueId && typeof uniqueId === 'object' && 'default' in uniqueId ? uniqueId['default'] : uniqueId);

            var _baseSlice = __commonjs(function (module) {
            /**
             * The base implementation of `_.slice` without an iteratee call guard.
             *
             * @private
             * @param {Array} array The array to slice.
             * @param {number} [start=0] The start position.
             * @param {number} [end=array.length] The end position.
             * @returns {Array} Returns the slice of `array`.
             */
            function baseSlice(array, start, end) {
              var index = -1,
                  length = array.length;

              if (start < 0) {
                start = -start > length ? 0 : (length + start);
              }
              end = end > length ? length : end;
              if (end < 0) {
                end += length;
              }
              length = start > end ? 0 : ((end - start) >>> 0);
              start >>>= 0;

              var result = Array(length);
              while (++index < length) {
                result[index] = array[index + start];
              }
              return result;
            }

            module.exports = baseSlice;
            });

            var require$$0$50 = (_baseSlice && typeof _baseSlice === 'object' && 'default' in _baseSlice ? _baseSlice['default'] : _baseSlice);

            var _parent = __commonjs(function (module) {
            var baseGet = require$$1$13,
                baseSlice = require$$0$50;

            /**
             * Gets the parent value at `path` of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array} path The path to get the parent value of.
             * @returns {*} Returns the parent value.
             */
            function parent(object, path) {
              return path.length == 1 ? object : baseGet(object, baseSlice(path, 0, -1));
            }

            module.exports = parent;
            });

            var require$$0$49 = (_parent && typeof _parent === 'object' && 'default' in _parent ? _parent['default'] : _parent);

            var last = __commonjs(function (module) {
            /**
             * Gets the last element of `array`.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Array
             * @param {Array} array The array to query.
             * @returns {*} Returns the last element of `array`.
             * @example
             *
             * _.last([1, 2, 3]);
             * // => 3
             */
            function last(array) {
              var length = array ? array.length : 0;
              return length ? array[length - 1] : undefined;
            }

            module.exports = last;
            });

            var _last = (last && typeof last === 'object' && 'default' in last ? last['default'] : last);

            var _baseInvoke = __commonjs(function (module) {
            var apply = require$$4,
                baseCastPath = require$$3$4,
                isKey = require$$2$5,
                last = _last,
                parent = require$$0$49;

            /**
             * The base implementation of `_.invoke` without support for individual
             * method arguments.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array|string} path The path of the method to invoke.
             * @param {Array} args The arguments to invoke the method with.
             * @returns {*} Returns the result of the invoked method.
             */
            function baseInvoke(object, path, args) {
              if (!isKey(path, object)) {
                path = baseCastPath(path);
                object = parent(object, path);
                path = last(path);
              }
              var func = object == null ? object : object[path];
              return func == null ? undefined : apply(func, object, args);
            }

            module.exports = baseInvoke;
            });

            var require$$3$14 = (_baseInvoke && typeof _baseInvoke === 'object' && 'default' in _baseInvoke ? _baseInvoke['default'] : _baseInvoke);

            var invokeMap = __commonjs(function (module) {
            var apply = require$$4,
                baseEach = require$$4$10,
                baseInvoke = require$$3$14,
                isArrayLike = require$$0$5,
                isKey = require$$2$5,
                rest = require$$0;

            /**
             * Invokes the method at `path` of each element in `collection`, returning
             * an array of the results of each invoked method. Any additional arguments
             * are provided to each invoked method. If `methodName` is a function it's
             * invoked for, and `this` bound to, each element in `collection`.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Collection
             * @param {Array|Object} collection The collection to iterate over.
             * @param {Array|Function|string} path The path of the method to invoke or
             *  the function invoked per iteration.
             * @param {...*} [args] The arguments to invoke each method with.
             * @returns {Array} Returns the array of results.
             * @example
             *
             * _.invokeMap([[5, 1, 7], [3, 2, 1]], 'sort');
             * // => [[1, 5, 7], [1, 2, 3]]
             *
             * _.invokeMap([123, 456], String.prototype.split, '');
             * // => [['1', '2', '3'], ['4', '5', '6']]
             */
            var invokeMap = rest(function(collection, path, args) {
              var index = -1,
                  isFunc = typeof path == 'function',
                  isProp = isKey(path),
                  result = isArrayLike(collection) ? Array(collection.length) : [];

              baseEach(collection, function(value) {
                var func = isFunc ? path : ((isProp && value != null) ? value[path] : undefined);
                result[++index] = func ? apply(func, value, args) : baseInvoke(value, path, args);
              });
              return result;
            });

            module.exports = invokeMap;
            });

            var _invokeMap = (invokeMap && typeof invokeMap === 'object' && 'default' in invokeMap ? invokeMap['default'] : invokeMap);

            var File = function (_Node) {
            	babelHelpers.inherits(File, _Node);

            	function File() {
            		babelHelpers.classCallCheck(this, File);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(File).apply(this, arguments));
            	}

            	babelHelpers.createClass(File, [{
            		key: "compile",
            		value: function compile(data) {
            			data = _assign({}, data, {
            				filename: this.filename || _uniqueId("template") + ".html",
            				headers: []
            			});

            			this.start(data);
            			this.push(_invokeMap(this.children, "compile", data));

            			var source = this.end();
            			if (this.source) source.setSourceContent(data.filename, this.source);

            			return source;
            		}
            	}]);
            	return File;
            }(ASTNode);

            // Copyright Joyent, Inc. and other Node contributors.
            //
            // Permission is hereby granted, free of charge, to any person obtaining a
            // copy of this software and associated documentation files (the
            // "Software"), to deal in the Software without restriction, including
            // without limitation the rights to use, copy, modify, merge, publish,
            // distribute, sublicense, and/or sell copies of the Software, and to permit
            // persons to whom the Software is furnished to do so, subject to the
            // following conditions:
            //
            // The above copyright notice and this permission notice shall be included
            // in all copies or substantial portions of the Software.
            //
            // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
            // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
            // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
            // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
            // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
            // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
            // USE OR OTHER DEALINGS IN THE SOFTWARE.

            // resolves . and .. elements in a path array with directory names there
            // must be no slashes, empty elements, or device names (c:\) in the array
            // (so also no leading and trailing slashes - it does not distinguish
            // relative and absolute paths)
            function normalizeArray(parts, allowAboveRoot) {
              // if the path tries to go above the root, `up` ends up > 0
              var up = 0;
              for (var i = parts.length - 1; i >= 0; i--) {
                var last = parts[i];
                if (last === '.') {
                  parts.splice(i, 1);
                } else if (last === '..') {
                  parts.splice(i, 1);
                  up++;
                } else if (up) {
                  parts.splice(i, 1);
                  up--;
                }
              }

              // if the path is allowed to go above the root, restore leading ..s
              if (allowAboveRoot) {
                for (; up--; up) {
                  parts.unshift('..');
                }
              }

              return parts;
            }

            // Split a filename into [root, dir, basename, ext], unix version
            // 'root' is just a slash, or nothing.
            var splitPathRe =
                /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
            var splitPath = function(filename) {
              return splitPathRe.exec(filename).slice(1);
            };

            // path.resolve([from ...], to)
            // posix version
            function resolve() {
              var resolvedPath = '',
                  resolvedAbsolute = false;

              for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
                var path = (i >= 0) ? arguments[i] : process.cwd();

                // Skip empty and invalid entries
                if (typeof path !== 'string') {
                  throw new TypeError('Arguments to path.resolve must be strings');
                } else if (!path) {
                  continue;
                }

                resolvedPath = path + '/' + resolvedPath;
                resolvedAbsolute = path.charAt(0) === '/';
              }

              // At this point the path should be resolved to a full absolute path, but
              // handle relative paths to be safe (might happen when process.cwd() fails)

              // Normalize the path
              resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function(p) {
                return !!p;
              }), !resolvedAbsolute).join('/');

              return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
            };

            // path.normalize(path)
            // posix version
            function normalize$1(path) {
              var isAbsolute = isAbsolute(path),
                  trailingSlash = substr(path, -1) === '/';

              // Normalize the path
              path = normalizeArray(filter(path.split('/'), function(p) {
                return !!p;
              }), !isAbsolute).join('/');

              if (!path && !isAbsolute) {
                path = '.';
              }
              if (path && trailingSlash) {
                path += '/';
              }

              return (isAbsolute ? '/' : '') + path;
            };

            // posix version
            function isAbsolute$1(path) {
              return path.charAt(0) === '/';
            }

            // posix version
            function join$1() {
              var paths = Array.prototype.slice.call(arguments, 0);
              return normalize$1(filter(paths, function(p, index) {
                if (typeof p !== 'string') {
                  throw new TypeError('Arguments to path.join must be strings');
                }
                return p;
              }).join('/'));
            }


            // path.relative(from, to)
            // posix version
            function relative$1(from, to) {
              from = resolve(from).substr(1);
              to = resolve(to).substr(1);

              function trim(arr) {
                var start = 0;
                for (; start < arr.length; start++) {
                  if (arr[start] !== '') break;
                }

                var end = arr.length - 1;
                for (; end >= 0; end--) {
                  if (arr[end] !== '') break;
                }

                if (start > end) return [];
                return arr.slice(start, end - start + 1);
              }

              var fromParts = trim(from.split('/'));
              var toParts = trim(to.split('/'));

              var length = Math.min(fromParts.length, toParts.length);
              var samePartsLength = length;
              for (var i = 0; i < length; i++) {
                if (fromParts[i] !== toParts[i]) {
                  samePartsLength = i;
                  break;
                }
              }

              var outputParts = [];
              for (var i = samePartsLength; i < fromParts.length; i++) {
                outputParts.push('..');
              }

              outputParts = outputParts.concat(toParts.slice(samePartsLength));

              return outputParts.join('/');
            }

            var sep = '/';
            var delimiter = ':';

            function dirname(path) {
              var result = splitPath(path),
                  root = result[0],
                  dir = result[1];

              if (!root && !dir) {
                // No dirname whatsoever
                return '.';
              }

              if (dir) {
                // It has a dirname, strip trailing slash
                dir = dir.substr(0, dir.length - 1);
              }

              return root + dir;
            };


            function basename(path, ext) {
              var f = splitPath(path)[2];
              // TODO: make this comparison case-insensitive on windows?
              if (ext && f.substr(-1 * ext.length) === ext) {
                f = f.substr(0, f.length - ext.length);
              }
              return f;
            }


            function extname(path) {
              return splitPath(path)[3];
            }
            var require$$1$36 = {
              extname: extname,
              basename: basename,
              dirname: dirname,
              sep: sep,
              delimiter: delimiter,
              relative: relative$1,
              join: join$1,
              isAbsolute: isAbsolute$1,
              normalize: normalize$1,
              resolve: resolve
            };
            function filter (xs, f) {
                if (xs.filter) return xs.filter(f);
                var res = [];
                for (var i = 0; i < xs.length; i++) {
                    if (f(xs[i], i, xs)) res.push(xs[i]);
                }
                return res;
            }

            // String.prototype.substr - negative index don't work in IE8
            var substr = 'ab'.substr(-1) === 'b'
                ? function (str, start, len) { return str.substr(start, len) }
                : function (str, start, len) {
                    if (start < 0) start = str.length + start;
                    return str.substr(start, len);
                }
            ;

            var Include = function (_Node) {
            	babelHelpers.inherits(Include, _Node);

            	function Include() {
            		babelHelpers.classCallCheck(this, Include);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Include).apply(this, arguments));
            	}

            	babelHelpers.createClass(Include, [{
            		key: "resolve",
            		value: function resolve(file) {
            			return require$$1$36.resolve(require$$1$36.dirname(file), this.src);
            		}
            	}, {
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);
            			this.write("import " + JSON.stringify(this.src) + ";");
            			return this.end();
            		}
            	}]);
            	return Include;
            }(ASTNode);

            function header(data, h) {
            	if (require$$0$21(data.headers) && !_includes(data.headers, h)) {
            		data.headers.push(h);
            	}
            }

            function hash(str) {
            	var h = 0,
            	    i,
            	    chr,
            	    len;

            	if (str.length === 0) return h;

            	for (i = 0, len = str.length; i < len; i++) {
            		chr = str.charCodeAt(i);
            		h = (h << 5) - h + chr;
            		h |= 0; // Convert to 32bit integer
            	}

            	return h;
            }

            function compileGroup(nodes, data) {
            	return nodes.map(function (n, i) {
            		return n.compile(addKey(data, i.toString()));
            	});
            }

            function compileGroupAsync(nodes, data) {
            	nodes = nodes.slice(0);
            	var out = [];
            	var next = function next() {
            		return !nodes.length ? Promise.resolve() : nodes.shift().compile(data).then(function (o) {
            			out.push(o);
            			return next();
            		});
            	};
            	return next().then(function () {
            		return out;
            	});
            }

            function getKey(data) {
            	return (data.key || []).reduce(function (memo, v) {
            		if (_isString(v) && _isString(_last(memo))) {
            			memo.push(memo.pop() + "-" + v);
            		} else {
            			memo.push(v);
            		}

            		return memo;
            	}, []).map(function (v, i, l) {
            		if ((typeof v === "undefined" ? "undefined" : babelHelpers.typeof(v)) === "object") return v.value;
            		if (i !== 0) v = "-" + v;
            		if (i !== l.length - 1) v += "-";
            		return JSON.stringify(v);
            	}).join(" + ");
            }

            function addKey(data, key) {
            	var base = data.key || [];
            	return _assign({}, data, {
            		key: [].concat(base, key)
            	});
            }

            function resetKey(data) {
            	return _assign({}, data, { key: [] });
            }

var utils$1 = Object.freeze({
            	header: header,
            	hash: hash,
            	compileGroup: compileGroup,
            	compileGroupAsync: compileGroupAsync,
            	getKey: getKey,
            	addKey: addKey,
            	resetKey: resetKey
            });

            var Template$1 = function (_Node) {
            	babelHelpers.inherits(Template, _Node);

            	function Template() {
            		babelHelpers.classCallCheck(this, Template);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Template).apply(this, arguments));
            	}

            	babelHelpers.createClass(Template, [{
            		key: "compile",
            		value: function compile(data) {
            			var _this2 = this;

            			this.start(data);
            			var safename = JSON.stringify(this.name);
            			var safetype = this.type ? JSON.stringify(this.type) : null;

            			header(data, "var Template = {};\n");

            			this.write("Template[" + safename + "] = Temple.create(" + safename + ", " + (safetype ? safetype + ", " : "") + "function(scope, key) {").indent();
            			data = addKey(data, { value: "key" });
            			this.push(compileGroup(this.children, data));
            			this.outdent().write("});\n");

            			if (this.plugins && this.plugins.length) {
            				this.plugins.forEach(function (p) {
            					_this2.write("Template[" + safename + "].use(" + JSON.stringify(p) + ");");
            				});
            				this.write("");
            			}

            			return this.end();
            		}
            	}]);
            	return Template;
            }(ASTNode);

            var Render = function (_Node) {
            	babelHelpers.inherits(Render, _Node);

            	function Render() {
            		babelHelpers.classCallCheck(this, Render);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Render).apply(this, arguments));
            	}

            	babelHelpers.createClass(Render, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);
            			var exp = this.expression.compile(data);
            			this.write(["Temple.render(", exp, ", scope, " + getKey(data) + ");"]);
            			return this.end();
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return true;
            		}
            	}]);
            	return Render;
            }(ASTNode);

            var Text = function (_Node) {
            	babelHelpers.inherits(Text, _Node);

            	function Text() {
            		babelHelpers.classCallCheck(this, Text);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Text).apply(this, arguments));
            	}

            	babelHelpers.createClass(Text, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);

            			var value = this.value.replace(/\s+/g, " ");
            			var safe = JSON.stringify(value);

            			if (containsEntities(value)) {
            				safe = "Temple.utils.decodeEntities(" + safe + ")";
            			}

            			header(data, "var idom = Temple.idom;\n");
            			this.write("idom.text(" + safe + ");");
            			return this.end();
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return false;
            		}
            	}]);
            	return Text;
            }(ASTNode);

            var Element$1 = function (_Node) {
            	babelHelpers.inherits(Element, _Node);

            	function Element() {
            		babelHelpers.classCallCheck(this, Element);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Element).apply(this, arguments));
            	}

            	babelHelpers.createClass(Element, [{
            		key: "compile",
            		value: function compile(data) {
            			var _this2 = this;

            			this.start(data);

            			var tagName = JSON.stringify(this.tagname);
            			var key = getKey(data);
            			var childs = this.children;
            			var attrs = this.attributes;

            			var body = function body() {
            				_this2.push([].concat(_invokeMap(attrs, "compile", data), compileGroup(childs, resetKey(data))));
            			};

            			header(data, "var idom = Temple.idom;\n");

            			if (childs.length || attrs.length) {
            				if (!childs.some(function (c) {
            					return c.reactive;
            				})) {
            					this.write("idom.elementOpen(" + tagName + (key ? ", " + key : "") + ");");
            					body();
            					this.write("idom.elementClose(" + tagName + ");");
            				} else {
            					this.write("Temple.Element(" + tagName + ", " + (key || "null") + ", scope, function(scope) {").indent();
            					body();
            					this.outdent().write("});");
            				}
            			} else {
            				this.write("idom.elementVoid(" + tagName + (key ? ", " + key : "") + ");");
            			}

            			return this.end();
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return false;
            		}
            	}]);
            	return Element;
            }(ASTNode);

            var Attribute = function (_Node) {
            	babelHelpers.inherits(Attribute, _Node);

            	function Attribute() {
            		babelHelpers.classCallCheck(this, Attribute);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Attribute).apply(this, arguments));
            	}

            	babelHelpers.createClass(Attribute, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);

            			var fun = void 0;
            			var value = this._sn(data.filename, "");
            			var len = this.children.length;

            			if (len) {
            				value.add(_invokeMap(this.children, "compile", data)).join(",");
            				fun = this.children.some(function (c) {
            					return c.reactive;
            				});
            				if (len > 1) value.prepend("[").add("]");

            				if (fun && this.type === "string") {
            					if (len > 1) value.add(".map(Temple.utils.toString).join(\"\")");else value.prepend("Temple.utils.toString(").add(")");
            				}
            			} else {
            				value = null;
            			}

            			header(data, "var decorators = Temple.decorators;\n");
            			this.push([this.tabs(), "decorators.render(scope, " + JSON.stringify(this.name)]);

            			if (fun) {
            				this.push(", function(scope) {\n").indent();
            				this.write(["return ", value, ";"]);
            				this.outdent().push([this.tabs(), "}"]);
            			} else if (value) {
            				this.push([", ", value]);
            			}

            			this.push(");\n");

            			return this.end();
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return false;
            		}
            	}]);
            	return Attribute;
            }(ASTNode);

            var If = function (_Node) {
            	babelHelpers.inherits(If, _Node);

            	function If() {
            		babelHelpers.classCallCheck(this, If);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(If).apply(this, arguments));
            	}

            	babelHelpers.createClass(If, [{
            		key: "compile",
            		value: function compile(data) {
            			var _this2 = this;

            			this.start(data);

            			if (this.attribute) {
            				this.push("(");
            			}

            			this.children.forEach(function (c, i, l) {
            				if (_this2.attribute) {
            					if (c.expression) _this2.push([c.expression.compile(data), " ? "]);
            					_this2.push(["Temple.utils.joinValues(", c.compile(addKey(data, i.toString())).join(","), ")"]);
            					if (i + 1 === l.length && c.expression) _this2.push(" : ''");
            				} else {
            					var line = [];
            					line.push(!i ? "if" : !c.expression ? "else" : "else if", " ");
            					if (c.expression) line.push(["(", c.expression.compile(data), ") "]);
            					line.push("{");
            					_this2.write(line).indent();
            					_this2.push(c.compile(addKey(data, i.toString())));
            					_this2.outdent().write("}");
            				}
            			});

            			if (this.attribute) {
            				this.push(")");
            			}

            			return this.end();
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return true;
            		}
            	}]);
            	return If;
            }(ASTNode);

            var Branch = function (_Node) {
            	babelHelpers.inherits(Branch, _Node);

            	function Branch() {
            		babelHelpers.classCallCheck(this, Branch);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Branch).apply(this, arguments));
            	}

            	babelHelpers.createClass(Branch, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);
            			this.push(compileGroup(this.children, data));
            			return this.end();
            		}
            	}]);
            	return Branch;
            }(ASTNode);

            var Each = function (_Node) {
            	babelHelpers.inherits(Each, _Node);

            	function Each() {
            		babelHelpers.classCallCheck(this, Each);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Each).apply(this, arguments));
            	}

            	babelHelpers.createClass(Each, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);

            			var exp = this.expression.compile(data);
            			var indexvar = _uniqueId("index");
            			var vars = JSON.stringify(this.variables || []);

            			if (!this.attribute) this.push(this.tabs());
            			this.push(["Temple.Each(", exp, ", ", vars, ", scope, function(scope, " + indexvar + ") {"]).indent();
            			if (!this.attribute) this.push("\n");
            			data = addKey(data, { value: indexvar });
            			var c = this._sn(data.filename, compileGroup(this.children, data));
            			if (this.attribute) c = [" return Temple.utils.joinValues(", c.join(","), "); "];
            			this.push(c);
            			this.outdent();
            			if (!this.attribute) this.write("});");else this.push("}).join(\"\")");

            			return this.end();
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return true;
            		}
            	}]);
            	return Each;
            }(ASTNode);

            var With = function (_Node) {
            	babelHelpers.inherits(With, _Node);

            	function With() {
            		babelHelpers.classCallCheck(this, With);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(With).apply(this, arguments));
            	}

            	babelHelpers.createClass(With, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);

            			var exp = this.expression.compile(data);

            			if (!this.attribute) this.push(this.tabs());
            			this.push(["Temple.With(", exp, ", scope, function(scope) {"]).indent();
            			if (!this.attribute) this.push("\n");
            			var c = this._sn(data.filename, compileGroup(this.children, data));
            			if (this.attribute) c = [" return Temple.utils.joinValues(", c.join(","), "); "];
            			this.push(c);
            			this.outdent();

            			if (!this.attribute) this.write("});");else this.push("})");

            			return this.end();
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return true;
            		}
            	}]);
            	return With;
            }(ASTNode);

            var Interpolator = function (_Node) {
            	babelHelpers.inherits(Interpolator, _Node);

            	function Interpolator() {
            		babelHelpers.classCallCheck(this, Interpolator);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Interpolator).apply(this, arguments));
            	}

            	babelHelpers.createClass(Interpolator, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);
            			header(data, "var idom = Temple.idom;\n");
            			this.write("idom.autotext(" + this.expression.compile(_assign({ asFn: true }, data)) + ");");
            			return this.end();
            		}
            	}, {
            		key: "reactive",

            		// while technically reactive, they contain their own autorun statement
            		get: function get() {
            			return false;
            		}
            	}]);
            	return Interpolator;
            }(ASTNode);

            var Comment = function (_Node) {
            	babelHelpers.inherits(Comment, _Node);

            	function Comment() {
            		babelHelpers.classCallCheck(this, Comment);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Comment).apply(this, arguments));
            	}

            	babelHelpers.createClass(Comment, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);
            			return this.end();
            		}
            	}]);
            	return Comment;
            }(ASTNode);

            // method to run to query the scope
            var SCOPE_LOOKUP = "scope.lookup";

            var Expression = function (_Node) {
            	babelHelpers.inherits(Expression, _Node);

            	function Expression() {
            		babelHelpers.classCallCheck(this, Expression);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Expression).apply(this, arguments));
            	}

            	babelHelpers.createClass(Expression, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);
            			var exp = Expression.render(this.tree);

            			if (data.asFn) {
            				this.push("function() {\n").indent();
            				this.write("return " + exp + ";");
            				this.outdent().push([this.tabs(), "}"]);
            			} else {
            				this.push(exp);
            			}

            			return this.end();
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return !Expression.isStatic(this.tree);
            		}
            	}], [{
            		key: "isStatic",
            		value: function isStatic(tree) {
            			var _isStatic = Expression.isStatic;

            			switch (tree.type) {
            				case "Compound":
            					return tree.body.every(_isStatic);
            				case "Identifier":
            					return false;
            				case "ThisExpression":
            					return false;
            				case "MemberExpression":
            					{
            						if (!_isStatic(tree.object)) return false;
            						var prop = tree.property;
            						if (!tree.computed && prop.type === "Identifier") return true;
            						return _isStatic(prop);
            					}
            				case "Literal":
            					return true;
            				case "CallExpression":
            					{
            						return _isStatic(tree.callee) && tree.arguments.every(_isStatic);
            					}
            				case "UnaryExpression":
            					return _isStatic(tree.argument);
            				case "LogicalExpression":
            				case "BinaryExpression":
            					return _isStatic(tree.left) && _isStatic(tree.right);
            				case "ArrayExpression":
            					return tree.elements.every(_isStatic);
            				case "ConditionalExpression":
            					{
            						return [tree.test, tree.consequent, tree.alternate].every(_isStatic);
            					}
            				default:
            					return false;
            			}
            		}
            	}, {
            		key: "render",
            		value: function render(tree) {
            			var _render = Expression.render;

            			switch (tree.type) {
            				case "Compound":
            					{
            						// expressions seperated by comma or semicolon
            						return "(" + tree.body.map(_render).join(",") + ")";
            					}

            				case "Identifier":
            					// plain varable
            					return SCOPE_LOOKUP + "(" + JSON.stringify(tree.name) + ")";

            				case "ThisExpression":
            					// plain varable
            					return SCOPE_LOOKUP + "()";

            				case "MemberExpression":
            					{
            						// object property
            						var out = _render(tree.object);
            						var prop = tree.property;
            						if (!tree.computed && prop.type === "Identifier") out += "." + prop.name;else out += "[" + _render(prop) + "]";
            						return out;
            					}

            				case "Literal":
            					// string, number, boolean
            					return JSON.stringify(tree.value);

            				case "CallExpression":
            					{
            						// function call
            						var _out = _render(tree.callee);
            						if (tree.callee.type === "MemberExpression") _out += "(";else _out += ".call(" + SCOPE_LOOKUP + "()" + (tree.arguments.length ? ", " : "");
            						_out += tree.arguments.map(_render).join(", ") + ")";
            						return _out;
            					}

            				case "UnaryExpression":
            					{
            						// single operators: ! - ++ --
            						var _out2 = _render(tree.argument);
            						if (tree.prefix) _out2 = tree.operator + _out2;else _out2 += tree.operator;
            						return _out2;
            					}

            				case "LogicalExpression":
            				case "BinaryExpression":
            					{
            						// math
            						return "(" + _render(tree.left) + tree.operator + _render(tree.right) + ")";
            					}

            				case "ArrayExpression":
            					{
            						// arrays
            						return "[" + tree.elements.map(_render).join(",") + "]";
            					}

            				case "ConditionalExpression":
            					{
            						// if ? then : else
            						return "(" + _render(tree.test) + "?" + _render(tree.consequent) + ":" + _render(tree.alternate) + ")";
            					}

            				default:
            					throw new Error("Not supported.");
            			}
            		}
            	}]);
            	return Expression;
            }(ASTNode);

            var Literal = function (_Node) {
            	babelHelpers.inherits(Literal, _Node);

            	function Literal() {
            		babelHelpers.classCallCheck(this, Literal);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Literal).apply(this, arguments));
            	}

            	babelHelpers.createClass(Literal, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);
            			this.push(JSON.stringify(this.value));
            			return this.end();
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return false;
            		}
            	}]);
            	return Literal;
            }(ASTNode);

            var Set = function (_Node) {
            	babelHelpers.inherits(Set, _Node);

            	function Set() {
            		babelHelpers.classCallCheck(this, Set);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Set).apply(this, arguments));
            	}

            	babelHelpers.createClass(Set, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);

            			var exp = this.expression.compile(data);
            			var safevar = JSON.stringify(this.variable);
            			if (this.attribute) this.push("(");else this.push(this.tabs());
            			this.push(["scope.set(" + safevar + ", ", exp, ")"]);
            			if (!this.attribute) this.push(";\n");else this.push(", \"\")");

            			return this.end();
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return true;
            		}
            	}]);
            	return Set;
            }(ASTNode);

            var _baseMap = __commonjs(function (module) {
            var baseEach = require$$4$10,
                isArrayLike = require$$0$5;

            /**
             * The base implementation of `_.map` without support for iteratee shorthands.
             *
             * @private
             * @param {Array|Object} collection The collection to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array} Returns the new mapped array.
             */
            function baseMap(collection, iteratee) {
              var index = -1,
                  result = isArrayLike(collection) ? Array(collection.length) : [];

              baseEach(collection, function(value, key, collection) {
                result[++index] = iteratee(value, key, collection);
              });
              return result;
            }

            module.exports = baseMap;
            });

            var require$$1$37 = (_baseMap && typeof _baseMap === 'object' && 'default' in _baseMap ? _baseMap['default'] : _baseMap);

            var map$1 = __commonjs(function (module) {
            var arrayMap = require$$3,
                baseIteratee = require$$1$11,
                baseMap = require$$1$37,
                isArray = require$$0$21;

            /**
             * Creates an array of values by running each element in `collection` through
             * `iteratee`. The iteratee is invoked with three arguments:
             * (value, index|key, collection).
             *
             * Many lodash methods are guarded to work as iteratees for methods like
             * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
             *
             * The guarded methods are:
             * `ary`, `curry`, `curryRight`, `drop`, `dropRight`, `every`, `fill`,
             * `invert`, `parseInt`, `random`, `range`, `rangeRight`, `slice`, `some`,
             * `sortBy`, `take`, `takeRight`, `template`, `trim`, `trimEnd`, `trimStart`,
             * and `words`
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Collection
             * @param {Array|Object} collection The collection to iterate over.
             * @param {Array|Function|Object|string} [iteratee=_.identity]
             *  The function invoked per iteration.
             * @returns {Array} Returns the new mapped array.
             * @example
             *
             * function square(n) {
             *   return n * n;
             * }
             *
             * _.map([4, 8], square);
             * // => [16, 64]
             *
             * _.map({ 'a': 4, 'b': 8 }, square);
             * // => [16, 64] (iteration order is not guaranteed)
             *
             * var users = [
             *   { 'user': 'barney' },
             *   { 'user': 'fred' }
             * ];
             *
             * // The `_.property` iteratee shorthand.
             * _.map(users, 'user');
             * // => ['barney', 'fred']
             */
            function map(collection, iteratee) {
              var func = isArray(collection) ? arrayMap : baseMap;
              return func(collection, baseIteratee(iteratee, 3));
            }

            module.exports = map;
            });

            var _map = (map$1 && typeof map$1 === 'object' && 'default' in map$1 ? map$1['default'] : map$1);

            var Raw = function (_Node) {
            	babelHelpers.inherits(Raw, _Node);

            	function Raw() {
            		babelHelpers.classCallCheck(this, Raw);
            		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Raw).apply(this, arguments));
            	}

            	babelHelpers.createClass(Raw, [{
            		key: "compile",
            		value: function compile(data) {
            			this.start(data);

            			var result = void 0;
            			var parsers = [].concat((data.tags || {})[this.tagname], this[this.tagname], this.defaultParser).filter(Boolean);

            			var attrs = this.attributes.reduce(function (m, a) {
            				switch (a.type) {
            					case "empty":
            						m[a.name] = true;
            						break;

            					case "string":
            						m[a.name] = a.value;
            						break;
            				}

            				return m;
            			}, {});

            			while (parsers.length && result == null) {
            				var parser = parsers.shift();
            				if (typeof parser === "function") {
            					result = parser.call(this, this.value, attrs, data);
            				}
            			}

            			if (result != null) this.write(result);
            			return this.end();
            		}
            	}, {
            		key: "defaultParser",
            		value: function defaultParser(value, attrs, data) {
            			this._normalize_indent();
            			var line = this._line || 1;
            			var column = this._column || 1;

            			return value.split(/\r?\n/g).map(function (l, i) {
            				return new SourceNode(i + line, i === 0 ? column : 1, data.filename, l + "\n");
            			});
            		}
            	}, {
            		key: "script",
            		value: function script(value, attrs) {
            			if (!attrs.src) return;

            			var attrsrc = _map(attrs, function (v, n) {
            				return "script[" + JSON.stringify(n) + "] = " + JSON.stringify(v) + ";";
            			}).join("\n");

            			return "(function(){\n\tvar script = document.createElement(\"script\");\n\t" + attrsrc + "\n\tdocument.head.appendChild(script);\n}());\n";
            		}
            	}, {
            		key: "style",
            		value: function style(value) {
            			return "(function() {\n\tvar style = document.createElement(\"style\");\n\tstyle.innerHTML = " + JSON.stringify(value) + ";\n\tdocument.head.appendChild(style);\n}());";
            		}
            	}, {
            		key: "reactive",
            		get: function get() {
            			return false;
            		}
            	}]);
            	return Raw;
            }(ASTNode);



            var AST = Object.freeze({
            	utils: utils$1,
            	Node: ASTNode,
            	File: File,
            	Include: Include,
            	Comment: Comment,
            	Template: Template$1,
            	Raw: Raw,
            	Element: Element$1,
            	Text: Text,
            	Attribute: Attribute,
            	If: If,
            	Branch: Branch,
            	Each: Each,
            	With: With,
            	Set: Set,
            	Render: Render,
            	Interpolator: Interpolator,
            	Expression: Expression,
            	Literal: Literal
            });

            var name = "templejs";
            var description = "A JavaScript view framework.";
            var author = "Beneath the Ink <info@beneaththeink.com>";
            var contributors = [{"name":"Tyler Johnson","email":"tyler@beneaththeink.com","url":"http://github.com/tyler-johnson"}];
            var repository = {"type":"git","url":"https://github.com/BeneathTheInk/Temple.git"};
            var scripts = {"lint":"eslint src/ test/","test":"make test","build":"make build","prepublish":"make clean && make","autorelease":"autorelease pre && npm publish && autorelease post"};
            var main = "lib/index.js";
            var bin = "lib/cli.js";
            var browser$1 = {"fs-promise":false};
            var dependencies = {"assign-props":"^1.1.2","backbone-extend-standalone":"^0.1.2","chalk":"^1.1.1","chokidar":"^1.4.2","dom-matches":"^2.0.0","express":"^4.13.4","fs-promise":"^0.4.1","jsep":"^0.3.0","lodash":"4.x","minimist":"^1.2.0","open":"0.0.5","raf":"^3.1.0","rollup":"^0.25.4","@mrgalaxy/rollup-plugin-inject":"^2.0.0","source-map":"^0.5.3","trackr":"^2.0.2","trackr-objects":"^0.4.0"};
            var devDependencies = {"ace-editor-builds":"^1.2.0","autorelease":"^1.6.0","autorelease-github":"^1.1.1","autorelease-travis":"^1.2.1","babel-eslint":"^6.0.0","babel-plugin-lodash":"^2.0.1","babel-preset-es2015-rollup":"^1.1.1","browserify":"^13.0.0","eslint":"~2.2.0","incremental-dom":"^0.3.0","istanbul":"^0.4.2","istanbul-coveralls":"^1.0.3","pegjs":"^0.9.0","random-port":"^0.1.0","rollup-plugin-babel":"^2.3.9","rollup-plugin-commonjs":"^2.2.1","rollup-plugin-json":"^2.0.0","rollup-plugin-node-builtins":"^1.0.0","rollup-plugin-node-globals":"1.0.3","rollup-plugin-node-resolve":"^1.4.0","rollup-plugin-replace":"^1.1.0","tape":"^4.4.0","tape-run":"^2.1.3","uglify-js":"^2.6.1"};
            var license = "MIT";
            var keywords = ["view","framework","DOM","html","binding","reactive","dependency","mustache"];
            var version$2 = "1.0.0";
            var pkg = {
            	name: name,
            	description: description,
            	author: author,
            	contributors: contributors,
            	repository: repository,
            	scripts: scripts,
            	main: main,
            	bin: bin,
            	browser: browser$1,
            	dependencies: dependencies,
            	devDependencies: devDependencies,
            	license: license,
            	keywords: keywords,
            	version: version$2,
            	"jsnext:main": "lib/es6.js"
            };

            var _buffer;
            (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
            'use strict'

            exports.toByteArray = toByteArray
            exports.fromByteArray = fromByteArray

            var lookup = []
            var revLookup = []
            var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array

            function init () {
              var i
              var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
              var len = code.length

              for (i = 0; i < len; i++) {
                lookup[i] = code[i]
              }

              for (i = 0; i < len; ++i) {
                revLookup[code.charCodeAt(i)] = i
              }
              revLookup['-'.charCodeAt(0)] = 62
              revLookup['_'.charCodeAt(0)] = 63
            }

            init()

            function toByteArray (b64) {
              var i, j, l, tmp, placeHolders, arr
              var len = b64.length

              if (len % 4 > 0) {
                throw new Error('Invalid string. Length must be a multiple of 4')
              }

              // the number of equal signs (place holders)
              // if there are two placeholders, than the two characters before it
              // represent one byte
              // if there is only one, then the three characters before it represent 2 bytes
              // this is just a cheap hack to not do indexOf twice
              placeHolders = b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0

              // base64 is 4/3 + up to two characters of the original data
              arr = new Arr(len * 3 / 4 - placeHolders)

              // if there are placeholders, only get up to the last complete 4 chars
              l = placeHolders > 0 ? len - 4 : len

              var L = 0

              for (i = 0, j = 0; i < l; i += 4, j += 3) {
                tmp = (revLookup[b64.charCodeAt(i)] << 18) | (revLookup[b64.charCodeAt(i + 1)] << 12) | (revLookup[b64.charCodeAt(i + 2)] << 6) | revLookup[b64.charCodeAt(i + 3)]
                arr[L++] = (tmp & 0xFF0000) >> 16
                arr[L++] = (tmp & 0xFF00) >> 8
                arr[L++] = tmp & 0xFF
              }

              if (placeHolders === 2) {
                tmp = (revLookup[b64.charCodeAt(i)] << 2) | (revLookup[b64.charCodeAt(i + 1)] >> 4)
                arr[L++] = tmp & 0xFF
              } else if (placeHolders === 1) {
                tmp = (revLookup[b64.charCodeAt(i)] << 10) | (revLookup[b64.charCodeAt(i + 1)] << 4) | (revLookup[b64.charCodeAt(i + 2)] >> 2)
                arr[L++] = (tmp >> 8) & 0xFF
                arr[L++] = tmp & 0xFF
              }

              return arr
            }

            function tripletToBase64 (num) {
              return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F]
            }

            function encodeChunk (uint8, start, end) {
              var tmp
              var output = []
              for (var i = start; i < end; i += 3) {
                tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2])
                output.push(tripletToBase64(tmp))
              }
              return output.join('')
            }

            function fromByteArray (uint8) {
              var tmp
              var len = uint8.length
              var extraBytes = len % 3 // if we have 1 byte left, pad 2 bytes
              var output = ''
              var parts = []
              var maxChunkLength = 16383 // must be multiple of 3

              // go through the array every three bytes, we'll deal with trailing stuff later
              for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
                parts.push(encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)))
              }

              // pad the end with zeros, but make sure to not forget the extra bytes
              if (extraBytes === 1) {
                tmp = uint8[len - 1]
                output += lookup[tmp >> 2]
                output += lookup[(tmp << 4) & 0x3F]
                output += '=='
              } else if (extraBytes === 2) {
                tmp = (uint8[len - 2] << 8) + (uint8[len - 1])
                output += lookup[tmp >> 10]
                output += lookup[(tmp >> 4) & 0x3F]
                output += lookup[(tmp << 2) & 0x3F]
                output += '='
              }

              parts.push(output)

              return parts.join('')
            }

            },{}],2:[function(require,module,exports){
            (function (global){
            /*!
             * The buffer module from node.js, for the browser.
             *
             * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
             * @license  MIT
             */
            /* eslint-disable no-proto */

            'use strict'

            var base64 = require('base64-js')
            var ieee754 = require('ieee754')
            var isArray = require('isarray')

            exports.Buffer = Buffer
            exports.SlowBuffer = SlowBuffer
            exports.INSPECT_MAX_BYTES = 50
            Buffer.poolSize = 8192 // not used by this implementation

            var rootParent = {}

            /**
             * If `Buffer.TYPED_ARRAY_SUPPORT`:
             *   === true    Use Uint8Array implementation (fastest)
             *   === false   Use Object implementation (most compatible, even IE6)
             *
             * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
             * Opera 11.6+, iOS 4.2+.
             *
             * Due to various browser bugs, sometimes the Object implementation will be used even
             * when the browser supports typed arrays.
             *
             * Note:
             *
             *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
             *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
             *
             *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
             *
             *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
             *     incorrect length in some situations.

             * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
             * get the Object implementation, which is slower but behaves correctly.
             */
            Buffer.TYPED_ARRAY_SUPPORT = global.TYPED_ARRAY_SUPPORT !== undefined
              ? global.TYPED_ARRAY_SUPPORT
              : typedArraySupport()

            function typedArraySupport () {
              try {
                var arr = new Uint8Array(1)
                arr.foo = function () { return 42 }
                return arr.foo() === 42 && // typed array instances can be augmented
                    typeof arr.subarray === 'function' && // chrome 9-10 lack `subarray`
                    arr.subarray(1, 1).byteLength === 0 // ie10 has broken `subarray`
              } catch (e) {
                return false
              }
            }

            function kMaxLength () {
              return Buffer.TYPED_ARRAY_SUPPORT
                ? 0x7fffffff
                : 0x3fffffff
            }

            /**
             * The Buffer constructor returns instances of `Uint8Array` that have their
             * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
             * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
             * and the `Uint8Array` methods. Square bracket notation works as expected -- it
             * returns a single octet.
             *
             * The `Uint8Array` prototype remains unmodified.
             */
            function Buffer (arg) {
              if (!(this instanceof Buffer)) {
                // Avoid going through an ArgumentsAdaptorTrampoline in the common case.
                if (arguments.length > 1) return new Buffer(arg, arguments[1])
                return new Buffer(arg)
              }

              if (!Buffer.TYPED_ARRAY_SUPPORT) {
                this.length = 0
                this.parent = undefined
              }

              // Common case.
              if (typeof arg === 'number') {
                return fromNumber(this, arg)
              }

              // Slightly less common case.
              if (typeof arg === 'string') {
                return fromString(this, arg, arguments.length > 1 ? arguments[1] : 'utf8')
              }

              // Unusual.
              return fromObject(this, arg)
            }

            // TODO: Legacy, not needed anymore. Remove in next major version.
            Buffer._augment = function (arr) {
              arr.__proto__ = Buffer.prototype
              return arr
            }

            function fromNumber (that, length) {
              that = allocate(that, length < 0 ? 0 : checked(length) | 0)
              if (!Buffer.TYPED_ARRAY_SUPPORT) {
                for (var i = 0; i < length; i++) {
                  that[i] = 0
                }
              }
              return that
            }

            function fromString (that, string, encoding) {
              if (typeof encoding !== 'string' || encoding === '') encoding = 'utf8'

              // Assumption: byteLength() return value is always < kMaxLength.
              var length = byteLength(string, encoding) | 0
              that = allocate(that, length)

              that.write(string, encoding)
              return that
            }

            function fromObject (that, object) {
              if (Buffer.isBuffer(object)) return fromBuffer(that, object)

              if (isArray(object)) return fromArray(that, object)

              if (object == null) {
                throw new TypeError('must start with number, buffer, array or string')
              }

              if (typeof ArrayBuffer !== 'undefined') {
                if (object.buffer instanceof ArrayBuffer) {
                  return fromTypedArray(that, object)
                }
                if (object instanceof ArrayBuffer) {
                  return fromArrayBuffer(that, object)
                }
              }

              if (object.length) return fromArrayLike(that, object)

              return fromJsonObject(that, object)
            }

            function fromBuffer (that, buffer) {
              var length = checked(buffer.length) | 0
              that = allocate(that, length)
              buffer.copy(that, 0, 0, length)
              return that
            }

            function fromArray (that, array) {
              var length = checked(array.length) | 0
              that = allocate(that, length)
              for (var i = 0; i < length; i += 1) {
                that[i] = array[i] & 255
              }
              return that
            }

            // Duplicate of fromArray() to keep fromArray() monomorphic.
            function fromTypedArray (that, array) {
              var length = checked(array.length) | 0
              that = allocate(that, length)
              // Truncating the elements is probably not what people expect from typed
              // arrays with BYTES_PER_ELEMENT > 1 but it's compatible with the behavior
              // of the old Buffer constructor.
              for (var i = 0; i < length; i += 1) {
                that[i] = array[i] & 255
              }
              return that
            }

            function fromArrayBuffer (that, array) {
              array.byteLength // this throws if `array` is not a valid ArrayBuffer

              if (Buffer.TYPED_ARRAY_SUPPORT) {
                // Return an augmented `Uint8Array` instance, for best performance
                that = new Uint8Array(array)
                that.__proto__ = Buffer.prototype
              } else {
                // Fallback: Return an object instance of the Buffer class
                that = fromTypedArray(that, new Uint8Array(array))
              }
              return that
            }

            function fromArrayLike (that, array) {
              var length = checked(array.length) | 0
              that = allocate(that, length)
              for (var i = 0; i < length; i += 1) {
                that[i] = array[i] & 255
              }
              return that
            }

            // Deserialize { type: 'Buffer', data: [1,2,3,...] } into a Buffer object.
            // Returns a zero-length buffer for inputs that don't conform to the spec.
            function fromJsonObject (that, object) {
              var array
              var length = 0

              if (object.type === 'Buffer' && isArray(object.data)) {
                array = object.data
                length = checked(array.length) | 0
              }
              that = allocate(that, length)

              for (var i = 0; i < length; i += 1) {
                that[i] = array[i] & 255
              }
              return that
            }

            if (Buffer.TYPED_ARRAY_SUPPORT) {
              Buffer.prototype.__proto__ = Uint8Array.prototype
              Buffer.__proto__ = Uint8Array
              if (typeof Symbol !== 'undefined' && Symbol.species &&
                  Buffer[Symbol.species] === Buffer) {
                // Fix subarray() in ES2016. See: https://github.com/feross/buffer/pull/97
                Object.defineProperty(Buffer, Symbol.species, {
                  value: null,
                  configurable: true
                })
              }
            } else {
              // pre-set for values that may exist in the future
              Buffer.prototype.length = undefined
              Buffer.prototype.parent = undefined
            }

            function allocate (that, length) {
              if (Buffer.TYPED_ARRAY_SUPPORT) {
                // Return an augmented `Uint8Array` instance, for best performance
                that = new Uint8Array(length)
                that.__proto__ = Buffer.prototype
              } else {
                // Fallback: Return an object instance of the Buffer class
                that.length = length
              }

              var fromPool = length !== 0 && length <= Buffer.poolSize >>> 1
              if (fromPool) that.parent = rootParent

              return that
            }

            function checked (length) {
              // Note: cannot use `length < kMaxLength` here because that fails when
              // length is NaN (which is otherwise coerced to zero.)
              if (length >= kMaxLength()) {
                throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
                                     'size: 0x' + kMaxLength().toString(16) + ' bytes')
              }
              return length | 0
            }

            function SlowBuffer (subject, encoding) {
              if (!(this instanceof SlowBuffer)) return new SlowBuffer(subject, encoding)

              var buf = new Buffer(subject, encoding)
              delete buf.parent
              return buf
            }

            Buffer.isBuffer = function isBuffer (b) {
              return !!(b != null && b._isBuffer)
            }

            Buffer.compare = function compare (a, b) {
              if (!Buffer.isBuffer(a) || !Buffer.isBuffer(b)) {
                throw new TypeError('Arguments must be Buffers')
              }

              if (a === b) return 0

              var x = a.length
              var y = b.length

              var i = 0
              var len = Math.min(x, y)
              while (i < len) {
                if (a[i] !== b[i]) break

                ++i
              }

              if (i !== len) {
                x = a[i]
                y = b[i]
              }

              if (x < y) return -1
              if (y < x) return 1
              return 0
            }

            Buffer.isEncoding = function isEncoding (encoding) {
              switch (String(encoding).toLowerCase()) {
                case 'hex':
                case 'utf8':
                case 'utf-8':
                case 'ascii':
                case 'binary':
                case 'base64':
                case 'raw':
                case 'ucs2':
                case 'ucs-2':
                case 'utf16le':
                case 'utf-16le':
                  return true
                default:
                  return false
              }
            }

            Buffer.concat = function concat (list, length) {
              if (!isArray(list)) throw new TypeError('list argument must be an Array of Buffers.')

              if (list.length === 0) {
                return new Buffer(0)
              }

              var i
              if (length === undefined) {
                length = 0
                for (i = 0; i < list.length; i++) {
                  length += list[i].length
                }
              }

              var buf = new Buffer(length)
              var pos = 0
              for (i = 0; i < list.length; i++) {
                var item = list[i]
                item.copy(buf, pos)
                pos += item.length
              }
              return buf
            }

            function byteLength (string, encoding) {
              if (typeof string !== 'string') string = '' + string

              var len = string.length
              if (len === 0) return 0

              // Use a for loop to avoid recursion
              var loweredCase = false
              for (;;) {
                switch (encoding) {
                  case 'ascii':
                  case 'binary':
                  // Deprecated
                  case 'raw':
                  case 'raws':
                    return len
                  case 'utf8':
                  case 'utf-8':
                    return utf8ToBytes(string).length
                  case 'ucs2':
                  case 'ucs-2':
                  case 'utf16le':
                  case 'utf-16le':
                    return len * 2
                  case 'hex':
                    return len >>> 1
                  case 'base64':
                    return base64ToBytes(string).length
                  default:
                    if (loweredCase) return utf8ToBytes(string).length // assume utf8
                    encoding = ('' + encoding).toLowerCase()
                    loweredCase = true
                }
              }
            }
            Buffer.byteLength = byteLength

            function slowToString (encoding, start, end) {
              var loweredCase = false

              start = start | 0
              end = end === undefined || end === Infinity ? this.length : end | 0

              if (!encoding) encoding = 'utf8'
              if (start < 0) start = 0
              if (end > this.length) end = this.length
              if (end <= start) return ''

              while (true) {
                switch (encoding) {
                  case 'hex':
                    return hexSlice(this, start, end)

                  case 'utf8':
                  case 'utf-8':
                    return utf8Slice(this, start, end)

                  case 'ascii':
                    return asciiSlice(this, start, end)

                  case 'binary':
                    return binarySlice(this, start, end)

                  case 'base64':
                    return base64Slice(this, start, end)

                  case 'ucs2':
                  case 'ucs-2':
                  case 'utf16le':
                  case 'utf-16le':
                    return utf16leSlice(this, start, end)

                  default:
                    if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
                    encoding = (encoding + '').toLowerCase()
                    loweredCase = true
                }
              }
            }

            // The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
            // Buffer instances.
            Buffer.prototype._isBuffer = true

            Buffer.prototype.toString = function toString () {
              var length = this.length | 0
              if (length === 0) return ''
              if (arguments.length === 0) return utf8Slice(this, 0, length)
              return slowToString.apply(this, arguments)
            }

            Buffer.prototype.equals = function equals (b) {
              if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
              if (this === b) return true
              return Buffer.compare(this, b) === 0
            }

            Buffer.prototype.inspect = function inspect () {
              var str = ''
              var max = exports.INSPECT_MAX_BYTES
              if (this.length > 0) {
                str = this.toString('hex', 0, max).match(/.{2}/g).join(' ')
                if (this.length > max) str += ' ... '
              }
              return '<Buffer ' + str + '>'
            }

            Buffer.prototype.compare = function compare (b) {
              if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
              if (this === b) return 0
              return Buffer.compare(this, b)
            }

            Buffer.prototype.indexOf = function indexOf (val, byteOffset) {
              if (byteOffset > 0x7fffffff) byteOffset = 0x7fffffff
              else if (byteOffset < -0x80000000) byteOffset = -0x80000000
              byteOffset >>= 0

              if (this.length === 0) return -1
              if (byteOffset >= this.length) return -1

              // Negative offsets start from the end of the buffer
              if (byteOffset < 0) byteOffset = Math.max(this.length + byteOffset, 0)

              if (typeof val === 'string') {
                if (val.length === 0) return -1 // special case: looking for empty string always fails
                return String.prototype.indexOf.call(this, val, byteOffset)
              }
              if (Buffer.isBuffer(val)) {
                return arrayIndexOf(this, val, byteOffset)
              }
              if (typeof val === 'number') {
                if (Buffer.TYPED_ARRAY_SUPPORT && Uint8Array.prototype.indexOf === 'function') {
                  return Uint8Array.prototype.indexOf.call(this, val, byteOffset)
                }
                return arrayIndexOf(this, [ val ], byteOffset)
              }

              function arrayIndexOf (arr, val, byteOffset) {
                var foundIndex = -1
                for (var i = 0; byteOffset + i < arr.length; i++) {
                  if (arr[byteOffset + i] === val[foundIndex === -1 ? 0 : i - foundIndex]) {
                    if (foundIndex === -1) foundIndex = i
                    if (i - foundIndex + 1 === val.length) return byteOffset + foundIndex
                  } else {
                    foundIndex = -1
                  }
                }
                return -1
              }

              throw new TypeError('val must be string, number or Buffer')
            }

            function hexWrite (buf, string, offset, length) {
              offset = Number(offset) || 0
              var remaining = buf.length - offset
              if (!length) {
                length = remaining
              } else {
                length = Number(length)
                if (length > remaining) {
                  length = remaining
                }
              }

              // must be an even number of digits
              var strLen = string.length
              if (strLen % 2 !== 0) throw new Error('Invalid hex string')

              if (length > strLen / 2) {
                length = strLen / 2
              }
              for (var i = 0; i < length; i++) {
                var parsed = parseInt(string.substr(i * 2, 2), 16)
                if (isNaN(parsed)) throw new Error('Invalid hex string')
                buf[offset + i] = parsed
              }
              return i
            }

            function utf8Write (buf, string, offset, length) {
              return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
            }

            function asciiWrite (buf, string, offset, length) {
              return blitBuffer(asciiToBytes(string), buf, offset, length)
            }

            function binaryWrite (buf, string, offset, length) {
              return asciiWrite(buf, string, offset, length)
            }

            function base64Write (buf, string, offset, length) {
              return blitBuffer(base64ToBytes(string), buf, offset, length)
            }

            function ucs2Write (buf, string, offset, length) {
              return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
            }

            Buffer.prototype.write = function write (string, offset, length, encoding) {
              // Buffer#write(string)
              if (offset === undefined) {
                encoding = 'utf8'
                length = this.length
                offset = 0
              // Buffer#write(string, encoding)
              } else if (length === undefined && typeof offset === 'string') {
                encoding = offset
                length = this.length
                offset = 0
              // Buffer#write(string, offset[, length][, encoding])
              } else if (isFinite(offset)) {
                offset = offset | 0
                if (isFinite(length)) {
                  length = length | 0
                  if (encoding === undefined) encoding = 'utf8'
                } else {
                  encoding = length
                  length = undefined
                }
              // legacy write(string, encoding, offset, length) - remove in v0.13
              } else {
                var swap = encoding
                encoding = offset
                offset = length | 0
                length = swap
              }

              var remaining = this.length - offset
              if (length === undefined || length > remaining) length = remaining

              if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
                throw new RangeError('attempt to write outside buffer bounds')
              }

              if (!encoding) encoding = 'utf8'

              var loweredCase = false
              for (;;) {
                switch (encoding) {
                  case 'hex':
                    return hexWrite(this, string, offset, length)

                  case 'utf8':
                  case 'utf-8':
                    return utf8Write(this, string, offset, length)

                  case 'ascii':
                    return asciiWrite(this, string, offset, length)

                  case 'binary':
                    return binaryWrite(this, string, offset, length)

                  case 'base64':
                    // Warning: maxLength not taken into account in base64Write
                    return base64Write(this, string, offset, length)

                  case 'ucs2':
                  case 'ucs-2':
                  case 'utf16le':
                  case 'utf-16le':
                    return ucs2Write(this, string, offset, length)

                  default:
                    if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
                    encoding = ('' + encoding).toLowerCase()
                    loweredCase = true
                }
              }
            }

            Buffer.prototype.toJSON = function toJSON () {
              return {
                type: 'Buffer',
                data: Array.prototype.slice.call(this._arr || this, 0)
              }
            }

            function base64Slice (buf, start, end) {
              if (start === 0 && end === buf.length) {
                return base64.fromByteArray(buf)
              } else {
                return base64.fromByteArray(buf.slice(start, end))
              }
            }

            function utf8Slice (buf, start, end) {
              end = Math.min(buf.length, end)
              var res = []

              var i = start
              while (i < end) {
                var firstByte = buf[i]
                var codePoint = null
                var bytesPerSequence = (firstByte > 0xEF) ? 4
                  : (firstByte > 0xDF) ? 3
                  : (firstByte > 0xBF) ? 2
                  : 1

                if (i + bytesPerSequence <= end) {
                  var secondByte, thirdByte, fourthByte, tempCodePoint

                  switch (bytesPerSequence) {
                    case 1:
                      if (firstByte < 0x80) {
                        codePoint = firstByte
                      }
                      break
                    case 2:
                      secondByte = buf[i + 1]
                      if ((secondByte & 0xC0) === 0x80) {
                        tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F)
                        if (tempCodePoint > 0x7F) {
                          codePoint = tempCodePoint
                        }
                      }
                      break
                    case 3:
                      secondByte = buf[i + 1]
                      thirdByte = buf[i + 2]
                      if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
                        tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F)
                        if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
                          codePoint = tempCodePoint
                        }
                      }
                      break
                    case 4:
                      secondByte = buf[i + 1]
                      thirdByte = buf[i + 2]
                      fourthByte = buf[i + 3]
                      if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
                        tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F)
                        if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
                          codePoint = tempCodePoint
                        }
                      }
                  }
                }

                if (codePoint === null) {
                  // we did not generate a valid codePoint so insert a
                  // replacement char (U+FFFD) and advance only 1 byte
                  codePoint = 0xFFFD
                  bytesPerSequence = 1
                } else if (codePoint > 0xFFFF) {
                  // encode to utf16 (surrogate pair dance)
                  codePoint -= 0x10000
                  res.push(codePoint >>> 10 & 0x3FF | 0xD800)
                  codePoint = 0xDC00 | codePoint & 0x3FF
                }

                res.push(codePoint)
                i += bytesPerSequence
              }

              return decodeCodePointsArray(res)
            }

            // Based on http://stackoverflow.com/a/22747272/680742, the browser with
            // the lowest limit is Chrome, with 0x10000 args.
            // We go 1 magnitude less, for safety
            var MAX_ARGUMENTS_LENGTH = 0x1000

            function decodeCodePointsArray (codePoints) {
              var len = codePoints.length
              if (len <= MAX_ARGUMENTS_LENGTH) {
                return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
              }

              // Decode in chunks to avoid "call stack size exceeded".
              var res = ''
              var i = 0
              while (i < len) {
                res += String.fromCharCode.apply(
                  String,
                  codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
                )
              }
              return res
            }

            function asciiSlice (buf, start, end) {
              var ret = ''
              end = Math.min(buf.length, end)

              for (var i = start; i < end; i++) {
                ret += String.fromCharCode(buf[i] & 0x7F)
              }
              return ret
            }

            function binarySlice (buf, start, end) {
              var ret = ''
              end = Math.min(buf.length, end)

              for (var i = start; i < end; i++) {
                ret += String.fromCharCode(buf[i])
              }
              return ret
            }

            function hexSlice (buf, start, end) {
              var len = buf.length

              if (!start || start < 0) start = 0
              if (!end || end < 0 || end > len) end = len

              var out = ''
              for (var i = start; i < end; i++) {
                out += toHex(buf[i])
              }
              return out
            }

            function utf16leSlice (buf, start, end) {
              var bytes = buf.slice(start, end)
              var res = ''
              for (var i = 0; i < bytes.length; i += 2) {
                res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256)
              }
              return res
            }

            Buffer.prototype.slice = function slice (start, end) {
              var len = this.length
              start = ~~start
              end = end === undefined ? len : ~~end

              if (start < 0) {
                start += len
                if (start < 0) start = 0
              } else if (start > len) {
                start = len
              }

              if (end < 0) {
                end += len
                if (end < 0) end = 0
              } else if (end > len) {
                end = len
              }

              if (end < start) end = start

              var newBuf
              if (Buffer.TYPED_ARRAY_SUPPORT) {
                newBuf = this.subarray(start, end)
                newBuf.__proto__ = Buffer.prototype
              } else {
                var sliceLen = end - start
                newBuf = new Buffer(sliceLen, undefined)
                for (var i = 0; i < sliceLen; i++) {
                  newBuf[i] = this[i + start]
                }
              }

              if (newBuf.length) newBuf.parent = this.parent || this

              return newBuf
            }

            /*
             * Need to make sure that buffer isn't trying to write out of bounds.
             */
            function checkOffset (offset, ext, length) {
              if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
              if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
            }

            Buffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
              offset = offset | 0
              byteLength = byteLength | 0
              if (!noAssert) checkOffset(offset, byteLength, this.length)

              var val = this[offset]
              var mul = 1
              var i = 0
              while (++i < byteLength && (mul *= 0x100)) {
                val += this[offset + i] * mul
              }

              return val
            }

            Buffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
              offset = offset | 0
              byteLength = byteLength | 0
              if (!noAssert) {
                checkOffset(offset, byteLength, this.length)
              }

              var val = this[offset + --byteLength]
              var mul = 1
              while (byteLength > 0 && (mul *= 0x100)) {
                val += this[offset + --byteLength] * mul
              }

              return val
            }

            Buffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 1, this.length)
              return this[offset]
            }

            Buffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 2, this.length)
              return this[offset] | (this[offset + 1] << 8)
            }

            Buffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 2, this.length)
              return (this[offset] << 8) | this[offset + 1]
            }

            Buffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length)

              return ((this[offset]) |
                  (this[offset + 1] << 8) |
                  (this[offset + 2] << 16)) +
                  (this[offset + 3] * 0x1000000)
            }

            Buffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length)

              return (this[offset] * 0x1000000) +
                ((this[offset + 1] << 16) |
                (this[offset + 2] << 8) |
                this[offset + 3])
            }

            Buffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
              offset = offset | 0
              byteLength = byteLength | 0
              if (!noAssert) checkOffset(offset, byteLength, this.length)

              var val = this[offset]
              var mul = 1
              var i = 0
              while (++i < byteLength && (mul *= 0x100)) {
                val += this[offset + i] * mul
              }
              mul *= 0x80

              if (val >= mul) val -= Math.pow(2, 8 * byteLength)

              return val
            }

            Buffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
              offset = offset | 0
              byteLength = byteLength | 0
              if (!noAssert) checkOffset(offset, byteLength, this.length)

              var i = byteLength
              var mul = 1
              var val = this[offset + --i]
              while (i > 0 && (mul *= 0x100)) {
                val += this[offset + --i] * mul
              }
              mul *= 0x80

              if (val >= mul) val -= Math.pow(2, 8 * byteLength)

              return val
            }

            Buffer.prototype.readInt8 = function readInt8 (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 1, this.length)
              if (!(this[offset] & 0x80)) return (this[offset])
              return ((0xff - this[offset] + 1) * -1)
            }

            Buffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 2, this.length)
              var val = this[offset] | (this[offset + 1] << 8)
              return (val & 0x8000) ? val | 0xFFFF0000 : val
            }

            Buffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 2, this.length)
              var val = this[offset + 1] | (this[offset] << 8)
              return (val & 0x8000) ? val | 0xFFFF0000 : val
            }

            Buffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length)

              return (this[offset]) |
                (this[offset + 1] << 8) |
                (this[offset + 2] << 16) |
                (this[offset + 3] << 24)
            }

            Buffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length)

              return (this[offset] << 24) |
                (this[offset + 1] << 16) |
                (this[offset + 2] << 8) |
                (this[offset + 3])
            }

            Buffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length)
              return ieee754.read(this, offset, true, 23, 4)
            }

            Buffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length)
              return ieee754.read(this, offset, false, 23, 4)
            }

            Buffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 8, this.length)
              return ieee754.read(this, offset, true, 52, 8)
            }

            Buffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 8, this.length)
              return ieee754.read(this, offset, false, 52, 8)
            }

            function checkInt (buf, value, offset, ext, max, min) {
              if (!Buffer.isBuffer(buf)) throw new TypeError('buffer must be a Buffer instance')
              if (value > max || value < min) throw new RangeError('value is out of bounds')
              if (offset + ext > buf.length) throw new RangeError('index out of range')
            }

            Buffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
              value = +value
              offset = offset | 0
              byteLength = byteLength | 0
              if (!noAssert) checkInt(this, value, offset, byteLength, Math.pow(2, 8 * byteLength), 0)

              var mul = 1
              var i = 0
              this[offset] = value & 0xFF
              while (++i < byteLength && (mul *= 0x100)) {
                this[offset + i] = (value / mul) & 0xFF
              }

              return offset + byteLength
            }

            Buffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
              value = +value
              offset = offset | 0
              byteLength = byteLength | 0
              if (!noAssert) checkInt(this, value, offset, byteLength, Math.pow(2, 8 * byteLength), 0)

              var i = byteLength - 1
              var mul = 1
              this[offset + i] = value & 0xFF
              while (--i >= 0 && (mul *= 0x100)) {
                this[offset + i] = (value / mul) & 0xFF
              }

              return offset + byteLength
            }

            Buffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0)
              if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
              this[offset] = (value & 0xff)
              return offset + 1
            }

            function objectWriteUInt16 (buf, value, offset, littleEndian) {
              if (value < 0) value = 0xffff + value + 1
              for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; i++) {
                buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
                  (littleEndian ? i : 1 - i) * 8
              }
            }

            Buffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
              if (Buffer.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value & 0xff)
                this[offset + 1] = (value >>> 8)
              } else {
                objectWriteUInt16(this, value, offset, true)
              }
              return offset + 2
            }

            Buffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
              if (Buffer.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value >>> 8)
                this[offset + 1] = (value & 0xff)
              } else {
                objectWriteUInt16(this, value, offset, false)
              }
              return offset + 2
            }

            function objectWriteUInt32 (buf, value, offset, littleEndian) {
              if (value < 0) value = 0xffffffff + value + 1
              for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; i++) {
                buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff
              }
            }

            Buffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
              if (Buffer.TYPED_ARRAY_SUPPORT) {
                this[offset + 3] = (value >>> 24)
                this[offset + 2] = (value >>> 16)
                this[offset + 1] = (value >>> 8)
                this[offset] = (value & 0xff)
              } else {
                objectWriteUInt32(this, value, offset, true)
              }
              return offset + 4
            }

            Buffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
              if (Buffer.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value >>> 24)
                this[offset + 1] = (value >>> 16)
                this[offset + 2] = (value >>> 8)
                this[offset + 3] = (value & 0xff)
              } else {
                objectWriteUInt32(this, value, offset, false)
              }
              return offset + 4
            }

            Buffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) {
                var limit = Math.pow(2, 8 * byteLength - 1)

                checkInt(this, value, offset, byteLength, limit - 1, -limit)
              }

              var i = 0
              var mul = 1
              var sub = value < 0 ? 1 : 0
              this[offset] = value & 0xFF
              while (++i < byteLength && (mul *= 0x100)) {
                this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
              }

              return offset + byteLength
            }

            Buffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) {
                var limit = Math.pow(2, 8 * byteLength - 1)

                checkInt(this, value, offset, byteLength, limit - 1, -limit)
              }

              var i = byteLength - 1
              var mul = 1
              var sub = value < 0 ? 1 : 0
              this[offset + i] = value & 0xFF
              while (--i >= 0 && (mul *= 0x100)) {
                this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
              }

              return offset + byteLength
            }

            Buffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80)
              if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
              if (value < 0) value = 0xff + value + 1
              this[offset] = (value & 0xff)
              return offset + 1
            }

            Buffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
              if (Buffer.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value & 0xff)
                this[offset + 1] = (value >>> 8)
              } else {
                objectWriteUInt16(this, value, offset, true)
              }
              return offset + 2
            }

            Buffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
              if (Buffer.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value >>> 8)
                this[offset + 1] = (value & 0xff)
              } else {
                objectWriteUInt16(this, value, offset, false)
              }
              return offset + 2
            }

            Buffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
              if (Buffer.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value & 0xff)
                this[offset + 1] = (value >>> 8)
                this[offset + 2] = (value >>> 16)
                this[offset + 3] = (value >>> 24)
              } else {
                objectWriteUInt32(this, value, offset, true)
              }
              return offset + 4
            }

            Buffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
              value = +value
              offset = offset | 0
              if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
              if (value < 0) value = 0xffffffff + value + 1
              if (Buffer.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value >>> 24)
                this[offset + 1] = (value >>> 16)
                this[offset + 2] = (value >>> 8)
                this[offset + 3] = (value & 0xff)
              } else {
                objectWriteUInt32(this, value, offset, false)
              }
              return offset + 4
            }

            function checkIEEE754 (buf, value, offset, ext, max, min) {
              if (offset + ext > buf.length) throw new RangeError('index out of range')
              if (offset < 0) throw new RangeError('index out of range')
            }

            function writeFloat (buf, value, offset, littleEndian, noAssert) {
              if (!noAssert) {
                checkIEEE754(buf, value, offset, 4, 3.4028234663852886e+38, -3.4028234663852886e+38)
              }
              ieee754.write(buf, value, offset, littleEndian, 23, 4)
              return offset + 4
            }

            Buffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
              return writeFloat(this, value, offset, true, noAssert)
            }

            Buffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
              return writeFloat(this, value, offset, false, noAssert)
            }

            function writeDouble (buf, value, offset, littleEndian, noAssert) {
              if (!noAssert) {
                checkIEEE754(buf, value, offset, 8, 1.7976931348623157E+308, -1.7976931348623157E+308)
              }
              ieee754.write(buf, value, offset, littleEndian, 52, 8)
              return offset + 8
            }

            Buffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
              return writeDouble(this, value, offset, true, noAssert)
            }

            Buffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
              return writeDouble(this, value, offset, false, noAssert)
            }

            // copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
            Buffer.prototype.copy = function copy (target, targetStart, start, end) {
              if (!start) start = 0
              if (!end && end !== 0) end = this.length
              if (targetStart >= target.length) targetStart = target.length
              if (!targetStart) targetStart = 0
              if (end > 0 && end < start) end = start

              // Copy 0 bytes; we're done
              if (end === start) return 0
              if (target.length === 0 || this.length === 0) return 0

              // Fatal error conditions
              if (targetStart < 0) {
                throw new RangeError('targetStart out of bounds')
              }
              if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
              if (end < 0) throw new RangeError('sourceEnd out of bounds')

              // Are we oob?
              if (end > this.length) end = this.length
              if (target.length - targetStart < end - start) {
                end = target.length - targetStart + start
              }

              var len = end - start
              var i

              if (this === target && start < targetStart && targetStart < end) {
                // descending copy from end
                for (i = len - 1; i >= 0; i--) {
                  target[i + targetStart] = this[i + start]
                }
              } else if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
                // ascending copy from start
                for (i = 0; i < len; i++) {
                  target[i + targetStart] = this[i + start]
                }
              } else {
                Uint8Array.prototype.set.call(
                  target,
                  this.subarray(start, start + len),
                  targetStart
                )
              }

              return len
            }

            // fill(value, start=0, end=buffer.length)
            Buffer.prototype.fill = function fill (value, start, end) {
              if (!value) value = 0
              if (!start) start = 0
              if (!end) end = this.length

              if (end < start) throw new RangeError('end < start')

              // Fill 0 bytes; we're done
              if (end === start) return
              if (this.length === 0) return

              if (start < 0 || start >= this.length) throw new RangeError('start out of bounds')
              if (end < 0 || end > this.length) throw new RangeError('end out of bounds')

              var i
              if (typeof value === 'number') {
                for (i = start; i < end; i++) {
                  this[i] = value
                }
              } else {
                var bytes = utf8ToBytes(value.toString())
                var len = bytes.length
                for (i = start; i < end; i++) {
                  this[i] = bytes[i % len]
                }
              }

              return this
            }

            // HELPER FUNCTIONS
            // ================

            var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g

            function base64clean (str) {
              // Node strips out invalid characters like \n and \t from the string, base64-js does not
              str = stringtrim(str).replace(INVALID_BASE64_RE, '')
              // Node converts strings with length < 2 to ''
              if (str.length < 2) return ''
              // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
              while (str.length % 4 !== 0) {
                str = str + '='
              }
              return str
            }

            function stringtrim (str) {
              if (str.trim) return str.trim()
              return str.replace(/^\s+|\s+$/g, '')
            }

            function toHex (n) {
              if (n < 16) return '0' + n.toString(16)
              return n.toString(16)
            }

            function utf8ToBytes (string, units) {
              units = units || Infinity
              var codePoint
              var length = string.length
              var leadSurrogate = null
              var bytes = []

              for (var i = 0; i < length; i++) {
                codePoint = string.charCodeAt(i)

                // is surrogate component
                if (codePoint > 0xD7FF && codePoint < 0xE000) {
                  // last char was a lead
                  if (!leadSurrogate) {
                    // no lead yet
                    if (codePoint > 0xDBFF) {
                      // unexpected trail
                      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
                      continue
                    } else if (i + 1 === length) {
                      // unpaired lead
                      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
                      continue
                    }

                    // valid lead
                    leadSurrogate = codePoint

                    continue
                  }

                  // 2 leads in a row
                  if (codePoint < 0xDC00) {
                    if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
                    leadSurrogate = codePoint
                    continue
                  }

                  // valid surrogate pair
                  codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000
                } else if (leadSurrogate) {
                  // valid bmp char, but last char was a lead
                  if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
                }

                leadSurrogate = null

                // encode utf8
                if (codePoint < 0x80) {
                  if ((units -= 1) < 0) break
                  bytes.push(codePoint)
                } else if (codePoint < 0x800) {
                  if ((units -= 2) < 0) break
                  bytes.push(
                    codePoint >> 0x6 | 0xC0,
                    codePoint & 0x3F | 0x80
                  )
                } else if (codePoint < 0x10000) {
                  if ((units -= 3) < 0) break
                  bytes.push(
                    codePoint >> 0xC | 0xE0,
                    codePoint >> 0x6 & 0x3F | 0x80,
                    codePoint & 0x3F | 0x80
                  )
                } else if (codePoint < 0x110000) {
                  if ((units -= 4) < 0) break
                  bytes.push(
                    codePoint >> 0x12 | 0xF0,
                    codePoint >> 0xC & 0x3F | 0x80,
                    codePoint >> 0x6 & 0x3F | 0x80,
                    codePoint & 0x3F | 0x80
                  )
                } else {
                  throw new Error('Invalid code point')
                }
              }

              return bytes
            }

            function asciiToBytes (str) {
              var byteArray = []
              for (var i = 0; i < str.length; i++) {
                // Node's code seems to be doing this and not & 0x7F..
                byteArray.push(str.charCodeAt(i) & 0xFF)
              }
              return byteArray
            }

            function utf16leToBytes (str, units) {
              var c, hi, lo
              var byteArray = []
              for (var i = 0; i < str.length; i++) {
                if ((units -= 2) < 0) break

                c = str.charCodeAt(i)
                hi = c >> 8
                lo = c % 256
                byteArray.push(lo)
                byteArray.push(hi)
              }

              return byteArray
            }

            function base64ToBytes (str) {
              return base64.toByteArray(base64clean(str))
            }

            function blitBuffer (src, dst, offset, length) {
              for (var i = 0; i < length; i++) {
                if ((i + offset >= dst.length) || (i >= src.length)) break
                dst[i + offset] = src[i]
              }
              return i
            }

            }).call(this,typeof global$1 !== "undefined" ? global$1 : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
            },{"base64-js":1,"ieee754":4,"isarray":3}],3:[function(require,module,exports){
            var toString = {}.toString;

            module.exports = Array.isArray || function (arr) {
              return toString.call(arr) == '[object Array]';
            };

            },{}],4:[function(require,module,exports){
            exports.read = function (buffer, offset, isLE, mLen, nBytes) {
              var e, m
              var eLen = nBytes * 8 - mLen - 1
              var eMax = (1 << eLen) - 1
              var eBias = eMax >> 1
              var nBits = -7
              var i = isLE ? (nBytes - 1) : 0
              var d = isLE ? -1 : 1
              var s = buffer[offset + i]

              i += d

              e = s & ((1 << (-nBits)) - 1)
              s >>= (-nBits)
              nBits += eLen
              for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

              m = e & ((1 << (-nBits)) - 1)
              e >>= (-nBits)
              nBits += mLen
              for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

              if (e === 0) {
                e = 1 - eBias
              } else if (e === eMax) {
                return m ? NaN : ((s ? -1 : 1) * Infinity)
              } else {
                m = m + Math.pow(2, mLen)
                e = e - eBias
              }
              return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
            }

            exports.write = function (buffer, value, offset, isLE, mLen, nBytes) {
              var e, m, c
              var eLen = nBytes * 8 - mLen - 1
              var eMax = (1 << eLen) - 1
              var eBias = eMax >> 1
              var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0)
              var i = isLE ? 0 : (nBytes - 1)
              var d = isLE ? 1 : -1
              var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0

              value = Math.abs(value)

              if (isNaN(value) || value === Infinity) {
                m = isNaN(value) ? 1 : 0
                e = eMax
              } else {
                e = Math.floor(Math.log(value) / Math.LN2)
                if (value * (c = Math.pow(2, -e)) < 1) {
                  e--
                  c *= 2
                }
                if (e + eBias >= 1) {
                  value += rt / c
                } else {
                  value += rt * Math.pow(2, 1 - eBias)
                }
                if (value * c >= 2) {
                  e++
                  c /= 2
                }

                if (e + eBias >= eMax) {
                  m = 0
                  e = eMax
                } else if (e + eBias >= 1) {
                  m = (value * c - 1) * Math.pow(2, mLen)
                  e = e + eBias
                } else {
                  m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen)
                  e = 0
                }
              }

              for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

              e = (e << mLen) | m
              eLen += mLen
              for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

              buffer[offset + i - d] |= s * 128
            }

            },{}],5:[function(require,module,exports){
            (function (Buffer){
            _buffer = Buffer;

            }).call(this,require("buffer").Buffer)
            },{"buffer":2}]},{},[5]);
            var Buffer = _buffer;

            var _baseFindIndex = __commonjs(function (module) {
            /**
             * The base implementation of `_.findIndex` and `_.findLastIndex` without
             * support for iteratee shorthands.
             *
             * @private
             * @param {Array} array The array to search.
             * @param {Function} predicate The function invoked per iteration.
             * @param {boolean} [fromRight] Specify iterating from right to left.
             * @returns {number} Returns the index of the matched value, else `-1`.
             */
            function baseFindIndex(array, predicate, fromRight) {
              var length = array.length,
                  index = fromRight ? length : -1;

              while ((fromRight ? index-- : ++index < length)) {
                if (predicate(array[index], index, array)) {
                  return index;
                }
              }
              return -1;
            }

            module.exports = baseFindIndex;
            });

            var require$$2$14 = (_baseFindIndex && typeof _baseFindIndex === 'object' && 'default' in _baseFindIndex ? _baseFindIndex['default'] : _baseFindIndex);

            var _baseFind = __commonjs(function (module) {
            /**
             * The base implementation of methods like `_.find` and `_.findKey`, without
             * support for iteratee shorthands, which iterates over `collection` using
             * `eachFunc`.
             *
             * @private
             * @param {Array|Object} collection The collection to search.
             * @param {Function} predicate The function invoked per iteration.
             * @param {Function} eachFunc The function to iterate over `collection`.
             * @param {boolean} [retKey] Specify returning the key of the found element
             *  instead of the element itself.
             * @returns {*} Returns the found element or its key, else `undefined`.
             */
            function baseFind(collection, predicate, eachFunc, retKey) {
              var result;
              eachFunc(collection, function(value, key, collection) {
                if (predicate(value, key, collection)) {
                  result = retKey ? key : value;
                  return false;
                }
              });
              return result;
            }

            module.exports = baseFind;
            });

            var require$$3$15 = (_baseFind && typeof _baseFind === 'object' && 'default' in _baseFind ? _baseFind['default'] : _baseFind);

            var find$1 = __commonjs(function (module) {
            var baseEach = require$$4$10,
                baseFind = require$$3$15,
                baseFindIndex = require$$2$14,
                baseIteratee = require$$1$11,
                isArray = require$$0$21;

            /**
             * Iterates over elements of `collection`, returning the first element
             * `predicate` returns truthy for. The predicate is invoked with three
             * arguments: (value, index|key, collection).
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Collection
             * @param {Array|Object} collection The collection to search.
             * @param {Array|Function|Object|string} [predicate=_.identity]
             *  The function invoked per iteration.
             * @returns {*} Returns the matched element, else `undefined`.
             * @example
             *
             * var users = [
             *   { 'user': 'barney',  'age': 36, 'active': true },
             *   { 'user': 'fred',    'age': 40, 'active': false },
             *   { 'user': 'pebbles', 'age': 1,  'active': true }
             * ];
             *
             * _.find(users, function(o) { return o.age < 40; });
             * // => object for 'barney'
             *
             * // The `_.matches` iteratee shorthand.
             * _.find(users, { 'age': 1, 'active': true });
             * // => object for 'pebbles'
             *
             * // The `_.matchesProperty` iteratee shorthand.
             * _.find(users, ['active', false]);
             * // => object for 'fred'
             *
             * // The `_.property` iteratee shorthand.
             * _.find(users, 'active');
             * // => object for 'barney'
             */
            function find(collection, predicate) {
              predicate = baseIteratee(predicate, 3);
              if (isArray(collection)) {
                var index = baseFindIndex(collection, predicate);
                return index > -1 ? collection[index] : undefined;
              }
              return baseFind(collection, predicate, baseEach);
            }

            module.exports = find;
            });

            var _find = (find$1 && typeof find$1 === 'object' && 'default' in find$1 ? find$1['default'] : find$1);

            var noop$1 = __commonjs(function (module) {
            /**
             * A no-operation function that returns `undefined` regardless of the
             * arguments it receives.
             *
             * @static
             * @memberOf _
             * @since 2.3.0
             * @category Util
             * @example
             *
             * var object = { 'user': 'fred' };
             *
             * _.noop(object) === undefined;
             * // => true
             */
            function noop() {
              // No operation performed.
            }

            module.exports = noop;
            });

            var require$$0$51 = (noop$1 && typeof noop$1 === 'object' && 'default' in noop$1 ? noop$1['default'] : noop$1);

            var _createSet = __commonjs(function (module) {
            var Set = require$$1$18,
                noop = require$$0$51;

            /**
             * Creates a set of `values`.
             *
             * @private
             * @param {Array} values The values to add to the set.
             * @returns {Object} Returns the new set.
             */
            var createSet = !(Set && new Set([1, 2]).size === 2) ? noop : function(values) {
              return new Set(values);
            };

            module.exports = createSet;
            });

            var require$$1$39 = (_createSet && typeof _createSet === 'object' && 'default' in _createSet ? _createSet['default'] : _createSet);

            var _baseUniq = __commonjs(function (module) {
            var SetCache = require$$5,
                arrayIncludes = require$$4$1,
                arrayIncludesWith = require$$3$1,
                cacheHas = require$$2$3,
                createSet = require$$1$39,
                setToArray = require$$0$32;

            /** Used as the size to enable large array optimizations. */
            var LARGE_ARRAY_SIZE = 200;

            /**
             * The base implementation of `_.uniqBy` without support for iteratee shorthands.
             *
             * @private
             * @param {Array} array The array to inspect.
             * @param {Function} [iteratee] The iteratee invoked per element.
             * @param {Function} [comparator] The comparator invoked per element.
             * @returns {Array} Returns the new duplicate free array.
             */
            function baseUniq(array, iteratee, comparator) {
              var index = -1,
                  includes = arrayIncludes,
                  length = array.length,
                  isCommon = true,
                  result = [],
                  seen = result;

              if (comparator) {
                isCommon = false;
                includes = arrayIncludesWith;
              }
              else if (length >= LARGE_ARRAY_SIZE) {
                var set = iteratee ? null : createSet(array);
                if (set) {
                  return setToArray(set);
                }
                isCommon = false;
                includes = cacheHas;
                seen = new SetCache;
              }
              else {
                seen = iteratee ? [] : result;
              }
              outer:
              while (++index < length) {
                var value = array[index],
                    computed = iteratee ? iteratee(value) : value;

                if (isCommon && computed === computed) {
                  var seenIndex = seen.length;
                  while (seenIndex--) {
                    if (seen[seenIndex] === computed) {
                      continue outer;
                    }
                  }
                  if (iteratee) {
                    seen.push(computed);
                  }
                  result.push(value);
                }
                else if (!includes(seen, computed, comparator)) {
                  if (seen !== result) {
                    seen.push(computed);
                  }
                  result.push(value);
                }
              }
              return result;
            }

            module.exports = baseUniq;
            });

            var require$$1$38 = (_baseUniq && typeof _baseUniq === 'object' && 'default' in _baseUniq ? _baseUniq['default'] : _baseUniq);

            var union = __commonjs(function (module) {
            var baseFlatten = require$$2$12,
                baseUniq = require$$1$38,
                rest = require$$0;

            /**
             * Creates an array of unique values, in order, from all given arrays using
             * [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
             * for equality comparisons.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Array
             * @param {...Array} [arrays] The arrays to inspect.
             * @returns {Array} Returns the new array of combined values.
             * @example
             *
             * _.union([2, 1], [4, 2], [1, 2]);
             * // => [2, 1, 4]
             */
            var union = rest(function(arrays) {
              return baseUniq(baseFlatten(arrays, 1, true));
            });

            module.exports = union;
            });

            var _union = (union && typeof union === 'object' && 'default' in union ? union['default'] : union);

            var jsep = __commonjs(function (module, exports, global) {
            //     JavaScript Expression Parser (JSEP) 0.3.0
            //     JSEP may be freely distributed under the MIT License
            //     http://jsep.from.so/

            /*global module: true, exports: true, console: true */
            (function (root) {
            	'use strict';
            	// Node Types
            	// ----------
            	
            	// This is the full set of types that any JSEP node can be.
            	// Store them here to save space when minified
            	var COMPOUND = 'Compound',
            		IDENTIFIER = 'Identifier',
            		MEMBER_EXP = 'MemberExpression',
            		LITERAL = 'Literal',
            		THIS_EXP = 'ThisExpression',
            		CALL_EXP = 'CallExpression',
            		UNARY_EXP = 'UnaryExpression',
            		BINARY_EXP = 'BinaryExpression',
            		LOGICAL_EXP = 'LogicalExpression',
            		CONDITIONAL_EXP = 'ConditionalExpression',
            		ARRAY_EXP = 'ArrayExpression',

            		PERIOD_CODE = 46, // '.'
            		COMMA_CODE  = 44, // ','
            		SQUOTE_CODE = 39, // single quote
            		DQUOTE_CODE = 34, // double quotes
            		OPAREN_CODE = 40, // (
            		CPAREN_CODE = 41, // )
            		OBRACK_CODE = 91, // [
            		CBRACK_CODE = 93, // ]
            		QUMARK_CODE = 63, // ?
            		SEMCOL_CODE = 59, // ;
            		COLON_CODE  = 58, // :

            		throwError = function(message, index) {
            			var error = new Error(message + ' at character ' + index);
            			error.index = index;
            			error.description = message;
            			throw error;
            		},

            	// Operations
            	// ----------
            	
            	// Set `t` to `true` to save space (when minified, not gzipped)
            		t = true,
            	// Use a quickly-accessible map to store all of the unary operators
            	// Values are set to `true` (it really doesn't matter)
            		unary_ops = {'-': t, '!': t, '~': t, '+': t},
            	// Also use a map for the binary operations but set their values to their
            	// binary precedence for quick reference:
            	// see [Order of operations](http://en.wikipedia.org/wiki/Order_of_operations#Programming_language)
            		binary_ops = {
            			'||': 1, '&&': 2, '|': 3,  '^': 4,  '&': 5,
            			'==': 6, '!=': 6, '===': 6, '!==': 6,
            			'<': 7,  '>': 7,  '<=': 7,  '>=': 7, 
            			'<<':8,  '>>': 8, '>>>': 8,
            			'+': 9, '-': 9,
            			'*': 10, '/': 10, '%': 10
            		},
            	// Get return the longest key length of any object
            		getMaxKeyLen = function(obj) {
            			var max_len = 0, len;
            			for(var key in obj) {
            				if((len = key.length) > max_len && obj.hasOwnProperty(key)) {
            					max_len = len;
            				}
            			}
            			return max_len;
            		},
            		max_unop_len = getMaxKeyLen(unary_ops),
            		max_binop_len = getMaxKeyLen(binary_ops),
            	// Literals
            	// ----------
            	// Store the values to return for the various literals we may encounter
            		literals = {
            			'true': true,
            			'false': false,
            			'null': null
            		},
            	// Except for `this`, which is special. This could be changed to something like `'self'` as well
            		this_str = 'this',
            	// Returns the precedence of a binary operator or `0` if it isn't a binary operator
            		binaryPrecedence = function(op_val) {
            			return binary_ops[op_val] || 0;
            		},
            	// Utility function (gets called from multiple places)
            	// Also note that `a && b` and `a || b` are *logical* expressions, not binary expressions
            		createBinaryExpression = function (operator, left, right) {
            			var type = (operator === '||' || operator === '&&') ? LOGICAL_EXP : BINARY_EXP;
            			return {
            				type: type,
            				operator: operator,
            				left: left,
            				right: right
            			};
            		},
            		// `ch` is a character code in the next three functions
            		isDecimalDigit = function(ch) {
            			return (ch >= 48 && ch <= 57); // 0...9
            		},
            		isIdentifierStart = function(ch) {
            			return (ch === 36) || (ch === 95) || // `$` and `_`
            					(ch >= 65 && ch <= 90) || // A...Z
            					(ch >= 97 && ch <= 122); // a...z
            		},
            		isIdentifierPart = function(ch) {
            			return (ch === 36) || (ch === 95) || // `$` and `_`
            					(ch >= 65 && ch <= 90) || // A...Z
            					(ch >= 97 && ch <= 122) || // a...z
            					(ch >= 48 && ch <= 57); // 0...9
            		},

            		// Parsing
            		// -------
            		// `expr` is a string with the passed in expression
            		jsep = function(expr) {
            			// `index` stores the character number we are currently at while `length` is a constant
            			// All of the gobbles below will modify `index` as we move along
            			var index = 0,
            				charAtFunc = expr.charAt,
            				charCodeAtFunc = expr.charCodeAt,
            				exprI = function(i) { return charAtFunc.call(expr, i); },
            				exprICode = function(i) { return charCodeAtFunc.call(expr, i); },
            				length = expr.length,

            				// Push `index` up to the next non-space character
            				gobbleSpaces = function() {
            					var ch = exprICode(index);
            					// space or tab
            					while(ch === 32 || ch === 9) {
            						ch = exprICode(++index);
            					}
            				},
            				
            				// The main parsing function. Much of this code is dedicated to ternary expressions
            				gobbleExpression = function() {
            					var test = gobbleBinaryExpression(),
            						consequent, alternate;
            					gobbleSpaces();
            					if(exprICode(index) === QUMARK_CODE) {
            						// Ternary expression: test ? consequent : alternate
            						index++;
            						consequent = gobbleExpression();
            						if(!consequent) {
            							throwError('Expected expression', index);
            						}
            						gobbleSpaces();
            						if(exprICode(index) === COLON_CODE) {
            							index++;
            							alternate = gobbleExpression();
            							if(!alternate) {
            								throwError('Expected expression', index);
            							}
            							return {
            								type: CONDITIONAL_EXP,
            								test: test,
            								consequent: consequent,
            								alternate: alternate
            							};
            						} else {
            							throwError('Expected :', index);
            						}
            					} else {
            						return test;
            					}
            				},

            				// Search for the operation portion of the string (e.g. `+`, `===`)
            				// Start by taking the longest possible binary operations (3 characters: `===`, `!==`, `>>>`)
            				// and move down from 3 to 2 to 1 character until a matching binary operation is found
            				// then, return that binary operation
            				gobbleBinaryOp = function() {
            					gobbleSpaces();
            					var biop, to_check = expr.substr(index, max_binop_len), tc_len = to_check.length;
            					while(tc_len > 0) {
            						if(binary_ops.hasOwnProperty(to_check)) {
            							index += tc_len;
            							return to_check;
            						}
            						to_check = to_check.substr(0, --tc_len);
            					}
            					return false;
            				},

            				// This function is responsible for gobbling an individual expression,
            				// e.g. `1`, `1+2`, `a+(b*2)-Math.sqrt(2)`
            				gobbleBinaryExpression = function() {
            					var ch_i, node, biop, prec, stack, biop_info, left, right, i;

            					// First, try to get the leftmost thing
            					// Then, check to see if there's a binary operator operating on that leftmost thing
            					left = gobbleToken();
            					biop = gobbleBinaryOp();

            					// If there wasn't a binary operator, just return the leftmost node
            					if(!biop) {
            						return left;
            					}

            					// Otherwise, we need to start a stack to properly place the binary operations in their
            					// precedence structure
            					biop_info = { value: biop, prec: binaryPrecedence(biop)};

            					right = gobbleToken();
            					if(!right) {
            						throwError("Expected expression after " + biop, index);
            					}
            					stack = [left, biop_info, right];

            					// Properly deal with precedence using [recursive descent](http://www.engr.mun.ca/~theo/Misc/exp_parsing.htm)
            					while((biop = gobbleBinaryOp())) {
            						prec = binaryPrecedence(biop);

            						if(prec === 0) {
            							break;
            						}
            						biop_info = { value: biop, prec: prec };

            						// Reduce: make a binary expression from the three topmost entries.
            						while ((stack.length > 2) && (prec <= stack[stack.length - 2].prec)) {
            							right = stack.pop();
            							biop = stack.pop().value;
            							left = stack.pop();
            							node = createBinaryExpression(biop, left, right);
            							stack.push(node);
            						}

            						node = gobbleToken();
            						if(!node) {
            							throwError("Expected expression after " + biop, index);
            						}
            						stack.push(biop_info, node);
            					}

            					i = stack.length - 1;
            					node = stack[i];
            					while(i > 1) {
            						node = createBinaryExpression(stack[i - 1].value, stack[i - 2], node); 
            						i -= 2;
            					}
            					return node;
            				},

            				// An individual part of a binary expression:
            				// e.g. `foo.bar(baz)`, `1`, `"abc"`, `(a % 2)` (because it's in parenthesis)
            				gobbleToken = function() {
            					var ch, to_check, tc_len;
            					
            					gobbleSpaces();
            					ch = exprICode(index);

            					if(isDecimalDigit(ch) || ch === PERIOD_CODE) {
            						// Char code 46 is a dot `.` which can start off a numeric literal
            						return gobbleNumericLiteral();
            					} else if(ch === SQUOTE_CODE || ch === DQUOTE_CODE) {
            						// Single or double quotes
            						return gobbleStringLiteral();
            					} else if(isIdentifierStart(ch) || ch === OPAREN_CODE) { // open parenthesis
            						// `foo`, `bar.baz`
            						return gobbleVariable();
            					} else if (ch === OBRACK_CODE) {
            						return gobbleArray();
            					} else {
            						to_check = expr.substr(index, max_unop_len);
            						tc_len = to_check.length;
            						while(tc_len > 0) {
            							if(unary_ops.hasOwnProperty(to_check)) {
            								index += tc_len;
            								return {
            									type: UNARY_EXP,
            									operator: to_check,
            									argument: gobbleToken(),
            									prefix: true
            								};
            							}
            							to_check = to_check.substr(0, --tc_len);
            						}
            						
            						return false;
            					}
            				},
            				// Parse simple numeric literals: `12`, `3.4`, `.5`. Do this by using a string to
            				// keep track of everything in the numeric literal and then calling `parseFloat` on that string
            				gobbleNumericLiteral = function() {
            					var number = '', ch, chCode;
            					while(isDecimalDigit(exprICode(index))) {
            						number += exprI(index++);
            					}

            					if(exprICode(index) === PERIOD_CODE) { // can start with a decimal marker
            						number += exprI(index++);

            						while(isDecimalDigit(exprICode(index))) {
            							number += exprI(index++);
            						}
            					}
            					
            					ch = exprI(index);
            					if(ch === 'e' || ch === 'E') { // exponent marker
            						number += exprI(index++);
            						ch = exprI(index);
            						if(ch === '+' || ch === '-') { // exponent sign
            							number += exprI(index++);
            						}
            						while(isDecimalDigit(exprICode(index))) { //exponent itself
            							number += exprI(index++);
            						}
            						if(!isDecimalDigit(exprICode(index-1)) ) {
            							throwError('Expected exponent (' + number + exprI(index) + ')', index);
            						}
            					}
            					

            					chCode = exprICode(index);
            					// Check to make sure this isn't a variable name that start with a number (123abc)
            					if(isIdentifierStart(chCode)) {
            						throwError('Variable names cannot start with a number (' +
            									number + exprI(index) + ')', index);
            					} else if(chCode === PERIOD_CODE) {
            						throwError('Unexpected period', index);
            					}

            					return {
            						type: LITERAL,
            						value: parseFloat(number),
            						raw: number
            					};
            				},

            				// Parses a string literal, staring with single or double quotes with basic support for escape codes
            				// e.g. `"hello world"`, `'this is\nJSEP'`
            				gobbleStringLiteral = function() {
            					var str = '', quote = exprI(index++), closed = false, ch;

            					while(index < length) {
            						ch = exprI(index++);
            						if(ch === quote) {
            							closed = true;
            							break;
            						} else if(ch === '\\') {
            							// Check for all of the common escape codes
            							ch = exprI(index++);
            							switch(ch) {
            								case 'n': str += '\n'; break;
            								case 'r': str += '\r'; break;
            								case 't': str += '\t'; break;
            								case 'b': str += '\b'; break;
            								case 'f': str += '\f'; break;
            								case 'v': str += '\x0B'; break;
            							}
            						} else {
            							str += ch;
            						}
            					}

            					if(!closed) {
            						throwError('Unclosed quote after "'+str+'"', index);
            					}

            					return {
            						type: LITERAL,
            						value: str,
            						raw: quote + str + quote
            					};
            				},
            				
            				// Gobbles only identifiers
            				// e.g.: `foo`, `_value`, `$x1`
            				// Also, this function checks if that identifier is a literal:
            				// (e.g. `true`, `false`, `null`) or `this`
            				gobbleIdentifier = function() {
            					var ch = exprICode(index), start = index, identifier;

            					if(isIdentifierStart(ch)) {
            						index++;
            					} else {
            						throwError('Unexpected ' + exprI(index), index);
            					}

            					while(index < length) {
            						ch = exprICode(index);
            						if(isIdentifierPart(ch)) {
            							index++;
            						} else {
            							break;
            						}
            					}
            					identifier = expr.slice(start, index);

            					if(literals.hasOwnProperty(identifier)) {
            						return {
            							type: LITERAL,
            							value: literals[identifier],
            							raw: identifier
            						};
            					} else if(identifier === this_str) {
            						return { type: THIS_EXP };
            					} else {
            						return {
            							type: IDENTIFIER,
            							name: identifier
            						};
            					}
            				},

            				// Gobbles a list of arguments within the context of a function call
            				// or array literal. This function also assumes that the opening character
            				// `(` or `[` has already been gobbled, and gobbles expressions and commas
            				// until the terminator character `)` or `]` is encountered.
            				// e.g. `foo(bar, baz)`, `my_func()`, or `[bar, baz]`
            				gobbleArguments = function(termination) {
            					var ch_i, args = [], node;
            					while(index < length) {
            						gobbleSpaces();
            						ch_i = exprICode(index);
            						if(ch_i === termination) { // done parsing
            							index++;
            							break;
            						} else if (ch_i === COMMA_CODE) { // between expressions
            							index++;
            						} else {
            							node = gobbleExpression();
            							if(!node || node.type === COMPOUND) {
            								throwError('Expected comma', index);
            							}
            							args.push(node);
            						}
            					}
            					return args;
            				},

            				// Gobble a non-literal variable name. This variable name may include properties
            				// e.g. `foo`, `bar.baz`, `foo['bar'].baz`
            				// It also gobbles function calls:
            				// e.g. `Math.acos(obj.angle)`
            				gobbleVariable = function() {
            					var ch_i, node;
            					ch_i = exprICode(index);
            						
            					if(ch_i === OPAREN_CODE) {
            						node = gobbleGroup();
            					} else {
            						node = gobbleIdentifier();
            					}
            					gobbleSpaces();
            					ch_i = exprICode(index);
            					while(ch_i === PERIOD_CODE || ch_i === OBRACK_CODE || ch_i === OPAREN_CODE) {
            						index++;
            						if(ch_i === PERIOD_CODE) {
            							gobbleSpaces();
            							node = {
            								type: MEMBER_EXP,
            								computed: false,
            								object: node,
            								property: gobbleIdentifier()
            							};
            						} else if(ch_i === OBRACK_CODE) {
            							node = {
            								type: MEMBER_EXP,
            								computed: true,
            								object: node,
            								property: gobbleExpression()
            							};
            							gobbleSpaces();
            							ch_i = exprICode(index);
            							if(ch_i !== CBRACK_CODE) {
            								throwError('Unclosed [', index);
            							}
            							index++;
            						} else if(ch_i === OPAREN_CODE) {
            							// A function call is being made; gobble all the arguments
            							node = {
            								type: CALL_EXP,
            								'arguments': gobbleArguments(CPAREN_CODE),
            								callee: node
            							};
            						}
            						gobbleSpaces();
            						ch_i = exprICode(index);
            					}
            					return node;
            				},

            				// Responsible for parsing a group of things within parentheses `()`
            				// This function assumes that it needs to gobble the opening parenthesis
            				// and then tries to gobble everything within that parenthesis, assuming
            				// that the next thing it should see is the close parenthesis. If not,
            				// then the expression probably doesn't have a `)`
            				gobbleGroup = function() {
            					index++;
            					var node = gobbleExpression();
            					gobbleSpaces();
            					if(exprICode(index) === CPAREN_CODE) {
            						index++;
            						return node;
            					} else {
            						throwError('Unclosed (', index);
            					}
            				},

            				// Responsible for parsing Array literals `[1, 2, 3]`
            				// This function assumes that it needs to gobble the opening bracket
            				// and then tries to gobble the expressions as arguments.
            				gobbleArray = function() {
            					index++;
            					return {
            						type: ARRAY_EXP,
            						elements: gobbleArguments(CBRACK_CODE)
            					};
            				},

            				nodes = [], ch_i, node;
            				
            			while(index < length) {
            				ch_i = exprICode(index);

            				// Expressions can be separated by semicolons, commas, or just inferred without any
            				// separators
            				if(ch_i === SEMCOL_CODE || ch_i === COMMA_CODE) {
            					index++; // ignore separators
            				} else {
            					// Try to gobble each expression individually
            					if((node = gobbleExpression())) {
            						nodes.push(node);
            					// If we weren't able to find a binary expression and are out of room, then
            					// the expression passed in probably has too much
            					} else if(index < length) {
            						throwError('Unexpected "' + exprI(index) + '"', index);
            					}
            				}
            			}

            			// If there's only one expression just try returning the expression
            			if(nodes.length === 1) {
            				return nodes[0];
            			} else {
            				return {
            					type: COMPOUND,
            					body: nodes
            				};
            			}
            		};

            	// To be filled in by the template
            	jsep.version = '0.3.0';
            	jsep.toString = function() { return 'JavaScript Expression Parser (JSEP) v' + jsep.version; };

            	/**
            	 * @method jsep.addUnaryOp
            	 * @param {string} op_name The name of the unary op to add
            	 * @return jsep
            	 */
            	jsep.addUnaryOp = function(op_name) {
            		unary_ops[op_name] = t; return this;
            	};

            	/**
            	 * @method jsep.addBinaryOp
            	 * @param {string} op_name The name of the binary op to add
            	 * @param {number} precedence The precedence of the binary op (can be a float)
            	 * @return jsep
            	 */
            	jsep.addBinaryOp = function(op_name, precedence) {
            		max_binop_len = Math.max(op_name.length, max_binop_len);
            		binary_ops[op_name] = precedence;
            		return this;
            	};

            	/**
            	 * @method jsep.removeUnaryOp
            	 * @param {string} op_name The name of the unary op to remove
            	 * @return jsep
            	 */
            	jsep.removeUnaryOp = function(op_name) {
            		delete unary_ops[op_name];
            		if(op_name.length === max_unop_len) {
            			max_unop_len = getMaxKeyLen(unary_ops);
            		}
            		return this;
            	};

            	/**
            	 * @method jsep.removeBinaryOp
            	 * @param {string} op_name The name of the binary op to remove
            	 * @return jsep
            	 */
            	jsep.removeBinaryOp = function(op_name) {
            		delete binary_ops[op_name];
            		if(op_name.length === max_binop_len) {
            			max_binop_len = getMaxKeyLen(binary_ops);
            		}
            		return this;
            	};

            	// In desktop environments, have a way to restore the old value for `jsep`
            	if (typeof exports === 'undefined') {
            		var old_jsep = root.jsep;
            		// The star of the show! It's a function!
            		root.jsep = jsep;
            		// And a courteous function willing to move out of the way for other similarly-named objects!
            		jsep.noConflict = function() {
            			if(root.jsep === jsep) {
            				root.jsep = old_jsep;
            			}
            			return jsep;
            		};
            	} else {
            		// In Node.JS environments
            		if (typeof module !== 'undefined' && module.exports) {
            			exports = module.exports = jsep;
            		} else {
            			exports.parse = jsep;
            		}
            	}
            }(__commonjs_global));
            });

            var jsep$1 = (jsep && typeof jsep === 'object' && 'default' in jsep ? jsep['default'] : jsep);

            var parser = function () {
              "use strict";

              /*
               * Generated by PEG.js 0.9.0.
               *
               * http://pegjs.org/
               */

              function peg$subclass(child, parent) {
                function ctor() {
                  this.constructor = child;
                }
                ctor.prototype = parent.prototype;
                child.prototype = new ctor();
              }

              function peg$SyntaxError(message, expected, found, location) {
                this.message = message;
                this.expected = expected;
                this.found = found;
                this.location = location;
                this.name = "SyntaxError";

                if (typeof Error.captureStackTrace === "function") {
                  Error.captureStackTrace(this, peg$SyntaxError);
                }
              }

              peg$subclass(peg$SyntaxError, Error);

              function peg$parse(input) {
                var options = arguments.length > 1 ? arguments[1] : {},
                    parser = this,
                    peg$FAILED = {},
                    peg$startRuleIndices = { start: 0 },
                    peg$startRuleIndex = 0,
                    peg$consts = [function (nodes) {
                  return createNode("File", {
                    filename: options.filename,
                    source: text(),
                    children: _map(nodes, 0)
                  });
                }, { type: "other", description: "template" }, "<", { type: "literal", value: "<", description: "\"<\"" }, "template", { type: "literal", value: "template", description: "\"template\"" }, ">", { type: "literal", value: ">", description: "\">\"" }, "</template>", { type: "literal", value: "</template>", description: "\"</template>\"" }, function (attrs, nodes) {
                  var name,
                      type,
                      plugins = [];

                  attrs = attrs.filter(function (a) {
                    switch (a.name) {
                      case "name":
                        name = a.value;
                        break;

                      case "type":
                        type = a.value;
                        break;

                      case "use":
                        plugins.push(a.value);
                        break;

                      default:
                        return true;
                    }
                  });

                  return createNode("Template", {
                    name: name,
                    type: type,
                    children: nodes,
                    plugins: plugins,
                    attributes: attrs
                  });
                }, { type: "other", description: "include" }, "include", { type: "literal", value: "include", description: "\"include\"" }, "/>", { type: "literal", value: "/>", description: "\"/>\"" }, function (attrs) {
                  var src;

                  attrs = attrs.filter(function (a) {
                    switch (a.name) {
                      case "src":
                        src = a.value;
                        break;

                      default:
                        return true;
                    }
                  });

                  return createNode("Include", {
                    src: src,
                    attributes: attrs
                  });
                }, { type: "other", description: "interpolator" }, "{-", { type: "literal", value: "{-", description: "\"{-\"" }, "-}", { type: "literal", value: "-}", description: "\"-}\"" }, { type: "any", description: "any character" }, function (v) {
                  return v;
                }, "{{", { type: "literal", value: "{{", description: "\"{{\"" }, "}}", { type: "literal", value: "}}", description: "\"}}\"" }, function (value) {
                  return createExpression(value);
                }, function (expression) {
                  return createNode("Interpolator", {
                    expression: expression
                  });
                }, function (nodes) {
                  return combineText(nodes);
                }, /^[a-z0-9\-$]/i, { type: "class", value: "[a-z0-9\\-$]i", description: "[a-z0-9\\-$]i" }, function (k) {
                  return k.toLowerCase();
                }, "</", { type: "literal", value: "</", description: "\"</\"" }, "{%", { type: "literal", value: "{%", description: "\"{%\"" }, { type: "other", description: "comment" }, "<!--", { type: "literal", value: "<!--", description: "\"<!--\"" }, "-->", { type: "literal", value: "-->", description: "\"-->\"" }, "{#", { type: "literal", value: "{#", description: "\"{#\"" }, "#}", { type: "literal", value: "#}", description: "\"#}\"" }, function (value) {
                  return createNode("Comment", { value: value });
                }, { type: "other", description: "raw tag" }, function (tagname) {
                  if (tagname[0] === "$") tagname = tagname.substr(1);
                  currentRawTag = tagname;
                  return _includes(rawTags, tagname);
                }, function (tagname, attrs, v) {
                  currentRawTag = null;
                  return true;
                }, function (tagname, attrs, v) {
                  if (tagname[0] === "$") tagname = tagname.substr(1);

                  return createNode("Raw", {
                    tagname: tagname,
                    attributes: attrs,
                    value: v
                  });
                }, function (t) {
                  if (t[0] === "$") t = t.substr(1);
                  return t === currentRawTag;
                }, { type: "other", description: "element" }, function (tagname, attrs) {
                  return createNode("Element", {
                    tagname: tagname,
                    attributes: attrs,
                    children: []
                  });
                }, function (starttag, attrs, nodes, t) {
                  if (starttag !== t) {
                    throw expected("</" + starttag + ">");
                  }

                  return t;
                }, function (starttag, attrs, nodes) {
                  return createNode("Element", {
                    tagname: starttag,
                    attributes: attrs,
                    children: nodes
                  });
                }, { type: "other", description: "attribute" }, "=", { type: "literal", value: "=", description: "\"=\"" }, function (key) {
                  enterAttribute();
                  return true;
                }, function (key, v) {
                  return v;
                }, function (key, value) {
                  exitAttribute();
                  return true;
                }, function (key, value) {
                  return createNode("Attribute", _assign({
                    name: key,
                    children: [],
                    type: "empty"
                  }, value));
                }, "{", { type: "literal", value: "{", description: "\"{\"" }, "}", { type: "literal", value: "}", description: "\"}\"" }, function (exp) {
                  var e = jsep$1(exp);
                  var exps = e.type === "Compound" ? e.body : [e];

                  return {
                    type: "expression",
                    children: exps.map(function (e) {
                      return createNode("Expression", { tree: e });
                    })
                  };
                }, "\"", { type: "literal", value: "\"", description: "\"\\\"\"" }, function (n) {
                  return {
                    children: combineText(n, "Literal"),
                    type: "string"
                  };
                }, "'", { type: "literal", value: "'", description: "\"'\"" }, function (children) {
                  var t = text();
                  t = t.substr(1, t.length - 2);

                  return _assign({
                    value: t
                  }, children);
                }, { type: "other", description: "section" }, function (name) {
                  if (!_includes(["render", "if", "endif", "each", "endeach", "with", "endwith", "set"], name)) {
                    expected("valid template section name");
                  }
                }, function (v) {
                  return v;
                }, "%}", { type: "literal", value: "%}", description: "\"%}\"" }, function () {
                  return attributeMode;
                }, function (n) {
                  return combineText(n, "Literal");
                }, { type: "other", description: "if section" }, "if", { type: "literal", value: "if", description: "\"if\"" }, "else", { type: "literal", value: "else", description: "\"else\"" }, function (exp, nodes) {
                  return [exp, nodes];
                }, function (exp, nodes, elsifs) {
                  return nodes;
                }, "endif", { type: "literal", value: "endif", description: "\"endif\"" }, function (exp, nodes, elsifs, els) {
                  var branches = [createNode("Branch", {
                    expression: createExpression(exp),
                    children: nodes
                  })];

                  elsifs.forEach(function (b) {
                    branches.push(createNode("Branch", {
                      expression: createExpression(b[0]),
                      children: b[1]
                    }));
                  });

                  if (els) branches.push(createNode("Branch", {
                    expression: null,
                    children: els
                  }));

                  return createNode("If", {
                    children: branches,
                    attribute: attributeMode
                  });
                }, { type: "other", description: "each section" }, "each", { type: "literal", value: "each", description: "\"each\"" }, ",", { type: "literal", value: ",", description: "\",\"" }, "in", { type: "literal", value: "in", description: "\"in\"" }, function (l, r) {
                  return [l].concat(_map(r, 3));
                }, "endeach", { type: "literal", value: "endeach", description: "\"endeach\"" }, function (vars, exp, nodes) {
                  return createNode("Each", {
                    expression: createExpression(exp),
                    children: nodes,
                    variables: vars || [],
                    attribute: attributeMode
                  });
                }, /^[a-z_$]/i, { type: "class", value: "[a-z_$]i", description: "[a-z_$]i" }, /^[a-z0-9_$]/i, { type: "class", value: "[a-z0-9_$]i", description: "[a-z0-9_$]i" }, { type: "other", description: "render section" }, function () {
                  return !attributeMode;
                }, "render", { type: "literal", value: "render", description: "\"render\"" }, function (exp) {
                  return createNode("Render", {
                    expression: createExpression(exp)
                  });
                }, { type: "other", description: "with section" }, "with", { type: "literal", value: "with", description: "\"with\"" }, "endwith", { type: "literal", value: "endwith", description: "\"endwith\"" }, function (exp, nodes) {
                  return createNode("With", {
                    expression: createExpression(exp),
                    children: nodes,
                    attribute: attributeMode
                  });
                }, { type: "other", description: "set section" }, "set", { type: "literal", value: "set", description: "\"set\"" }, /^[a-z]/i, { type: "class", value: "[a-z]i", description: "[a-z]i" }, function (v, exp) {
                  return createNode("Set", {
                    variable: v,
                    expression: createExpression(exp),
                    attribute: attributeMode
                  });
                }, "true", { type: "literal", value: "true", description: "\"true\"" }, function () {
                  return true;
                }, "false", { type: "literal", value: "false", description: "\"false\"" }, function () {
                  return false;
                }, "-", { type: "literal", value: "-", description: "\"-\"" }, /^[0-9]/, { type: "class", value: "[0-9]", description: "[0-9]" }, ".", { type: "literal", value: ".", description: "\".\"" }, function () {
                  return parseFloat(text(), 10);
                }, function () {
                  return parseInt(text(), 10);
                }, /^[^"]/, { type: "class", value: "[^\"]", description: "[^\"]" }, function (v) {
                  return v.join("");
                }, /^[^']/, { type: "class", value: "[^']", description: "[^']" }, "null", { type: "literal", value: "null", description: "\"null\"" }, function () {
                  return null;
                }, "undefined", { type: "literal", value: "undefined", description: "\"undefined\"" }, "void", { type: "literal", value: "void", description: "\"void\"" }, /^[,; \t\n\r]/, { type: "class", value: "[,; \\t\\n\\r]", description: "[,; \\t\\n\\r]" }, function () {
                  return void 0;
                }, { type: "other", description: "whitespace" }, /^[ \t\n\r]/, { type: "class", value: "[ \\t\\n\\r]", description: "[ \\t\\n\\r]" }, { type: "other", description: "guaranteed whitespace" }, "\\", { type: "literal", value: "\\", description: "\"\\\\\"" }, function (char) {
                  return char;
                }],
                    peg$bytecode = [peg$decode("%;B/\x82#$%;)./ &;\".) &;!.# &;(/,#;B/#$+\")(\"'#&'#0H*%;)./ &;\".) &;!.# &;(/,#;B/#$+\")(\"'#&'#&/($8\": \"! )(\"'#&'#"), peg$decode("<%2\"\"\"6\"7#/q#;B/h$2$\"\"6$7%/Y$;,/P$2&\"\"6&7'/A$;%/8$2(\"\"6(7)/)$8':*'\"#!)(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7!"), peg$decode("<%2\"\"\"6\"7#/X#;B/O$2,\"\"6,7-/@$;,/7$2.\"\"6.7//($8%:0%!!)(%'#($'#(#'#(\"'#&'#=.\" 7+"), peg$decode("<%%22\"\"6273/\xA2#%$%%<24\"\"6475=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0M*%%<24\"\"6475=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/7$24\"\"6475/($8#:7#!!)(#'#(\"'#&'#.\xB2 &%28\"\"6879/\xA2#%$%%<2:\"\"6:7;=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0M*%%<2:\"\"6:7;=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/7$2:\"\"6:7;/($8#:7#!!)(#'#(\"'#&'#/' 8!:<!! )=.\" 71"), peg$decode("%;#/' 8!:=!! )"), peg$decode("%$;(.5 &;1./ &;$.) &;+.# &;'0;*;(.5 &;1./ &;$.) &;+.# &;'&/' 8!:>!! )"), peg$decode("%;B/Z#%$4?\"\"5!7@/,#0)*4?\"\"5!7@&&&#/\"!&,)/1$;B/($8#:A#!!)(#'#(\"'#&'#"), peg$decode("%%%<%2B\"\"6B7C/;#;&/2$2&\"\"6&7'/#$+#)(#'#(\"'#&'#=.##&&!&'#/g#%<2D\"\"6D7E=.##&&!&'#/L$%<28\"\"6879=.##&&!&'#/1$1\"\"5!76/#$+$)($'#(#'#(\"'#&'#/\"!&,)"), peg$decode("<%%2G\"\"6G7H/\xA2#%$%%<2I\"\"6I7J=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0M*%%<2I\"\"6I7J=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/7$2I\"\"6I7J/($8#:7#!!)(#'#(\"'#&'#.\xB2 &%2K\"\"6K7L/\xA2#%$%%<2M\"\"6M7N=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0M*%%<2M\"\"6M7N=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/7$2M\"\"6M7N/($8#:7#!!)(#'#(\"'#&'#/' 8!:O!! )=.\" 7F"), peg$decode("<%2\"\"\"6\"7#/\xDD#;&/\xD4$9:Q ! -\"\"&!&#/\xC0$;,/\xB7$2&\"\"6&7'/\xA8$%$%%<;*=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0G*%%<;*=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/I$;*/@$9:R #%#!-\"\"&!&#/*$8(:S(#&$\")(('#(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7P"), peg$decode("%2B\"\"6B7C/O#;&/F$9:T ! -\"\"&!&#/2$2&\"\"6&7'/#$+$)($'#(#'#(\"'#&'#"), peg$decode("<%2\"\"\"6\"7#/J#;&/A$;,/8$2.\"\"6.7//)$8$:V$\"\"!)($'#(#'#(\"'#&'#.\x9D &%2\"\"\"6\"7#/\x8D#;&/\x84$;,/{$2&\"\"6&7'/l$;%/c$%2B\"\"6B7C/C#;&/:$2&\"\"6&7'/+$8#:W#$'&$!)(#'#(\"'#&'#/*$8&:X&#$#!)(&'#(%'#($'#(#'#(\"'#&'#=.\" 7U"), peg$decode("$;-0#*;-&"), peg$decode("<%;./\x91#%2Z\"\"6Z7[/X#;B/O$9:\\ !#-\"\"&!&#/;$;0/2$;B/)$8%:]%\"&!)(%'#($'#(#'#(\"'#&'#.\" &\"/>$9:^ \"! -\"\"&!&#/)$8#:_#\"\"!)(#'#(\"'#&'#=.\" 7Y"), peg$decode("%;B/Z#%$4?\"\"5!7@/,#0)*4?\"\"5!7@&&&#/\"!&,)/1$;B/($8#:A#!!)(#'#(\"'#&'#"), peg$decode(";D.) &;1.# &;#"), peg$decode("%%2`\"\"6`7a/¢#%$%%<2b\"\"6b7c=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0M*%%<2b\"\"6b7c=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/7$2b\"\"6b7c/($8#:d#!!)(#'#(\"'#&'#.ŭ &%2e\"\"6e7f/µ#$;/.T &%%%<2e\"\"6e7f=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)0Z*;/.T &%%%<2e\"\"6e7f=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)&/7$2e\"\"6e7f/($8#:g#!!)(#'#(\"'#&'#.Å &%2h\"\"6h7i/µ#$;/.T &%%%<2h\"\"6h7i=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)0Z*;/.T &%%%<2h\"\"6h7i=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)&/7$2h\"\"6h7i/($8#:g#!!)(#'#(\"'#&'#/' 8!:j!! )"), peg$decode("<%%<%;2/8#%;7/' 8!:l!! )/#$+\")(\"'#&'#=/##&'!&&#/I#;5.5 &;6./ &;8.) &;9.# &;:/($8\":m\"! )(\"'#&'#=.\" 7k"), peg$decode("%2D\"\"6D7E/,#;B/#$+\")(\"'#&'#"), peg$decode("%;B/2#2n\"\"6n7o/#$+\")(\"'#&'#"), peg$decode("%9:p  -\"\"&!&#/\x9A#$;/.N &%%%<;2=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)0T*;/.N &%%%<;2=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)&/($8\":q\"! )(\"'#&'#.# &;%"), peg$decode("<%;2/Ư#3s\"\"5\"7t/Ơ$;B/Ɨ$%$;;0#*;;&/\"!&,)/ƀ$;3/ŷ$;4/Ů$$%;2/#3u\"\"5$7v/s$;C/j$3s\"\"5\"7t/[$;B/R$%$;;0#*;;&/\"!&,)/;$;3/2$;4/)$8(:w(\"\" )(('#(''#(&'#(%'#($'#(#'#(\"'#&'#0*%;2/#3u\"\"5$7v/s$;C/j$3s\"\"5\"7t/[$;B/R$%$;;0#*;;&/\"!&,)/;$;3/2$;4/)$8(:w(\"\" )(('#(''#(&'#(%'#($'#(#'#(\"'#&'#&/$%;2/K#3u\"\"5$7v/<$;3/3$;4/*$8$:x$#( %)($'#(#'#(\"'#&'#.\" &\"/L$;2/C$3y\"\"5%7z/4$;3/+$8+:{+$'%$#)(+'#(*'#()'#(('#(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7r"), peg$decode("<%;2/ı#3}\"\"5$7~/Ģ$;B/ę$%;7/§#$%;B/D#2\"\"67/5$;B/,$;7/#$+$)($'#(#'#(\"'#&'#0N*%;B/D#2\"\"67/5$;B/,$;7/#$+$)($'#(#'#(\"'#&'#&/A$;B/8$2\"\"67/)$8$:$\"#\")($'#(#'#(\"'#&'#.\" &\"/}$;B/t$%$;;0#*;;&/\"!&,)/]$;3/T$;4/K$;2/B$3\"\"5'7/3$;3/*$8+:+#'%#)(+'#(*'#()'#(('#(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7|"), peg$decode("%%4\x87\"\"5!7\x88/?#$4\x89\"\"5!7\x8A0)*4\x89\"\"5!7\x8A&/#$+\")(\"'#&'#/\"!&,)"), peg$decode("<%9:\x8C  -\"\"&!&#/i#;2/`$3\x8D\"\"5&7\x8E/Q$;B/H$%$;;0#*;;&/\"!&,)/1$;3/($8&:\x8F&!!)(&'#(%'#($'#(#'#(\"'#&'#=.\" 7\x8B"), peg$decode("<%;2/\x8B#3\x91\"\"5$7\x92/|$;B/s$%$;;0#*;;&/\"!&,)/\\$;3/S$;4/J$;2/A$3\x93\"\"5'7\x94/2$;3/)$8):\x95)\"%#)()'#(('#(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7\x90"), peg$decode("<%;2/\xC4#3\x97\"\"5#7\x98/\xB5$;B/\xAC$%%4\x99\"\"5!7\x9A/E#$4\x89\"\"5!7\x8A/,#0)*4\x89\"\"5!7\x8A&&&#/#$+\")(\"'#&'#/\"!&,)/j$;B/a$2Z\"\"6Z7[/R$;B/I$%$;;0#*;;&/\"!&,)/2$;3/)$8):\x9B)\"%!)()'#(('#(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7\x96"), peg$decode("%%<2n\"\"6n7o=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#"), peg$decode("%2\x9C\"\"6\x9C7\x9D/& 8!:\x9E! ).4 &%2\x9F\"\"6\x9F7\xA0/& 8!:\xA1! )"), peg$decode("%2\xA2\"\"6\xA27\xA3.\" &\"/\x89#$4\xA4\"\"5!7\xA5/,#0)*4\xA4\"\"5!7\xA5&&&#/g$%2\xA6\"\"6\xA67\xA7/E#$4\xA4\"\"5!7\xA5/,#0)*4\xA4\"\"5!7\xA5&&&#/#$+\")(\"'#&'#.\" &\"/'$8#:\xA8# )(#'#(\"'#&'#"), peg$decode("%$4\xA4\"\"5!7\xA5/,#0)*4\xA4\"\"5!7\xA5&&&#/& 8!:\xA9! )"), peg$decode("%2e\"\"6e7f/_#$;D.) &4\xAA\"\"5!7\xAB0/*;D.) &4\xAA\"\"5!7\xAB&/7$2e\"\"6e7f/($8#:\xAC#!!)(#'#(\"'#&'#.o &%2h\"\"6h7i/_#$;D.) &4\xAD\"\"5!7\xAE0/*;D.) &4\xAD\"\"5!7\xAE&/7$2h\"\"6h7i/($8#:\xAC#!!)(#'#(\"'#&'#"), peg$decode("%2\xAF\"\"6\xAF7\xB0/& 8!:\xB1! )"), peg$decode("%2\xB2\"\"6\xB27\xB3.\xA6 &%2\xB4\"\"6\xB47\xB5/\x96#;C/\x8D$$%%<4\xB6\"\"5!7\xB7=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/P#0M*%%<4\xB6\"\"5!7\xB7=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&&&#/#$+#)(#'#(\"'#&'#/& 8!:\xB8! )"), peg$decode("<%$4\xBA\"\"5!7\xBB0)*4\xBA\"\"5!7\xBB&/\"!&,)=.\" 7\xB9"), peg$decode("<%$4\xBA\"\"5!7\xBB/,#0)*4\xBA\"\"5!7\xBB&&&#/\"!&,)=.\" 7\xBC"), peg$decode("%2\xBD\"\"6\xBD7\xBE/6#1\"\"5!76/($8\":\xBF\"! )(\"'#&'#")],
                    peg$currPos = 0,
                    peg$savedPos = 0,
                    peg$posDetailsCache = [{ line: 1, column: 1, seenCR: false }],
                    peg$maxFailPos = 0,
                    peg$maxFailExpected = [],
                    peg$silentFails = 0,
                    peg$result;

                if ("startRule" in options) {
                  if (!(options.startRule in peg$startRuleIndices)) {
                    throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
                  }

                  peg$startRuleIndex = peg$startRuleIndices[options.startRule];
                }

                function text() {
                  return input.substring(peg$savedPos, peg$currPos);
                }

                function location() {
                  return peg$computeLocation(peg$savedPos, peg$currPos);
                }

                function expected(description) {
                  throw peg$buildException(null, [{ type: "other", description: description }], input.substring(peg$savedPos, peg$currPos), peg$computeLocation(peg$savedPos, peg$currPos));
                }

                function error(message) {
                  throw peg$buildException(message, null, input.substring(peg$savedPos, peg$currPos), peg$computeLocation(peg$savedPos, peg$currPos));
                }

                function peg$computePosDetails(pos) {
                  var details = peg$posDetailsCache[pos],
                      p,
                      ch;

                  if (details) {
                    return details;
                  } else {
                    p = pos - 1;
                    while (!peg$posDetailsCache[p]) {
                      p--;
                    }

                    details = peg$posDetailsCache[p];
                    details = {
                      line: details.line,
                      column: details.column,
                      seenCR: details.seenCR
                    };

                    while (p < pos) {
                      ch = input.charAt(p);
                      if (ch === "\n") {
                        if (!details.seenCR) {
                          details.line++;
                        }
                        details.column = 1;
                        details.seenCR = false;
                      } else if (ch === "\r" || ch === "\u2028" || ch === "\u2029") {
                        details.line++;
                        details.column = 1;
                        details.seenCR = true;
                      } else {
                        details.column++;
                        details.seenCR = false;
                      }

                      p++;
                    }

                    peg$posDetailsCache[pos] = details;
                    return details;
                  }
                }

                function peg$computeLocation(startPos, endPos) {
                  var startPosDetails = peg$computePosDetails(startPos),
                      endPosDetails = peg$computePosDetails(endPos);

                  return {
                    start: {
                      offset: startPos,
                      line: startPosDetails.line,
                      column: startPosDetails.column
                    },
                    end: {
                      offset: endPos,
                      line: endPosDetails.line,
                      column: endPosDetails.column
                    }
                  };
                }

                function peg$fail(expected) {
                  if (peg$currPos < peg$maxFailPos) {
                    return;
                  }

                  if (peg$currPos > peg$maxFailPos) {
                    peg$maxFailPos = peg$currPos;
                    peg$maxFailExpected = [];
                  }

                  peg$maxFailExpected.push(expected);
                }

                function peg$buildException(message, expected, found, location) {
                  function cleanupExpected(expected) {
                    var i = 1;

                    expected.sort(function (a, b) {
                      if (a.description < b.description) {
                        return -1;
                      } else if (a.description > b.description) {
                        return 1;
                      } else {
                        return 0;
                      }
                    });

                    while (i < expected.length) {
                      if (expected[i - 1] === expected[i]) {
                        expected.splice(i, 1);
                      } else {
                        i++;
                      }
                    }
                  }

                  function buildMessage(expected, found) {
                    function stringEscape(s) {
                      function hex(ch) {
                        return ch.charCodeAt(0).toString(16).toUpperCase();
                      }

                      return s.replace(/\\/g, '\\\\').replace(/"/g, '\\"').replace(/\x08/g, '\\b').replace(/\t/g, '\\t').replace(/\n/g, '\\n').replace(/\f/g, '\\f').replace(/\r/g, '\\r').replace(/[\x00-\x07\x0B\x0E\x0F]/g, function (ch) {
                        return '\\x0' + hex(ch);
                      }).replace(/[\x10-\x1F\x80-\xFF]/g, function (ch) {
                        return '\\x' + hex(ch);
                      }).replace(/[\u0100-\u0FFF]/g, function (ch) {
                        return "\\u0" + hex(ch);
                      }).replace(/[\u1000-\uFFFF]/g, function (ch) {
                        return "\\u" + hex(ch);
                      });
                    }

                    var expectedDescs = new Array(expected.length),
                        expectedDesc,
                        foundDesc,
                        i;

                    for (i = 0; i < expected.length; i++) {
                      expectedDescs[i] = expected[i].description;
                    }

                    expectedDesc = expected.length > 1 ? expectedDescs.slice(0, -1).join(", ") + " or " + expectedDescs[expected.length - 1] : expectedDescs[0];

                    foundDesc = found ? "\"" + stringEscape(found) + "\"" : "end of input";

                    return "Expected " + expectedDesc + " but " + foundDesc + " found.";
                  }

                  if (expected !== null) {
                    cleanupExpected(expected);
                  }

                  return new peg$SyntaxError(message !== null ? message : buildMessage(expected, found), expected, found, location);
                }

                function peg$decode(s) {
                  var bc = new Array(s.length),
                      i;

                  for (i = 0; i < s.length; i++) {
                    bc[i] = s.charCodeAt(i) - 32;
                  }

                  return bc;
                }

                function peg$parseRule(index) {
                  var bc = peg$bytecode[index],
                      ip = 0,
                      ips = [],
                      end = bc.length,
                      ends = [],
                      stack = [],
                      params,
                      i;

                  while (true) {
                    while (ip < end) {
                      switch (bc[ip]) {
                        case 0:
                          stack.push(peg$consts[bc[ip + 1]]);
                          ip += 2;
                          break;

                        case 1:
                          stack.push(void 0);
                          ip++;
                          break;

                        case 2:
                          stack.push(null);
                          ip++;
                          break;

                        case 3:
                          stack.push(peg$FAILED);
                          ip++;
                          break;

                        case 4:
                          stack.push([]);
                          ip++;
                          break;

                        case 5:
                          stack.push(peg$currPos);
                          ip++;
                          break;

                        case 6:
                          stack.pop();
                          ip++;
                          break;

                        case 7:
                          peg$currPos = stack.pop();
                          ip++;
                          break;

                        case 8:
                          stack.length -= bc[ip + 1];
                          ip += 2;
                          break;

                        case 9:
                          stack.splice(-2, 1);
                          ip++;
                          break;

                        case 10:
                          stack[stack.length - 2].push(stack.pop());
                          ip++;
                          break;

                        case 11:
                          stack.push(stack.splice(stack.length - bc[ip + 1], bc[ip + 1]));
                          ip += 2;
                          break;

                        case 12:
                          stack.push(input.substring(stack.pop(), peg$currPos));
                          ip++;
                          break;

                        case 13:
                          ends.push(end);
                          ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

                          if (stack[stack.length - 1]) {
                            end = ip + 3 + bc[ip + 1];
                            ip += 3;
                          } else {
                            end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                            ip += 3 + bc[ip + 1];
                          }

                          break;

                        case 14:
                          ends.push(end);
                          ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

                          if (stack[stack.length - 1] === peg$FAILED) {
                            end = ip + 3 + bc[ip + 1];
                            ip += 3;
                          } else {
                            end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                            ip += 3 + bc[ip + 1];
                          }

                          break;

                        case 15:
                          ends.push(end);
                          ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

                          if (stack[stack.length - 1] !== peg$FAILED) {
                            end = ip + 3 + bc[ip + 1];
                            ip += 3;
                          } else {
                            end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                            ip += 3 + bc[ip + 1];
                          }

                          break;

                        case 16:
                          if (stack[stack.length - 1] !== peg$FAILED) {
                            ends.push(end);
                            ips.push(ip);

                            end = ip + 2 + bc[ip + 1];
                            ip += 2;
                          } else {
                            ip += 2 + bc[ip + 1];
                          }

                          break;

                        case 17:
                          ends.push(end);
                          ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

                          if (input.length > peg$currPos) {
                            end = ip + 3 + bc[ip + 1];
                            ip += 3;
                          } else {
                            end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                            ip += 3 + bc[ip + 1];
                          }

                          break;

                        case 18:
                          ends.push(end);
                          ips.push(ip + 4 + bc[ip + 2] + bc[ip + 3]);

                          if (input.substr(peg$currPos, peg$consts[bc[ip + 1]].length) === peg$consts[bc[ip + 1]]) {
                            end = ip + 4 + bc[ip + 2];
                            ip += 4;
                          } else {
                            end = ip + 4 + bc[ip + 2] + bc[ip + 3];
                            ip += 4 + bc[ip + 2];
                          }

                          break;

                        case 19:
                          ends.push(end);
                          ips.push(ip + 4 + bc[ip + 2] + bc[ip + 3]);

                          if (input.substr(peg$currPos, peg$consts[bc[ip + 1]].length).toLowerCase() === peg$consts[bc[ip + 1]]) {
                            end = ip + 4 + bc[ip + 2];
                            ip += 4;
                          } else {
                            end = ip + 4 + bc[ip + 2] + bc[ip + 3];
                            ip += 4 + bc[ip + 2];
                          }

                          break;

                        case 20:
                          ends.push(end);
                          ips.push(ip + 4 + bc[ip + 2] + bc[ip + 3]);

                          if (peg$consts[bc[ip + 1]].test(input.charAt(peg$currPos))) {
                            end = ip + 4 + bc[ip + 2];
                            ip += 4;
                          } else {
                            end = ip + 4 + bc[ip + 2] + bc[ip + 3];
                            ip += 4 + bc[ip + 2];
                          }

                          break;

                        case 21:
                          stack.push(input.substr(peg$currPos, bc[ip + 1]));
                          peg$currPos += bc[ip + 1];
                          ip += 2;
                          break;

                        case 22:
                          stack.push(peg$consts[bc[ip + 1]]);
                          peg$currPos += peg$consts[bc[ip + 1]].length;
                          ip += 2;
                          break;

                        case 23:
                          stack.push(peg$FAILED);
                          if (peg$silentFails === 0) {
                            peg$fail(peg$consts[bc[ip + 1]]);
                          }
                          ip += 2;
                          break;

                        case 24:
                          peg$savedPos = stack[stack.length - 1 - bc[ip + 1]];
                          ip += 2;
                          break;

                        case 25:
                          peg$savedPos = peg$currPos;
                          ip++;
                          break;

                        case 26:
                          params = bc.slice(ip + 4, ip + 4 + bc[ip + 3]);
                          for (i = 0; i < bc[ip + 3]; i++) {
                            params[i] = stack[stack.length - 1 - params[i]];
                          }

                          stack.splice(stack.length - bc[ip + 2], bc[ip + 2], peg$consts[bc[ip + 1]].apply(null, params));

                          ip += 4 + bc[ip + 3];
                          break;

                        case 27:
                          stack.push(peg$parseRule(bc[ip + 1]));
                          ip += 2;
                          break;

                        case 28:
                          peg$silentFails++;
                          ip++;
                          break;

                        case 29:
                          peg$silentFails--;
                          ip++;
                          break;

                        default:
                          throw new Error("Invalid opcode: " + bc[ip] + ".");
                      }
                    }

                    if (ends.length > 0) {
                      end = ends.pop();
                      ip = ips.pop();
                    } else {
                      break;
                    }
                  }

                  return stack[0];
                }

                options = _assign({
                  strict: true
                }, options);

                function createNode(type, props) {
                  var loc = location();
                  if (typeof type !== "function") type = AST[type];
                  return new type(loc.start.line, loc.start.column, props);
                }

                function combineText(nodes, type) {
                  return nodes.reduce(function (m, n) {
                    var last = m.length - 1;
                    if (typeof n === "string" && typeof m[last] === "string") {
                      m[last] += n;
                    } else {
                      m.push(n);
                    }
                    return m;
                  }, []).map(function (n) {
                    if (typeof n !== "string") return n;
                    return createNode(type || "Text", { value: n });
                  });
                }

                function createExpression(v) {
                  return createNode("Expression", {
                    value: v,
                    tree: jsep$1(v)
                  });
                }

                var attributeMode = false;
                function enterAttribute() {
                  attributeMode = true;
                }
                function exitAttribute() {
                  attributeMode = false;
                }

                var rawTags = _union(["script", "style"], Object.keys(options.tags || {}));
                var currentRawTag;

                peg$result = peg$parseRule(peg$startRuleIndex);

                if (peg$result !== peg$FAILED && peg$currPos === input.length) {
                  return peg$result;
                } else {
                  if (peg$result !== peg$FAILED && peg$currPos < input.length) {
                    peg$fail({ type: "end", description: "end of input" });
                  }

                  throw peg$buildException(null, peg$maxFailExpected, peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null, peg$maxFailPos < input.length ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1) : peg$computeLocation(peg$maxFailPos, peg$maxFailPos));
                }
              }

              return {
                SyntaxError: peg$SyntaxError,
                parse: peg$parse
              };
            }();
            var parse$1 = parser.parse;

            var require$$0$52 = {};

            var rollup = __commonjs(function (module, exports) {
            /*
            	Rollup.js v0.25.7
            	Sun Mar 27 2016 19:11:12 GMT-0400 (EDT) - commit eb29daaacfaccb5b7139d0784e74dd8fa7aed524


            	https://github.com/rollup/rollup

            	Released under the MIT License.
            */

            'use strict';

            var fs = require$$0$52;

            var babelHelpers = {};

            babelHelpers.classCallCheck = function (instance, Constructor) {
              if (!(instance instanceof Constructor)) {
                throw new TypeError("Cannot call a class as a function");
              }
            };
            function objectOrFunction(x) {
              return typeof x === 'function' || (typeof x === 'object' && x !== null);
            }

            function isFunction(x) {
              return typeof x === 'function';
            }

            var _isArray;
            if (!Array.isArray) {
              _isArray = function (x) {
                return Object.prototype.toString.call(x) === '[object Array]';
              };
            } else {
              _isArray = Array.isArray;
            }

            var isArray$1 = _isArray;

            var len = 0;
            var vertxNext;
            var customSchedulerFn;

            var asap = function asap(callback, arg) {
              queue[len] = callback;
              queue[len + 1] = arg;
              len += 2;
              if (len === 2) {
                // If len is 2, that means that we need to schedule an async flush.
                // If additional callbacks are queued before the queue is flushed, they
                // will be processed by this flush that we are scheduling.
                if (customSchedulerFn) {
                  customSchedulerFn(flush);
                } else {
                  scheduleFlush();
                }
              }
            }

            function setScheduler(scheduleFn) {
              customSchedulerFn = scheduleFn;
            }

            function setAsap(asapFn) {
              asap = asapFn;
            }

            var browserWindow = (typeof window !== 'undefined') ? window : undefined;
            var browserGlobal = browserWindow || {};
            var BrowserMutationObserver = browserGlobal.MutationObserver || browserGlobal.WebKitMutationObserver;
            var isNode = typeof process !== 'undefined' && {}.toString.call(process) === '[object process]';

            // test for web worker but not in IE10
            var isWorker = typeof Uint8ClampedArray !== 'undefined' &&
              typeof importScripts !== 'undefined' &&
              typeof MessageChannel !== 'undefined';

            // node
            function useNextTick() {
              // node version 0.10.x displays a deprecation warning when nextTick is used recursively
              // see https://github.com/cujojs/when/issues/410 for details
              return function() {
                $inject_process_nextTick(flush);
              };
            }

            // vertx
            function useVertxTimer() {
              return function() {
                vertxNext(flush);
              };
            }

            function useMutationObserver() {
              var iterations = 0;
              var observer = new BrowserMutationObserver(flush);
              var node = document.createTextNode('');
              observer.observe(node, { characterData: true });

              return function() {
                node.data = (iterations = ++iterations % 2);
              };
            }

            // web worker
            function useMessageChannel() {
              var channel = new MessageChannel();
              channel.port1.onmessage = flush;
              return function () {
                channel.port2.postMessage(0);
              };
            }

            function useSetTimeout() {
              return function() {
                setTimeout(flush, 1);
              };
            }

            var queue = new Array(1000);
            function flush() {
              for (var i = 0; i < len; i+=2) {
                var callback = queue[i];
                var arg = queue[i+1];

                callback(arg);

                queue[i] = undefined;
                queue[i+1] = undefined;
              }

              len = 0;
            }

            function attemptVertx() {
              try {
                var r = require;
                var vertx = r('vertx');
                vertxNext = vertx.runOnLoop || vertx.runOnContext;
                return useVertxTimer();
              } catch(e) {
                return useSetTimeout();
              }
            }

            var scheduleFlush;
            // Decide what async method to use to triggering processing of queued callbacks:
            if (isNode) {
              scheduleFlush = useNextTick();
            } else if (BrowserMutationObserver) {
              scheduleFlush = useMutationObserver();
            } else if (isWorker) {
              scheduleFlush = useMessageChannel();
            } else if (browserWindow === undefined && typeof require === 'function') {
              scheduleFlush = attemptVertx();
            } else {
              scheduleFlush = useSetTimeout();
            }

            function then(onFulfillment, onRejection) {
              var parent = this;
              var state = parent._state;

              if (state === FULFILLED && !onFulfillment || state === REJECTED && !onRejection) {
                return this;
              }

              var child = new this.constructor(noop);
              var result = parent._result;

              if (state) {
                var callback = arguments[state - 1];
                asap(function(){
                  invokeCallback(state, child, callback, result);
                });
              } else {
                subscribe(parent, child, onFulfillment, onRejection);
              }

              return child;
            }

            /**
              `Promise.resolve` returns a promise that will become resolved with the
              passed `value`. It is shorthand for the following:

              ```javascript
              var promise = new Promise(function(resolve, reject){
                resolve(1);
              });

              promise.then(function(value){
                // value === 1
              });
              ```

              Instead of writing the above, your code now simply becomes the following:

              ```javascript
              var promise = Promise.resolve(1);

              promise.then(function(value){
                // value === 1
              });
              ```

              @method resolve
              @static
              @param {Any} value value that the returned promise will be resolved with
              Useful for tooling.
              @return {Promise} a promise that will become fulfilled with the given
              `value`
            */
            function resolve$1(object) {
              /*jshint validthis:true */
              var Constructor = this;

              if (object && typeof object === 'object' && object.constructor === Constructor) {
                return object;
              }

              var promise = new Constructor(noop);
              _resolve(promise, object);
              return promise;
            }

            function noop() {}

            var PENDING   = void 0;
            var FULFILLED = 1;
            var REJECTED  = 2;

            var GET_THEN_ERROR = new ErrorObject();

            function selfFulfillment() {
              return new TypeError("You cannot resolve a promise with itself");
            }

            function cannotReturnOwn() {
              return new TypeError('A promises callback cannot return that same promise.');
            }

            function getThen(promise) {
              try {
                return promise.then;
              } catch(error) {
                GET_THEN_ERROR.error = error;
                return GET_THEN_ERROR;
              }
            }

            function tryThen(then, value, fulfillmentHandler, rejectionHandler) {
              try {
                then.call(value, fulfillmentHandler, rejectionHandler);
              } catch(e) {
                return e;
              }
            }

            function handleForeignThenable(promise, thenable, then) {
               asap(function(promise) {
                var sealed = false;
                var error = tryThen(then, thenable, function(value) {
                  if (sealed) { return; }
                  sealed = true;
                  if (thenable !== value) {
                    _resolve(promise, value);
                  } else {
                    fulfill(promise, value);
                  }
                }, function(reason) {
                  if (sealed) { return; }
                  sealed = true;

                  reject(promise, reason);
                }, 'Settle: ' + (promise._label || ' unknown promise'));

                if (!sealed && error) {
                  sealed = true;
                  reject(promise, error);
                }
              }, promise);
            }

            function handleOwnThenable(promise, thenable) {
              if (thenable._state === FULFILLED) {
                fulfill(promise, thenable._result);
              } else if (thenable._state === REJECTED) {
                reject(promise, thenable._result);
              } else {
                subscribe(thenable, undefined, function(value) {
                  _resolve(promise, value);
                }, function(reason) {
                  reject(promise, reason);
                });
              }
            }

            function handleMaybeThenable(promise, maybeThenable, then$$) {
              if (maybeThenable.constructor === promise.constructor &&
                  then$$ === then &&
                  constructor.resolve === resolve$1) {
                handleOwnThenable(promise, maybeThenable);
              } else {
                if (then$$ === GET_THEN_ERROR) {
                  reject(promise, GET_THEN_ERROR.error);
                } else if (then$$ === undefined) {
                  fulfill(promise, maybeThenable);
                } else if (isFunction(then$$)) {
                  handleForeignThenable(promise, maybeThenable, then$$);
                } else {
                  fulfill(promise, maybeThenable);
                }
              }
            }

            function _resolve(promise, value) {
              if (promise === value) {
                reject(promise, selfFulfillment());
              } else if (objectOrFunction(value)) {
                handleMaybeThenable(promise, value, getThen(value));
              } else {
                fulfill(promise, value);
              }
            }

            function publishRejection(promise) {
              if (promise._onerror) {
                promise._onerror(promise._result);
              }

              publish(promise);
            }

            function fulfill(promise, value) {
              if (promise._state !== PENDING) { return; }

              promise._result = value;
              promise._state = FULFILLED;

              if (promise._subscribers.length !== 0) {
                asap(publish, promise);
              }
            }

            function reject(promise, reason) {
              if (promise._state !== PENDING) { return; }
              promise._state = REJECTED;
              promise._result = reason;

              asap(publishRejection, promise);
            }

            function subscribe(parent, child, onFulfillment, onRejection) {
              var subscribers = parent._subscribers;
              var length = subscribers.length;

              parent._onerror = null;

              subscribers[length] = child;
              subscribers[length + FULFILLED] = onFulfillment;
              subscribers[length + REJECTED]  = onRejection;

              if (length === 0 && parent._state) {
                asap(publish, parent);
              }
            }

            function publish(promise) {
              var subscribers = promise._subscribers;
              var settled = promise._state;

              if (subscribers.length === 0) { return; }

              var child, callback, detail = promise._result;

              for (var i = 0; i < subscribers.length; i += 3) {
                child = subscribers[i];
                callback = subscribers[i + settled];

                if (child) {
                  invokeCallback(settled, child, callback, detail);
                } else {
                  callback(detail);
                }
              }

              promise._subscribers.length = 0;
            }

            function ErrorObject() {
              this.error = null;
            }

            var TRY_CATCH_ERROR = new ErrorObject();

            function tryCatch(callback, detail) {
              try {
                return callback(detail);
              } catch(e) {
                TRY_CATCH_ERROR.error = e;
                return TRY_CATCH_ERROR;
              }
            }

            function invokeCallback(settled, promise, callback, detail) {
              var hasCallback = isFunction(callback),
                  value, error, succeeded, failed;

              if (hasCallback) {
                value = tryCatch(callback, detail);

                if (value === TRY_CATCH_ERROR) {
                  failed = true;
                  error = value.error;
                  value = null;
                } else {
                  succeeded = true;
                }

                if (promise === value) {
                  reject(promise, cannotReturnOwn());
                  return;
                }

              } else {
                value = detail;
                succeeded = true;
              }

              if (promise._state !== PENDING) {
                // noop
              } else if (hasCallback && succeeded) {
                _resolve(promise, value);
              } else if (failed) {
                reject(promise, error);
              } else if (settled === FULFILLED) {
                fulfill(promise, value);
              } else if (settled === REJECTED) {
                reject(promise, value);
              }
            }

            function initializePromise(promise, resolver) {
              try {
                resolver(function resolvePromise(value){
                  _resolve(promise, value);
                }, function rejectPromise(reason) {
                  reject(promise, reason);
                });
              } catch(e) {
                reject(promise, e);
              }
            }

            function Enumerator(Constructor, input) {
              this._instanceConstructor = Constructor;
              this.promise = new Constructor(noop);

              if (Array.isArray(input)) {
                this._input     = input;
                this.length     = input.length;
                this._remaining = input.length;

                this._result = new Array(this.length);

                if (this.length === 0) {
                  fulfill(this.promise, this._result);
                } else {
                  this.length = this.length || 0;
                  this._enumerate();
                  if (this._remaining === 0) {
                    fulfill(this.promise, this._result);
                  }
                }
              } else {
                reject(this.promise, this._validationError());
              }
            }

            Enumerator.prototype._validationError = function() {
              return new Error('Array Methods must be provided an Array');
            };

            Enumerator.prototype._enumerate = function() {
              var length  = this.length;
              var input   = this._input;

              for (var i = 0; this._state === PENDING && i < length; i++) {
                this._eachEntry(input[i], i);
              }
            };

            Enumerator.prototype._eachEntry = function(entry, i) {
              var c = this._instanceConstructor;
              var resolve = c.resolve;

              if (resolve === resolve$1) {
                var then$$ = getThen(entry);

                if (then$$ === then &&
                    entry._state !== PENDING) {
                  this._settledAt(entry._state, i, entry._result);
                } else if (typeof then$$ !== 'function') {
                  this._remaining--;
                  this._result[i] = entry;
                } else if (c === Promise) {
                  var promise = new c(noop);
                  handleMaybeThenable(promise, entry, then$$);
                  this._willSettleAt(promise, i);
                } else {
                  this._willSettleAt(new c(function(resolve) { resolve(entry); }), i);
                }
              } else {
                this._willSettleAt(resolve(entry), i);
              }
            };

            Enumerator.prototype._settledAt = function(state, i, value) {
              var promise = this.promise;

              if (promise._state === PENDING) {
                this._remaining--;

                if (state === REJECTED) {
                  reject(promise, value);
                } else {
                  this._result[i] = value;
                }
              }

              if (this._remaining === 0) {
                fulfill(promise, this._result);
              }
            };

            Enumerator.prototype._willSettleAt = function(promise, i) {
              var enumerator = this;

              subscribe(promise, undefined, function(value) {
                enumerator._settledAt(FULFILLED, i, value);
              }, function(reason) {
                enumerator._settledAt(REJECTED, i, reason);
              });
            };

            /**
              `Promise.all` accepts an array of promises, and returns a new promise which
              is fulfilled with an array of fulfillment values for the passed promises, or
              rejected with the reason of the first passed promise to be rejected. It casts all
              elements of the passed iterable to promises as it runs this algorithm.

              Example:

              ```javascript
              var promise1 = resolve(1);
              var promise2 = resolve(2);
              var promise3 = resolve(3);
              var promises = [ promise1, promise2, promise3 ];

              Promise.all(promises).then(function(array){
                // The array here would be [ 1, 2, 3 ];
              });
              ```

              If any of the `promises` given to `all` are rejected, the first promise
              that is rejected will be given as an argument to the returned promises's
              rejection handler. For example:

              Example:

              ```javascript
              var promise1 = resolve(1);
              var promise2 = reject(new Error("2"));
              var promise3 = reject(new Error("3"));
              var promises = [ promise1, promise2, promise3 ];

              Promise.all(promises).then(function(array){
                // Code here never runs because there are rejected promises!
              }, function(error) {
                // error.message === "2"
              });
              ```

              @method all
              @static
              @param {Array} entries array of promises
              @param {String} label optional string for labeling the promise.
              Useful for tooling.
              @return {Promise} promise that is fulfilled when all `promises` have been
              fulfilled, or rejected if any of them become rejected.
              @static
            */
            function all(entries) {
              return new Enumerator(this, entries).promise;
            }

            /**
              `Promise.race` returns a new promise which is settled in the same way as the
              first passed promise to settle.

              Example:

              ```javascript
              var promise1 = new Promise(function(resolve, reject){
                setTimeout(function(){
                  resolve('promise 1');
                }, 200);
              });

              var promise2 = new Promise(function(resolve, reject){
                setTimeout(function(){
                  resolve('promise 2');
                }, 100);
              });

              Promise.race([promise1, promise2]).then(function(result){
                // result === 'promise 2' because it was resolved before promise1
                // was resolved.
              });
              ```

              `Promise.race` is deterministic in that only the state of the first
              settled promise matters. For example, even if other promises given to the
              `promises` array argument are resolved, but the first settled promise has
              become rejected before the other promises became fulfilled, the returned
              promise will become rejected:

              ```javascript
              var promise1 = new Promise(function(resolve, reject){
                setTimeout(function(){
                  resolve('promise 1');
                }, 200);
              });

              var promise2 = new Promise(function(resolve, reject){
                setTimeout(function(){
                  reject(new Error('promise 2'));
                }, 100);
              });

              Promise.race([promise1, promise2]).then(function(result){
                // Code here never runs
              }, function(reason){
                // reason.message === 'promise 2' because promise 2 became rejected before
                // promise 1 became fulfilled
              });
              ```

              An example real-world use case is implementing timeouts:

              ```javascript
              Promise.race([ajax('foo.json'), timeout(5000)])
              ```

              @method race
              @static
              @param {Array} promises array of promises to observe
              Useful for tooling.
              @return {Promise} a promise which settles in the same way as the first passed
              promise to settle.
            */
            function race(entries) {
              /*jshint validthis:true */
              var Constructor = this;

              var promise = new Constructor(noop);

              if (!isArray$1(entries)) {
                reject(promise, new TypeError('You must pass an array to race.'));
                return promise;
              }

              var length = entries.length;

              function onFulfillment(value) {
                _resolve(promise, value);
              }

              function onRejection(reason) {
                reject(promise, reason);
              }

              for (var i = 0; promise._state === PENDING && i < length; i++) {
                subscribe(Constructor.resolve(entries[i]), undefined, onFulfillment, onRejection);
              }

              return promise;
            }

            /**
              `Promise.reject` returns a promise rejected with the passed `reason`.
              It is shorthand for the following:

              ```javascript
              var promise = new Promise(function(resolve, reject){
                reject(new Error('WHOOPS'));
              });

              promise.then(function(value){
                // Code here doesn't run because the promise is rejected!
              }, function(reason){
                // reason.message === 'WHOOPS'
              });
              ```

              Instead of writing the above, your code now simply becomes the following:

              ```javascript
              var promise = Promise.reject(new Error('WHOOPS'));

              promise.then(function(value){
                // Code here doesn't run because the promise is rejected!
              }, function(reason){
                // reason.message === 'WHOOPS'
              });
              ```

              @method reject
              @static
              @param {Any} reason value that the returned promise will be rejected with.
              Useful for tooling.
              @return {Promise} a promise rejected with the given `reason`.
            */
            function reject$1(reason) {
              /*jshint validthis:true */
              var Constructor = this;
              var promise = new Constructor(noop);
              reject(promise, reason);
              return promise;
            }

            var counter = 0;

            function needsResolver() {
              throw new TypeError('You must pass a resolver function as the first argument to the promise constructor');
            }

            function needsNew() {
              throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.");
            }

            /**
              Promise objects represent the eventual result of an asynchronous operation. The
              primary way of interacting with a promise is through its `then` method, which
              registers callbacks to receive either a promise's eventual value or the reason
              why the promise cannot be fulfilled.

              Terminology
              -----------

              - `promise` is an object or function with a `then` method whose behavior conforms to this specification.
              - `thenable` is an object or function that defines a `then` method.
              - `value` is any legal JavaScript value (including undefined, a thenable, or a promise).
              - `exception` is a value that is thrown using the throw statement.
              - `reason` is a value that indicates why a promise was rejected.
              - `settled` the final resting state of a promise, fulfilled or rejected.

              A promise can be in one of three states: pending, fulfilled, or rejected.

              Promises that are fulfilled have a fulfillment value and are in the fulfilled
              state.  Promises that are rejected have a rejection reason and are in the
              rejected state.  A fulfillment value is never a thenable.

              Promises can also be said to *resolve* a value.  If this value is also a
              promise, then the original promise's settled state will match the value's
              settled state.  So a promise that *resolves* a promise that rejects will
              itself reject, and a promise that *resolves* a promise that fulfills will
              itself fulfill.


              Basic Usage:
              ------------

              ```js
              var promise = new Promise(function(resolve, reject) {
                // on success
                resolve(value);

                // on failure
                reject(reason);
              });

              promise.then(function(value) {
                // on fulfillment
              }, function(reason) {
                // on rejection
              });
              ```

              Advanced Usage:
              ---------------

              Promises shine when abstracting away asynchronous interactions such as
              `XMLHttpRequest`s.

              ```js
              function getJSON(url) {
                return new Promise(function(resolve, reject){
                  var xhr = new XMLHttpRequest();

                  xhr.open('GET', url);
                  xhr.onreadystatechange = handler;
                  xhr.responseType = 'json';
                  xhr.setRequestHeader('Accept', 'application/json');
                  xhr.send();

                  function handler() {
                    if (this.readyState === this.DONE) {
                      if (this.status === 200) {
                        resolve(this.response);
                      } else {
                        reject(new Error('getJSON: `' + url + '` failed with status: [' + this.status + ']'));
                      }
                    }
                  };
                });
              }

              getJSON('/posts.json').then(function(json) {
                // on fulfillment
              }, function(reason) {
                // on rejection
              });
              ```

              Unlike callbacks, promises are great composable primitives.

              ```js
              Promise.all([
                getJSON('/posts'),
                getJSON('/comments')
              ]).then(function(values){
                values[0] // => postsJSON
                values[1] // => commentsJSON

                return values;
              });
              ```

              @class Promise
              @param {function} resolver
              Useful for tooling.
              @constructor
            */
            function Promise(resolver) {
              this._id = counter++;
              this._state = undefined;
              this._result = undefined;
              this._subscribers = [];

              if (noop !== resolver) {
                typeof resolver !== 'function' && needsResolver();
                this instanceof Promise ? initializePromise(this, resolver) : needsNew();
              }
            }

            Promise.all = all;
            Promise.race = race;
            Promise.resolve = resolve$1;
            Promise.reject = reject$1;
            Promise._setScheduler = setScheduler;
            Promise._setAsap = setAsap;
            Promise._asap = asap;

            Promise.prototype = {
              constructor: Promise,

            /**
              The primary way of interacting with a promise is through its `then` method,
              which registers callbacks to receive either a promise's eventual value or the
              reason why the promise cannot be fulfilled.

              ```js
              findUser().then(function(user){
                // user is available
              }, function(reason){
                // user is unavailable, and you are given the reason why
              });
              ```

              Chaining
              --------

              The return value of `then` is itself a promise.  This second, 'downstream'
              promise is resolved with the return value of the first promise's fulfillment
              or rejection handler, or rejected if the handler throws an exception.

              ```js
              findUser().then(function (user) {
                return user.name;
              }, function (reason) {
                return 'default name';
              }).then(function (userName) {
                // If `findUser` fulfilled, `userName` will be the user's name, otherwise it
                // will be `'default name'`
              });

              findUser().then(function (user) {
                throw new Error('Found user, but still unhappy');
              }, function (reason) {
                throw new Error('`findUser` rejected and we're unhappy');
              }).then(function (value) {
                // never reached
              }, function (reason) {
                // if `findUser` fulfilled, `reason` will be 'Found user, but still unhappy'.
                // If `findUser` rejected, `reason` will be '`findUser` rejected and we're unhappy'.
              });
              ```
              If the downstream promise does not specify a rejection handler, rejection reasons will be propagated further downstream.

              ```js
              findUser().then(function (user) {
                throw new PedagogicalException('Upstream error');
              }).then(function (value) {
                // never reached
              }).then(function (value) {
                // never reached
              }, function (reason) {
                // The `PedgagocialException` is propagated all the way down to here
              });
              ```

              Assimilation
              ------------

              Sometimes the value you want to propagate to a downstream promise can only be
              retrieved asynchronously. This can be achieved by returning a promise in the
              fulfillment or rejection handler. The downstream promise will then be pending
              until the returned promise is settled. This is called *assimilation*.

              ```js
              findUser().then(function (user) {
                return findCommentsByAuthor(user);
              }).then(function (comments) {
                // The user's comments are now available
              });
              ```

              If the assimliated promise rejects, then the downstream promise will also reject.

              ```js
              findUser().then(function (user) {
                return findCommentsByAuthor(user);
              }).then(function (comments) {
                // If `findCommentsByAuthor` fulfills, we'll have the value here
              }, function (reason) {
                // If `findCommentsByAuthor` rejects, we'll have the reason here
              });
              ```

              Simple Example
              --------------

              Synchronous Example

              ```javascript
              var result;

              try {
                result = findResult();
                // success
              } catch(reason) {
                // failure
              }
              ```

              Errback Example

              ```js
              findResult(function(result, err){
                if (err) {
                  // failure
                } else {
                  // success
                }
              });
              ```

              Promise Example;

              ```javascript
              findResult().then(function(result){
                // success
              }, function(reason){
                // failure
              });
              ```

              Advanced Example
              --------------

              Synchronous Example

              ```javascript
              var author, books;

              try {
                author = findAuthor();
                books  = findBooksByAuthor(author);
                // success
              } catch(reason) {
                // failure
              }
              ```

              Errback Example

              ```js

              function foundBooks(books) {

              }

              function failure(reason) {

              }

              findAuthor(function(author, err){
                if (err) {
                  failure(err);
                  // failure
                } else {
                  try {
                    findBoooksByAuthor(author, function(books, err) {
                      if (err) {
                        failure(err);
                      } else {
                        try {
                          foundBooks(books);
                        } catch(reason) {
                          failure(reason);
                        }
                      }
                    });
                  } catch(error) {
                    failure(err);
                  }
                  // success
                }
              });
              ```

              Promise Example;

              ```javascript
              findAuthor().
                then(findBooksByAuthor).
                then(function(books){
                  // found books
              }).catch(function(reason){
                // something went wrong
              });
              ```

              @method then
              @param {Function} onFulfilled
              @param {Function} onRejected
              Useful for tooling.
              @return {Promise}
            */
              then: then,

            /**
              `catch` is simply sugar for `then(undefined, onRejection)` which makes it the same
              as the catch block of a try/catch statement.

              ```js
              function findAuthor(){
                throw new Error('couldn't find that author');
              }

              // synchronous
              try {
                findAuthor();
              } catch(reason) {
                // something went wrong
              }

              // async with promises
              findAuthor().catch(function(reason){
                // something went wrong
              });
              ```

              @method catch
              @param {Function} onRejection
              Useful for tooling.
              @return {Promise}
            */
              'catch': function(onRejection) {
                return this.then(null, onRejection);
              }
            };

            // TODO does this all work on windows?

            var absolutePath = /^(?:\/|(?:[A-Za-z]:)?[\\|\/])/;
            var relativePath = /^\.?\.\//;

            function isAbsolute(path) {
            	return absolutePath.test(path);
            }

            function isRelative(path) {
            	return relativePath.test(path);
            }

            function _basename(path) {
            	return path.split(/(\/|\\)/).pop();
            }

            function dirname(path) {
            	var match = /(\/|\\)[^\/\\]*$/.exec(path);
            	if (!match) return '.';

            	var dir = path.slice(0, -match[0].length);

            	// If `dir` is the empty string, we're at root.
            	return dir ? dir : '/';
            }

            function extname(path) {
            	var match = /\.[^\.]+$/.exec(_basename(path));
            	if (!match) return '';
            	return match[0];
            }

            function resolve() {
            	for (var _len = arguments.length, paths = Array(_len), _key = 0; _key < _len; _key++) {
            		paths[_key] = arguments[_key];
            	}

            	var resolvedParts = paths.shift().split(/[\/\\]/);

            	paths.forEach(function (path) {
            		if (isAbsolute(path)) {
            			resolvedParts = path.split(/[\/\\]/);
            		} else {
            			var parts = path.split(/[\/\\]/);

            			while (parts[0] === '.' || parts[0] === '..') {
            				var part = parts.shift();
            				if (part === '..') {
            					resolvedParts.pop();
            				}
            			}

            			resolvedParts.push.apply(resolvedParts, parts);
            		}
            	});

            	return resolvedParts.join('/'); // TODO windows...
            }

            function mkdirpath(path) {
            	var dir = dirname(path);
            	try {
            		fs.readdirSync(dir);
            	} catch (err) {
            		mkdirpath(dir);
            		fs.mkdirSync(dir);
            	}
            }

            function isFile(file) {
            	try {
            		var stats = fs.statSync(file);
            		return stats.isFile();
            	} catch (err) {
            		return false;
            	}
            }

            function writeFile(dest, data) {
            	return new Promise(function (fulfil, reject) {
            		mkdirpath(dest);

            		fs.writeFile(dest, data, function (err) {
            			if (err) {
            				reject(err);
            			} else {
            				fulfil();
            			}
            		});
            	});
            }

            var readFileSync = fs.readFileSync;

            var keys = Object.keys;
            function blank() {
            	return Object.create(null);
            }

            function forOwn(object, func) {
            	Object.keys(object).forEach(function (key) {
            		return func(object[key], key);
            	});
            }

            function validateKeys(object, allowedKeys) {
            	var actualKeys = keys(object);

            	var i = actualKeys.length;

            	while (i--) {
            		var key = actualKeys[i];

            		if (allowedKeys.indexOf(key) === -1) {
            			return new Error('Unexpected key \'' + key + '\' found, expected one of: ' + allowedKeys.join(', '));
            		}
            	}
            }

            // this looks ridiculous, but it prevents sourcemap tooling from mistaking
            // this for an actual sourceMappingURL
            var SOURCEMAPPING_URL = 'sourceMa';
            SOURCEMAPPING_URL += 'ppingURL';

            var SOURCEMAPPING_URL$1 = SOURCEMAPPING_URL;

            var charToInteger$1 = {};
            var integerToChar$1 = {};

            'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/='.split( '' ).forEach( function ( char, i ) {
            	charToInteger$1[ char ] = i;
            	integerToChar$1[ i ] = char;
            });

            function encode$1$1 ( value ) {
            	var result, i;

            	if ( typeof value === 'number' ) {
            		result = encodeInteger$1( value );
            	} else {
            		result = '';
            		for ( i = 0; i < value.length; i += 1 ) {
            			result += encodeInteger$1( value[i] );
            		}
            	}

            	return result;
            }

            function encodeInteger$1 ( num ) {
            	var result = '', clamped;

            	if ( num < 0 ) {
            		num = ( -num << 1 ) | 1;
            	} else {
            		num <<= 1;
            	}

            	do {
            		clamped = num & 31;
            		num >>= 5;

            		if ( num > 0 ) {
            			clamped |= 32;
            		}

            		result += integerToChar$1[ clamped ];
            	} while ( num > 0 );

            	return result;
            }

            function Patch(start, end, content, original, storeName) {
            	this.start = start;
            	this.end = end;
            	this.content = content;
            	this.original = original;
            	this.storeName = storeName;
            }

            Patch.prototype = {
            	clone: function clone() {
            		return new Patch(this.start, this.end, this.content, this.original, this.storeName);
            	}
            };

            var _btoa = undefined;

            if (typeof window !== 'undefined' && typeof window.btoa === 'function') {
            	_btoa = window.btoa;
            } else if (typeof Buffer === 'function') {
            	/* global Buffer */
            	_btoa = function (str) {
            		return new Buffer(str).toString('base64');
            	};
            } else {
            	throw new Error('Unsupported environment: `window.btoa` or `Buffer` should be supported.');
            }

            var btoa = _btoa;

            function SourceMap(properties) {
            	this.version = 3;

            	this.file = properties.file;
            	this.sources = properties.sources;
            	this.sourcesContent = properties.sourcesContent;
            	this.names = properties.names;
            	this.mappings = properties.mappings;
            }

            SourceMap.prototype = {
            	toString: function toString() {
            		return JSON.stringify(this);
            	},
            	toUrl: function toUrl() {
            		return 'data:application/json;charset=utf-8;base64,' + btoa(this.toString());
            	}
            };

            function guessIndent(code) {
            	var lines = code.split('\n');

            	var tabbed = lines.filter(function (line) {
            		return (/^\t+/.test(line)
            		);
            	});
            	var spaced = lines.filter(function (line) {
            		return (/^ {2,}/.test(line)
            		);
            	});

            	if (tabbed.length === 0 && spaced.length === 0) {
            		return null;
            	}

            	// More lines tabbed than spaced? Assume tabs, and
            	// default to tabs in the case of a tie (or nothing
            	// to go on)
            	if (tabbed.length >= spaced.length) {
            		return '\t';
            	}

            	// Otherwise, we need to guess the multiple
            	var min = spaced.reduce(function (previous, current) {
            		var numSpaces = /^ +/.exec(current)[0].length;
            		return Math.min(numSpaces, previous);
            	}, Infinity);

            	return new Array(min + 1).join(' ');
            }

            function encodeMappings(original, intro, patches, hires, sourcemapLocations, sourceIndex, offsets, names) {
            	var rawLines = [];

            	var generatedCodeLine = intro.split('\n').length - 1;
            	var rawSegments = rawLines[generatedCodeLine] = [];

            	var originalCharIndex = 0;

            	var generatedCodeColumn = 0;
            	var sourceCodeLine = 0;
            	var sourceCodeColumn = 0;

            	function addSegmentsUntil(end) {
            		var first = true;

            		while (originalCharIndex < end) {
            			if (hires || first || sourcemapLocations[originalCharIndex]) {
            				rawSegments.push({
            					generatedCodeLine: generatedCodeLine,
            					generatedCodeColumn: generatedCodeColumn,
            					sourceCodeLine: sourceCodeLine,
            					sourceCodeColumn: sourceCodeColumn,
            					sourceCodeName: -1,
            					sourceIndex: sourceIndex
            				});
            			}

            			if (original[originalCharIndex] === '\n') {
            				sourceCodeLine += 1;
            				sourceCodeColumn = 0;
            				generatedCodeLine += 1;
            				rawLines[generatedCodeLine] = rawSegments = [];
            				generatedCodeColumn = 0;
            			} else {
            				sourceCodeColumn += 1;
            				generatedCodeColumn += 1;
            			}

            			originalCharIndex += 1;
            			first = false;
            		}
            	}

            	for (var i = 0; i < patches.length; i += 1) {
            		var patch = patches[i];
            		var addSegmentForPatch = patch.storeName || patch.start > originalCharIndex;

            		addSegmentsUntil(patch.start);

            		if (addSegmentForPatch) {
            			rawSegments.push({
            				generatedCodeLine: generatedCodeLine,
            				generatedCodeColumn: generatedCodeColumn,
            				sourceCodeLine: sourceCodeLine,
            				sourceCodeColumn: sourceCodeColumn,
            				sourceCodeName: patch.storeName ? names.indexOf(patch.original) : -1,
            				sourceIndex: sourceIndex
            			});
            		}

            		var lines = patch.content.split('\n');
            		var lastLine = lines.pop();

            		if (lines.length) {
            			generatedCodeLine += lines.length;
            			rawLines[generatedCodeLine] = rawSegments = [];
            			generatedCodeColumn = lastLine.length;
            		} else {
            			generatedCodeColumn += lastLine.length;
            		}

            		lines = patch.original.split('\n');
            		lastLine = lines.pop();

            		if (lines.length) {
            			sourceCodeLine += lines.length;
            			sourceCodeColumn = lastLine.length;
            		} else {
            			sourceCodeColumn += lastLine.length;
            		}

            		originalCharIndex = patch.end;
            	}

            	addSegmentsUntil(original.length);

            	offsets.sourceIndex = offsets.sourceIndex || 0;
            	offsets.sourceCodeLine = offsets.sourceCodeLine || 0;
            	offsets.sourceCodeColumn = offsets.sourceCodeColumn || 0;
            	offsets.sourceCodeName = offsets.sourceCodeName || 0;

            	var encoded = rawLines.map(function (segments) {
            		var generatedCodeColumn = 0;

            		return segments.map(function (segment) {
            			var arr = [segment.generatedCodeColumn - generatedCodeColumn, segment.sourceIndex - offsets.sourceIndex, segment.sourceCodeLine - offsets.sourceCodeLine, segment.sourceCodeColumn - offsets.sourceCodeColumn];

            			generatedCodeColumn = segment.generatedCodeColumn;
            			offsets.sourceIndex = segment.sourceIndex;
            			offsets.sourceCodeLine = segment.sourceCodeLine;
            			offsets.sourceCodeColumn = segment.sourceCodeColumn;

            			if (~segment.sourceCodeName) {
            				arr.push(segment.sourceCodeName - offsets.sourceCodeName);
            				offsets.sourceCodeName = segment.sourceCodeName;
            			}

            			return encode$1$1(arr);
            		}).join(',');
            	}).join(';');

            	return encoded;
            }

            function getRelativePath(from, to) {
            	var fromParts = from.split(/[\/\\]/);
            	var toParts = to.split(/[\/\\]/);

            	fromParts.pop(); // get dirname

            	while (fromParts[0] === toParts[0]) {
            		fromParts.shift();
            		toParts.shift();
            	}

            	if (fromParts.length) {
            		var i = fromParts.length;
            		while (i--) {
            			fromParts[i] = '..';
            		}
            	}

            	return fromParts.concat(toParts).join('/');
            }

            var toString = Object.prototype.toString;

            function isObject(thing) {
            	return toString.call(thing) === '[object Object]';
            }

            var warned = false;

            function MagicString(string) {
            	var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

            	Object.defineProperties(this, {
            		original: { writable: true, value: string },
            		outro: { writable: true, value: '' },
            		intro: { writable: true, value: '' },
            		patches: { writable: true, value: [] },
            		filename: { writable: true, value: options.filename },
            		indentExclusionRanges: { writable: true, value: options.indentExclusionRanges },
            		sourcemapLocations: { writable: true, value: {} },
            		storedNames: { writable: true, value: {} },
            		indentStr: { writable: true, value: guessIndent(string) }
            	});
            }

            MagicString.prototype = {
            	addSourcemapLocation: function addSourcemapLocation(char) {
            		this.sourcemapLocations[char] = true;
            	},
            	append: function append(content) {
            		if (typeof content !== 'string') throw new TypeError('outro content must be a string');

            		this.outro += content;
            		return this;
            	},
            	clone: function clone() {
            		var cloned = new MagicString(this.original, { filename: this.filename });

            		cloned.patches = this.patches.map(function (patch) {
            			return patch.clone();
            		});

            		if (this.indentExclusionRanges) {
            			cloned.indentExclusionRanges = typeof this.indentExclusionRanges[0] === 'number' ? [this.indentExclusionRanges[0], this.indentExclusionRanges[1]] : this.indentExclusionRanges.map(function (range) {
            				return [range.start, range.end];
            			});
            		}

            		Object.keys(this.sourcemapLocations).forEach(function (loc) {
            			cloned.sourcemapLocations[loc] = true;
            		});

            		return cloned;
            	},
            	generateMap: function generateMap(options) {
            		options = options || {};

            		var names = Object.keys(this.storedNames);

            		return new SourceMap({
            			file: options.file ? options.file.split(/[\/\\]/).pop() : null,
            			sources: [options.source ? getRelativePath(options.file || '', options.source) : null],
            			sourcesContent: options.includeContent ? [this.original] : [null],
            			names: names,
            			mappings: this.getMappings(options.hires, 0, {}, names)
            		});
            	},
            	getIndentString: function getIndentString() {
            		return this.indentStr === null ? '\t' : this.indentStr;
            	},
            	getMappings: function getMappings(hires, sourceIndex, offsets, names) {
            		return encodeMappings(this.original, this.intro, this.patches, hires, this.sourcemapLocations, sourceIndex, offsets, names);
            	},
            	indent: function indent(indentStr, options) {
            		var _this = this;

            		var pattern = /^[^\r\n]/gm;

            		if (isObject(indentStr)) {
            			options = indentStr;
            			indentStr = undefined;
            		}

            		indentStr = indentStr !== undefined ? indentStr : this.indentStr || '\t';

            		if (indentStr === '') return this; // noop

            		options = options || {};

            		// Process exclusion ranges
            		var isExcluded = {};

            		if (options.exclude) {
            			var exclusions = typeof options.exclude[0] === 'number' ? [options.exclude] : options.exclude;
            			exclusions.forEach(function (exclusion) {
            				for (var i = exclusion[0]; i < exclusion[1]; i += 1) {
            					isExcluded[i] = true;
            				}
            			});
            		}

            		var shouldIndentNextCharacter = options.indentStart !== false;
            		var replacer = function replacer(match) {
            			if (shouldIndentNextCharacter) return '' + indentStr + match;
            			shouldIndentNextCharacter = true;
            			return match;
            		};

            		this.intro = this.intro.replace(pattern, replacer);

            		var charIndex = 0;
            		var patchIndex = 0;

            		var indentUntil = function indentUntil(end) {
            			while (charIndex < end) {
            				if (!isExcluded[charIndex]) {
            					var char = _this.original[charIndex];

            					if (char === '\n') {
            						shouldIndentNextCharacter = true;
            					} else if (char !== '\r' && shouldIndentNextCharacter) {
            						_this.patches.splice(patchIndex, 0, new Patch(charIndex, charIndex, indentStr, '', false));
            						shouldIndentNextCharacter = false;

            						patchIndex += 1;
            					}
            				}

            				charIndex += 1;
            			}
            		};

            		for (; patchIndex < this.patches.length; patchIndex += 1) {
            			// can't cache this.patches.length, it may change
            			var patch = this.patches[patchIndex];

            			indentUntil(patch.start);

            			if (!isExcluded[charIndex]) {
            				patch.content = patch.content.replace(pattern, replacer);

            				if (patch.content.length) {
            					shouldIndentNextCharacter = patch.content[patch.content.length - 1] === '\n';
            				}
            			}

            			charIndex = patch.end;
            		}

            		indentUntil(this.original.length);

            		this.outro = this.outro.replace(pattern, replacer);

            		return this;
            	},
            	insert: function insert(index, content) {
            		if (typeof content !== 'string') {
            			throw new TypeError('inserted content must be a string');
            		}

            		this.patch(index, index, content);
            		return this;
            	},

            	// get current location of character in original string
            	locate: function locate(character) {
            		throw new Error('magicString.locate is deprecated');
            	},
            	locateOrigin: function locateOrigin(character) {
            		throw new Error('magicString.locateOrigin is deprecated');
            	},
            	overwrite: function overwrite(start, end, content, storeName) {
            		if (typeof content !== 'string') {
            			throw new TypeError('replacement content must be a string');
            		}

            		this.patch(start, end, content, storeName);
            		return this;
            	},
            	patch: function patch(start, end, content, storeName) {
            		var original = this.original.slice(start, end);
            		if (storeName) this.storedNames[original] = true;

            		var i = this.patches.length;
            		while (i--) {
            			var previous = this.patches[i];

            			// TODO can we tidy this up?

            			// if this completely covers previous patch, remove it
            			if (start !== end && start <= previous.start && end >= previous.end) {
            				// unless it's an insert at the start
            				if (previous.start === previous.end && previous.start === start) break;
            				// or it's an insert at the end
            				if (previous.start === previous.end && previous.end === end) continue;
            				this.patches.splice(i, 1);
            			}

            			// if it overlaps, throw error
            			else if (start < previous.end && end > previous.start) {
            					// special case – it's okay to remove overlapping ranges
            					if (!previous.content.length && !content.length) {
            						previous.start = Math.min(start, previous.start);
            						previous.end = Math.max(end, previous.end);
            						return;
            					}

            					throw new Error('Cannot overwrite the same content twice: \'' + original + '\'');
            				}

            				// if this precedes previous patch, stop search
            				else if (start >= previous.end) {
            						break;
            					}
            		}

            		var patch = new Patch(start, end, content, original, storeName);
            		this.patches.splice(i + 1, 0, patch);
            		return patch;
            	},
            	prepend: function prepend(content) {
            		if (typeof content !== 'string') throw new TypeError('outro content must be a string');

            		this.intro = content + this.intro;
            		return this;
            	},
            	remove: function remove(start, end) {
            		if (start < 0 || end > this.original.length) {
            			throw new Error('Character is out of bounds');
            		}

            		this.patch(start, end, '');
            		return this;
            	},
            	replace: function replace(start, end, content) {
            		if (!warned) {
            			console.warn('magicString.replace(...) is deprecated. Use magicString.overwrite(...) instead');
            			warned = true;
            		}

            		return this.overwrite(start, end, content);
            	},
            	slice: function slice(start) {
            		var end = arguments.length <= 1 || arguments[1] === undefined ? this.original.length : arguments[1];

            		while (start < 0) {
            			start += this.original.length;
            		}while (end < 0) {
            			end += this.original.length;
            		}var firstPatchIndex = 0;
            		var lastPatchIndex = this.patches.length;

            		while (lastPatchIndex--) {
            			var patch = this.patches[lastPatchIndex];
            			if (end >= patch.start && end < patch.end) throw new Error('Cannot use replaced characters (' + start + ', ' + end + ') as slice anchors');

            			// TODO this is weird, rewrite it
            			if (patch.start > end) continue;
            			break;
            		}

            		for (firstPatchIndex = 0; firstPatchIndex <= lastPatchIndex; firstPatchIndex += 1) {
            			var patch = this.patches[firstPatchIndex];
            			if (start > patch.start && start <= patch.end) throw new Error('Cannot use replaced characters (' + start + ', ' + end + ') as slice anchors');

            			if (start <= patch.start) {
            				break;
            			}
            		}

            		var result = '';
            		var lastIndex = start;

            		for (var i = firstPatchIndex; i <= lastPatchIndex; i += 1) {
            			var patch = this.patches[i];
            			result += this.original.slice(lastIndex, patch.start);
            			result += patch.content;

            			lastIndex = patch.end;
            		}

            		result += this.original.slice(lastIndex, end);

            		return result;
            	},
            	snip: function snip(start, end) {
            		var clone = this.clone();
            		clone.remove(0, start);
            		clone.remove(end, clone.original.length);

            		return clone;
            	},
            	toString: function toString() {
            		return this.intro + this.slice(0, this.original.length) + this.outro;
            	},
            	trimLines: function trimLines() {
            		return this.trim('[\\r\\n]');
            	},
            	trim: function trim(charType) {
            		return this.trimStart(charType).trimEnd(charType);
            	},
            	trimEnd: function trimEnd(charType) {
            		var rx = new RegExp((charType || '\\s') + '+$');

            		this.outro = this.outro.replace(rx, '');
            		if (this.outro.length) return this;

            		var charIndex = this.original.length;
            		var i = this.patches.length;

            		while (i--) {
            			var patch = this.patches[i];

            			if (charIndex > patch.end) {
            				var _slice = this.original.slice(patch.end, charIndex);

            				var _match = rx.exec(_slice);
            				if (_match) {
            					this.patch(charIndex - _match[0].length, charIndex, '');
            				}

            				if (!_match || _match[0].length < _slice.length) {
            					// there is non-whitespace after the patch
            					return this;
            				}
            			}

            			patch.content = patch.content.replace(rx, '');
            			if (patch.content) return this;

            			charIndex = patch.start;
            		}

            		var slice = this.original.slice(0, charIndex);

            		var match = rx.exec(slice);
            		if (match) this.patch(charIndex - match[0].length, charIndex, '');

            		return this;
            	},
            	trimStart: function trimStart(charType) {
            		var rx = new RegExp('^' + (charType || '\\s') + '+');

            		this.intro = this.intro.replace(rx, '');
            		if (this.intro.length) return this;

            		var charIndex = 0;

            		for (var i = 0; i < this.patches.length; i += 1) {
            			var patch = this.patches[i];

            			if (charIndex < patch.start) {
            				var _slice2 = this.original.slice(charIndex, patch.start);

            				var _match2 = rx.exec(_slice2);
            				if (_match2) this.patch(charIndex, charIndex + _match2[0].length, '');

            				if (!_match2 || _match2[0].length < _slice2.length) {
            					// there is non-whitespace before the patch
            					return this;
            				}
            			}

            			patch.content = patch.content.replace(rx, '');
            			if (patch.content) return this;

            			charIndex = patch.end;
            		}

            		var slice = this.original.slice(charIndex, this.original.length);

            		var match = rx.exec(slice);
            		if (match) this.patch(charIndex, charIndex + match[0].length, '');

            		return this;
            	}
            };

            var hasOwnProp = Object.prototype.hasOwnProperty;

            function Bundle$1() {
            	var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

            	this.intro = options.intro || '';
            	this.separator = options.separator !== undefined ? options.separator : '\n';

            	this.sources = [];

            	this.uniqueSources = [];
            	this.uniqueSourceIndexByFilename = {};
            }

            Bundle$1.prototype = {
            	addSource: function addSource(source) {
            		if (source instanceof MagicString) {
            			return this.addSource({
            				content: source,
            				filename: source.filename,
            				separator: this.separator
            			});
            		}

            		if (!isObject(source) || !source.content) {
            			throw new Error('bundle.addSource() takes an object with a `content` property, which should be an instance of MagicString, and an optional `filename`');
            		}

            		['filename', 'indentExclusionRanges', 'separator'].forEach(function (option) {
            			if (!hasOwnProp.call(source, option)) source[option] = source.content[option];
            		});

            		if (source.separator === undefined) {
            			// TODO there's a bunch of this sort of thing, needs cleaning up
            			source.separator = this.separator;
            		}

            		if (source.filename) {
            			if (!hasOwnProp.call(this.uniqueSourceIndexByFilename, source.filename)) {
            				this.uniqueSourceIndexByFilename[source.filename] = this.uniqueSources.length;
            				this.uniqueSources.push({ filename: source.filename, content: source.content.original });
            			} else {
            				var uniqueSource = this.uniqueSources[this.uniqueSourceIndexByFilename[source.filename]];
            				if (source.content.original !== uniqueSource.content) {
            					throw new Error('Illegal source: same filename (' + source.filename + '), different contents');
            				}
            			}
            		}

            		this.sources.push(source);
            		return this;
            	},
            	append: function append(str, options) {
            		this.addSource({
            			content: new MagicString(str),
            			separator: options && options.separator || ''
            		});

            		return this;
            	},
            	clone: function clone() {
            		var bundle = new Bundle$1({
            			intro: this.intro,
            			separator: this.separator
            		});

            		this.sources.forEach(function (source) {
            			bundle.addSource({
            				filename: source.filename,
            				content: source.content.clone(),
            				separator: source.separator
            			});
            		});

            		return bundle;
            	},
            	generateMap: function generateMap(options) {
            		var _this = this;

            		var offsets = {};

            		var names = [];
            		this.sources.forEach(function (source) {
            			Object.keys(source.content.storedNames).forEach(function (name) {
            				if (! ~names.indexOf(name)) names.push(name);
            			});
            		});

            		var encoded = getSemis(this.intro) + this.sources.map(function (source, i) {
            			var prefix = i > 0 ? getSemis(source.separator) || ',' : '';
            			var mappings = undefined;

            			// we don't bother encoding sources without a filename
            			if (!source.filename) {
            				mappings = getSemis(source.content.toString());
            			} else {
            				var sourceIndex = _this.uniqueSourceIndexByFilename[source.filename];
            				mappings = source.content.getMappings(options.hires, sourceIndex, offsets, names);
            			}

            			return prefix + mappings;
            		}).join('');

            		return new SourceMap({
            			file: options.file ? options.file.split(/[\/\\]/).pop() : null,
            			sources: this.uniqueSources.map(function (source) {
            				return options.file ? getRelativePath(options.file, source.filename) : source.filename;
            			}),
            			sourcesContent: this.uniqueSources.map(function (source) {
            				return options.includeContent ? source.content : null;
            			}),
            			names: names,
            			mappings: encoded
            		});
            	},
            	getIndentString: function getIndentString() {
            		var indentStringCounts = {};

            		this.sources.forEach(function (source) {
            			var indentStr = source.content.indentStr;

            			if (indentStr === null) return;

            			if (!indentStringCounts[indentStr]) indentStringCounts[indentStr] = 0;
            			indentStringCounts[indentStr] += 1;
            		});

            		return Object.keys(indentStringCounts).sort(function (a, b) {
            			return indentStringCounts[a] - indentStringCounts[b];
            		})[0] || '\t';
            	},
            	indent: function indent(indentStr) {
            		var _this2 = this;

            		if (!arguments.length) {
            			indentStr = this.getIndentString();
            		}

            		if (indentStr === '') return this; // noop

            		var trailingNewline = !this.intro || this.intro.slice(-1) === '\n';

            		this.sources.forEach(function (source, i) {
            			var separator = source.separator !== undefined ? source.separator : _this2.separator;
            			var indentStart = trailingNewline || i > 0 && /\r?\n$/.test(separator);

            			source.content.indent(indentStr, {
            				exclude: source.indentExclusionRanges,
            				indentStart: indentStart //: trailingNewline || /\r?\n$/.test( separator )  //true///\r?\n/.test( separator )
            			});

            			// TODO this is a very slow way to determine this
            			trailingNewline = source.content.toString().slice(0, -1) === '\n';
            		});

            		if (this.intro) {
            			this.intro = indentStr + this.intro.replace(/^[^\n]/gm, function (match, index) {
            				return index > 0 ? indentStr + match : match;
            			});
            		}

            		return this;
            	},
            	prepend: function prepend(str) {
            		this.intro = str + this.intro;
            		return this;
            	},
            	toString: function toString() {
            		var _this3 = this;

            		var body = this.sources.map(function (source, i) {
            			var separator = source.separator !== undefined ? source.separator : _this3.separator;
            			var str = (i > 0 ? separator : '') + source.content.toString();

            			return str;
            		}).join('');

            		return this.intro + body;
            	},
            	trimLines: function trimLines() {
            		return this.trim('[\\r\\n]');
            	},
            	trim: function trim(charType) {
            		return this.trimStart(charType).trimEnd(charType);
            	},
            	trimStart: function trimStart(charType) {
            		var rx = new RegExp('^' + (charType || '\\s') + '+');
            		this.intro = this.intro.replace(rx, '');

            		if (!this.intro) {
            			var source = undefined;
            			var i = 0;

            			do {
            				source = this.sources[i];

            				if (!source) {
            					break;
            				}

            				source.content.trimStart(charType);
            				i += 1;
            			} while (source.content.toString() === ''); // TODO faster way to determine non-empty source?
            		}

            		return this;
            	},
            	trimEnd: function trimEnd(charType) {
            		var rx = new RegExp((charType || '\\s') + '+$');

            		var source = undefined;
            		var i = this.sources.length - 1;

            		do {
            			source = this.sources[i];

            			if (!source) {
            				this.intro = this.intro.replace(rx, '');
            				break;
            			}

            			source.content.trimEnd(charType);
            			i -= 1;
            		} while (source.content.toString() === ''); // TODO faster way to determine non-empty source?

            		return this;
            	}
            };

            function getSemis(str) {
            	return new Array(str.split('\n').length).join(';');
            }

            MagicString.Bundle = Bundle$1;

            // Return the first non-falsy result from an array of
            // maybe-sync, maybe-promise-returning functions

            function first(candidates) {
            	return function () {
            		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            			args[_key] = arguments[_key];
            		}

            		return candidates.reduce(function (promise, candidate) {
            			return promise.then(function (result) {
            				return result != null ? result : Promise.resolve(candidate.apply(undefined, args));
            			});
            		}, Promise.resolve());
            	};
            }

            // This is a trick taken from Esprima. It turns out that, on
            // non-Chrome browsers, to check whether a string is in a set, a
            // predicate containing a big ugly `switch` statement is faster than
            // a regular expression, and on Chrome the two are about on par.
            // This function uses `eval` (non-lexical) to produce such a
            // predicate from a space-separated string of words.
            //
            // It starts by sorting the words by length.

            // Reserved word lists for various dialects of the language

            var reservedWords$1 = {
              3: "abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile",
              5: "class enum extends super const export import",
              6: "enum",
              strict: "implements interface let package private protected public static yield",
              strictBind: "eval arguments"
            };

            // And the keywords

            var ecma5AndLessKeywords = "break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this";

            var keywords = {
              5: ecma5AndLessKeywords,
              6: ecma5AndLessKeywords + " let const class extends export import yield super"
            };

            // ## Character categories

            // Big ugly regular expressions that match characters in the
            // whitespace, identifier, and identifier-start categories. These
            // are only applied when a character is found to actually have a
            // code point above 128.
            // Generated by `bin/generate-identifier-regex.js`.

            var nonASCIIidentifierStartChars = "\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-\u02c1\u02c6-\u02d1\u02e0-\u02e4\u02ec\u02ee\u0370-\u0374\u0376\u0377\u037a-\u037d\u037f\u0386\u0388-\u038a\u038c\u038e-\u03a1\u03a3-\u03f5\u03f7-\u0481\u048a-\u052f\u0531-\u0556\u0559\u0561-\u0587\u05d0-\u05ea\u05f0-\u05f2\u0620-\u064a\u066e\u066f\u0671-\u06d3\u06d5\u06e5\u06e6\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u07f4\u07f5\u07fa\u0800-\u0815\u081a\u0824\u0828\u0840-\u0858\u08a0-\u08b2\u0904-\u0939\u093d\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce\u09dc\u09dd\u09df-\u09e1\u09f0\u09f1\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35\u0a36\u0a38\u0a39\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2\u0ab3\u0ab5-\u0ab9\u0abd\u0ad0\u0ae0\u0ae1\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33\u0b35-\u0b39\u0b3d\u0b5c\u0b5d\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c39\u0c3d\u0c58\u0c59\u0c60\u0c61\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9\u0cbd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2\u0d05-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d60\u0d61\u0d7a-\u0d7f\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e46\u0e81\u0e82\u0e84\u0e87\u0e88\u0e8a\u0e8d\u0e94-\u0e97\u0e99-\u0e9f\u0ea1-\u0ea3\u0ea5\u0ea7\u0eaa\u0eab\u0ead-\u0eb0\u0eb2\u0eb3\u0ebd\u0ec0-\u0ec4\u0ec6\u0edc-\u0edf\u0f00\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070\u1075-\u1081\u108e\u10a0-\u10c5\u10c7\u10cd\u10d0-\u10fa\u10fc-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f4\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u16ee-\u16f8\u1700-\u170c\u170e-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17d7\u17dc\u1820-\u1877\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191e\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19c1-\u19c7\u1a00-\u1a16\u1a20-\u1a54\u1aa7\u1b05-\u1b33\u1b45-\u1b4b\u1b83-\u1ba0\u1bae\u1baf\u1bba-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f\u1c5a-\u1c7d\u1ce9-\u1cec\u1cee-\u1cf1\u1cf5\u1cf6\u1d00-\u1dbf\u1e00-\u1f15\u1f18-\u1f1d\u1f20-\u1f45\u1f48-\u1f4d\u1f50-\u1f57\u1f59\u1f5b\u1f5d\u1f5f-\u1f7d\u1f80-\u1fb4\u1fb6-\u1fbc\u1fbe\u1fc2-\u1fc4\u1fc6-\u1fcc\u1fd0-\u1fd3\u1fd6-\u1fdb\u1fe0-\u1fec\u1ff2-\u1ff4\u1ff6-\u1ffc\u2071\u207f\u2090-\u209c\u2102\u2107\u210a-\u2113\u2115\u2118-\u211d\u2124\u2126\u2128\u212a-\u2139\u213c-\u213f\u2145-\u2149\u214e\u2160-\u2188\u2c00-\u2c2e\u2c30-\u2c5e\u2c60-\u2ce4\u2ceb-\u2cee\u2cf2\u2cf3\u2d00-\u2d25\u2d27\u2d2d\u2d30-\u2d67\u2d6f\u2d80-\u2d96\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303c\u3041-\u3096\u309b-\u309f\u30a1-\u30fa\u30fc-\u30ff\u3105-\u312d\u3131-\u318e\u31a0-\u31ba\u31f0-\u31ff\u3400-\u4db5\u4e00-\u9fcc\ua000-\ua48c\ua4d0-\ua4fd\ua500-\ua60c\ua610-\ua61f\ua62a\ua62b\ua640-\ua66e\ua67f-\ua69d\ua6a0-\ua6ef\ua717-\ua71f\ua722-\ua788\ua78b-\ua78e\ua790-\ua7ad\ua7b0\ua7b1\ua7f7-\ua801\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua90a-\ua925\ua930-\ua946\ua960-\ua97c\ua984-\ua9b2\ua9cf\ua9e0-\ua9e4\ua9e6-\ua9ef\ua9fa-\ua9fe\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa76\uaa7a\uaa7e-\uaaaf\uaab1\uaab5\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb-\uaadd\uaae0-\uaaea\uaaf2-\uaaf4\uab01-\uab06\uab09-\uab0e\uab11-\uab16\uab20-\uab26\uab28-\uab2e\uab30-\uab5a\uab5c-\uab5f\uab64\uab65\uabc0-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa6d\ufa70-\ufad9\ufb00-\ufb06\ufb13-\ufb17\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44\ufb46-\ufbb1\ufbd3-\ufd3d\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff21-\uff3a\uff41-\uff5a\uff66-\uffbe\uffc2-\uffc7\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc";
            var nonASCIIidentifierChars = "\u200c\u200d\xb7\u0300-\u036f\u0387\u0483-\u0487\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u0669\u0670\u06d6-\u06dc\u06df-\u06e4\u06e7\u06e8\u06ea-\u06ed\u06f0-\u06f9\u0711\u0730-\u074a\u07a6-\u07b0\u07c0-\u07c9\u07eb-\u07f3\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0859-\u085b\u08e4-\u0903\u093a-\u093c\u093e-\u094f\u0951-\u0957\u0962\u0963\u0966-\u096f\u0981-\u0983\u09bc\u09be-\u09c4\u09c7\u09c8\u09cb-\u09cd\u09d7\u09e2\u09e3\u09e6-\u09ef\u0a01-\u0a03\u0a3c\u0a3e-\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a66-\u0a71\u0a75\u0a81-\u0a83\u0abc\u0abe-\u0ac5\u0ac7-\u0ac9\u0acb-\u0acd\u0ae2\u0ae3\u0ae6-\u0aef\u0b01-\u0b03\u0b3c\u0b3e-\u0b44\u0b47\u0b48\u0b4b-\u0b4d\u0b56\u0b57\u0b62\u0b63\u0b66-\u0b6f\u0b82\u0bbe-\u0bc2\u0bc6-\u0bc8\u0bca-\u0bcd\u0bd7\u0be6-\u0bef\u0c00-\u0c03\u0c3e-\u0c44\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0c66-\u0c6f\u0c81-\u0c83\u0cbc\u0cbe-\u0cc4\u0cc6-\u0cc8\u0cca-\u0ccd\u0cd5\u0cd6\u0ce2\u0ce3\u0ce6-\u0cef\u0d01-\u0d03\u0d3e-\u0d44\u0d46-\u0d48\u0d4a-\u0d4d\u0d57\u0d62\u0d63\u0d66-\u0d6f\u0d82\u0d83\u0dca\u0dcf-\u0dd4\u0dd6\u0dd8-\u0ddf\u0de6-\u0def\u0df2\u0df3\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0e50-\u0e59\u0eb1\u0eb4-\u0eb9\u0ebb\u0ebc\u0ec8-\u0ecd\u0ed0-\u0ed9\u0f18\u0f19\u0f20-\u0f29\u0f35\u0f37\u0f39\u0f3e\u0f3f\u0f71-\u0f84\u0f86\u0f87\u0f8d-\u0f97\u0f99-\u0fbc\u0fc6\u102b-\u103e\u1040-\u1049\u1056-\u1059\u105e-\u1060\u1062-\u1064\u1067-\u106d\u1071-\u1074\u1082-\u108d\u108f-\u109d\u135d-\u135f\u1369-\u1371\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17b4-\u17d3\u17dd\u17e0-\u17e9\u180b-\u180d\u1810-\u1819\u18a9\u1920-\u192b\u1930-\u193b\u1946-\u194f\u19b0-\u19c0\u19c8\u19c9\u19d0-\u19da\u1a17-\u1a1b\u1a55-\u1a5e\u1a60-\u1a7c\u1a7f-\u1a89\u1a90-\u1a99\u1ab0-\u1abd\u1b00-\u1b04\u1b34-\u1b44\u1b50-\u1b59\u1b6b-\u1b73\u1b80-\u1b82\u1ba1-\u1bad\u1bb0-\u1bb9\u1be6-\u1bf3\u1c24-\u1c37\u1c40-\u1c49\u1c50-\u1c59\u1cd0-\u1cd2\u1cd4-\u1ce8\u1ced\u1cf2-\u1cf4\u1cf8\u1cf9\u1dc0-\u1df5\u1dfc-\u1dff\u203f\u2040\u2054\u20d0-\u20dc\u20e1\u20e5-\u20f0\u2cef-\u2cf1\u2d7f\u2de0-\u2dff\u302a-\u302f\u3099\u309a\ua620-\ua629\ua66f\ua674-\ua67d\ua69f\ua6f0\ua6f1\ua802\ua806\ua80b\ua823-\ua827\ua880\ua881\ua8b4-\ua8c4\ua8d0-\ua8d9\ua8e0-\ua8f1\ua900-\ua909\ua926-\ua92d\ua947-\ua953\ua980-\ua983\ua9b3-\ua9c0\ua9d0-\ua9d9\ua9e5\ua9f0-\ua9f9\uaa29-\uaa36\uaa43\uaa4c\uaa4d\uaa50-\uaa59\uaa7b-\uaa7d\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uaaeb-\uaaef\uaaf5\uaaf6\uabe3-\uabea\uabec\uabed\uabf0-\uabf9\ufb1e\ufe00-\ufe0f\ufe20-\ufe2d\ufe33\ufe34\ufe4d-\ufe4f\uff10-\uff19\uff3f";

            var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
            var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");

            nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;

            // These are a run-length and offset encoded representation of the
            // >0xffff code points that are a valid part of identifiers. The
            // offset starts at 0x10000, and each pair of numbers represents an
            // offset to the next range, and then a size of the range. They were
            // generated by tools/generate-identifier-regex.js
            var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 17, 26, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 99, 39, 9, 51, 157, 310, 10, 21, 11, 7, 153, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 98, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 26, 45, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 955, 52, 76, 44, 33, 24, 27, 35, 42, 34, 4, 0, 13, 47, 15, 3, 22, 0, 38, 17, 2, 24, 133, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 32, 4, 287, 47, 21, 1, 2, 0, 185, 46, 82, 47, 21, 0, 60, 42, 502, 63, 32, 0, 449, 56, 1288, 920, 104, 110, 2962, 1070, 13266, 568, 8, 30, 114, 29, 19, 47, 17, 3, 32, 20, 6, 18, 881, 68, 12, 0, 67, 12, 16481, 1, 3071, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 4149, 196, 1340, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42710, 42, 4148, 12, 221, 16355, 541];
            var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 1306, 2, 54, 14, 32, 9, 16, 3, 46, 10, 54, 9, 7, 2, 37, 13, 2, 9, 52, 0, 13, 2, 49, 13, 16, 9, 83, 11, 168, 11, 6, 9, 8, 2, 57, 0, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 316, 19, 13, 9, 214, 6, 3, 8, 112, 16, 16, 9, 82, 12, 9, 9, 535, 9, 20855, 9, 135, 4, 60, 6, 26, 9, 1016, 45, 17, 3, 19723, 1, 5319, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 4305, 6, 792618, 239];

            // This has a complexity linear to the value of the code. The
            // assumption is that looking up astral identifier characters is
            // rare.
            function isInAstralSet(code, set) {
              var pos = 0x10000;
              for (var i = 0; i < set.length; i += 2) {
                pos += set[i];
                if (pos > code) return false;
                pos += set[i + 1];
                if (pos >= code) return true;
              }
            }

            // Test whether a given character code starts an identifier.

            function isIdentifierStart(code, astral) {
              if (code < 65) return code === 36;
              if (code < 91) return true;
              if (code < 97) return code === 95;
              if (code < 123) return true;
              if (code <= 0xffff) return code >= 0xaa && nonASCIIidentifierStart.test(String.fromCharCode(code));
              if (astral === false) return false;
              return isInAstralSet(code, astralIdentifierStartCodes);
            }

            // Test whether a given character is part of an identifier.

            function isIdentifierChar(code, astral) {
              if (code < 48) return code === 36;
              if (code < 58) return true;
              if (code < 65) return false;
              if (code < 91) return true;
              if (code < 97) return code === 95;
              if (code < 123) return true;
              if (code <= 0xffff) return code >= 0xaa && nonASCIIidentifier.test(String.fromCharCode(code));
              if (astral === false) return false;
              return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
            }

            // ## Token types

            // The assignment of fine-grained, information-carrying type objects
            // allows the tokenizer to store the information it has about a
            // token in a way that is very cheap for the parser to look up.

            // All token type variables start with an underscore, to make them
            // easy to recognize.

            // The `beforeExpr` property is used to disambiguate between regular
            // expressions and divisions. It is set on all token types that can
            // be followed by an expression (thus, a slash after them would be a
            // regular expression).
            //
            // The `startsExpr` property is used to check if the token ends a
            // `yield` expression. It is set on all token types that either can
            // directly start an expression (like a quotation mark) or can
            // continue an expression (like the body of a string).
            //
            // `isLoop` marks a keyword as starting a loop, which is important
            // to know when parsing a label, in order to allow or disallow
            // continue jumps to that label.

            var TokenType = function TokenType(label) {
              var conf = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
              babelHelpers.classCallCheck(this, TokenType);

              this.label = label;
              this.keyword = conf.keyword;
              this.beforeExpr = !!conf.beforeExpr;
              this.startsExpr = !!conf.startsExpr;
              this.isLoop = !!conf.isLoop;
              this.isAssign = !!conf.isAssign;
              this.prefix = !!conf.prefix;
              this.postfix = !!conf.postfix;
              this.binop = conf.binop || null;
              this.updateContext = null;
            };

            function binop(name, prec) {
              return new TokenType(name, { beforeExpr: true, binop: prec });
            }
            var beforeExpr = { beforeExpr: true };
            var startsExpr = { startsExpr: true };
            var tt = {
              num: new TokenType("num", startsExpr),
              regexp: new TokenType("regexp", startsExpr),
              string: new TokenType("string", startsExpr),
              name: new TokenType("name", startsExpr),
              eof: new TokenType("eof"),

              // Punctuation token types.
              bracketL: new TokenType("[", { beforeExpr: true, startsExpr: true }),
              bracketR: new TokenType("]"),
              braceL: new TokenType("{", { beforeExpr: true, startsExpr: true }),
              braceR: new TokenType("}"),
              parenL: new TokenType("(", { beforeExpr: true, startsExpr: true }),
              parenR: new TokenType(")"),
              comma: new TokenType(",", beforeExpr),
              semi: new TokenType(";", beforeExpr),
              colon: new TokenType(":", beforeExpr),
              dot: new TokenType("."),
              question: new TokenType("?", beforeExpr),
              arrow: new TokenType("=>", beforeExpr),
              template: new TokenType("template"),
              ellipsis: new TokenType("...", beforeExpr),
              backQuote: new TokenType("`", startsExpr),
              dollarBraceL: new TokenType("${", { beforeExpr: true, startsExpr: true }),

              // Operators. These carry several kinds of properties to help the
              // parser use them properly (the presence of these properties is
              // what categorizes them as operators).
              //
              // `binop`, when present, specifies that this operator is a binary
              // operator, and will refer to its precedence.
              //
              // `prefix` and `postfix` mark the operator as a prefix or postfix
              // unary operator.
              //
              // `isAssign` marks all of `=`, `+=`, `-=` etcetera, which act as
              // binary operators with a very low precedence, that should result
              // in AssignmentExpression nodes.

              eq: new TokenType("=", { beforeExpr: true, isAssign: true }),
              assign: new TokenType("_=", { beforeExpr: true, isAssign: true }),
              incDec: new TokenType("++/--", { prefix: true, postfix: true, startsExpr: true }),
              prefix: new TokenType("prefix", { beforeExpr: true, prefix: true, startsExpr: true }),
              logicalOR: binop("||", 1),
              logicalAND: binop("&&", 2),
              bitwiseOR: binop("|", 3),
              bitwiseXOR: binop("^", 4),
              bitwiseAND: binop("&", 5),
              equality: binop("==/!=", 6),
              relational: binop("</>", 7),
              bitShift: binop("<</>>", 8),
              plusMin: new TokenType("+/-", { beforeExpr: true, binop: 9, prefix: true, startsExpr: true }),
              modulo: binop("%", 10),
              star: binop("*", 10),
              slash: binop("/", 10)
            };

            // Map keyword names to token types.

            var keywordTypes = {};

            // Succinct definitions of keyword token types
            function kw(name) {
              var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

              options.keyword = name;
              keywordTypes[name] = tt["_" + name] = new TokenType(name, options);
            }

            kw("break");
            kw("case", beforeExpr);
            kw("catch");
            kw("continue");
            kw("debugger");
            kw("default", beforeExpr);
            kw("do", { isLoop: true, beforeExpr: true });
            kw("else", beforeExpr);
            kw("finally");
            kw("for", { isLoop: true });
            kw("function", startsExpr);
            kw("if");
            kw("return", beforeExpr);
            kw("switch");
            kw("throw", beforeExpr);
            kw("try");
            kw("var");
            kw("let");
            kw("const");
            kw("while", { isLoop: true });
            kw("with");
            kw("new", { beforeExpr: true, startsExpr: true });
            kw("this", startsExpr);
            kw("super", startsExpr);
            kw("class");
            kw("extends", beforeExpr);
            kw("export");
            kw("import");
            kw("yield", { beforeExpr: true, startsExpr: true });
            kw("null", startsExpr);
            kw("true", startsExpr);
            kw("false", startsExpr);
            kw("in", { beforeExpr: true, binop: 7 });
            kw("instanceof", { beforeExpr: true, binop: 7 });
            kw("typeof", { beforeExpr: true, prefix: true, startsExpr: true });
            kw("void", { beforeExpr: true, prefix: true, startsExpr: true });
            kw("delete", { beforeExpr: true, prefix: true, startsExpr: true });

            // Matches a whole line break (where CRLF is considered a single
            // line break). Used to count lines.

            var lineBreak = /\r\n?|\n|\u2028|\u2029/;
            var lineBreakG = new RegExp(lineBreak.source, "g");

            function isNewLine(code) {
              return code === 10 || code === 13 || code === 0x2028 || code == 0x2029;
            }

            var nonASCIIwhitespace = /[\u1680\u180e\u2000-\u200a\u202f\u205f\u3000\ufeff]/;

            function isArray$2(obj) {
              return Object.prototype.toString.call(obj) === "[object Array]";
            }

            // Checks if an object has a property.

            function has(obj, propName) {
              return Object.prototype.hasOwnProperty.call(obj, propName);
            }

            // These are used when `options.locations` is on, for the
            // `startLoc` and `endLoc` properties.

            var Position = (function () {
              function Position(line, col) {
                babelHelpers.classCallCheck(this, Position);

                this.line = line;
                this.column = col;
              }

              Position.prototype.offset = function offset(n) {
                return new Position(this.line, this.column + n);
              };

              return Position;
            })();

            var SourceLocation = function SourceLocation(p, start, end) {
              babelHelpers.classCallCheck(this, SourceLocation);

              this.start = start;
              this.end = end;
              if (p.sourceFile !== null) this.source = p.sourceFile;
            }

            // The `getLineInfo` function is mostly useful when the
            // `locations` option is off (for performance reasons) and you
            // want to find the line/column position for a given character
            // offset. `input` should be the code string that the offset refers
            // into.

            ;

            function getLineInfo(input, offset) {
              for (var line = 1, cur = 0;;) {
                lineBreakG.lastIndex = cur;
                var match = lineBreakG.exec(input);
                if (match && match.index < offset) {
                  ++line;
                  cur = match.index + match[0].length;
                } else {
                  return new Position(line, offset - cur);
                }
              }
            }

            // A second optional argument can be given to further configure
            // the parser process. These options are recognized:

            var defaultOptions = {
              // `ecmaVersion` indicates the ECMAScript version to parse. Must
              // be either 3, or 5, or 6. This influences support for strict
              // mode, the set of reserved words, support for getters and
              // setters and other features.
              ecmaVersion: 5,
              // Source type ("script" or "module") for different semantics
              sourceType: "script",
              // `onInsertedSemicolon` can be a callback that will be called
              // when a semicolon is automatically inserted. It will be passed
              // th position of the comma as an offset, and if `locations` is
              // enabled, it is given the location as a `{line, column}` object
              // as second argument.
              onInsertedSemicolon: null,
              // `onTrailingComma` is similar to `onInsertedSemicolon`, but for
              // trailing commas.
              onTrailingComma: null,
              // By default, reserved words are only enforced if ecmaVersion >= 5.
              // Set `allowReserved` to a boolean value to explicitly turn this on
              // an off. When this option has the value "never", reserved words
              // and keywords can also not be used as property names.
              allowReserved: null,
              // When enabled, a return at the top level is not considered an
              // error.
              allowReturnOutsideFunction: false,
              // When enabled, import/export statements are not constrained to
              // appearing at the top of the program.
              allowImportExportEverywhere: false,
              // When enabled, hashbang directive in the beginning of file
              // is allowed and treated as a line comment.
              allowHashBang: false,
              // When `locations` is on, `loc` properties holding objects with
              // `start` and `end` properties in `{line, column}` form (with
              // line being 1-based and column 0-based) will be attached to the
              // nodes.
              locations: false,
              // A function can be passed as `onToken` option, which will
              // cause Acorn to call that function with object in the same
              // format as tokens returned from `tokenizer().getToken()`. Note
              // that you are not allowed to call the parser from the
              // callback—that will corrupt its internal state.
              onToken: null,
              // A function can be passed as `onComment` option, which will
              // cause Acorn to call that function with `(block, text, start,
              // end)` parameters whenever a comment is skipped. `block` is a
              // boolean indicating whether this is a block (`/* */`) comment,
              // `text` is the content of the comment, and `start` and `end` are
              // character offsets that denote the start and end of the comment.
              // When the `locations` option is on, two more parameters are
              // passed, the full `{line, column}` locations of the start and
              // end of the comments. Note that you are not allowed to call the
              // parser from the callback—that will corrupt its internal state.
              onComment: null,
              // Nodes have their start and end characters offsets recorded in
              // `start` and `end` properties (directly on the node, rather than
              // the `loc` object, which holds line/column data. To also add a
              // [semi-standardized][range] `range` property holding a `[start,
              // end]` array with the same numbers, set the `ranges` option to
              // `true`.
              //
              // [range]: https://bugzilla.mozilla.org/show_bug.cgi?id=745678
              ranges: false,
              // It is possible to parse multiple files into a single AST by
              // passing the tree produced by parsing the first file as
              // `program` option in subsequent parses. This will add the
              // toplevel forms of the parsed file to the `Program` (top) node
              // of an existing parse tree.
              program: null,
              // When `locations` is on, you can pass this to record the source
              // file in every node's `loc` object.
              sourceFile: null,
              // This value, if given, is stored in every node, whether
              // `locations` is on or off.
              directSourceFile: null,
              // When enabled, parenthesized expressions are represented by
              // (non-standard) ParenthesizedExpression nodes
              preserveParens: false,
              plugins: {}
            };

            // Interpret and default an options object

            function getOptions(opts) {
              var options = {};
              for (var opt in defaultOptions) {
                options[opt] = opts && has(opts, opt) ? opts[opt] : defaultOptions[opt];
              }if (options.allowReserved == null) options.allowReserved = options.ecmaVersion < 5;

              if (isArray$2(options.onToken)) {
                (function () {
                  var tokens = options.onToken;
                  options.onToken = function (token) {
                    return tokens.push(token);
                  };
                })();
              }
              if (isArray$2(options.onComment)) options.onComment = pushComment(options, options.onComment);

              return options;
            }

            function pushComment(options, array) {
              return function (block, text, start, end, startLoc, endLoc) {
                var comment = {
                  type: block ? 'Block' : 'Line',
                  value: text,
                  start: start,
                  end: end
                };
                if (options.locations) comment.loc = new SourceLocation(this, startLoc, endLoc);
                if (options.ranges) comment.range = [start, end];
                array.push(comment);
              };
            }

            // Registered plugins
            var plugins = {};

            function keywordRegexp(words) {
              return new RegExp("^(" + words.replace(/ /g, "|") + ")$");
            }

            var Parser = (function () {
              function Parser(options, input, startPos) {
                babelHelpers.classCallCheck(this, Parser);

                this.options = options = getOptions(options);
                this.sourceFile = options.sourceFile;
                this.keywords = keywordRegexp(keywords[options.ecmaVersion >= 6 ? 6 : 5]);
                var reserved = options.allowReserved ? "" : reservedWords$1[options.ecmaVersion] + (options.sourceType == "module" ? " await" : "");
                this.reservedWords = keywordRegexp(reserved);
                var reservedStrict = (reserved ? reserved + " " : "") + reservedWords$1.strict;
                this.reservedWordsStrict = keywordRegexp(reservedStrict);
                this.reservedWordsStrictBind = keywordRegexp(reservedStrict + " " + reservedWords$1.strictBind);
                this.input = String(input);

                // Used to signal to callers of `readWord1` whether the word
                // contained any escape sequences. This is needed because words with
                // escape sequences must not be interpreted as keywords.
                this.containsEsc = false;

                // Load plugins
                this.loadPlugins(options.plugins);

                // Set up token state

                // The current position of the tokenizer in the input.
                if (startPos) {
                  this.pos = startPos;
                  this.lineStart = Math.max(0, this.input.lastIndexOf("\n", startPos));
                  this.curLine = this.input.slice(0, this.lineStart).split(lineBreak).length;
                } else {
                  this.pos = this.lineStart = 0;
                  this.curLine = 1;
                }

                // Properties of the current token:
                // Its type
                this.type = tt.eof;
                // For tokens that include more information than their type, the value
                this.value = null;
                // Its start and end offset
                this.start = this.end = this.pos;
                // And, if locations are used, the {line, column} object
                // corresponding to those offsets
                this.startLoc = this.endLoc = this.curPosition();

                // Position information for the previous token
                this.lastTokEndLoc = this.lastTokStartLoc = null;
                this.lastTokStart = this.lastTokEnd = this.pos;

                // The context stack is used to superficially track syntactic
                // context to predict whether a regular expression is allowed in a
                // given position.
                this.context = this.initialContext();
                this.exprAllowed = true;

                // Figure out if it's a module code.
                this.strict = this.inModule = options.sourceType === "module";

                // Used to signify the start of a potential arrow function
                this.potentialArrowAt = -1;

                // Flags to track whether we are in a function, a generator.
                this.inFunction = this.inGenerator = false;
                // Labels in scope.
                this.labels = [];

                // If enabled, skip leading hashbang line.
                if (this.pos === 0 && options.allowHashBang && this.input.slice(0, 2) === '#!') this.skipLineComment(2);
              }

              // DEPRECATED Kept for backwards compatibility until 3.0 in case a plugin uses them

              Parser.prototype.isKeyword = function isKeyword(word) {
                return this.keywords.test(word);
              };

              Parser.prototype.isReservedWord = function isReservedWord(word) {
                return this.reservedWords.test(word);
              };

              Parser.prototype.extend = function extend(name, f) {
                this[name] = f(this[name]);
              };

              Parser.prototype.loadPlugins = function loadPlugins(pluginConfigs) {
                for (var _name in pluginConfigs) {
                  var plugin = plugins[_name];
                  if (!plugin) throw new Error("Plugin '" + _name + "' not found");
                  plugin(this, pluginConfigs[_name]);
                }
              };

              Parser.prototype.parse = function parse() {
                var node = this.options.program || this.startNode();
                this.nextToken();
                return this.parseTopLevel(node);
              };

              return Parser;
            })();

            var pp = Parser.prototype;

            // ## Parser utilities

            // Test whether a statement node is the string literal `"use strict"`.

            pp.isUseStrict = function (stmt) {
              return this.options.ecmaVersion >= 5 && stmt.type === "ExpressionStatement" && stmt.expression.type === "Literal" && stmt.expression.raw.slice(1, -1) === "use strict";
            };

            // Predicate that tests whether the next token is of the given
            // type, and if yes, consumes it as a side effect.

            pp.eat = function (type) {
              if (this.type === type) {
                this.next();
                return true;
              } else {
                return false;
              }
            };

            // Tests whether parsed token is a contextual keyword.

            pp.isContextual = function (name) {
              return this.type === tt.name && this.value === name;
            };

            // Consumes contextual keyword if possible.

            pp.eatContextual = function (name) {
              return this.value === name && this.eat(tt.name);
            };

            // Asserts that following token is given contextual keyword.

            pp.expectContextual = function (name) {
              if (!this.eatContextual(name)) this.unexpected();
            };

            // Test whether a semicolon can be inserted at the current position.

            pp.canInsertSemicolon = function () {
              return this.type === tt.eof || this.type === tt.braceR || lineBreak.test(this.input.slice(this.lastTokEnd, this.start));
            };

            pp.insertSemicolon = function () {
              if (this.canInsertSemicolon()) {
                if (this.options.onInsertedSemicolon) this.options.onInsertedSemicolon(this.lastTokEnd, this.lastTokEndLoc);
                return true;
              }
            };

            // Consume a semicolon, or, failing that, see if we are allowed to
            // pretend that there is a semicolon at this position.

            pp.semicolon = function () {
              if (!this.eat(tt.semi) && !this.insertSemicolon()) this.unexpected();
            };

            pp.afterTrailingComma = function (tokType) {
              if (this.type == tokType) {
                if (this.options.onTrailingComma) this.options.onTrailingComma(this.lastTokStart, this.lastTokStartLoc);
                this.next();
                return true;
              }
            };

            // Expect a token of a given type. If found, consume it, otherwise,
            // raise an unexpected token error.

            pp.expect = function (type) {
              this.eat(type) || this.unexpected();
            };

            // Raise an unexpected token error.

            pp.unexpected = function (pos) {
              this.raise(pos != null ? pos : this.start, "Unexpected token");
            };

            pp.checkPatternErrors = function (refDestructuringErrors, andThrow) {
              var pos = refDestructuringErrors && refDestructuringErrors.trailingComma;
              if (!andThrow) return !!pos;
              if (pos) this.raise(pos, "Trailing comma is not permitted in destructuring patterns");
            };

            pp.checkExpressionErrors = function (refDestructuringErrors, andThrow) {
              var pos = refDestructuringErrors && refDestructuringErrors.shorthandAssign;
              if (!andThrow) return !!pos;
              if (pos) this.raise(pos, "Shorthand property assignments are valid only in destructuring patterns");
            };

            var pp$1 = Parser.prototype;

            // ### Statement parsing

            // Parse a program. Initializes the parser, reads any number of
            // statements, and wraps them in a Program node.  Optionally takes a
            // `program` argument.  If present, the statements will be appended
            // to its body instead of creating a new node.

            pp$1.parseTopLevel = function (node) {
              var first = true;
              if (!node.body) node.body = [];
              while (this.type !== tt.eof) {
                var stmt = this.parseStatement(true, true);
                node.body.push(stmt);
                if (first) {
                  if (this.isUseStrict(stmt)) this.setStrict(true);
                  first = false;
                }
              }
              this.next();
              if (this.options.ecmaVersion >= 6) {
                node.sourceType = this.options.sourceType;
              }
              return this.finishNode(node, "Program");
            };

            var loopLabel = { kind: "loop" };
            var switchLabel = { kind: "switch" };
            // Parse a single statement.
            //
            // If expecting a statement and finding a slash operator, parse a
            // regular expression literal. This is to handle cases like
            // `if (foo) /blah/.exec(foo)`, where looking at the previous token
            // does not help.

            pp$1.parseStatement = function (declaration, topLevel) {
              var starttype = this.type,
                  node = this.startNode();

              // Most types of statements are recognized by the keyword they
              // start with. Many are trivial to parse, some require a bit of
              // complexity.

              switch (starttype) {
                case tt._break:case tt._continue:
                  return this.parseBreakContinueStatement(node, starttype.keyword);
                case tt._debugger:
                  return this.parseDebuggerStatement(node);
                case tt._do:
                  return this.parseDoStatement(node);
                case tt._for:
                  return this.parseForStatement(node);
                case tt._function:
                  if (!declaration && this.options.ecmaVersion >= 6) this.unexpected();
                  return this.parseFunctionStatement(node);
                case tt._class:
                  if (!declaration) this.unexpected();
                  return this.parseClass(node, true);
                case tt._if:
                  return this.parseIfStatement(node);
                case tt._return:
                  return this.parseReturnStatement(node);
                case tt._switch:
                  return this.parseSwitchStatement(node);
                case tt._throw:
                  return this.parseThrowStatement(node);
                case tt._try:
                  return this.parseTryStatement(node);
                case tt._let:case tt._const:
                  if (!declaration) this.unexpected(); // NOTE: falls through to _var
                case tt._var:
                  return this.parseVarStatement(node, starttype);
                case tt._while:
                  return this.parseWhileStatement(node);
                case tt._with:
                  return this.parseWithStatement(node);
                case tt.braceL:
                  return this.parseBlock();
                case tt.semi:
                  return this.parseEmptyStatement(node);
                case tt._export:
                case tt._import:
                  if (!this.options.allowImportExportEverywhere) {
                    if (!topLevel) this.raise(this.start, "'import' and 'export' may only appear at the top level");
                    if (!this.inModule) this.raise(this.start, "'import' and 'export' may appear only with 'sourceType: module'");
                  }
                  return starttype === tt._import ? this.parseImport(node) : this.parseExport(node);

                // If the statement does not start with a statement keyword or a
                // brace, it's an ExpressionStatement or LabeledStatement. We
                // simply start parsing an expression, and afterwards, if the
                // next token is a colon and the expression was a simple
                // Identifier node, we switch to interpreting it as a label.
                default:
                  var maybeName = this.value,
                      expr = this.parseExpression();
                  if (starttype === tt.name && expr.type === "Identifier" && this.eat(tt.colon)) return this.parseLabeledStatement(node, maybeName, expr);else return this.parseExpressionStatement(node, expr);
              }
            };

            pp$1.parseBreakContinueStatement = function (node, keyword) {
              var isBreak = keyword == "break";
              this.next();
              if (this.eat(tt.semi) || this.insertSemicolon()) node.label = null;else if (this.type !== tt.name) this.unexpected();else {
                node.label = this.parseIdent();
                this.semicolon();
              }

              // Verify that there is an actual destination to break or
              // continue to.
              for (var i = 0; i < this.labels.length; ++i) {
                var lab = this.labels[i];
                if (node.label == null || lab.name === node.label.name) {
                  if (lab.kind != null && (isBreak || lab.kind === "loop")) break;
                  if (node.label && isBreak) break;
                }
              }
              if (i === this.labels.length) this.raise(node.start, "Unsyntactic " + keyword);
              return this.finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement");
            };

            pp$1.parseDebuggerStatement = function (node) {
              this.next();
              this.semicolon();
              return this.finishNode(node, "DebuggerStatement");
            };

            pp$1.parseDoStatement = function (node) {
              this.next();
              this.labels.push(loopLabel);
              node.body = this.parseStatement(false);
              this.labels.pop();
              this.expect(tt._while);
              node.test = this.parseParenExpression();
              if (this.options.ecmaVersion >= 6) this.eat(tt.semi);else this.semicolon();
              return this.finishNode(node, "DoWhileStatement");
            };

            // Disambiguating between a `for` and a `for`/`in` or `for`/`of`
            // loop is non-trivial. Basically, we have to parse the init `var`
            // statement or expression, disallowing the `in` operator (see
            // the second parameter to `parseExpression`), and then check
            // whether the next token is `in` or `of`. When there is no init
            // part (semicolon immediately after the opening parenthesis), it
            // is a regular `for` loop.

            pp$1.parseForStatement = function (node) {
              this.next();
              this.labels.push(loopLabel);
              this.expect(tt.parenL);
              if (this.type === tt.semi) return this.parseFor(node, null);
              if (this.type === tt._var || this.type === tt._let || this.type === tt._const) {
                var _init = this.startNode(),
                    varKind = this.type;
                this.next();
                this.parseVar(_init, true, varKind);
                this.finishNode(_init, "VariableDeclaration");
                if ((this.type === tt._in || this.options.ecmaVersion >= 6 && this.isContextual("of")) && _init.declarations.length === 1 && !(varKind !== tt._var && _init.declarations[0].init)) return this.parseForIn(node, _init);
                return this.parseFor(node, _init);
              }
              var refDestructuringErrors = { shorthandAssign: 0, trailingComma: 0 };
              var init = this.parseExpression(true, refDestructuringErrors);
              if (this.type === tt._in || this.options.ecmaVersion >= 6 && this.isContextual("of")) {
                this.checkPatternErrors(refDestructuringErrors, true);
                this.toAssignable(init);
                this.checkLVal(init);
                return this.parseForIn(node, init);
              } else {
                this.checkExpressionErrors(refDestructuringErrors, true);
              }
              return this.parseFor(node, init);
            };

            pp$1.parseFunctionStatement = function (node) {
              this.next();
              return this.parseFunction(node, true);
            };

            pp$1.parseIfStatement = function (node) {
              this.next();
              node.test = this.parseParenExpression();
              node.consequent = this.parseStatement(false);
              node.alternate = this.eat(tt._else) ? this.parseStatement(false) : null;
              return this.finishNode(node, "IfStatement");
            };

            pp$1.parseReturnStatement = function (node) {
              if (!this.inFunction && !this.options.allowReturnOutsideFunction) this.raise(this.start, "'return' outside of function");
              this.next();

              // In `return` (and `break`/`continue`), the keywords with
              // optional arguments, we eagerly look for a semicolon or the
              // possibility to insert one.

              if (this.eat(tt.semi) || this.insertSemicolon()) node.argument = null;else {
                node.argument = this.parseExpression();this.semicolon();
              }
              return this.finishNode(node, "ReturnStatement");
            };

            pp$1.parseSwitchStatement = function (node) {
              this.next();
              node.discriminant = this.parseParenExpression();
              node.cases = [];
              this.expect(tt.braceL);
              this.labels.push(switchLabel);

              // Statements under must be grouped (by label) in SwitchCase
              // nodes. `cur` is used to keep the node that we are currently
              // adding statements to.

              for (var cur, sawDefault = false; this.type != tt.braceR;) {
                if (this.type === tt._case || this.type === tt._default) {
                  var isCase = this.type === tt._case;
                  if (cur) this.finishNode(cur, "SwitchCase");
                  node.cases.push(cur = this.startNode());
                  cur.consequent = [];
                  this.next();
                  if (isCase) {
                    cur.test = this.parseExpression();
                  } else {
                    if (sawDefault) this.raise(this.lastTokStart, "Multiple default clauses");
                    sawDefault = true;
                    cur.test = null;
                  }
                  this.expect(tt.colon);
                } else {
                  if (!cur) this.unexpected();
                  cur.consequent.push(this.parseStatement(true));
                }
              }
              if (cur) this.finishNode(cur, "SwitchCase");
              this.next(); // Closing brace
              this.labels.pop();
              return this.finishNode(node, "SwitchStatement");
            };

            pp$1.parseThrowStatement = function (node) {
              this.next();
              if (lineBreak.test(this.input.slice(this.lastTokEnd, this.start))) this.raise(this.lastTokEnd, "Illegal newline after throw");
              node.argument = this.parseExpression();
              this.semicolon();
              return this.finishNode(node, "ThrowStatement");
            };

            // Reused empty array added for node fields that are always empty.

            var empty = [];

            pp$1.parseTryStatement = function (node) {
              this.next();
              node.block = this.parseBlock();
              node.handler = null;
              if (this.type === tt._catch) {
                var clause = this.startNode();
                this.next();
                this.expect(tt.parenL);
                clause.param = this.parseBindingAtom();
                this.checkLVal(clause.param, true);
                this.expect(tt.parenR);
                clause.body = this.parseBlock();
                node.handler = this.finishNode(clause, "CatchClause");
              }
              node.finalizer = this.eat(tt._finally) ? this.parseBlock() : null;
              if (!node.handler && !node.finalizer) this.raise(node.start, "Missing catch or finally clause");
              return this.finishNode(node, "TryStatement");
            };

            pp$1.parseVarStatement = function (node, kind) {
              this.next();
              this.parseVar(node, false, kind);
              this.semicolon();
              return this.finishNode(node, "VariableDeclaration");
            };

            pp$1.parseWhileStatement = function (node) {
              this.next();
              node.test = this.parseParenExpression();
              this.labels.push(loopLabel);
              node.body = this.parseStatement(false);
              this.labels.pop();
              return this.finishNode(node, "WhileStatement");
            };

            pp$1.parseWithStatement = function (node) {
              if (this.strict) this.raise(this.start, "'with' in strict mode");
              this.next();
              node.object = this.parseParenExpression();
              node.body = this.parseStatement(false);
              return this.finishNode(node, "WithStatement");
            };

            pp$1.parseEmptyStatement = function (node) {
              this.next();
              return this.finishNode(node, "EmptyStatement");
            };

            pp$1.parseLabeledStatement = function (node, maybeName, expr) {
              for (var i = 0; i < this.labels.length; ++i) {
                if (this.labels[i].name === maybeName) this.raise(expr.start, "Label '" + maybeName + "' is already declared");
              }var kind = this.type.isLoop ? "loop" : this.type === tt._switch ? "switch" : null;
              for (var i = this.labels.length - 1; i >= 0; i--) {
                var label = this.labels[i];
                if (label.statementStart == node.start) {
                  label.statementStart = this.start;
                  label.kind = kind;
                } else break;
              }
              this.labels.push({ name: maybeName, kind: kind, statementStart: this.start });
              node.body = this.parseStatement(true);
              this.labels.pop();
              node.label = expr;
              return this.finishNode(node, "LabeledStatement");
            };

            pp$1.parseExpressionStatement = function (node, expr) {
              node.expression = expr;
              this.semicolon();
              return this.finishNode(node, "ExpressionStatement");
            };

            // Parse a semicolon-enclosed block of statements, handling `"use
            // strict"` declarations when `allowStrict` is true (used for
            // function bodies).

            pp$1.parseBlock = function (allowStrict) {
              var node = this.startNode(),
                  first = true,
                  oldStrict = undefined;
              node.body = [];
              this.expect(tt.braceL);
              while (!this.eat(tt.braceR)) {
                var stmt = this.parseStatement(true);
                node.body.push(stmt);
                if (first && allowStrict && this.isUseStrict(stmt)) {
                  oldStrict = this.strict;
                  this.setStrict(this.strict = true);
                }
                first = false;
              }
              if (oldStrict === false) this.setStrict(false);
              return this.finishNode(node, "BlockStatement");
            };

            // Parse a regular `for` loop. The disambiguation code in
            // `parseStatement` will already have parsed the init statement or
            // expression.

            pp$1.parseFor = function (node, init) {
              node.init = init;
              this.expect(tt.semi);
              node.test = this.type === tt.semi ? null : this.parseExpression();
              this.expect(tt.semi);
              node.update = this.type === tt.parenR ? null : this.parseExpression();
              this.expect(tt.parenR);
              node.body = this.parseStatement(false);
              this.labels.pop();
              return this.finishNode(node, "ForStatement");
            };

            // Parse a `for`/`in` and `for`/`of` loop, which are almost
            // same from parser's perspective.

            pp$1.parseForIn = function (node, init) {
              var type = this.type === tt._in ? "ForInStatement" : "ForOfStatement";
              this.next();
              node.left = init;
              node.right = this.parseExpression();
              this.expect(tt.parenR);
              node.body = this.parseStatement(false);
              this.labels.pop();
              return this.finishNode(node, type);
            };

            // Parse a list of variable declarations.

            pp$1.parseVar = function (node, isFor, kind) {
              node.declarations = [];
              node.kind = kind.keyword;
              for (;;) {
                var decl = this.startNode();
                this.parseVarId(decl);
                if (this.eat(tt.eq)) {
                  decl.init = this.parseMaybeAssign(isFor);
                } else if (kind === tt._const && !(this.type === tt._in || this.options.ecmaVersion >= 6 && this.isContextual("of"))) {
                  this.unexpected();
                } else if (decl.id.type != "Identifier" && !(isFor && (this.type === tt._in || this.isContextual("of")))) {
                  this.raise(this.lastTokEnd, "Complex binding patterns require an initialization value");
                } else {
                  decl.init = null;
                }
                node.declarations.push(this.finishNode(decl, "VariableDeclarator"));
                if (!this.eat(tt.comma)) break;
              }
              return node;
            };

            pp$1.parseVarId = function (decl) {
              decl.id = this.parseBindingAtom();
              this.checkLVal(decl.id, true);
            };

            // Parse a function declaration or literal (depending on the
            // `isStatement` parameter).

            pp$1.parseFunction = function (node, isStatement, allowExpressionBody) {
              this.initFunction(node);
              if (this.options.ecmaVersion >= 6) node.generator = this.eat(tt.star);
              if (isStatement || this.type === tt.name) node.id = this.parseIdent();
              this.parseFunctionParams(node);
              this.parseFunctionBody(node, allowExpressionBody);
              return this.finishNode(node, isStatement ? "FunctionDeclaration" : "FunctionExpression");
            };

            pp$1.parseFunctionParams = function (node) {
              this.expect(tt.parenL);
              node.params = this.parseBindingList(tt.parenR, false, false, true);
            };

            // Parse a class declaration or literal (depending on the
            // `isStatement` parameter).

            pp$1.parseClass = function (node, isStatement) {
              this.next();
              this.parseClassId(node, isStatement);
              this.parseClassSuper(node);
              var classBody = this.startNode();
              var hadConstructor = false;
              classBody.body = [];
              this.expect(tt.braceL);
              while (!this.eat(tt.braceR)) {
                if (this.eat(tt.semi)) continue;
                var method = this.startNode();
                var isGenerator = this.eat(tt.star);
                var isMaybeStatic = this.type === tt.name && this.value === "static";
                this.parsePropertyName(method);
                method.static = isMaybeStatic && this.type !== tt.parenL;
                if (method.static) {
                  if (isGenerator) this.unexpected();
                  isGenerator = this.eat(tt.star);
                  this.parsePropertyName(method);
                }
                method.kind = "method";
                var isGetSet = false;
                if (!method.computed) {
                  var key = method.key;

                  if (!isGenerator && key.type === "Identifier" && this.type !== tt.parenL && (key.name === "get" || key.name === "set")) {
                    isGetSet = true;
                    method.kind = key.name;
                    key = this.parsePropertyName(method);
                  }
                  if (!method.static && (key.type === "Identifier" && key.name === "constructor" || key.type === "Literal" && key.value === "constructor")) {
                    if (hadConstructor) this.raise(key.start, "Duplicate constructor in the same class");
                    if (isGetSet) this.raise(key.start, "Constructor can't have get/set modifier");
                    if (isGenerator) this.raise(key.start, "Constructor can't be a generator");
                    method.kind = "constructor";
                    hadConstructor = true;
                  }
                }
                this.parseClassMethod(classBody, method, isGenerator);
                if (isGetSet) {
                  var paramCount = method.kind === "get" ? 0 : 1;
                  if (method.value.params.length !== paramCount) {
                    var start = method.value.start;
                    if (method.kind === "get") this.raise(start, "getter should have no params");else this.raise(start, "setter should have exactly one param");
                  }
                  if (method.kind === "set" && method.value.params[0].type === "RestElement") this.raise(method.value.params[0].start, "Setter cannot use rest params");
                }
              }
              node.body = this.finishNode(classBody, "ClassBody");
              return this.finishNode(node, isStatement ? "ClassDeclaration" : "ClassExpression");
            };

            pp$1.parseClassMethod = function (classBody, method, isGenerator) {
              method.value = this.parseMethod(isGenerator);
              classBody.body.push(this.finishNode(method, "MethodDefinition"));
            };

            pp$1.parseClassId = function (node, isStatement) {
              node.id = this.type === tt.name ? this.parseIdent() : isStatement ? this.unexpected() : null;
            };

            pp$1.parseClassSuper = function (node) {
              node.superClass = this.eat(tt._extends) ? this.parseExprSubscripts() : null;
            };

            // Parses module export declaration.

            pp$1.parseExport = function (node) {
              this.next();
              // export * from '...'
              if (this.eat(tt.star)) {
                this.expectContextual("from");
                node.source = this.type === tt.string ? this.parseExprAtom() : this.unexpected();
                this.semicolon();
                return this.finishNode(node, "ExportAllDeclaration");
              }
              if (this.eat(tt._default)) {
                // export default ...
                var expr = this.parseMaybeAssign();
                var needsSemi = true;
                if (expr.type == "FunctionExpression" || expr.type == "ClassExpression") {
                  needsSemi = false;
                  if (expr.id) {
                    expr.type = expr.type == "FunctionExpression" ? "FunctionDeclaration" : "ClassDeclaration";
                  }
                }
                node.declaration = expr;
                if (needsSemi) this.semicolon();
                return this.finishNode(node, "ExportDefaultDeclaration");
              }
              // export var|const|let|function|class ...
              if (this.shouldParseExportStatement()) {
                node.declaration = this.parseStatement(true);
                node.specifiers = [];
                node.source = null;
              } else {
                // export { x, y as z } [from '...']
                node.declaration = null;
                node.specifiers = this.parseExportSpecifiers();
                if (this.eatContextual("from")) {
                  node.source = this.type === tt.string ? this.parseExprAtom() : this.unexpected();
                } else {
                  // check for keywords used as local names
                  for (var i = 0; i < node.specifiers.length; i++) {
                    if (this.keywords.test(node.specifiers[i].local.name) || this.reservedWords.test(node.specifiers[i].local.name)) {
                      this.unexpected(node.specifiers[i].local.start);
                    }
                  }

                  node.source = null;
                }
                this.semicolon();
              }
              return this.finishNode(node, "ExportNamedDeclaration");
            };

            pp$1.shouldParseExportStatement = function () {
              return this.type.keyword;
            };

            // Parses a comma-separated list of module exports.

            pp$1.parseExportSpecifiers = function () {
              var nodes = [],
                  first = true;
              // export { x, y as z } [from '...']
              this.expect(tt.braceL);
              while (!this.eat(tt.braceR)) {
                if (!first) {
                  this.expect(tt.comma);
                  if (this.afterTrailingComma(tt.braceR)) break;
                } else first = false;

                var node = this.startNode();
                node.local = this.parseIdent(this.type === tt._default);
                node.exported = this.eatContextual("as") ? this.parseIdent(true) : node.local;
                nodes.push(this.finishNode(node, "ExportSpecifier"));
              }
              return nodes;
            };

            // Parses import declaration.

            pp$1.parseImport = function (node) {
              this.next();
              // import '...'
              if (this.type === tt.string) {
                node.specifiers = empty;
                node.source = this.parseExprAtom();
              } else {
                node.specifiers = this.parseImportSpecifiers();
                this.expectContextual("from");
                node.source = this.type === tt.string ? this.parseExprAtom() : this.unexpected();
              }
              this.semicolon();
              return this.finishNode(node, "ImportDeclaration");
            };

            // Parses a comma-separated list of module imports.

            pp$1.parseImportSpecifiers = function () {
              var nodes = [],
                  first = true;
              if (this.type === tt.name) {
                // import defaultObj, { x, y as z } from '...'
                var node = this.startNode();
                node.local = this.parseIdent();
                this.checkLVal(node.local, true);
                nodes.push(this.finishNode(node, "ImportDefaultSpecifier"));
                if (!this.eat(tt.comma)) return nodes;
              }
              if (this.type === tt.star) {
                var node = this.startNode();
                this.next();
                this.expectContextual("as");
                node.local = this.parseIdent();
                this.checkLVal(node.local, true);
                nodes.push(this.finishNode(node, "ImportNamespaceSpecifier"));
                return nodes;
              }
              this.expect(tt.braceL);
              while (!this.eat(tt.braceR)) {
                if (!first) {
                  this.expect(tt.comma);
                  if (this.afterTrailingComma(tt.braceR)) break;
                } else first = false;

                var node = this.startNode();
                node.imported = this.parseIdent(true);
                if (this.eatContextual("as")) {
                  node.local = this.parseIdent();
                } else {
                  node.local = node.imported;
                  if (this.isKeyword(node.local.name)) this.unexpected(node.local.start);
                  if (this.reservedWordsStrict.test(node.local.name)) this.raise(node.local.start, "The keyword '" + node.local.name + "' is reserved");
                }
                this.checkLVal(node.local, true);
                nodes.push(this.finishNode(node, "ImportSpecifier"));
              }
              return nodes;
            };

            var pp$2 = Parser.prototype;

            // Convert existing expression atom to assignable pattern
            // if possible.

            pp$2.toAssignable = function (node, isBinding) {
              if (this.options.ecmaVersion >= 6 && node) {
                switch (node.type) {
                  case "Identifier":
                  case "ObjectPattern":
                  case "ArrayPattern":
                    break;

                  case "ObjectExpression":
                    node.type = "ObjectPattern";
                    for (var i = 0; i < node.properties.length; i++) {
                      var prop = node.properties[i];
                      if (prop.kind !== "init") this.raise(prop.key.start, "Object pattern can't contain getter or setter");
                      this.toAssignable(prop.value, isBinding);
                    }
                    break;

                  case "ArrayExpression":
                    node.type = "ArrayPattern";
                    this.toAssignableList(node.elements, isBinding);
                    break;

                  case "AssignmentExpression":
                    if (node.operator === "=") {
                      node.type = "AssignmentPattern";
                      delete node.operator;
                      // falls through to AssignmentPattern
                    } else {
                        this.raise(node.left.end, "Only '=' operator can be used for specifying default value.");
                        break;
                      }

                  case "AssignmentPattern":
                    if (node.right.type === "YieldExpression") this.raise(node.right.start, "Yield expression cannot be a default value");
                    break;

                  case "ParenthesizedExpression":
                    node.expression = this.toAssignable(node.expression, isBinding);
                    break;

                  case "MemberExpression":
                    if (!isBinding) break;

                  default:
                    this.raise(node.start, "Assigning to rvalue");
                }
              }
              return node;
            };

            // Convert list of expression atoms to binding list.

            pp$2.toAssignableList = function (exprList, isBinding) {
              var end = exprList.length;
              if (end) {
                var last = exprList[end - 1];
                if (last && last.type == "RestElement") {
                  --end;
                } else if (last && last.type == "SpreadElement") {
                  last.type = "RestElement";
                  var arg = last.argument;
                  this.toAssignable(arg, isBinding);
                  if (arg.type !== "Identifier" && arg.type !== "MemberExpression" && arg.type !== "ArrayPattern") this.unexpected(arg.start);
                  --end;
                }

                if (isBinding && last.type === "RestElement" && last.argument.type !== "Identifier") this.unexpected(last.argument.start);
              }
              for (var i = 0; i < end; i++) {
                var elt = exprList[i];
                if (elt) this.toAssignable(elt, isBinding);
              }
              return exprList;
            };

            // Parses spread element.

            pp$2.parseSpread = function (refDestructuringErrors) {
              var node = this.startNode();
              this.next();
              node.argument = this.parseMaybeAssign(refDestructuringErrors);
              return this.finishNode(node, "SpreadElement");
            };

            pp$2.parseRest = function (allowNonIdent) {
              var node = this.startNode();
              this.next();

              // RestElement inside of a function parameter must be an identifier
              if (allowNonIdent) node.argument = this.type === tt.name ? this.parseIdent() : this.unexpected();else node.argument = this.type === tt.name || this.type === tt.bracketL ? this.parseBindingAtom() : this.unexpected();

              return this.finishNode(node, "RestElement");
            };

            // Parses lvalue (assignable) atom.

            pp$2.parseBindingAtom = function () {
              if (this.options.ecmaVersion < 6) return this.parseIdent();
              switch (this.type) {
                case tt.name:
                  return this.parseIdent();

                case tt.bracketL:
                  var node = this.startNode();
                  this.next();
                  node.elements = this.parseBindingList(tt.bracketR, true, true);
                  return this.finishNode(node, "ArrayPattern");

                case tt.braceL:
                  return this.parseObj(true);

                default:
                  this.unexpected();
              }
            };

            pp$2.parseBindingList = function (close, allowEmpty, allowTrailingComma, allowNonIdent) {
              var elts = [],
                  first = true;
              while (!this.eat(close)) {
                if (first) first = false;else this.expect(tt.comma);
                if (allowEmpty && this.type === tt.comma) {
                  elts.push(null);
                } else if (allowTrailingComma && this.afterTrailingComma(close)) {
                  break;
                } else if (this.type === tt.ellipsis) {
                  var rest = this.parseRest(allowNonIdent);
                  this.parseBindingListItem(rest);
                  elts.push(rest);
                  this.expect(close);
                  break;
                } else {
                  var elem = this.parseMaybeDefault(this.start, this.startLoc);
                  this.parseBindingListItem(elem);
                  elts.push(elem);
                }
              }
              return elts;
            };

            pp$2.parseBindingListItem = function (param) {
              return param;
            };

            // Parses assignment pattern around given atom if possible.

            pp$2.parseMaybeDefault = function (startPos, startLoc, left) {
              left = left || this.parseBindingAtom();
              if (this.options.ecmaVersion < 6 || !this.eat(tt.eq)) return left;
              var node = this.startNodeAt(startPos, startLoc);
              node.left = left;
              node.right = this.parseMaybeAssign();
              return this.finishNode(node, "AssignmentPattern");
            };

            // Verify that a node is an lval — something that can be assigned
            // to.

            pp$2.checkLVal = function (expr, isBinding, checkClashes) {
              switch (expr.type) {
                case "Identifier":
                  if (this.strict && this.reservedWordsStrictBind.test(expr.name)) this.raise(expr.start, (isBinding ? "Binding " : "Assigning to ") + expr.name + " in strict mode");
                  if (checkClashes) {
                    if (has(checkClashes, expr.name)) this.raise(expr.start, "Argument name clash");
                    checkClashes[expr.name] = true;
                  }
                  break;

                case "MemberExpression":
                  if (isBinding) this.raise(expr.start, (isBinding ? "Binding" : "Assigning to") + " member expression");
                  break;

                case "ObjectPattern":
                  for (var i = 0; i < expr.properties.length; i++) {
                    this.checkLVal(expr.properties[i].value, isBinding, checkClashes);
                  }break;

                case "ArrayPattern":
                  for (var i = 0; i < expr.elements.length; i++) {
                    var elem = expr.elements[i];
                    if (elem) this.checkLVal(elem, isBinding, checkClashes);
                  }
                  break;

                case "AssignmentPattern":
                  this.checkLVal(expr.left, isBinding, checkClashes);
                  break;

                case "RestElement":
                  this.checkLVal(expr.argument, isBinding, checkClashes);
                  break;

                case "ParenthesizedExpression":
                  this.checkLVal(expr.expression, isBinding, checkClashes);
                  break;

                default:
                  this.raise(expr.start, (isBinding ? "Binding" : "Assigning to") + " rvalue");
              }
            };

            var pp$3 = Parser.prototype;

            // Check if property name clashes with already added.
            // Object/class getters and setters are not allowed to clash —
            // either with each other or with an init property — and in
            // strict mode, init properties are also not allowed to be repeated.

            pp$3.checkPropClash = function (prop, propHash) {
              if (this.options.ecmaVersion >= 6 && (prop.computed || prop.method || prop.shorthand)) return;
              var key = prop.key;var name = undefined;
              switch (key.type) {
                case "Identifier":
                  name = key.name;break;
                case "Literal":
                  name = String(key.value);break;
                default:
                  return;
              }
              var kind = prop.kind;

              if (this.options.ecmaVersion >= 6) {
                if (name === "__proto__" && kind === "init") {
                  if (propHash.proto) this.raise(key.start, "Redefinition of __proto__ property");
                  propHash.proto = true;
                }
                return;
              }
              name = "$" + name;
              var other = propHash[name];
              if (other) {
                var isGetSet = kind !== "init";
                if ((this.strict || isGetSet) && other[kind] || !(isGetSet ^ other.init)) this.raise(key.start, "Redefinition of property");
              } else {
                other = propHash[name] = {
                  init: false,
                  get: false,
                  set: false
                };
              }
              other[kind] = true;
            };

            // ### Expression parsing

            // These nest, from the most general expression type at the top to
            // 'atomic', nondivisible expression types at the bottom. Most of
            // the functions will simply let the function(s) below them parse,
            // and, *if* the syntactic construct they handle is present, wrap
            // the AST node that the inner parser gave them in another node.

            // Parse a full expression. The optional arguments are used to
            // forbid the `in` operator (in for loops initalization expressions)
            // and provide reference for storing '=' operator inside shorthand
            // property assignment in contexts where both object expression
            // and object pattern might appear (so it's possible to raise
            // delayed syntax error at correct position).

            pp$3.parseExpression = function (noIn, refDestructuringErrors) {
              var startPos = this.start,
                  startLoc = this.startLoc;
              var expr = this.parseMaybeAssign(noIn, refDestructuringErrors);
              if (this.type === tt.comma) {
                var node = this.startNodeAt(startPos, startLoc);
                node.expressions = [expr];
                while (this.eat(tt.comma)) node.expressions.push(this.parseMaybeAssign(noIn, refDestructuringErrors));
                return this.finishNode(node, "SequenceExpression");
              }
              return expr;
            };

            // Parse an assignment expression. This includes applications of
            // operators like `+=`.

            pp$3.parseMaybeAssign = function (noIn, refDestructuringErrors, afterLeftParse) {
              if (this.type == tt._yield && this.inGenerator) return this.parseYield();

              var validateDestructuring = false;
              if (!refDestructuringErrors) {
                refDestructuringErrors = { shorthandAssign: 0, trailingComma: 0 };
                validateDestructuring = true;
              }
              var startPos = this.start,
                  startLoc = this.startLoc;
              if (this.type == tt.parenL || this.type == tt.name) this.potentialArrowAt = this.start;
              var left = this.parseMaybeConditional(noIn, refDestructuringErrors);
              if (afterLeftParse) left = afterLeftParse.call(this, left, startPos, startLoc);
              if (this.type.isAssign) {
                if (validateDestructuring) this.checkPatternErrors(refDestructuringErrors, true);
                var node = this.startNodeAt(startPos, startLoc);
                node.operator = this.value;
                node.left = this.type === tt.eq ? this.toAssignable(left) : left;
                refDestructuringErrors.shorthandAssign = 0; // reset because shorthand default was used correctly
                this.checkLVal(left);
                this.next();
                node.right = this.parseMaybeAssign(noIn);
                return this.finishNode(node, "AssignmentExpression");
              } else {
                if (validateDestructuring) this.checkExpressionErrors(refDestructuringErrors, true);
              }
              return left;
            };

            // Parse a ternary conditional (`?:`) operator.

            pp$3.parseMaybeConditional = function (noIn, refDestructuringErrors) {
              var startPos = this.start,
                  startLoc = this.startLoc;
              var expr = this.parseExprOps(noIn, refDestructuringErrors);
              if (this.checkExpressionErrors(refDestructuringErrors)) return expr;
              if (this.eat(tt.question)) {
                var node = this.startNodeAt(startPos, startLoc);
                node.test = expr;
                node.consequent = this.parseMaybeAssign();
                this.expect(tt.colon);
                node.alternate = this.parseMaybeAssign(noIn);
                return this.finishNode(node, "ConditionalExpression");
              }
              return expr;
            };

            // Start the precedence parser.

            pp$3.parseExprOps = function (noIn, refDestructuringErrors) {
              var startPos = this.start,
                  startLoc = this.startLoc;
              var expr = this.parseMaybeUnary(refDestructuringErrors);
              if (this.checkExpressionErrors(refDestructuringErrors)) return expr;
              return this.parseExprOp(expr, startPos, startLoc, -1, noIn);
            };

            // Parse binary operators with the operator precedence parsing
            // algorithm. `left` is the left-hand side of the operator.
            // `minPrec` provides context that allows the function to stop and
            // defer further parser to one of its callers when it encounters an
            // operator that has a lower precedence than the set it is parsing.

            pp$3.parseExprOp = function (left, leftStartPos, leftStartLoc, minPrec, noIn) {
              var prec = this.type.binop;
              if (prec != null && (!noIn || this.type !== tt._in)) {
                if (prec > minPrec) {
                  var node = this.startNodeAt(leftStartPos, leftStartLoc);
                  node.left = left;
                  node.operator = this.value;
                  var op = this.type;
                  this.next();
                  var startPos = this.start,
                      startLoc = this.startLoc;
                  node.right = this.parseExprOp(this.parseMaybeUnary(), startPos, startLoc, prec, noIn);
                  this.finishNode(node, op === tt.logicalOR || op === tt.logicalAND ? "LogicalExpression" : "BinaryExpression");
                  return this.parseExprOp(node, leftStartPos, leftStartLoc, minPrec, noIn);
                }
              }
              return left;
            };

            // Parse unary operators, both prefix and postfix.

            pp$3.parseMaybeUnary = function (refDestructuringErrors) {
              if (this.type.prefix) {
                var node = this.startNode(),
                    update = this.type === tt.incDec;
                node.operator = this.value;
                node.prefix = true;
                this.next();
                node.argument = this.parseMaybeUnary();
                this.checkExpressionErrors(refDestructuringErrors, true);
                if (update) this.checkLVal(node.argument);else if (this.strict && node.operator === "delete" && node.argument.type === "Identifier") this.raise(node.start, "Deleting local variable in strict mode");
                return this.finishNode(node, update ? "UpdateExpression" : "UnaryExpression");
              }
              var startPos = this.start,
                  startLoc = this.startLoc;
              var expr = this.parseExprSubscripts(refDestructuringErrors);
              if (this.checkExpressionErrors(refDestructuringErrors)) return expr;
              while (this.type.postfix && !this.canInsertSemicolon()) {
                var node = this.startNodeAt(startPos, startLoc);
                node.operator = this.value;
                node.prefix = false;
                node.argument = expr;
                this.checkLVal(expr);
                this.next();
                expr = this.finishNode(node, "UpdateExpression");
              }
              return expr;
            };

            // Parse call, dot, and `[]`-subscript expressions.

            pp$3.parseExprSubscripts = function (refDestructuringErrors) {
              var startPos = this.start,
                  startLoc = this.startLoc;
              var expr = this.parseExprAtom(refDestructuringErrors);
              var skipArrowSubscripts = expr.type === "ArrowFunctionExpression" && this.input.slice(this.lastTokStart, this.lastTokEnd) !== ")";
              if (this.checkExpressionErrors(refDestructuringErrors) || skipArrowSubscripts) return expr;
              return this.parseSubscripts(expr, startPos, startLoc);
            };

            pp$3.parseSubscripts = function (base, startPos, startLoc, noCalls) {
              for (;;) {
                if (this.eat(tt.dot)) {
                  var node = this.startNodeAt(startPos, startLoc);
                  node.object = base;
                  node.property = this.parseIdent(true);
                  node.computed = false;
                  base = this.finishNode(node, "MemberExpression");
                } else if (this.eat(tt.bracketL)) {
                  var node = this.startNodeAt(startPos, startLoc);
                  node.object = base;
                  node.property = this.parseExpression();
                  node.computed = true;
                  this.expect(tt.bracketR);
                  base = this.finishNode(node, "MemberExpression");
                } else if (!noCalls && this.eat(tt.parenL)) {
                  var node = this.startNodeAt(startPos, startLoc);
                  node.callee = base;
                  node.arguments = this.parseExprList(tt.parenR, false);
                  base = this.finishNode(node, "CallExpression");
                } else if (this.type === tt.backQuote) {
                  var node = this.startNodeAt(startPos, startLoc);
                  node.tag = base;
                  node.quasi = this.parseTemplate();
                  base = this.finishNode(node, "TaggedTemplateExpression");
                } else {
                  return base;
                }
              }
            };

            // Parse an atomic expression — either a single token that is an
            // expression, an expression started by a keyword like `function` or
            // `new`, or an expression wrapped in punctuation like `()`, `[]`,
            // or `{}`.

            pp$3.parseExprAtom = function (refDestructuringErrors) {
              var node = undefined,
                  canBeArrow = this.potentialArrowAt == this.start;
              switch (this.type) {
                case tt._super:
                  if (!this.inFunction) this.raise(this.start, "'super' outside of function or class");
                case tt._this:
                  var type = this.type === tt._this ? "ThisExpression" : "Super";
                  node = this.startNode();
                  this.next();
                  return this.finishNode(node, type);

                case tt._yield:
                  if (this.inGenerator) this.unexpected();

                case tt.name:
                  var startPos = this.start,
                      startLoc = this.startLoc;
                  var id = this.parseIdent(this.type !== tt.name);
                  if (canBeArrow && !this.canInsertSemicolon() && this.eat(tt.arrow)) return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), [id]);
                  return id;

                case tt.regexp:
                  var value = this.value;
                  node = this.parseLiteral(value.value);
                  node.regex = { pattern: value.pattern, flags: value.flags };
                  return node;

                case tt.num:case tt.string:
                  return this.parseLiteral(this.value);

                case tt._null:case tt._true:case tt._false:
                  node = this.startNode();
                  node.value = this.type === tt._null ? null : this.type === tt._true;
                  node.raw = this.type.keyword;
                  this.next();
                  return this.finishNode(node, "Literal");

                case tt.parenL:
                  return this.parseParenAndDistinguishExpression(canBeArrow);

                case tt.bracketL:
                  node = this.startNode();
                  this.next();
                  // check whether this is array comprehension or regular array
                  if (this.options.ecmaVersion >= 7 && this.type === tt._for) {
                    return this.parseComprehension(node, false);
                  }
                  node.elements = this.parseExprList(tt.bracketR, true, true, refDestructuringErrors);
                  return this.finishNode(node, "ArrayExpression");

                case tt.braceL:
                  return this.parseObj(false, refDestructuringErrors);

                case tt._function:
                  node = this.startNode();
                  this.next();
                  return this.parseFunction(node, false);

                case tt._class:
                  return this.parseClass(this.startNode(), false);

                case tt._new:
                  return this.parseNew();

                case tt.backQuote:
                  return this.parseTemplate();

                default:
                  this.unexpected();
              }
            };

            pp$3.parseLiteral = function (value) {
              var node = this.startNode();
              node.value = value;
              node.raw = this.input.slice(this.start, this.end);
              this.next();
              return this.finishNode(node, "Literal");
            };

            pp$3.parseParenExpression = function () {
              this.expect(tt.parenL);
              var val = this.parseExpression();
              this.expect(tt.parenR);
              return val;
            };

            pp$3.parseParenAndDistinguishExpression = function (canBeArrow) {
              var startPos = this.start,
                  startLoc = this.startLoc,
                  val = undefined;
              if (this.options.ecmaVersion >= 6) {
                this.next();

                if (this.options.ecmaVersion >= 7 && this.type === tt._for) {
                  return this.parseComprehension(this.startNodeAt(startPos, startLoc), true);
                }

                var innerStartPos = this.start,
                    innerStartLoc = this.startLoc;
                var exprList = [],
                    first = true;
                var refDestructuringErrors = { shorthandAssign: 0, trailingComma: 0 },
                    spreadStart = undefined,
                    innerParenStart = undefined;
                while (this.type !== tt.parenR) {
                  first ? first = false : this.expect(tt.comma);
                  if (this.type === tt.ellipsis) {
                    spreadStart = this.start;
                    exprList.push(this.parseParenItem(this.parseRest()));
                    break;
                  } else {
                    if (this.type === tt.parenL && !innerParenStart) {
                      innerParenStart = this.start;
                    }
                    exprList.push(this.parseMaybeAssign(false, refDestructuringErrors, this.parseParenItem));
                  }
                }
                var innerEndPos = this.start,
                    innerEndLoc = this.startLoc;
                this.expect(tt.parenR);

                if (canBeArrow && !this.canInsertSemicolon() && this.eat(tt.arrow)) {
                  this.checkPatternErrors(refDestructuringErrors, true);
                  if (innerParenStart) this.unexpected(innerParenStart);
                  return this.parseParenArrowList(startPos, startLoc, exprList);
                }

                if (!exprList.length) this.unexpected(this.lastTokStart);
                if (spreadStart) this.unexpected(spreadStart);
                this.checkExpressionErrors(refDestructuringErrors, true);

                if (exprList.length > 1) {
                  val = this.startNodeAt(innerStartPos, innerStartLoc);
                  val.expressions = exprList;
                  this.finishNodeAt(val, "SequenceExpression", innerEndPos, innerEndLoc);
                } else {
                  val = exprList[0];
                }
              } else {
                val = this.parseParenExpression();
              }

              if (this.options.preserveParens) {
                var par = this.startNodeAt(startPos, startLoc);
                par.expression = val;
                return this.finishNode(par, "ParenthesizedExpression");
              } else {
                return val;
              }
            };

            pp$3.parseParenItem = function (item) {
              return item;
            };

            pp$3.parseParenArrowList = function (startPos, startLoc, exprList) {
              return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), exprList);
            };

            // New's precedence is slightly tricky. It must allow its argument to
            // be a `[]` or dot subscript expression, but not a call — at least,
            // not without wrapping it in parentheses. Thus, it uses the noCalls
            // argument to parseSubscripts to prevent it from consuming the
            // argument list.

            var empty$1 = [];

            pp$3.parseNew = function () {
              var node = this.startNode();
              var meta = this.parseIdent(true);
              if (this.options.ecmaVersion >= 6 && this.eat(tt.dot)) {
                node.meta = meta;
                node.property = this.parseIdent(true);
                if (node.property.name !== "target") this.raise(node.property.start, "The only valid meta property for new is new.target");
                if (!this.inFunction) this.raise(node.start, "new.target can only be used in functions");
                return this.finishNode(node, "MetaProperty");
              }
              var startPos = this.start,
                  startLoc = this.startLoc;
              node.callee = this.parseSubscripts(this.parseExprAtom(), startPos, startLoc, true);
              if (this.eat(tt.parenL)) node.arguments = this.parseExprList(tt.parenR, false);else node.arguments = empty$1;
              return this.finishNode(node, "NewExpression");
            };

            // Parse template expression.

            pp$3.parseTemplateElement = function () {
              var elem = this.startNode();
              elem.value = {
                raw: this.input.slice(this.start, this.end).replace(/\r\n?/g, '\n'),
                cooked: this.value
              };
              this.next();
              elem.tail = this.type === tt.backQuote;
              return this.finishNode(elem, "TemplateElement");
            };

            pp$3.parseTemplate = function () {
              var node = this.startNode();
              this.next();
              node.expressions = [];
              var curElt = this.parseTemplateElement();
              node.quasis = [curElt];
              while (!curElt.tail) {
                this.expect(tt.dollarBraceL);
                node.expressions.push(this.parseExpression());
                this.expect(tt.braceR);
                node.quasis.push(curElt = this.parseTemplateElement());
              }
              this.next();
              return this.finishNode(node, "TemplateLiteral");
            };

            // Parse an object literal or binding pattern.

            pp$3.parseObj = function (isPattern, refDestructuringErrors) {
              var node = this.startNode(),
                  first = true,
                  propHash = {};
              node.properties = [];
              this.next();
              while (!this.eat(tt.braceR)) {
                if (!first) {
                  this.expect(tt.comma);
                  if (this.afterTrailingComma(tt.braceR)) break;
                } else first = false;

                var prop = this.startNode(),
                    isGenerator = undefined,
                    startPos = undefined,
                    startLoc = undefined;
                if (this.options.ecmaVersion >= 6) {
                  prop.method = false;
                  prop.shorthand = false;
                  if (isPattern || refDestructuringErrors) {
                    startPos = this.start;
                    startLoc = this.startLoc;
                  }
                  if (!isPattern) isGenerator = this.eat(tt.star);
                }
                this.parsePropertyName(prop);
                this.parsePropertyValue(prop, isPattern, isGenerator, startPos, startLoc, refDestructuringErrors);
                this.checkPropClash(prop, propHash);
                node.properties.push(this.finishNode(prop, "Property"));
              }
              return this.finishNode(node, isPattern ? "ObjectPattern" : "ObjectExpression");
            };

            pp$3.parsePropertyValue = function (prop, isPattern, isGenerator, startPos, startLoc, refDestructuringErrors) {
              if (this.eat(tt.colon)) {
                prop.value = isPattern ? this.parseMaybeDefault(this.start, this.startLoc) : this.parseMaybeAssign(false, refDestructuringErrors);
                prop.kind = "init";
              } else if (this.options.ecmaVersion >= 6 && this.type === tt.parenL) {
                if (isPattern) this.unexpected();
                prop.kind = "init";
                prop.method = true;
                prop.value = this.parseMethod(isGenerator);
              } else if (this.options.ecmaVersion >= 5 && !prop.computed && prop.key.type === "Identifier" && (prop.key.name === "get" || prop.key.name === "set") && this.type != tt.comma && this.type != tt.braceR) {
                if (isGenerator || isPattern) this.unexpected();
                prop.kind = prop.key.name;
                this.parsePropertyName(prop);
                prop.value = this.parseMethod(false);
                var paramCount = prop.kind === "get" ? 0 : 1;
                if (prop.value.params.length !== paramCount) {
                  var start = prop.value.start;
                  if (prop.kind === "get") this.raise(start, "getter should have no params");else this.raise(start, "setter should have exactly one param");
                }
                if (prop.kind === "set" && prop.value.params[0].type === "RestElement") this.raise(prop.value.params[0].start, "Setter cannot use rest params");
              } else if (this.options.ecmaVersion >= 6 && !prop.computed && prop.key.type === "Identifier") {
                prop.kind = "init";
                if (isPattern) {
                  if (this.keywords.test(prop.key.name) || (this.strict ? this.reservedWordsStrictBind : this.reservedWords).test(prop.key.name)) this.raise(prop.key.start, "Binding " + prop.key.name);
                  prop.value = this.parseMaybeDefault(startPos, startLoc, prop.key);
                } else if (this.type === tt.eq && refDestructuringErrors) {
                  if (!refDestructuringErrors.shorthandAssign) refDestructuringErrors.shorthandAssign = this.start;
                  prop.value = this.parseMaybeDefault(startPos, startLoc, prop.key);
                } else {
                  prop.value = prop.key;
                }
                prop.shorthand = true;
              } else this.unexpected();
            };

            pp$3.parsePropertyName = function (prop) {
              if (this.options.ecmaVersion >= 6) {
                if (this.eat(tt.bracketL)) {
                  prop.computed = true;
                  prop.key = this.parseMaybeAssign();
                  this.expect(tt.bracketR);
                  return prop.key;
                } else {
                  prop.computed = false;
                }
              }
              return prop.key = this.type === tt.num || this.type === tt.string ? this.parseExprAtom() : this.parseIdent(true);
            };

            // Initialize empty function node.

            pp$3.initFunction = function (node) {
              node.id = null;
              if (this.options.ecmaVersion >= 6) {
                node.generator = false;
                node.expression = false;
              }
            };

            // Parse object or class method.

            pp$3.parseMethod = function (isGenerator) {
              var node = this.startNode();
              this.initFunction(node);
              this.expect(tt.parenL);
              node.params = this.parseBindingList(tt.parenR, false, false);
              if (this.options.ecmaVersion >= 6) node.generator = isGenerator;
              this.parseFunctionBody(node, false);
              return this.finishNode(node, "FunctionExpression");
            };

            // Parse arrow function expression with given parameters.

            pp$3.parseArrowExpression = function (node, params) {
              this.initFunction(node);
              node.params = this.toAssignableList(params, true);
              this.parseFunctionBody(node, true);
              return this.finishNode(node, "ArrowFunctionExpression");
            };

            // Parse function body and check parameters.

            pp$3.parseFunctionBody = function (node, isArrowFunction) {
              var isExpression = isArrowFunction && this.type !== tt.braceL;

              if (isExpression) {
                node.body = this.parseMaybeAssign();
                node.expression = true;
              } else {
                // Start a new scope with regard to labels and the `inFunction`
                // flag (restore them to their old value afterwards).
                var oldInFunc = this.inFunction,
                    oldInGen = this.inGenerator,
                    oldLabels = this.labels;
                this.inFunction = true;this.inGenerator = node.generator;this.labels = [];
                node.body = this.parseBlock(true);
                node.expression = false;
                this.inFunction = oldInFunc;this.inGenerator = oldInGen;this.labels = oldLabels;
              }

              // If this is a strict mode function, verify that argument names
              // are not repeated, and it does not try to bind the words `eval`
              // or `arguments`.
              if (this.strict || !isExpression && node.body.body.length && this.isUseStrict(node.body.body[0])) {
                var oldStrict = this.strict;
                this.strict = true;
                if (node.id) this.checkLVal(node.id, true);
                this.checkParams(node);
                this.strict = oldStrict;
              } else if (isArrowFunction) {
                this.checkParams(node);
              }
            };

            // Checks function params for various disallowed patterns such as using "eval"
            // or "arguments" and duplicate parameters.

            pp$3.checkParams = function (node) {
              var nameHash = {};
              for (var i = 0; i < node.params.length; i++) {
                this.checkLVal(node.params[i], true, nameHash);
              }
            };

            // Parses a comma-separated list of expressions, and returns them as
            // an array. `close` is the token type that ends the list, and
            // `allowEmpty` can be turned on to allow subsequent commas with
            // nothing in between them to be parsed as `null` (which is needed
            // for array literals).

            pp$3.parseExprList = function (close, allowTrailingComma, allowEmpty, refDestructuringErrors) {
              var elts = [],
                  first = true;
              while (!this.eat(close)) {
                if (!first) {
                  this.expect(tt.comma);
                  if (this.type === close && refDestructuringErrors && !refDestructuringErrors.trailingComma) {
                    refDestructuringErrors.trailingComma = this.lastTokStart;
                  }
                  if (allowTrailingComma && this.afterTrailingComma(close)) break;
                } else first = false;

                var elt = undefined;
                if (allowEmpty && this.type === tt.comma) elt = null;else if (this.type === tt.ellipsis) elt = this.parseSpread(refDestructuringErrors);else elt = this.parseMaybeAssign(false, refDestructuringErrors);
                elts.push(elt);
              }
              return elts;
            };

            // Parse the next token as an identifier. If `liberal` is true (used
            // when parsing properties), it will also convert keywords into
            // identifiers.

            pp$3.parseIdent = function (liberal) {
              var node = this.startNode();
              if (liberal && this.options.allowReserved == "never") liberal = false;
              if (this.type === tt.name) {
                if (!liberal && (this.strict ? this.reservedWordsStrict : this.reservedWords).test(this.value) && (this.options.ecmaVersion >= 6 || this.input.slice(this.start, this.end).indexOf("\\") == -1)) this.raise(this.start, "The keyword '" + this.value + "' is reserved");
                node.name = this.value;
              } else if (liberal && this.type.keyword) {
                node.name = this.type.keyword;
              } else {
                this.unexpected();
              }
              this.next();
              return this.finishNode(node, "Identifier");
            };

            // Parses yield expression inside generator.

            pp$3.parseYield = function () {
              var node = this.startNode();
              this.next();
              if (this.type == tt.semi || this.canInsertSemicolon() || this.type != tt.star && !this.type.startsExpr) {
                node.delegate = false;
                node.argument = null;
              } else {
                node.delegate = this.eat(tt.star);
                node.argument = this.parseMaybeAssign();
              }
              return this.finishNode(node, "YieldExpression");
            };

            // Parses array and generator comprehensions.

            pp$3.parseComprehension = function (node, isGenerator) {
              node.blocks = [];
              while (this.type === tt._for) {
                var block = this.startNode();
                this.next();
                this.expect(tt.parenL);
                block.left = this.parseBindingAtom();
                this.checkLVal(block.left, true);
                this.expectContextual("of");
                block.right = this.parseExpression();
                this.expect(tt.parenR);
                node.blocks.push(this.finishNode(block, "ComprehensionBlock"));
              }
              node.filter = this.eat(tt._if) ? this.parseParenExpression() : null;
              node.body = this.parseExpression();
              this.expect(isGenerator ? tt.parenR : tt.bracketR);
              node.generator = isGenerator;
              return this.finishNode(node, "ComprehensionExpression");
            };

            var pp$4 = Parser.prototype;

            // This function is used to raise exceptions on parse errors. It
            // takes an offset integer (into the current `input`) to indicate
            // the location of the error, attaches the position to the end
            // of the error message, and then raises a `SyntaxError` with that
            // message.

            pp$4.raise = function (pos, message) {
              var loc = getLineInfo(this.input, pos);
              message += " (" + loc.line + ":" + loc.column + ")";
              var err = new SyntaxError(message);
              err.pos = pos;err.loc = loc;err.raisedAt = this.pos;
              throw err;
            };

            pp$4.curPosition = function () {
              if (this.options.locations) {
                return new Position(this.curLine, this.pos - this.lineStart);
              }
            };

            var Node = function Node(parser, pos, loc) {
              babelHelpers.classCallCheck(this, Node);

              this.type = "";
              this.start = pos;
              this.end = 0;
              if (parser.options.locations) this.loc = new SourceLocation(parser, loc);
              if (parser.options.directSourceFile) this.sourceFile = parser.options.directSourceFile;
              if (parser.options.ranges) this.range = [pos, 0];
            }

            // Start an AST node, attaching a start offset.

            ;

            var pp$5 = Parser.prototype;

            pp$5.startNode = function () {
              return new Node(this, this.start, this.startLoc);
            };

            pp$5.startNodeAt = function (pos, loc) {
              return new Node(this, pos, loc);
            };

            // Finish an AST node, adding `type` and `end` properties.

            function finishNodeAt(node, type, pos, loc) {
              node.type = type;
              node.end = pos;
              if (this.options.locations) node.loc.end = loc;
              if (this.options.ranges) node.range[1] = pos;
              return node;
            }

            pp$5.finishNode = function (node, type) {
              return finishNodeAt.call(this, node, type, this.lastTokEnd, this.lastTokEndLoc);
            };

            // Finish node at given position

            pp$5.finishNodeAt = function (node, type, pos, loc) {
              return finishNodeAt.call(this, node, type, pos, loc);
            };

            var TokContext = function TokContext(token, isExpr, preserveSpace, override) {
              babelHelpers.classCallCheck(this, TokContext);

              this.token = token;
              this.isExpr = !!isExpr;
              this.preserveSpace = !!preserveSpace;
              this.override = override;
            };

            var types = {
              b_stat: new TokContext("{", false),
              b_expr: new TokContext("{", true),
              b_tmpl: new TokContext("${", true),
              p_stat: new TokContext("(", false),
              p_expr: new TokContext("(", true),
              q_tmpl: new TokContext("`", true, true, function (p) {
                return p.readTmplToken();
              }),
              f_expr: new TokContext("function", true)
            };

            var pp$6 = Parser.prototype;

            pp$6.initialContext = function () {
              return [types.b_stat];
            };

            pp$6.braceIsBlock = function (prevType) {
              if (prevType === tt.colon) {
                var _parent = this.curContext();
                if (_parent === types.b_stat || _parent === types.b_expr) return !_parent.isExpr;
              }
              if (prevType === tt._return) return lineBreak.test(this.input.slice(this.lastTokEnd, this.start));
              if (prevType === tt._else || prevType === tt.semi || prevType === tt.eof || prevType === tt.parenR) return true;
              if (prevType == tt.braceL) return this.curContext() === types.b_stat;
              return !this.exprAllowed;
            };

            pp$6.updateContext = function (prevType) {
              var update = undefined,
                  type = this.type;
              if (type.keyword && prevType == tt.dot) this.exprAllowed = false;else if (update = type.updateContext) update.call(this, prevType);else this.exprAllowed = type.beforeExpr;
            };

            // Token-specific context update code

            tt.parenR.updateContext = tt.braceR.updateContext = function () {
              if (this.context.length == 1) {
                this.exprAllowed = true;
                return;
              }
              var out = this.context.pop();
              if (out === types.b_stat && this.curContext() === types.f_expr) {
                this.context.pop();
                this.exprAllowed = false;
              } else if (out === types.b_tmpl) {
                this.exprAllowed = true;
              } else {
                this.exprAllowed = !out.isExpr;
              }
            };

            tt.braceL.updateContext = function (prevType) {
              this.context.push(this.braceIsBlock(prevType) ? types.b_stat : types.b_expr);
              this.exprAllowed = true;
            };

            tt.dollarBraceL.updateContext = function () {
              this.context.push(types.b_tmpl);
              this.exprAllowed = true;
            };

            tt.parenL.updateContext = function (prevType) {
              var statementParens = prevType === tt._if || prevType === tt._for || prevType === tt._with || prevType === tt._while;
              this.context.push(statementParens ? types.p_stat : types.p_expr);
              this.exprAllowed = true;
            };

            tt.incDec.updateContext = function () {
              // tokExprAllowed stays unchanged
            };

            tt._function.updateContext = function () {
              if (this.curContext() !== types.b_stat) this.context.push(types.f_expr);
              this.exprAllowed = false;
            };

            tt.backQuote.updateContext = function () {
              if (this.curContext() === types.q_tmpl) this.context.pop();else this.context.push(types.q_tmpl);
              this.exprAllowed = false;
            };

            // Object type used to represent tokens. Note that normally, tokens
            // simply exist as properties on the parser object. This is only
            // used for the onToken callback and the external tokenizer.

            var Token = function Token(p) {
              babelHelpers.classCallCheck(this, Token);

              this.type = p.type;
              this.value = p.value;
              this.start = p.start;
              this.end = p.end;
              if (p.options.locations) this.loc = new SourceLocation(p, p.startLoc, p.endLoc);
              if (p.options.ranges) this.range = [p.start, p.end];
            }

            // ## Tokenizer

            ;

            var pp$7 = Parser.prototype;

            // Are we running under Rhino?
            var isRhino = typeof Packages == "object" && Object.prototype.toString.call(Packages) == "[object JavaPackage]";

            // Move to the next token

            pp$7.next = function () {
              if (this.options.onToken) this.options.onToken(new Token(this));

              this.lastTokEnd = this.end;
              this.lastTokStart = this.start;
              this.lastTokEndLoc = this.endLoc;
              this.lastTokStartLoc = this.startLoc;
              this.nextToken();
            };

            pp$7.getToken = function () {
              this.next();
              return new Token(this);
            };

            // If we're in an ES6 environment, make parsers iterable
            if (typeof Symbol !== "undefined") pp$7[Symbol.iterator] = function () {
              var self = this;
              return { next: function () {
                  var token = self.getToken();
                  return {
                    done: token.type === tt.eof,
                    value: token
                  };
                } };
            };

            // Toggle strict mode. Re-reads the next number or string to please
            // pedantic tests (`"use strict"; 010;` should fail).

            pp$7.setStrict = function (strict) {
              this.strict = strict;
              if (this.type !== tt.num && this.type !== tt.string) return;
              this.pos = this.start;
              if (this.options.locations) {
                while (this.pos < this.lineStart) {
                  this.lineStart = this.input.lastIndexOf("\n", this.lineStart - 2) + 1;
                  --this.curLine;
                }
              }
              this.nextToken();
            };

            pp$7.curContext = function () {
              return this.context[this.context.length - 1];
            };

            // Read a single token, updating the parser object's token-related
            // properties.

            pp$7.nextToken = function () {
              var curContext = this.curContext();
              if (!curContext || !curContext.preserveSpace) this.skipSpace();

              this.start = this.pos;
              if (this.options.locations) this.startLoc = this.curPosition();
              if (this.pos >= this.input.length) return this.finishToken(tt.eof);

              if (curContext.override) return curContext.override(this);else this.readToken(this.fullCharCodeAtPos());
            };

            pp$7.readToken = function (code) {
              // Identifier or keyword. '\uXXXX' sequences are allowed in
              // identifiers, so '\' also dispatches to that.
              if (isIdentifierStart(code, this.options.ecmaVersion >= 6) || code === 92 /* '\' */) return this.readWord();

              return this.getTokenFromCode(code);
            };

            pp$7.fullCharCodeAtPos = function () {
              var code = this.input.charCodeAt(this.pos);
              if (code <= 0xd7ff || code >= 0xe000) return code;
              var next = this.input.charCodeAt(this.pos + 1);
              return (code << 10) + next - 0x35fdc00;
            };

            pp$7.skipBlockComment = function () {
              var startLoc = this.options.onComment && this.curPosition();
              var start = this.pos,
                  end = this.input.indexOf("*/", this.pos += 2);
              if (end === -1) this.raise(this.pos - 2, "Unterminated comment");
              this.pos = end + 2;
              if (this.options.locations) {
                lineBreakG.lastIndex = start;
                var match = undefined;
                while ((match = lineBreakG.exec(this.input)) && match.index < this.pos) {
                  ++this.curLine;
                  this.lineStart = match.index + match[0].length;
                }
              }
              if (this.options.onComment) this.options.onComment(true, this.input.slice(start + 2, end), start, this.pos, startLoc, this.curPosition());
            };

            pp$7.skipLineComment = function (startSkip) {
              var start = this.pos;
              var startLoc = this.options.onComment && this.curPosition();
              var ch = this.input.charCodeAt(this.pos += startSkip);
              while (this.pos < this.input.length && ch !== 10 && ch !== 13 && ch !== 8232 && ch !== 8233) {
                ++this.pos;
                ch = this.input.charCodeAt(this.pos);
              }
              if (this.options.onComment) this.options.onComment(false, this.input.slice(start + startSkip, this.pos), start, this.pos, startLoc, this.curPosition());
            };

            // Called at the start of the parse and after every token. Skips
            // whitespace and comments, and.

            pp$7.skipSpace = function () {
              loop: while (this.pos < this.input.length) {
                var ch = this.input.charCodeAt(this.pos);
                switch (ch) {
                  case 32:case 160:
                    // ' '
                    ++this.pos;
                    break;
                  case 13:
                    if (this.input.charCodeAt(this.pos + 1) === 10) {
                      ++this.pos;
                    }
                  case 10:case 8232:case 8233:
                    ++this.pos;
                    if (this.options.locations) {
                      ++this.curLine;
                      this.lineStart = this.pos;
                    }
                    break;
                  case 47:
                    // '/'
                    switch (this.input.charCodeAt(this.pos + 1)) {
                      case 42:
                        // '*'
                        this.skipBlockComment();
                        break;
                      case 47:
                        this.skipLineComment(2);
                        break;
                      default:
                        break loop;
                    }
                    break;
                  default:
                    if (ch > 8 && ch < 14 || ch >= 5760 && nonASCIIwhitespace.test(String.fromCharCode(ch))) {
                      ++this.pos;
                    } else {
                      break loop;
                    }
                }
              }
            };

            // Called at the end of every token. Sets `end`, `val`, and
            // maintains `context` and `exprAllowed`, and skips the space after
            // the token, so that the next one's `start` will point at the
            // right position.

            pp$7.finishToken = function (type, val) {
              this.end = this.pos;
              if (this.options.locations) this.endLoc = this.curPosition();
              var prevType = this.type;
              this.type = type;
              this.value = val;

              this.updateContext(prevType);
            };

            // ### Token reading

            // This is the function that is called to fetch the next token. It
            // is somewhat obscure, because it works in character codes rather
            // than characters, and because operator parsing has been inlined
            // into it.
            //
            // All in the name of speed.
            //
            pp$7.readToken_dot = function () {
              var next = this.input.charCodeAt(this.pos + 1);
              if (next >= 48 && next <= 57) return this.readNumber(true);
              var next2 = this.input.charCodeAt(this.pos + 2);
              if (this.options.ecmaVersion >= 6 && next === 46 && next2 === 46) {
                // 46 = dot '.'
                this.pos += 3;
                return this.finishToken(tt.ellipsis);
              } else {
                ++this.pos;
                return this.finishToken(tt.dot);
              }
            };

            pp$7.readToken_slash = function () {
              // '/'
              var next = this.input.charCodeAt(this.pos + 1);
              if (this.exprAllowed) {
                ++this.pos;return this.readRegexp();
              }
              if (next === 61) return this.finishOp(tt.assign, 2);
              return this.finishOp(tt.slash, 1);
            };

            pp$7.readToken_mult_modulo = function (code) {
              // '%*'
              var next = this.input.charCodeAt(this.pos + 1);
              if (next === 61) return this.finishOp(tt.assign, 2);
              return this.finishOp(code === 42 ? tt.star : tt.modulo, 1);
            };

            pp$7.readToken_pipe_amp = function (code) {
              // '|&'
              var next = this.input.charCodeAt(this.pos + 1);
              if (next === code) return this.finishOp(code === 124 ? tt.logicalOR : tt.logicalAND, 2);
              if (next === 61) return this.finishOp(tt.assign, 2);
              return this.finishOp(code === 124 ? tt.bitwiseOR : tt.bitwiseAND, 1);
            };

            pp$7.readToken_caret = function () {
              // '^'
              var next = this.input.charCodeAt(this.pos + 1);
              if (next === 61) return this.finishOp(tt.assign, 2);
              return this.finishOp(tt.bitwiseXOR, 1);
            };

            pp$7.readToken_plus_min = function (code) {
              // '+-'
              var next = this.input.charCodeAt(this.pos + 1);
              if (next === code) {
                if (next == 45 && this.input.charCodeAt(this.pos + 2) == 62 && lineBreak.test(this.input.slice(this.lastTokEnd, this.pos))) {
                  // A `-->` line comment
                  this.skipLineComment(3);
                  this.skipSpace();
                  return this.nextToken();
                }
                return this.finishOp(tt.incDec, 2);
              }
              if (next === 61) return this.finishOp(tt.assign, 2);
              return this.finishOp(tt.plusMin, 1);
            };

            pp$7.readToken_lt_gt = function (code) {
              // '<>'
              var next = this.input.charCodeAt(this.pos + 1);
              var size = 1;
              if (next === code) {
                size = code === 62 && this.input.charCodeAt(this.pos + 2) === 62 ? 3 : 2;
                if (this.input.charCodeAt(this.pos + size) === 61) return this.finishOp(tt.assign, size + 1);
                return this.finishOp(tt.bitShift, size);
              }
              if (next == 33 && code == 60 && this.input.charCodeAt(this.pos + 2) == 45 && this.input.charCodeAt(this.pos + 3) == 45) {
                if (this.inModule) this.unexpected();
                // `<!--`, an XML-style comment that should be interpreted as a line comment
                this.skipLineComment(4);
                this.skipSpace();
                return this.nextToken();
              }
              if (next === 61) size = this.input.charCodeAt(this.pos + 2) === 61 ? 3 : 2;
              return this.finishOp(tt.relational, size);
            };

            pp$7.readToken_eq_excl = function (code) {
              // '=!'
              var next = this.input.charCodeAt(this.pos + 1);
              if (next === 61) return this.finishOp(tt.equality, this.input.charCodeAt(this.pos + 2) === 61 ? 3 : 2);
              if (code === 61 && next === 62 && this.options.ecmaVersion >= 6) {
                // '=>'
                this.pos += 2;
                return this.finishToken(tt.arrow);
              }
              return this.finishOp(code === 61 ? tt.eq : tt.prefix, 1);
            };

            pp$7.getTokenFromCode = function (code) {
              switch (code) {
                // The interpretation of a dot depends on whether it is followed
                // by a digit or another two dots.
                case 46:
                  // '.'
                  return this.readToken_dot();

                // Punctuation tokens.
                case 40:
                  ++this.pos;return this.finishToken(tt.parenL);
                case 41:
                  ++this.pos;return this.finishToken(tt.parenR);
                case 59:
                  ++this.pos;return this.finishToken(tt.semi);
                case 44:
                  ++this.pos;return this.finishToken(tt.comma);
                case 91:
                  ++this.pos;return this.finishToken(tt.bracketL);
                case 93:
                  ++this.pos;return this.finishToken(tt.bracketR);
                case 123:
                  ++this.pos;return this.finishToken(tt.braceL);
                case 125:
                  ++this.pos;return this.finishToken(tt.braceR);
                case 58:
                  ++this.pos;return this.finishToken(tt.colon);
                case 63:
                  ++this.pos;return this.finishToken(tt.question);

                case 96:
                  // '`'
                  if (this.options.ecmaVersion < 6) break;
                  ++this.pos;
                  return this.finishToken(tt.backQuote);

                case 48:
                  // '0'
                  var next = this.input.charCodeAt(this.pos + 1);
                  if (next === 120 || next === 88) return this.readRadixNumber(16); // '0x', '0X' - hex number
                  if (this.options.ecmaVersion >= 6) {
                    if (next === 111 || next === 79) return this.readRadixNumber(8); // '0o', '0O' - octal number
                    if (next === 98 || next === 66) return this.readRadixNumber(2); // '0b', '0B' - binary number
                  }
                // Anything else beginning with a digit is an integer, octal
                // number, or float.
                case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:
                  // 1-9
                  return this.readNumber(false);

                // Quotes produce strings.
                case 34:case 39:
                  // '"', "'"
                  return this.readString(code);

                // Operators are parsed inline in tiny state machines. '=' (61) is
                // often referred to. `finishOp` simply skips the amount of
                // characters it is given as second argument, and returns a token
                // of the type given by its first argument.

                case 47:
                  // '/'
                  return this.readToken_slash();

                case 37:case 42:
                  // '%*'
                  return this.readToken_mult_modulo(code);

                case 124:case 38:
                  // '|&'
                  return this.readToken_pipe_amp(code);

                case 94:
                  // '^'
                  return this.readToken_caret();

                case 43:case 45:
                  // '+-'
                  return this.readToken_plus_min(code);

                case 60:case 62:
                  // '<>'
                  return this.readToken_lt_gt(code);

                case 61:case 33:
                  // '=!'
                  return this.readToken_eq_excl(code);

                case 126:
                  // '~'
                  return this.finishOp(tt.prefix, 1);
              }

              this.raise(this.pos, "Unexpected character '" + codePointToString(code) + "'");
            };

            pp$7.finishOp = function (type, size) {
              var str = this.input.slice(this.pos, this.pos + size);
              this.pos += size;
              return this.finishToken(type, str);
            };

            // Parse a regular expression. Some context-awareness is necessary,
            // since a '/' inside a '[]' set does not end the expression.

            function tryCreateRegexp(src, flags, throwErrorAt, parser) {
              try {
                return new RegExp(src, flags);
              } catch (e) {
                if (throwErrorAt !== undefined) {
                  if (e instanceof SyntaxError) parser.raise(throwErrorAt, "Error parsing regular expression: " + e.message);
                  throw e;
                }
              }
            }

            var regexpUnicodeSupport = !!tryCreateRegexp("\uffff", "u");

            pp$7.readRegexp = function () {
              var _this = this;

              var escaped = undefined,
                  inClass = undefined,
                  start = this.pos;
              for (;;) {
                if (this.pos >= this.input.length) this.raise(start, "Unterminated regular expression");
                var ch = this.input.charAt(this.pos);
                if (lineBreak.test(ch)) this.raise(start, "Unterminated regular expression");
                if (!escaped) {
                  if (ch === "[") inClass = true;else if (ch === "]" && inClass) inClass = false;else if (ch === "/" && !inClass) break;
                  escaped = ch === "\\";
                } else escaped = false;
                ++this.pos;
              }
              var content = this.input.slice(start, this.pos);
              ++this.pos;
              // Need to use `readWord1` because '\uXXXX' sequences are allowed
              // here (don't ask).
              var mods = this.readWord1();
              var tmp = content;
              if (mods) {
                var validFlags = /^[gim]*$/;
                if (this.options.ecmaVersion >= 6) validFlags = /^[gimuy]*$/;
                if (!validFlags.test(mods)) this.raise(start, "Invalid regular expression flag");
                if (mods.indexOf('u') >= 0 && !regexpUnicodeSupport) {
                  // Replace each astral symbol and every Unicode escape sequence that
                  // possibly represents an astral symbol or a paired surrogate with a
                  // single ASCII symbol to avoid throwing on regular expressions that
                  // are only valid in combination with the `/u` flag.
                  // Note: replacing with the ASCII symbol `x` might cause false
                  // negatives in unlikely scenarios. For example, `[\u{61}-b]` is a
                  // perfectly valid pattern that is equivalent to `[a-b]`, but it would
                  // be replaced by `[x-b]` which throws an error.
                  tmp = tmp.replace(/\\u\{([0-9a-fA-F]+)\}/g, function (_match, code, offset) {
                    code = Number("0x" + code);
                    if (code > 0x10FFFF) _this.raise(start + offset + 3, "Code point out of bounds");
                    return "x";
                  });
                  tmp = tmp.replace(/\\u([a-fA-F0-9]{4})|[\uD800-\uDBFF][\uDC00-\uDFFF]/g, "x");
                }
              }
              // Detect invalid regular expressions.
              var value = null;
              // Rhino's regular expression parser is flaky and throws uncatchable exceptions,
              // so don't do detection if we are running under Rhino
              if (!isRhino) {
                tryCreateRegexp(tmp, undefined, start, this);
                // Get a regular expression object for this pattern-flag pair, or `null` in
                // case the current environment doesn't support the flags it uses.
                value = tryCreateRegexp(content, mods);
              }
              return this.finishToken(tt.regexp, { pattern: content, flags: mods, value: value });
            };

            // Read an integer in the given radix. Return null if zero digits
            // were read, the integer value otherwise. When `len` is given, this
            // will return `null` unless the integer has exactly `len` digits.

            pp$7.readInt = function (radix, len) {
              var start = this.pos,
                  total = 0;
              for (var i = 0, e = len == null ? Infinity : len; i < e; ++i) {
                var code = this.input.charCodeAt(this.pos),
                    val = undefined;
                if (code >= 97) val = code - 97 + 10; // a
                else if (code >= 65) val = code - 65 + 10; // A
                  else if (code >= 48 && code <= 57) val = code - 48; // 0-9
                    else val = Infinity;
                if (val >= radix) break;
                ++this.pos;
                total = total * radix + val;
              }
              if (this.pos === start || len != null && this.pos - start !== len) return null;

              return total;
            };

            pp$7.readRadixNumber = function (radix) {
              this.pos += 2; // 0x
              var val = this.readInt(radix);
              if (val == null) this.raise(this.start + 2, "Expected number in radix " + radix);
              if (isIdentifierStart(this.fullCharCodeAtPos())) this.raise(this.pos, "Identifier directly after number");
              return this.finishToken(tt.num, val);
            };

            // Read an integer, octal integer, or floating-point number.

            pp$7.readNumber = function (startsWithDot) {
              var start = this.pos,
                  isFloat = false,
                  octal = this.input.charCodeAt(this.pos) === 48;
              if (!startsWithDot && this.readInt(10) === null) this.raise(start, "Invalid number");
              var next = this.input.charCodeAt(this.pos);
              if (next === 46) {
                // '.'
                ++this.pos;
                this.readInt(10);
                isFloat = true;
                next = this.input.charCodeAt(this.pos);
              }
              if (next === 69 || next === 101) {
                // 'eE'
                next = this.input.charCodeAt(++this.pos);
                if (next === 43 || next === 45) ++this.pos; // '+-'
                if (this.readInt(10) === null) this.raise(start, "Invalid number");
                isFloat = true;
              }
              if (isIdentifierStart(this.fullCharCodeAtPos())) this.raise(this.pos, "Identifier directly after number");

              var str = this.input.slice(start, this.pos),
                  val = undefined;
              if (isFloat) val = parseFloat(str);else if (!octal || str.length === 1) val = parseInt(str, 10);else if (/[89]/.test(str) || this.strict) this.raise(start, "Invalid number");else val = parseInt(str, 8);
              return this.finishToken(tt.num, val);
            };

            // Read a string value, interpreting backslash-escapes.

            pp$7.readCodePoint = function () {
              var ch = this.input.charCodeAt(this.pos),
                  code = undefined;

              if (ch === 123) {
                if (this.options.ecmaVersion < 6) this.unexpected();
                var codePos = ++this.pos;
                code = this.readHexChar(this.input.indexOf('}', this.pos) - this.pos);
                ++this.pos;
                if (code > 0x10FFFF) this.raise(codePos, "Code point out of bounds");
              } else {
                code = this.readHexChar(4);
              }
              return code;
            };

            function codePointToString(code) {
              // UTF-16 Decoding
              if (code <= 0xFFFF) return String.fromCharCode(code);
              code -= 0x10000;
              return String.fromCharCode((code >> 10) + 0xD800, (code & 1023) + 0xDC00);
            }

            pp$7.readString = function (quote) {
              var out = "",
                  chunkStart = ++this.pos;
              for (;;) {
                if (this.pos >= this.input.length) this.raise(this.start, "Unterminated string constant");
                var ch = this.input.charCodeAt(this.pos);
                if (ch === quote) break;
                if (ch === 92) {
                  // '\'
                  out += this.input.slice(chunkStart, this.pos);
                  out += this.readEscapedChar(false);
                  chunkStart = this.pos;
                } else {
                  if (isNewLine(ch)) this.raise(this.start, "Unterminated string constant");
                  ++this.pos;
                }
              }
              out += this.input.slice(chunkStart, this.pos++);
              return this.finishToken(tt.string, out);
            };

            // Reads template string tokens.

            pp$7.readTmplToken = function () {
              var out = "",
                  chunkStart = this.pos;
              for (;;) {
                if (this.pos >= this.input.length) this.raise(this.start, "Unterminated template");
                var ch = this.input.charCodeAt(this.pos);
                if (ch === 96 || ch === 36 && this.input.charCodeAt(this.pos + 1) === 123) {
                  // '`', '${'
                  if (this.pos === this.start && this.type === tt.template) {
                    if (ch === 36) {
                      this.pos += 2;
                      return this.finishToken(tt.dollarBraceL);
                    } else {
                      ++this.pos;
                      return this.finishToken(tt.backQuote);
                    }
                  }
                  out += this.input.slice(chunkStart, this.pos);
                  return this.finishToken(tt.template, out);
                }
                if (ch === 92) {
                  // '\'
                  out += this.input.slice(chunkStart, this.pos);
                  out += this.readEscapedChar(true);
                  chunkStart = this.pos;
                } else if (isNewLine(ch)) {
                  out += this.input.slice(chunkStart, this.pos);
                  ++this.pos;
                  switch (ch) {
                    case 13:
                      if (this.input.charCodeAt(this.pos) === 10) ++this.pos;
                    case 10:
                      out += "\n";
                      break;
                    default:
                      out += String.fromCharCode(ch);
                      break;
                  }
                  if (this.options.locations) {
                    ++this.curLine;
                    this.lineStart = this.pos;
                  }
                  chunkStart = this.pos;
                } else {
                  ++this.pos;
                }
              }
            };

            // Used to read escaped characters

            pp$7.readEscapedChar = function (inTemplate) {
              var ch = this.input.charCodeAt(++this.pos);
              ++this.pos;
              switch (ch) {
                case 110:
                  return "\n"; // 'n' -> '\n'
                case 114:
                  return "\r"; // 'r' -> '\r'
                case 120:
                  return String.fromCharCode(this.readHexChar(2)); // 'x'
                case 117:
                  return codePointToString(this.readCodePoint()); // 'u'
                case 116:
                  return "\t"; // 't' -> '\t'
                case 98:
                  return "\b"; // 'b' -> '\b'
                case 118:
                  return "\u000b"; // 'v' -> '\u000b'
                case 102:
                  return "\f"; // 'f' -> '\f'
                case 13:
                  if (this.input.charCodeAt(this.pos) === 10) ++this.pos; // '\r\n'
                case 10:
                  // ' \n'
                  if (this.options.locations) {
                    this.lineStart = this.pos;++this.curLine;
                  }
                  return "";
                default:
                  if (ch >= 48 && ch <= 55) {
                    var octalStr = this.input.substr(this.pos - 1, 3).match(/^[0-7]+/)[0];
                    var octal = parseInt(octalStr, 8);
                    if (octal > 255) {
                      octalStr = octalStr.slice(0, -1);
                      octal = parseInt(octalStr, 8);
                    }
                    if (octalStr !== "0" && (this.strict || inTemplate)) {
                      this.raise(this.pos - 2, "Octal literal in strict mode");
                    }
                    this.pos += octalStr.length - 1;
                    return String.fromCharCode(octal);
                  }
                  return String.fromCharCode(ch);
              }
            };

            // Used to read character escape sequences ('\x', '\u', '\U').

            pp$7.readHexChar = function (len) {
              var codePos = this.pos;
              var n = this.readInt(16, len);
              if (n === null) this.raise(codePos, "Bad character escape sequence");
              return n;
            };

            // Read an identifier, and return it as a string. Sets `this.containsEsc`
            // to whether the word contained a '\u' escape.
            //
            // Incrementally adds only escaped chars, adding other chunks as-is
            // as a micro-optimization.

            pp$7.readWord1 = function () {
              this.containsEsc = false;
              var word = "",
                  first = true,
                  chunkStart = this.pos;
              var astral = this.options.ecmaVersion >= 6;
              while (this.pos < this.input.length) {
                var ch = this.fullCharCodeAtPos();
                if (isIdentifierChar(ch, astral)) {
                  this.pos += ch <= 0xffff ? 1 : 2;
                } else if (ch === 92) {
                  // "\"
                  this.containsEsc = true;
                  word += this.input.slice(chunkStart, this.pos);
                  var escStart = this.pos;
                  if (this.input.charCodeAt(++this.pos) != 117) // "u"
                    this.raise(this.pos, "Expecting Unicode escape sequence \\uXXXX");
                  ++this.pos;
                  var esc = this.readCodePoint();
                  if (!(first ? isIdentifierStart : isIdentifierChar)(esc, astral)) this.raise(escStart, "Invalid Unicode escape");
                  word += codePointToString(esc);
                  chunkStart = this.pos;
                } else {
                  break;
                }
                first = false;
              }
              return word + this.input.slice(chunkStart, this.pos);
            };

            // Read an identifier or keyword token. Will check for reserved
            // words when necessary.

            pp$7.readWord = function () {
              var word = this.readWord1();
              var type = tt.name;
              if ((this.options.ecmaVersion >= 6 || !this.containsEsc) && this.keywords.test(word)) type = keywordTypes[word];
              return this.finishToken(type, word);
            };

            // The main exported interface (under `self.acorn` when in the
            // browser) is a `parse` function that takes a code string and
            // returns an abstract syntax tree as specified by [Mozilla parser
            // API][api].
            //
            // [api]: https://developer.mozilla.org/en-US/docs/SpiderMonkey/Parser_API

            function parse(input, options) {
              return new Parser(options, input).parse();
            }

            function walk(ast, _ref) {
            	var enter = _ref.enter;
            	var leave = _ref.leave;

            	visit(ast, null, enter, leave);
            }

            var context = {
            	skip: function skip() {
            		return context.shouldSkip = true;
            	}
            };

            var childKeys = {};

            var toString$1 = Object.prototype.toString;

            function isArray(thing) {
            	return toString$1.call(thing) === '[object Array]';
            }

            function visit(node, parent, enter, leave, prop, index) {
            	if (!node) return;

            	if (enter) {
            		context.shouldSkip = false;
            		enter.call(context, node, parent, prop, index);
            		if (context.shouldSkip) return;
            	}

            	var keys = childKeys[node.type] || (childKeys[node.type] = Object.keys(node).filter(function (prop) {
            		return typeof node[prop] === 'object';
            	}));

            	var key = undefined,
            	    value = undefined,
            	    i = undefined,
            	    j = undefined;

            	i = keys.length;
            	while (i--) {
            		key = keys[i];
            		value = node[key];

            		if (isArray(value)) {
            			j = value.length;
            			while (j--) {
            				visit(value[j], node, enter, leave, key, j);
            			}
            		} else if (value && value.type) {
            			visit(value, node, enter, leave, key, null);
            		}
            	}

            	if (leave) {
            		leave(node, parent, prop, index);
            	}
            }

            var modifierNodes = {
            	AssignmentExpression: 'left',
            	UpdateExpression: 'argument',
            	UnaryExpression: 'argument'
            };

            function isModifierNode(node) {
            	if (!(node.type in modifierNodes)) {
            		return false;
            	}

            	if (node.type === 'UnaryExpression') {
            		return node.operator === 'delete';
            	}

            	return true;
            }

            function isReference(node, parent) {
            	if (node.type === 'MemberExpression') {
            		return !node.computed && isReference(node.object, node);
            	}

            	if (node.type === 'Identifier') {
            		// the only time we could have an identifier node without a parent is
            		// if it's the entire body of a function without a block statement –
            		// i.e. an arrow function expression like `a => a`
            		if (!parent) return true;

            		// TODO is this right?
            		if (parent.type === 'MemberExpression' || parent.type === 'MethodDefinition') {
            			return parent.computed || node === parent.object;
            		}

            		// disregard the `bar` in `{ bar: foo }`, but keep it in `{ [bar]: foo }`
            		if (parent.type === 'Property') return parent.computed || node === parent.value;

            		// disregard the `bar` in `class Foo { bar () {...} }`
            		if (parent.type === 'MethodDefinition') return false;

            		// disregard the `bar` in `export { foo as bar }`
            		if (parent.type === 'ExportSpecifier' && node !== parent.local) return;

            		return true;
            	}
            }

            function flatten(node) {
            	var parts = [];
            	while (node.type === 'MemberExpression') {
            		if (node.computed) return null;
            		parts.unshift(node.property.name);

            		node = node.object;
            	}

            	if (node.type !== 'Identifier') return null;

            	var name = node.name;
            	parts.unshift(name);

            	return { name: name, keypath: parts.join('.') };
            }

            var pureFunctions = {};

            var arrayTypes = 'Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array'.split(' ');
            var simdTypes = 'Int8x16 Int16x8 Int32x4 Float32x4 Float64x2'.split(' ');
            var simdMethods = 'abs add and bool check div equal extractLane fromFloat32x4 fromFloat32x4Bits fromFloat64x2 fromFloat64x2Bits fromInt16x8Bits fromInt32x4 fromInt32x4Bits fromInt8x16Bits greaterThan greaterThanOrEqual lessThan lessThanOrEqual load max maxNum min minNum mul neg not notEqual or reciprocalApproximation reciprocalSqrtApproximation replaceLane select selectBits shiftLeftByScalar shiftRightArithmeticByScalar shiftRightLogicalByScalar shuffle splat sqrt store sub swizzle xor'.split(' ');
            var allSimdMethods = [];
            simdTypes.forEach(function (t) {
            	simdMethods.forEach(function (m) {
            		allSimdMethods.push('SIMD.' + t + '.' + m);
            	});
            });

            ['Array.isArray', 'Error', 'EvalError', 'InternalError', 'RangeError', 'ReferenceError', 'SyntaxError', 'TypeError', 'URIError', 'isFinite', 'isNaN', 'parseFloat', 'parseInt', 'decodeURI', 'decodeURIComponent', 'encodeURI', 'encodeURIComponent', 'escape', 'unescape', 'Object', 'Object.create', 'Object.getNotifier', 'Object.getOwn', 'Object.getOwnPropertyDescriptor', 'Object.getOwnPropertyNames', 'Object.getOwnPropertySymbols', 'Object.getPrototypeOf', 'Object.is', 'Object.isExtensible', 'Object.isFrozen', 'Object.isSealed', 'Object.keys', 'Function', 'Boolean', 'Number', 'Number.isFinite', 'Number.isInteger', 'Number.isNaN', 'Number.isSafeInteger', 'Number.parseFloat', 'Number.parseInt', 'Symbol', 'Symbol.for', 'Symbol.keyFor', 'Math.abs', 'Math.acos', 'Math.acosh', 'Math.asin', 'Math.asinh', 'Math.atan', 'Math.atan2', 'Math.atanh', 'Math.cbrt', 'Math.ceil', 'Math.clz32', 'Math.cos', 'Math.cosh', 'Math.exp', 'Math.expm1', 'Math.floor', 'Math.fround', 'Math.hypot', 'Math.imul', 'Math.log', 'Math.log10', 'Math.log1p', 'Math.log2', 'Math.max', 'Math.min', 'Math.pow', 'Math.random', 'Math.round', 'Math.sign', 'Math.sin', 'Math.sinh', 'Math.sqrt', 'Math.tan', 'Math.tanh', 'Math.trunc', 'Date', 'Date.UTC', 'Date.now', 'Date.parse', 'String', 'String.fromCharCode', 'String.fromCodePoint', 'String.raw', 'RegExp', 'Map', 'Set', 'WeakMap', 'WeakSet', 'ArrayBuffer', 'ArrayBuffer.isView', 'DataView', 'JSON.parse', 'JSON.stringify', 'Promise', 'Promise.all', 'Promise.race', 'Promise.reject', 'Promise.resolve', 'Intl.Collator', 'Intl.Collator.supportedLocalesOf', 'Intl.DateTimeFormat', 'Intl.DateTimeFormat.supportedLocalesOf', 'Intl.NumberFormat', 'Intl.NumberFormat.supportedLocalesOf'

            // TODO properties of e.g. window...
            ].concat(arrayTypes, arrayTypes.map(function (t) {
            	return t + '.from';
            }), arrayTypes.map(function (t) {
            	return t + '.of';
            }), simdTypes.map(function (t) {
            	return 'SIMD.' + t;
            }), allSimdMethods).forEach(function (name) {
            	return pureFunctions[name] = true;
            });

            function getLocation(source, charIndex) {
            	var lines = source.split('\n');
            	var len = lines.length;

            	var lineStart = 0;
            	var i = undefined;

            	for (i = 0; i < len; i += 1) {
            		var line = lines[i];
            		var lineEnd = lineStart + line.length + 1; // +1 for newline

            		if (lineEnd > charIndex) {
            			return { line: i + 1, column: charIndex - lineStart };
            		}

            		lineStart = lineEnd;
            	}

            	throw new Error('Could not determine location of character');
            }

            function error(props) {
            	var err = new Error(props.message);

            	Object.keys(props).forEach(function (key) {
            		err[key] = props[key];
            	});

            	throw err;
            }

            function call(callee, scope, statement, strongDependencies) {
            	while (callee.type === 'ParenthesizedExpression') callee = callee.expression;

            	if (callee.type === 'Identifier') {
            		var declaration = scope.findDeclaration(callee.name) || statement.module.trace(callee.name);

            		if (declaration) {
            			if (declaration.isNamespace) {
            				error({
            					message: 'Cannot call a namespace (\'' + callee.name + '\')',
            					file: statement.module.id,
            					pos: callee.start,
            					loc: getLocation(statement.module.code, callee.start)
            				});
            			}

            			return declaration.run(strongDependencies);
            		}

            		return !pureFunctions[callee.name];
            	}

            	if (/FunctionExpression/.test(callee.type)) {
            		return run(callee.body, scope, statement, strongDependencies);
            	}

            	if (callee.type === 'MemberExpression') {
            		var flattened = flatten(callee);

            		if (flattened) {
            			// if we're calling e.g. Object.keys(thing), there are no side-effects
            			// TODO make pureFunctions configurable
            			var declaration = scope.findDeclaration(flattened.name) || statement.module.trace(flattened.name);

            			return !!declaration || !pureFunctions[flattened.keypath];
            		}
            	}

            	// complex case like `( a ? b : c )()` or foo[bar].baz()`
            	// – err on the side of caution
            	return true;
            }
            function run(node, scope, statement, strongDependencies, force) {
            	var hasSideEffect = false;

            	walk(node, {
            		enter: function (node, parent) {
            			if (!force && /Function/.test(node.type)) return this.skip();

            			if (node._scope) scope = node._scope;

            			if (isReference(node, parent)) {
            				var flattened = flatten(node);

            				if (flattened.name === 'arguments') {
            					hasSideEffect = true;
            				} else if (!scope.contains(flattened.name)) {
            					var declaration = statement.module.trace(flattened.name);
            					if (declaration && !declaration.isExternal) {
            						var _module = declaration.module || declaration.statement.module; // TODO is this right?
            						if (!_module.isExternal && ! ~strongDependencies.indexOf(_module)) strongDependencies.push(_module);
            					}
            				}
            			} else if (node.type === 'ThrowStatement') {
            				// we only care about errors thrown at the top level, otherwise
            				// any function with error checking gets included if called
            				if (scope.isTopLevel) hasSideEffect = true;
            			} else if (node.type === 'CallExpression' || node.type === 'NewExpression') {
            				if (call(node.callee, scope, statement, strongDependencies)) {
            					hasSideEffect = true;
            				}
            			} else if (isModifierNode(node)) {
            				var subject = node[modifierNodes[node.type]];
            				while (subject.type === 'MemberExpression') subject = subject.object;

            				var declaration = scope.findDeclaration(subject.name);

            				if (declaration) {
            					if (declaration.isParam) hasSideEffect = true;
            				} else if (!scope.isTopLevel) {
            					hasSideEffect = true;
            				} else {
            					declaration = statement.module.trace(subject.name);

            					if (!declaration || declaration.isExternal || declaration.isUsed) {
            						hasSideEffect = true;
            					}
            				}
            			}
            		},
            		leave: function (node) {
            			if (node._scope) scope = scope.parent;
            		}
            	});

            	return hasSideEffect;
            }

            var Reference = function Reference(node, scope, statement) {
            	babelHelpers.classCallCheck(this, Reference);

            	this.node = node;
            	this.scope = scope;
            	this.statement = statement;

            	this.declaration = null; // bound later

            	this.parts = [];

            	var root = node;
            	while (root.type === 'MemberExpression') {
            		this.parts.unshift(root.property);
            		root = root.object;
            	}

            	this.name = root.name;

            	this.start = node.start;
            	this.end = node.start + this.name.length; // can be overridden in the case of namespace members
            	this.rewritten = false;
            };

            var SyntheticReference = function SyntheticReference(name) {
            	babelHelpers.classCallCheck(this, SyntheticReference);

            	this.name = name;
            	this.parts = [];
            };

            var _use = function (alias) {
            	return alias.use();
            };

            var Declaration = (function () {
            	function Declaration(node, isParam, statement) {
            		babelHelpers.classCallCheck(this, Declaration);

            		if (node) {
            			if (node.type === 'FunctionDeclaration') {
            				this.isFunctionDeclaration = true;
            				this.functionNode = node;
            			} else if (node.type === 'VariableDeclarator' && node.init && /FunctionExpression/.test(node.init.type)) {
            				this.isFunctionDeclaration = true;
            				this.functionNode = node.init;
            			}
            		}

            		this.statement = statement;
            		this.name = null;
            		this.exportName = null;
            		this.isParam = isParam;

            		this.isReassigned = false;
            		this.aliases = [];

            		this.isUsed = false;
            	}

            	Declaration.prototype.addAlias = function addAlias(declaration) {
            		this.aliases.push(declaration);
            	};

            	Declaration.prototype.addReference = function addReference(reference) {
            		reference.declaration = this;
            		this.name = reference.name; // TODO handle differences of opinion

            		if (reference.isReassignment) this.isReassigned = true;
            	};

            	Declaration.prototype.render = function render(es6) {
            		if (es6) return this.name;
            		if (!this.isReassigned || !this.exportName) return this.name;

            		return 'exports.' + this.exportName;
            	};

            	Declaration.prototype.run = function run$$(strongDependencies) {
            		if (this.tested) return this.hasSideEffects;

            		if (!this.functionNode) {
            			this.hasSideEffects = true; // err on the side of caution. TODO handle unambiguous `var x; x = y => z` cases
            		} else {
            				if (this.running) return true; // short-circuit infinite loop
            				this.running = true;

            				this.hasSideEffects = run(this.functionNode.body, this.functionNode._scope, this.statement, strongDependencies, false);

            				this.running = false;
            			}

            		this.tested = true;
            		return this.hasSideEffects;
            	};

            	Declaration.prototype.use = function use() {
            		if (this.isUsed) return;

            		this.isUsed = true;
            		if (this.statement) this.statement.mark();

            		this.aliases.forEach(_use);
            	};

            	return Declaration;
            })();

            var SyntheticDefaultDeclaration = (function () {
            	function SyntheticDefaultDeclaration(node, statement, name) {
            		babelHelpers.classCallCheck(this, SyntheticDefaultDeclaration);

            		this.node = node;
            		this.statement = statement;
            		this.name = name;

            		this.original = null;
            		this.exportName = null;
            		this.aliases = [];
            	}

            	SyntheticDefaultDeclaration.prototype.addAlias = function addAlias(declaration) {
            		this.aliases.push(declaration);
            	};

            	SyntheticDefaultDeclaration.prototype.addReference = function addReference(reference) {
            		// Bind the reference to `this` declaration.
            		reference.declaration = this;

            		// Don't change the name to `default`; it's not a valid identifier name.
            		if (reference.name === 'default') return;

            		this.name = reference.name;
            	};

            	SyntheticDefaultDeclaration.prototype.bind = function bind(declaration) {
            		this.original = declaration;
            	};

            	SyntheticDefaultDeclaration.prototype.render = function render() {
            		return !this.original || this.original.isReassigned ? this.name : this.original.render();
            	};

            	SyntheticDefaultDeclaration.prototype.run = function run$$(strongDependencies) {
            		if (this.original) {
            			return this.original.run(strongDependencies);
            		}

            		var declaration = this.node.declaration;
            		while (declaration.type === 'ParenthesizedExpression') declaration = declaration.expression;

            		if (/FunctionExpression/.test(declaration.type)) {
            			return run(declaration.body, this.statement.scope, this.statement, strongDependencies, false);
            		}

            		// otherwise assume the worst
            		return true;
            	};

            	SyntheticDefaultDeclaration.prototype.use = function use() {
            		this.isUsed = true;
            		this.statement.mark();

            		if (this.original) this.original.use();

            		this.aliases.forEach(_use);
            	};

            	return SyntheticDefaultDeclaration;
            })();

            var SyntheticGlobalDeclaration = (function () {
            	function SyntheticGlobalDeclaration(name) {
            		babelHelpers.classCallCheck(this, SyntheticGlobalDeclaration);

            		this.name = name;
            		this.isExternal = true;
            		this.isGlobal = true;
            		this.isReassigned = false;

            		this.aliases = [];

            		this.isUsed = false;
            	}

            	SyntheticGlobalDeclaration.prototype.addAlias = function addAlias(declaration) {
            		this.aliases.push(declaration);
            	};

            	SyntheticGlobalDeclaration.prototype.addReference = function addReference(reference) {
            		reference.declaration = this;
            		if (reference.isReassignment) this.isReassigned = true;
            	};

            	SyntheticGlobalDeclaration.prototype.render = function render() {
            		return this.name;
            	};

            	SyntheticGlobalDeclaration.prototype.run = function run() {
            		return true;
            	};

            	SyntheticGlobalDeclaration.prototype.use = function use() {
            		if (this.isUsed) return;
            		this.isUsed = true;

            		this.aliases.forEach(_use);
            	};

            	return SyntheticGlobalDeclaration;
            })();

            var SyntheticNamespaceDeclaration = (function () {
            	function SyntheticNamespaceDeclaration(module) {
            		var _this = this;

            		babelHelpers.classCallCheck(this, SyntheticNamespaceDeclaration);

            		this.isNamespace = true;
            		this.module = module;
            		this.name = null;

            		this.needsNamespaceBlock = false;
            		this.aliases = [];

            		this.originals = blank();
            		module.getExports().forEach(function (name) {
            			_this.originals[name] = module.traceExport(name);
            		});
            	}

            	SyntheticNamespaceDeclaration.prototype.addAlias = function addAlias(declaration) {
            		this.aliases.push(declaration);
            	};

            	SyntheticNamespaceDeclaration.prototype.addReference = function addReference(reference) {
            		// if we have e.g. `foo.bar`, we can optimise
            		// the reference by pointing directly to `bar`
            		if (reference.parts.length) {
            			var ref = reference.parts.shift();
            			reference.name = ref.name;
            			reference.end = ref.end;

            			var original = this.originals[reference.name];

            			// throw with an informative error message if the reference doesn't exist.
            			if (!original) {
            				this.module.bundle.onwarn('Export \'' + reference.name + '\' is not defined by \'' + this.module.id + '\'');
            				reference.isUndefined = true;
            				return;
            			}

            			original.addReference(reference);
            			return;
            		}

            		// otherwise we're accessing the namespace directly,
            		// which means we need to mark all of this module's
            		// exports and render a namespace block in the bundle
            		if (!this.needsNamespaceBlock) {
            			this.needsNamespaceBlock = true;
            			this.module.bundle.internalNamespaces.push(this);

            			// add synthetic references, in case of chained
            			// namespace imports
            			forOwn(this.originals, function (original, name) {
            				original.addReference(new SyntheticReference(name));
            			});
            		}

            		reference.declaration = this;
            		this.name = reference.name;
            	};

            	SyntheticNamespaceDeclaration.prototype.renderBlock = function renderBlock(indentString) {
            		var _this2 = this;

            		var members = keys(this.originals).map(function (name) {
            			var original = _this2.originals[name];

            			if (original.isReassigned) {
            				return indentString + 'get ' + name + ' () { return ' + original.render() + '; }';
            			}

            			return '' + indentString + name + ': ' + original.render();
            		});

            		return 'var ' + this.render() + ' = Object.freeze({\n' + members.join(',\n') + '\n});\n\n';
            	};

            	SyntheticNamespaceDeclaration.prototype.render = function render() {
            		return this.name;
            	};

            	SyntheticNamespaceDeclaration.prototype.use = function use() {
            		forOwn(this.originals, _use);
            		this.aliases.forEach(_use);
            	};

            	return SyntheticNamespaceDeclaration;
            })();

            var ExternalDeclaration = (function () {
            	function ExternalDeclaration(module, name) {
            		babelHelpers.classCallCheck(this, ExternalDeclaration);

            		this.module = module;
            		this.name = name;
            		this.safeName = null;
            		this.isExternal = true;

            		this.isNamespace = name === '*';
            	}

            	ExternalDeclaration.prototype.addAlias = function addAlias() {
            		// noop
            	};

            	ExternalDeclaration.prototype.addReference = function addReference(reference) {
            		reference.declaration = this;

            		if (this.name === 'default' || this.name === '*') {
            			this.module.suggestName(reference.name);
            		}
            	};

            	ExternalDeclaration.prototype.render = function render(es6) {
            		if (this.name === '*') {
            			return this.module.name;
            		}

            		if (this.name === 'default') {
            			return !es6 && this.module.exportsNames ? this.module.name + '__default' : this.module.name;
            		}

            		return es6 ? this.safeName : this.module.name + '.' + this.name;
            	};

            	ExternalDeclaration.prototype.run = function run() {
            		return true;
            	};

            	ExternalDeclaration.prototype.setSafeName = function setSafeName(name) {
            		this.safeName = name;
            	};

            	ExternalDeclaration.prototype.use = function use() {
            		// noop?
            	};

            	return ExternalDeclaration;
            })();

            function extractNames(param) {
            	var names = [];
            	extractors[param.type](names, param);
            	return names;
            }

            var extractors = {
            	Identifier: function (names, param) {
            		names.push(param.name);
            	},

            	ObjectPattern: function (names, param) {
            		param.properties.forEach(function (prop) {
            			extractors[prop.value.type](names, prop.value);
            		});
            	},

            	ArrayPattern: function (names, param) {
            		param.elements.forEach(function (element) {
            			if (element) extractors[element.type](names, element);
            		});
            	},

            	RestElement: function (names, param) {
            		extractors[param.argument.type](names, param.argument);
            	},

            	AssignmentPattern: function (names, param) {
            		extractors[param.left.type](names, param.left);
            	}
            };

            var Scope = (function () {
            	function Scope(options) {
            		var _this = this;

            		babelHelpers.classCallCheck(this, Scope);

            		options = options || {};

            		this.parent = options.parent;
            		this.statement = options.statement || this.parent.statement;
            		this.isBlockScope = !!options.block;
            		this.isTopLevel = !this.parent || this.parent.isTopLevel && this.isBlockScope;

            		this.declarations = blank();

            		if (options.params) {
            			options.params.forEach(function (param) {
            				extractNames(param).forEach(function (name) {
            					_this.declarations[name] = new Declaration(param, true, _this.statement);
            				});
            			});
            		}
            	}

            	Scope.prototype.addDeclaration = function addDeclaration(node, isBlockDeclaration, isVar) {
            		var _this2 = this;

            		if (!isBlockDeclaration && this.isBlockScope) {
            			// it's a `var` or function node, and this
            			// is a block scope, so we need to go up
            			this.parent.addDeclaration(node, isBlockDeclaration, isVar);
            		} else {
            			extractNames(node.id).forEach(function (name) {
            				_this2.declarations[name] = new Declaration(node, false, _this2.statement);
            			});
            		}
            	};

            	Scope.prototype.contains = function contains(name) {
            		return this.declarations[name] || (this.parent ? this.parent.contains(name) : false);
            	};

            	Scope.prototype.eachDeclaration = function eachDeclaration(fn) {
            		var _this3 = this;

            		keys(this.declarations).forEach(function (key) {
            			fn(key, _this3.declarations[key]);
            		});
            	};

            	Scope.prototype.findDeclaration = function findDeclaration(name) {
            		return this.declarations[name] || this.parent && this.parent.findDeclaration(name);
            	};

            	return Scope;
            })();

            var blockDeclarations = {
            	'const': true,
            	'let': true
            };
            function attachScopes(statement) {
            	var node = statement.node;
            	var scope = statement.scope;

            	walk(node, {
            		enter: function (node, parent) {
            			// function foo () {...}
            			// class Foo {...}
            			if (/(Function|Class)Declaration/.test(node.type)) {
            				scope.addDeclaration(node, false, false);
            			}

            			// var foo = 1, bar = 2
            			if (node.type === 'VariableDeclaration') {
            				(function () {
            					var isBlockDeclaration = blockDeclarations[node.kind];

            					node.declarations.forEach(function (declarator) {
            						scope.addDeclaration(declarator, isBlockDeclaration, true);
            					});
            				})();
            			}

            			var newScope = undefined;

            			// create new function scope
            			if (/Function/.test(node.type)) {
            				newScope = new Scope({
            					parent: scope,
            					block: false,
            					params: node.params
            				});

            				// named function expressions - the name is considered
            				// part of the function's scope
            				if (node.type === 'FunctionExpression' && node.id) {
            					newScope.addDeclaration(node, false, false);
            				}
            			}

            			// create new block scope
            			if (node.type === 'BlockStatement' && (!parent || !/Function/.test(parent.type))) {
            				newScope = new Scope({
            					parent: scope,
            					block: true
            				});
            			}

            			// catch clause has its own block scope
            			if (node.type === 'CatchClause') {
            				newScope = new Scope({
            					parent: scope,
            					params: [node.param],
            					block: true
            				});
            			}

            			if (newScope) {
            				Object.defineProperty(node, '_scope', {
            					value: newScope,
            					configurable: true
            				});

            				scope = newScope;
            			}
            		},
            		leave: function (node) {
            			if (node._scope) {
            				scope = scope.parent;
            			}
            		}
            	});
            }

            function isFunctionDeclaration(node) {
            	if (!node) return false;

            	return node.type === 'FunctionDeclaration' || node.type === 'VariableDeclaration' && node.init && /FunctionExpression/.test(node.init.type);
            }

            var Statement = (function () {
            	function Statement(node, module, start, end) {
            		babelHelpers.classCallCheck(this, Statement);

            		this.node = node;
            		this.module = module;
            		this.start = start;
            		this.end = end;
            		this.next = null; // filled in later

            		this.scope = new Scope({ statement: this });

            		this.references = [];
            		this.stringLiteralRanges = [];

            		this.isIncluded = false;
            		this.ran = false;

            		this.isImportDeclaration = node.type === 'ImportDeclaration';
            		this.isExportDeclaration = /^Export/.test(node.type);
            		this.isReexportDeclaration = this.isExportDeclaration && !!node.source;

            		this.isFunctionDeclaration = isFunctionDeclaration(node) || this.isExportDeclaration && isFunctionDeclaration(node.declaration);
            	}

            	Statement.prototype.firstPass = function firstPass() {
            		if (this.isImportDeclaration) return; // nothing to analyse

            		// attach scopes
            		attachScopes(this);

            		// find references
            		var statement = this;
            		var module = this.module;
            		var references = this.references;
            		var scope = this.scope;
            		var stringLiteralRanges = this.stringLiteralRanges;

            		var readDepth = 0;

            		walk(this.node, {
            			enter: function (node, parent, prop) {
            				// warn about eval
            				if (node.type === 'CallExpression' && node.callee.name === 'eval' && !scope.contains('eval')) {
            					module.bundle.onwarn('Use of `eval` (in ' + module.id + ') is discouraged, as it may cause issues with minification. See https://github.com/rollup/rollup/wiki/Troubleshooting#avoiding-eval for more details');
            				}

            				// skip re-export declarations
            				if (node.type === 'ExportNamedDeclaration' && node.source) return this.skip();

            				if (node.type === 'TemplateElement') stringLiteralRanges.push([node.start, node.end]);
            				if (node.type === 'Literal' && typeof node.value === 'string' && /\n/.test(node.raw)) {
            					stringLiteralRanges.push([node.start + 1, node.end - 1]);
            				}

            				if (node._scope) scope = node._scope;
            				if (/Function/.test(node.type)) readDepth += 1;

            				var isReassignment = undefined;

            				if (parent && isModifierNode(parent)) {
            					var subject = parent[modifierNodes[parent.type]];
            					var depth = 0;

            					while (subject.type === 'MemberExpression') {
            						subject = subject.object;
            						depth += 1;
            					}

            					var importDeclaration = module.imports[subject.name];

            					if (!scope.contains(subject.name) && importDeclaration) {
            						var minDepth = importDeclaration.name === '*' ? 2 : // cannot do e.g. `namespace.foo = bar`
            						1; // cannot do e.g. `foo = bar`, but `foo.bar = bar` is fine

            						if (depth < minDepth) {
            							var err = new Error('Illegal reassignment to import \'' + subject.name + '\'');
            							err.file = module.id;
            							err.loc = getLocation(module.magicString.toString(), subject.start);
            							throw err;
            						}
            					}

            					isReassignment = !depth;
            				}

            				if (isReference(node, parent)) {
            					// function declaration IDs are a special case – they're associated
            					// with the parent scope
            					var referenceScope = parent.type === 'FunctionDeclaration' && node === parent.id ? scope.parent : scope;

            					var isShorthandProperty = parent.type === 'Property' && parent.shorthand;

            					// Since `node.key` can equal `node.value` for shorthand properties
            					// we must use the `prop` argument provided by `estree-walker` to determine
            					// if we're looking at the key or the value.
            					// If they are equal, we'll return to not create duplicate references.
            					if (isShorthandProperty && parent.value === parent.key && prop === 'value') {
            						return;
            					}

            					var reference = new Reference(node, referenceScope, statement);
            					reference.isReassignment = isReassignment;
            					reference.isShorthandProperty = isShorthandProperty;
            					references.push(reference);

            					this.skip(); // don't descend from `foo.bar.baz` into `foo.bar`
            				}
            			},
            			leave: function (node) {
            				if (node._scope) scope = scope.parent;
            				if (/Function/.test(node.type)) readDepth -= 1;
            			}
            		});
            	};

            	Statement.prototype.mark = function mark() {
            		if (this.isIncluded) return; // prevent infinite loops
            		this.isIncluded = true;

            		this.references.forEach(function (reference) {
            			if (reference.declaration) reference.declaration.use();
            		});
            	};

            	Statement.prototype.run = function run$$(strongDependencies) {
            		if (this.ran && this.isIncluded || this.isImportDeclaration || this.isFunctionDeclaration) return;
            		this.ran = true;

            		if (run(this.node, this.scope, this, strongDependencies, false)) {
            			this.mark();
            			return true;
            		}
            	};

            	Statement.prototype.source = function source() {
            		return this.module.source.slice(this.start, this.end);
            	};

            	Statement.prototype.toString = function toString() {
            		return this.module.magicString.slice(this.start, this.end);
            	};

            	return Statement;
            })();

            var reservedWords = 'break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public'.split(' ');
            var builtins = 'Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl'.split(' ');

            var blacklisted = blank();
            reservedWords.concat(builtins).forEach(function (word) {
            	return blacklisted[word] = true;
            });
            function makeLegalIdentifier(str) {
            	str = str.replace(/-(\w)/g, function (_, letter) {
            		return letter.toUpperCase();
            	}).replace(/[^$_a-zA-Z0-9]/g, '_');

            	if (/\d/.test(str[0]) || blacklisted[str]) str = '_' + str;

            	return str;
            }

            function isTruthy(node) {
            	if (node.type === 'Literal') return !!node.value;
            	if (node.type === 'ParenthesizedExpression') return isTruthy(node.expression);
            	if (node.operator in operators) return operators[node.operator](node);
            }

            function isFalsy(node) {
            	return not(isTruthy(node));
            }

            function not(value) {
            	return value === undefined ? value : !value;
            }

            function equals(a, b, strict) {
            	if (a.type !== b.type) return undefined;
            	if (a.type === 'Literal') return strict ? a.value === b.value : a.value == b.value;
            }

            var operators = {
            	'==': function (x) {
            		return equals(x.left, x.right, false);
            	},

            	'!=': function (x) {
            		return not(operators['=='](x));
            	},

            	'===': function (x) {
            		return equals(x.left, x.right, true);
            	},

            	'!==': function (x) {
            		return not(operators['==='](x));
            	},

            	'!': function (x) {
            		return isFalsy(x.argument);
            	},

            	'&&': function (x) {
            		return isTruthy(x.left) && isTruthy(x.right);
            	},

            	'||': function (x) {
            		return isTruthy(x.left) || isTruthy(x.right);
            	}
            };

            function emptyBlockStatement(start, end) {
            	return {
            		start: start, end: end,
            		type: 'BlockStatement',
            		body: []
            	};
            }

            var Module = (function () {
            	function Module(_ref) {
            		var id = _ref.id;
            		var code = _ref.code;
            		var originalCode = _ref.originalCode;
            		var ast = _ref.ast;
            		var sourceMapChain = _ref.sourceMapChain;
            		var bundle = _ref.bundle;
            		babelHelpers.classCallCheck(this, Module);

            		this.code = code;
            		this.originalCode = originalCode;
            		this.sourceMapChain = sourceMapChain;

            		this.bundle = bundle;
            		this.id = id;

            		// all dependencies
            		this.sources = [];
            		this.dependencies = [];
            		this.resolvedIds = blank();

            		// imports and exports, indexed by local name
            		this.imports = blank();
            		this.exports = blank();
            		this.reexports = blank();

            		this.exportAllSources = [];
            		this.exportAllModules = null;

            		// By default, `id` is the filename. Custom resolvers and loaders
            		// can change that, but it makes sense to use it for the source filename
            		this.magicString = new MagicString(code, {
            			filename: id,
            			indentExclusionRanges: []
            		});

            		// remove existing sourceMappingURL comments
            		var pattern = new RegExp('\\/\\/#\\s+' + SOURCEMAPPING_URL$1 + '=.+\\n?', 'g');
            		var match = undefined;
            		while (match = pattern.exec(code)) {
            			this.magicString.remove(match.index, match.index + match[0].length);
            		}

            		this.comments = [];
            		this.statements = this.parse(ast);

            		this.declarations = blank();
            		this.analyse();

            		this.strongDependencies = [];
            	}

            	Module.prototype.addExport = function addExport(statement) {
            		var _this = this;

            		var node = statement.node;
            		var source = node.source && node.source.value;

            		// export { name } from './other.js'
            		if (source) {
            			if (! ~this.sources.indexOf(source)) this.sources.push(source);

            			if (node.type === 'ExportAllDeclaration') {
            				// Store `export * from '...'` statements in an array of delegates.
            				// When an unknown import is encountered, we see if one of them can satisfy it.
            				this.exportAllSources.push(source);
            			} else {
            				node.specifiers.forEach(function (specifier) {
            					_this.reexports[specifier.exported.name] = {
            						start: specifier.start,
            						source: source,
            						localName: specifier.local.name,
            						module: null // filled in later
            					};
            				});
            			}
            		}

            		// export default function foo () {}
            		// export default foo;
            		// export default 42;
            		else if (node.type === 'ExportDefaultDeclaration') {
            				var identifier = node.declaration.id && node.declaration.id.name || node.declaration.name;

            				this.exports.default = {
            					localName: 'default',
            					identifier: identifier
            				};

            				// create a synthetic declaration
            				this.declarations.default = new SyntheticDefaultDeclaration(node, statement, identifier || this.basename());
            			}

            			// export var { foo, bar } = ...
            			// export var foo = 42;
            			// export var a = 1, b = 2, c = 3;
            			// export function foo () {}
            			else if (node.declaration) {
            					var declaration = node.declaration;

            					if (declaration.type === 'VariableDeclaration') {
            						declaration.declarations.forEach(function (decl) {
            							extractNames(decl.id).forEach(function (localName) {
            								_this.exports[localName] = { localName: localName };
            							});
            						});
            					} else {
            						// export function foo () {}
            						var localName = declaration.id.name;
            						this.exports[localName] = { localName: localName };
            					}
            				}

            				// export { foo, bar, baz }
            				else {
            						if (node.specifiers.length) {
            							node.specifiers.forEach(function (specifier) {
            								var localName = specifier.local.name;
            								var exportedName = specifier.exported.name;

            								_this.exports[exportedName] = { localName: localName };
            							});
            						} else {
            							this.bundle.onwarn('Module ' + this.id + ' has an empty export declaration');
            						}
            					}
            	};

            	Module.prototype.addImport = function addImport(statement) {
            		var _this2 = this;

            		var node = statement.node;
            		var source = node.source.value;

            		if (! ~this.sources.indexOf(source)) this.sources.push(source);

            		node.specifiers.forEach(function (specifier) {
            			var localName = specifier.local.name;

            			if (_this2.imports[localName]) {
            				var err = new Error('Duplicated import \'' + localName + '\'');
            				err.file = _this2.id;
            				err.loc = getLocation(_this2.code, specifier.start);
            				throw err;
            			}

            			var isDefault = specifier.type === 'ImportDefaultSpecifier';
            			var isNamespace = specifier.type === 'ImportNamespaceSpecifier';

            			var name = isDefault ? 'default' : isNamespace ? '*' : specifier.imported.name;
            			_this2.imports[localName] = { source: source, name: name, module: null };
            		});
            	};

            	Module.prototype.analyse = function analyse() {
            		var _this3 = this;

            		// discover this module's imports and exports
            		this.statements.forEach(function (statement) {
            			if (statement.isImportDeclaration) _this3.addImport(statement);else if (statement.isExportDeclaration) _this3.addExport(statement);

            			statement.firstPass();

            			statement.scope.eachDeclaration(function (name, declaration) {
            				_this3.declarations[name] = declaration;
            			});
            		});
            	};

            	Module.prototype.basename = function basename() {
            		var base = _basename(this.id);
            		var ext = extname(this.id);

            		return makeLegalIdentifier(ext ? base.slice(0, -ext.length) : base);
            	};

            	Module.prototype.bindAliases = function bindAliases() {
            		var _this4 = this;

            		keys(this.declarations).forEach(function (name) {
            			if (name === '*') return;

            			var declaration = _this4.declarations[name];
            			var statement = declaration.statement;

            			if (!statement || statement.node.type !== 'VariableDeclaration') return;

            			var init = statement.node.declarations[0].init;
            			if (!init || init.type === 'FunctionExpression') return;

            			statement.references.forEach(function (reference) {
            				if (reference.name === name) return;

            				var otherDeclaration = _this4.trace(reference.name);
            				if (otherDeclaration) otherDeclaration.addAlias(declaration);
            			});
            		});
            	};

            	Module.prototype.bindImportSpecifiers = function bindImportSpecifiers() {
            		var _this5 = this;

            		[this.imports, this.reexports].forEach(function (specifiers) {
            			keys(specifiers).forEach(function (name) {
            				var specifier = specifiers[name];

            				var id = _this5.resolvedIds[specifier.source];
            				specifier.module = _this5.bundle.moduleById[id];
            			});
            		});

            		this.exportAllModules = this.exportAllSources.map(function (source) {
            			var id = _this5.resolvedIds[source];
            			return _this5.bundle.moduleById[id];
            		});

            		this.sources.forEach(function (source) {
            			var id = _this5.resolvedIds[source];
            			var module = _this5.bundle.moduleById[id];

            			if (!module.isExternal) _this5.dependencies.push(module);
            		});
            	};

            	Module.prototype.bindReferences = function bindReferences() {
            		var _this6 = this;

            		if (this.declarations.default) {
            			if (this.exports.default.identifier) {
            				var declaration = this.trace(this.exports.default.identifier);
            				if (declaration) this.declarations.default.bind(declaration);
            			}
            		}

            		this.statements.forEach(function (statement) {
            			// skip `export { foo, bar, baz }`...
            			if (statement.node.type === 'ExportNamedDeclaration' && statement.node.specifiers.length) {
            				// ...unless this is the entry module
            				if (_this6 !== _this6.bundle.entryModule) return;
            			}

            			statement.references.forEach(function (reference) {
            				var declaration = reference.scope.findDeclaration(reference.name) || _this6.trace(reference.name);

            				if (declaration) {
            					declaration.addReference(reference);
            				} else {
            					// TODO handle globals
            					_this6.bundle.assumedGlobals[reference.name] = true;
            				}
            			});
            		});
            	};

            	Module.prototype.getExports = function getExports() {
            		var exports = blank();

            		keys(this.exports).forEach(function (name) {
            			exports[name] = true;
            		});

            		keys(this.reexports).forEach(function (name) {
            			exports[name] = true;
            		});

            		this.exportAllModules.forEach(function (module) {
            			module.getExports().forEach(function (name) {
            				if (name !== 'default') exports[name] = true;
            			});
            		});

            		return keys(exports);
            	};

            	Module.prototype.namespace = function namespace() {
            		if (!this.declarations['*']) {
            			this.declarations['*'] = new SyntheticNamespaceDeclaration(this);
            		}

            		return this.declarations['*'];
            	};

            	Module.prototype.parse = function parse$$(ast) {
            		var _this7 = this;

            		// The ast can be supplied programmatically (but usually won't be)
            		if (!ast) {
            			// Try to extract a list of top-level statements/declarations. If
            			// the parse fails, attach file info and abort
            			try {
            				ast = parse(this.code, {
            					ecmaVersion: 6,
            					sourceType: 'module',
            					onComment: function (block, text, start, end) {
            						return _this7.comments.push({ block: block, text: text, start: start, end: end });
            					},
            					preserveParens: true
            				});
            			} catch (err) {
            				err.code = 'PARSE_ERROR';
            				err.file = this.id; // see above - not necessarily true, but true enough
            				err.message += ' in ' + this.id;
            				throw err;
            			}
            		}

            		walk(ast, {
            			enter: function (node) {
            				// eliminate dead branches early
            				if (node.type === 'IfStatement') {
            					if (isFalsy(node.test)) {
            						_this7.magicString.overwrite(node.consequent.start, node.consequent.end, '{}');
            						node.consequent = emptyBlockStatement(node.consequent.start, node.consequent.end);
            					} else if (node.alternate && isTruthy(node.test)) {
            						_this7.magicString.overwrite(node.alternate.start, node.alternate.end, '{}');
            						node.alternate = emptyBlockStatement(node.alternate.start, node.alternate.end);
            					}
            				}

            				_this7.magicString.addSourcemapLocation(node.start);
            				_this7.magicString.addSourcemapLocation(node.end);
            			},

            			leave: function (node, parent, prop) {
            				// eliminate dead branches early
            				if (node.type === 'ConditionalExpression') {
            					if (isFalsy(node.test)) {
            						_this7.magicString.remove(node.start, node.alternate.start);
            						parent[prop] = node.alternate;
            					} else if (isTruthy(node.test)) {
            						_this7.magicString.remove(node.start, node.consequent.start);
            						_this7.magicString.remove(node.consequent.end, node.end);
            						parent[prop] = node.consequent;
            					}
            				}
            			}
            		});

            		var statements = [];
            		var lastChar = 0;
            		var commentIndex = 0;

            		ast.body.forEach(function (node) {
            			if (node.type === 'EmptyStatement') return;

            			if (node.type === 'ExportNamedDeclaration' && node.declaration && node.declaration.type === 'VariableDeclaration' && node.declaration.declarations && node.declaration.declarations.length > 1) {
            				// push a synthetic export declaration
            				var syntheticNode = {
            					type: 'ExportNamedDeclaration',
            					specifiers: node.declaration.declarations.map(function (declarator) {
            						var id = { name: declarator.id.name };
            						return {
            							local: id,
            							exported: id
            						};
            					}),
            					isSynthetic: true
            				};

            				var statement = new Statement(syntheticNode, _this7, node.start, node.start);
            				statements.push(statement);

            				_this7.magicString.remove(node.start, node.declaration.start);
            				node = node.declaration;
            			}

            			// special case - top-level var declarations with multiple declarators
            			// should be split up. Otherwise, we may end up including code we
            			// don't need, just because an unwanted declarator is included
            			if (node.type === 'VariableDeclaration' && node.declarations.length > 1) {
            				// remove the leading var/let/const... UNLESS the previous node
            				// was also a synthetic node, in which case it'll get removed anyway
            				var lastStatement = statements[statements.length - 1];
            				if (!lastStatement || !lastStatement.node.isSynthetic) {
            					_this7.magicString.remove(node.start, node.declarations[0].start);
            				}

            				node.declarations.forEach(function (declarator) {
            					var start = declarator.start;
            					var end = declarator.end;

            					var syntheticNode = {
            						type: 'VariableDeclaration',
            						kind: node.kind,
            						start: start,
            						end: end,
            						declarations: [declarator],
            						isSynthetic: true
            					};

            					var statement = new Statement(syntheticNode, _this7, start, end);
            					statements.push(statement);
            				});

            				lastChar = node.end; // TODO account for trailing line comment
            			} else {
            					var comment = undefined;
            					do {
            						comment = _this7.comments[commentIndex];
            						if (!comment) break;
            						if (comment.start > node.start) break;
            						commentIndex += 1;
            					} while (comment.end < lastChar);

            					var start = comment ? Math.min(comment.start, node.start) : node.start;
            					var end = node.end; // TODO account for trailing line comment

            					var statement = new Statement(node, _this7, start, end);
            					statements.push(statement);

            					lastChar = end;
            				}
            		});

            		var i = statements.length;
            		var next = this.code.length;
            		while (i--) {
            			statements[i].next = next;
            			if (!statements[i].isSynthetic) next = statements[i].start;
            		}

            		return statements;
            	};

            	Module.prototype.render = function render(es6) {
            		var _this8 = this;

            		var magicString = this.magicString.clone();

            		this.statements.forEach(function (statement) {
            			if (!statement.isIncluded) {
            				magicString.remove(statement.start, statement.next);
            				return;
            			}

            			statement.stringLiteralRanges.forEach(function (range) {
            				return magicString.indentExclusionRanges.push(range);
            			});

            			// skip `export { foo, bar, baz }`
            			if (statement.node.type === 'ExportNamedDeclaration') {
            				if (statement.node.isSynthetic) return;

            				// skip `export { foo, bar, baz }`
            				if (statement.node.specifiers.length) {
            					magicString.remove(statement.start, statement.next);
            					return;
            				}
            			}

            			// split up/remove var declarations as necessary
            			if (statement.node.type === 'VariableDeclaration') {
            				var declarator = statement.node.declarations[0];

            				if (declarator.id.type === 'Identifier') {
            					var declaration = _this8.declarations[declarator.id.name];

            					if (declaration.exportName && declaration.isReassigned) {
            						// `var foo = ...` becomes `exports.foo = ...`
            						if (declarator.init) {
            							magicString.overwrite(statement.start, declarator.init.start, 'exports.' + declaration.exportName + ' = ');
            						} else {
            							magicString.remove(statement.start, declarator.init ? declarator.start : statement.next);
            						}

            						return;
            					}
            				} else {
            					// we handle destructuring differently, because whereas we can rewrite
            					// `var foo = ...` as `exports.foo = ...`, in a case like `var { a, b } = c()`
            					// where `a` or `b` is exported and reassigned, we have to append
            					// `exports.a = a;` and `exports.b = b` instead
            					extractNames(declarator.id).forEach(function (name) {
            						var declaration = _this8.declarations[name];

            						if (declaration.exportName && declaration.isReassigned) {
            							magicString.insert(statement.end, ';\nexports.' + name + ' = ' + declaration.render(es6));
            						}
            					});
            				}

            				if (statement.node.isSynthetic) {
            					// insert `var/let/const` if necessary
            					magicString.insert(statement.start, statement.node.kind + ' ');
            					magicString.overwrite(statement.end, statement.next, ';\n'); // TODO account for trailing newlines
            				}
            			}

            			var toDeshadow = blank();

            			statement.references.forEach(function (reference) {
            				var start = reference.start;
            				var end = reference.end;

            				if (reference.isUndefined) {
            					magicString.overwrite(start, end, 'undefined', true);
            				}

            				var declaration = reference.declaration;

            				if (declaration) {
            					var _name = declaration.render(es6);

            					// the second part of this check is necessary because of
            					// namespace optimisation – name of `foo.bar` could be `bar`
            					if (reference.name === _name && _name.length === end - start) return;

            					reference.rewritten = true;

            					// prevent local variables from shadowing renamed references
            					var identifier = _name.match(/[^\.]+/)[0];
            					if (reference.scope.contains(identifier)) {
            						toDeshadow[identifier] = identifier + '$$'; // TODO more robust mechanism
            					}

            					if (reference.isShorthandProperty) {
            						magicString.insert(end, ': ' + _name);
            					} else {
            						magicString.overwrite(start, end, _name, true);
            					}
            				}
            			});

            			if (keys(toDeshadow).length) {
            				statement.references.forEach(function (reference) {
            					if (!reference.rewritten && reference.name in toDeshadow) {
            						var replacement = toDeshadow[reference.name];
            						magicString.overwrite(reference.start, reference.end, reference.isShorthandProperty ? reference.name + ': ' + replacement : replacement, true);
            					}
            				});
            			}

            			// modify exports as necessary
            			if (statement.isExportDeclaration) {
            				// remove `export` from `export var foo = 42`
            				// TODO: can we do something simpler here?
            				// we just want to remove `export`, right?
            				if (statement.node.type === 'ExportNamedDeclaration' && statement.node.declaration.type === 'VariableDeclaration') {
            					var _name2 = extractNames(statement.node.declaration.declarations[0].id)[0];
            					var declaration = _this8.declarations[_name2];

            					if (!declaration) throw new Error('Missing declaration for ' + _name2 + '!');

            					var end = declaration.exportName && declaration.isReassigned ? statement.node.declaration.declarations[0].start : statement.node.declaration.start;

            					magicString.remove(statement.node.start, end);
            				} else if (statement.node.type === 'ExportAllDeclaration') {
            					// TODO: remove once `export * from 'external'` is supported.
            					magicString.remove(statement.start, statement.next);
            				}

            				// remove `export` from `export class Foo {...}` or `export default Foo`
            				// TODO default exports need different treatment
            				else if (statement.node.declaration.id) {
            						magicString.remove(statement.node.start, statement.node.declaration.start);
            					} else if (statement.node.type === 'ExportDefaultDeclaration') {
            						var defaultDeclaration = _this8.declarations.default;

            						// prevent `var foo = foo`
            						if (defaultDeclaration.original && !defaultDeclaration.original.isReassigned) {
            							magicString.remove(statement.start, statement.next);
            							return;
            						}

            						var defaultName = defaultDeclaration.render();

            						// prevent `var undefined = sideEffectyDefault(foo)`
            						if (!defaultDeclaration.exportName && !defaultDeclaration.isUsed) {
            							magicString.remove(statement.start, statement.node.declaration.start);
            							return;
            						}

            						// anonymous functions should be converted into declarations
            						if (statement.node.declaration.type === 'FunctionExpression') {
            							magicString.overwrite(statement.node.start, statement.node.declaration.start + 8, 'function ' + defaultName);
            						} else {
            							magicString.overwrite(statement.node.start, statement.node.declaration.start, 'var ' + defaultName + ' = ');
            						}
            					} else {
            						throw new Error('Unhandled export');
            					}
            			}
            		});

            		// add namespace block if necessary
            		var namespace = this.declarations['*'];
            		if (namespace && namespace.needsNamespaceBlock) {
            			magicString.append('\n\n' + namespace.renderBlock(magicString.getIndentString()));
            		}

            		return magicString.trim();
            	};

            	Module.prototype.run = function run() {
            		var _this9 = this;

            		var marked = false;

            		this.statements.forEach(function (statement) {
            			marked = statement.run(_this9.strongDependencies) || marked;
            		});

            		return marked;
            	};

            	Module.prototype.trace = function trace(name) {
            		if (name in this.declarations) return this.declarations[name];
            		if (name in this.imports) {
            			var importDeclaration = this.imports[name];
            			var otherModule = importDeclaration.module;

            			if (importDeclaration.name === '*' && !otherModule.isExternal) {
            				return otherModule.namespace();
            			}

            			var declaration = otherModule.traceExport(importDeclaration.name);

            			if (!declaration) throw new Error('Module ' + otherModule.id + ' does not export ' + importDeclaration.name + ' (imported by ' + this.id + ')');
            			return declaration;
            		}

            		return null;
            	};

            	Module.prototype.traceExport = function traceExport(name) {
            		// export { foo } from './other.js'
            		var reexportDeclaration = this.reexports[name];
            		if (reexportDeclaration) {
            			var declaration = reexportDeclaration.module.traceExport(reexportDeclaration.localName);

            			if (!declaration) {
            				var err = new Error('\'' + reexportDeclaration.localName + '\' is not exported by \'' + reexportDeclaration.module.id + '\' (imported by \'' + this.id + '\')');
            				err.file = this.id;
            				err.loc = getLocation(this.code, reexportDeclaration.start);
            				throw err;
            			}

            			return declaration;
            		}

            		var exportDeclaration = this.exports[name];
            		if (exportDeclaration) {
            			var _name3 = exportDeclaration.localName;
            			var declaration = this.trace(_name3);

            			if (declaration) return declaration;

            			this.bundle.assumedGlobals[_name3] = true;
            			return this.declarations[_name3] = new SyntheticGlobalDeclaration(_name3);
            		}

            		for (var i = 0; i < this.exportAllModules.length; i += 1) {
            			var _module = this.exportAllModules[i];
            			var declaration = _module.traceExport(name);

            			if (declaration) return declaration;
            		}
            	};

            	return Module;
            })();

            var ExternalModule = (function () {
            	function ExternalModule(id) {
            		babelHelpers.classCallCheck(this, ExternalModule);

            		this.id = id;
            		this.name = makeLegalIdentifier(id);

            		this.nameSuggestions = blank();
            		this.mostCommonSuggestion = 0;

            		this.isExternal = true;
            		this.declarations = blank();

            		this.exportsNames = false;
            	}

            	ExternalModule.prototype.suggestName = function suggestName(name) {
            		if (!this.nameSuggestions[name]) this.nameSuggestions[name] = 0;
            		this.nameSuggestions[name] += 1;

            		if (this.nameSuggestions[name] > this.mostCommonSuggestion) {
            			this.mostCommonSuggestion = this.nameSuggestions[name];
            			this.name = name;
            		}
            	};

            	ExternalModule.prototype.traceExport = function traceExport(name) {
            		if (name !== 'default' && name !== '*') {
            			this.exportsNames = true;
            		}

            		return this.declarations[name] || (this.declarations[name] = new ExternalDeclaration(this, name));
            	};

            	return ExternalModule;
            })();

            function getName(x) {
            	return x.name;
            }

            function quoteId(x) {
            	return "'" + x.id + "'";
            }

            function req(x) {
            	return "require('" + x.id + "')";
            }

            function getInteropBlock(bundle) {
            	return bundle.externalModules.map(function (module) {
            		return module.declarations.default ? module.exportsNames ? 'var ' + module.name + '__default = \'default\' in ' + module.name + ' ? ' + module.name + '[\'default\'] : ' + module.name + ';' : module.name + ' = \'default\' in ' + module.name + ' ? ' + module.name + '[\'default\'] : ' + module.name + ';' : null;
            	}).filter(Boolean).join('\n');
            }

            function getExportBlock(entryModule, exportMode) {
            	var mechanism = arguments.length <= 2 || arguments[2] === undefined ? 'return' : arguments[2];

            	if (exportMode === 'default') {
            		return mechanism + ' ' + entryModule.traceExport('default').render(false) + ';';
            	}

            	return entryModule.getExports().map(function (name) {
            		var prop = name === 'default' ? '[\'default\']' : '.' + name;
            		var declaration = entryModule.traceExport(name);

            		var lhs = 'exports' + prop;
            		var rhs = declaration.render(false);

            		// prevent `exports.count = exports.count`
            		if (lhs === rhs) return null;

            		return lhs + ' = ' + rhs + ';';
            	}).filter(Boolean).join('\n');
            }

            function getGlobalNameMaker(globals, onwarn) {
            	var fn = typeof globals === 'function' ? globals : function (id) {
            		return globals[id];
            	};

            	return function (module) {
            		var name = fn(module.id);
            		if (name) return name;

            		onwarn('No name was provided for external module \'' + module.id + '\' in options.globals – guessing \'' + module.name + '\'');
            		return module.name;
            	};
            }

            function setupNamespace$1(name) {
            	var parts = name.split('.');
            	parts.pop();

            	var acc = 'global';
            	return parts.map(function (part) {
            		return acc += '.' + part, acc + ' = ' + acc + ' || {}';
            	}).concat('global.' + name).join(', ');
            }
            function umd(bundle, magicString, _ref, options) {
            	var exportMode = _ref.exportMode;
            	var indentString = _ref.indentString;

            	if (exportMode !== 'none' && !options.moduleName) {
            		throw new Error('You must supply options.moduleName for UMD bundles');
            	}

            	var globalNameMaker = getGlobalNameMaker(options.globals || blank(), bundle.onwarn);

            	var amdDeps = bundle.externalModules.map(quoteId);
            	var cjsDeps = bundle.externalModules.map(req);
            	var globalDeps = bundle.externalModules.map(function (module) {
            		return 'global.' + globalNameMaker(module);
            	});

            	var args = bundle.externalModules.map(getName);

            	if (exportMode === 'named') {
            		amdDeps.unshift('\'exports\'');
            		cjsDeps.unshift('exports');
            		globalDeps.unshift('(' + setupNamespace$1(options.moduleName) + ' = global.' + options.moduleName + ' || {})');

            		args.unshift('exports');
            	}

            	var amdParams = (options.moduleId ? '\'' + options.moduleId + '\', ' : '') + (amdDeps.length ? '[' + amdDeps.join(', ') + '], ' : '');

            	var cjsExport = exportMode === 'default' ? 'module.exports = ' : '';
            	var defaultExport = exportMode === 'default' ? setupNamespace$1(options.moduleName) + ' = ' : '';

            	var useStrict = options.useStrict !== false ? ' \'use strict\';' : '';

            	var intro = ('(function (global, factory) {\n\t\t\ttypeof exports === \'object\' && typeof module !== \'undefined\' ? ' + cjsExport + 'factory(' + cjsDeps.join(', ') + ') :\n\t\t\ttypeof define === \'function\' && define.amd ? define(' + amdParams + 'factory) :\n\t\t\t(' + defaultExport + 'factory(' + globalDeps + '));\n\t\t}(this, function (' + args + ') {' + useStrict + '\n\n\t\t').replace(/^\t\t/gm, '').replace(/^\t/gm, magicString.getIndentString());

            	// var foo__default = 'default' in foo ? foo['default'] : foo;
            	var interopBlock = getInteropBlock(bundle);
            	if (interopBlock) magicString.prepend(interopBlock + '\n\n');

            	var exportBlock = getExportBlock(bundle.entryModule, exportMode);
            	if (exportBlock) magicString.append('\n\n' + exportBlock);

            	return magicString.trim().indent(indentString).append('\n\n}));').prepend(intro);
            }

            function setupNamespace(keypath) {
            	var parts = keypath.split('.'); // TODO support e.g. `foo['something-hyphenated']`?

            	parts.pop();

            	var acc = 'this';

            	return parts.map(function (part) {
            		return acc += '.' + part, acc + ' = ' + acc + ' || {};';
            	}).join('\n') + '\n';
            }
            function iife(bundle, magicString, _ref, options) {
            	var exportMode = _ref.exportMode;
            	var indentString = _ref.indentString;

            	var globalNameMaker = getGlobalNameMaker(options.globals || blank(), bundle.onwarn);

            	var name = options.moduleName;
            	var isNamespaced = name && ~name.indexOf('.');

            	var dependencies = bundle.externalModules.map(globalNameMaker);

            	var args = bundle.externalModules.map(getName);

            	if (exportMode !== 'none' && !name) {
            		throw new Error('You must supply options.moduleName for IIFE bundles');
            	}

            	if (exportMode === 'named') {
            		dependencies.unshift('(this.' + name + ' = this.' + name + ' || {})');
            		args.unshift('exports');
            	}

            	var useStrict = options.useStrict !== false ? '\'use strict\';' : '';

            	var intro = '(function (' + args + ') {\n';
            	var outro = '\n\n}(' + dependencies + '));';

            	if (exportMode === 'default') {
            		intro = (isNamespaced ? 'this.' : 'var ') + (name + ' = ' + intro);
            	}

            	if (isNamespaced) {
            		intro = setupNamespace(name) + intro;
            	}

            	// var foo__default = 'default' in foo ? foo['default'] : foo;
            	var interopBlock = getInteropBlock(bundle);
            	if (interopBlock) magicString.prepend(interopBlock + '\n\n');
            	if (useStrict) magicString.prepend(useStrict + '\n\n');
            	var exportBlock = getExportBlock(bundle.entryModule, exportMode);
            	if (exportBlock) magicString.append('\n\n' + exportBlock);

            	return magicString.indent(indentString).prepend(intro).append(outro);
            }

            function notDefault(name) {
            	return name !== 'default';
            }
            function es6(bundle, magicString) {
            	var importBlock = bundle.externalModules.map(function (module) {
            		var specifiers = [];
            		var specifiersList = [specifiers];
            		var importedNames = keys(module.declarations).filter(function (name) {
            			return name !== '*' && name !== 'default';
            		});

            		if (module.declarations.default) {
            			specifiers.push(module.name);
            		}

            		var namespaceSpecifier = module.declarations['*'] ? '* as ' + module.name : null;
            		var namedSpecifier = importedNames.length ? '{ ' + importedNames.join(', ') + ' }' : null;

            		if (namespaceSpecifier && namedSpecifier) {
            			// Namespace and named specifiers cannot be combined.
            			specifiersList.push([namespaceSpecifier]);
            			specifiers.push(namedSpecifier);
            		} else if (namedSpecifier) {
            			specifiers.push(namedSpecifier);
            		} else if (namespaceSpecifier) {
            			specifiers.push(namespaceSpecifier);
            		}

            		return specifiersList.map(function (specifiers) {
            			return specifiers.length ? 'import ' + specifiers.join(', ') + ' from \'' + module.id + '\';' : 'import \'' + module.id + '\';';
            		}).join('\n');
            	}).join('\n');

            	if (importBlock) {
            		magicString.prepend(importBlock + '\n\n');
            	}

            	var module = bundle.entryModule;

            	var specifiers = module.getExports().filter(notDefault).map(function (name) {
            		var declaration = module.traceExport(name);
            		var rendered = declaration.render(true);

            		return rendered === name ? name : rendered + ' as ' + name;
            	});

            	var exportBlock = specifiers.length ? 'export { ' + specifiers.join(', ') + ' };' : '';

            	var defaultExport = module.exports.default || module.reexports.default;
            	if (defaultExport) {
            		exportBlock += 'export default ' + module.traceExport('default').render(true) + ';';
            	}

            	if (exportBlock) {
            		magicString.append('\n\n' + exportBlock.trim());
            	}

            	return magicString.trim();
            }

            function cjs(bundle, magicString, _ref, options) {
            	var exportMode = _ref.exportMode;

            	var intro = options.useStrict === false ? '' : '\'use strict\';\n\n';

            	var hasDefaultImport = bundle.externalModules.some(function (mod) {
            		return mod.declarations.default;
            	});

            	if (hasDefaultImport) {
            		intro += 'function _interopDefault (ex) { return (ex && (typeof ex === \'object\') && \'default\' in ex) ? ex[\'default\'] : ex; }\n\n';
            	}

            	// TODO handle empty imports, once they're supported
            	var importBlock = bundle.externalModules.map(function (module) {
            		if (module.declarations.default) {
            			if (module.exportsNames) {
            				return 'var ' + module.name + ' = require(\'' + module.id + '\');' + ('\nvar ' + module.name + '__default = _interopDefault(' + module.name + ');');
            			} else {
            				return 'var ' + module.name + ' = _interopDefault(require(\'' + module.id + '\'));';
            			}
            		} else {
            			return 'var ' + module.name + ' = require(\'' + module.id + '\');';
            		}
            	}).join('\n');

            	if (importBlock) {
            		intro += importBlock + '\n\n';
            	}

            	magicString.prepend(intro);

            	var exportBlock = getExportBlock(bundle.entryModule, exportMode, 'module.exports =');
            	if (exportBlock) magicString.append('\n\n' + exportBlock);

            	return magicString;
            }

            function amd(bundle, magicString, _ref, options) {
            	var exportMode = _ref.exportMode;
            	var indentString = _ref.indentString;

            	var deps = bundle.externalModules.map(quoteId);
            	var args = bundle.externalModules.map(getName);

            	if (exportMode === 'named') {
            		args.unshift('exports');
            		deps.unshift('\'exports\'');
            	}

            	var params = (options.moduleId ? '\'' + options.moduleId + '\', ' : '') + (deps.length ? '[' + deps.join(', ') + '], ' : '');

            	var useStrict = options.useStrict !== false ? ' \'use strict\';' : '';
            	var intro = 'define(' + params + 'function (' + args.join(', ') + ') {' + useStrict + '\n\n';

            	// var foo__default = 'default' in foo ? foo['default'] : foo;
            	var interopBlock = getInteropBlock(bundle);
            	if (interopBlock) magicString.prepend(interopBlock + '\n\n');

            	var exportBlock = getExportBlock(bundle.entryModule, exportMode);
            	if (exportBlock) magicString.append('\n\n' + exportBlock);

            	return magicString.indent(indentString).append('\n\n});').prepend(intro);
            }

            var finalisers = { amd: amd, cjs: cjs, es6: es6, iife: iife, umd: umd };

            function ensureArray(thing) {
            	if (Array.isArray(thing)) return thing;
            	if (thing == undefined) return [];
            	return [thing];
            }

            function load(id) {
            	return readFileSync(id, 'utf-8');
            }

            function addJsExtensionIfNecessary(file) {
            	if (isFile(file)) return file;

            	file += '.js';
            	if (isFile(file)) return file;

            	return null;
            }

            function resolveId(importee, importer) {
            	if (typeof process === 'undefined') throw new Error('It looks like you\'re using Rollup in a non-Node.js environment. This means you must supply a plugin with custom resolveId and load functions. See https://github.com/rollup/rollup/wiki/Plugins for more information');

            	// absolute paths are left untouched
            	if (isAbsolute(importee)) return addJsExtensionIfNecessary(importee);

            	// if this is the entry point, resolve against cwd
            	if (importer === undefined) return addJsExtensionIfNecessary(resolve(process.cwd(), importee));

            	// external modules are skipped at this stage
            	if (importee[0] !== '.') return null;

            	return addJsExtensionIfNecessary(resolve(dirname(importer), importee));
            }

            function makeOnwarn() {
            	var warned = blank();

            	return function (msg) {
            		if (msg in warned) return;
            		console.error(msg); //eslint-disable-line no-console
            		warned[msg] = true;
            	};
            }

            function badExports(option, keys) {
            	throw new Error('\'' + option + '\' was specified for options.exports, but entry module has following exports: ' + keys.join(', '));
            }
            function getExportMode(bundle, exportMode) {
            	var exportKeys = keys(bundle.entryModule.exports).concat(keys(bundle.entryModule.reexports)).concat(bundle.entryModule.exportAllSources); // not keys, but makes our job easier this way

            	if (exportMode === 'default') {
            		if (exportKeys.length !== 1 || exportKeys[0] !== 'default') {
            			badExports('default', exportKeys);
            		}
            	} else if (exportMode === 'none' && exportKeys.length) {
            		badExports('none', exportKeys);
            	}

            	if (!exportMode || exportMode === 'auto') {
            		if (exportKeys.length === 0) {
            			exportMode = 'none';
            		} else if (exportKeys.length === 1 && exportKeys[0] === 'default') {
            			exportMode = 'default';
            		} else {
            			exportMode = 'named';
            		}
            	}

            	if (!/(?:default|named|none)/.test(exportMode)) {
            		throw new Error('options.exports must be \'default\', \'named\', \'none\', \'auto\', or left unspecified (defaults to \'auto\')');
            	}

            	return exportMode;
            }

            function getIndentString(magicString, options) {
            	if (!('indent' in options) || options.indent === true) {
            		return magicString.getIndentString();
            	}

            	return options.indent || '';
            }

            function unixizePath(path) {
            	return path.split(/[\/\\]/).join('/');
            }

            function mapSequence(array, fn) {
            	var results = [];
            	var promise = Promise.resolve();

            	function next(member, i) {
            		return fn(member).then(function (value) {
            			return results[i] = value;
            		});
            	}

            	var _loop = function (i) {
            		promise = promise.then(function () {
            			return next(array[i], i);
            		});
            	};

            	for (var i = 0; i < array.length; i += 1) {
            		_loop(i);
            	}

            	return promise.then(function () {
            		return results;
            	});
            }

            function transform(source, id, transformers) {
            	var sourceMapChain = [];

            	if (typeof source === 'string') {
            		source = {
            			code: source,
            			ast: null
            		};
            	}

            	var originalCode = source.code;
            	var ast = source.ast;

            	return transformers.reduce(function (promise, transformer) {
            		return promise.then(function (previous) {
            			return Promise.resolve(transformer(previous, id)).then(function (result) {
            				if (result == null) return previous;

            				if (typeof result === 'string') {
            					result = {
            						code: result,
            						ast: null,
            						map: null
            					};
            				}
            				// `result.map` can only be a string if `result` isn't
            				else if (typeof result.map === 'string') {
            						result.map = JSON.parse(result.map);
            					}

            				sourceMapChain.push(result.map);
            				ast = result.ast;

            				return result.code;
            			});
            		});
            	}, Promise.resolve(source.code)).then(function (code) {
            		return { code: code, originalCode: originalCode, ast: ast, sourceMapChain: sourceMapChain };
            	});
            }

            function transformBundle(code, transformers, sourceMapChain) {
            	return transformers.reduce(function (code, transformer) {
            		var result = transformer(code);

            		if (result == null) return code;

            		if (typeof result === 'string') {
            			result = {
            				code: result,
            				map: null
            			};
            		}

            		var map = typeof result.map === 'string' ? JSON.parse(result.map) : map;
            		sourceMapChain.push(map);

            		return result.code;
            	}, code);
            }

            var charToInteger = {};
            var integerToChar = {};

            'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/='.split( '' ).forEach( function ( char, i ) {
            	charToInteger[ char ] = i;
            	integerToChar[ i ] = char;
            });

            function decode$1 ( string ) {
            	var result = [],
            		len = string.length,
            		i,
            		hasContinuationBit,
            		shift = 0,
            		value = 0,
            		integer,
            		shouldNegate;

            	for ( i = 0; i < len; i += 1 ) {
            		integer = charToInteger[ string[i] ];

            		if ( integer === undefined ) {
            			throw new Error( 'Invalid character (' + string[i] + ')' );
            		}

            		hasContinuationBit = integer & 32;

            		integer &= 31;
            		value += integer << shift;

            		if ( hasContinuationBit ) {
            			shift += 5;
            		} else {
            			shouldNegate = value & 1;
            			value >>= 1;

            			result.push( shouldNegate ? -value : value );

            			// reset
            			value = shift = 0;
            		}
            	}

            	return result;
            }

            function encode$1 ( value ) {
            	var result, i;

            	if ( typeof value === 'number' ) {
            		result = encodeInteger( value );
            	} else {
            		result = '';
            		for ( i = 0; i < value.length; i += 1 ) {
            			result += encodeInteger( value[i] );
            		}
            	}

            	return result;
            }

            function encodeInteger ( num ) {
            	var result = '', clamped;

            	if ( num < 0 ) {
            		num = ( -num << 1 ) | 1;
            	} else {
            		num <<= 1;
            	}

            	do {
            		clamped = num & 31;
            		num >>= 5;

            		if ( num > 0 ) {
            			clamped |= 32;
            		}

            		result += integerToChar[ clamped ];
            	} while ( num > 0 );

            	return result;
            }

            function decodeSegments(encodedSegments) {
            	var i = encodedSegments.length;
            	var segments = new Array(i);

            	while (i--) {
            		segments[i] = decode$1(encodedSegments[i]);
            	}return segments;
            }

            function decode(mappings) {
            	var sourceFileIndex = 0; // second field
            	var sourceCodeLine = 0; // third field
            	var sourceCodeColumn = 0; // fourth field
            	var nameIndex = 0; // fifth field

            	var lines = mappings.split(';');
            	var numLines = lines.length;
            	var decoded = new Array(numLines);

            	var i = undefined;
            	var j = undefined;
            	var line = undefined;
            	var generatedCodeColumn = undefined;
            	var decodedLine = undefined;
            	var segments = undefined;
            	var segment = undefined;
            	var result = undefined;

            	for (i = 0; i < numLines; i += 1) {
            		line = lines[i];

            		generatedCodeColumn = 0; // first field - reset each time
            		decodedLine = [];

            		segments = decodeSegments(line.split(','));

            		for (j = 0; j < segments.length; j += 1) {
            			segment = segments[j];

            			if (!segment.length) {
            				break;
            			}

            			generatedCodeColumn += segment[0];

            			result = [generatedCodeColumn];
            			decodedLine.push(result);

            			if (segment.length === 1) {
            				// only one field!
            				continue;
            			}

            			sourceFileIndex += segment[1];
            			sourceCodeLine += segment[2];
            			sourceCodeColumn += segment[3];

            			result.push(sourceFileIndex, sourceCodeLine, sourceCodeColumn);

            			if (segment.length === 5) {
            				nameIndex += segment[4];
            				result.push(nameIndex);
            			}
            		}

            		decoded[i] = decodedLine;
            	}

            	return decoded;
            }

            function encode(decoded) {
            	var offsets = {
            		generatedCodeColumn: 0,
            		sourceFileIndex: 0, // second field
            		sourceCodeLine: 0, // third field
            		sourceCodeColumn: 0, // fourth field
            		nameIndex: 0 // fifth field
            	};

            	return decoded.map(function (line) {
            		offsets.generatedCodeColumn = 0; // first field - reset each time
            		return line.map(encodeSegment).join(',');
            	}).join(';');

            	function encodeSegment(segment) {
            		if (!segment.length) {
            			return segment;
            		}

            		var result = new Array(segment.length);

            		result[0] = segment[0] - offsets.generatedCodeColumn;
            		offsets.generatedCodeColumn = segment[0];

            		if (segment.length === 1) {
            			// only one field!
            			return encode$1(result);
            		}

            		result[1] = segment[1] - offsets.sourceFileIndex;
            		result[2] = segment[2] - offsets.sourceCodeLine;
            		result[3] = segment[3] - offsets.sourceCodeColumn;

            		offsets.sourceFileIndex = segment[1];
            		offsets.sourceCodeLine = segment[2];
            		offsets.sourceCodeColumn = segment[3];

            		if (segment.length === 5) {
            			result[4] = segment[4] - offsets.nameIndex;
            			offsets.nameIndex = segment[4];
            		}

            		return encode$1(result);
            	}
            }

            function Source(index) {
            	this.isOriginal = true;
            	this.index = index;
            }

            Source.prototype = {
            	traceSegment: function (line, column, name) {
            		return { line: line, column: column, name: name, index: this.index };
            	}
            };

            function Link(map, sources) {
            	if (!map) throw new Error('Cannot generate a sourcemap if non-sourcemap-generating transformers are used');

            	this.sources = sources;
            	this.names = map.names;
            	this.mappings = decode(map.mappings);
            }

            Link.prototype = { // TODO bring into line with others post-https://github.com/rollup/rollup/pull/386
            	traceMappings: function () {
            		var _this = this;

            		var names = [];

            		var mappings = this.mappings.map(function (line) {
            			var tracedLine = [];

            			line.forEach(function (segment) {
            				var source = _this.sources[segment[1]];
            				var traced = source.traceSegment(segment[2], segment[3], _this.names[segment[4]]);

            				if (traced) {
            					var nameIndex = null;
            					segment = [segment[0], traced.index, traced.line, traced.column];

            					if (traced.name) {
            						nameIndex = names.indexOf(traced.name);
            						if (nameIndex === -1) {
            							nameIndex = names.length;
            							names.push(traced.name);
            						}

            						segment[4] = nameIndex;
            					}

            					tracedLine.push(segment);
            				}
            			});

            			return tracedLine;
            		});

            		return { names: names, mappings: mappings };
            	},

            	traceSegment: function (line, column, name) {
            		var segments = this.mappings[line];

            		if (!segments) return null;

            		for (var i = 0; i < segments.length; i += 1) {
            			var segment = segments[i];

            			if (segment[0] > column) return null;

            			if (segment[0] === column) {
            				var source = this.sources[segment[1]];

            				if (!source) throw new Error('Bad sourcemap');

            				return source.traceSegment(segment[2], segment[3], this.names[segment[4]] || name);
            			}
            		}

            		return null;
            	}
            };
            function collapseSourcemaps(map, modules, bundleSourcemapChain) {
            	var sources = modules.map(function (module, i) {
            		var source = new Source(i);

            		module.sourceMapChain.forEach(function (map) {
            			source = new Link(map, [source]);
            		});

            		return source;
            	});

            	var source = new Link(map, sources);

            	bundleSourcemapChain.forEach(function (map) {
            		source = new Link(map, [source]);
            	});

            	var _source$traceMappings = source.traceMappings();

            	var names = _source$traceMappings.names;
            	var mappings = _source$traceMappings.mappings;

            	// we re-use the `map` object because it has convenient toString/toURL methods
            	map.sourcesContent = modules.map(function (module) {
            		return module.originalCode;
            	});
            	map.mappings = encode(mappings);
            	map.names = names;

            	return map;
            }

            function callIfFunction(thing) {
            	return typeof thing === 'function' ? thing() : thing;
            }

            var Bundle = (function () {
            	function Bundle(options) {
            		var _this = this;

            		babelHelpers.classCallCheck(this, Bundle);

            		this.plugins = ensureArray(options.plugins);

            		this.plugins.forEach(function (plugin) {
            			if (plugin.options) {
            				options = plugin.options(options) || options;
            			}
            		});

            		this.entry = options.entry;
            		this.entryModule = null;

            		this.resolveId = first([function (id) {
            			return ~_this.external.indexOf(id) ? false : null;
            		}].concat(this.plugins.map(function (plugin) {
            			return plugin.resolveId;
            		}).filter(Boolean)).concat(resolveId));

            		this.load = first(this.plugins.map(function (plugin) {
            			return plugin.load;
            		}).filter(Boolean).concat(load));

            		this.transformers = this.plugins.map(function (plugin) {
            			return plugin.transform;
            		}).filter(Boolean);

            		this.bundleTransformers = this.plugins.map(function (plugin) {
            			return plugin.transformBundle;
            		}).filter(Boolean);

            		this.moduleById = blank();
            		this.modules = [];

            		this.externalModules = [];
            		this.internalNamespaces = [];

            		this.assumedGlobals = blank();

            		this.external = ensureArray(options.external).map(function (id) {
            			return id.replace(/[\/\\]/g, '/');
            		});
            		this.onwarn = options.onwarn || makeOnwarn();

            		// TODO strictly speaking, this only applies with non-ES6, non-default-only bundles
            		['module', 'exports', '_interopDefault'].forEach(function (global) {
            			return _this.assumedGlobals[global] = true;
            		});
            	}

            	Bundle.prototype.build = function build() {
            		var _this2 = this;

            		// Phase 1 – discovery. We load the entry module and find which
            		// modules it imports, and import those, until we have all
            		// of the entry module's dependencies
            		return this.resolveId(this.entry, undefined).then(function (id) {
            			return _this2.fetchModule(id, undefined);
            		}).then(function (entryModule) {
            			_this2.entryModule = entryModule;

            			// Phase 2 – binding. We link references to their declarations
            			// to generate a complete picture of the bundle
            			_this2.modules.forEach(function (module) {
            				return module.bindImportSpecifiers();
            			});
            			_this2.modules.forEach(function (module) {
            				return module.bindAliases();
            			});
            			_this2.modules.forEach(function (module) {
            				return module.bindReferences();
            			});

            			// Phase 3 – marking. We 'run' each statement to see which ones
            			// need to be included in the generated bundle

            			// mark all export statements
            			entryModule.getExports().forEach(function (name) {
            				var declaration = entryModule.traceExport(name);
            				declaration.exportName = name;

            				declaration.use();
            			});

            			// mark statements that should appear in the bundle
            			var settled = false;
            			while (!settled) {
            				settled = true;

            				_this2.modules.forEach(function (module) {
            					if (module.run()) settled = false;
            				});
            			}

            			// Phase 4 – final preparation. We order the modules with an
            			// enhanced topological sort that accounts for cycles, then
            			// ensure that names are deconflicted throughout the bundle
            			_this2.orderedModules = _this2.sort();
            			_this2.deconflict();
            		});
            	};

            	Bundle.prototype.deconflict = function deconflict() {
            		var used = blank();

            		// ensure no conflicts with globals
            		keys(this.assumedGlobals).forEach(function (name) {
            			return used[name] = 1;
            		});

            		function getSafeName(name) {
            			while (used[name]) {
            				name += '$' + used[name]++;
            			}

            			used[name] = 1;
            			return name;
            		}

            		this.externalModules.forEach(function (module) {
            			module.name = getSafeName(module.name);

            			// ensure we don't shadow named external imports, if
            			// we're creating an ES6 bundle
            			forOwn(module.declarations, function (declaration, name) {
            				declaration.setSafeName(getSafeName(name));
            			});
            		});

            		this.modules.forEach(function (module) {
            			forOwn(module.declarations, function (declaration, originalName) {
            				if (declaration.isGlobal) return;

            				if (originalName === 'default') {
            					if (declaration.original && !declaration.original.isReassigned) return;
            				}

            				declaration.name = getSafeName(declaration.name);
            			});
            		});
            	};

            	Bundle.prototype.fetchModule = function fetchModule(id, importer) {
            		var _this3 = this;

            		// short-circuit cycles
            		if (id in this.moduleById) return null;
            		this.moduleById[id] = null;

            		return this.load(id).catch(function (err) {
            			var msg = 'Could not load ' + id;
            			if (importer) msg += ' (imported by ' + importer + ')';

            			msg += ': ' + err.message;
            			throw new Error(msg);
            		}).then(function (source) {
            			return transform(source, id, _this3.transformers);
            		}).then(function (source) {
            			var code = source.code;
            			var originalCode = source.originalCode;
            			var ast = source.ast;
            			var sourceMapChain = source.sourceMapChain;

            			var module = new Module({ id: id, code: code, originalCode: originalCode, ast: ast, sourceMapChain: sourceMapChain, bundle: _this3 });

            			_this3.modules.push(module);
            			_this3.moduleById[id] = module;

            			return _this3.fetchAllDependencies(module).then(function () {
            				return module;
            			});
            		});
            	};

            	Bundle.prototype.fetchAllDependencies = function fetchAllDependencies(module) {
            		var _this4 = this;

            		return mapSequence(module.sources, function (source) {
            			return _this4.resolveId(source, module.id).then(function (resolvedId) {
            				var externalName = undefined;
            				if (resolvedId) {
            					// If the `resolvedId` is supposed to be external, make it so.
            					externalName = resolvedId.replace(/[\/\\]/g, '/');
            				} else if (isRelative(source)) {
            					// This could be an external, relative dependency, based on the current module's parent dir.
            					externalName = resolve(module.id, '..', source);
            				}
            				var forcedExternal = externalName && ~_this4.external.indexOf(externalName);

            				if (!resolvedId || forcedExternal) {
            					if (!forcedExternal) {
            						if (isRelative(source)) throw new Error('Could not resolve ' + source + ' from ' + module.id);
            						if (! ~_this4.external.indexOf(source)) _this4.onwarn('Treating \'' + source + '\' as external dependency');
            					}
            					module.resolvedIds[source] = source;

            					if (!_this4.moduleById[source]) {
            						var _module = new ExternalModule(source);
            						_this4.externalModules.push(_module);
            						_this4.moduleById[source] = _module;
            					}
            				} else {
            					if (resolvedId === module.id) {
            						throw new Error('A module cannot import itself (' + resolvedId + ')');
            					}

            					module.resolvedIds[source] = resolvedId;
            					return _this4.fetchModule(resolvedId, module.id);
            				}
            			});
            		});
            	};

            	Bundle.prototype.render = function render() {
            		var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

            		var format = options.format || 'es6';

            		// Determine export mode - 'default', 'named', 'none'
            		var exportMode = getExportMode(this, options.exports);

            		var magicString = new MagicString.Bundle({ separator: '\n\n' });
            		var usedModules = [];

            		this.orderedModules.forEach(function (module) {
            			var source = module.render(format === 'es6');
            			if (source.toString().length) {
            				magicString.addSource(source);
            				usedModules.push(module);
            			}
            		});

            		var intro = [options.intro].concat(this.plugins.map(function (plugin) {
            			return plugin.intro && plugin.intro();
            		})).filter(Boolean).join('\n\n');

            		if (intro) magicString.prepend(intro + '\n');
            		if (options.outro) magicString.append('\n' + options.outro);

            		var indentString = getIndentString(magicString, options);

            		var finalise = finalisers[format];
            		if (!finalise) throw new Error('You must specify an output type - valid options are ' + keys(finalisers).join(', '));

            		magicString = finalise(this, magicString.trim(), { exportMode: exportMode, indentString: indentString }, options);

            		var banner = [options.banner].concat(this.plugins.map(function (plugin) {
            			return plugin.banner;
            		})).map(callIfFunction).filter(Boolean).join('\n');

            		var footer = [options.footer].concat(this.plugins.map(function (plugin) {
            			return plugin.footer;
            		})).map(callIfFunction).filter(Boolean).join('\n');

            		if (banner) magicString.prepend(banner + '\n');
            		if (footer) magicString.append('\n' + footer);

            		var code = magicString.toString();
            		var map = null;
            		var bundleSourcemapChain = [];

            		code = transformBundle(code, this.bundleTransformers, bundleSourcemapChain).replace(new RegExp('\\/\\/#\\s+' + SOURCEMAPPING_URL$1 + '=.+\\n?', 'g'), '');

            		if (options.sourceMap) {
            			var file = options.sourceMapFile || options.dest;
            			if (file) file = resolve(typeof process !== 'undefined' ? process.cwd() : '', file);

            			map = magicString.generateMap({ file: file, includeContent: true });

            			if (this.transformers.length || this.bundleTransformers.length) {
            				map = collapseSourcemaps(map, usedModules, bundleSourcemapChain);
            			}

            			map.sources = map.sources.map(unixizePath);
            		}

            		return { code: code, map: map };
            	};

            	Bundle.prototype.sort = function sort() {
            		var _this5 = this;

            		var seen = {};
            		var hasCycles = undefined;
            		var ordered = [];

            		var stronglyDependsOn = blank();
            		var dependsOn = blank();

            		this.modules.forEach(function (module) {
            			stronglyDependsOn[module.id] = blank();
            			dependsOn[module.id] = blank();
            		});

            		this.modules.forEach(function (module) {
            			function processStrongDependency(dependency) {
            				if (dependency === module || stronglyDependsOn[module.id][dependency.id]) return;

            				stronglyDependsOn[module.id][dependency.id] = true;
            				dependency.strongDependencies.forEach(processStrongDependency);
            			}

            			function processDependency(dependency) {
            				if (dependency === module || dependsOn[module.id][dependency.id]) return;

            				dependsOn[module.id][dependency.id] = true;
            				dependency.dependencies.forEach(processDependency);
            			}

            			module.strongDependencies.forEach(processStrongDependency);
            			module.dependencies.forEach(processDependency);
            		});

            		var visit = function (module) {
            			if (seen[module.id]) {
            				hasCycles = true;
            				return;
            			}

            			seen[module.id] = true;

            			module.dependencies.forEach(visit);
            			ordered.push(module);
            		};

            		visit(this.entryModule);

            		if (hasCycles) {
            			ordered.forEach(function (a, i) {
            				var _loop = function () {
            					var b = ordered[i];

            					if (stronglyDependsOn[a.id][b.id]) {
            						(function () {
            							// somewhere, there is a module that imports b before a. Because
            							// b imports a, a is placed before b. We need to find the module
            							// in question, so we can provide a useful error message
            							var parent = '[[unknown]]';

            							var findParent = function (module) {
            								if (dependsOn[module.id][a.id] && dependsOn[module.id][b.id]) {
            									parent = module.id;
            								} else {
            									for (var _i = 0; _i < module.dependencies.length; _i += 1) {
            										var dependency = module.dependencies[_i];
            										if (findParent(dependency)) return;
            									}
            								}
            							};

            							findParent(_this5.entryModule);

            							_this5.onwarn('Module ' + a.id + ' may be unable to evaluate without ' + b.id + ', but is included first due to a cyclical dependency. Consider swapping the import statements in ' + parent + ' to ensure correct ordering');
            						})();
            					}
            				};

            				for (i += 1; i < ordered.length; i += 1) {
            					_loop();
            				}
            			});
            		}

            		return ordered;
            	};

            	return Bundle;
            })();

            var VERSION = '0.25.7';

            var ALLOWED_KEYS = ['banner', 'dest', 'entry', 'exports', 'external', 'footer', 'format', 'globals', 'indent', 'intro', 'moduleId', 'moduleName', 'onwarn', 'outro', 'plugins', 'sourceMap'];

            function rollup(options) {
            	if (!options || !options.entry) {
            		return Promise.reject(new Error('You must supply options.entry to rollup'));
            	}

            	if (options.transform || options.load || options.resolveId || options.resolveExternal) {
            		return Promise.reject(new Error('The `transform`, `load`, `resolveId` and `resolveExternal` options are deprecated in favour of a unified plugin API. See https://github.com/rollup/rollup/wiki/Plugins for details'));
            	}

            	var error = validateKeys(options, ALLOWED_KEYS);

            	if (error) {
            		return Promise.reject(error);
            	}

            	var bundle = new Bundle(options);

            	return bundle.build().then(function () {
            		return {
            			imports: bundle.externalModules.map(function (module) {
            				return module.id;
            			}),
            			exports: keys(bundle.entryModule.exports),
            			modules: bundle.orderedModules.map(function (module) {
            				return { id: module.id };
            			}),

            			generate: function (options) {
            				return bundle.render(options);
            			},
            			write: function (options) {
            				if (!options || !options.dest) {
            					throw new Error('You must supply options.dest to bundle.write');
            				}

            				var dest = options.dest;

            				var _bundle$render = bundle.render(options);

            				var code = _bundle$render.code;
            				var map = _bundle$render.map;

            				var promises = [];

            				if (options.sourceMap) {
            					var url = undefined;

            					if (options.sourceMap === 'inline') {
            						url = map.toUrl();
            					} else {
            						url = _basename(dest) + '.map';
            						promises.push(writeFile(dest + '.map', map.toString()));
            					}

            					code += '\n//# ' + SOURCEMAPPING_URL$1 + '=' + url;
            				}

            				promises.push(writeFile(dest, code));
            				return Promise.all(promises);
            			}
            		};
            	});
            }

            exports.rollup = rollup;
            exports.VERSION = VERSION;
            });

            var rollup = rollup.rollup;

            var vlq = __commonjs(function (module, exports, global) {
            (function (global, factory) {
            	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
            	typeof define === 'function' && define.amd ? define(['exports'], factory) :
            	factory((global.vlq = {}))
            }(__commonjs_global, function (exports) { 'use strict';

            	exports.decode = decode;
            	exports.encode = encode;

            	var charToInteger = {};
            	var integerToChar = {};

            	'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/='.split( '' ).forEach( function ( char, i ) {
            		charToInteger[ char ] = i;
            		integerToChar[ i ] = char;
            	});

            	function decode ( string ) {
            		var result = [],
            			len = string.length,
            			i,
            			hasContinuationBit,
            			shift = 0,
            			value = 0,
            			integer,
            			shouldNegate;

            		for ( i = 0; i < len; i += 1 ) {
            			integer = charToInteger[ string[i] ];

            			if ( integer === undefined ) {
            				throw new Error( 'Invalid character (' + string[i] + ')' );
            			}

            			hasContinuationBit = integer & 32;

            			integer &= 31;
            			value += integer << shift;

            			if ( hasContinuationBit ) {
            				shift += 5;
            			} else {
            				shouldNegate = value & 1;
            				value >>= 1;

            				result.push( shouldNegate ? -value : value );

            				// reset
            				value = shift = 0;
            			}
            		}

            		return result;
            	}

            	function encode ( value ) {
            		var result, i;

            		if ( typeof value === 'number' ) {
            			result = encodeInteger( value );
            		} else {
            			result = '';
            			for ( i = 0; i < value.length; i += 1 ) {
            				result += encodeInteger( value[i] );
            			}
            		}

            		return result;
            	}

            	function encodeInteger ( num ) {
            		var result = '', clamped;

            		if ( num < 0 ) {
            			num = ( -num << 1 ) | 1;
            		} else {
            			num <<= 1;
            		}

            		do {
            			clamped = num & 31;
            			num >>= 5;

            			if ( num > 0 ) {
            				clamped |= 32;
            			}

            			result += integerToChar[ clamped ];
            		} while ( num > 0 );

            		return result;
            	}

            }));
            });

            var require$$0$54 = (vlq && typeof vlq === 'object' && 'default' in vlq ? vlq['default'] : vlq);

            var magicString_cjs = __commonjs(function (module) {
            'use strict';

            var vlq = require$$0$54;

            function Patch(start, end, content, original, storeName) {
            	this.start = start;
            	this.end = end;
            	this.content = content;
            	this.original = original;
            	this.storeName = storeName;
            }

            Patch.prototype = {
            	clone: function clone() {
            		return new Patch(this.start, this.end, this.content, this.original, this.storeName);
            	}
            };

            var _btoa = undefined;

            if (typeof window !== 'undefined' && typeof window.btoa === 'function') {
            	_btoa = window.btoa;
            } else if (typeof Buffer === 'function') {
            	/* global Buffer */
            	_btoa = function (str) {
            		return new Buffer(str).toString('base64');
            	};
            } else {
            	throw new Error('Unsupported environment: `window.btoa` or `Buffer` should be supported.');
            }

            var btoa = _btoa;

            function SourceMap(properties) {
            	this.version = 3;

            	this.file = properties.file;
            	this.sources = properties.sources;
            	this.sourcesContent = properties.sourcesContent;
            	this.names = properties.names;
            	this.mappings = properties.mappings;
            }

            SourceMap.prototype = {
            	toString: function toString() {
            		return JSON.stringify(this);
            	},
            	toUrl: function toUrl() {
            		return 'data:application/json;charset=utf-8;base64,' + btoa(this.toString());
            	}
            };

            function guessIndent(code) {
            	var lines = code.split('\n');

            	var tabbed = lines.filter(function (line) {
            		return (/^\t+/.test(line)
            		);
            	});
            	var spaced = lines.filter(function (line) {
            		return (/^ {2,}/.test(line)
            		);
            	});

            	if (tabbed.length === 0 && spaced.length === 0) {
            		return null;
            	}

            	// More lines tabbed than spaced? Assume tabs, and
            	// default to tabs in the case of a tie (or nothing
            	// to go on)
            	if (tabbed.length >= spaced.length) {
            		return '\t';
            	}

            	// Otherwise, we need to guess the multiple
            	var min = spaced.reduce(function (previous, current) {
            		var numSpaces = /^ +/.exec(current)[0].length;
            		return Math.min(numSpaces, previous);
            	}, Infinity);

            	return new Array(min + 1).join(' ');
            }

            function encodeMappings(original, intro, patches, hires, sourcemapLocations, sourceIndex, offsets, names) {
            	var rawLines = [];

            	var generatedCodeLine = intro.split('\n').length - 1;
            	var rawSegments = rawLines[generatedCodeLine] = [];

            	var originalCharIndex = 0;

            	var generatedCodeColumn = 0;
            	var sourceCodeLine = 0;
            	var sourceCodeColumn = 0;

            	function addSegmentsUntil(end) {
            		var first = true;

            		while (originalCharIndex < end) {
            			if (hires || first || sourcemapLocations[originalCharIndex]) {
            				rawSegments.push({
            					generatedCodeLine: generatedCodeLine,
            					generatedCodeColumn: generatedCodeColumn,
            					sourceCodeLine: sourceCodeLine,
            					sourceCodeColumn: sourceCodeColumn,
            					sourceCodeName: -1,
            					sourceIndex: sourceIndex
            				});
            			}

            			if (original[originalCharIndex] === '\n') {
            				sourceCodeLine += 1;
            				sourceCodeColumn = 0;
            				generatedCodeLine += 1;
            				rawLines[generatedCodeLine] = rawSegments = [];
            				generatedCodeColumn = 0;
            			} else {
            				sourceCodeColumn += 1;
            				generatedCodeColumn += 1;
            			}

            			originalCharIndex += 1;
            			first = false;
            		}
            	}

            	for (var i = 0; i < patches.length; i += 1) {
            		var patch = patches[i];
            		var addSegmentForPatch = patch.storeName || patch.start > originalCharIndex;

            		addSegmentsUntil(patch.start);

            		if (addSegmentForPatch) {
            			rawSegments.push({
            				generatedCodeLine: generatedCodeLine,
            				generatedCodeColumn: generatedCodeColumn,
            				sourceCodeLine: sourceCodeLine,
            				sourceCodeColumn: sourceCodeColumn,
            				sourceCodeName: patch.storeName ? names.indexOf(patch.original) : -1,
            				sourceIndex: sourceIndex
            			});
            		}

            		var lines = patch.content.split('\n');
            		var lastLine = lines.pop();

            		if (lines.length) {
            			generatedCodeLine += lines.length;
            			rawLines[generatedCodeLine] = rawSegments = [];
            			generatedCodeColumn = lastLine.length;
            		} else {
            			generatedCodeColumn += lastLine.length;
            		}

            		lines = patch.original.split('\n');
            		lastLine = lines.pop();

            		if (lines.length) {
            			sourceCodeLine += lines.length;
            			sourceCodeColumn = lastLine.length;
            		} else {
            			sourceCodeColumn += lastLine.length;
            		}

            		originalCharIndex = patch.end;
            	}

            	addSegmentsUntil(original.length);

            	offsets.sourceIndex = offsets.sourceIndex || 0;
            	offsets.sourceCodeLine = offsets.sourceCodeLine || 0;
            	offsets.sourceCodeColumn = offsets.sourceCodeColumn || 0;
            	offsets.sourceCodeName = offsets.sourceCodeName || 0;

            	var encoded = rawLines.map(function (segments) {
            		var generatedCodeColumn = 0;

            		return segments.map(function (segment) {
            			var arr = [segment.generatedCodeColumn - generatedCodeColumn, segment.sourceIndex - offsets.sourceIndex, segment.sourceCodeLine - offsets.sourceCodeLine, segment.sourceCodeColumn - offsets.sourceCodeColumn];

            			generatedCodeColumn = segment.generatedCodeColumn;
            			offsets.sourceIndex = segment.sourceIndex;
            			offsets.sourceCodeLine = segment.sourceCodeLine;
            			offsets.sourceCodeColumn = segment.sourceCodeColumn;

            			if (~segment.sourceCodeName) {
            				arr.push(segment.sourceCodeName - offsets.sourceCodeName);
            				offsets.sourceCodeName = segment.sourceCodeName;
            			}

            			return vlq.encode(arr);
            		}).join(',');
            	}).join(';');

            	return encoded;
            }

            function getRelativePath(from, to) {
            	var fromParts = from.split(/[\/\\]/);
            	var toParts = to.split(/[\/\\]/);

            	fromParts.pop(); // get dirname

            	while (fromParts[0] === toParts[0]) {
            		fromParts.shift();
            		toParts.shift();
            	}

            	if (fromParts.length) {
            		var i = fromParts.length;
            		while (i--) {
            			fromParts[i] = '..';
            		}
            	}

            	return fromParts.concat(toParts).join('/');
            }

            var toString = Object.prototype.toString;

            function isObject(thing) {
            	return toString.call(thing) === '[object Object]';
            }

            var warned = false;

            function MagicString(string) {
            	var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

            	Object.defineProperties(this, {
            		original: { writable: true, value: string },
            		outro: { writable: true, value: '' },
            		intro: { writable: true, value: '' },
            		patches: { writable: true, value: [] },
            		filename: { writable: true, value: options.filename },
            		indentExclusionRanges: { writable: true, value: options.indentExclusionRanges },
            		sourcemapLocations: { writable: true, value: {} },
            		storedNames: { writable: true, value: {} },
            		indentStr: { writable: true, value: guessIndent(string) }
            	});
            }

            MagicString.prototype = {
            	addSourcemapLocation: function addSourcemapLocation(char) {
            		this.sourcemapLocations[char] = true;
            	},
            	append: function append(content) {
            		if (typeof content !== 'string') throw new TypeError('outro content must be a string');

            		this.outro += content;
            		return this;
            	},
            	clone: function clone() {
            		var cloned = new MagicString(this.original, { filename: this.filename });

            		cloned.patches = this.patches.map(function (patch) {
            			return patch.clone();
            		});

            		if (this.indentExclusionRanges) {
            			cloned.indentExclusionRanges = typeof this.indentExclusionRanges[0] === 'number' ? [this.indentExclusionRanges[0], this.indentExclusionRanges[1]] : this.indentExclusionRanges.map(function (range) {
            				return [range.start, range.end];
            			});
            		}

            		Object.keys(this.sourcemapLocations).forEach(function (loc) {
            			cloned.sourcemapLocations[loc] = true;
            		});

            		return cloned;
            	},
            	generateMap: function generateMap(options) {
            		options = options || {};

            		var names = Object.keys(this.storedNames);

            		return new SourceMap({
            			file: options.file ? options.file.split(/[\/\\]/).pop() : null,
            			sources: [options.source ? getRelativePath(options.file || '', options.source) : null],
            			sourcesContent: options.includeContent ? [this.original] : [null],
            			names: names,
            			mappings: this.getMappings(options.hires, 0, {}, names)
            		});
            	},
            	getIndentString: function getIndentString() {
            		return this.indentStr === null ? '\t' : this.indentStr;
            	},
            	getMappings: function getMappings(hires, sourceIndex, offsets, names) {
            		return encodeMappings(this.original, this.intro, this.patches, hires, this.sourcemapLocations, sourceIndex, offsets, names);
            	},
            	indent: function indent(indentStr, options) {
            		var _this = this;

            		var pattern = /^[^\r\n]/gm;

            		if (isObject(indentStr)) {
            			options = indentStr;
            			indentStr = undefined;
            		}

            		indentStr = indentStr !== undefined ? indentStr : this.indentStr || '\t';

            		if (indentStr === '') return this; // noop

            		options = options || {};

            		// Process exclusion ranges
            		var isExcluded = {};

            		if (options.exclude) {
            			var exclusions = typeof options.exclude[0] === 'number' ? [options.exclude] : options.exclude;
            			exclusions.forEach(function (exclusion) {
            				for (var i = exclusion[0]; i < exclusion[1]; i += 1) {
            					isExcluded[i] = true;
            				}
            			});
            		}

            		var shouldIndentNextCharacter = options.indentStart !== false;
            		var replacer = function replacer(match) {
            			if (shouldIndentNextCharacter) return '' + indentStr + match;
            			shouldIndentNextCharacter = true;
            			return match;
            		};

            		this.intro = this.intro.replace(pattern, replacer);

            		var charIndex = 0;
            		var patchIndex = 0;

            		var indentUntil = function indentUntil(end) {
            			while (charIndex < end) {
            				if (!isExcluded[charIndex]) {
            					var char = _this.original[charIndex];

            					if (char === '\n') {
            						shouldIndentNextCharacter = true;
            					} else if (char !== '\r' && shouldIndentNextCharacter) {
            						_this.patches.splice(patchIndex, 0, new Patch(charIndex, charIndex, indentStr, '', false));
            						shouldIndentNextCharacter = false;

            						patchIndex += 1;
            					}
            				}

            				charIndex += 1;
            			}
            		};

            		for (; patchIndex < this.patches.length; patchIndex += 1) {
            			// can't cache this.patches.length, it may change
            			var patch = this.patches[patchIndex];

            			indentUntil(patch.start);

            			if (!isExcluded[charIndex]) {
            				patch.content = patch.content.replace(pattern, replacer);

            				if (patch.content.length) {
            					shouldIndentNextCharacter = patch.content[patch.content.length - 1] === '\n';
            				}
            			}

            			charIndex = patch.end;
            		}

            		indentUntil(this.original.length);

            		this.outro = this.outro.replace(pattern, replacer);

            		return this;
            	},
            	insert: function insert(index, content) {
            		if (typeof content !== 'string') {
            			throw new TypeError('inserted content must be a string');
            		}

            		this.patch(index, index, content);
            		return this;
            	},

            	// get current location of character in original string
            	locate: function locate(character) {
            		throw new Error('magicString.locate is deprecated');
            	},
            	locateOrigin: function locateOrigin(character) {
            		throw new Error('magicString.locateOrigin is deprecated');
            	},
            	overwrite: function overwrite(start, end, content, storeName) {
            		if (typeof content !== 'string') {
            			throw new TypeError('replacement content must be a string');
            		}

            		this.patch(start, end, content, storeName);
            		return this;
            	},
            	patch: function patch(start, end, content, storeName) {
            		var original = this.original.slice(start, end);
            		if (storeName) this.storedNames[original] = true;

            		var i = this.patches.length;
            		while (i--) {
            			var previous = this.patches[i];

            			// TODO can we tidy this up?

            			// if this completely covers previous patch, remove it
            			if (start !== end && start <= previous.start && end >= previous.end) {
            				// unless it's an insert at the start
            				if (previous.start === previous.end && previous.start === start) break;
            				// or it's an insert at the end
            				if (previous.start === previous.end && previous.end === end) continue;
            				this.patches.splice(i, 1);
            			}

            			// if it overlaps, throw error
            			else if (start < previous.end && end > previous.start) {
            					// special case – it's okay to remove overlapping ranges
            					if (!previous.content.length && !content.length) {
            						previous.start = Math.min(start, previous.start);
            						previous.end = Math.max(end, previous.end);
            						return;
            					}

            					throw new Error('Cannot overwrite the same content twice: \'' + original + '\'');
            				}

            				// if this precedes previous patch, stop search
            				else if (start >= previous.end) {
            						break;
            					}
            		}

            		var patch = new Patch(start, end, content, original, storeName);
            		this.patches.splice(i + 1, 0, patch);
            		return patch;
            	},
            	prepend: function prepend(content) {
            		if (typeof content !== 'string') throw new TypeError('outro content must be a string');

            		this.intro = content + this.intro;
            		return this;
            	},
            	remove: function remove(start, end) {
            		if (start < 0 || end > this.original.length) {
            			throw new Error('Character is out of bounds');
            		}

            		this.patch(start, end, '');
            		return this;
            	},
            	replace: function replace(start, end, content) {
            		if (!warned) {
            			console.warn('magicString.replace(...) is deprecated. Use magicString.overwrite(...) instead');
            			warned = true;
            		}

            		return this.overwrite(start, end, content);
            	},
            	slice: function slice(start) {
            		var end = arguments.length <= 1 || arguments[1] === undefined ? this.original.length : arguments[1];

            		while (start < 0) {
            			start += this.original.length;
            		}while (end < 0) {
            			end += this.original.length;
            		}var firstPatchIndex = 0;
            		var lastPatchIndex = this.patches.length;

            		while (lastPatchIndex--) {
            			var patch = this.patches[lastPatchIndex];
            			if (end >= patch.start && end < patch.end) throw new Error('Cannot use replaced characters (' + start + ', ' + end + ') as slice anchors');

            			// TODO this is weird, rewrite it
            			if (patch.start > end) continue;
            			break;
            		}

            		for (firstPatchIndex = 0; firstPatchIndex <= lastPatchIndex; firstPatchIndex += 1) {
            			var patch = this.patches[firstPatchIndex];
            			if (start > patch.start && start <= patch.end) throw new Error('Cannot use replaced characters (' + start + ', ' + end + ') as slice anchors');

            			if (start <= patch.start) {
            				break;
            			}
            		}

            		var result = '';
            		var lastIndex = start;

            		for (var i = firstPatchIndex; i <= lastPatchIndex; i += 1) {
            			var patch = this.patches[i];
            			result += this.original.slice(lastIndex, patch.start);
            			result += patch.content;

            			lastIndex = patch.end;
            		}

            		result += this.original.slice(lastIndex, end);

            		return result;
            	},
            	snip: function snip(start, end) {
            		var clone = this.clone();
            		clone.remove(0, start);
            		clone.remove(end, clone.original.length);

            		return clone;
            	},
            	toString: function toString() {
            		return this.intro + this.slice(0, this.original.length) + this.outro;
            	},
            	trimLines: function trimLines() {
            		return this.trim('[\\r\\n]');
            	},
            	trim: function trim(charType) {
            		return this.trimStart(charType).trimEnd(charType);
            	},
            	trimEnd: function trimEnd(charType) {
            		var rx = new RegExp((charType || '\\s') + '+$');

            		this.outro = this.outro.replace(rx, '');
            		if (this.outro.length) return this;

            		var charIndex = this.original.length;
            		var i = this.patches.length;

            		while (i--) {
            			var patch = this.patches[i];

            			if (charIndex > patch.end) {
            				var _slice = this.original.slice(patch.end, charIndex);

            				var _match = rx.exec(_slice);
            				if (_match) {
            					this.patch(charIndex - _match[0].length, charIndex, '');
            				}

            				if (!_match || _match[0].length < _slice.length) {
            					// there is non-whitespace after the patch
            					return this;
            				}
            			}

            			patch.content = patch.content.replace(rx, '');
            			if (patch.content) return this;

            			charIndex = patch.start;
            		}

            		var slice = this.original.slice(0, charIndex);

            		var match = rx.exec(slice);
            		if (match) this.patch(charIndex - match[0].length, charIndex, '');

            		return this;
            	},
            	trimStart: function trimStart(charType) {
            		var rx = new RegExp('^' + (charType || '\\s') + '+');

            		this.intro = this.intro.replace(rx, '');
            		if (this.intro.length) return this;

            		var charIndex = 0;

            		for (var i = 0; i < this.patches.length; i += 1) {
            			var patch = this.patches[i];

            			if (charIndex < patch.start) {
            				var _slice2 = this.original.slice(charIndex, patch.start);

            				var _match2 = rx.exec(_slice2);
            				if (_match2) this.patch(charIndex, charIndex + _match2[0].length, '');

            				if (!_match2 || _match2[0].length < _slice2.length) {
            					// there is non-whitespace before the patch
            					return this;
            				}
            			}

            			patch.content = patch.content.replace(rx, '');
            			if (patch.content) return this;

            			charIndex = patch.end;
            		}

            		var slice = this.original.slice(charIndex, this.original.length);

            		var match = rx.exec(slice);
            		if (match) this.patch(charIndex, charIndex + match[0].length, '');

            		return this;
            	}
            };

            var hasOwnProp = Object.prototype.hasOwnProperty;

            function Bundle() {
            	var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

            	this.intro = options.intro || '';
            	this.separator = options.separator !== undefined ? options.separator : '\n';

            	this.sources = [];

            	this.uniqueSources = [];
            	this.uniqueSourceIndexByFilename = {};
            }

            Bundle.prototype = {
            	addSource: function addSource(source) {
            		if (source instanceof MagicString) {
            			return this.addSource({
            				content: source,
            				filename: source.filename,
            				separator: this.separator
            			});
            		}

            		if (!isObject(source) || !source.content) {
            			throw new Error('bundle.addSource() takes an object with a `content` property, which should be an instance of MagicString, and an optional `filename`');
            		}

            		['filename', 'indentExclusionRanges', 'separator'].forEach(function (option) {
            			if (!hasOwnProp.call(source, option)) source[option] = source.content[option];
            		});

            		if (source.separator === undefined) {
            			// TODO there's a bunch of this sort of thing, needs cleaning up
            			source.separator = this.separator;
            		}

            		if (source.filename) {
            			if (!hasOwnProp.call(this.uniqueSourceIndexByFilename, source.filename)) {
            				this.uniqueSourceIndexByFilename[source.filename] = this.uniqueSources.length;
            				this.uniqueSources.push({ filename: source.filename, content: source.content.original });
            			} else {
            				var uniqueSource = this.uniqueSources[this.uniqueSourceIndexByFilename[source.filename]];
            				if (source.content.original !== uniqueSource.content) {
            					throw new Error('Illegal source: same filename (' + source.filename + '), different contents');
            				}
            			}
            		}

            		this.sources.push(source);
            		return this;
            	},
            	append: function append(str, options) {
            		this.addSource({
            			content: new MagicString(str),
            			separator: options && options.separator || ''
            		});

            		return this;
            	},
            	clone: function clone() {
            		var bundle = new Bundle({
            			intro: this.intro,
            			separator: this.separator
            		});

            		this.sources.forEach(function (source) {
            			bundle.addSource({
            				filename: source.filename,
            				content: source.content.clone(),
            				separator: source.separator
            			});
            		});

            		return bundle;
            	},
            	generateMap: function generateMap(options) {
            		var _this = this;

            		var offsets = {};

            		var names = [];
            		this.sources.forEach(function (source) {
            			Object.keys(source.content.storedNames).forEach(function (name) {
            				if (! ~names.indexOf(name)) names.push(name);
            			});
            		});

            		var encoded = getSemis(this.intro) + this.sources.map(function (source, i) {
            			var prefix = i > 0 ? getSemis(source.separator) || ',' : '';
            			var mappings = undefined;

            			// we don't bother encoding sources without a filename
            			if (!source.filename) {
            				mappings = getSemis(source.content.toString());
            			} else {
            				var sourceIndex = _this.uniqueSourceIndexByFilename[source.filename];
            				mappings = source.content.getMappings(options.hires, sourceIndex, offsets, names);
            			}

            			return prefix + mappings;
            		}).join('');

            		return new SourceMap({
            			file: options.file ? options.file.split(/[\/\\]/).pop() : null,
            			sources: this.uniqueSources.map(function (source) {
            				return options.file ? getRelativePath(options.file, source.filename) : source.filename;
            			}),
            			sourcesContent: this.uniqueSources.map(function (source) {
            				return options.includeContent ? source.content : null;
            			}),
            			names: names,
            			mappings: encoded
            		});
            	},
            	getIndentString: function getIndentString() {
            		var indentStringCounts = {};

            		this.sources.forEach(function (source) {
            			var indentStr = source.content.indentStr;

            			if (indentStr === null) return;

            			if (!indentStringCounts[indentStr]) indentStringCounts[indentStr] = 0;
            			indentStringCounts[indentStr] += 1;
            		});

            		return Object.keys(indentStringCounts).sort(function (a, b) {
            			return indentStringCounts[a] - indentStringCounts[b];
            		})[0] || '\t';
            	},
            	indent: function indent(indentStr) {
            		var _this2 = this;

            		if (!arguments.length) {
            			indentStr = this.getIndentString();
            		}

            		if (indentStr === '') return this; // noop

            		var trailingNewline = !this.intro || this.intro.slice(-1) === '\n';

            		this.sources.forEach(function (source, i) {
            			var separator = source.separator !== undefined ? source.separator : _this2.separator;
            			var indentStart = trailingNewline || i > 0 && /\r?\n$/.test(separator);

            			source.content.indent(indentStr, {
            				exclude: source.indentExclusionRanges,
            				indentStart: indentStart //: trailingNewline || /\r?\n$/.test( separator )  //true///\r?\n/.test( separator )
            			});

            			// TODO this is a very slow way to determine this
            			trailingNewline = source.content.toString().slice(0, -1) === '\n';
            		});

            		if (this.intro) {
            			this.intro = indentStr + this.intro.replace(/^[^\n]/gm, function (match, index) {
            				return index > 0 ? indentStr + match : match;
            			});
            		}

            		return this;
            	},
            	prepend: function prepend(str) {
            		this.intro = str + this.intro;
            		return this;
            	},
            	toString: function toString() {
            		var _this3 = this;

            		var body = this.sources.map(function (source, i) {
            			var separator = source.separator !== undefined ? source.separator : _this3.separator;
            			var str = (i > 0 ? separator : '') + source.content.toString();

            			return str;
            		}).join('');

            		return this.intro + body;
            	},
            	trimLines: function trimLines() {
            		return this.trim('[\\r\\n]');
            	},
            	trim: function trim(charType) {
            		return this.trimStart(charType).trimEnd(charType);
            	},
            	trimStart: function trimStart(charType) {
            		var rx = new RegExp('^' + (charType || '\\s') + '+');
            		this.intro = this.intro.replace(rx, '');

            		if (!this.intro) {
            			var source = undefined;
            			var i = 0;

            			do {
            				source = this.sources[i];

            				if (!source) {
            					break;
            				}

            				source.content.trimStart(charType);
            				i += 1;
            			} while (source.content.toString() === ''); // TODO faster way to determine non-empty source?
            		}

            		return this;
            	},
            	trimEnd: function trimEnd(charType) {
            		var rx = new RegExp((charType || '\\s') + '+$');

            		var source = undefined;
            		var i = this.sources.length - 1;

            		do {
            			source = this.sources[i];

            			if (!source) {
            				this.intro = this.intro.replace(rx, '');
            				break;
            			}

            			source.content.trimEnd(charType);
            			i -= 1;
            		} while (source.content.toString() === ''); // TODO faster way to determine non-empty source?

            		return this;
            	}
            };

            function getSemis(str) {
            	return new Array(str.split('\n').length).join(';');
            }

            MagicString.Bundle = Bundle;

            module.exports = MagicString;
            });

            var require$$0$53 = (magicString_cjs && typeof magicString_cjs === 'object' && 'default' in magicString_cjs ? magicString_cjs['default'] : magicString_cjs);

            var acorn = __commonjs(function (module, exports, global) {
            (function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.acorn = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(_dereq_,module,exports){
            // A recursive descent parser operates by defining functions for all
            // syntactic elements, and recursively calling those, each function
            // advancing the input stream and returning an AST node. Precedence
            // of constructs (for example, the fact that `!x[1]` means `!(x[1])`
            // instead of `(!x)[1]` is handled by the fact that the parser
            // function that parses unary prefix operators is called first, and
            // in turn calls the function that parses `[]` subscripts — that
            // way, it'll receive the node for `x[1]` already parsed, and wraps
            // *that* in the unary operator node.
            //
            // Acorn uses an [operator precedence parser][opp] to handle binary
            // operator precedence, because it is much more compact than using
            // the technique outlined above, which uses different, nesting
            // functions to specify precedence, for all of the ten binary
            // precedence levels that JavaScript defines.
            //
            // [opp]: http://en.wikipedia.org/wiki/Operator-precedence_parser

            "use strict";

            var _tokentype = _dereq_("./tokentype");

            var _state = _dereq_("./state");

            var pp = _state.Parser.prototype;

            // Check if property name clashes with already added.
            // Object/class getters and setters are not allowed to clash —
            // either with each other or with an init property — and in
            // strict mode, init properties are also not allowed to be repeated.

            pp.checkPropClash = function (prop, propHash) {
              if (this.options.ecmaVersion >= 6 && (prop.computed || prop.method || prop.shorthand)) return;
              var key = prop.key;var name = undefined;
              switch (key.type) {
                case "Identifier":
                  name = key.name;break;
                case "Literal":
                  name = String(key.value);break;
                default:
                  return;
              }
              var kind = prop.kind;

              if (this.options.ecmaVersion >= 6) {
                if (name === "__proto__" && kind === "init") {
                  if (propHash.proto) this.raise(key.start, "Redefinition of __proto__ property");
                  propHash.proto = true;
                }
                return;
              }
              name = "$" + name;
              var other = propHash[name];
              if (other) {
                var isGetSet = kind !== "init";
                if ((this.strict || isGetSet) && other[kind] || !(isGetSet ^ other.init)) this.raise(key.start, "Redefinition of property");
              } else {
                other = propHash[name] = {
                  init: false,
                  get: false,
                  set: false
                };
              }
              other[kind] = true;
            };

            // ### Expression parsing

            // These nest, from the most general expression type at the top to
            // 'atomic', nondivisible expression types at the bottom. Most of
            // the functions will simply let the function(s) below them parse,
            // and, *if* the syntactic construct they handle is present, wrap
            // the AST node that the inner parser gave them in another node.

            // Parse a full expression. The optional arguments are used to
            // forbid the `in` operator (in for loops initalization expressions)
            // and provide reference for storing '=' operator inside shorthand
            // property assignment in contexts where both object expression
            // and object pattern might appear (so it's possible to raise
            // delayed syntax error at correct position).

            pp.parseExpression = function (noIn, refDestructuringErrors) {
              var startPos = this.start,
                  startLoc = this.startLoc;
              var expr = this.parseMaybeAssign(noIn, refDestructuringErrors);
              if (this.type === _tokentype.types.comma) {
                var node = this.startNodeAt(startPos, startLoc);
                node.expressions = [expr];
                while (this.eat(_tokentype.types.comma)) node.expressions.push(this.parseMaybeAssign(noIn, refDestructuringErrors));
                return this.finishNode(node, "SequenceExpression");
              }
              return expr;
            };

            // Parse an assignment expression. This includes applications of
            // operators like `+=`.

            pp.parseMaybeAssign = function (noIn, refDestructuringErrors, afterLeftParse) {
              if (this.type == _tokentype.types._yield && this.inGenerator) return this.parseYield();

              var validateDestructuring = false;
              if (!refDestructuringErrors) {
                refDestructuringErrors = { shorthandAssign: 0, trailingComma: 0 };
                validateDestructuring = true;
              }
              var startPos = this.start,
                  startLoc = this.startLoc;
              if (this.type == _tokentype.types.parenL || this.type == _tokentype.types.name) this.potentialArrowAt = this.start;
              var left = this.parseMaybeConditional(noIn, refDestructuringErrors);
              if (afterLeftParse) left = afterLeftParse.call(this, left, startPos, startLoc);
              if (this.type.isAssign) {
                if (validateDestructuring) this.checkPatternErrors(refDestructuringErrors, true);
                var node = this.startNodeAt(startPos, startLoc);
                node.operator = this.value;
                node.left = this.type === _tokentype.types.eq ? this.toAssignable(left) : left;
                refDestructuringErrors.shorthandAssign = 0; // reset because shorthand default was used correctly
                this.checkLVal(left);
                this.next();
                node.right = this.parseMaybeAssign(noIn);
                return this.finishNode(node, "AssignmentExpression");
              } else {
                if (validateDestructuring) this.checkExpressionErrors(refDestructuringErrors, true);
              }
              return left;
            };

            // Parse a ternary conditional (`?:`) operator.

            pp.parseMaybeConditional = function (noIn, refDestructuringErrors) {
              var startPos = this.start,
                  startLoc = this.startLoc;
              var expr = this.parseExprOps(noIn, refDestructuringErrors);
              if (this.checkExpressionErrors(refDestructuringErrors)) return expr;
              if (this.eat(_tokentype.types.question)) {
                var node = this.startNodeAt(startPos, startLoc);
                node.test = expr;
                node.consequent = this.parseMaybeAssign();
                this.expect(_tokentype.types.colon);
                node.alternate = this.parseMaybeAssign(noIn);
                return this.finishNode(node, "ConditionalExpression");
              }
              return expr;
            };

            // Start the precedence parser.

            pp.parseExprOps = function (noIn, refDestructuringErrors) {
              var startPos = this.start,
                  startLoc = this.startLoc;
              var expr = this.parseMaybeUnary(refDestructuringErrors);
              if (this.checkExpressionErrors(refDestructuringErrors)) return expr;
              return this.parseExprOp(expr, startPos, startLoc, -1, noIn);
            };

            // Parse binary operators with the operator precedence parsing
            // algorithm. `left` is the left-hand side of the operator.
            // `minPrec` provides context that allows the function to stop and
            // defer further parser to one of its callers when it encounters an
            // operator that has a lower precedence than the set it is parsing.

            pp.parseExprOp = function (left, leftStartPos, leftStartLoc, minPrec, noIn) {
              var prec = this.type.binop;
              if (prec != null && (!noIn || this.type !== _tokentype.types._in)) {
                if (prec > minPrec) {
                  var node = this.startNodeAt(leftStartPos, leftStartLoc);
                  node.left = left;
                  node.operator = this.value;
                  var op = this.type;
                  this.next();
                  var startPos = this.start,
                      startLoc = this.startLoc;
                  node.right = this.parseExprOp(this.parseMaybeUnary(), startPos, startLoc, prec, noIn);
                  this.finishNode(node, op === _tokentype.types.logicalOR || op === _tokentype.types.logicalAND ? "LogicalExpression" : "BinaryExpression");
                  return this.parseExprOp(node, leftStartPos, leftStartLoc, minPrec, noIn);
                }
              }
              return left;
            };

            // Parse unary operators, both prefix and postfix.

            pp.parseMaybeUnary = function (refDestructuringErrors) {
              if (this.type.prefix) {
                var node = this.startNode(),
                    update = this.type === _tokentype.types.incDec;
                node.operator = this.value;
                node.prefix = true;
                this.next();
                node.argument = this.parseMaybeUnary();
                this.checkExpressionErrors(refDestructuringErrors, true);
                if (update) this.checkLVal(node.argument);else if (this.strict && node.operator === "delete" && node.argument.type === "Identifier") this.raise(node.start, "Deleting local variable in strict mode");
                return this.finishNode(node, update ? "UpdateExpression" : "UnaryExpression");
              }
              var startPos = this.start,
                  startLoc = this.startLoc;
              var expr = this.parseExprSubscripts(refDestructuringErrors);
              if (this.checkExpressionErrors(refDestructuringErrors)) return expr;
              while (this.type.postfix && !this.canInsertSemicolon()) {
                var node = this.startNodeAt(startPos, startLoc);
                node.operator = this.value;
                node.prefix = false;
                node.argument = expr;
                this.checkLVal(expr);
                this.next();
                expr = this.finishNode(node, "UpdateExpression");
              }
              return expr;
            };

            // Parse call, dot, and `[]`-subscript expressions.

            pp.parseExprSubscripts = function (refDestructuringErrors) {
              var startPos = this.start,
                  startLoc = this.startLoc;
              var expr = this.parseExprAtom(refDestructuringErrors);
              var skipArrowSubscripts = expr.type === "ArrowFunctionExpression" && this.input.slice(this.lastTokStart, this.lastTokEnd) !== ")";
              if (this.checkExpressionErrors(refDestructuringErrors) || skipArrowSubscripts) return expr;
              return this.parseSubscripts(expr, startPos, startLoc);
            };

            pp.parseSubscripts = function (base, startPos, startLoc, noCalls) {
              for (;;) {
                if (this.eat(_tokentype.types.dot)) {
                  var node = this.startNodeAt(startPos, startLoc);
                  node.object = base;
                  node.property = this.parseIdent(true);
                  node.computed = false;
                  base = this.finishNode(node, "MemberExpression");
                } else if (this.eat(_tokentype.types.bracketL)) {
                  var node = this.startNodeAt(startPos, startLoc);
                  node.object = base;
                  node.property = this.parseExpression();
                  node.computed = true;
                  this.expect(_tokentype.types.bracketR);
                  base = this.finishNode(node, "MemberExpression");
                } else if (!noCalls && this.eat(_tokentype.types.parenL)) {
                  var node = this.startNodeAt(startPos, startLoc);
                  node.callee = base;
                  node.arguments = this.parseExprList(_tokentype.types.parenR, false);
                  base = this.finishNode(node, "CallExpression");
                } else if (this.type === _tokentype.types.backQuote) {
                  var node = this.startNodeAt(startPos, startLoc);
                  node.tag = base;
                  node.quasi = this.parseTemplate();
                  base = this.finishNode(node, "TaggedTemplateExpression");
                } else {
                  return base;
                }
              }
            };

            // Parse an atomic expression — either a single token that is an
            // expression, an expression started by a keyword like `function` or
            // `new`, or an expression wrapped in punctuation like `()`, `[]`,
            // or `{}`.

            pp.parseExprAtom = function (refDestructuringErrors) {
              var node = undefined,
                  canBeArrow = this.potentialArrowAt == this.start;
              switch (this.type) {
                case _tokentype.types._super:
                  if (!this.inFunction) this.raise(this.start, "'super' outside of function or class");
                case _tokentype.types._this:
                  var type = this.type === _tokentype.types._this ? "ThisExpression" : "Super";
                  node = this.startNode();
                  this.next();
                  return this.finishNode(node, type);

                case _tokentype.types._yield:
                  if (this.inGenerator) this.unexpected();

                case _tokentype.types.name:
                  var startPos = this.start,
                      startLoc = this.startLoc;
                  var id = this.parseIdent(this.type !== _tokentype.types.name);
                  if (canBeArrow && !this.canInsertSemicolon() && this.eat(_tokentype.types.arrow)) return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), [id]);
                  return id;

                case _tokentype.types.regexp:
                  var value = this.value;
                  node = this.parseLiteral(value.value);
                  node.regex = { pattern: value.pattern, flags: value.flags };
                  return node;

                case _tokentype.types.num:case _tokentype.types.string:
                  return this.parseLiteral(this.value);

                case _tokentype.types._null:case _tokentype.types._true:case _tokentype.types._false:
                  node = this.startNode();
                  node.value = this.type === _tokentype.types._null ? null : this.type === _tokentype.types._true;
                  node.raw = this.type.keyword;
                  this.next();
                  return this.finishNode(node, "Literal");

                case _tokentype.types.parenL:
                  return this.parseParenAndDistinguishExpression(canBeArrow);

                case _tokentype.types.bracketL:
                  node = this.startNode();
                  this.next();
                  // check whether this is array comprehension or regular array
                  if (this.options.ecmaVersion >= 7 && this.type === _tokentype.types._for) {
                    return this.parseComprehension(node, false);
                  }
                  node.elements = this.parseExprList(_tokentype.types.bracketR, true, true, refDestructuringErrors);
                  return this.finishNode(node, "ArrayExpression");

                case _tokentype.types.braceL:
                  return this.parseObj(false, refDestructuringErrors);

                case _tokentype.types._function:
                  node = this.startNode();
                  this.next();
                  return this.parseFunction(node, false);

                case _tokentype.types._class:
                  return this.parseClass(this.startNode(), false);

                case _tokentype.types._new:
                  return this.parseNew();

                case _tokentype.types.backQuote:
                  return this.parseTemplate();

                default:
                  this.unexpected();
              }
            };

            pp.parseLiteral = function (value) {
              var node = this.startNode();
              node.value = value;
              node.raw = this.input.slice(this.start, this.end);
              this.next();
              return this.finishNode(node, "Literal");
            };

            pp.parseParenExpression = function () {
              this.expect(_tokentype.types.parenL);
              var val = this.parseExpression();
              this.expect(_tokentype.types.parenR);
              return val;
            };

            pp.parseParenAndDistinguishExpression = function (canBeArrow) {
              var startPos = this.start,
                  startLoc = this.startLoc,
                  val = undefined;
              if (this.options.ecmaVersion >= 6) {
                this.next();

                if (this.options.ecmaVersion >= 7 && this.type === _tokentype.types._for) {
                  return this.parseComprehension(this.startNodeAt(startPos, startLoc), true);
                }

                var innerStartPos = this.start,
                    innerStartLoc = this.startLoc;
                var exprList = [],
                    first = true;
                var refDestructuringErrors = { shorthandAssign: 0, trailingComma: 0 },
                    spreadStart = undefined,
                    innerParenStart = undefined;
                while (this.type !== _tokentype.types.parenR) {
                  first ? first = false : this.expect(_tokentype.types.comma);
                  if (this.type === _tokentype.types.ellipsis) {
                    spreadStart = this.start;
                    exprList.push(this.parseParenItem(this.parseRest()));
                    break;
                  } else {
                    if (this.type === _tokentype.types.parenL && !innerParenStart) {
                      innerParenStart = this.start;
                    }
                    exprList.push(this.parseMaybeAssign(false, refDestructuringErrors, this.parseParenItem));
                  }
                }
                var innerEndPos = this.start,
                    innerEndLoc = this.startLoc;
                this.expect(_tokentype.types.parenR);

                if (canBeArrow && !this.canInsertSemicolon() && this.eat(_tokentype.types.arrow)) {
                  this.checkPatternErrors(refDestructuringErrors, true);
                  if (innerParenStart) this.unexpected(innerParenStart);
                  return this.parseParenArrowList(startPos, startLoc, exprList);
                }

                if (!exprList.length) this.unexpected(this.lastTokStart);
                if (spreadStart) this.unexpected(spreadStart);
                this.checkExpressionErrors(refDestructuringErrors, true);

                if (exprList.length > 1) {
                  val = this.startNodeAt(innerStartPos, innerStartLoc);
                  val.expressions = exprList;
                  this.finishNodeAt(val, "SequenceExpression", innerEndPos, innerEndLoc);
                } else {
                  val = exprList[0];
                }
              } else {
                val = this.parseParenExpression();
              }

              if (this.options.preserveParens) {
                var par = this.startNodeAt(startPos, startLoc);
                par.expression = val;
                return this.finishNode(par, "ParenthesizedExpression");
              } else {
                return val;
              }
            };

            pp.parseParenItem = function (item) {
              return item;
            };

            pp.parseParenArrowList = function (startPos, startLoc, exprList) {
              return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), exprList);
            };

            // New's precedence is slightly tricky. It must allow its argument to
            // be a `[]` or dot subscript expression, but not a call — at least,
            // not without wrapping it in parentheses. Thus, it uses the noCalls
            // argument to parseSubscripts to prevent it from consuming the
            // argument list.

            var empty = [];

            pp.parseNew = function () {
              var node = this.startNode();
              var meta = this.parseIdent(true);
              if (this.options.ecmaVersion >= 6 && this.eat(_tokentype.types.dot)) {
                node.meta = meta;
                node.property = this.parseIdent(true);
                if (node.property.name !== "target") this.raise(node.property.start, "The only valid meta property for new is new.target");
                if (!this.inFunction) this.raise(node.start, "new.target can only be used in functions");
                return this.finishNode(node, "MetaProperty");
              }
              var startPos = this.start,
                  startLoc = this.startLoc;
              node.callee = this.parseSubscripts(this.parseExprAtom(), startPos, startLoc, true);
              if (this.eat(_tokentype.types.parenL)) node.arguments = this.parseExprList(_tokentype.types.parenR, false);else node.arguments = empty;
              return this.finishNode(node, "NewExpression");
            };

            // Parse template expression.

            pp.parseTemplateElement = function () {
              var elem = this.startNode();
              elem.value = {
                raw: this.input.slice(this.start, this.end).replace(/\r\n?/g, '\n'),
                cooked: this.value
              };
              this.next();
              elem.tail = this.type === _tokentype.types.backQuote;
              return this.finishNode(elem, "TemplateElement");
            };

            pp.parseTemplate = function () {
              var node = this.startNode();
              this.next();
              node.expressions = [];
              var curElt = this.parseTemplateElement();
              node.quasis = [curElt];
              while (!curElt.tail) {
                this.expect(_tokentype.types.dollarBraceL);
                node.expressions.push(this.parseExpression());
                this.expect(_tokentype.types.braceR);
                node.quasis.push(curElt = this.parseTemplateElement());
              }
              this.next();
              return this.finishNode(node, "TemplateLiteral");
            };

            // Parse an object literal or binding pattern.

            pp.parseObj = function (isPattern, refDestructuringErrors) {
              var node = this.startNode(),
                  first = true,
                  propHash = {};
              node.properties = [];
              this.next();
              while (!this.eat(_tokentype.types.braceR)) {
                if (!first) {
                  this.expect(_tokentype.types.comma);
                  if (this.afterTrailingComma(_tokentype.types.braceR)) break;
                } else first = false;

                var prop = this.startNode(),
                    isGenerator = undefined,
                    startPos = undefined,
                    startLoc = undefined;
                if (this.options.ecmaVersion >= 6) {
                  prop.method = false;
                  prop.shorthand = false;
                  if (isPattern || refDestructuringErrors) {
                    startPos = this.start;
                    startLoc = this.startLoc;
                  }
                  if (!isPattern) isGenerator = this.eat(_tokentype.types.star);
                }
                this.parsePropertyName(prop);
                this.parsePropertyValue(prop, isPattern, isGenerator, startPos, startLoc, refDestructuringErrors);
                this.checkPropClash(prop, propHash);
                node.properties.push(this.finishNode(prop, "Property"));
              }
              return this.finishNode(node, isPattern ? "ObjectPattern" : "ObjectExpression");
            };

            pp.parsePropertyValue = function (prop, isPattern, isGenerator, startPos, startLoc, refDestructuringErrors) {
              if (this.eat(_tokentype.types.colon)) {
                prop.value = isPattern ? this.parseMaybeDefault(this.start, this.startLoc) : this.parseMaybeAssign(false, refDestructuringErrors);
                prop.kind = "init";
              } else if (this.options.ecmaVersion >= 6 && this.type === _tokentype.types.parenL) {
                if (isPattern) this.unexpected();
                prop.kind = "init";
                prop.method = true;
                prop.value = this.parseMethod(isGenerator);
              } else if (this.options.ecmaVersion >= 5 && !prop.computed && prop.key.type === "Identifier" && (prop.key.name === "get" || prop.key.name === "set") && (this.type != _tokentype.types.comma && this.type != _tokentype.types.braceR)) {
                if (isGenerator || isPattern) this.unexpected();
                prop.kind = prop.key.name;
                this.parsePropertyName(prop);
                prop.value = this.parseMethod(false);
                var paramCount = prop.kind === "get" ? 0 : 1;
                if (prop.value.params.length !== paramCount) {
                  var start = prop.value.start;
                  if (prop.kind === "get") this.raise(start, "getter should have no params");else this.raise(start, "setter should have exactly one param");
                }
                if (prop.kind === "set" && prop.value.params[0].type === "RestElement") this.raise(prop.value.params[0].start, "Setter cannot use rest params");
              } else if (this.options.ecmaVersion >= 6 && !prop.computed && prop.key.type === "Identifier") {
                prop.kind = "init";
                if (isPattern) {
                  if (this.keywords.test(prop.key.name) || (this.strict ? this.reservedWordsStrictBind : this.reservedWords).test(prop.key.name)) this.raise(prop.key.start, "Binding " + prop.key.name);
                  prop.value = this.parseMaybeDefault(startPos, startLoc, prop.key);
                } else if (this.type === _tokentype.types.eq && refDestructuringErrors) {
                  if (!refDestructuringErrors.shorthandAssign) refDestructuringErrors.shorthandAssign = this.start;
                  prop.value = this.parseMaybeDefault(startPos, startLoc, prop.key);
                } else {
                  prop.value = prop.key;
                }
                prop.shorthand = true;
              } else this.unexpected();
            };

            pp.parsePropertyName = function (prop) {
              if (this.options.ecmaVersion >= 6) {
                if (this.eat(_tokentype.types.bracketL)) {
                  prop.computed = true;
                  prop.key = this.parseMaybeAssign();
                  this.expect(_tokentype.types.bracketR);
                  return prop.key;
                } else {
                  prop.computed = false;
                }
              }
              return prop.key = this.type === _tokentype.types.num || this.type === _tokentype.types.string ? this.parseExprAtom() : this.parseIdent(true);
            };

            // Initialize empty function node.

            pp.initFunction = function (node) {
              node.id = null;
              if (this.options.ecmaVersion >= 6) {
                node.generator = false;
                node.expression = false;
              }
            };

            // Parse object or class method.

            pp.parseMethod = function (isGenerator) {
              var node = this.startNode();
              this.initFunction(node);
              this.expect(_tokentype.types.parenL);
              node.params = this.parseBindingList(_tokentype.types.parenR, false, false);
              if (this.options.ecmaVersion >= 6) node.generator = isGenerator;
              this.parseFunctionBody(node, false);
              return this.finishNode(node, "FunctionExpression");
            };

            // Parse arrow function expression with given parameters.

            pp.parseArrowExpression = function (node, params) {
              this.initFunction(node);
              node.params = this.toAssignableList(params, true);
              this.parseFunctionBody(node, true);
              return this.finishNode(node, "ArrowFunctionExpression");
            };

            // Parse function body and check parameters.

            pp.parseFunctionBody = function (node, isArrowFunction) {
              var isExpression = isArrowFunction && this.type !== _tokentype.types.braceL;

              if (isExpression) {
                node.body = this.parseMaybeAssign();
                node.expression = true;
              } else {
                // Start a new scope with regard to labels and the `inFunction`
                // flag (restore them to their old value afterwards).
                var oldInFunc = this.inFunction,
                    oldInGen = this.inGenerator,
                    oldLabels = this.labels;
                this.inFunction = true;this.inGenerator = node.generator;this.labels = [];
                node.body = this.parseBlock(true);
                node.expression = false;
                this.inFunction = oldInFunc;this.inGenerator = oldInGen;this.labels = oldLabels;
              }

              // If this is a strict mode function, verify that argument names
              // are not repeated, and it does not try to bind the words `eval`
              // or `arguments`.
              if (this.strict || !isExpression && node.body.body.length && this.isUseStrict(node.body.body[0])) {
                var oldStrict = this.strict;
                this.strict = true;
                if (node.id) this.checkLVal(node.id, true);
                this.checkParams(node);
                this.strict = oldStrict;
              } else if (isArrowFunction) {
                this.checkParams(node);
              }
            };

            // Checks function params for various disallowed patterns such as using "eval"
            // or "arguments" and duplicate parameters.

            pp.checkParams = function (node) {
              var nameHash = {};
              for (var i = 0; i < node.params.length; i++) {
                this.checkLVal(node.params[i], true, nameHash);
              }
            };

            // Parses a comma-separated list of expressions, and returns them as
            // an array. `close` is the token type that ends the list, and
            // `allowEmpty` can be turned on to allow subsequent commas with
            // nothing in between them to be parsed as `null` (which is needed
            // for array literals).

            pp.parseExprList = function (close, allowTrailingComma, allowEmpty, refDestructuringErrors) {
              var elts = [],
                  first = true;
              while (!this.eat(close)) {
                if (!first) {
                  this.expect(_tokentype.types.comma);
                  if (this.type === close && refDestructuringErrors && !refDestructuringErrors.trailingComma) {
                    refDestructuringErrors.trailingComma = this.lastTokStart;
                  }
                  if (allowTrailingComma && this.afterTrailingComma(close)) break;
                } else first = false;

                var elt = undefined;
                if (allowEmpty && this.type === _tokentype.types.comma) elt = null;else if (this.type === _tokentype.types.ellipsis) elt = this.parseSpread(refDestructuringErrors);else elt = this.parseMaybeAssign(false, refDestructuringErrors);
                elts.push(elt);
              }
              return elts;
            };

            // Parse the next token as an identifier. If `liberal` is true (used
            // when parsing properties), it will also convert keywords into
            // identifiers.

            pp.parseIdent = function (liberal) {
              var node = this.startNode();
              if (liberal && this.options.allowReserved == "never") liberal = false;
              if (this.type === _tokentype.types.name) {
                if (!liberal && (this.strict ? this.reservedWordsStrict : this.reservedWords).test(this.value) && (this.options.ecmaVersion >= 6 || this.input.slice(this.start, this.end).indexOf("\\") == -1)) this.raise(this.start, "The keyword '" + this.value + "' is reserved");
                node.name = this.value;
              } else if (liberal && this.type.keyword) {
                node.name = this.type.keyword;
              } else {
                this.unexpected();
              }
              this.next();
              return this.finishNode(node, "Identifier");
            };

            // Parses yield expression inside generator.

            pp.parseYield = function () {
              var node = this.startNode();
              this.next();
              if (this.type == _tokentype.types.semi || this.canInsertSemicolon() || this.type != _tokentype.types.star && !this.type.startsExpr) {
                node.delegate = false;
                node.argument = null;
              } else {
                node.delegate = this.eat(_tokentype.types.star);
                node.argument = this.parseMaybeAssign();
              }
              return this.finishNode(node, "YieldExpression");
            };

            // Parses array and generator comprehensions.

            pp.parseComprehension = function (node, isGenerator) {
              node.blocks = [];
              while (this.type === _tokentype.types._for) {
                var block = this.startNode();
                this.next();
                this.expect(_tokentype.types.parenL);
                block.left = this.parseBindingAtom();
                this.checkLVal(block.left, true);
                this.expectContextual("of");
                block.right = this.parseExpression();
                this.expect(_tokentype.types.parenR);
                node.blocks.push(this.finishNode(block, "ComprehensionBlock"));
              }
              node.filter = this.eat(_tokentype.types._if) ? this.parseParenExpression() : null;
              node.body = this.parseExpression();
              this.expect(isGenerator ? _tokentype.types.parenR : _tokentype.types.bracketR);
              node.generator = isGenerator;
              return this.finishNode(node, "ComprehensionExpression");
            };

            },{"./state":10,"./tokentype":14}],2:[function(_dereq_,module,exports){
            // This is a trick taken from Esprima. It turns out that, on
            // non-Chrome browsers, to check whether a string is in a set, a
            // predicate containing a big ugly `switch` statement is faster than
            // a regular expression, and on Chrome the two are about on par.
            // This function uses `eval` (non-lexical) to produce such a
            // predicate from a space-separated string of words.
            //
            // It starts by sorting the words by length.

            // Reserved word lists for various dialects of the language

            "use strict";

            exports.__esModule = true;
            exports.isIdentifierStart = isIdentifierStart;
            exports.isIdentifierChar = isIdentifierChar;
            var reservedWords = {
              3: "abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile",
              5: "class enum extends super const export import",
              6: "enum",
              strict: "implements interface let package private protected public static yield",
              strictBind: "eval arguments"
            };

            exports.reservedWords = reservedWords;
            // And the keywords

            var ecma5AndLessKeywords = "break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this";

            var keywords = {
              5: ecma5AndLessKeywords,
              6: ecma5AndLessKeywords + " let const class extends export import yield super"
            };

            exports.keywords = keywords;
            // ## Character categories

            // Big ugly regular expressions that match characters in the
            // whitespace, identifier, and identifier-start categories. These
            // are only applied when a character is found to actually have a
            // code point above 128.
            // Generated by `bin/generate-identifier-regex.js`.

            var nonASCIIidentifierStartChars = "ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙա-ևא-תװ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࢠ-ࢲऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘౙౠౡಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೞೠೡೱೲഅ-ഌഎ-ഐഒ-ഺഽൎൠൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄງຈຊຍດ-ທນ-ຟມ-ຣລວສຫອ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏼᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜌᜎ-ᜑᜠ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡷᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᧁ-ᧇᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭋᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᳩ-ᳬᳮ-ᳱᳵᳶᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-Ⱞⰰ-ⱞⱠ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄭㄱ-ㆎㆠ-ㆺㇰ-ㇿ㐀-䶵一-鿌ꀀ-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꞎꞐ-ꞭꞰꞱꟷ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭟꭤꭥꯀ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ";
            var nonASCIIidentifierChars = "‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛ࣤ-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ଁ-ଃ଼ା-ୄେୈୋ-୍ୖୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఃా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ഁ-ഃാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ංඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ູົຼ່-ໍ໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜔ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠐-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏ᦰ-ᧀᧈᧉ᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭ᳲ-᳴᳸᳹᷀-᷵᷼-᷿‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯꘠-꘩꙯ꙴ-꙽ꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧꢀꢁꢴ-꣄꣐-꣙꣠-꣱꤀-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︭︳︴﹍-﹏０-９＿";

            var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
            var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");

            nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;

            // These are a run-length and offset encoded representation of the
            // >0xffff code points that are a valid part of identifiers. The
            // offset starts at 0x10000, and each pair of numbers represents an
            // offset to the next range, and then a size of the range. They were
            // generated by tools/generate-identifier-regex.js
            var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 17, 26, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 99, 39, 9, 51, 157, 310, 10, 21, 11, 7, 153, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 98, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 26, 45, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 955, 52, 76, 44, 33, 24, 27, 35, 42, 34, 4, 0, 13, 47, 15, 3, 22, 0, 38, 17, 2, 24, 133, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 32, 4, 287, 47, 21, 1, 2, 0, 185, 46, 82, 47, 21, 0, 60, 42, 502, 63, 32, 0, 449, 56, 1288, 920, 104, 110, 2962, 1070, 13266, 568, 8, 30, 114, 29, 19, 47, 17, 3, 32, 20, 6, 18, 881, 68, 12, 0, 67, 12, 16481, 1, 3071, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 4149, 196, 1340, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42710, 42, 4148, 12, 221, 16355, 541];
            var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 1306, 2, 54, 14, 32, 9, 16, 3, 46, 10, 54, 9, 7, 2, 37, 13, 2, 9, 52, 0, 13, 2, 49, 13, 16, 9, 83, 11, 168, 11, 6, 9, 8, 2, 57, 0, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 316, 19, 13, 9, 214, 6, 3, 8, 112, 16, 16, 9, 82, 12, 9, 9, 535, 9, 20855, 9, 135, 4, 60, 6, 26, 9, 1016, 45, 17, 3, 19723, 1, 5319, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 4305, 6, 792618, 239];

            // This has a complexity linear to the value of the code. The
            // assumption is that looking up astral identifier characters is
            // rare.
            function isInAstralSet(code, set) {
              var pos = 0x10000;
              for (var i = 0; i < set.length; i += 2) {
                pos += set[i];
                if (pos > code) return false;
                pos += set[i + 1];
                if (pos >= code) return true;
              }
            }

            // Test whether a given character code starts an identifier.

            function isIdentifierStart(code, astral) {
              if (code < 65) return code === 36;
              if (code < 91) return true;
              if (code < 97) return code === 95;
              if (code < 123) return true;
              if (code <= 0xffff) return code >= 0xaa && nonASCIIidentifierStart.test(String.fromCharCode(code));
              if (astral === false) return false;
              return isInAstralSet(code, astralIdentifierStartCodes);
            }

            // Test whether a given character is part of an identifier.

            function isIdentifierChar(code, astral) {
              if (code < 48) return code === 36;
              if (code < 58) return true;
              if (code < 65) return false;
              if (code < 91) return true;
              if (code < 97) return code === 95;
              if (code < 123) return true;
              if (code <= 0xffff) return code >= 0xaa && nonASCIIidentifier.test(String.fromCharCode(code));
              if (astral === false) return false;
              return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
            }

            },{}],3:[function(_dereq_,module,exports){
            // Acorn is a tiny, fast JavaScript parser written in JavaScript.
            //
            // Acorn was written by Marijn Haverbeke, Ingvar Stepanyan, and
            // various contributors and released under an MIT license.
            //
            // Git repositories for Acorn are available at
            //
            //     http://marijnhaverbeke.nl/git/acorn
            //     https://github.com/ternjs/acorn.git
            //
            // Please use the [github bug tracker][ghbt] to report issues.
            //
            // [ghbt]: https://github.com/ternjs/acorn/issues
            //
            // This file defines the main parser interface. The library also comes
            // with a [error-tolerant parser][dammit] and an
            // [abstract syntax tree walker][walk], defined in other files.
            //
            // [dammit]: acorn_loose.js
            // [walk]: util/walk.js

            "use strict";

            exports.__esModule = true;
            exports.parse = parse;
            exports.parseExpressionAt = parseExpressionAt;
            exports.tokenizer = tokenizer;

            var _state = _dereq_("./state");

            _dereq_("./parseutil");

            _dereq_("./statement");

            _dereq_("./lval");

            _dereq_("./expression");

            _dereq_("./location");

            exports.Parser = _state.Parser;
            exports.plugins = _state.plugins;

            var _options = _dereq_("./options");

            exports.defaultOptions = _options.defaultOptions;

            var _locutil = _dereq_("./locutil");

            exports.Position = _locutil.Position;
            exports.SourceLocation = _locutil.SourceLocation;
            exports.getLineInfo = _locutil.getLineInfo;

            var _node = _dereq_("./node");

            exports.Node = _node.Node;

            var _tokentype = _dereq_("./tokentype");

            exports.TokenType = _tokentype.TokenType;
            exports.tokTypes = _tokentype.types;

            var _tokencontext = _dereq_("./tokencontext");

            exports.TokContext = _tokencontext.TokContext;
            exports.tokContexts = _tokencontext.types;

            var _identifier = _dereq_("./identifier");

            exports.isIdentifierChar = _identifier.isIdentifierChar;
            exports.isIdentifierStart = _identifier.isIdentifierStart;

            var _tokenize = _dereq_("./tokenize");

            exports.Token = _tokenize.Token;

            var _whitespace = _dereq_("./whitespace");

            exports.isNewLine = _whitespace.isNewLine;
            exports.lineBreak = _whitespace.lineBreak;
            exports.lineBreakG = _whitespace.lineBreakG;
            var version = "2.7.0";

            exports.version = version;
            // The main exported interface (under `self.acorn` when in the
            // browser) is a `parse` function that takes a code string and
            // returns an abstract syntax tree as specified by [Mozilla parser
            // API][api].
            //
            // [api]: https://developer.mozilla.org/en-US/docs/SpiderMonkey/Parser_API

            function parse(input, options) {
              return new _state.Parser(options, input).parse();
            }

            // This function tries to parse a single expression at a given
            // offset in a string. Useful for parsing mixed-language formats
            // that embed JavaScript expressions.

            function parseExpressionAt(input, pos, options) {
              var p = new _state.Parser(options, input, pos);
              p.nextToken();
              return p.parseExpression();
            }

            // Acorn is organized as a tokenizer and a recursive-descent parser.
            // The `tokenizer` export provides an interface to the tokenizer.

            function tokenizer(input, options) {
              return new _state.Parser(options, input);
            }

            },{"./expression":1,"./identifier":2,"./location":4,"./locutil":5,"./lval":6,"./node":7,"./options":8,"./parseutil":9,"./state":10,"./statement":11,"./tokencontext":12,"./tokenize":13,"./tokentype":14,"./whitespace":16}],4:[function(_dereq_,module,exports){
            "use strict";

            var _state = _dereq_("./state");

            var _locutil = _dereq_("./locutil");

            var pp = _state.Parser.prototype;

            // This function is used to raise exceptions on parse errors. It
            // takes an offset integer (into the current `input`) to indicate
            // the location of the error, attaches the position to the end
            // of the error message, and then raises a `SyntaxError` with that
            // message.

            pp.raise = function (pos, message) {
              var loc = _locutil.getLineInfo(this.input, pos);
              message += " (" + loc.line + ":" + loc.column + ")";
              var err = new SyntaxError(message);
              err.pos = pos;err.loc = loc;err.raisedAt = this.pos;
              throw err;
            };

            pp.curPosition = function () {
              if (this.options.locations) {
                return new _locutil.Position(this.curLine, this.pos - this.lineStart);
              }
            };

            },{"./locutil":5,"./state":10}],5:[function(_dereq_,module,exports){
            "use strict";

            exports.__esModule = true;
            exports.getLineInfo = getLineInfo;

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var _whitespace = _dereq_("./whitespace");

            // These are used when `options.locations` is on, for the
            // `startLoc` and `endLoc` properties.

            var Position = (function () {
              function Position(line, col) {
                _classCallCheck(this, Position);

                this.line = line;
                this.column = col;
              }

              Position.prototype.offset = function offset(n) {
                return new Position(this.line, this.column + n);
              };

              return Position;
            })();

            exports.Position = Position;

            var SourceLocation = function SourceLocation(p, start, end) {
              _classCallCheck(this, SourceLocation);

              this.start = start;
              this.end = end;
              if (p.sourceFile !== null) this.source = p.sourceFile;
            }

            // The `getLineInfo` function is mostly useful when the
            // `locations` option is off (for performance reasons) and you
            // want to find the line/column position for a given character
            // offset. `input` should be the code string that the offset refers
            // into.

            ;

            exports.SourceLocation = SourceLocation;

            function getLineInfo(input, offset) {
              for (var line = 1, cur = 0;;) {
                _whitespace.lineBreakG.lastIndex = cur;
                var match = _whitespace.lineBreakG.exec(input);
                if (match && match.index < offset) {
                  ++line;
                  cur = match.index + match[0].length;
                } else {
                  return new Position(line, offset - cur);
                }
              }
            }

            },{"./whitespace":16}],6:[function(_dereq_,module,exports){
            "use strict";

            var _tokentype = _dereq_("./tokentype");

            var _state = _dereq_("./state");

            var _util = _dereq_("./util");

            var pp = _state.Parser.prototype;

            // Convert existing expression atom to assignable pattern
            // if possible.

            pp.toAssignable = function (node, isBinding) {
              if (this.options.ecmaVersion >= 6 && node) {
                switch (node.type) {
                  case "Identifier":
                  case "ObjectPattern":
                  case "ArrayPattern":
                    break;

                  case "ObjectExpression":
                    node.type = "ObjectPattern";
                    for (var i = 0; i < node.properties.length; i++) {
                      var prop = node.properties[i];
                      if (prop.kind !== "init") this.raise(prop.key.start, "Object pattern can't contain getter or setter");
                      this.toAssignable(prop.value, isBinding);
                    }
                    break;

                  case "ArrayExpression":
                    node.type = "ArrayPattern";
                    this.toAssignableList(node.elements, isBinding);
                    break;

                  case "AssignmentExpression":
                    if (node.operator === "=") {
                      node.type = "AssignmentPattern";
                      delete node.operator;
                      // falls through to AssignmentPattern
                    } else {
                        this.raise(node.left.end, "Only '=' operator can be used for specifying default value.");
                        break;
                      }

                  case "AssignmentPattern":
                    if (node.right.type === "YieldExpression") this.raise(node.right.start, "Yield expression cannot be a default value");
                    break;

                  case "ParenthesizedExpression":
                    node.expression = this.toAssignable(node.expression, isBinding);
                    break;

                  case "MemberExpression":
                    if (!isBinding) break;

                  default:
                    this.raise(node.start, "Assigning to rvalue");
                }
              }
              return node;
            };

            // Convert list of expression atoms to binding list.

            pp.toAssignableList = function (exprList, isBinding) {
              var end = exprList.length;
              if (end) {
                var last = exprList[end - 1];
                if (last && last.type == "RestElement") {
                  --end;
                } else if (last && last.type == "SpreadElement") {
                  last.type = "RestElement";
                  var arg = last.argument;
                  this.toAssignable(arg, isBinding);
                  if (arg.type !== "Identifier" && arg.type !== "MemberExpression" && arg.type !== "ArrayPattern") this.unexpected(arg.start);
                  --end;
                }

                if (isBinding && last.type === "RestElement" && last.argument.type !== "Identifier") this.unexpected(last.argument.start);
              }
              for (var i = 0; i < end; i++) {
                var elt = exprList[i];
                if (elt) this.toAssignable(elt, isBinding);
              }
              return exprList;
            };

            // Parses spread element.

            pp.parseSpread = function (refDestructuringErrors) {
              var node = this.startNode();
              this.next();
              node.argument = this.parseMaybeAssign(refDestructuringErrors);
              return this.finishNode(node, "SpreadElement");
            };

            pp.parseRest = function (allowNonIdent) {
              var node = this.startNode();
              this.next();

              // RestElement inside of a function parameter must be an identifier
              if (allowNonIdent) node.argument = this.type === _tokentype.types.name ? this.parseIdent() : this.unexpected();else node.argument = this.type === _tokentype.types.name || this.type === _tokentype.types.bracketL ? this.parseBindingAtom() : this.unexpected();

              return this.finishNode(node, "RestElement");
            };

            // Parses lvalue (assignable) atom.

            pp.parseBindingAtom = function () {
              if (this.options.ecmaVersion < 6) return this.parseIdent();
              switch (this.type) {
                case _tokentype.types.name:
                  return this.parseIdent();

                case _tokentype.types.bracketL:
                  var node = this.startNode();
                  this.next();
                  node.elements = this.parseBindingList(_tokentype.types.bracketR, true, true);
                  return this.finishNode(node, "ArrayPattern");

                case _tokentype.types.braceL:
                  return this.parseObj(true);

                default:
                  this.unexpected();
              }
            };

            pp.parseBindingList = function (close, allowEmpty, allowTrailingComma, allowNonIdent) {
              var elts = [],
                  first = true;
              while (!this.eat(close)) {
                if (first) first = false;else this.expect(_tokentype.types.comma);
                if (allowEmpty && this.type === _tokentype.types.comma) {
                  elts.push(null);
                } else if (allowTrailingComma && this.afterTrailingComma(close)) {
                  break;
                } else if (this.type === _tokentype.types.ellipsis) {
                  var rest = this.parseRest(allowNonIdent);
                  this.parseBindingListItem(rest);
                  elts.push(rest);
                  this.expect(close);
                  break;
                } else {
                  var elem = this.parseMaybeDefault(this.start, this.startLoc);
                  this.parseBindingListItem(elem);
                  elts.push(elem);
                }
              }
              return elts;
            };

            pp.parseBindingListItem = function (param) {
              return param;
            };

            // Parses assignment pattern around given atom if possible.

            pp.parseMaybeDefault = function (startPos, startLoc, left) {
              left = left || this.parseBindingAtom();
              if (this.options.ecmaVersion < 6 || !this.eat(_tokentype.types.eq)) return left;
              var node = this.startNodeAt(startPos, startLoc);
              node.left = left;
              node.right = this.parseMaybeAssign();
              return this.finishNode(node, "AssignmentPattern");
            };

            // Verify that a node is an lval — something that can be assigned
            // to.

            pp.checkLVal = function (expr, isBinding, checkClashes) {
              switch (expr.type) {
                case "Identifier":
                  if (this.strict && this.reservedWordsStrictBind.test(expr.name)) this.raise(expr.start, (isBinding ? "Binding " : "Assigning to ") + expr.name + " in strict mode");
                  if (checkClashes) {
                    if (_util.has(checkClashes, expr.name)) this.raise(expr.start, "Argument name clash");
                    checkClashes[expr.name] = true;
                  }
                  break;

                case "MemberExpression":
                  if (isBinding) this.raise(expr.start, (isBinding ? "Binding" : "Assigning to") + " member expression");
                  break;

                case "ObjectPattern":
                  for (var i = 0; i < expr.properties.length; i++) {
                    this.checkLVal(expr.properties[i].value, isBinding, checkClashes);
                  }break;

                case "ArrayPattern":
                  for (var i = 0; i < expr.elements.length; i++) {
                    var elem = expr.elements[i];
                    if (elem) this.checkLVal(elem, isBinding, checkClashes);
                  }
                  break;

                case "AssignmentPattern":
                  this.checkLVal(expr.left, isBinding, checkClashes);
                  break;

                case "RestElement":
                  this.checkLVal(expr.argument, isBinding, checkClashes);
                  break;

                case "ParenthesizedExpression":
                  this.checkLVal(expr.expression, isBinding, checkClashes);
                  break;

                default:
                  this.raise(expr.start, (isBinding ? "Binding" : "Assigning to") + " rvalue");
              }
            };

            },{"./state":10,"./tokentype":14,"./util":15}],7:[function(_dereq_,module,exports){
            "use strict";

            exports.__esModule = true;

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var _state = _dereq_("./state");

            var _locutil = _dereq_("./locutil");

            var Node = function Node(parser, pos, loc) {
              _classCallCheck(this, Node);

              this.type = "";
              this.start = pos;
              this.end = 0;
              if (parser.options.locations) this.loc = new _locutil.SourceLocation(parser, loc);
              if (parser.options.directSourceFile) this.sourceFile = parser.options.directSourceFile;
              if (parser.options.ranges) this.range = [pos, 0];
            }

            // Start an AST node, attaching a start offset.

            ;

            exports.Node = Node;
            var pp = _state.Parser.prototype;

            pp.startNode = function () {
              return new Node(this, this.start, this.startLoc);
            };

            pp.startNodeAt = function (pos, loc) {
              return new Node(this, pos, loc);
            };

            // Finish an AST node, adding `type` and `end` properties.

            function finishNodeAt(node, type, pos, loc) {
              node.type = type;
              node.end = pos;
              if (this.options.locations) node.loc.end = loc;
              if (this.options.ranges) node.range[1] = pos;
              return node;
            }

            pp.finishNode = function (node, type) {
              return finishNodeAt.call(this, node, type, this.lastTokEnd, this.lastTokEndLoc);
            };

            // Finish node at given position

            pp.finishNodeAt = function (node, type, pos, loc) {
              return finishNodeAt.call(this, node, type, pos, loc);
            };

            },{"./locutil":5,"./state":10}],8:[function(_dereq_,module,exports){
            "use strict";

            exports.__esModule = true;
            exports.getOptions = getOptions;

            var _util = _dereq_("./util");

            var _locutil = _dereq_("./locutil");

            // A second optional argument can be given to further configure
            // the parser process. These options are recognized:

            var defaultOptions = {
              // `ecmaVersion` indicates the ECMAScript version to parse. Must
              // be either 3, or 5, or 6. This influences support for strict
              // mode, the set of reserved words, support for getters and
              // setters and other features.
              ecmaVersion: 5,
              // Source type ("script" or "module") for different semantics
              sourceType: "script",
              // `onInsertedSemicolon` can be a callback that will be called
              // when a semicolon is automatically inserted. It will be passed
              // th position of the comma as an offset, and if `locations` is
              // enabled, it is given the location as a `{line, column}` object
              // as second argument.
              onInsertedSemicolon: null,
              // `onTrailingComma` is similar to `onInsertedSemicolon`, but for
              // trailing commas.
              onTrailingComma: null,
              // By default, reserved words are only enforced if ecmaVersion >= 5.
              // Set `allowReserved` to a boolean value to explicitly turn this on
              // an off. When this option has the value "never", reserved words
              // and keywords can also not be used as property names.
              allowReserved: null,
              // When enabled, a return at the top level is not considered an
              // error.
              allowReturnOutsideFunction: false,
              // When enabled, import/export statements are not constrained to
              // appearing at the top of the program.
              allowImportExportEverywhere: false,
              // When enabled, hashbang directive in the beginning of file
              // is allowed and treated as a line comment.
              allowHashBang: false,
              // When `locations` is on, `loc` properties holding objects with
              // `start` and `end` properties in `{line, column}` form (with
              // line being 1-based and column 0-based) will be attached to the
              // nodes.
              locations: false,
              // A function can be passed as `onToken` option, which will
              // cause Acorn to call that function with object in the same
              // format as tokens returned from `tokenizer().getToken()`. Note
              // that you are not allowed to call the parser from the
              // callback—that will corrupt its internal state.
              onToken: null,
              // A function can be passed as `onComment` option, which will
              // cause Acorn to call that function with `(block, text, start,
              // end)` parameters whenever a comment is skipped. `block` is a
              // boolean indicating whether this is a block (`/* */`) comment,
              // `text` is the content of the comment, and `start` and `end` are
              // character offsets that denote the start and end of the comment.
              // When the `locations` option is on, two more parameters are
              // passed, the full `{line, column}` locations of the start and
              // end of the comments. Note that you are not allowed to call the
              // parser from the callback—that will corrupt its internal state.
              onComment: null,
              // Nodes have their start and end characters offsets recorded in
              // `start` and `end` properties (directly on the node, rather than
              // the `loc` object, which holds line/column data. To also add a
              // [semi-standardized][range] `range` property holding a `[start,
              // end]` array with the same numbers, set the `ranges` option to
              // `true`.
              //
              // [range]: https://bugzilla.mozilla.org/show_bug.cgi?id=745678
              ranges: false,
              // It is possible to parse multiple files into a single AST by
              // passing the tree produced by parsing the first file as
              // `program` option in subsequent parses. This will add the
              // toplevel forms of the parsed file to the `Program` (top) node
              // of an existing parse tree.
              program: null,
              // When `locations` is on, you can pass this to record the source
              // file in every node's `loc` object.
              sourceFile: null,
              // This value, if given, is stored in every node, whether
              // `locations` is on or off.
              directSourceFile: null,
              // When enabled, parenthesized expressions are represented by
              // (non-standard) ParenthesizedExpression nodes
              preserveParens: false,
              plugins: {}
            };

            exports.defaultOptions = defaultOptions;
            // Interpret and default an options object

            function getOptions(opts) {
              var options = {};
              for (var opt in defaultOptions) {
                options[opt] = opts && _util.has(opts, opt) ? opts[opt] : defaultOptions[opt];
              }if (options.allowReserved == null) options.allowReserved = options.ecmaVersion < 5;

              if (_util.isArray(options.onToken)) {
                (function () {
                  var tokens = options.onToken;
                  options.onToken = function (token) {
                    return tokens.push(token);
                  };
                })();
              }
              if (_util.isArray(options.onComment)) options.onComment = pushComment(options, options.onComment);

              return options;
            }

            function pushComment(options, array) {
              return function (block, text, start, end, startLoc, endLoc) {
                var comment = {
                  type: block ? 'Block' : 'Line',
                  value: text,
                  start: start,
                  end: end
                };
                if (options.locations) comment.loc = new _locutil.SourceLocation(this, startLoc, endLoc);
                if (options.ranges) comment.range = [start, end];
                array.push(comment);
              };
            }

            },{"./locutil":5,"./util":15}],9:[function(_dereq_,module,exports){
            "use strict";

            var _tokentype = _dereq_("./tokentype");

            var _state = _dereq_("./state");

            var _whitespace = _dereq_("./whitespace");

            var pp = _state.Parser.prototype;

            // ## Parser utilities

            // Test whether a statement node is the string literal `"use strict"`.

            pp.isUseStrict = function (stmt) {
              return this.options.ecmaVersion >= 5 && stmt.type === "ExpressionStatement" && stmt.expression.type === "Literal" && stmt.expression.raw.slice(1, -1) === "use strict";
            };

            // Predicate that tests whether the next token is of the given
            // type, and if yes, consumes it as a side effect.

            pp.eat = function (type) {
              if (this.type === type) {
                this.next();
                return true;
              } else {
                return false;
              }
            };

            // Tests whether parsed token is a contextual keyword.

            pp.isContextual = function (name) {
              return this.type === _tokentype.types.name && this.value === name;
            };

            // Consumes contextual keyword if possible.

            pp.eatContextual = function (name) {
              return this.value === name && this.eat(_tokentype.types.name);
            };

            // Asserts that following token is given contextual keyword.

            pp.expectContextual = function (name) {
              if (!this.eatContextual(name)) this.unexpected();
            };

            // Test whether a semicolon can be inserted at the current position.

            pp.canInsertSemicolon = function () {
              return this.type === _tokentype.types.eof || this.type === _tokentype.types.braceR || _whitespace.lineBreak.test(this.input.slice(this.lastTokEnd, this.start));
            };

            pp.insertSemicolon = function () {
              if (this.canInsertSemicolon()) {
                if (this.options.onInsertedSemicolon) this.options.onInsertedSemicolon(this.lastTokEnd, this.lastTokEndLoc);
                return true;
              }
            };

            // Consume a semicolon, or, failing that, see if we are allowed to
            // pretend that there is a semicolon at this position.

            pp.semicolon = function () {
              if (!this.eat(_tokentype.types.semi) && !this.insertSemicolon()) this.unexpected();
            };

            pp.afterTrailingComma = function (tokType) {
              if (this.type == tokType) {
                if (this.options.onTrailingComma) this.options.onTrailingComma(this.lastTokStart, this.lastTokStartLoc);
                this.next();
                return true;
              }
            };

            // Expect a token of a given type. If found, consume it, otherwise,
            // raise an unexpected token error.

            pp.expect = function (type) {
              this.eat(type) || this.unexpected();
            };

            // Raise an unexpected token error.

            pp.unexpected = function (pos) {
              this.raise(pos != null ? pos : this.start, "Unexpected token");
            };

            pp.checkPatternErrors = function (refDestructuringErrors, andThrow) {
              var pos = refDestructuringErrors && refDestructuringErrors.trailingComma;
              if (!andThrow) return !!pos;
              if (pos) this.raise(pos, "Trailing comma is not permitted in destructuring patterns");
            };

            pp.checkExpressionErrors = function (refDestructuringErrors, andThrow) {
              var pos = refDestructuringErrors && refDestructuringErrors.shorthandAssign;
              if (!andThrow) return !!pos;
              if (pos) this.raise(pos, "Shorthand property assignments are valid only in destructuring patterns");
            };

            },{"./state":10,"./tokentype":14,"./whitespace":16}],10:[function(_dereq_,module,exports){
            "use strict";

            exports.__esModule = true;

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var _identifier = _dereq_("./identifier");

            var _tokentype = _dereq_("./tokentype");

            var _whitespace = _dereq_("./whitespace");

            var _options = _dereq_("./options");

            // Registered plugins
            var plugins = {};

            exports.plugins = plugins;
            function keywordRegexp(words) {
              return new RegExp("^(" + words.replace(/ /g, "|") + ")$");
            }

            var Parser = (function () {
              function Parser(options, input, startPos) {
                _classCallCheck(this, Parser);

                this.options = options = _options.getOptions(options);
                this.sourceFile = options.sourceFile;
                this.keywords = keywordRegexp(_identifier.keywords[options.ecmaVersion >= 6 ? 6 : 5]);
                var reserved = options.allowReserved ? "" : _identifier.reservedWords[options.ecmaVersion] + (options.sourceType == "module" ? " await" : "");
                this.reservedWords = keywordRegexp(reserved);
                var reservedStrict = (reserved ? reserved + " " : "") + _identifier.reservedWords.strict;
                this.reservedWordsStrict = keywordRegexp(reservedStrict);
                this.reservedWordsStrictBind = keywordRegexp(reservedStrict + " " + _identifier.reservedWords.strictBind);
                this.input = String(input);

                // Used to signal to callers of `readWord1` whether the word
                // contained any escape sequences. This is needed because words with
                // escape sequences must not be interpreted as keywords.
                this.containsEsc = false;

                // Load plugins
                this.loadPlugins(options.plugins);

                // Set up token state

                // The current position of the tokenizer in the input.
                if (startPos) {
                  this.pos = startPos;
                  this.lineStart = Math.max(0, this.input.lastIndexOf("\n", startPos));
                  this.curLine = this.input.slice(0, this.lineStart).split(_whitespace.lineBreak).length;
                } else {
                  this.pos = this.lineStart = 0;
                  this.curLine = 1;
                }

                // Properties of the current token:
                // Its type
                this.type = _tokentype.types.eof;
                // For tokens that include more information than their type, the value
                this.value = null;
                // Its start and end offset
                this.start = this.end = this.pos;
                // And, if locations are used, the {line, column} object
                // corresponding to those offsets
                this.startLoc = this.endLoc = this.curPosition();

                // Position information for the previous token
                this.lastTokEndLoc = this.lastTokStartLoc = null;
                this.lastTokStart = this.lastTokEnd = this.pos;

                // The context stack is used to superficially track syntactic
                // context to predict whether a regular expression is allowed in a
                // given position.
                this.context = this.initialContext();
                this.exprAllowed = true;

                // Figure out if it's a module code.
                this.strict = this.inModule = options.sourceType === "module";

                // Used to signify the start of a potential arrow function
                this.potentialArrowAt = -1;

                // Flags to track whether we are in a function, a generator.
                this.inFunction = this.inGenerator = false;
                // Labels in scope.
                this.labels = [];

                // If enabled, skip leading hashbang line.
                if (this.pos === 0 && options.allowHashBang && this.input.slice(0, 2) === '#!') this.skipLineComment(2);
              }

              // DEPRECATED Kept for backwards compatibility until 3.0 in case a plugin uses them

              Parser.prototype.isKeyword = function isKeyword(word) {
                return this.keywords.test(word);
              };

              Parser.prototype.isReservedWord = function isReservedWord(word) {
                return this.reservedWords.test(word);
              };

              Parser.prototype.extend = function extend(name, f) {
                this[name] = f(this[name]);
              };

              Parser.prototype.loadPlugins = function loadPlugins(pluginConfigs) {
                for (var _name in pluginConfigs) {
                  var plugin = plugins[_name];
                  if (!plugin) throw new Error("Plugin '" + _name + "' not found");
                  plugin(this, pluginConfigs[_name]);
                }
              };

              Parser.prototype.parse = function parse() {
                var node = this.options.program || this.startNode();
                this.nextToken();
                return this.parseTopLevel(node);
              };

              return Parser;
            })();

            exports.Parser = Parser;

            },{"./identifier":2,"./options":8,"./tokentype":14,"./whitespace":16}],11:[function(_dereq_,module,exports){
            "use strict";

            var _tokentype = _dereq_("./tokentype");

            var _state = _dereq_("./state");

            var _whitespace = _dereq_("./whitespace");

            var pp = _state.Parser.prototype;

            // ### Statement parsing

            // Parse a program. Initializes the parser, reads any number of
            // statements, and wraps them in a Program node.  Optionally takes a
            // `program` argument.  If present, the statements will be appended
            // to its body instead of creating a new node.

            pp.parseTopLevel = function (node) {
              var first = true;
              if (!node.body) node.body = [];
              while (this.type !== _tokentype.types.eof) {
                var stmt = this.parseStatement(true, true);
                node.body.push(stmt);
                if (first) {
                  if (this.isUseStrict(stmt)) this.setStrict(true);
                  first = false;
                }
              }
              this.next();
              if (this.options.ecmaVersion >= 6) {
                node.sourceType = this.options.sourceType;
              }
              return this.finishNode(node, "Program");
            };

            var loopLabel = { kind: "loop" },
                switchLabel = { kind: "switch" };

            // Parse a single statement.
            //
            // If expecting a statement and finding a slash operator, parse a
            // regular expression literal. This is to handle cases like
            // `if (foo) /blah/.exec(foo)`, where looking at the previous token
            // does not help.

            pp.parseStatement = function (declaration, topLevel) {
              var starttype = this.type,
                  node = this.startNode();

              // Most types of statements are recognized by the keyword they
              // start with. Many are trivial to parse, some require a bit of
              // complexity.

              switch (starttype) {
                case _tokentype.types._break:case _tokentype.types._continue:
                  return this.parseBreakContinueStatement(node, starttype.keyword);
                case _tokentype.types._debugger:
                  return this.parseDebuggerStatement(node);
                case _tokentype.types._do:
                  return this.parseDoStatement(node);
                case _tokentype.types._for:
                  return this.parseForStatement(node);
                case _tokentype.types._function:
                  if (!declaration && this.options.ecmaVersion >= 6) this.unexpected();
                  return this.parseFunctionStatement(node);
                case _tokentype.types._class:
                  if (!declaration) this.unexpected();
                  return this.parseClass(node, true);
                case _tokentype.types._if:
                  return this.parseIfStatement(node);
                case _tokentype.types._return:
                  return this.parseReturnStatement(node);
                case _tokentype.types._switch:
                  return this.parseSwitchStatement(node);
                case _tokentype.types._throw:
                  return this.parseThrowStatement(node);
                case _tokentype.types._try:
                  return this.parseTryStatement(node);
                case _tokentype.types._let:case _tokentype.types._const:
                  if (!declaration) this.unexpected(); // NOTE: falls through to _var
                case _tokentype.types._var:
                  return this.parseVarStatement(node, starttype);
                case _tokentype.types._while:
                  return this.parseWhileStatement(node);
                case _tokentype.types._with:
                  return this.parseWithStatement(node);
                case _tokentype.types.braceL:
                  return this.parseBlock();
                case _tokentype.types.semi:
                  return this.parseEmptyStatement(node);
                case _tokentype.types._export:
                case _tokentype.types._import:
                  if (!this.options.allowImportExportEverywhere) {
                    if (!topLevel) this.raise(this.start, "'import' and 'export' may only appear at the top level");
                    if (!this.inModule) this.raise(this.start, "'import' and 'export' may appear only with 'sourceType: module'");
                  }
                  return starttype === _tokentype.types._import ? this.parseImport(node) : this.parseExport(node);

                // If the statement does not start with a statement keyword or a
                // brace, it's an ExpressionStatement or LabeledStatement. We
                // simply start parsing an expression, and afterwards, if the
                // next token is a colon and the expression was a simple
                // Identifier node, we switch to interpreting it as a label.
                default:
                  var maybeName = this.value,
                      expr = this.parseExpression();
                  if (starttype === _tokentype.types.name && expr.type === "Identifier" && this.eat(_tokentype.types.colon)) return this.parseLabeledStatement(node, maybeName, expr);else return this.parseExpressionStatement(node, expr);
              }
            };

            pp.parseBreakContinueStatement = function (node, keyword) {
              var isBreak = keyword == "break";
              this.next();
              if (this.eat(_tokentype.types.semi) || this.insertSemicolon()) node.label = null;else if (this.type !== _tokentype.types.name) this.unexpected();else {
                node.label = this.parseIdent();
                this.semicolon();
              }

              // Verify that there is an actual destination to break or
              // continue to.
              for (var i = 0; i < this.labels.length; ++i) {
                var lab = this.labels[i];
                if (node.label == null || lab.name === node.label.name) {
                  if (lab.kind != null && (isBreak || lab.kind === "loop")) break;
                  if (node.label && isBreak) break;
                }
              }
              if (i === this.labels.length) this.raise(node.start, "Unsyntactic " + keyword);
              return this.finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement");
            };

            pp.parseDebuggerStatement = function (node) {
              this.next();
              this.semicolon();
              return this.finishNode(node, "DebuggerStatement");
            };

            pp.parseDoStatement = function (node) {
              this.next();
              this.labels.push(loopLabel);
              node.body = this.parseStatement(false);
              this.labels.pop();
              this.expect(_tokentype.types._while);
              node.test = this.parseParenExpression();
              if (this.options.ecmaVersion >= 6) this.eat(_tokentype.types.semi);else this.semicolon();
              return this.finishNode(node, "DoWhileStatement");
            };

            // Disambiguating between a `for` and a `for`/`in` or `for`/`of`
            // loop is non-trivial. Basically, we have to parse the init `var`
            // statement or expression, disallowing the `in` operator (see
            // the second parameter to `parseExpression`), and then check
            // whether the next token is `in` or `of`. When there is no init
            // part (semicolon immediately after the opening parenthesis), it
            // is a regular `for` loop.

            pp.parseForStatement = function (node) {
              this.next();
              this.labels.push(loopLabel);
              this.expect(_tokentype.types.parenL);
              if (this.type === _tokentype.types.semi) return this.parseFor(node, null);
              if (this.type === _tokentype.types._var || this.type === _tokentype.types._let || this.type === _tokentype.types._const) {
                var _init = this.startNode(),
                    varKind = this.type;
                this.next();
                this.parseVar(_init, true, varKind);
                this.finishNode(_init, "VariableDeclaration");
                if ((this.type === _tokentype.types._in || this.options.ecmaVersion >= 6 && this.isContextual("of")) && _init.declarations.length === 1 && !(varKind !== _tokentype.types._var && _init.declarations[0].init)) return this.parseForIn(node, _init);
                return this.parseFor(node, _init);
              }
              var refDestructuringErrors = { shorthandAssign: 0, trailingComma: 0 };
              var init = this.parseExpression(true, refDestructuringErrors);
              if (this.type === _tokentype.types._in || this.options.ecmaVersion >= 6 && this.isContextual("of")) {
                this.checkPatternErrors(refDestructuringErrors, true);
                this.toAssignable(init);
                this.checkLVal(init);
                return this.parseForIn(node, init);
              } else {
                this.checkExpressionErrors(refDestructuringErrors, true);
              }
              return this.parseFor(node, init);
            };

            pp.parseFunctionStatement = function (node) {
              this.next();
              return this.parseFunction(node, true);
            };

            pp.parseIfStatement = function (node) {
              this.next();
              node.test = this.parseParenExpression();
              node.consequent = this.parseStatement(false);
              node.alternate = this.eat(_tokentype.types._else) ? this.parseStatement(false) : null;
              return this.finishNode(node, "IfStatement");
            };

            pp.parseReturnStatement = function (node) {
              if (!this.inFunction && !this.options.allowReturnOutsideFunction) this.raise(this.start, "'return' outside of function");
              this.next();

              // In `return` (and `break`/`continue`), the keywords with
              // optional arguments, we eagerly look for a semicolon or the
              // possibility to insert one.

              if (this.eat(_tokentype.types.semi) || this.insertSemicolon()) node.argument = null;else {
                node.argument = this.parseExpression();this.semicolon();
              }
              return this.finishNode(node, "ReturnStatement");
            };

            pp.parseSwitchStatement = function (node) {
              this.next();
              node.discriminant = this.parseParenExpression();
              node.cases = [];
              this.expect(_tokentype.types.braceL);
              this.labels.push(switchLabel);

              // Statements under must be grouped (by label) in SwitchCase
              // nodes. `cur` is used to keep the node that we are currently
              // adding statements to.

              for (var cur, sawDefault = false; this.type != _tokentype.types.braceR;) {
                if (this.type === _tokentype.types._case || this.type === _tokentype.types._default) {
                  var isCase = this.type === _tokentype.types._case;
                  if (cur) this.finishNode(cur, "SwitchCase");
                  node.cases.push(cur = this.startNode());
                  cur.consequent = [];
                  this.next();
                  if (isCase) {
                    cur.test = this.parseExpression();
                  } else {
                    if (sawDefault) this.raise(this.lastTokStart, "Multiple default clauses");
                    sawDefault = true;
                    cur.test = null;
                  }
                  this.expect(_tokentype.types.colon);
                } else {
                  if (!cur) this.unexpected();
                  cur.consequent.push(this.parseStatement(true));
                }
              }
              if (cur) this.finishNode(cur, "SwitchCase");
              this.next(); // Closing brace
              this.labels.pop();
              return this.finishNode(node, "SwitchStatement");
            };

            pp.parseThrowStatement = function (node) {
              this.next();
              if (_whitespace.lineBreak.test(this.input.slice(this.lastTokEnd, this.start))) this.raise(this.lastTokEnd, "Illegal newline after throw");
              node.argument = this.parseExpression();
              this.semicolon();
              return this.finishNode(node, "ThrowStatement");
            };

            // Reused empty array added for node fields that are always empty.

            var empty = [];

            pp.parseTryStatement = function (node) {
              this.next();
              node.block = this.parseBlock();
              node.handler = null;
              if (this.type === _tokentype.types._catch) {
                var clause = this.startNode();
                this.next();
                this.expect(_tokentype.types.parenL);
                clause.param = this.parseBindingAtom();
                this.checkLVal(clause.param, true);
                this.expect(_tokentype.types.parenR);
                clause.body = this.parseBlock();
                node.handler = this.finishNode(clause, "CatchClause");
              }
              node.finalizer = this.eat(_tokentype.types._finally) ? this.parseBlock() : null;
              if (!node.handler && !node.finalizer) this.raise(node.start, "Missing catch or finally clause");
              return this.finishNode(node, "TryStatement");
            };

            pp.parseVarStatement = function (node, kind) {
              this.next();
              this.parseVar(node, false, kind);
              this.semicolon();
              return this.finishNode(node, "VariableDeclaration");
            };

            pp.parseWhileStatement = function (node) {
              this.next();
              node.test = this.parseParenExpression();
              this.labels.push(loopLabel);
              node.body = this.parseStatement(false);
              this.labels.pop();
              return this.finishNode(node, "WhileStatement");
            };

            pp.parseWithStatement = function (node) {
              if (this.strict) this.raise(this.start, "'with' in strict mode");
              this.next();
              node.object = this.parseParenExpression();
              node.body = this.parseStatement(false);
              return this.finishNode(node, "WithStatement");
            };

            pp.parseEmptyStatement = function (node) {
              this.next();
              return this.finishNode(node, "EmptyStatement");
            };

            pp.parseLabeledStatement = function (node, maybeName, expr) {
              for (var i = 0; i < this.labels.length; ++i) {
                if (this.labels[i].name === maybeName) this.raise(expr.start, "Label '" + maybeName + "' is already declared");
              }var kind = this.type.isLoop ? "loop" : this.type === _tokentype.types._switch ? "switch" : null;
              for (var i = this.labels.length - 1; i >= 0; i--) {
                var label = this.labels[i];
                if (label.statementStart == node.start) {
                  label.statementStart = this.start;
                  label.kind = kind;
                } else break;
              }
              this.labels.push({ name: maybeName, kind: kind, statementStart: this.start });
              node.body = this.parseStatement(true);
              this.labels.pop();
              node.label = expr;
              return this.finishNode(node, "LabeledStatement");
            };

            pp.parseExpressionStatement = function (node, expr) {
              node.expression = expr;
              this.semicolon();
              return this.finishNode(node, "ExpressionStatement");
            };

            // Parse a semicolon-enclosed block of statements, handling `"use
            // strict"` declarations when `allowStrict` is true (used for
            // function bodies).

            pp.parseBlock = function (allowStrict) {
              var node = this.startNode(),
                  first = true,
                  oldStrict = undefined;
              node.body = [];
              this.expect(_tokentype.types.braceL);
              while (!this.eat(_tokentype.types.braceR)) {
                var stmt = this.parseStatement(true);
                node.body.push(stmt);
                if (first && allowStrict && this.isUseStrict(stmt)) {
                  oldStrict = this.strict;
                  this.setStrict(this.strict = true);
                }
                first = false;
              }
              if (oldStrict === false) this.setStrict(false);
              return this.finishNode(node, "BlockStatement");
            };

            // Parse a regular `for` loop. The disambiguation code in
            // `parseStatement` will already have parsed the init statement or
            // expression.

            pp.parseFor = function (node, init) {
              node.init = init;
              this.expect(_tokentype.types.semi);
              node.test = this.type === _tokentype.types.semi ? null : this.parseExpression();
              this.expect(_tokentype.types.semi);
              node.update = this.type === _tokentype.types.parenR ? null : this.parseExpression();
              this.expect(_tokentype.types.parenR);
              node.body = this.parseStatement(false);
              this.labels.pop();
              return this.finishNode(node, "ForStatement");
            };

            // Parse a `for`/`in` and `for`/`of` loop, which are almost
            // same from parser's perspective.

            pp.parseForIn = function (node, init) {
              var type = this.type === _tokentype.types._in ? "ForInStatement" : "ForOfStatement";
              this.next();
              node.left = init;
              node.right = this.parseExpression();
              this.expect(_tokentype.types.parenR);
              node.body = this.parseStatement(false);
              this.labels.pop();
              return this.finishNode(node, type);
            };

            // Parse a list of variable declarations.

            pp.parseVar = function (node, isFor, kind) {
              node.declarations = [];
              node.kind = kind.keyword;
              for (;;) {
                var decl = this.startNode();
                this.parseVarId(decl);
                if (this.eat(_tokentype.types.eq)) {
                  decl.init = this.parseMaybeAssign(isFor);
                } else if (kind === _tokentype.types._const && !(this.type === _tokentype.types._in || this.options.ecmaVersion >= 6 && this.isContextual("of"))) {
                  this.unexpected();
                } else if (decl.id.type != "Identifier" && !(isFor && (this.type === _tokentype.types._in || this.isContextual("of")))) {
                  this.raise(this.lastTokEnd, "Complex binding patterns require an initialization value");
                } else {
                  decl.init = null;
                }
                node.declarations.push(this.finishNode(decl, "VariableDeclarator"));
                if (!this.eat(_tokentype.types.comma)) break;
              }
              return node;
            };

            pp.parseVarId = function (decl) {
              decl.id = this.parseBindingAtom();
              this.checkLVal(decl.id, true);
            };

            // Parse a function declaration or literal (depending on the
            // `isStatement` parameter).

            pp.parseFunction = function (node, isStatement, allowExpressionBody) {
              this.initFunction(node);
              if (this.options.ecmaVersion >= 6) node.generator = this.eat(_tokentype.types.star);
              if (isStatement || this.type === _tokentype.types.name) node.id = this.parseIdent();
              this.parseFunctionParams(node);
              this.parseFunctionBody(node, allowExpressionBody);
              return this.finishNode(node, isStatement ? "FunctionDeclaration" : "FunctionExpression");
            };

            pp.parseFunctionParams = function (node) {
              this.expect(_tokentype.types.parenL);
              node.params = this.parseBindingList(_tokentype.types.parenR, false, false, true);
            };

            // Parse a class declaration or literal (depending on the
            // `isStatement` parameter).

            pp.parseClass = function (node, isStatement) {
              this.next();
              this.parseClassId(node, isStatement);
              this.parseClassSuper(node);
              var classBody = this.startNode();
              var hadConstructor = false;
              classBody.body = [];
              this.expect(_tokentype.types.braceL);
              while (!this.eat(_tokentype.types.braceR)) {
                if (this.eat(_tokentype.types.semi)) continue;
                var method = this.startNode();
                var isGenerator = this.eat(_tokentype.types.star);
                var isMaybeStatic = this.type === _tokentype.types.name && this.value === "static";
                this.parsePropertyName(method);
                method["static"] = isMaybeStatic && this.type !== _tokentype.types.parenL;
                if (method["static"]) {
                  if (isGenerator) this.unexpected();
                  isGenerator = this.eat(_tokentype.types.star);
                  this.parsePropertyName(method);
                }
                method.kind = "method";
                var isGetSet = false;
                if (!method.computed) {
                  var key = method.key;

                  if (!isGenerator && key.type === "Identifier" && this.type !== _tokentype.types.parenL && (key.name === "get" || key.name === "set")) {
                    isGetSet = true;
                    method.kind = key.name;
                    key = this.parsePropertyName(method);
                  }
                  if (!method["static"] && (key.type === "Identifier" && key.name === "constructor" || key.type === "Literal" && key.value === "constructor")) {
                    if (hadConstructor) this.raise(key.start, "Duplicate constructor in the same class");
                    if (isGetSet) this.raise(key.start, "Constructor can't have get/set modifier");
                    if (isGenerator) this.raise(key.start, "Constructor can't be a generator");
                    method.kind = "constructor";
                    hadConstructor = true;
                  }
                }
                this.parseClassMethod(classBody, method, isGenerator);
                if (isGetSet) {
                  var paramCount = method.kind === "get" ? 0 : 1;
                  if (method.value.params.length !== paramCount) {
                    var start = method.value.start;
                    if (method.kind === "get") this.raise(start, "getter should have no params");else this.raise(start, "setter should have exactly one param");
                  }
                  if (method.kind === "set" && method.value.params[0].type === "RestElement") this.raise(method.value.params[0].start, "Setter cannot use rest params");
                }
              }
              node.body = this.finishNode(classBody, "ClassBody");
              return this.finishNode(node, isStatement ? "ClassDeclaration" : "ClassExpression");
            };

            pp.parseClassMethod = function (classBody, method, isGenerator) {
              method.value = this.parseMethod(isGenerator);
              classBody.body.push(this.finishNode(method, "MethodDefinition"));
            };

            pp.parseClassId = function (node, isStatement) {
              node.id = this.type === _tokentype.types.name ? this.parseIdent() : isStatement ? this.unexpected() : null;
            };

            pp.parseClassSuper = function (node) {
              node.superClass = this.eat(_tokentype.types._extends) ? this.parseExprSubscripts() : null;
            };

            // Parses module export declaration.

            pp.parseExport = function (node) {
              this.next();
              // export * from '...'
              if (this.eat(_tokentype.types.star)) {
                this.expectContextual("from");
                node.source = this.type === _tokentype.types.string ? this.parseExprAtom() : this.unexpected();
                this.semicolon();
                return this.finishNode(node, "ExportAllDeclaration");
              }
              if (this.eat(_tokentype.types._default)) {
                // export default ...
                var expr = this.parseMaybeAssign();
                var needsSemi = true;
                if (expr.type == "FunctionExpression" || expr.type == "ClassExpression") {
                  needsSemi = false;
                  if (expr.id) {
                    expr.type = expr.type == "FunctionExpression" ? "FunctionDeclaration" : "ClassDeclaration";
                  }
                }
                node.declaration = expr;
                if (needsSemi) this.semicolon();
                return this.finishNode(node, "ExportDefaultDeclaration");
              }
              // export var|const|let|function|class ...
              if (this.shouldParseExportStatement()) {
                node.declaration = this.parseStatement(true);
                node.specifiers = [];
                node.source = null;
              } else {
                // export { x, y as z } [from '...']
                node.declaration = null;
                node.specifiers = this.parseExportSpecifiers();
                if (this.eatContextual("from")) {
                  node.source = this.type === _tokentype.types.string ? this.parseExprAtom() : this.unexpected();
                } else {
                  // check for keywords used as local names
                  for (var i = 0; i < node.specifiers.length; i++) {
                    if (this.keywords.test(node.specifiers[i].local.name) || this.reservedWords.test(node.specifiers[i].local.name)) {
                      this.unexpected(node.specifiers[i].local.start);
                    }
                  }

                  node.source = null;
                }
                this.semicolon();
              }
              return this.finishNode(node, "ExportNamedDeclaration");
            };

            pp.shouldParseExportStatement = function () {
              return this.type.keyword;
            };

            // Parses a comma-separated list of module exports.

            pp.parseExportSpecifiers = function () {
              var nodes = [],
                  first = true;
              // export { x, y as z } [from '...']
              this.expect(_tokentype.types.braceL);
              while (!this.eat(_tokentype.types.braceR)) {
                if (!first) {
                  this.expect(_tokentype.types.comma);
                  if (this.afterTrailingComma(_tokentype.types.braceR)) break;
                } else first = false;

                var node = this.startNode();
                node.local = this.parseIdent(this.type === _tokentype.types._default);
                node.exported = this.eatContextual("as") ? this.parseIdent(true) : node.local;
                nodes.push(this.finishNode(node, "ExportSpecifier"));
              }
              return nodes;
            };

            // Parses import declaration.

            pp.parseImport = function (node) {
              this.next();
              // import '...'
              if (this.type === _tokentype.types.string) {
                node.specifiers = empty;
                node.source = this.parseExprAtom();
              } else {
                node.specifiers = this.parseImportSpecifiers();
                this.expectContextual("from");
                node.source = this.type === _tokentype.types.string ? this.parseExprAtom() : this.unexpected();
              }
              this.semicolon();
              return this.finishNode(node, "ImportDeclaration");
            };

            // Parses a comma-separated list of module imports.

            pp.parseImportSpecifiers = function () {
              var nodes = [],
                  first = true;
              if (this.type === _tokentype.types.name) {
                // import defaultObj, { x, y as z } from '...'
                var node = this.startNode();
                node.local = this.parseIdent();
                this.checkLVal(node.local, true);
                nodes.push(this.finishNode(node, "ImportDefaultSpecifier"));
                if (!this.eat(_tokentype.types.comma)) return nodes;
              }
              if (this.type === _tokentype.types.star) {
                var node = this.startNode();
                this.next();
                this.expectContextual("as");
                node.local = this.parseIdent();
                this.checkLVal(node.local, true);
                nodes.push(this.finishNode(node, "ImportNamespaceSpecifier"));
                return nodes;
              }
              this.expect(_tokentype.types.braceL);
              while (!this.eat(_tokentype.types.braceR)) {
                if (!first) {
                  this.expect(_tokentype.types.comma);
                  if (this.afterTrailingComma(_tokentype.types.braceR)) break;
                } else first = false;

                var node = this.startNode();
                node.imported = this.parseIdent(true);
                if (this.eatContextual("as")) {
                  node.local = this.parseIdent();
                } else {
                  node.local = node.imported;
                  if (this.isKeyword(node.local.name)) this.unexpected(node.local.start);
                  if (this.reservedWordsStrict.test(node.local.name)) this.raise(node.local.start, "The keyword '" + node.local.name + "' is reserved");
                }
                this.checkLVal(node.local, true);
                nodes.push(this.finishNode(node, "ImportSpecifier"));
              }
              return nodes;
            };

            },{"./state":10,"./tokentype":14,"./whitespace":16}],12:[function(_dereq_,module,exports){
            // The algorithm used to determine whether a regexp can appear at a
            // given point in the program is loosely based on sweet.js' approach.
            // See https://github.com/mozilla/sweet.js/wiki/design

            "use strict";

            exports.__esModule = true;

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var _state = _dereq_("./state");

            var _tokentype = _dereq_("./tokentype");

            var _whitespace = _dereq_("./whitespace");

            var TokContext = function TokContext(token, isExpr, preserveSpace, override) {
              _classCallCheck(this, TokContext);

              this.token = token;
              this.isExpr = !!isExpr;
              this.preserveSpace = !!preserveSpace;
              this.override = override;
            };

            exports.TokContext = TokContext;
            var types = {
              b_stat: new TokContext("{", false),
              b_expr: new TokContext("{", true),
              b_tmpl: new TokContext("${", true),
              p_stat: new TokContext("(", false),
              p_expr: new TokContext("(", true),
              q_tmpl: new TokContext("`", true, true, function (p) {
                return p.readTmplToken();
              }),
              f_expr: new TokContext("function", true)
            };

            exports.types = types;
            var pp = _state.Parser.prototype;

            pp.initialContext = function () {
              return [types.b_stat];
            };

            pp.braceIsBlock = function (prevType) {
              if (prevType === _tokentype.types.colon) {
                var _parent = this.curContext();
                if (_parent === types.b_stat || _parent === types.b_expr) return !_parent.isExpr;
              }
              if (prevType === _tokentype.types._return) return _whitespace.lineBreak.test(this.input.slice(this.lastTokEnd, this.start));
              if (prevType === _tokentype.types._else || prevType === _tokentype.types.semi || prevType === _tokentype.types.eof || prevType === _tokentype.types.parenR) return true;
              if (prevType == _tokentype.types.braceL) return this.curContext() === types.b_stat;
              return !this.exprAllowed;
            };

            pp.updateContext = function (prevType) {
              var update = undefined,
                  type = this.type;
              if (type.keyword && prevType == _tokentype.types.dot) this.exprAllowed = false;else if (update = type.updateContext) update.call(this, prevType);else this.exprAllowed = type.beforeExpr;
            };

            // Token-specific context update code

            _tokentype.types.parenR.updateContext = _tokentype.types.braceR.updateContext = function () {
              if (this.context.length == 1) {
                this.exprAllowed = true;
                return;
              }
              var out = this.context.pop();
              if (out === types.b_stat && this.curContext() === types.f_expr) {
                this.context.pop();
                this.exprAllowed = false;
              } else if (out === types.b_tmpl) {
                this.exprAllowed = true;
              } else {
                this.exprAllowed = !out.isExpr;
              }
            };

            _tokentype.types.braceL.updateContext = function (prevType) {
              this.context.push(this.braceIsBlock(prevType) ? types.b_stat : types.b_expr);
              this.exprAllowed = true;
            };

            _tokentype.types.dollarBraceL.updateContext = function () {
              this.context.push(types.b_tmpl);
              this.exprAllowed = true;
            };

            _tokentype.types.parenL.updateContext = function (prevType) {
              var statementParens = prevType === _tokentype.types._if || prevType === _tokentype.types._for || prevType === _tokentype.types._with || prevType === _tokentype.types._while;
              this.context.push(statementParens ? types.p_stat : types.p_expr);
              this.exprAllowed = true;
            };

            _tokentype.types.incDec.updateContext = function () {
              // tokExprAllowed stays unchanged
            };

            _tokentype.types._function.updateContext = function () {
              if (this.curContext() !== types.b_stat) this.context.push(types.f_expr);
              this.exprAllowed = false;
            };

            _tokentype.types.backQuote.updateContext = function () {
              if (this.curContext() === types.q_tmpl) this.context.pop();else this.context.push(types.q_tmpl);
              this.exprAllowed = false;
            };

            },{"./state":10,"./tokentype":14,"./whitespace":16}],13:[function(_dereq_,module,exports){
            "use strict";

            exports.__esModule = true;

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var _identifier = _dereq_("./identifier");

            var _tokentype = _dereq_("./tokentype");

            var _state = _dereq_("./state");

            var _locutil = _dereq_("./locutil");

            var _whitespace = _dereq_("./whitespace");

            // Object type used to represent tokens. Note that normally, tokens
            // simply exist as properties on the parser object. This is only
            // used for the onToken callback and the external tokenizer.

            var Token = function Token(p) {
              _classCallCheck(this, Token);

              this.type = p.type;
              this.value = p.value;
              this.start = p.start;
              this.end = p.end;
              if (p.options.locations) this.loc = new _locutil.SourceLocation(p, p.startLoc, p.endLoc);
              if (p.options.ranges) this.range = [p.start, p.end];
            }

            // ## Tokenizer

            ;

            exports.Token = Token;
            var pp = _state.Parser.prototype;

            // Are we running under Rhino?
            var isRhino = typeof Packages == "object" && Object.prototype.toString.call(Packages) == "[object JavaPackage]";

            // Move to the next token

            pp.next = function () {
              if (this.options.onToken) this.options.onToken(new Token(this));

              this.lastTokEnd = this.end;
              this.lastTokStart = this.start;
              this.lastTokEndLoc = this.endLoc;
              this.lastTokStartLoc = this.startLoc;
              this.nextToken();
            };

            pp.getToken = function () {
              this.next();
              return new Token(this);
            };

            // If we're in an ES6 environment, make parsers iterable
            if (typeof Symbol !== "undefined") pp[Symbol.iterator] = function () {
              var self = this;
              return { next: function next() {
                  var token = self.getToken();
                  return {
                    done: token.type === _tokentype.types.eof,
                    value: token
                  };
                } };
            };

            // Toggle strict mode. Re-reads the next number or string to please
            // pedantic tests (`"use strict"; 010;` should fail).

            pp.setStrict = function (strict) {
              this.strict = strict;
              if (this.type !== _tokentype.types.num && this.type !== _tokentype.types.string) return;
              this.pos = this.start;
              if (this.options.locations) {
                while (this.pos < this.lineStart) {
                  this.lineStart = this.input.lastIndexOf("\n", this.lineStart - 2) + 1;
                  --this.curLine;
                }
              }
              this.nextToken();
            };

            pp.curContext = function () {
              return this.context[this.context.length - 1];
            };

            // Read a single token, updating the parser object's token-related
            // properties.

            pp.nextToken = function () {
              var curContext = this.curContext();
              if (!curContext || !curContext.preserveSpace) this.skipSpace();

              this.start = this.pos;
              if (this.options.locations) this.startLoc = this.curPosition();
              if (this.pos >= this.input.length) return this.finishToken(_tokentype.types.eof);

              if (curContext.override) return curContext.override(this);else this.readToken(this.fullCharCodeAtPos());
            };

            pp.readToken = function (code) {
              // Identifier or keyword. '\uXXXX' sequences are allowed in
              // identifiers, so '\' also dispatches to that.
              if (_identifier.isIdentifierStart(code, this.options.ecmaVersion >= 6) || code === 92 /* '\' */) return this.readWord();

              return this.getTokenFromCode(code);
            };

            pp.fullCharCodeAtPos = function () {
              var code = this.input.charCodeAt(this.pos);
              if (code <= 0xd7ff || code >= 0xe000) return code;
              var next = this.input.charCodeAt(this.pos + 1);
              return (code << 10) + next - 0x35fdc00;
            };

            pp.skipBlockComment = function () {
              var startLoc = this.options.onComment && this.curPosition();
              var start = this.pos,
                  end = this.input.indexOf("*/", this.pos += 2);
              if (end === -1) this.raise(this.pos - 2, "Unterminated comment");
              this.pos = end + 2;
              if (this.options.locations) {
                _whitespace.lineBreakG.lastIndex = start;
                var match = undefined;
                while ((match = _whitespace.lineBreakG.exec(this.input)) && match.index < this.pos) {
                  ++this.curLine;
                  this.lineStart = match.index + match[0].length;
                }
              }
              if (this.options.onComment) this.options.onComment(true, this.input.slice(start + 2, end), start, this.pos, startLoc, this.curPosition());
            };

            pp.skipLineComment = function (startSkip) {
              var start = this.pos;
              var startLoc = this.options.onComment && this.curPosition();
              var ch = this.input.charCodeAt(this.pos += startSkip);
              while (this.pos < this.input.length && ch !== 10 && ch !== 13 && ch !== 8232 && ch !== 8233) {
                ++this.pos;
                ch = this.input.charCodeAt(this.pos);
              }
              if (this.options.onComment) this.options.onComment(false, this.input.slice(start + startSkip, this.pos), start, this.pos, startLoc, this.curPosition());
            };

            // Called at the start of the parse and after every token. Skips
            // whitespace and comments, and.

            pp.skipSpace = function () {
              loop: while (this.pos < this.input.length) {
                var ch = this.input.charCodeAt(this.pos);
                switch (ch) {
                  case 32:case 160:
                    // ' '
                    ++this.pos;
                    break;
                  case 13:
                    if (this.input.charCodeAt(this.pos + 1) === 10) {
                      ++this.pos;
                    }
                  case 10:case 8232:case 8233:
                    ++this.pos;
                    if (this.options.locations) {
                      ++this.curLine;
                      this.lineStart = this.pos;
                    }
                    break;
                  case 47:
                    // '/'
                    switch (this.input.charCodeAt(this.pos + 1)) {
                      case 42:
                        // '*'
                        this.skipBlockComment();
                        break;
                      case 47:
                        this.skipLineComment(2);
                        break;
                      default:
                        break loop;
                    }
                    break;
                  default:
                    if (ch > 8 && ch < 14 || ch >= 5760 && _whitespace.nonASCIIwhitespace.test(String.fromCharCode(ch))) {
                      ++this.pos;
                    } else {
                      break loop;
                    }
                }
              }
            };

            // Called at the end of every token. Sets `end`, `val`, and
            // maintains `context` and `exprAllowed`, and skips the space after
            // the token, so that the next one's `start` will point at the
            // right position.

            pp.finishToken = function (type, val) {
              this.end = this.pos;
              if (this.options.locations) this.endLoc = this.curPosition();
              var prevType = this.type;
              this.type = type;
              this.value = val;

              this.updateContext(prevType);
            };

            // ### Token reading

            // This is the function that is called to fetch the next token. It
            // is somewhat obscure, because it works in character codes rather
            // than characters, and because operator parsing has been inlined
            // into it.
            //
            // All in the name of speed.
            //
            pp.readToken_dot = function () {
              var next = this.input.charCodeAt(this.pos + 1);
              if (next >= 48 && next <= 57) return this.readNumber(true);
              var next2 = this.input.charCodeAt(this.pos + 2);
              if (this.options.ecmaVersion >= 6 && next === 46 && next2 === 46) {
                // 46 = dot '.'
                this.pos += 3;
                return this.finishToken(_tokentype.types.ellipsis);
              } else {
                ++this.pos;
                return this.finishToken(_tokentype.types.dot);
              }
            };

            pp.readToken_slash = function () {
              // '/'
              var next = this.input.charCodeAt(this.pos + 1);
              if (this.exprAllowed) {
                ++this.pos;return this.readRegexp();
              }
              if (next === 61) return this.finishOp(_tokentype.types.assign, 2);
              return this.finishOp(_tokentype.types.slash, 1);
            };

            pp.readToken_mult_modulo = function (code) {
              // '%*'
              var next = this.input.charCodeAt(this.pos + 1);
              if (next === 61) return this.finishOp(_tokentype.types.assign, 2);
              return this.finishOp(code === 42 ? _tokentype.types.star : _tokentype.types.modulo, 1);
            };

            pp.readToken_pipe_amp = function (code) {
              // '|&'
              var next = this.input.charCodeAt(this.pos + 1);
              if (next === code) return this.finishOp(code === 124 ? _tokentype.types.logicalOR : _tokentype.types.logicalAND, 2);
              if (next === 61) return this.finishOp(_tokentype.types.assign, 2);
              return this.finishOp(code === 124 ? _tokentype.types.bitwiseOR : _tokentype.types.bitwiseAND, 1);
            };

            pp.readToken_caret = function () {
              // '^'
              var next = this.input.charCodeAt(this.pos + 1);
              if (next === 61) return this.finishOp(_tokentype.types.assign, 2);
              return this.finishOp(_tokentype.types.bitwiseXOR, 1);
            };

            pp.readToken_plus_min = function (code) {
              // '+-'
              var next = this.input.charCodeAt(this.pos + 1);
              if (next === code) {
                if (next == 45 && this.input.charCodeAt(this.pos + 2) == 62 && _whitespace.lineBreak.test(this.input.slice(this.lastTokEnd, this.pos))) {
                  // A `-->` line comment
                  this.skipLineComment(3);
                  this.skipSpace();
                  return this.nextToken();
                }
                return this.finishOp(_tokentype.types.incDec, 2);
              }
              if (next === 61) return this.finishOp(_tokentype.types.assign, 2);
              return this.finishOp(_tokentype.types.plusMin, 1);
            };

            pp.readToken_lt_gt = function (code) {
              // '<>'
              var next = this.input.charCodeAt(this.pos + 1);
              var size = 1;
              if (next === code) {
                size = code === 62 && this.input.charCodeAt(this.pos + 2) === 62 ? 3 : 2;
                if (this.input.charCodeAt(this.pos + size) === 61) return this.finishOp(_tokentype.types.assign, size + 1);
                return this.finishOp(_tokentype.types.bitShift, size);
              }
              if (next == 33 && code == 60 && this.input.charCodeAt(this.pos + 2) == 45 && this.input.charCodeAt(this.pos + 3) == 45) {
                if (this.inModule) this.unexpected();
                // `<!--`, an XML-style comment that should be interpreted as a line comment
                this.skipLineComment(4);
                this.skipSpace();
                return this.nextToken();
              }
              if (next === 61) size = this.input.charCodeAt(this.pos + 2) === 61 ? 3 : 2;
              return this.finishOp(_tokentype.types.relational, size);
            };

            pp.readToken_eq_excl = function (code) {
              // '=!'
              var next = this.input.charCodeAt(this.pos + 1);
              if (next === 61) return this.finishOp(_tokentype.types.equality, this.input.charCodeAt(this.pos + 2) === 61 ? 3 : 2);
              if (code === 61 && next === 62 && this.options.ecmaVersion >= 6) {
                // '=>'
                this.pos += 2;
                return this.finishToken(_tokentype.types.arrow);
              }
              return this.finishOp(code === 61 ? _tokentype.types.eq : _tokentype.types.prefix, 1);
            };

            pp.getTokenFromCode = function (code) {
              switch (code) {
                // The interpretation of a dot depends on whether it is followed
                // by a digit or another two dots.
                case 46:
                  // '.'
                  return this.readToken_dot();

                // Punctuation tokens.
                case 40:
                  ++this.pos;return this.finishToken(_tokentype.types.parenL);
                case 41:
                  ++this.pos;return this.finishToken(_tokentype.types.parenR);
                case 59:
                  ++this.pos;return this.finishToken(_tokentype.types.semi);
                case 44:
                  ++this.pos;return this.finishToken(_tokentype.types.comma);
                case 91:
                  ++this.pos;return this.finishToken(_tokentype.types.bracketL);
                case 93:
                  ++this.pos;return this.finishToken(_tokentype.types.bracketR);
                case 123:
                  ++this.pos;return this.finishToken(_tokentype.types.braceL);
                case 125:
                  ++this.pos;return this.finishToken(_tokentype.types.braceR);
                case 58:
                  ++this.pos;return this.finishToken(_tokentype.types.colon);
                case 63:
                  ++this.pos;return this.finishToken(_tokentype.types.question);

                case 96:
                  // '`'
                  if (this.options.ecmaVersion < 6) break;
                  ++this.pos;
                  return this.finishToken(_tokentype.types.backQuote);

                case 48:
                  // '0'
                  var next = this.input.charCodeAt(this.pos + 1);
                  if (next === 120 || next === 88) return this.readRadixNumber(16); // '0x', '0X' - hex number
                  if (this.options.ecmaVersion >= 6) {
                    if (next === 111 || next === 79) return this.readRadixNumber(8); // '0o', '0O' - octal number
                    if (next === 98 || next === 66) return this.readRadixNumber(2); // '0b', '0B' - binary number
                  }
                // Anything else beginning with a digit is an integer, octal
                // number, or float.
                case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:
                  // 1-9
                  return this.readNumber(false);

                // Quotes produce strings.
                case 34:case 39:
                  // '"', "'"
                  return this.readString(code);

                // Operators are parsed inline in tiny state machines. '=' (61) is
                // often referred to. `finishOp` simply skips the amount of
                // characters it is given as second argument, and returns a token
                // of the type given by its first argument.

                case 47:
                  // '/'
                  return this.readToken_slash();

                case 37:case 42:
                  // '%*'
                  return this.readToken_mult_modulo(code);

                case 124:case 38:
                  // '|&'
                  return this.readToken_pipe_amp(code);

                case 94:
                  // '^'
                  return this.readToken_caret();

                case 43:case 45:
                  // '+-'
                  return this.readToken_plus_min(code);

                case 60:case 62:
                  // '<>'
                  return this.readToken_lt_gt(code);

                case 61:case 33:
                  // '=!'
                  return this.readToken_eq_excl(code);

                case 126:
                  // '~'
                  return this.finishOp(_tokentype.types.prefix, 1);
              }

              this.raise(this.pos, "Unexpected character '" + codePointToString(code) + "'");
            };

            pp.finishOp = function (type, size) {
              var str = this.input.slice(this.pos, this.pos + size);
              this.pos += size;
              return this.finishToken(type, str);
            };

            // Parse a regular expression. Some context-awareness is necessary,
            // since a '/' inside a '[]' set does not end the expression.

            function tryCreateRegexp(src, flags, throwErrorAt, parser) {
              try {
                return new RegExp(src, flags);
              } catch (e) {
                if (throwErrorAt !== undefined) {
                  if (e instanceof SyntaxError) parser.raise(throwErrorAt, "Error parsing regular expression: " + e.message);
                  throw e;
                }
              }
            }

            var regexpUnicodeSupport = !!tryCreateRegexp("￿", "u");

            pp.readRegexp = function () {
              var _this = this;

              var escaped = undefined,
                  inClass = undefined,
                  start = this.pos;
              for (;;) {
                if (this.pos >= this.input.length) this.raise(start, "Unterminated regular expression");
                var ch = this.input.charAt(this.pos);
                if (_whitespace.lineBreak.test(ch)) this.raise(start, "Unterminated regular expression");
                if (!escaped) {
                  if (ch === "[") inClass = true;else if (ch === "]" && inClass) inClass = false;else if (ch === "/" && !inClass) break;
                  escaped = ch === "\\";
                } else escaped = false;
                ++this.pos;
              }
              var content = this.input.slice(start, this.pos);
              ++this.pos;
              // Need to use `readWord1` because '\uXXXX' sequences are allowed
              // here (don't ask).
              var mods = this.readWord1();
              var tmp = content;
              if (mods) {
                var validFlags = /^[gim]*$/;
                if (this.options.ecmaVersion >= 6) validFlags = /^[gimuy]*$/;
                if (!validFlags.test(mods)) this.raise(start, "Invalid regular expression flag");
                if (mods.indexOf('u') >= 0 && !regexpUnicodeSupport) {
                  // Replace each astral symbol and every Unicode escape sequence that
                  // possibly represents an astral symbol or a paired surrogate with a
                  // single ASCII symbol to avoid throwing on regular expressions that
                  // are only valid in combination with the `/u` flag.
                  // Note: replacing with the ASCII symbol `x` might cause false
                  // negatives in unlikely scenarios. For example, `[\u{61}-b]` is a
                  // perfectly valid pattern that is equivalent to `[a-b]`, but it would
                  // be replaced by `[x-b]` which throws an error.
                  tmp = tmp.replace(/\\u\{([0-9a-fA-F]+)\}/g, function (_match, code, offset) {
                    code = Number("0x" + code);
                    if (code > 0x10FFFF) _this.raise(start + offset + 3, "Code point out of bounds");
                    return "x";
                  });
                  tmp = tmp.replace(/\\u([a-fA-F0-9]{4})|[\uD800-\uDBFF][\uDC00-\uDFFF]/g, "x");
                }
              }
              // Detect invalid regular expressions.
              var value = null;
              // Rhino's regular expression parser is flaky and throws uncatchable exceptions,
              // so don't do detection if we are running under Rhino
              if (!isRhino) {
                tryCreateRegexp(tmp, undefined, start, this);
                // Get a regular expression object for this pattern-flag pair, or `null` in
                // case the current environment doesn't support the flags it uses.
                value = tryCreateRegexp(content, mods);
              }
              return this.finishToken(_tokentype.types.regexp, { pattern: content, flags: mods, value: value });
            };

            // Read an integer in the given radix. Return null if zero digits
            // were read, the integer value otherwise. When `len` is given, this
            // will return `null` unless the integer has exactly `len` digits.

            pp.readInt = function (radix, len) {
              var start = this.pos,
                  total = 0;
              for (var i = 0, e = len == null ? Infinity : len; i < e; ++i) {
                var code = this.input.charCodeAt(this.pos),
                    val = undefined;
                if (code >= 97) val = code - 97 + 10; // a
                else if (code >= 65) val = code - 65 + 10; // A
                  else if (code >= 48 && code <= 57) val = code - 48; // 0-9
                    else val = Infinity;
                if (val >= radix) break;
                ++this.pos;
                total = total * radix + val;
              }
              if (this.pos === start || len != null && this.pos - start !== len) return null;

              return total;
            };

            pp.readRadixNumber = function (radix) {
              this.pos += 2; // 0x
              var val = this.readInt(radix);
              if (val == null) this.raise(this.start + 2, "Expected number in radix " + radix);
              if (_identifier.isIdentifierStart(this.fullCharCodeAtPos())) this.raise(this.pos, "Identifier directly after number");
              return this.finishToken(_tokentype.types.num, val);
            };

            // Read an integer, octal integer, or floating-point number.

            pp.readNumber = function (startsWithDot) {
              var start = this.pos,
                  isFloat = false,
                  octal = this.input.charCodeAt(this.pos) === 48;
              if (!startsWithDot && this.readInt(10) === null) this.raise(start, "Invalid number");
              var next = this.input.charCodeAt(this.pos);
              if (next === 46) {
                // '.'
                ++this.pos;
                this.readInt(10);
                isFloat = true;
                next = this.input.charCodeAt(this.pos);
              }
              if (next === 69 || next === 101) {
                // 'eE'
                next = this.input.charCodeAt(++this.pos);
                if (next === 43 || next === 45) ++this.pos; // '+-'
                if (this.readInt(10) === null) this.raise(start, "Invalid number");
                isFloat = true;
              }
              if (_identifier.isIdentifierStart(this.fullCharCodeAtPos())) this.raise(this.pos, "Identifier directly after number");

              var str = this.input.slice(start, this.pos),
                  val = undefined;
              if (isFloat) val = parseFloat(str);else if (!octal || str.length === 1) val = parseInt(str, 10);else if (/[89]/.test(str) || this.strict) this.raise(start, "Invalid number");else val = parseInt(str, 8);
              return this.finishToken(_tokentype.types.num, val);
            };

            // Read a string value, interpreting backslash-escapes.

            pp.readCodePoint = function () {
              var ch = this.input.charCodeAt(this.pos),
                  code = undefined;

              if (ch === 123) {
                if (this.options.ecmaVersion < 6) this.unexpected();
                var codePos = ++this.pos;
                code = this.readHexChar(this.input.indexOf('}', this.pos) - this.pos);
                ++this.pos;
                if (code > 0x10FFFF) this.raise(codePos, "Code point out of bounds");
              } else {
                code = this.readHexChar(4);
              }
              return code;
            };

            function codePointToString(code) {
              // UTF-16 Decoding
              if (code <= 0xFFFF) return String.fromCharCode(code);
              code -= 0x10000;
              return String.fromCharCode((code >> 10) + 0xD800, (code & 1023) + 0xDC00);
            }

            pp.readString = function (quote) {
              var out = "",
                  chunkStart = ++this.pos;
              for (;;) {
                if (this.pos >= this.input.length) this.raise(this.start, "Unterminated string constant");
                var ch = this.input.charCodeAt(this.pos);
                if (ch === quote) break;
                if (ch === 92) {
                  // '\'
                  out += this.input.slice(chunkStart, this.pos);
                  out += this.readEscapedChar(false);
                  chunkStart = this.pos;
                } else {
                  if (_whitespace.isNewLine(ch)) this.raise(this.start, "Unterminated string constant");
                  ++this.pos;
                }
              }
              out += this.input.slice(chunkStart, this.pos++);
              return this.finishToken(_tokentype.types.string, out);
            };

            // Reads template string tokens.

            pp.readTmplToken = function () {
              var out = "",
                  chunkStart = this.pos;
              for (;;) {
                if (this.pos >= this.input.length) this.raise(this.start, "Unterminated template");
                var ch = this.input.charCodeAt(this.pos);
                if (ch === 96 || ch === 36 && this.input.charCodeAt(this.pos + 1) === 123) {
                  // '`', '${'
                  if (this.pos === this.start && this.type === _tokentype.types.template) {
                    if (ch === 36) {
                      this.pos += 2;
                      return this.finishToken(_tokentype.types.dollarBraceL);
                    } else {
                      ++this.pos;
                      return this.finishToken(_tokentype.types.backQuote);
                    }
                  }
                  out += this.input.slice(chunkStart, this.pos);
                  return this.finishToken(_tokentype.types.template, out);
                }
                if (ch === 92) {
                  // '\'
                  out += this.input.slice(chunkStart, this.pos);
                  out += this.readEscapedChar(true);
                  chunkStart = this.pos;
                } else if (_whitespace.isNewLine(ch)) {
                  out += this.input.slice(chunkStart, this.pos);
                  ++this.pos;
                  switch (ch) {
                    case 13:
                      if (this.input.charCodeAt(this.pos) === 10) ++this.pos;
                    case 10:
                      out += "\n";
                      break;
                    default:
                      out += String.fromCharCode(ch);
                      break;
                  }
                  if (this.options.locations) {
                    ++this.curLine;
                    this.lineStart = this.pos;
                  }
                  chunkStart = this.pos;
                } else {
                  ++this.pos;
                }
              }
            };

            // Used to read escaped characters

            pp.readEscapedChar = function (inTemplate) {
              var ch = this.input.charCodeAt(++this.pos);
              ++this.pos;
              switch (ch) {
                case 110:
                  return "\n"; // 'n' -> '\n'
                case 114:
                  return "\r"; // 'r' -> '\r'
                case 120:
                  return String.fromCharCode(this.readHexChar(2)); // 'x'
                case 117:
                  return codePointToString(this.readCodePoint()); // 'u'
                case 116:
                  return "\t"; // 't' -> '\t'
                case 98:
                  return "\b"; // 'b' -> '\b'
                case 118:
                  return "\u000b"; // 'v' -> '\u000b'
                case 102:
                  return "\f"; // 'f' -> '\f'
                case 13:
                  if (this.input.charCodeAt(this.pos) === 10) ++this.pos; // '\r\n'
                case 10:
                  // ' \n'
                  if (this.options.locations) {
                    this.lineStart = this.pos;++this.curLine;
                  }
                  return "";
                default:
                  if (ch >= 48 && ch <= 55) {
                    var octalStr = this.input.substr(this.pos - 1, 3).match(/^[0-7]+/)[0];
                    var octal = parseInt(octalStr, 8);
                    if (octal > 255) {
                      octalStr = octalStr.slice(0, -1);
                      octal = parseInt(octalStr, 8);
                    }
                    if (octalStr !== "0" && (this.strict || inTemplate)) {
                      this.raise(this.pos - 2, "Octal literal in strict mode");
                    }
                    this.pos += octalStr.length - 1;
                    return String.fromCharCode(octal);
                  }
                  return String.fromCharCode(ch);
              }
            };

            // Used to read character escape sequences ('\x', '\u', '\U').

            pp.readHexChar = function (len) {
              var codePos = this.pos;
              var n = this.readInt(16, len);
              if (n === null) this.raise(codePos, "Bad character escape sequence");
              return n;
            };

            // Read an identifier, and return it as a string. Sets `this.containsEsc`
            // to whether the word contained a '\u' escape.
            //
            // Incrementally adds only escaped chars, adding other chunks as-is
            // as a micro-optimization.

            pp.readWord1 = function () {
              this.containsEsc = false;
              var word = "",
                  first = true,
                  chunkStart = this.pos;
              var astral = this.options.ecmaVersion >= 6;
              while (this.pos < this.input.length) {
                var ch = this.fullCharCodeAtPos();
                if (_identifier.isIdentifierChar(ch, astral)) {
                  this.pos += ch <= 0xffff ? 1 : 2;
                } else if (ch === 92) {
                  // "\"
                  this.containsEsc = true;
                  word += this.input.slice(chunkStart, this.pos);
                  var escStart = this.pos;
                  if (this.input.charCodeAt(++this.pos) != 117) // "u"
                    this.raise(this.pos, "Expecting Unicode escape sequence \\uXXXX");
                  ++this.pos;
                  var esc = this.readCodePoint();
                  if (!(first ? _identifier.isIdentifierStart : _identifier.isIdentifierChar)(esc, astral)) this.raise(escStart, "Invalid Unicode escape");
                  word += codePointToString(esc);
                  chunkStart = this.pos;
                } else {
                  break;
                }
                first = false;
              }
              return word + this.input.slice(chunkStart, this.pos);
            };

            // Read an identifier or keyword token. Will check for reserved
            // words when necessary.

            pp.readWord = function () {
              var word = this.readWord1();
              var type = _tokentype.types.name;
              if ((this.options.ecmaVersion >= 6 || !this.containsEsc) && this.keywords.test(word)) type = _tokentype.keywords[word];
              return this.finishToken(type, word);
            };

            },{"./identifier":2,"./locutil":5,"./state":10,"./tokentype":14,"./whitespace":16}],14:[function(_dereq_,module,exports){
            // ## Token types

            // The assignment of fine-grained, information-carrying type objects
            // allows the tokenizer to store the information it has about a
            // token in a way that is very cheap for the parser to look up.

            // All token type variables start with an underscore, to make them
            // easy to recognize.

            // The `beforeExpr` property is used to disambiguate between regular
            // expressions and divisions. It is set on all token types that can
            // be followed by an expression (thus, a slash after them would be a
            // regular expression).
            //
            // The `startsExpr` property is used to check if the token ends a
            // `yield` expression. It is set on all token types that either can
            // directly start an expression (like a quotation mark) or can
            // continue an expression (like the body of a string).
            //
            // `isLoop` marks a keyword as starting a loop, which is important
            // to know when parsing a label, in order to allow or disallow
            // continue jumps to that label.

            "use strict";

            exports.__esModule = true;

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var TokenType = function TokenType(label) {
              var conf = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

              _classCallCheck(this, TokenType);

              this.label = label;
              this.keyword = conf.keyword;
              this.beforeExpr = !!conf.beforeExpr;
              this.startsExpr = !!conf.startsExpr;
              this.isLoop = !!conf.isLoop;
              this.isAssign = !!conf.isAssign;
              this.prefix = !!conf.prefix;
              this.postfix = !!conf.postfix;
              this.binop = conf.binop || null;
              this.updateContext = null;
            };

            exports.TokenType = TokenType;

            function binop(name, prec) {
              return new TokenType(name, { beforeExpr: true, binop: prec });
            }
            var beforeExpr = { beforeExpr: true },
                startsExpr = { startsExpr: true };

            var types = {
              num: new TokenType("num", startsExpr),
              regexp: new TokenType("regexp", startsExpr),
              string: new TokenType("string", startsExpr),
              name: new TokenType("name", startsExpr),
              eof: new TokenType("eof"),

              // Punctuation token types.
              bracketL: new TokenType("[", { beforeExpr: true, startsExpr: true }),
              bracketR: new TokenType("]"),
              braceL: new TokenType("{", { beforeExpr: true, startsExpr: true }),
              braceR: new TokenType("}"),
              parenL: new TokenType("(", { beforeExpr: true, startsExpr: true }),
              parenR: new TokenType(")"),
              comma: new TokenType(",", beforeExpr),
              semi: new TokenType(";", beforeExpr),
              colon: new TokenType(":", beforeExpr),
              dot: new TokenType("."),
              question: new TokenType("?", beforeExpr),
              arrow: new TokenType("=>", beforeExpr),
              template: new TokenType("template"),
              ellipsis: new TokenType("...", beforeExpr),
              backQuote: new TokenType("`", startsExpr),
              dollarBraceL: new TokenType("${", { beforeExpr: true, startsExpr: true }),

              // Operators. These carry several kinds of properties to help the
              // parser use them properly (the presence of these properties is
              // what categorizes them as operators).
              //
              // `binop`, when present, specifies that this operator is a binary
              // operator, and will refer to its precedence.
              //
              // `prefix` and `postfix` mark the operator as a prefix or postfix
              // unary operator.
              //
              // `isAssign` marks all of `=`, `+=`, `-=` etcetera, which act as
              // binary operators with a very low precedence, that should result
              // in AssignmentExpression nodes.

              eq: new TokenType("=", { beforeExpr: true, isAssign: true }),
              assign: new TokenType("_=", { beforeExpr: true, isAssign: true }),
              incDec: new TokenType("++/--", { prefix: true, postfix: true, startsExpr: true }),
              prefix: new TokenType("prefix", { beforeExpr: true, prefix: true, startsExpr: true }),
              logicalOR: binop("||", 1),
              logicalAND: binop("&&", 2),
              bitwiseOR: binop("|", 3),
              bitwiseXOR: binop("^", 4),
              bitwiseAND: binop("&", 5),
              equality: binop("==/!=", 6),
              relational: binop("</>", 7),
              bitShift: binop("<</>>", 8),
              plusMin: new TokenType("+/-", { beforeExpr: true, binop: 9, prefix: true, startsExpr: true }),
              modulo: binop("%", 10),
              star: binop("*", 10),
              slash: binop("/", 10)
            };

            exports.types = types;
            // Map keyword names to token types.

            var keywords = {};

            exports.keywords = keywords;
            // Succinct definitions of keyword token types
            function kw(name) {
              var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

              options.keyword = name;
              keywords[name] = types["_" + name] = new TokenType(name, options);
            }

            kw("break");
            kw("case", beforeExpr);
            kw("catch");
            kw("continue");
            kw("debugger");
            kw("default", beforeExpr);
            kw("do", { isLoop: true, beforeExpr: true });
            kw("else", beforeExpr);
            kw("finally");
            kw("for", { isLoop: true });
            kw("function", startsExpr);
            kw("if");
            kw("return", beforeExpr);
            kw("switch");
            kw("throw", beforeExpr);
            kw("try");
            kw("var");
            kw("let");
            kw("const");
            kw("while", { isLoop: true });
            kw("with");
            kw("new", { beforeExpr: true, startsExpr: true });
            kw("this", startsExpr);
            kw("super", startsExpr);
            kw("class");
            kw("extends", beforeExpr);
            kw("export");
            kw("import");
            kw("yield", { beforeExpr: true, startsExpr: true });
            kw("null", startsExpr);
            kw("true", startsExpr);
            kw("false", startsExpr);
            kw("in", { beforeExpr: true, binop: 7 });
            kw("instanceof", { beforeExpr: true, binop: 7 });
            kw("typeof", { beforeExpr: true, prefix: true, startsExpr: true });
            kw("void", { beforeExpr: true, prefix: true, startsExpr: true });
            kw("delete", { beforeExpr: true, prefix: true, startsExpr: true });

            },{}],15:[function(_dereq_,module,exports){
            "use strict";

            exports.__esModule = true;
            exports.isArray = isArray;
            exports.has = has;

            function isArray(obj) {
              return Object.prototype.toString.call(obj) === "[object Array]";
            }

            // Checks if an object has a property.

            function has(obj, propName) {
              return Object.prototype.hasOwnProperty.call(obj, propName);
            }

            },{}],16:[function(_dereq_,module,exports){
            // Matches a whole line break (where CRLF is considered a single
            // line break). Used to count lines.

            "use strict";

            exports.__esModule = true;
            exports.isNewLine = isNewLine;
            var lineBreak = /\r\n?|\n|\u2028|\u2029/;
            exports.lineBreak = lineBreak;
            var lineBreakG = new RegExp(lineBreak.source, "g");

            exports.lineBreakG = lineBreakG;

            function isNewLine(code) {
              return code === 10 || code === 13 || code === 0x2028 || code == 0x2029;
            }

            var nonASCIIwhitespace = /[\u1680\u180e\u2000-\u200a\u202f\u205f\u3000\ufeff]/;
            exports.nonASCIIwhitespace = nonASCIIwhitespace;

            },{}]},{},[3])(3)
            });
            });

            var require$$1$40 = (acorn && typeof acorn === 'object' && 'default' in acorn ? acorn['default'] : acorn);

            var estreeWalker_umd = __commonjs(function (module, exports, global) {
            (function (global, factory) {
            	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
            	typeof define === 'function' && define.amd ? define(['exports'], factory) :
            	factory((global.estreeWalker = {}));
            }(__commonjs_global, function (exports) { 'use strict';

            	function walk(ast, _ref) {
            		var enter = _ref.enter;
            		var leave = _ref.leave;

            		visit(ast, null, enter, leave);
            	}

            	var context = {
            		skip: function skip() {
            			return context.shouldSkip = true;
            		}
            	};

            	var childKeys = {};

            	var toString = Object.prototype.toString;

            	function isArray(thing) {
            		return toString.call(thing) === '[object Array]';
            	}

            	function visit(node, parent, enter, leave, prop, index) {
            		if (!node) return;

            		if (enter) {
            			context.shouldSkip = false;
            			enter.call(context, node, parent, prop, index);
            			if (context.shouldSkip) return;
            		}

            		var keys = childKeys[node.type] || (childKeys[node.type] = Object.keys(node).filter(function (prop) {
            			return typeof node[prop] === 'object';
            		}));

            		var key = undefined,
            		    value = undefined,
            		    i = undefined,
            		    j = undefined;

            		i = keys.length;
            		while (i--) {
            			key = keys[i];
            			value = node[key];

            			if (isArray(value)) {
            				j = value.length;
            				while (j--) {
            					visit(value[j], node, enter, leave, key, j);
            				}
            			} else if (value && value.type) {
            				visit(value, node, enter, leave, key, null);
            			}
            		}

            		if (leave) {
            			leave(node, parent, prop, index);
            		}
            	}

            	exports.walk = walk;

            }));
            });

            var require$$2$15 = (estreeWalker_umd && typeof estreeWalker_umd === 'object' && 'default' in estreeWalker_umd ? estreeWalker_umd['default'] : estreeWalker_umd);

            var index$7 = __commonjs(function (module) {
            module.exports = balanced;
            function balanced(a, b, str) {
              var r = range(a, b, str);

              return r && {
                start: r[0],
                end: r[1],
                pre: str.slice(0, r[0]),
                body: str.slice(r[0] + a.length, r[1]),
                post: str.slice(r[1] + b.length)
              };
            }

            balanced.range = range;
            function range(a, b, str) {
              var begs, beg, left, right, result;
              var ai = str.indexOf(a);
              var bi = str.indexOf(b, ai + 1);
              var i = ai;

              if (ai >= 0 && bi > 0) {
                begs = [];
                left = str.length;

                while (i < str.length && i >= 0 && ! result) {
                  if (i == ai) {
                    begs.push(i);
                    ai = str.indexOf(a, i + 1);
                  } else if (begs.length == 1) {
                    result = [ begs.pop(), bi ];
                  } else {
                    beg = begs.pop();
                    if (beg < left) {
                      left = beg;
                      right = bi;
                    }

                    bi = str.indexOf(b, i + 1);
                  }

                  i = ai < bi && ai >= 0 ? ai : bi;
                }

                if (begs.length) {
                  result = [ left, right ];
                }
              }

              return result;
            }
            });

            var require$$0$57 = (index$7 && typeof index$7 === 'object' && 'default' in index$7 ? index$7['default'] : index$7);

            var index$8 = __commonjs(function (module) {
            module.exports = function (xs, fn) {
                var res = [];
                for (var i = 0; i < xs.length; i++) {
                    var x = fn(xs[i], i);
                    if (isArray(x)) res.push.apply(res, x);
                    else res.push(x);
                }
                return res;
            };

            var isArray = Array.isArray || function (xs) {
                return Object.prototype.toString.call(xs) === '[object Array]';
            };
            });

            var require$$1$41 = (index$8 && typeof index$8 === 'object' && 'default' in index$8 ? index$8['default'] : index$8);

            var index$6 = __commonjs(function (module) {
            var concatMap = require$$1$41;
            var balanced = require$$0$57;

            module.exports = expandTop;

            var escSlash = '\0SLASH'+Math.random()+'\0';
            var escOpen = '\0OPEN'+Math.random()+'\0';
            var escClose = '\0CLOSE'+Math.random()+'\0';
            var escComma = '\0COMMA'+Math.random()+'\0';
            var escPeriod = '\0PERIOD'+Math.random()+'\0';

            function numeric(str) {
              return parseInt(str, 10) == str
                ? parseInt(str, 10)
                : str.charCodeAt(0);
            }

            function escapeBraces(str) {
              return str.split('\\\\').join(escSlash)
                        .split('\\{').join(escOpen)
                        .split('\\}').join(escClose)
                        .split('\\,').join(escComma)
                        .split('\\.').join(escPeriod);
            }

            function unescapeBraces(str) {
              return str.split(escSlash).join('\\')
                        .split(escOpen).join('{')
                        .split(escClose).join('}')
                        .split(escComma).join(',')
                        .split(escPeriod).join('.');
            }


            // Basically just str.split(","), but handling cases
            // where we have nested braced sections, which should be
            // treated as individual members, like {a,{b,c},d}
            function parseCommaParts(str) {
              if (!str)
                return [''];

              var parts = [];
              var m = balanced('{', '}', str);

              if (!m)
                return str.split(',');

              var pre = m.pre;
              var body = m.body;
              var post = m.post;
              var p = pre.split(',');

              p[p.length-1] += '{' + body + '}';
              var postParts = parseCommaParts(post);
              if (post.length) {
                p[p.length-1] += postParts.shift();
                p.push.apply(p, postParts);
              }

              parts.push.apply(parts, p);

              return parts;
            }

            function expandTop(str) {
              if (!str)
                return [];

              return expand(escapeBraces(str), true).map(unescapeBraces);
            }

            function identity(e) {
              return e;
            }

            function embrace(str) {
              return '{' + str + '}';
            }
            function isPadded(el) {
              return /^-?0\d/.test(el);
            }

            function lte(i, y) {
              return i <= y;
            }
            function gte(i, y) {
              return i >= y;
            }

            function expand(str, isTop) {
              var expansions = [];

              var m = balanced('{', '}', str);
              if (!m || /\$$/.test(m.pre)) return [str];

              var isNumericSequence = /^-?\d+\.\.-?\d+(?:\.\.-?\d+)?$/.test(m.body);
              var isAlphaSequence = /^[a-zA-Z]\.\.[a-zA-Z](?:\.\.-?\d+)?$/.test(m.body);
              var isSequence = isNumericSequence || isAlphaSequence;
              var isOptions = /^(.*,)+(.+)?$/.test(m.body);
              if (!isSequence && !isOptions) {
                // {a},b}
                if (m.post.match(/,.*\}/)) {
                  str = m.pre + '{' + m.body + escClose + m.post;
                  return expand(str);
                }
                return [str];
              }

              var n;
              if (isSequence) {
                n = m.body.split(/\.\./);
              } else {
                n = parseCommaParts(m.body);
                if (n.length === 1) {
                  // x{{a,b}}y ==> x{a}y x{b}y
                  n = expand(n[0], false).map(embrace);
                  if (n.length === 1) {
                    var post = m.post.length
                      ? expand(m.post, false)
                      : [''];
                    return post.map(function(p) {
                      return m.pre + n[0] + p;
                    });
                  }
                }
              }

              // at this point, n is the parts, and we know it's not a comma set
              // with a single entry.

              // no need to expand pre, since it is guaranteed to be free of brace-sets
              var pre = m.pre;
              var post = m.post.length
                ? expand(m.post, false)
                : [''];

              var N;

              if (isSequence) {
                var x = numeric(n[0]);
                var y = numeric(n[1]);
                var width = Math.max(n[0].length, n[1].length)
                var incr = n.length == 3
                  ? Math.abs(numeric(n[2]))
                  : 1;
                var test = lte;
                var reverse = y < x;
                if (reverse) {
                  incr *= -1;
                  test = gte;
                }
                var pad = n.some(isPadded);

                N = [];

                for (var i = x; test(i, y); i += incr) {
                  var c;
                  if (isAlphaSequence) {
                    c = String.fromCharCode(i);
                    if (c === '\\')
                      c = '';
                  } else {
                    c = String(i);
                    if (pad) {
                      var need = width - c.length;
                      if (need > 0) {
                        var z = new Array(need + 1).join('0');
                        if (i < 0)
                          c = '-' + z + c.slice(1);
                        else
                          c = z + c;
                      }
                    }
                  }
                  N.push(c);
                }
              } else {
                N = concatMap(n, function(el) { return expand(el, false) });
              }

              for (var j = 0; j < N.length; j++) {
                for (var k = 0; k < post.length; k++) {
                  var expansion = pre + N[j] + post[k];
                  if (!isTop || isSequence || expansion)
                    expansions.push(expansion);
                }
              }

              return expansions;
            }
            });

            var require$$0$56 = (index$6 && typeof index$6 === 'object' && 'default' in index$6 ? index$6['default'] : index$6);

            var minimatch = __commonjs(function (module) {
            module.exports = minimatch
            minimatch.Minimatch = Minimatch

            var path = { sep: '/' }
            try {
              path = require$$1$36
            } catch (er) {}

            var GLOBSTAR = minimatch.GLOBSTAR = Minimatch.GLOBSTAR = {}
            var expand = require$$0$56

            // any single thing other than /
            // don't need to escape / when using new RegExp()
            var qmark = '[^/]'

            // * => any number of characters
            var star = qmark + '*?'

            // ** when dots are allowed.  Anything goes, except .. and .
            // not (^ or / followed by one or two dots followed by $ or /),
            // followed by anything, any number of times.
            var twoStarDot = '(?:(?!(?:\\\/|^)(?:\\.{1,2})($|\\\/)).)*?'

            // not a ^ or / followed by a dot,
            // followed by anything, any number of times.
            var twoStarNoDot = '(?:(?!(?:\\\/|^)\\.).)*?'

            // characters that need to be escaped in RegExp.
            var reSpecials = charSet('().*{}+?[]^$\\!')

            // "abc" -> { a:true, b:true, c:true }
            function charSet (s) {
              return s.split('').reduce(function (set, c) {
                set[c] = true
                return set
              }, {})
            }

            // normalizes slashes.
            var slashSplit = /\/+/

            minimatch.filter = filter
            function filter (pattern, options) {
              options = options || {}
              return function (p, i, list) {
                return minimatch(p, pattern, options)
              }
            }

            function ext (a, b) {
              a = a || {}
              b = b || {}
              var t = {}
              Object.keys(b).forEach(function (k) {
                t[k] = b[k]
              })
              Object.keys(a).forEach(function (k) {
                t[k] = a[k]
              })
              return t
            }

            minimatch.defaults = function (def) {
              if (!def || !Object.keys(def).length) return minimatch

              var orig = minimatch

              var m = function minimatch (p, pattern, options) {
                return orig.minimatch(p, pattern, ext(def, options))
              }

              m.Minimatch = function Minimatch (pattern, options) {
                return new orig.Minimatch(pattern, ext(def, options))
              }

              return m
            }

            Minimatch.defaults = function (def) {
              if (!def || !Object.keys(def).length) return Minimatch
              return minimatch.defaults(def).Minimatch
            }

            function minimatch (p, pattern, options) {
              if (typeof pattern !== 'string') {
                throw new TypeError('glob pattern string required')
              }

              if (!options) options = {}

              // shortcut: comments match nothing.
              if (!options.nocomment && pattern.charAt(0) === '#') {
                return false
              }

              // "" only matches ""
              if (pattern.trim() === '') return p === ''

              return new Minimatch(pattern, options).match(p)
            }

            function Minimatch (pattern, options) {
              if (!(this instanceof Minimatch)) {
                return new Minimatch(pattern, options)
              }

              if (typeof pattern !== 'string') {
                throw new TypeError('glob pattern string required')
              }

              if (!options) options = {}
              pattern = pattern.trim()

              // windows support: need to use /, not \
              if (path.sep !== '/') {
                pattern = pattern.split(path.sep).join('/')
              }

              this.options = options
              this.set = []
              this.pattern = pattern
              this.regexp = null
              this.negate = false
              this.comment = false
              this.empty = false

              // make the set of regexps etc.
              this.make()
            }

            Minimatch.prototype.debug = function () {}

            Minimatch.prototype.make = make
            function make () {
              // don't do it more than once.
              if (this._made) return

              var pattern = this.pattern
              var options = this.options

              // empty patterns and comments match nothing.
              if (!options.nocomment && pattern.charAt(0) === '#') {
                this.comment = true
                return
              }
              if (!pattern) {
                this.empty = true
                return
              }

              // step 1: figure out negation, etc.
              this.parseNegate()

              // step 2: expand braces
              var set = this.globSet = this.braceExpand()

              if (options.debug) this.debug = console.error

              this.debug(this.pattern, set)

              // step 3: now we have a set, so turn each one into a series of path-portion
              // matching patterns.
              // These will be regexps, except in the case of "**", which is
              // set to the GLOBSTAR object for globstar behavior,
              // and will not contain any / characters
              set = this.globParts = set.map(function (s) {
                return s.split(slashSplit)
              })

              this.debug(this.pattern, set)

              // glob --> regexps
              set = set.map(function (s, si, set) {
                return s.map(this.parse, this)
              }, this)

              this.debug(this.pattern, set)

              // filter out everything that didn't compile properly.
              set = set.filter(function (s) {
                return s.indexOf(false) === -1
              })

              this.debug(this.pattern, set)

              this.set = set
            }

            Minimatch.prototype.parseNegate = parseNegate
            function parseNegate () {
              var pattern = this.pattern
              var negate = false
              var options = this.options
              var negateOffset = 0

              if (options.nonegate) return

              for (var i = 0, l = pattern.length
                ; i < l && pattern.charAt(i) === '!'
                ; i++) {
                negate = !negate
                negateOffset++
              }

              if (negateOffset) this.pattern = pattern.substr(negateOffset)
              this.negate = negate
            }

            // Brace expansion:
            // a{b,c}d -> abd acd
            // a{b,}c -> abc ac
            // a{0..3}d -> a0d a1d a2d a3d
            // a{b,c{d,e}f}g -> abg acdfg acefg
            // a{b,c}d{e,f}g -> abdeg acdeg abdeg abdfg
            //
            // Invalid sets are not expanded.
            // a{2..}b -> a{2..}b
            // a{b}c -> a{b}c
            minimatch.braceExpand = function (pattern, options) {
              return braceExpand(pattern, options)
            }

            Minimatch.prototype.braceExpand = braceExpand

            function braceExpand (pattern, options) {
              if (!options) {
                if (this instanceof Minimatch) {
                  options = this.options
                } else {
                  options = {}
                }
              }

              pattern = typeof pattern === 'undefined'
                ? this.pattern : pattern

              if (typeof pattern === 'undefined') {
                throw new Error('undefined pattern')
              }

              if (options.nobrace ||
                !pattern.match(/\{.*\}/)) {
                // shortcut. no need to expand.
                return [pattern]
              }

              return expand(pattern)
            }

            // parse a component of the expanded set.
            // At this point, no pattern may contain "/" in it
            // so we're going to return a 2d array, where each entry is the full
            // pattern, split on '/', and then turned into a regular expression.
            // A regexp is made at the end which joins each array with an
            // escaped /, and another full one which joins each regexp with |.
            //
            // Following the lead of Bash 4.1, note that "**" only has special meaning
            // when it is the *only* thing in a path portion.  Otherwise, any series
            // of * is equivalent to a single *.  Globstar behavior is enabled by
            // default, and can be disabled by setting options.noglobstar.
            Minimatch.prototype.parse = parse
            var SUBPARSE = {}
            function parse (pattern, isSub) {
              var options = this.options

              // shortcuts
              if (!options.noglobstar && pattern === '**') return GLOBSTAR
              if (pattern === '') return ''

              var re = ''
              var hasMagic = !!options.nocase
              var escaping = false
              // ? => one single character
              var patternListStack = []
              var negativeLists = []
              var plType
              var stateChar
              var inClass = false
              var reClassStart = -1
              var classStart = -1
              // . and .. never match anything that doesn't start with .,
              // even when options.dot is set.
              var patternStart = pattern.charAt(0) === '.' ? '' // anything
              // not (start or / followed by . or .. followed by / or end)
              : options.dot ? '(?!(?:^|\\\/)\\.{1,2}(?:$|\\\/))'
              : '(?!\\.)'
              var self = this

              function clearStateChar () {
                if (stateChar) {
                  // we had some state-tracking character
                  // that wasn't consumed by this pass.
                  switch (stateChar) {
                    case '*':
                      re += star
                      hasMagic = true
                    break
                    case '?':
                      re += qmark
                      hasMagic = true
                    break
                    default:
                      re += '\\' + stateChar
                    break
                  }
                  self.debug('clearStateChar %j %j', stateChar, re)
                  stateChar = false
                }
              }

              for (var i = 0, len = pattern.length, c
                ; (i < len) && (c = pattern.charAt(i))
                ; i++) {
                this.debug('%s\t%s %s %j', pattern, i, re, c)

                // skip over any that are escaped.
                if (escaping && reSpecials[c]) {
                  re += '\\' + c
                  escaping = false
                  continue
                }

                switch (c) {
                  case '/':
                    // completely not allowed, even escaped.
                    // Should already be path-split by now.
                    return false

                  case '\\':
                    clearStateChar()
                    escaping = true
                  continue

                  // the various stateChar values
                  // for the "extglob" stuff.
                  case '?':
                  case '*':
                  case '+':
                  case '@':
                  case '!':
                    this.debug('%s\t%s %s %j <-- stateChar', pattern, i, re, c)

                    // all of those are literals inside a class, except that
                    // the glob [!a] means [^a] in regexp
                    if (inClass) {
                      this.debug('  in class')
                      if (c === '!' && i === classStart + 1) c = '^'
                      re += c
                      continue
                    }

                    // if we already have a stateChar, then it means
                    // that there was something like ** or +? in there.
                    // Handle the stateChar, then proceed with this one.
                    self.debug('call clearStateChar %j', stateChar)
                    clearStateChar()
                    stateChar = c
                    // if extglob is disabled, then +(asdf|foo) isn't a thing.
                    // just clear the statechar *now*, rather than even diving into
                    // the patternList stuff.
                    if (options.noext) clearStateChar()
                  continue

                  case '(':
                    if (inClass) {
                      re += '('
                      continue
                    }

                    if (!stateChar) {
                      re += '\\('
                      continue
                    }

                    plType = stateChar
                    patternListStack.push({
                      type: plType,
                      start: i - 1,
                      reStart: re.length
                    })
                    // negation is (?:(?!js)[^/]*)
                    re += stateChar === '!' ? '(?:(?!(?:' : '(?:'
                    this.debug('plType %j %j', stateChar, re)
                    stateChar = false
                  continue

                  case ')':
                    if (inClass || !patternListStack.length) {
                      re += '\\)'
                      continue
                    }

                    clearStateChar()
                    hasMagic = true
                    re += ')'
                    var pl = patternListStack.pop()
                    plType = pl.type
                    // negation is (?:(?!js)[^/]*)
                    // The others are (?:<pattern>)<type>
                    switch (plType) {
                      case '!':
                        negativeLists.push(pl)
                        re += ')[^/]*?)'
                        pl.reEnd = re.length
                        break
                      case '?':
                      case '+':
                      case '*':
                        re += plType
                        break
                      case '@': break // the default anyway
                    }
                  continue

                  case '|':
                    if (inClass || !patternListStack.length || escaping) {
                      re += '\\|'
                      escaping = false
                      continue
                    }

                    clearStateChar()
                    re += '|'
                  continue

                  // these are mostly the same in regexp and glob
                  case '[':
                    // swallow any state-tracking char before the [
                    clearStateChar()

                    if (inClass) {
                      re += '\\' + c
                      continue
                    }

                    inClass = true
                    classStart = i
                    reClassStart = re.length
                    re += c
                  continue

                  case ']':
                    //  a right bracket shall lose its special
                    //  meaning and represent itself in
                    //  a bracket expression if it occurs
                    //  first in the list.  -- POSIX.2 2.8.3.2
                    if (i === classStart + 1 || !inClass) {
                      re += '\\' + c
                      escaping = false
                      continue
                    }

                    // handle the case where we left a class open.
                    // "[z-a]" is valid, equivalent to "\[z-a\]"
                    if (inClass) {
                      // split where the last [ was, make sure we don't have
                      // an invalid re. if so, re-walk the contents of the
                      // would-be class to re-translate any characters that
                      // were passed through as-is
                      // TODO: It would probably be faster to determine this
                      // without a try/catch and a new RegExp, but it's tricky
                      // to do safely.  For now, this is safe and works.
                      var cs = pattern.substring(classStart + 1, i)
                      try {
                        RegExp('[' + cs + ']')
                      } catch (er) {
                        // not a valid class!
                        var sp = this.parse(cs, SUBPARSE)
                        re = re.substr(0, reClassStart) + '\\[' + sp[0] + '\\]'
                        hasMagic = hasMagic || sp[1]
                        inClass = false
                        continue
                      }
                    }

                    // finish up the class.
                    hasMagic = true
                    inClass = false
                    re += c
                  continue

                  default:
                    // swallow any state char that wasn't consumed
                    clearStateChar()

                    if (escaping) {
                      // no need
                      escaping = false
                    } else if (reSpecials[c]
                      && !(c === '^' && inClass)) {
                      re += '\\'
                    }

                    re += c

                } // switch
              } // for

              // handle the case where we left a class open.
              // "[abc" is valid, equivalent to "\[abc"
              if (inClass) {
                // split where the last [ was, and escape it
                // this is a huge pita.  We now have to re-walk
                // the contents of the would-be class to re-translate
                // any characters that were passed through as-is
                cs = pattern.substr(classStart + 1)
                sp = this.parse(cs, SUBPARSE)
                re = re.substr(0, reClassStart) + '\\[' + sp[0]
                hasMagic = hasMagic || sp[1]
              }

              // handle the case where we had a +( thing at the *end*
              // of the pattern.
              // each pattern list stack adds 3 chars, and we need to go through
              // and escape any | chars that were passed through as-is for the regexp.
              // Go through and escape them, taking care not to double-escape any
              // | chars that were already escaped.
              for (pl = patternListStack.pop(); pl; pl = patternListStack.pop()) {
                var tail = re.slice(pl.reStart + 3)
                // maybe some even number of \, then maybe 1 \, followed by a |
                tail = tail.replace(/((?:\\{2})*)(\\?)\|/g, function (_, $1, $2) {
                  if (!$2) {
                    // the | isn't already escaped, so escape it.
                    $2 = '\\'
                  }

                  // need to escape all those slashes *again*, without escaping the
                  // one that we need for escaping the | character.  As it works out,
                  // escaping an even number of slashes can be done by simply repeating
                  // it exactly after itself.  That's why this trick works.
                  //
                  // I am sorry that you have to see this.
                  return $1 + $1 + $2 + '|'
                })

                this.debug('tail=%j\n   %s', tail, tail)
                var t = pl.type === '*' ? star
                  : pl.type === '?' ? qmark
                  : '\\' + pl.type

                hasMagic = true
                re = re.slice(0, pl.reStart) + t + '\\(' + tail
              }

              // handle trailing things that only matter at the very end.
              clearStateChar()
              if (escaping) {
                // trailing \\
                re += '\\\\'
              }

              // only need to apply the nodot start if the re starts with
              // something that could conceivably capture a dot
              var addPatternStart = false
              switch (re.charAt(0)) {
                case '.':
                case '[':
                case '(': addPatternStart = true
              }

              // Hack to work around lack of negative lookbehind in JS
              // A pattern like: *.!(x).!(y|z) needs to ensure that a name
              // like 'a.xyz.yz' doesn't match.  So, the first negative
              // lookahead, has to look ALL the way ahead, to the end of
              // the pattern.
              for (var n = negativeLists.length - 1; n > -1; n--) {
                var nl = negativeLists[n]

                var nlBefore = re.slice(0, nl.reStart)
                var nlFirst = re.slice(nl.reStart, nl.reEnd - 8)
                var nlLast = re.slice(nl.reEnd - 8, nl.reEnd)
                var nlAfter = re.slice(nl.reEnd)

                nlLast += nlAfter

                // Handle nested stuff like *(*.js|!(*.json)), where open parens
                // mean that we should *not* include the ) in the bit that is considered
                // "after" the negated section.
                var openParensBefore = nlBefore.split('(').length - 1
                var cleanAfter = nlAfter
                for (i = 0; i < openParensBefore; i++) {
                  cleanAfter = cleanAfter.replace(/\)[+*?]?/, '')
                }
                nlAfter = cleanAfter

                var dollar = ''
                if (nlAfter === '' && isSub !== SUBPARSE) {
                  dollar = '$'
                }
                var newRe = nlBefore + nlFirst + nlAfter + dollar + nlLast
                re = newRe
              }

              // if the re is not "" at this point, then we need to make sure
              // it doesn't match against an empty path part.
              // Otherwise a/* will match a/, which it should not.
              if (re !== '' && hasMagic) {
                re = '(?=.)' + re
              }

              if (addPatternStart) {
                re = patternStart + re
              }

              // parsing just a piece of a larger pattern.
              if (isSub === SUBPARSE) {
                return [re, hasMagic]
              }

              // skip the regexp for non-magical patterns
              // unescape anything in it, though, so that it'll be
              // an exact match against a file etc.
              if (!hasMagic) {
                return globUnescape(pattern)
              }

              var flags = options.nocase ? 'i' : ''
              var regExp = new RegExp('^' + re + '$', flags)

              regExp._glob = pattern
              regExp._src = re

              return regExp
            }

            minimatch.makeRe = function (pattern, options) {
              return new Minimatch(pattern, options || {}).makeRe()
            }

            Minimatch.prototype.makeRe = makeRe
            function makeRe () {
              if (this.regexp || this.regexp === false) return this.regexp

              // at this point, this.set is a 2d array of partial
              // pattern strings, or "**".
              //
              // It's better to use .match().  This function shouldn't
              // be used, really, but it's pretty convenient sometimes,
              // when you just want to work with a regex.
              var set = this.set

              if (!set.length) {
                this.regexp = false
                return this.regexp
              }
              var options = this.options

              var twoStar = options.noglobstar ? star
                : options.dot ? twoStarDot
                : twoStarNoDot
              var flags = options.nocase ? 'i' : ''

              var re = set.map(function (pattern) {
                return pattern.map(function (p) {
                  return (p === GLOBSTAR) ? twoStar
                  : (typeof p === 'string') ? regExpEscape(p)
                  : p._src
                }).join('\\\/')
              }).join('|')

              // must match entire pattern
              // ending in a * or ** will make it less strict.
              re = '^(?:' + re + ')$'

              // can match anything, as long as it's not this.
              if (this.negate) re = '^(?!' + re + ').*$'

              try {
                this.regexp = new RegExp(re, flags)
              } catch (ex) {
                this.regexp = false
              }
              return this.regexp
            }

            minimatch.match = function (list, pattern, options) {
              options = options || {}
              var mm = new Minimatch(pattern, options)
              list = list.filter(function (f) {
                return mm.match(f)
              })
              if (mm.options.nonull && !list.length) {
                list.push(pattern)
              }
              return list
            }

            Minimatch.prototype.match = match
            function match (f, partial) {
              this.debug('match', f, this.pattern)
              // short-circuit in the case of busted things.
              // comments, etc.
              if (this.comment) return false
              if (this.empty) return f === ''

              if (f === '/' && partial) return true

              var options = this.options

              // windows: need to use /, not \
              if (path.sep !== '/') {
                f = f.split(path.sep).join('/')
              }

              // treat the test path as a set of pathparts.
              f = f.split(slashSplit)
              this.debug(this.pattern, 'split', f)

              // just ONE of the pattern sets in this.set needs to match
              // in order for it to be valid.  If negating, then just one
              // match means that we have failed.
              // Either way, return on the first hit.

              var set = this.set
              this.debug(this.pattern, 'set', set)

              // Find the basename of the path by looking for the last non-empty segment
              var filename
              var i
              for (i = f.length - 1; i >= 0; i--) {
                filename = f[i]
                if (filename) break
              }

              for (i = 0; i < set.length; i++) {
                var pattern = set[i]
                var file = f
                if (options.matchBase && pattern.length === 1) {
                  file = [filename]
                }
                var hit = this.matchOne(file, pattern, partial)
                if (hit) {
                  if (options.flipNegate) return true
                  return !this.negate
                }
              }

              // didn't get any hits.  this is success if it's a negative
              // pattern, failure otherwise.
              if (options.flipNegate) return false
              return this.negate
            }

            // set partial to true to test if, for example,
            // "/a/b" matches the start of "/*/b/*/d"
            // Partial means, if you run out of file before you run
            // out of pattern, then that's fine, as long as all
            // the parts match.
            Minimatch.prototype.matchOne = function (file, pattern, partial) {
              var options = this.options

              this.debug('matchOne',
                { 'this': this, file: file, pattern: pattern })

              this.debug('matchOne', file.length, pattern.length)

              for (var fi = 0,
                  pi = 0,
                  fl = file.length,
                  pl = pattern.length
                  ; (fi < fl) && (pi < pl)
                  ; fi++, pi++) {
                this.debug('matchOne loop')
                var p = pattern[pi]
                var f = file[fi]

                this.debug(pattern, p, f)

                // should be impossible.
                // some invalid regexp stuff in the set.
                if (p === false) return false

                if (p === GLOBSTAR) {
                  this.debug('GLOBSTAR', [pattern, p, f])

                  // "**"
                  // a/**/b/**/c would match the following:
                  // a/b/x/y/z/c
                  // a/x/y/z/b/c
                  // a/b/x/b/x/c
                  // a/b/c
                  // To do this, take the rest of the pattern after
                  // the **, and see if it would match the file remainder.
                  // If so, return success.
                  // If not, the ** "swallows" a segment, and try again.
                  // This is recursively awful.
                  //
                  // a/**/b/**/c matching a/b/x/y/z/c
                  // - a matches a
                  // - doublestar
                  //   - matchOne(b/x/y/z/c, b/**/c)
                  //     - b matches b
                  //     - doublestar
                  //       - matchOne(x/y/z/c, c) -> no
                  //       - matchOne(y/z/c, c) -> no
                  //       - matchOne(z/c, c) -> no
                  //       - matchOne(c, c) yes, hit
                  var fr = fi
                  var pr = pi + 1
                  if (pr === pl) {
                    this.debug('** at the end')
                    // a ** at the end will just swallow the rest.
                    // We have found a match.
                    // however, it will not swallow /.x, unless
                    // options.dot is set.
                    // . and .. are *never* matched by **, for explosively
                    // exponential reasons.
                    for (; fi < fl; fi++) {
                      if (file[fi] === '.' || file[fi] === '..' ||
                        (!options.dot && file[fi].charAt(0) === '.')) return false
                    }
                    return true
                  }

                  // ok, let's see if we can swallow whatever we can.
                  while (fr < fl) {
                    var swallowee = file[fr]

                    this.debug('\nglobstar while', file, fr, pattern, pr, swallowee)

                    // XXX remove this slice.  Just pass the start index.
                    if (this.matchOne(file.slice(fr), pattern.slice(pr), partial)) {
                      this.debug('globstar found match!', fr, fl, swallowee)
                      // found a match.
                      return true
                    } else {
                      // can't swallow "." or ".." ever.
                      // can only swallow ".foo" when explicitly asked.
                      if (swallowee === '.' || swallowee === '..' ||
                        (!options.dot && swallowee.charAt(0) === '.')) {
                        this.debug('dot detected!', file, fr, pattern, pr)
                        break
                      }

                      // ** swallows a segment, and continue.
                      this.debug('globstar swallow a segment, and continue')
                      fr++
                    }
                  }

                  // no match was found.
                  // However, in partial mode, we can't say this is necessarily over.
                  // If there's more *pattern* left, then
                  if (partial) {
                    // ran out of file
                    this.debug('\n>>> no match, partial?', file, fr, pattern, pr)
                    if (fr === fl) return true
                  }
                  return false
                }

                // something other than **
                // non-magic patterns just have to match exactly
                // patterns with magic have been turned into regexps.
                var hit
                if (typeof p === 'string') {
                  if (options.nocase) {
                    hit = f.toLowerCase() === p.toLowerCase()
                  } else {
                    hit = f === p
                  }
                  this.debug('string match', p, f, hit)
                } else {
                  hit = f.match(p)
                  this.debug('pattern match', p, f, hit)
                }

                if (!hit) return false
              }

              // Note: ending in / means that we'll get a final ""
              // at the end of the pattern.  This can only match a
              // corresponding "" at the end of the file.
              // If the file ends in /, then it can only match a
              // a pattern that ends in /, unless the pattern just
              // doesn't have any more for it. But, a/b/ should *not*
              // match "a/b/*", even though "" matches against the
              // [^/]*? pattern, except in partial mode, where it might
              // simply not be reached yet.
              // However, a/b/ should still satisfy a/*

              // now either we fell off the end of the pattern, or we're done.
              if (fi === fl && pi === pl) {
                // ran out of pattern and filename at the same time.
                // an exact hit!
                return true
              } else if (fi === fl) {
                // ran out of file, but still had pattern left.
                // this is ok if we're doing the match as part of
                // a glob fs traversal.
                return partial
              } else if (pi === pl) {
                // ran out of pattern, still have file left.
                // this is only acceptable if we're on the very last
                // empty segment of a file with a trailing slash.
                // a/* should match a/b/
                var emptyFileEnd = (fi === fl - 1) && (file[fi] === '')
                return emptyFileEnd
              }

              // should be unreachable.
              throw new Error('wtf?')
            }

            // replace stuff like \* with *
            function globUnescape (s) {
              return s.replace(/\\(.)/g, '$1')
            }

            function regExpEscape (s) {
              return s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, '\\$&')
            }
            });

            var require$$0$55 = (minimatch && typeof minimatch === 'object' && 'default' in minimatch ? minimatch['default'] : minimatch);

            var pluginutils_cjs = __commonjs(function (module, exports) {
            'use strict';

            var estreeWalker = require$$2$15;
            var path = require$$1$36;
            var minimatch = require$$0$55;

            var babelHelpers = {};

            babelHelpers.createClass = (function () {
              function defineProperties(target, props) {
                for (var i = 0; i < props.length; i++) {
                  var descriptor = props[i];
                  descriptor.enumerable = descriptor.enumerable || false;
                  descriptor.configurable = true;
                  if ("value" in descriptor) descriptor.writable = true;
                  Object.defineProperty(target, descriptor.key, descriptor);
                }
              }

              return function (Constructor, protoProps, staticProps) {
                if (protoProps) defineProperties(Constructor.prototype, protoProps);
                if (staticProps) defineProperties(Constructor, staticProps);
                return Constructor;
              };
            })();

            babelHelpers.classCallCheck = function (instance, Constructor) {
              if (!(instance instanceof Constructor)) {
                throw new TypeError("Cannot call a class as a function");
              }
            };
            function basename(path) {
            	return path.split(/(\/|\\)/).pop();
            }

            function extname(path) {
            	var match = /\.[^\.]+$/.exec(basename(path));
            	if (!match) return '';
            	return match[0];
            }
            function addExtension(filename) {
            	var ext = arguments.length <= 1 || arguments[1] === undefined ? '.js' : arguments[1];

            	if (!extname(filename)) filename += ext;
            	return filename;
            }

            var blockDeclarations = {
            	'const': true,
            	'let': true
            };

            var extractors = {
            	Identifier: function Identifier(names, param) {
            		names.push(param.name);
            	},

            	ObjectPattern: function ObjectPattern(names, param) {
            		param.properties.forEach(function (prop) {
            			extractors[prop.key.type](names, prop.key);
            		});
            	},

            	ArrayPattern: function ArrayPattern(names, param) {
            		param.elements.forEach(function (element) {
            			if (element) extractors[element.type](names, element);
            		});
            	},

            	RestElement: function RestElement(names, param) {
            		extractors[param.argument.type](names, param.argument);
            	},

            	AssignmentPattern: function AssignmentPattern(names, param) {
            		return extractors[param.left.type](names, param.left);
            	}
            };

            function extractNames(param) {
            	var names = [];

            	extractors[param.type](names, param);
            	return names;
            }

            var Scope = (function () {
            	function Scope(options) {
            		var _this = this;

            		babelHelpers.classCallCheck(this, Scope);

            		options = options || {};

            		this.parent = options.parent;
            		this.isBlockScope = !!options.block;

            		this.declarations = Object.create(null);

            		if (options.params) {
            			options.params.forEach(function (param) {
            				extractNames(param).forEach(function (name) {
            					_this.declarations[name] = true;
            				});
            			});
            		}
            	}

            	babelHelpers.createClass(Scope, [{
            		key: 'addDeclaration',
            		value: function addDeclaration(node, isBlockDeclaration, isVar) {
            			var _this2 = this;

            			if (!isBlockDeclaration && this.isBlockScope) {
            				// it's a `var` or function node, and this
            				// is a block scope, so we need to go up
            				this.parent.addDeclaration(node, isBlockDeclaration, isVar);
            			} else {
            				extractNames(node.id).forEach(function (name) {
            					_this2.declarations[name] = true;
            				});
            			}
            		}
            	}, {
            		key: 'contains',
            		value: function contains(name) {
            			return this.declarations[name] || (this.parent ? this.parent.contains(name) : false);
            		}
            	}]);
            	return Scope;
            })();

            function attachScopes(ast) {
            	var propertyName = arguments.length <= 1 || arguments[1] === undefined ? 'scope' : arguments[1];

            	var scope = new Scope();

            	estreeWalker.walk(ast, {
            		enter: function enter(node, parent) {
            			// function foo () {...}
            			// class Foo {...}
            			if (/(Function|Class)Declaration/.test(node.type)) {
            				scope.addDeclaration(node, false, false);
            			}

            			// var foo = 1
            			if (node.type === 'VariableDeclaration') {
            				var isBlockDeclaration = blockDeclarations[node.kind];
            				// only one declarator per block, because we split them up already
            				scope.addDeclaration(node.declarations[0], isBlockDeclaration, true);
            			}

            			var newScope = undefined;

            			// create new function scope
            			if (/Function/.test(node.type)) {
            				newScope = new Scope({
            					parent: scope,
            					block: false,
            					params: node.params
            				});

            				// named function expressions - the name is considered
            				// part of the function's scope
            				if (node.type === 'FunctionExpression' && node.id) {
            					newScope.addDeclaration(node, false, false);
            				}
            			}

            			// create new block scope
            			if (node.type === 'BlockStatement' && !/Function/.test(parent.type)) {
            				newScope = new Scope({
            					parent: scope,
            					block: true
            				});
            			}

            			// catch clause has its own block scope
            			if (node.type === 'CatchClause') {
            				newScope = new Scope({
            					parent: scope,
            					params: [node.param],
            					block: true
            				});
            			}

            			if (newScope) {
            				Object.defineProperty(node, propertyName, {
            					value: newScope,
            					configurable: true
            				});

            				scope = newScope;
            			}
            		},
            		leave: function leave(node) {
            			if (node[propertyName]) scope = scope.parent;
            		}
            	});

            	return scope;
            }

            function ensureArray(thing) {
            	if (Array.isArray(thing)) return thing;
            	if (thing == undefined) return [];
            	return [thing];
            }

            function createFilter(include, exclude) {
            	include = ensureArray(include).map(function (id) {
            		return path.resolve(id);
            	}).map(minimatch.makeRe);
            	exclude = ensureArray(exclude).map(function (id) {
            		return path.resolve(id);
            	}).map(minimatch.makeRe);

            	return function (id) {
            		var included = !include.length;
            		id = id.split(path.sep).join('/');

            		include.forEach(function (pattern) {
            			if (pattern.test(id)) included = true;
            		});

            		exclude.forEach(function (pattern) {
            			if (pattern.test(id)) included = false;
            		});

            		return included;
            	};
            }

            var reservedWords = 'break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public'.split(' ');
            var builtins = 'Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl'.split(' ');

            var blacklisted = Object.create(null);
            reservedWords.concat(builtins).forEach(function (word) {
            	return blacklisted[word] = true;
            });
            function makeLegalIdentifier(str) {
            	str = str.replace(/-(\w)/g, function (_, letter) {
            		return letter.toUpperCase();
            	}).replace(/[^$_a-zA-Z0-9]/g, '_');

            	if (/\d/.test(str[0]) || blacklisted[str]) str = '_' + str;

            	return str;
            }

            exports.addExtension = addExtension;
            exports.attachScopes = attachScopes;
            exports.createFilter = createFilter;
            exports.makeLegalIdentifier = makeLegalIdentifier;
            });

            var require$$4$14 = (pluginutils_cjs && typeof pluginutils_cjs === 'object' && 'default' in pluginutils_cjs ? pluginutils_cjs['default'] : pluginutils_cjs);

            var rollupPluginInject_cjs = __commonjs(function (module) {
            'use strict';

            var rollupPluginutils = require$$4$14;
            var path = require$$1$36;
            var estreeWalker = require$$2$15;
            var acorn = require$$1$40;
            var MagicString = require$$0$53;
            MagicString = 'default' in MagicString ? MagicString['default'] : MagicString;

            var reservedWords = 'break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public'.split(' ');
            var builtins = 'Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl'.split(' ');

            var blacklisted = Object.create(null);
            reservedWords.concat(builtins).forEach(function (word) {
            	return blacklisted[word] = true;
            });

            function makeLegalIdentifier(str) {
            	str = str.replace(/-(\w)/g, function (_, letter) {
            		return letter.toUpperCase();
            	}).replace(/[^$_a-zA-Z0-9]/g, '_');

            	if (/\d/.test(str[0]) || blacklisted[str]) str = '_' + str;

            	return str;
            }

            function escape(str) {
            	return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
            }

            function isReference(node, parent) {
            	if (node.type === 'MemberExpression') {
            		return !node.computed && isReference(node.object, node);
            	}

            	if (node.type === 'Identifier') {
            		// TODO is this right?
            		if (parent.type === 'MemberExpression') return parent.computed || node === parent.object;

            		// disregard the `bar` in { bar: foo }
            		if (parent.type === 'Property' && node !== parent.value) return false;

            		// disregard the `bar` in `class Foo { bar () {...} }`
            		if (parent.type === 'MethodDefinition') return false;

            		// disregard the `bar` in `export { foo as bar }`
            		if (parent.type === 'ExportSpecifier' && node !== parent.local) return;

            		return true;
            	}
            }

            function flatten(node) {
            	var name = void 0;
            	var parts = [];

            	while (node.type === 'MemberExpression') {
            		parts.unshift(node.property.name);
            		node = node.object;
            	}

            	name = node.name;
            	parts.unshift(name);

            	return { name: name, keypath: parts.join('.') };
            }

            function assign(target, source) {
            	Object.keys(source).forEach(function (key) {
            		target[key] = source[key];
            	});
            	return target;
            }

            function isArray(thing) {
            	return Object.prototype.toString.call(thing) === '[object Array]';
            }

            function inject(options) {
            	if (!options) throw new Error('Missing options');

            	var filter = rollupPluginutils.createFilter(options.include, options.exclude);

            	var modules = void 0;

            	if (options.modules) {
            		modules = options.modules;
            	} else {
            		modules = assign({}, options);
            		delete modules.include;
            		delete modules.exclude;
            	}

            	// Fix paths on Windows
            	if (path.sep !== '/') {
            		Object.keys(modules).forEach(function (key) {
            			var module = modules[key];

            			modules[key] = isArray(module) ? [module[0].split(path.sep).join('/'), module[1]] : module.split(path.sep).join('/');
            		});
            	}

            	var firstpass = new RegExp('(?:' + Object.keys(modules).map(escape).join('|') + ')', 'g');
            	var sourceMap = options.sourceMap !== false;

            	return {
            		transform: function transform(code, id) {
            			if (!filter(id)) return null;
            			if (code.search(firstpass) == -1) return null;

            			var ast = void 0;

            			try {
            				ast = acorn.parse(code, {
            					ecmaVersion: 6,
            					sourceType: 'module'
            				});
            			} catch (err) {
            				err.message += ' in ' + id;
            				throw err;
            			}

            			// analyse scopes
            			var scope = rollupPluginutils.attachScopes(ast, 'scope');

            			var imports = {};
            			ast.body.forEach(function (node) {
            				if (node.type === 'ImportDeclaration') {
            					node.specifiers.forEach(function (specifier) {
            						imports[specifier.local.name] = true;
            					});
            				}
            			});

            			var magicString = new MagicString(code);

            			var newImports = {};

            			function handleReference(node, name, keypath) {
            				if (keypath in modules && !scope.contains(name) && !imports[name]) {
            					var module = modules[keypath];
            					if (typeof module === 'string') module = [module, 'default'];

            					// prevent module from importing itself
            					if (module[0] === id) return;

            					var hash = keypath + ':' + module[0] + ':' + module[1];

            					var importLocalName = name === keypath ? name : makeLegalIdentifier('$inject_' + keypath);

            					if (!newImports[hash]) {
            						newImports[hash] = 'import { ' + module[1] + ' as ' + importLocalName + ' } from \'' + module[0] + '\';';
            					}

            					if (name !== keypath) {
            						magicString.overwrite(node.start, node.end, importLocalName, true);
            					}
            				}
            			}

            			estreeWalker.walk(ast, {
            				enter: function enter(node, parent) {
            					if (sourceMap) {
            						magicString.addSourcemapLocation(node.start);
            						magicString.addSourcemapLocation(node.end);
            					}

            					if (node.scope) scope = node.scope;

            					// special case – shorthand properties. because node.key === node.value,
            					// we can't differentiate once we've descended into the node
            					if (node.type === 'Property' && node.shorthand) {
            						var name = node.key.name;
            						handleReference(node, name, name);
            						return this.skip();
            					}

            					if (isReference(node, parent)) {
            						var _flatten = flatten(node);

            						var _name = _flatten.name;
            						var keypath = _flatten.keypath;

            						handleReference(node, _name, keypath);
            					}
            				},
            				leave: function leave(node) {
            					if (node.scope) scope = scope.parent;
            				}
            			});

            			var keys = Object.keys(newImports);
            			if (!keys.length) return null;

            			var importBlock = keys.map(function (hash) {
            				return newImports[hash];
            			}).join('\n\n');
            			magicString.prepend(importBlock + '\n\n');

            			return {
            				code: magicString.toString(),
            				map: sourceMap ? magicString.generateMap() : null
            			};
            		}
            	};
            }

            module.exports = inject;
            });

            var inject = (rollupPluginInject_cjs && typeof rollupPluginInject_cjs === 'object' && 'default' in rollupPluginInject_cjs ? rollupPluginInject_cjs['default'] : rollupPluginInject_cjs);

            var smfurl = "sourceMappingURL=";
            var datauri = "data:application/json;charset=utf-8;base64,";
            var rel_regex = /^\.{0,2}\//;

            var toBase64;
            if (typeof window !== "undefined" && typeof window.btoa === "function") {
            	toBase64 = window.btoa;
            } else toBase64 = function toBase64(str) {
            	return new Buffer(str, "utf-8").toString("base64");
            };

            function parseFiles(files, _ref) {
            	var filename = _ref.filename;

            	if (typeof files === "string") {
            		if (filename) files = babelHelpers.defineProperty({}, filename, files);else files = [files];
            	}

            	if (Array.isArray(files)) files = files.reduce(function (memo, src, name) {
            		if (typeof name === "number") name = "template" + name + ".html";
            		memo[name] = src;
            		return memo;
            	}, {});

            	return files;
            }

            function parse(src) {
            	var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

            	try {
            		return parse$1(src, options);
            	} catch (e) {
            		e.filename = options.filename;
            		e.source = src;
            		throw e;
            	}
            }

            function srcToString(smf) {
            	return this.code + "\n\n//# " + smfurl + (typeof smf === "string" ? smf : datauri + toBase64(this.map.toString()));
            }

            function compile(files) {
            	var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
            	var cb = arguments[2];

            	files = parseFiles(files, options);
            	var exts = [].concat(options.extensions || ".html").filter(Boolean);
            	var basedir = options.basedir || (options.filename ? require$$1$36.dirname(options.filename) : ".");
            	var hasCb = typeof cb === "function";
            	var templates = [];

            	return rollup({
            		onwarn: function onwarn() {},
            		entry: "_entry.js",
            		plugins: [{
            			resolveId: function resolveId(id, file) {
            				if (id === "_entry.js" || id === "_template.js") return id;

            				var full = require$$1$36.resolve(basedir, require$$1$36.dirname(file), id);
            				var entry = _find(Object.keys(files), function (name) {
            					return require$$1$36.resolve(basedir, name) === full;
            				});
            				if (entry) return entry;

            				// only relative paths are followed
            				if (rel_regex.test(id) && _includes(exts, require$$1$36.extname(id))) {
            					return full;
            				}
            			},
            			load: function load(id) {
            				if (id === "_entry.js") {
            					return Object.keys(files).map(function (name) {
            						return "import " + JSON.stringify(name);
            					}).join("\n") + "\nexport default Template;\n";
            				}

            				if (id === "_template.js") {
            					return "export default {};\n";
            				}

            				if (_has(files, id)) {
            					return files[id];
            				}
            			},
            			transform: function transform(src, id) {
            				if (!_includes(exts, require$$1$36.extname(id))) return;
            				templates.push(id);

            				var file = parse(src, _assign({ filename: id }, options));
            				var out = file.compile(options).toStringWithSourceMap();
            				out.map = out.map.toJSON();
            				return out;
            			}
            		}, inject({
            			Temple: "templejs",
            			Template: "_template.js",
            			idom: ["templejs", "idom"],
            			decorators: ["templejs", "decorators"]
            		})].concat(options.plugins).filter(Boolean)
            	}).then(function (bundle) {
            		var out = bundle.generate({
            			format: options.format,
            			sourceMap: true,
            			exports: "default",
            			useStrict: false,
            			moduleId: options.moduleId,
            			moduleName: options.moduleName,
            			globals: {
            				templejs: "Temple"
            			}
            		});

            		out.templates = templates;
            		out.toString = srcToString;

            		return out;
            	}).then(function (res) {
            		if (hasCb) cb(null, res);
            		return res;
            	}, function (e) {
            		if (hasCb) cb(e);
            		throw e;
            	});
            }

            function exec(tpl, options) {
            	return compile(tpl, _assign({
            		format: "iife",
            		moduleName: "Template"
            	}, options)).then(function (r) {
            		return new Function("Temple", r.code)(Temple);
            	});
            }

            // export function compileHTML(html, options) {
            // 	options = options || {};
            // 	var node = new AST.HTML(null, html);
            // 	return getSource(node.compile(options), html, options);
            // }
            //
            // export function renderHTML(html, options) {
            // 	/* jshint -W054 */
            // 	var r = compileHTML(html, options);
            // 	// console.log(r);
            // 	return (new Function("Temple", r))(require("./"));
            // }

            function Each$1(val, vars, scope, fn, that) {
            	return map(val, function (item, key) {
            		var nscope = new Scope(scope);

            		if (vars.length === 1) nscope.set(vars[0], item);else if (vars.length == 2) {
            			nscope.set(vars[0], key);
            			nscope.set(vars[1], item);
            		}

            		return fn.call(that, nscope, key, val);
            	});
            }

            function With$1(val, scope, fn, that) {
            	var nscope = new Scope(scope);
            	nscope.set(val);
            	nscope.dataVar.set(val);
            	return fn.call(that, nscope);
            }

            function Element$2(tagname, key, scope, fn, that) {
            	var node = elementOpen(tagname, key);
            	var nscope = new Scope(null, scope);
            	var comp = autoelement(node, function () {
            		return fn.call(that, nscope, node);
            	});
            	elementClose(tagname);
            	return comp;
            }

            var version = pkg.version || "edge";



            var Temple = Object.freeze({
            	version: version,
            	Trackr: Trackr,
            	Scope: Scope,
            	AST: AST,
            	idom: idom,
            	utils: utils,
            	plugins: plugins$1,
            	decorators: decorators$1,
            	actions: actions$1,
            	Map: Map,
            	List: List,
            	Variable: Variable,
            	trackProperty: trackProperty,
            	templates: templates,
            	types: types,
            	Template: Template,
            	helpers: helpers,
            	getHelper: getHelper,
            	render: render,
            	getByName: getByName,
            	paint: paint,
            	registerType: registerType,
            	create: create$1,
            	parse: parse,
            	compile: compile,
            	exec: exec,
            	Each: Each$1,
            	With: With$1,
            	Element: Element$2
            });

            exports.version = version;
            exports.Trackr = Trackr;
            exports.Scope = Scope;
            exports.AST = AST;
            exports.idom = idom;
            exports.utils = utils;
            exports.plugins = plugins$1;
            exports.decorators = decorators$1;
            exports.actions = actions$1;
            exports.Map = Map;
            exports.List = List;
            exports.Variable = Variable;
            exports.trackProperty = trackProperty;
            exports.templates = templates;
            exports.types = types;
            exports.Template = Template;
            exports.helpers = helpers;
            exports.getHelper = getHelper;
            exports.render = render;
            exports.getByName = getByName;
            exports.paint = paint;
            exports.registerType = registerType;
            exports.create = create$1;
            exports.parse = parse;
            exports.compile = compile;
            exports.exec = exec;
            exports.Each = Each$1;
            exports.With = With$1;
            exports.Element = Element$2;

}));
//# sourceMappingURL=temple.js.map